package com.simibubi.create.compat.botania;

import com.simibubi.create.api.behaviour.BlockSpoutingBehaviour;
import com.simibubi.create.compat.Mods;
import com.simibubi.create.content.fluids.spout.SpoutBlockEntity;
import com.simibubi.create.foundation.utility.RegisteredObjects;
import com.simibubi.create.infrastructure.config.AllConfigs;

import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidConstants;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2960;
import net.minecraft.class_3611;
import net.minecraft.class_3612;
import vazkii.botania.api.block.PetalApothecary;

public class ApothecaryFilling extends BlockSpoutingBehaviour {

	static Boolean BOTANIA_PRESENT = null;

	private final class_2960 APOTHECARY = new class_2960("botania", "altar");

	@Override
	public long fillBlock(class_1937 level, class_2338 pos, SpoutBlockEntity spout, FluidStack availableFluid,
						  boolean simulate) {
		if (!enabled())
			return 0;

		class_2586 te = level.method_8321(pos);
		if (te == null)
			return 0;

		class_2960 registryName = RegisteredObjects.getKeyOrThrow(te.method_11017());
		if (!registryName.equals(APOTHECARY))
			return 0;

		// this shouldn't fail but... better safe than sorry.
		if (!(te instanceof PetalApothecary apothecary))
			return 0;
		// don't insert if it's not empty
		if (apothecary.getFluid() != PetalApothecary.State.EMPTY)
			return 0;

		PetalApothecary.State fluidState;

		class_3611 fluid = availableFluid.getType().getFluid();
		if (fluid == class_3612.field_15910) {
			fluidState = PetalApothecary.State.WATER;
		} else if (fluid == class_3612.field_15908) {
			fluidState = PetalApothecary.State.LAVA;
		} else {
			return 0;
		}

		// don't insert if we have less than a bucket's worth of fluid
		if (availableFluid.getAmount() < FluidConstants.BUCKET) {
			return 0;
		}

		long inserted = FluidConstants.BUCKET;
		if (!simulate) {
			availableFluid.shrink(inserted);
			apothecary.setFluid(fluidState);
		}

		return inserted;
	}

	private boolean enabled() {
		if (BOTANIA_PRESENT == null)
			BOTANIA_PRESENT = Mods.BOTANIA.isLoaded();
		if (!BOTANIA_PRESENT)
			return false;
		return AllConfigs.server().recipes.allowFillingBySpout.get();
	}

}
