package com.simibubi.create.compat.computercraft.implementation.peripherals;

import java.util.concurrent.atomic.AtomicInteger;
import net.minecraft.class_2499;
import net.minecraft.class_2519;
import net.minecraft.class_2520;
import org.jetbrains.annotations.NotNull;

import com.simibubi.create.content.redstone.displayLink.DisplayLinkBlockEntity;
import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.content.redstone.displayLink.target.DisplayTargetStats;

import dan200.computercraft.api.lua.LuaFunction;

public class DisplayLinkPeripheral extends SyncedPeripheral<DisplayLinkBlockEntity> {

	public static final String TAG_KEY = "ComputerSourceList";
	private final AtomicInteger cursorX = new AtomicInteger();
	private final AtomicInteger cursorY = new AtomicInteger();

	public DisplayLinkPeripheral(DisplayLinkBlockEntity blockEntity) {
		super(blockEntity);
	}

	@LuaFunction
	public final void setCursorPos(int x, int y) {
		cursorX.set(x - 1);
		cursorY.set(y - 1);
	}

	@LuaFunction
	public final Object[] getCursorPos() {
		return new Object[] {cursorX.get() + 1, cursorY.get() + 1};
	}

	@LuaFunction(mainThread = true)
	public final Object[] getSize() {
		DisplayTargetStats stats = blockEntity.activeTarget.provideStats(new DisplayLinkContext(blockEntity.method_10997(), blockEntity));
		return new Object[]{stats.maxRows(), stats.maxColumns()};
	}

	@LuaFunction
	public final boolean isColor() {
		return false;
	}

	@LuaFunction
	public final boolean isColour() {
		return false;
	}

	@LuaFunction
	public final void write(String text) {
		class_2499 tag = blockEntity.getSourceConfig().method_10554(TAG_KEY, class_2520.field_33258);

		int x = cursorX.get();
		int y = cursorY.get();

		for (int i = tag.size(); i <= y; i++) {
			tag.add(class_2519.method_23256(""));
		}

		StringBuilder builder = new StringBuilder(tag.method_10608(y));

		builder.append(" ".repeat(Math.max(0, x - builder.length())));
		builder.replace(x, x + text.length(), text);

		tag.method_10606(y, class_2519.method_23256(builder.toString()));

		synchronized (blockEntity) {
			blockEntity.getSourceConfig().method_10566(TAG_KEY, tag);
		}

		cursorX.set(x + text.length());
	}

	@LuaFunction
	public final void clearLine() {
		class_2499 tag = blockEntity.getSourceConfig().method_10554(TAG_KEY, class_2520.field_33258);

		if (tag.size() > cursorY.get())
			tag.method_10606(cursorY.get(), class_2519.method_23256(""));

		synchronized (blockEntity) {
			blockEntity.getSourceConfig().method_10566(TAG_KEY, tag);
		}
	}

	@LuaFunction
	public final void clear() {
		synchronized (blockEntity) {
			blockEntity.getSourceConfig().method_10566(TAG_KEY, new class_2499());
		}
	}

	@LuaFunction(mainThread = true)
	public final void update() {
		blockEntity.tickSource();
	}

	@NotNull
	@Override
	public String getType() {
		return "Create_DisplayLink";
	}

}
