package com.simibubi.create.compat.emi;

import java.util.List;

import com.simibubi.create.foundation.mixin.fabric.ClientTextTooltipAccessor;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.infrastructure.config.AllConfigs;

import com.tterrag.registrate.util.entry.FluidEntry;

import dev.emi.emi.api.stack.EmiIngredient;
import dev.emi.emi.api.stack.EmiStack;
import dev.emi.emi.api.widget.SlotWidget;
import io.github.fabricators_of_create.porting_lib.util.FluidTextUtil;
import io.github.fabricators_of_create.porting_lib.util.FluidUnit;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidVariant;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidVariantAttributes;
import net.fabricmc.loader.api.FabricLoader;
import net.minecraft.class_124;
import net.minecraft.class_2561;
import net.minecraft.class_3611;
import net.minecraft.class_5250;
import net.minecraft.class_5481;
import net.minecraft.class_5684;
import net.minecraft.class_7923;

public class CreateSlotWidget extends SlotWidget {
	public CreateSlotWidget(EmiIngredient stack, int x, int y) {
		super(stack, x, y);
	}

	@Override
	public List<class_5684> getTooltip(int mouseX, int mouseY) {
		List<class_5684> tooltip = super.getTooltip(mouseX, mouseY);
		if (stack instanceof EmiStack emiStack && emiStack.getKey() instanceof class_3611 fluid) {
			// add custom fluid tooltip
			FluidVariant variant = FluidVariant.of(fluid);
			addCreateAmount(tooltip, variant);
			removeEmiAmount(tooltip, variant);
		}
		return tooltip;
	}

	private void addCreateAmount(List<class_5684> tooltip, FluidVariant fluid) {
		FluidUnit unit = AllConfigs.client().fluidUnitType.get();
		String amount = FluidTextUtil.getUnicodeMillibuckets(stack.getAmount(), unit, AllConfigs.client().simplifyFluidUnit.get());

		class_2561 amountComponent = class_2561.method_43470(" " + amount)
				.method_10852(Lang.translateDirect(unit.getTranslationKey()))
				.method_27692(class_124.field_1065);

		class_5250 fluidName = FluidVariantAttributes.getName(fluid)
				.method_27661()
				.method_10852(amountComponent);

		class_5684 component = toTooltip(fluidName);

		if (tooltip.isEmpty()) {
			tooltip.add(component);
		} else {
			tooltip.set(0, toTooltip(fluidName));
		}
	}

	private void removeEmiAmount(List<class_5684> tooltip, FluidVariant entry) {
		class_3611 fluid = entry.getFluid();
		String namespace = class_7923.field_41173.method_10221(fluid).method_12836();
		String modName = FabricLoader.getInstance().getModContainer(namespace).map(c -> c.getMetadata().getName()).orElse(null);
		if (modName == null)
			return;
		int indexOfModName = -1;
		for (int i = 0; i < tooltip.size(); i++) {
			class_5684 component = tooltip.get(i);
			if (component instanceof ClientTextTooltipAccessor text) {
				class_5481 contents = text.create$text();
				StringBuilder string = new StringBuilder();
				contents.accept((what, style, c) -> {
					string.append((char) c);
					return true;
				});
				if (string.toString().equals(modName)) {
					indexOfModName = i;
					break;
				}
			}
		}
		if (indexOfModName != -1) {
			// emi amount is always(?) right above the mod name
			int indexOfAmount = indexOfModName - 1;
			if (indexOfAmount > 0) {
				tooltip.remove(indexOfAmount);
			}
		}
	}

	private static class_5684 toTooltip(class_2561 component) {
		return class_5684.method_32662(component.method_30937());
	}
}
