package com.simibubi.create.compat.emi;

import java.util.List;

import javax.annotation.ParametersAreNonnullByDefault;
import net.minecraft.class_1735;
import net.minecraft.class_1799;
import net.minecraft.class_6328;
import net.minecraft.class_768;
import com.simibubi.create.AllPackets;
import com.simibubi.create.content.logistics.filter.AttributeFilterScreen;
import com.simibubi.create.foundation.gui.menu.AbstractSimiContainerScreen;
import com.simibubi.create.foundation.gui.menu.GhostItemMenu;
import com.simibubi.create.foundation.gui.menu.GhostItemSubmitPacket;

import dev.emi.emi.api.EmiDragDropHandler;
import dev.emi.emi.api.stack.EmiIngredient;
import dev.emi.emi.api.stack.EmiStack;
import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.AbstractContainerScreenAccessor;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemHandlerHelper;

@class_6328
@ParametersAreNonnullByDefault
public class GhostIngredientHandler<T extends GhostItemMenu<?>>
		implements EmiDragDropHandler<AbstractSimiContainerScreen<T>> {

	public static final int INVENTORY_SIZE = 36;

	@Override
	public boolean dropStack(AbstractSimiContainerScreen<T> gui, EmiIngredient ingredient, int x, int y) {
		List<EmiStack> stacks = ingredient.getEmiStacks();
		if (!(gui instanceof AbstractContainerScreenAccessor access) || stacks.size() != 1)
			return false;
		class_1799 stack = stacks.get(0).getItemStack();
		if (stack.method_7960())
			return false;
		boolean isAttributeFilter = gui instanceof AttributeFilterScreen;

		for (int i = INVENTORY_SIZE; i < gui.method_17577().field_7761.size(); i++) {
			class_1735 slot = gui.method_17577().field_7761.get(i);
			if (slot.method_7682()) {
				class_768 slotArea = new class_768(access.port_lib$getGuiLeft() + slot.field_7873, access.port_lib$getGuiTop() + slot.field_7872, 16, 16);
				if (slotArea.method_3318(x, y)) {
					acceptStack(gui, isAttributeFilter, i - INVENTORY_SIZE, stack);
					return true;
				}
			}
			// Only accept items in 1st slot. 2nd is used for functionality, don't wanna
			// override that one
			if (isAttributeFilter)
				break;
		}

		return false;
	}

	private void acceptStack(AbstractSimiContainerScreen<T> gui, boolean isAttributeFilter, int slotIndex, class_1799 stack) {
		stack = ItemHandlerHelper.copyStackWithSize(stack, 1);
		gui.method_17577().ghostInventory.setStackInSlot(slotIndex, stack);

		if (isAttributeFilter)
			return;

		// sync new filter contents with server
		AllPackets.getChannel().sendToServer(new GhostItemSubmitPacket(stack, slotIndex));
	}
}
