package com.simibubi.create.compat.emi;

import com.simibubi.create.foundation.gui.element.GuiGameElement;

import dev.emi.emi.api.render.EmiRenderable;
import dev.emi.emi.api.stack.EmiIngredient;
import dev.emi.emi.api.stack.EmiStack;
import dev.emi.emi.api.widget.DrawableWidget.DrawableWidgetConsumer;
import javax.annotation.Nullable;
import net.minecraft.class_1747;
import net.minecraft.class_1799;
import net.minecraft.class_2680;
import net.minecraft.class_332;
import net.minecraft.class_4587;
import net.minecraft.class_7833;
import java.util.List;

public record RenderedBlock(class_2680 state) implements EmiRenderable, DrawableWidgetConsumer {
	@Nullable
	public static RenderedBlock of(EmiIngredient ingredient) {
		List<EmiStack> stacks = ingredient.getEmiStacks();
		if (stacks.size() == 0)
			return null;
		return of(stacks.get(0));
	}

	@Nullable
	public static RenderedBlock of(EmiStack stack) {
		class_1799 item = stack.getItemStack();
		if (item.method_7960())
			return null;
		if (!(item.method_7909() instanceof class_1747 block))
			return null;
		return new RenderedBlock(block.method_7711().method_9564());
	}
	@Override
	public void render(class_332 graphics, int x, int y, float delta) {
		class_4587 matrixStack = graphics.method_51448();
		matrixStack.method_22903();
		matrixStack.method_46416(74, 51, 100);
		matrixStack.method_22907(class_7833.field_40714.rotationDegrees(-15.5f));
		matrixStack.method_22907(class_7833.field_40716.rotationDegrees(22.5f));
		int scale = 20;

		GuiGameElement.of(state)
				.lighting(CreateEmiAnimations.DEFAULT_LIGHTING)
				.scale(scale)
				.render(graphics);

		matrixStack.method_22909();
	}
}
