package com.simibubi.create.compat.emi.recipes;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_1799;
import net.minecraft.class_1856;
import net.minecraft.class_1860;
import net.minecraft.class_2960;
import net.minecraft.class_3975;
import org.apache.commons.compress.utils.Lists;

import com.simibubi.create.compat.emi.CreateEmiAnimations;
import com.simibubi.create.compat.emi.recipes.BlockCuttingEmiRecipe.CondensedBlockCuttingRecipe;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.item.ItemHelper;

import dev.emi.emi.api.recipe.EmiRecipeCategory;
import dev.emi.emi.api.stack.EmiStack;
import dev.emi.emi.api.widget.WidgetHolder;

public class BlockCuttingEmiRecipe extends CreateEmiRecipe<CondensedBlockCuttingRecipe> {

	public BlockCuttingEmiRecipe(EmiRecipeCategory category, CondensedBlockCuttingRecipe recipe) {
		super(category, recipe, 177, 75);
		id = null;
	}

	@Override
	public boolean supportsRecipeTree() {
		return false;
	}

	@Override
	public void addWidgets(WidgetHolder widgets) {
		addTexture(widgets, AllGuiTextures.JEI_DOWN_ARROW, 31, 6);
		addTexture(widgets, AllGuiTextures.JEI_SHADOW, 16, 50);

		addSlot(widgets, input.get(0), 4, 8);

		List<List<class_1799>> results = recipe.getCondensedOutputs();
		for (int i = 0; i < results.size(); i++) {
			int x = (i % 5) * 19;
			int y = (i / 5) * -19;
			addSlot(widgets, EmiStack.of(results.get(i).get(0)), 77 + x, 47 + y).recipeContext(this);
		}

		CreateEmiAnimations.addSaw(widgets, 33, 37);
	}

	public static class CondensedBlockCuttingRecipe extends class_3975 {
		private List<class_1799> outputs = Lists.newArrayList();

		public CondensedBlockCuttingRecipe(class_1856 ingredient) {
			super(new class_2960(""), "", ingredient, class_1799.field_8037);
		}

		public void addOutput(class_1799 stack) {
			outputs.add(stack);
		}

		public List<class_1799> getOutputs() {
			return outputs;
		}

		public List<List<class_1799>> getCondensedOutputs() {
			List<List<class_1799>> result = Lists.newArrayList();
			int index = 0;
			boolean firstPass = true;
			for (class_1799 stack : outputs) {
				if (firstPass) {
					result.add(new ArrayList<>());
				}
				result.get(index).add(stack);
				index++;
				if (index >= 15) {
					index = 0;
					firstPass = false;
				}
			}
			return result;
		}

		@Override
		public boolean method_8118() {
			return true;
		}

		@SuppressWarnings("rawtypes")
		public static List<CondensedBlockCuttingRecipe> condenseRecipes(List<? extends class_1860> recipes, String name) {
			List<CondensedBlockCuttingRecipe> condensed = Lists.newArrayList();
			outer:
			for (class_1860<?> recipe : recipes) {
				class_1856 ingredient = recipe.method_8117().get(0);
				if (ingredient.method_8103()) {
					continue;
				}
				for (CondensedBlockCuttingRecipe condensedRecipe : condensed) {
					if (ItemHelper.matchIngredients(ingredient, condensedRecipe.method_8117().get(0))) {
						condensedRecipe.addOutput(CreateEmiRecipe.getResultItem(recipe));
						continue outer;
					}
				}
				CondensedBlockCuttingRecipe cr = new CondensedBlockCuttingRecipe(ingredient);
				cr.addOutput(CreateEmiRecipe.getResultItem(recipe));
				condensed.add(cr);
			}
			return condensed;
		}
	}
}
