package com.simibubi.create.compat.emi.recipes;

import java.util.List;
import net.minecraft.class_1856;
import net.minecraft.class_1869;
import net.minecraft.class_2561;
import net.minecraft.class_332;
import net.minecraft.class_3532;
import net.minecraft.class_3955;
import net.minecraft.class_4587;
import com.simibubi.create.compat.emi.CreateEmiAnimations;
import com.simibubi.create.foundation.gui.AllGuiTextures;

import dev.emi.emi.api.recipe.EmiRecipeCategory;
import dev.emi.emi.api.stack.EmiIngredient;
import dev.emi.emi.api.stack.EmiStack;
import dev.emi.emi.api.widget.Bounds;
import dev.emi.emi.api.widget.SlotWidget;
import dev.emi.emi.api.widget.WidgetHolder;

public class MechanicalCraftingEmiRecipe extends CreateEmiRecipe<class_3955> {
	private static final int MAX_SIZE = 100;
	private int recipeAmount = 0;

	public MechanicalCraftingEmiRecipe(EmiRecipeCategory category, class_3955 recipe) {
		super(category, recipe, 177, 109, c -> {});
		this.input = recipe.method_8117().stream().map(EmiIngredient::of).toList();
		this.output = List.of(getResultEmi(recipe));
		for (class_1856 ingredient : recipe.method_8117()) {
			if (!ingredient.method_8103()) {
				recipeAmount++;
			}
		}
	}

	public float getScale() {
		int w = getWidth();
		int h = getHeight();
		return Math.min(1, MAX_SIZE / (19f * Math.max(w, h)));
	}

	public int getYPadding() {
		return 3 + 50 - (int) (getScale() * getHeight() * 19 * .5);
	}

	public int getXPadding() {
		return 3 + 50 - (int) (getScale() * getWidth() * 19 * .5);
	}

	private int getWidth() {
		return recipe instanceof class_1869 ? ((class_1869) recipe).method_8150() : 1;
	}

	private int getHeight() {
		return recipe instanceof class_1869 ? ((class_1869) recipe).method_8158() : 1;
	}

	@Override
	public void addWidgets(WidgetHolder widgets) {
		int x = getXPadding();
		int y = getYPadding();
		float scale = getScale();

		addTexture(widgets, AllGuiTextures.JEI_DOWN_ARROW, 128, 59);
		addTexture(widgets, AllGuiTextures.JEI_SHADOW, 113, 38);


		for (int i = 0; i < input.size(); i++) {
			EmiIngredient ingredient = input.get(i);
			if (ingredient.isEmpty())
				continue;
			float f = 19 * scale;
			int xPosition = (int) (x + 1 + (i % getWidth()) * f);
			int yPosition = (int) (y + 1 + (i / getWidth()) * f);
			widgets.add(new CrafterSlotWidget(ingredient, xPosition, yPosition))
					.backgroundTexture(
							AllGuiTextures.JEI_SLOT.location, AllGuiTextures.JEI_SLOT.startX, AllGuiTextures.JEI_SLOT.startY
					);
		}

		addSlot(widgets, output.get(0), 134, 81).recipeContext(this);

		CreateEmiAnimations.addCrafter(widgets, 132, 38);

		widgets.addText(class_2561.method_43470("" + recipeAmount).method_30937(), 142, 39, -1, true);
	}

	public class CrafterSlotWidget extends SlotWidget {
		private boolean hideStack;

		public CrafterSlotWidget(EmiIngredient stack, int x, int y) {
			super(stack, x, y);
			int w = class_3532.method_15386(18 * getScale());
			this.bounds = new Bounds(x, y, w, w);
		}

		@Override
		public Bounds getBounds() {
			return bounds;
		}

		@Override
		public EmiIngredient getStack() {
			return hideStack ? EmiStack.EMPTY : super.getStack();
		}

		@Override
		public void method_25394(class_332 graphics, int mouseX, int mouseY, float delta) {
			class_4587 matrices = graphics.method_51448();
			matrices.method_22903();
			hideStack = true;
			super.method_25394(graphics, mouseX, mouseY, delta);
			hideStack = false;

			float scale = getScale();
			matrices.method_46416(x, y, 0);
			matrices.method_22905(scale, scale, scale);
			matrices.method_46416(-x, -y, 0);

			getStack().render(graphics, bounds.x() + 1, bounds.y() + 1, delta);
			matrices.method_22909();
		}
	}
}
