package com.simibubi.create.compat.emi.recipes;

import com.simibubi.create.AllItems;
import com.simibubi.create.compat.emi.CreateEmiPlugin;
import com.simibubi.create.content.equipment.sandPaper.SandPaperPolishingRecipe;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.element.GuiGameElement;

import dev.emi.emi.api.widget.WidgetHolder;
import io.github.fabricators_of_create.porting_lib.util.NBTSerializer;
import net.minecraft.class_1799;
import net.minecraft.class_1856;
import net.minecraft.class_2371;
import net.minecraft.class_2487;
import net.minecraft.class_4587;

public class PolishingEmiRecipe extends CreateEmiRecipe<SandPaperPolishingRecipe> {

	public PolishingEmiRecipe(SandPaperPolishingRecipe recipe) {
		super(CreateEmiPlugin.SANDPAPER_POLISHING, recipe, 134, 55);
	}

	@Override
	public void addWidgets(WidgetHolder widgets) {
		addTexture(widgets, AllGuiTextures.JEI_SHADOW, 39, 25);
		addTexture(widgets, AllGuiTextures.JEI_LONG_ARROW, 30, 37);

		addSlot(widgets, input.get(0), 5, 33);

		addSlot(widgets, output.get(0), 110, 33).recipeContext(this);

		class_2371<class_1856> ingredients = recipe.method_8117();
		if (!ingredients.isEmpty() && !ingredients.get(0).method_8103()) {
			class_1799[] matchingStacks = ingredients.get(0).method_8105();
			class_1799 stack = AllItems.SAND_PAPER.asStack();
			class_2487 tag = stack.method_7948();
			tag.method_10566("Polishing", NBTSerializer.serializeNBT(matchingStacks[0]));
			tag.method_10556("JEI", true);
			widgets.addDrawable(49, 4, 0, 0, (graphics, mouseX, mouseY, delta) -> {
				class_4587 matrices = graphics.method_51448();
				matrices.method_46416(0, 0, 100);
				matrices.method_22905(2, 2, 1);
				GuiGameElement.of(stack)
						.<GuiGameElement.GuiRenderBuilder>at(0, 0, 1)
						.scale(1)
						.render(graphics);
			});
		}
	}
}
