package com.simibubi.create.compat.jei;

import java.util.function.Supplier;

import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.foundation.gui.element.GuiGameElement;

import mezz.jei.api.gui.drawable.IDrawable;
import net.minecraft.class_1799;
import net.minecraft.class_332;
import net.minecraft.class_4587;

public class DoubleItemIcon implements IDrawable {

	private Supplier<class_1799> primarySupplier;
	private Supplier<class_1799> secondarySupplier;
	private class_1799 primaryStack;
	private class_1799 secondaryStack;

	public DoubleItemIcon(Supplier<class_1799> primary, Supplier<class_1799> secondary) {
		this.primarySupplier = primary;
		this.secondarySupplier = secondary;
	}

	@Override
	public int getWidth() {
		return 18;
	}

	@Override
	public int getHeight() {
		return 18;
	}

	@Override
	public void draw(class_332 graphics, int xOffset, int yOffset) {
		class_4587 matrixStack = graphics.method_51448();
		if (primaryStack == null) {
			primaryStack = primarySupplier.get();
			secondaryStack = secondarySupplier.get();
		}

		RenderSystem.enableDepthTest();
		matrixStack.method_22903();
		matrixStack.method_46416(xOffset, yOffset, 0);

		matrixStack.method_22903();
		matrixStack.method_46416(1, 1, 0);
		GuiGameElement.of(primaryStack)
			.render(graphics);
		matrixStack.method_22909();

		matrixStack.method_22903();
		matrixStack.method_46416(10, 10, 100);
		matrixStack.method_22905(.5f, .5f, .5f);
		GuiGameElement.of(secondaryStack)
			.render(graphics);
		matrixStack.method_22909();

		matrixStack.method_22909();
	}

}
