package com.simibubi.create.compat.jei;

import java.util.LinkedList;
import java.util.List;

import javax.annotation.ParametersAreNonnullByDefault;

import com.simibubi.create.AllPackets;
import com.simibubi.create.content.logistics.filter.AttributeFilterScreen;
import com.simibubi.create.foundation.gui.menu.AbstractSimiContainerScreen;
import com.simibubi.create.foundation.gui.menu.GhostItemMenu;
import com.simibubi.create.foundation.gui.menu.GhostItemSubmitPacket;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.AbstractContainerScreenAccessor;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.gui.handlers.IGhostIngredientHandler;
import mezz.jei.api.ingredients.ITypedIngredient;
import net.minecraft.class_1735;
import net.minecraft.class_1799;
import net.minecraft.class_6328;
import net.minecraft.class_768;

@class_6328
@ParametersAreNonnullByDefault
public class GhostIngredientHandler<T extends GhostItemMenu<?>>
		implements IGhostIngredientHandler<AbstractSimiContainerScreen<T>> {

	@Override
	public <I> List<Target<I>> getTargetsTyped(AbstractSimiContainerScreen<T> gui, ITypedIngredient<I> ingredient,
		boolean doStart) {
		boolean isAttributeFilter = gui instanceof AttributeFilterScreen;
		List<Target<I>> targets = new LinkedList<>();

		if (ingredient.getType() == VanillaTypes.ITEM_STACK) {
			for (int i = 36; i < gui.method_17577().field_7761.size(); i++) {
				if (gui.method_17577().field_7761.get(i)
						.method_7682())
					targets.add(new GhostTarget<>(gui, i - 36, isAttributeFilter));

				// Only accept items in 1st slot. 2nd is used for functionality, don't wanna
				// override that one
				if (isAttributeFilter)
					break;
			}
		}

		return targets;
	}

	@Override
	public void onComplete() {}

	@Override
	public boolean shouldHighlightTargets() {
		// TODO change to false and highlight the slots ourself in some better way
		return true;
	}

	private static class GhostTarget<I, T extends GhostItemMenu<?>> implements Target<I> {

		private final class_768 area;
		private final AbstractSimiContainerScreen<T> gui;
		private final int slotIndex;
		private final boolean isAttributeFilter;

		public GhostTarget(AbstractSimiContainerScreen<T> gui, int slotIndex, boolean isAttributeFilter) {
			this.gui = gui;
			this.slotIndex = slotIndex;
			this.isAttributeFilter = isAttributeFilter;
			class_1735 slot = gui.method_17577().field_7761.get(slotIndex + 36);
			AbstractContainerScreenAccessor access = (AbstractContainerScreenAccessor) gui;
			this.area = new class_768(access.port_lib$getGuiLeft() + slot.field_7873, access.port_lib$getGuiTop() + slot.field_7872, 16, 16);
		}

		@Override
		public class_768 getArea() {
			return area;
		}

		@Override
		public void accept(I ingredient) {
			class_1799 stack = ((class_1799) ingredient).method_7972();
			stack.method_7939(1);
			gui.method_17577().ghostInventory.setStackInSlot(slotIndex, stack);

			if (isAttributeFilter)
				return;

			// sync new filter contents with server
			AllPackets.getChannel().sendToServer(new GhostItemSubmitPacket(stack, slotIndex));
		}
	}
}
