package com.simibubi.create.compat.jei;

import java.util.List;

import com.simibubi.create.content.fluids.potion.PotionFluid.BottleType;
import com.simibubi.create.foundation.utility.NBTHelper;

import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;
import mezz.jei.api.fabric.ingredients.fluids.IJeiFluidIngredient;
import mezz.jei.api.ingredients.subtypes.IIngredientSubtypeInterpreter;
import mezz.jei.api.ingredients.subtypes.UidContext;
import net.minecraft.class_1293;
import net.minecraft.class_1842;
import net.minecraft.class_1844;
import net.minecraft.class_2487;

/* From JEI's Potion item subtype interpreter */
public class PotionFluidSubtypeInterpreter implements IIngredientSubtypeInterpreter<IJeiFluidIngredient> {

	@Override
	public String apply(IJeiFluidIngredient ingredient, UidContext context) {
		if (ingredient.getTag().isEmpty())
			return IIngredientSubtypeInterpreter.NONE;

		class_2487 tag = ingredient.getTag().get();
		class_1842 potionType = class_1844.method_8057(tag);
		String potionTypeString = potionType.method_8051("");
		String bottleType = NBTHelper.readEnum(tag, "Bottle", BottleType.class)
				.toString();

		StringBuilder stringBuilder = new StringBuilder(potionTypeString);
		List<class_1293> effects = class_1844.method_8060(tag);

		stringBuilder.append(";")
				.append(bottleType);
		for (class_1293 effect : potionType.method_8049())
			stringBuilder.append(";")
					.append(effect);
		for (class_1293 effect : effects)
			stringBuilder.append(";")
					.append(effect);
		return stringBuilder.toString();
	}

}
