package com.simibubi.create.compat.jei.category.animations;

import java.util.List;
import net.minecraft.class_289;
import net.minecraft.class_308;
import net.minecraft.class_332;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_4597.class_4598;
import net.minecraft.class_765;
import net.minecraft.class_7833;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.foundation.fluid.FluidRenderer;
import com.simibubi.create.foundation.gui.UIRenderHelper;
import com.simibubi.create.foundation.utility.AnimationTickHolder;

import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;

public class AnimatedSpout extends AnimatedKinetics {

	private List<FluidStack> fluids;

	public AnimatedSpout withFluids(List<FluidStack> fluids) {
		this.fluids = fluids;
		return this;
	}

	@Override
	public void draw(class_332 graphics, int xOffset, int yOffset) {
		class_4587 matrixStack = graphics.method_51448();
		matrixStack.method_22903();
		matrixStack.method_46416(xOffset, yOffset, 100);
		matrixStack.method_22907(class_7833.field_40714.rotationDegrees(-15.5f));
		matrixStack.method_22907(class_7833.field_40716.rotationDegrees(22.5f));
		int scale = 20;

		blockElement(AllBlocks.SPOUT.getDefaultState())
			.scale(scale)
			.render(graphics);

		float cycle = (AnimationTickHolder.getRenderTime() - offset * 8) % 30;
		float squeeze = cycle < 20 ? class_3532.method_15374((float) (cycle / 20f * Math.PI)) : 0;
		squeeze *= 20;

		matrixStack.method_22903();

		blockElement(AllPartialModels.SPOUT_TOP)
			.scale(scale)
			.render(graphics);
		matrixStack.method_46416(0, -3 * squeeze / 32f, 0);
		blockElement(AllPartialModels.SPOUT_MIDDLE)
			.scale(scale)
			.render(graphics);
		matrixStack.method_46416(0, -3 * squeeze / 32f, 0);
		blockElement(AllPartialModels.SPOUT_BOTTOM)
			.scale(scale)
			.render(graphics);
		matrixStack.method_46416(0, -3 * squeeze / 32f, 0);

		matrixStack.method_22909();

		blockElement(AllBlocks.DEPOT.getDefaultState())
			.atLocal(0, 2, 0)
			.scale(scale)
			.render(graphics);

		AnimatedKinetics.DEFAULT_LIGHTING.applyLighting();
		class_4598 buffer = class_4597.method_22991(class_289.method_1348()
			.method_1349());
		matrixStack.method_22903();
		UIRenderHelper.flipForGuiRender(matrixStack);
		matrixStack.method_22905(16, 16, 16);
		float from = 3f / 16f;
		float to = 17f / 16f;
		FluidRenderer.renderFluidBox(fluids.get(0), from, from, from, to, to, to, buffer, matrixStack, class_765.field_32767, false);
		matrixStack.method_22909();

		float width = 1 / 128f * squeeze;
		matrixStack.method_46416(scale / 2f, scale * 1.5f, scale / 2f);
		UIRenderHelper.flipForGuiRender(matrixStack);
		matrixStack.method_22905(16, 16, 16);
		matrixStack.method_46416(-0.5f, 0, -0.5f);
		from = -width / 2 + 0.5f;
		to = width / 2 + 0.5f;
		FluidRenderer.renderFluidBox(fluids.get(0), from, 0, from, to, 2, to, buffer, matrixStack, class_765.field_32767,
			false);
		buffer.method_22993();
		class_308.method_24211();

		matrixStack.method_22909();
	}

}
