package com.simibubi.create.compat.rei;

import java.util.function.Supplier;

import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.foundation.gui.element.GuiGameElement;

import me.shedaniel.math.Point;
import me.shedaniel.math.Rectangle;
import me.shedaniel.rei.api.client.gui.Renderer;
import net.minecraft.class_1799;
import net.minecraft.class_332;
import net.minecraft.class_4587;

public class DoubleItemIcon implements Renderer {

	private Supplier<class_1799> primarySupplier;
	private Supplier<class_1799> secondarySupplier;
	private class_1799 primaryStack;
	private class_1799 secondaryStack;
	private Point pos;

	public DoubleItemIcon(Supplier<class_1799> primary, Supplier<class_1799> secondary) {
		this.primarySupplier = primary;
		this.secondarySupplier = secondary;
	}

	public DoubleItemIcon setPos(Point pos) {
		this.pos = pos;
		return this;
	}

	@Override
	public void render(class_332 graphics, Rectangle bounds, int mouseX, int mouseY, float delta) {
		if (primaryStack == null) {
			primaryStack = primarySupplier.get();
			secondaryStack = secondarySupplier.get();
		}

		class_4587 matrixStack = graphics.method_51448();
		RenderSystem.enableDepthTest();
		matrixStack.method_22903();
		if(pos == null)
			matrixStack.method_46416(bounds.getCenterX() - 9, bounds.getCenterY() - 9, 0);
		else
			matrixStack.method_46416(pos.getX(), pos.getY(), 0);

		matrixStack.method_22903();
		matrixStack.method_46416(1, 1, 0);
		GuiGameElement.of(primaryStack)
			.render(graphics);
		matrixStack.method_22909();

		matrixStack.method_22903();
		matrixStack.method_46416(10, 10, 100);
		matrixStack.method_22905(.5f, .5f, .5f);
		GuiGameElement.of(secondaryStack)
			.render(graphics);
		matrixStack.method_22909();

		matrixStack.method_22909();
	}
}
