package com.simibubi.create.compat.rei;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Stream;

import com.simibubi.create.AllPackets;
import com.simibubi.create.content.equipment.blueprint.BlueprintScreen;
import com.simibubi.create.content.logistics.filter.AbstractFilterScreen;
import com.simibubi.create.content.logistics.filter.AttributeFilterScreen;
import com.simibubi.create.content.redstone.link.controller.LinkedControllerScreen;
import com.simibubi.create.content.trains.schedule.ScheduleScreen;
import com.simibubi.create.foundation.gui.menu.AbstractSimiContainerScreen;
import com.simibubi.create.foundation.gui.menu.GhostItemMenu;
import com.simibubi.create.foundation.gui.menu.GhostItemSubmitPacket;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.AbstractContainerScreenAccessor;
import me.shedaniel.math.Point;
import me.shedaniel.math.Rectangle;
import me.shedaniel.rei.api.client.gui.drag.DraggableStack;
import me.shedaniel.rei.api.client.gui.drag.DraggableStackVisitor;
import me.shedaniel.rei.api.client.gui.drag.DraggedAcceptorResult;
import me.shedaniel.rei.api.client.gui.drag.DraggingContext;
import net.minecraft.class_1735;
import net.minecraft.class_1799;
import net.minecraft.class_238;
import net.minecraft.class_265;
import net.minecraft.class_437;

public class GhostIngredientHandler<T extends GhostItemMenu<?>>
		implements DraggableStackVisitor<AbstractSimiContainerScreen<T>> {

	@Override
	public DraggedAcceptorResult acceptDraggedStack(DraggingContext<AbstractSimiContainerScreen<T>> context, DraggableStack stack) {
		Stream<BoundsProvider> bounds = getDraggableAcceptingBounds(context, stack);
		Point cursor = context.getCurrentPosition();
		if (cursor != null) {
			int x = cursor.getX();
			int y = cursor.getY();
			Optional<BoundsProvider> target = bounds.filter(b -> {
				class_238 box = b.bounds().method_1107();
				double minX = box.field_1323;
				double minY = box.field_1322;
				double maxX = box.field_1320;
				double maxY = box.field_1325;
				return x >= minX && x <= maxX && y >= minY && y <= maxY && b instanceof GhostTarget;
			}).findFirst();
			if (target.isPresent() && target.get() instanceof GhostTarget ghost) {
				Object held = stack.getStack().getValue();
				if (held instanceof class_1799 item) {
					ghost.accept(item);
					return DraggedAcceptorResult.CONSUMED;
				}
			}
		}
		return DraggableStackVisitor.super.acceptDraggedStack(context, stack);
	}

	@Override
	public Stream<BoundsProvider> getDraggableAcceptingBounds(DraggingContext<AbstractSimiContainerScreen<T>> context, DraggableStack stack) {
		List<BoundsProvider> targets = new ArrayList<>();
		AbstractSimiContainerScreen<T> gui = context.getScreen();
		boolean isAttributeFilter = gui instanceof AttributeFilterScreen;

		if (stack.getStack().getValue() instanceof class_1799) {
			for (int i = 36; i < gui.method_17577().field_7761.size(); i++) {
				if (gui.method_17577().field_7761.get(i)
						.method_7682())
					targets.add(new GhostTarget<>(gui, i - 36, isAttributeFilter));

				// Only accept items in 1st slot. 2nd is used for functionality, don't wanna
				// override that one
				if (isAttributeFilter)
					break;
			}
		}

		return targets.stream();
	}

	@Override
	public <R extends class_437> boolean isHandingScreen(R screen) {
		return screen instanceof AbstractFilterScreen || screen instanceof BlueprintScreen || screen instanceof LinkedControllerScreen || screen instanceof ScheduleScreen;
	}

	private static class GhostTarget<I, T extends GhostItemMenu<?>> implements BoundsProvider {

		private final Rectangle area;
		private final AbstractSimiContainerScreen<T> gui;
		private final int slotIndex;
		private final boolean isAttributeFilter;

		public GhostTarget(AbstractSimiContainerScreen<T> gui, int slotIndex, boolean isAttributeFilter) {
			this.gui = gui;
			this.slotIndex = slotIndex;
			this.isAttributeFilter = isAttributeFilter;
			class_1735 slot = gui.method_17577().field_7761.get(slotIndex + 36);
			AbstractContainerScreenAccessor access = (AbstractContainerScreenAccessor) gui;
			this.area = new Rectangle(access.port_lib$getGuiLeft() + slot.field_7873, access.port_lib$getGuiTop() + slot.field_7872, 16, 16);
		}

		public void accept(I ingredient) {
			class_1799 stack = ((class_1799) ingredient).method_7972();
			stack.method_7939(1);
			gui.method_17577().ghostInventory.setStackInSlot(slotIndex, stack);

			if (isAttributeFilter)
				return;

			// sync new filter contents with server
			AllPackets.getChannel().sendToServer(new GhostItemSubmitPacket(stack, slotIndex));
		}

		@Override
		public class_265 bounds() {
			return BoundsProvider.fromRectangle(area);
		}
	}
}
