package com.simibubi.create.compat.rei.category;

import java.util.ArrayList;
import java.util.List;
import com.simibubi.create.compat.rei.category.BlockCuttingCategory.CondensedBlockCuttingRecipe;
import com.simibubi.create.compat.rei.category.animations.AnimatedSaw;
import com.simibubi.create.compat.rei.display.CreateDisplay;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.item.ItemHelper;

import me.shedaniel.math.Point;
import me.shedaniel.rei.api.client.gui.widgets.Widget;
import me.shedaniel.rei.api.common.util.EntryIngredients;
import net.minecraft.class_1799;
import net.minecraft.class_1856;
import net.minecraft.class_1860;
import net.minecraft.class_2960;
import net.minecraft.class_332;
import net.minecraft.class_3975;

public class BlockCuttingCategory extends CreateRecipeCategory<CondensedBlockCuttingRecipe> {

	private AnimatedSaw saw = new AnimatedSaw();

	public BlockCuttingCategory(Info<CondensedBlockCuttingRecipe> info) {
		super(info);
	}

	@Override
	public void addWidgets(CreateDisplay<CondensedBlockCuttingRecipe> display, List<Widget> ingredients, Point origin) {
		ingredients.add(basicSlot(origin.x + 5, origin.y + 5)
				.markInput()
				.entries(display.getInputEntries().get(0)));

		List<List<class_1799>> results = display.getRecipe().getCondensedOutputs();
		for (int outputIndex = 0; outputIndex < results.size(); outputIndex++) {
			int xOffset = (outputIndex % 5) * 19;
			int yOffset = (outputIndex / 5) * -19;

			ingredients.add(basicSlot(origin.x + 78 + xOffset, origin.y + 48 + yOffset)
					.markOutput()
					.entries(EntryIngredients.ofItemStacks(results.get(outputIndex))));
		}
	}

	@Override
	public void draw(CondensedBlockCuttingRecipe recipe, class_332 graphics, double mouseX, double mouseY) {
		AllGuiTextures.JEI_SLOT.render(graphics, 4, 4);
		int size = Math.min(recipe.getOutputs().size(), 15);
		for (int i = 0; i < size; i++) {
			int xOffset = (i % 5) * 19;
			int yOffset = (i / 5) * -19;
			AllGuiTextures.JEI_SLOT.render(graphics, 77 + xOffset, 47 + yOffset);
		}
		AllGuiTextures.JEI_DOWN_ARROW.render(graphics, 31, 6);
		AllGuiTextures.JEI_SHADOW.render(graphics, 33 - 17, 37 + 13);
		saw.draw(graphics, 33, 37);
	}

	public static class CondensedBlockCuttingRecipe extends class_3975 {

		List<class_1799> outputs = new ArrayList<>();

		public CondensedBlockCuttingRecipe(class_1856 ingredient) {
			super(new class_2960(""), "", ingredient, class_1799.field_8037);
		}

		public void addOutput(class_1799 stack) {
			outputs.add(stack);
		}

		public List<class_1799> getOutputs() {
			return outputs;
		}

		public List<List<class_1799>> getCondensedOutputs() {
			List<List<class_1799>> result = new ArrayList<>();
			int index = 0;
			boolean firstPass = true;
			for (class_1799 itemStack : outputs) {
				if (firstPass)
					result.add(new ArrayList<>());
				result.get(index).add(itemStack);
				index++;
				if (index >= 15) {
					index = 0;
					firstPass = false;
				}
			}
			return result;
		}

		@Override
		public boolean method_8118() {
			return true;
		}

		public static List<CondensedBlockCuttingRecipe> condenseRecipes(List<class_1860<?>> stoneCuttingRecipes) {
			List<CondensedBlockCuttingRecipe> condensed = new ArrayList<>();
			Recipes: for (class_1860<?> recipe : stoneCuttingRecipes) {
				class_1856 i1 = recipe.method_8117().get(0);
				for (CondensedBlockCuttingRecipe condensedRecipe : condensed) {
					if (ItemHelper.matchIngredients(i1, condensedRecipe.method_8117().get(0))) {
						condensedRecipe.addOutput(CreateRecipeCategory.getResultItem(recipe));
						continue Recipes;
					}
				}
				CondensedBlockCuttingRecipe cr = new CondensedBlockCuttingRecipe(i1);
				cr.addOutput(CreateRecipeCategory.getResultItem(recipe));
				condensed.add(cr);
			}
			return condensed;
		}

	}

}
