package com.simibubi.create.compat.rei.category;

import java.util.List;
import com.simibubi.create.compat.rei.category.animations.AnimatedKinetics;
import com.simibubi.create.compat.rei.display.CreateDisplay;
import com.simibubi.create.content.kinetics.deployer.ItemApplicationRecipe;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import com.simibubi.create.foundation.utility.Lang;

import me.shedaniel.math.Point;
import me.shedaniel.rei.api.client.gui.widgets.Slot;
import me.shedaniel.rei.api.client.gui.widgets.Widget;
import me.shedaniel.rei.api.client.util.ClientEntryStacks;
import me.shedaniel.rei.api.common.entry.EntryIngredient;
import me.shedaniel.rei.api.common.util.EntryIngredients;
import net.minecraft.class_124;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2680;
import net.minecraft.class_332;
import net.minecraft.class_4587;
import net.minecraft.class_7833;

public class ItemApplicationCategory extends CreateRecipeCategory<ItemApplicationRecipe> {

	public ItemApplicationCategory(Info<ItemApplicationRecipe> info) {
		super(info);
	}

	@Override
	public void addWidgets(CreateDisplay<ItemApplicationRecipe> display, List<Widget> ingredients, Point origin) {
		ingredients.add(basicSlot( 27, 38, origin)
				.markInput()
				.entries(EntryIngredients.ofIngredient(display.getRecipe().getProcessedItem())));

		Slot slot = basicSlot(51, 5, origin)
				.markInput()
				.entries(EntryIngredients.ofIngredient(display.getRecipe().getRequiredHeldItem()));
		ClientEntryStacks.setTooltipProcessor(slot.getCurrentEntry(), (entryStack, tooltip) -> {
			if (display.getRecipe().shouldKeepHeldItem())
					tooltip.add(Lang.translateDirect("recipe.deploying.not_consumed")
					.method_27692(class_124.field_1065));
			return tooltip;
		});
		ingredients.add(slot);

		Slot outputSlot = basicSlot(132, 38, origin)
				.markOutput()
				.entries(display.getOutputEntries().get(0));
		ClientEntryStacks.setTooltipProcessor(outputSlot.getCurrentEntry(), (entryStack, tooltip) -> {
					addStochasticTooltip(display.getRecipe().getRollableResults()
							.get(0), tooltip);
			return tooltip;
		});
		ingredients.add(outputSlot);
	}

	@Override
	public void draw(ItemApplicationRecipe recipe, CreateDisplay<ItemApplicationRecipe> display, class_332 graphics,
		double mouseX, double mouseY) {
		AllGuiTextures.JEI_SLOT.render(graphics, 50, 4);
		AllGuiTextures.JEI_SLOT.render(graphics, 26, 37);
		getRenderedSlot(recipe, 0).render(graphics, 131, 37);
		AllGuiTextures.JEI_SHADOW.render(graphics, 62, 47);
		AllGuiTextures.JEI_DOWN_ARROW.render(graphics, 74, 10);

		EntryIngredient displayedIngredient = display.getInputEntries().get(0);
		if (displayedIngredient.isEmpty())
			return;

		class_1792 item = ((class_1799)displayedIngredient.get(0).getValue()).method_7909();
		if (!(item instanceof class_1747 blockItem))
			return;

		class_2680 state = blockItem.method_7711()
			.method_9564();

		class_4587 matrixStack = graphics.method_51448();
		matrixStack.method_22903();
		matrixStack.method_46416(74, 51, 100);
		matrixStack.method_22907(class_7833.field_40714.rotationDegrees(-15.5f));
		matrixStack.method_22907(class_7833.field_40716.rotationDegrees(22.5f));
		int scale = 20;

		GuiGameElement.of(state)
			.lighting(AnimatedKinetics.DEFAULT_LIGHTING)
			.scale(scale)
			.render(graphics);

		matrixStack.method_22909();
	}

}
