package com.simibubi.create.compat.rei.category;

import java.util.List;
import com.simibubi.create.compat.rei.category.animations.AnimatedCrafter;
import com.simibubi.create.compat.rei.display.CreateDisplay;
import com.simibubi.create.foundation.gui.AllGuiTextures;

import me.shedaniel.math.FloatingDimension;
import me.shedaniel.math.Point;
import me.shedaniel.math.Rectangle;
import me.shedaniel.rei.api.client.gui.widgets.Slot;
import me.shedaniel.rei.api.client.gui.widgets.Widget;
import me.shedaniel.rei.api.client.gui.widgets.Widgets;
import me.shedaniel.rei.api.common.entry.EntryIngredient;
import me.shedaniel.rei.api.common.util.EntryIngredients;
import me.shedaniel.rei.api.common.util.EntryStacks;
import net.minecraft.class_1856;
import net.minecraft.class_1869;
import net.minecraft.class_2371;
import net.minecraft.class_310;
import net.minecraft.class_332;
import net.minecraft.class_3955;
import net.minecraft.class_4587;

public class MechanicalCraftingCategory extends CreateRecipeCategory<class_3955> {

	private final AnimatedCrafter crafter = new AnimatedCrafter();

	public MechanicalCraftingCategory(Info<class_3955> info) {
		super(info);
	}

	static int maxSize = 100;

	public static float getScale(class_3955 recipe) {
		int w = getWidth(recipe);
		int h = getHeight(recipe);
		return Math.min(1, maxSize / (19f * Math.max(w, h)));
	}

	public static int getYPadding(class_3955 recipe) {
		return 3 + 50 - (int) (getScale(recipe) * getHeight(recipe) * 19 * .5);
	}

	public static int getXPadding(class_3955 recipe) {
		return 3 + 50 - (int) (getScale(recipe) * getWidth(recipe) * 19 * .5);
	}

	private static int getWidth(class_3955 recipe) {
		return recipe instanceof class_1869 ? ((class_1869)recipe).method_8150() : 1;
	}

	private static int getHeight(class_3955 recipe) {
		return recipe instanceof class_1869 ? ((class_1869)recipe).method_8158() : 1;
	}

	@Override
	public List<Widget> setupDisplay(CreateDisplay<class_3955> display, Rectangle pos) {
		List<Widget> widgets = super.setupDisplay(display, pos);
		class_3955 recipe = display.getRecipe();

		Slot result = Widgets.createSlot(new Point( pos.x + 134, pos.y + 81))
				.entries(List.of(EntryStacks.of(getResultItem(recipe))))
				.disableBackground();
		widgets.add(result);

		int x = getXPadding(recipe);
		int y = getYPadding(recipe);
		float scale = getScale(recipe);
		FloatingDimension slotSize = new FloatingDimension(18 * scale, 18 * scale);

		class_2371<class_1856> ingredients = recipe.method_8117();
		for (int i = 0; i < ingredients.size(); i++) {
			float f = 19 * scale;
			int xPosition = (int) (x + 1 + (i % getWidth(recipe)) * f) + pos.x;
			int yPosition = (int) (y + 1 + (i / getWidth(recipe)) * f) + pos.y;

			EntryIngredient ingredient = EntryIngredients.ofIngredient(ingredients.get(i));
			if (ingredient.isEmpty())
				continue;
			Slot slot = Widgets.createSlot(new Point(xPosition, yPosition))
					.disableBackground().markInput().entries(ingredient);
			slot.getBounds().setSize(slotSize);
			widgets.add(slot);
		}

		return widgets;
	}

	@Override
	public void draw(class_3955 recipe, class_332 graphics, double mouseX, double mouseY) {
		class_4587 matrixStack = graphics.method_51448();
		matrixStack.method_22903();
		matrixStack.method_46416(0, -4, 0); // why?
		matrixStack.method_22903();
		float scale = getScale(recipe);
		matrixStack.method_46416(getXPadding(recipe), getYPadding(recipe), 0);

		for (int i = 0; i < recipe.method_8117().size(); i++)
			if (!recipe.method_8117().get(i).method_8103()) {
				int row = i / getWidth(recipe);
				int col = i % getWidth(recipe);

				matrixStack.method_22903();
				matrixStack.method_46416(col * 19 * scale, row * 19 * scale, 0);
				matrixStack.method_22905(scale, scale, scale);
				AllGuiTextures.JEI_SLOT.render(graphics, 0, 0);
				matrixStack.method_22909();
			}

		matrixStack.method_22909();

		AllGuiTextures.JEI_SLOT.render(graphics, 133, 80);
		AllGuiTextures.JEI_DOWN_ARROW.render(graphics, 128, 59);
		crafter.draw(graphics, 129, 25);

		matrixStack.method_22903();
		matrixStack.method_46416(0, 0, 300);

		int amount = 0;
		for (class_1856 ingredient : recipe.method_8117()) {
			if (class_1856.field_9017 == ingredient)
				continue;
			amount++;
		}

		graphics.method_51433(class_310.method_1551().field_1772, String.valueOf(amount), 142, 39, 0xFFFFFF, true);
		matrixStack.method_22909();
		matrixStack.method_22909();
	}
}
