package com.simibubi.create.compat.rei.category;

import java.util.List;
import com.simibubi.create.AllItems;
import com.simibubi.create.compat.rei.display.CreateDisplay;
import com.simibubi.create.content.equipment.sandPaper.SandPaperPolishingRecipe;
import com.simibubi.create.content.processing.recipe.ProcessingOutput;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.element.GuiGameElement;

import io.github.fabricators_of_create.porting_lib.util.NBTSerializer;
import me.shedaniel.math.Point;
import me.shedaniel.rei.api.client.gui.widgets.Widget;
import me.shedaniel.rei.api.common.util.EntryIngredients;
import net.minecraft.class_1799;
import net.minecraft.class_1856;
import net.minecraft.class_2371;
import net.minecraft.class_2487;
import net.minecraft.class_332;

public class PolishingCategory extends CreateRecipeCategory<SandPaperPolishingRecipe> {

	private final class_1799 renderedSandpaper;

	public PolishingCategory(Info<SandPaperPolishingRecipe> info) {
		super(info);
		renderedSandpaper = AllItems.SAND_PAPER.asStack();
	}

	@Override
	public void addWidgets(CreateDisplay<SandPaperPolishingRecipe> display, List<Widget> ingredients, Point origin) {
		List<ProcessingOutput> results = display.getRecipe().getRollableResults();

		ingredients.add(basicSlot(origin.x + 27, origin.y + 29)
				.markInput()
				.entries(display.getInputEntries().get(0)));
		ingredients.add(basicSlot(origin.x + 132, origin.y + 29)
				.markOutput()
				.entries(EntryIngredients.of(results.get(0).getStack())));

		addStochasticTooltip(ingredients, results);
	}

	@Override
	public void draw(SandPaperPolishingRecipe recipe, class_332 graphics, double mouseX, double mouseY) {
		AllGuiTextures.JEI_SLOT.render(graphics, 26, 28);
		getRenderedSlot(recipe, 0).render(graphics, 131, 28);
		AllGuiTextures.JEI_SHADOW.render(graphics, 61, 21);
		AllGuiTextures.JEI_LONG_ARROW.render(graphics, 52, 32);

		class_2371<class_1856> ingredients = recipe.method_8117();
		class_1799[] matchingStacks = ingredients.get(0)
			.method_8105();
		if (matchingStacks.length == 0)
			return;


		class_2487 tag = renderedSandpaper.method_7948();
		tag.method_10566("Polishing", NBTSerializer.serializeNBT(matchingStacks[0]));
		tag.method_10556("JEI", true);
		GuiGameElement.of(renderedSandpaper)
				.<GuiGameElement.GuiRenderBuilder>at(getDisplayWidth(null) / 2 - 16, 0, 0)
				.scale(2)
				.render(graphics);
	}

}
