package com.simibubi.create.content.contraptions;

import java.util.List;
import java.util.function.Supplier;

import org.jetbrains.annotations.Nullable;

import com.google.common.collect.ImmutableList;
import com.google.common.collect.Iterators;
import com.simibubi.create.foundation.utility.Lang;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;
import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_1263;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1703;
import net.minecraft.class_1707;
import net.minecraft.class_1799;
import net.minecraft.class_2561;
import net.minecraft.class_3532;
import net.minecraft.class_3908;
import net.minecraft.class_3917;

public class MountedStorageInteraction {

	public static final List<class_3917<?>> menus = ImmutableList.of(class_3917.field_18664, class_3917.field_18665,
		class_3917.field_17326, class_3917.field_18666, class_3917.field_18667, class_3917.field_17327);

	public static class_3908 createMenuProvider(class_2561 displayName, ItemStackHandler primary, @Nullable ItemStackHandler secondary,
		int slotCount, Supplier<Boolean> stillValid) {
		int rows = class_3532.method_15340(slotCount / 9, 1, 6);
		class_3917<?> menuType = menus.get(rows - 1);
		class_2561 menuName = Lang.translateDirect("contraptions.moving_container", displayName);

		return new class_3908() {

			@Override
			public class_1703 createMenu(int pContainerId, class_1661 pPlayerInventory, class_1657 pPlayer) {
				return new class_1707(menuType, pContainerId, pPlayerInventory, new StorageInteractionContainer(primary, secondary, stillValid),
					rows);
			}

			@Override
			public class_2561 method_5476() {
				return menuName;
			}

		};
	}

	public static class StorageInteractionContainer implements class_1263 {

		private Supplier<Boolean> stillValid;
		private final ItemStackHandler primary;
		@Nullable
		private final ItemStackHandler secondary; // for double chests


		public StorageInteractionContainer(ItemStackHandler primary, @Nullable ItemStackHandler secondary, Supplier<Boolean> stillValid) {
			this.primary = primary;
			this.secondary = secondary;
			this.stillValid = stillValid;
		}

		private ItemStackHandler handlerForSlot(int slot) {
			return secondary == null || slot < primary.getSlotCount() ? primary : secondary;
		}

		private int actualSlot(int slot) {
			return handlerForSlot(slot) == primary ? slot : slot - primary.getSlotCount();
		}

		private boolean oob(int slot) {
			if (slot < 0)
				return true;
			ItemStackHandler handler = handlerForSlot(slot);
			slot = actualSlot(slot);
			return slot >= handler.getSlotCount();
		}

		@Override
		public int method_5439() {
			return primary.getSlotCount() + (secondary == null ? 0 : secondary.getSlotCount());
		}

		@Override
		public boolean method_5442() {
			boolean primaryEmpty = Iterators.size(primary.nonEmptyIterator()) == 0;
			boolean secondaryEmpty = secondary == null || Iterators.size(secondary.nonEmptyIterator()) == 0;
			return primaryEmpty && secondaryEmpty;
		}

		@Override
		public class_1799 method_5438(int slot) {
			if (oob(slot))
				return class_1799.field_8037;
			ItemStackHandler handler = handlerForSlot(slot);
			slot = actualSlot(slot);
			return handler.getStackInSlot(slot);
		}

		@Override
		public class_1799 method_5434(int slot, int count) {
			if (oob(slot))
				return class_1799.field_8037;
			ItemStackHandler handler = handlerForSlot(slot);
			slot = actualSlot(slot);

			class_1799 current = handler.getStackInSlot(slot);
			if (current.method_7960())
				return class_1799.field_8037;
			current = current.method_7972();
			class_1799 extracted = current.method_7971(count);
			handler.setStackInSlot(slot, current);
			return extracted;
		}

		@Override
		public class_1799 method_5441(int slot) {
			return method_5434(slot, Integer.MAX_VALUE);
		}

		@Override
		public void method_5447(int slot, class_1799 stack) {
			if (!oob(slot)) {
				ItemStackHandler handler = handlerForSlot(slot);
				slot = actualSlot(slot);
				handler.setStackInSlot(slot, stack.method_7972());
			}
		}

		@Override
		public void method_5431() {
		}

		@Override
		public boolean method_5443(class_1657 player) {
			return stillValid.get();
		}

		@Override
		public boolean method_5437(int slot, class_1799 stack) {
			ItemStackHandler handler = handlerForSlot(slot);
			slot = actualSlot(slot);
			return handler.isItemValid(slot, ItemVariant.of(stack));
		}

		@Override
		public void method_5448() {
			primary.setSize(primary.getSlotCount());
			if (secondary != null)
				secondary.setSize(secondary.getSlotCount());
		}
	}

}
