package com.simibubi.create.content.contraptions.actors.contraptionControls;

import java.util.Iterator;
import java.util.List;
import net.minecraft.class_1297;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_310;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.content.contraptions.Contraption;
import com.simibubi.create.foundation.networking.SimplePacketBase;

public class ContraptionDisableActorPacket extends SimplePacketBase {

	private int entityID;
	private class_1799 filter;
	private boolean enable;

	public ContraptionDisableActorPacket(int entityID, class_1799 filter, boolean enable) {
		this.entityID = entityID;
		this.filter = filter;
		this.enable = enable;
	}

	public ContraptionDisableActorPacket(class_2540 buffer) {
		entityID = buffer.readInt();
		enable = buffer.readBoolean();
		filter = buffer.method_10819();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(entityID);
		buffer.writeBoolean(enable);
		buffer.method_10793(filter);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_1297 entityByID = class_310.method_1551().field_1687.method_8469(entityID);
			if (!(entityByID instanceof AbstractContraptionEntity ace))
				return;

			Contraption contraption = ace.getContraption();
			List<class_1799> disabledActors = contraption.getDisabledActors();
			if (filter.method_7960())
				disabledActors.clear();

			if (!enable) {
				disabledActors.add(filter);
				contraption.setActorsActive(filter, false);
				return;
			}

			for (Iterator<class_1799> iterator = disabledActors.iterator(); iterator.hasNext();) {
				class_1799 next = iterator.next();
				if (ContraptionControlsMovement.isSameFilter(next, filter) || next.method_7960())
					iterator.remove();
			}

			contraption.setActorsActive(filter, true);
		});
		return true;
	}

}
