package com.simibubi.create.content.contraptions.actors.psi;

import com.jozufozu.flywheel.api.MaterialManager;
import com.jozufozu.flywheel.core.Materials;
import com.jozufozu.flywheel.core.materials.model.ModelData;
import com.simibubi.create.foundation.utility.AngleHelper;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;

public class PIInstance {
	private final MaterialManager materialManager;
	private final class_2680 blockState;
	private final class_2338 instancePos;
	private final float angleX;
	private final float angleY;

	private boolean lit;
	ModelData middle;
	ModelData top;

	public PIInstance(MaterialManager materialManager, class_2680 blockState, class_2338 instancePos) {
		this.materialManager = materialManager;
		this.blockState = blockState;
		this.instancePos = instancePos;
		class_2350 facing = blockState.method_11654(PortableStorageInterfaceBlock.field_10927);
		angleX = facing == class_2350.field_11036 ? 0 : facing == class_2350.field_11033 ? 180 : 90;
		angleY = AngleHelper.horizontalAngle(facing);
	}

	public void init(boolean lit) {
		this.lit = lit;
		middle = materialManager.defaultSolid()
				.material(Materials.TRANSFORMED)
				.getModel(PortableStorageInterfaceRenderer.getMiddleForState(blockState, lit), blockState)
				.createInstance();
		top = materialManager.defaultSolid()
				.material(Materials.TRANSFORMED)
				.getModel(PortableStorageInterfaceRenderer.getTopForState(blockState), blockState)
				.createInstance();
	}

	public void beginFrame(float progress) {
		middle.loadIdentity()
				.translate(instancePos)
				.centre()
				.rotateY(angleY)
				.rotateX(angleX)
				.unCentre();

		top.loadIdentity()
				.translate(instancePos)
				.centre()
				.rotateY(angleY)
				.rotateX(angleX)
				.unCentre();

		middle.translate(0, progress * 0.5f + 0.375f, 0);
		top.translate(0, progress, 0);

	}

	public void tick(boolean lit) {
		if (this.lit != lit) {
			this.lit = lit;
			materialManager.defaultSolid()
					.material(Materials.TRANSFORMED)
					.getModel(PortableStorageInterfaceRenderer.getMiddleForState(blockState, lit), blockState)
					.stealInstance(middle);
		}
	}

	public void remove() {
		middle.delete();
		top.delete();
	}
}
