package com.simibubi.create.content.contraptions.actors.trainControls;

import java.util.ArrayList;
import java.util.Collection;
import java.util.UUID;
import net.minecraft.class_1297;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.foundation.networking.SimplePacketBase;

public class ControlsInputPacket extends SimplePacketBase {

	private Collection<Integer> activatedButtons;
	private boolean press;
	private int contraptionEntityId;
	private class_2338 controlsPos;
	private boolean stopControlling;

	public ControlsInputPacket(Collection<Integer> activatedButtons, boolean press, int contraptionEntityId,
		class_2338 controlsPos, boolean stopControlling) {
		this.contraptionEntityId = contraptionEntityId;
		this.activatedButtons = activatedButtons;
		this.press = press;
		this.controlsPos = controlsPos;
		this.stopControlling = stopControlling;
	}

	public ControlsInputPacket(class_2540 buffer) {
		contraptionEntityId = buffer.readInt();
		activatedButtons = new ArrayList<>();
		press = buffer.readBoolean();
		int size = buffer.method_10816();
		for (int i = 0; i < size; i++)
			activatedButtons.add(buffer.method_10816());
		controlsPos = buffer.method_10811();
		stopControlling = buffer.readBoolean();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(contraptionEntityId);
		buffer.writeBoolean(press);
		buffer.method_10804(activatedButtons.size());
		activatedButtons.forEach(buffer::method_10804);
		buffer.method_10807(controlsPos);
		buffer.writeBoolean(stopControlling);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			class_1937 world = player.method_5770();
			UUID uniqueID = player.method_5667();

			if (player.method_7325() && press)
				return;

			class_1297 entity = world.method_8469(contraptionEntityId);
			if (!(entity instanceof AbstractContraptionEntity ace))
				return;
			if (stopControlling) {
				ace.stopControlling(controlsPos);
				return;
			}

			if (ace.toGlobalVector(class_243.method_24953(controlsPos), 0)
				.method_24802(player.method_19538(), 16))
				ControlsServerHandler.receivePressed(world, ace, controlsPos, uniqueID, activatedButtons, press);
		});
		return true;
	}

}
