package com.simibubi.create.content.contraptions.behaviour.dispenser;

import java.util.HashMap;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2246;
import net.minecraft.class_2315;
import net.minecraft.class_2338;
import net.minecraft.class_2347;
import net.minecraft.class_2350;
import net.minecraft.class_2357;
import net.minecraft.class_243;
import net.minecraft.class_2965;
import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import com.simibubi.create.foundation.mixin.accessor.DispenserBlockAccessor;

public class DispenserMovementBehaviour extends DropperMovementBehaviour {
	private static final HashMap<class_1792, IMovedDispenseItemBehaviour> MOVED_DISPENSE_ITEM_BEHAVIOURS = new HashMap<>();
	private static final HashMap<class_1792, IMovedDispenseItemBehaviour> MOVED_PROJECTILE_DISPENSE_BEHAVIOURS = new HashMap<>();
	private static boolean spawnEggsRegistered = false;

	public static void gatherMovedDispenseItemBehaviours() {
		IMovedDispenseItemBehaviour.init();
	}

	public static void registerMovedDispenseItemBehaviour(class_1792 item,
		IMovedDispenseItemBehaviour movedDispenseItemBehaviour) {
		MOVED_DISPENSE_ITEM_BEHAVIOURS.put(item, movedDispenseItemBehaviour);
	}

	public static class_2357 getDispenseMethod(class_1799 itemstack) {
		return ((DispenserBlockAccessor) class_2246.field_10200).create$callGetDispenseMethod(itemstack);
	}

	@Override
	protected void activate(MovementContext context, class_2338 pos) {
		if (!spawnEggsRegistered) {
			spawnEggsRegistered = true;
			IMovedDispenseItemBehaviour.initSpawnEggs();
		}

		DispenseItemLocation location = getDispenseLocation(context);
		if (location.isEmpty()) {
			context.world.method_20290(1001, pos, 0);
		} else {
			class_1799 itemStack = getItemStackAt(location, context);
			// Special dispense item behaviour for moving contraptions
			if (MOVED_DISPENSE_ITEM_BEHAVIOURS.containsKey(itemStack.method_7909())) {
				setItemStackAt(location, MOVED_DISPENSE_ITEM_BEHAVIOURS.get(itemStack.method_7909()).dispense(itemStack, context, pos), context);
				return;
			}

			class_1799 backup = itemStack.method_7972();
			// If none is there, try vanilla registry
			try {
				if (MOVED_PROJECTILE_DISPENSE_BEHAVIOURS.containsKey(itemStack.method_7909())) {
					setItemStackAt(location, MOVED_PROJECTILE_DISPENSE_BEHAVIOURS.get(itemStack.method_7909()).dispense(itemStack, context, pos), context);
					return;
				}

				class_2357 behavior = getDispenseMethod(itemStack);
				if (behavior instanceof class_2965) { // Projectile behaviours can be converted most of the time
					IMovedDispenseItemBehaviour movedBehaviour = MovedProjectileDispenserBehaviour.of((class_2965) behavior);
					setItemStackAt(location, movedBehaviour.dispense(itemStack, context, pos), context);
					MOVED_PROJECTILE_DISPENSE_BEHAVIOURS.put(itemStack.method_7909(), movedBehaviour); // buffer conversion if successful
					return;
				}

				class_243 facingVec = class_243.method_24954(context.state.method_11654(class_2315.field_10918).method_10163());
				facingVec = context.rotation.apply(facingVec);
				facingVec.method_1029();
				class_2350 clostestFacing = class_2350.method_10142(facingVec.field_1352, facingVec.field_1351, facingVec.field_1350);
				ContraptionBlockSource blockSource = new ContraptionBlockSource(context, pos, clostestFacing);

				if (behavior.getClass() != class_2347.class) { // There is a dispense item behaviour registered for the vanilla dispenser
					setItemStackAt(location, behavior.dispense(blockSource, itemStack), context);
					return;
				}
			} catch (NullPointerException ignored) {
				itemStack = backup; // Something went wrong with the BE being null in ContraptionBlockSource, reset the stack
			}

			setItemStackAt(location, DEFAULT_BEHAVIOUR.dispense(itemStack, context, pos), context);  // the default: launch the item
		}
	}

}
