package com.simibubi.create.content.contraptions.behaviour.dispenser;

import com.simibubi.create.content.contraptions.behaviour.MovementContext;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemHandlerHelper;

import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_1263;
import net.minecraft.class_1542;
import net.minecraft.class_1799;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2315;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2614;

public class MovedDefaultDispenseItemBehaviour implements IMovedDispenseItemBehaviour {
	private static final MovedDefaultDispenseItemBehaviour DEFAULT_INSTANCE = new MovedDefaultDispenseItemBehaviour();

	public static void doDispense(class_1937 p_82486_0_, class_1799 p_82486_1_, int p_82486_2_, class_243 facing,
		class_2338 p_82486_4_, MovementContext context) {
		double d0 = p_82486_4_.method_10263() + facing.field_1352 + .5;
		double d1 = p_82486_4_.method_10264() + facing.field_1351 + .5;
		double d2 = p_82486_4_.method_10260() + facing.field_1350 + .5;
		if (class_2350.method_10142(facing.field_1352, facing.field_1351, facing.field_1350)
			.method_10166() == class_2350.class_2351.field_11052) {
			d1 = d1 - 0.125D;
		} else {
			d1 = d1 - 0.15625D;
		}

		class_1542 itementity = new class_1542(p_82486_0_, d0, d1, d2, p_82486_1_);
		double d3 = p_82486_0_.field_9229.method_43058() * 0.1D + 0.2D;
		itementity.method_18800(
			p_82486_0_.field_9229.method_43059() * (double) 0.0075F * (double) p_82486_2_ + facing.method_10216() * d3
				+ context.motion.field_1352,
			p_82486_0_.field_9229.method_43059() * (double) 0.0075F * (double) p_82486_2_ + facing.method_10214() * d3
				+ context.motion.field_1351,
			p_82486_0_.field_9229.method_43059() * (double) 0.0075F * (double) p_82486_2_ + facing.method_10215() * d3
				+ context.motion.field_1350);
		p_82486_0_.method_8649(itementity);
	}

	@Override
	public class_1799 dispense(class_1799 itemStack, MovementContext context, class_2338 pos) {
		class_243 facingVec = class_243.method_24954(context.state.method_11654(class_2315.field_10918)
			.method_10163());
		facingVec = context.rotation.apply(facingVec);
		facingVec.method_1029();

		class_2350 closestToFacing = getClosestFacingDirection(facingVec);
		class_1263 inventory = class_2614.method_11250(context.world, pos.method_10093(closestToFacing));
		if (inventory == null) {
			this.playDispenseSound(context.world, pos);
			this.spawnDispenseParticles(context.world, pos, closestToFacing);
			return this.dispenseStack(itemStack, context, pos, facingVec);
		} else {
			if (class_2614.method_11260(null, inventory, itemStack.method_7972()
				.method_7971(1), closestToFacing.method_10153())
				.method_7960())
				itemStack.method_7934(1);
			return itemStack;
		}
	}

	/**
	 * Dispense the specified stack, play the dispense sound and spawn particles.
	 */
	protected class_1799 dispenseStack(class_1799 itemStack, MovementContext context, class_2338 pos, class_243 facing) {
		class_1799 itemstack = itemStack.method_7971(1);
		doDispense(context.world, itemstack, 6, facing, pos, context);
		return itemStack;
	}

	/**
	 * Play the dispense sound from the specified block.
	 */
	protected void playDispenseSound(class_1936 world, class_2338 pos) {
		world.method_20290(1000, pos, 0);
	}

	/**
	 * Order clients to display dispense particles from the specified block and
	 * facing.
	 */
	protected void spawnDispenseParticles(class_1936 world, class_2338 pos, class_243 facing) {
		spawnDispenseParticles(world, pos, getClosestFacingDirection(facing));
	}

	protected void spawnDispenseParticles(class_1936 world, class_2338 pos, class_2350 direction) {
		world.method_20290(2000, pos, direction.method_10146());
	}

	protected class_2350 getClosestFacingDirection(class_243 exactFacing) {
		return class_2350.method_10142(exactFacing.field_1352, exactFacing.field_1351, exactFacing.field_1350);
	}

	protected class_1799 placeItemInInventory(class_1799 consumedFrom, class_1799 output, MovementContext context,
		class_2338 pos, class_243 facing) {
		consumedFrom.method_7934(1);
		try (Transaction t = TransferUtil.getTransaction()) {
			long inserted = TransferUtil.insertItem(context.contraption.getSharedInventory(), output.method_7972());
			if (inserted != 0)
				DEFAULT_INSTANCE.dispenseStack(output, context, pos, facing);
			t.commit();
			return consumedFrom;
		}
	}
}
