package com.simibubi.create.content.contraptions.behaviour.dispenser;

import javax.annotation.Nullable;
import net.minecraft.class_1676;
import net.minecraft.class_1799;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_2965;
import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import com.simibubi.create.foundation.mixin.accessor.AbstractProjectileDispenseBehaviorAccessor;

public abstract class MovedProjectileDispenserBehaviour extends MovedDefaultDispenseItemBehaviour {

	@Override
	protected class_1799 dispenseStack(class_1799 itemStack, MovementContext context, class_2338 pos, class_243 facing) {
		double x = pos.method_10263() + facing.field_1352 * .7 + .5;
		double y = pos.method_10264() + facing.field_1351 * .7 + .5;
		double z = pos.method_10260() + facing.field_1350 * .7 + .5;
		class_1676 projectile = this.getProjectileEntity(context.world, x, y, z, itemStack.method_7972());
		if (projectile == null)
			return itemStack;
		class_243 effectiveMovementVec = facing.method_1021(getProjectileVelocity()).method_1019(context.motion);
		projectile.method_7485(effectiveMovementVec.field_1352, effectiveMovementVec.field_1351, effectiveMovementVec.field_1350, (float) effectiveMovementVec.method_1033(), this.getProjectileInaccuracy());
		context.world.method_8649(projectile);
		itemStack.method_7934(1);
		return itemStack;
	}

	@Override
	protected void playDispenseSound(class_1936 world, class_2338 pos) {
		world.method_20290(1002, pos, 0);
	}

	@Nullable
	protected abstract class_1676 getProjectileEntity(class_1937 world, double x, double y, double z, class_1799 itemStack);

	protected float getProjectileInaccuracy() {
		return 6.0F;
	}

	protected float getProjectileVelocity() {
		return 1.1F;
	}

	public static MovedProjectileDispenserBehaviour of(class_2965 vanillaBehaviour) {
		AbstractProjectileDispenseBehaviorAccessor accessor = (AbstractProjectileDispenseBehaviorAccessor) vanillaBehaviour;
		return new MovedProjectileDispenserBehaviour() {
			@Override
			protected class_1676 getProjectileEntity(class_1937 world, double x, double y, double z, class_1799 itemStack) {
				return accessor.create$callGetProjectile(world, new SimplePos(x, y, z), itemStack);
			}

			@Override
			protected float getProjectileInaccuracy() {
				return accessor.create$callGetUncertainty();
			}

			@Override
			protected float getProjectileVelocity() {
				return accessor.create$callGetPower();
			}
		};
	}
}
