package com.simibubi.create.content.contraptions.chassis;

import com.jozufozu.flywheel.api.MaterialManager;
import com.jozufozu.flywheel.api.instance.DynamicInstance;
import com.jozufozu.flywheel.backend.instancing.blockentity.BlockEntityInstance;
import com.jozufozu.flywheel.core.materials.model.ModelData;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.foundation.utility.AngleHelper;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import net.minecraft.class_2350;
import net.minecraft.class_310;
import net.minecraft.class_3532;

public class StickerInstance extends BlockEntityInstance<StickerBlockEntity> implements DynamicInstance {

	float lastOffset = Float.NaN;
	final class_2350 facing;
	final boolean fakeWorld;
	final int offset;

	private final ModelData head;

	public StickerInstance(MaterialManager materialManager, StickerBlockEntity blockEntity) {
		super(materialManager, blockEntity);

		head = getTransformMaterial().getModel(AllPartialModels.STICKER_HEAD, blockState).createInstance();

		fakeWorld = blockEntity.method_10997() != class_310.method_1551().field_1687;
		facing = blockState.method_11654(StickerBlock.field_10927);
		offset = blockState.method_11654(StickerBlock.EXTENDED) ? 1 : 0;

		animateHead(offset);
	}

	@Override
	public void beginFrame() {
		float offset = blockEntity.piston.getValue(AnimationTickHolder.getPartialTicks());

		if (fakeWorld)
			offset = this.offset;

		if (class_3532.method_15347(offset, lastOffset))
			return;

		animateHead(offset);

		lastOffset = offset;
	}

	private void animateHead(float offset) {
		head.loadIdentity()
				.translate(getInstancePosition())
				.nudge(blockEntity.hashCode())
				.centre()
				.rotateY(AngleHelper.horizontalAngle(facing))
				.rotateX(AngleHelper.verticalAngle(facing) + 90)
				.unCentre()
				.translate(0, (offset * offset) * 4 / 16f, 0);
	}

	@Override
	public void updateLight() {
		relight(pos, head);
	}

	@Override
	public void remove() {
		head.delete();
	}
}
