package com.simibubi.create.content.contraptions.elevator;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_1297;
import net.minecraft.class_2540;
import net.minecraft.class_310;
import net.minecraft.class_3222;
import com.simibubi.create.AllPackets;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.simibubi.create.foundation.utility.Couple;
import com.simibubi.create.foundation.utility.IntAttached;

public class ElevatorFloorListPacket extends SimplePacketBase {

	private int entityId;
	private List<IntAttached<Couple<String>>> floorsList;

	public ElevatorFloorListPacket(AbstractContraptionEntity entity, List<IntAttached<Couple<String>>> floorsList) {
		this.entityId = entity.method_5628();
		this.floorsList = floorsList;
	}

	public ElevatorFloorListPacket(class_2540 buffer) {
		entityId = buffer.readInt();
		int size = buffer.readInt();
		floorsList = new ArrayList<>();
		for (int i = 0; i < size; i++)
			floorsList.add(IntAttached.with(buffer.readInt(), Couple.create(buffer.method_19772(), buffer.method_19772())));
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(entityId);
		buffer.writeInt(floorsList.size());
		for (IntAttached<Couple<String>> entry : floorsList) {
			buffer.writeInt(entry.getFirst());
			entry.getSecond()
				.forEach(buffer::method_10814);
		}
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_1297 entityByID = class_310.method_1551().field_1687.method_8469(entityId);
			if (!(entityByID instanceof AbstractContraptionEntity ace))
				return;
			if (!(ace.getContraption()instanceof ElevatorContraption ec))
				return;

			ec.namesList = floorsList;
			ec.syncControlDisplays();
		});
		return true;
	}

	public static class RequestFloorList extends SimplePacketBase {

		private int entityId;

		public RequestFloorList(AbstractContraptionEntity entity) {
			this.entityId = entity.method_5628();
		}

		public RequestFloorList(class_2540 buffer) {
			entityId = buffer.readInt();
		}

		@Override
		public void write(class_2540 buffer) {
			buffer.writeInt(entityId);
		}

		@Override
		public boolean handle(Context context) {
			context.enqueueWork(() -> {
				class_3222 sender = context.getSender();
				class_1297 entityByID = sender.method_37908()
					.method_8469(entityId);
				if (!(entityByID instanceof AbstractContraptionEntity ace))
					return;
				if (!(ace.getContraption()instanceof ElevatorContraption ec))
					return;
				AllPackets.getChannel().sendToClient(new ElevatorFloorListPacket(ace, ec.namesList), sender);
			});
			return true;
		}

	}

}
