package com.simibubi.create.content.contraptions.elevator;

import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1297;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2540;
import net.minecraft.class_2680;
import net.minecraft.class_3222;

public class ElevatorTargetFloorPacket extends SimplePacketBase {

	private int entityId;
	private int targetY;

	public ElevatorTargetFloorPacket(AbstractContraptionEntity entity, int targetY) {
		this.targetY = targetY;
		this.entityId = entity.method_5628();
	}

	public ElevatorTargetFloorPacket(class_2540 buffer) {
		entityId = buffer.readInt();
		targetY = buffer.readInt();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(entityId);
		buffer.writeInt(targetY);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 sender = context.getSender();
			class_1297 entityByID = sender.method_51469()
				.method_8469(entityId);
			if (!(entityByID instanceof AbstractContraptionEntity ace))
				return;
			if (!(ace.getContraption() instanceof ElevatorContraption ec))
				return;
			if (ace.method_5858(sender) > 50 * 50)
				return;

			class_1937 level = sender.method_37908();
			ElevatorColumn elevatorColumn = ElevatorColumn.get(level, ec.getGlobalColumn());
			if (!elevatorColumn.contacts.contains(targetY))
				return;
			if (ec.isTargetUnreachable(targetY))
				return;

			class_2338 pos = elevatorColumn.contactAt(targetY);
			class_2680 blockState = level.method_8320(pos);
			if (!(blockState.method_26204() instanceof ElevatorContactBlock ecb))
				return;

			ecb.callToContactAndUpdate(elevatorColumn, blockState, level, pos, false);
		});
		return true;
	}

}
