package com.simibubi.create.content.contraptions.glue;

import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.simibubi.create.foundation.utility.AdventureUtil;
import net.minecraft.class_1297;
import net.minecraft.class_2338;
import net.minecraft.class_2540;
import net.minecraft.class_3222;

public class SuperGlueRemovalPacket extends SimplePacketBase {

	private int entityId;
	private class_2338 soundSource;

	public SuperGlueRemovalPacket(int id, class_2338 soundSource) {
		entityId = id;
		this.soundSource = soundSource;
	}

	public SuperGlueRemovalPacket(class_2540 buffer) {
		entityId = buffer.readInt();
		soundSource = buffer.method_10811();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(entityId);
		buffer.method_10807(soundSource);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (AdventureUtil.isAdventure(player))
				return;
			class_1297 entity = player.method_37908().method_8469(entityId);
			if (!(entity instanceof SuperGlueEntity superGlue))
				return;
			double range = 32;
			if (player.method_5707(superGlue.method_19538()) > range * range)
				return;
			AllSoundEvents.SLIME_ADDED.play(player.method_37908(), null, soundSource, 0.5F, 0.5F);
			superGlue.spawnParticles();
			entity.method_31472();
		});
		return true;
	}

}
