package com.simibubi.create.content.contraptions.glue;

import java.util.Set;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import com.simibubi.create.foundation.advancement.AllAdvancements;
import com.jamieswhiteshirt.reachentityattributes.ReachEntityAttributes;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.simibubi.create.foundation.utility.fabric.ReachUtil;

public class SuperGlueSelectionPacket extends SimplePacketBase {

	private class_2338 from;
	private class_2338 to;

	public SuperGlueSelectionPacket(class_2338 from, class_2338 to) {
		this.from = from;
		this.to = to;
	}

	public SuperGlueSelectionPacket(class_2540 buffer) {
		from = buffer.method_10811();
		to = buffer.method_10811();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10807(from);
		buffer.method_10807(to);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (AdventureUtil.isAdventure(player))
				return;

			double range = ReachUtil.reach(player) + 2;
			if (player.method_5707(class_243.method_24953(to)) > range * range)
				return;
			if (!to.method_19771(from, 25))
				return;

			Set<class_2338> group = SuperGlueSelectionHelper.searchGlueGroup(player.method_37908(), from, to, false);
			if (group == null)
				return;
			if (!group.contains(to))
				return;
			if (!SuperGlueSelectionHelper.collectGlueFromInventory(player, 1, true))
				return;

			class_238 bb = SuperGlueEntity.span(from, to);
			SuperGlueSelectionHelper.collectGlueFromInventory(player, 1, false);
			SuperGlueEntity entity = new SuperGlueEntity(player.method_37908(), bb);
			player.method_37908().method_8649(entity);
			entity.spawnParticles();

			AllAdvancements.SUPER_GLUE.awardTo(player);
		});
		return true;
	}

}
