package com.simibubi.create.content.contraptions.render;

import org.joml.Matrix4f;
import org.lwjgl.opengl.GL20;

import com.jozufozu.flywheel.core.shader.WorldProgram;
import net.minecraft.class_238;
import net.minecraft.class_2960;

public class ContraptionProgram extends WorldProgram {
	protected final int uLightBoxSize;
	protected final int uLightBoxMin;
	protected final int uModel;

	protected int uLightVolume;

	public ContraptionProgram(class_2960 name, int handle) {
		super(name, handle);
		uLightBoxSize = getUniformLocation("uLightBoxSize");
		uLightBoxMin = getUniformLocation("uLightBoxMin");
		uModel = getUniformLocation("uModel");
	}

	@Override
	protected void registerSamplers() {
		super.registerSamplers();
		uLightVolume = setSamplerBinding("uLightVolume", 4);
	}

    public void bind(Matrix4f model, class_238 lightVolume) {
        double sizeX = lightVolume.field_1320 - lightVolume.field_1323;
        double sizeY = lightVolume.field_1325 - lightVolume.field_1322;
        double sizeZ = lightVolume.field_1324 - lightVolume.field_1321;
        GL20.glUniform3f(uLightBoxSize, (float) sizeX, (float) sizeY, (float) sizeZ);
        GL20.glUniform3f(uLightBoxMin, (float) lightVolume.field_1323, (float) lightVolume.field_1322, (float) lightVolume.field_1321);
        uploadMatrixUniform(uModel, model);
    }
}
