package com.simibubi.create.content.contraptions.render;

import com.jozufozu.flywheel.core.virtual.VirtualRenderWorld;
import com.jozufozu.flywheel.event.BeginFrameEvent;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.content.contraptions.Contraption;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import net.minecraft.class_3532;
import net.minecraft.class_4587;

public class ContraptionRenderInfo {
	public final Contraption contraption;
	public final VirtualRenderWorld renderWorld;

	private final ContraptionMatrices matrices = new ContraptionMatrices();
	private boolean visible;

	public ContraptionRenderInfo(Contraption contraption, VirtualRenderWorld renderWorld) {
		this.contraption = contraption;
		this.renderWorld = renderWorld;
	}

	public int getEntityId() {
		return contraption.entity.method_5628();
	}

	public boolean isDead() {
		return !contraption.entity.isAliveOrStale();
	}

	public void beginFrame(BeginFrameEvent event) {
		matrices.clear();

		AbstractContraptionEntity entity = contraption.entity;

		visible = event.getFrustum()
			.method_23093(entity.method_5830()
				.method_1014(2));
	}

	public boolean isVisible() {
		return visible && contraption.entity.isAliveOrStale() && contraption.entity.isReadyForRender();
	}

	/**
	 * Need to call this during RenderLayerEvent.
	 */
	public void setupMatrices(class_4587 viewProjection, double camX, double camY, double camZ) {
		if (!matrices.isReady()) {
			AbstractContraptionEntity entity = contraption.entity;

			viewProjection.method_22903();

			double x = class_3532.method_16436(AnimationTickHolder.getPartialTicks(), entity.field_6038, entity.method_23317()) - camX;
			double y = class_3532.method_16436(AnimationTickHolder.getPartialTicks(), entity.field_5971, entity.method_23318()) - camY;
			double z = class_3532.method_16436(AnimationTickHolder.getPartialTicks(), entity.field_5989, entity.method_23321()) - camZ;

			viewProjection.method_22904(x, y, z);

			matrices.setup(viewProjection, entity);

			viewProjection.method_22909();
		}
	}

	/**
	 * If #setupMatrices is called correctly, the returned matrices will be ready
	 */
	public ContraptionMatrices getMatrices() {
		return matrices;
	}

	public void invalidate() {

	}
}
