package com.simibubi.create.content.contraptions.sync;

import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;
import net.minecraft.class_1297;
import net.minecraft.class_2338;
import net.minecraft.class_2540;
import net.minecraft.class_310;

public class ContraptionFluidPacket extends SimplePacketBase {

	private int entityId;
	private class_2338 localPos;
	private FluidStack containedFluid;

	public ContraptionFluidPacket(int entityId, class_2338 localPos, FluidStack containedFluid) {
		this.entityId = entityId;
		this.localPos = localPos;
		this.containedFluid = containedFluid;
	}

	public ContraptionFluidPacket(class_2540 buffer) {
		entityId = buffer.readInt();
		localPos = buffer.method_10811();
		containedFluid = FluidStack.readFromPacket(buffer);
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(entityId);
		buffer.method_10807(localPos);
		containedFluid.writeToPacket(buffer);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_1297 entityByID = class_310.method_1551().field_1687.method_8469(entityId);
			if (!(entityByID instanceof AbstractContraptionEntity))
				return;
			AbstractContraptionEntity contraptionEntity = (AbstractContraptionEntity) entityByID;
			contraptionEntity.getContraption().handleContraptionFluidPacket(localPos, containedFluid);
		});
		return true;
	}
}
