package com.simibubi.create.content.contraptions.sync;

import java.util.function.Supplier;
import net.minecraft.class_1268;
import net.minecraft.class_1297;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_238;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import com.jamieswhiteshirt.reachentityattributes.ReachEntityAttributes;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.simibubi.create.foundation.utility.fabric.ReachUtil;

public class ContraptionInteractionPacket extends SimplePacketBase {

	private class_1268 interactionHand;
	private int target;
	private class_2338 localPos;
	private class_2350 face;

	public ContraptionInteractionPacket(AbstractContraptionEntity target, class_1268 hand, class_2338 localPos, class_2350 side) {
		this.interactionHand = hand;
		this.localPos = localPos;
		this.target = target.method_5628();
		this.face = side;
	}

	public ContraptionInteractionPacket(class_2540 buffer) {
		target = buffer.readInt();
		int handId = buffer.readInt();
		interactionHand = handId == -1 ? null : class_1268.values()[handId];
		localPos = buffer.method_10811();
		face = class_2350.method_10143(buffer.readShort());
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(target);
		buffer.writeInt(interactionHand == null ? -1 : interactionHand.ordinal());
		buffer.method_10807(localPos);
		buffer.writeShort(face.method_10146());
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 sender = context.getSender();
			if (sender == null)
				return;
			class_1297 entityByID = sender.method_37908().method_8469(target);
			if (!(entityByID instanceof AbstractContraptionEntity))
				return;
			AbstractContraptionEntity contraptionEntity = (AbstractContraptionEntity) entityByID;
			class_238 bb = contraptionEntity.method_5829();
			double boundsExtra = Math.max(bb.method_17939(), bb.method_17940());
			double d = ReachUtil.reach(sender) + 10 + boundsExtra;
			if (!sender.method_6057(entityByID))
				d -= 3;
			d *= d;
			if (sender.method_5858(entityByID) > d)
				return;
			if (contraptionEntity.handlePlayerInteraction(sender, localPos, face, interactionHand))
				sender.method_23667(interactionHand, true);
		});
		return true;
	}

}
