package com.simibubi.create.content.contraptions.sync;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import net.minecraft.class_1297;
import net.minecraft.class_243;
import net.minecraft.class_2540;
import net.minecraft.class_310;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.simibubi.create.foundation.utility.VecHelper;

public class ContraptionSeatMappingPacket extends SimplePacketBase {

	private Map<UUID, Integer> mapping;
	private int entityID;
	private int dismountedID;

	public ContraptionSeatMappingPacket(int entityID, Map<UUID, Integer> mapping) {
		this(entityID, mapping, -1);
	}

	public ContraptionSeatMappingPacket(int entityID, Map<UUID, Integer> mapping, int dismountedID) {
		this.entityID = entityID;
		this.mapping = mapping;
		this.dismountedID = dismountedID;
	}

	public ContraptionSeatMappingPacket(class_2540 buffer) {
		entityID = buffer.readInt();
		dismountedID = buffer.readInt();
		mapping = new HashMap<>();
		short size = buffer.readShort();
		for (int i = 0; i < size; i++)
			mapping.put(buffer.method_10790(), (int) buffer.readShort());
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(entityID);
		buffer.writeInt(dismountedID);
		buffer.writeShort(mapping.size());
		mapping.forEach((k, v) -> {
			buffer.method_10797(k);
			buffer.writeShort(v);
		});
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
				class_1297 entityByID = class_310.method_1551().field_1687.method_8469(entityID);
				if (!(entityByID instanceof AbstractContraptionEntity))
					return;
				AbstractContraptionEntity contraptionEntity = (AbstractContraptionEntity) entityByID;

				if (dismountedID != -1) {
					class_1297 dismountedByID = class_310.method_1551().field_1687.method_8469(dismountedID);
					if (class_310.method_1551().field_1724 != dismountedByID)
						return;
					class_243 transformedVector = contraptionEntity.getPassengerPosition(dismountedByID, 1);
					if (transformedVector != null)
						dismountedByID.getCustomData()
							.method_10566("ContraptionDismountLocation", VecHelper.writeNBT(transformedVector));
				}

				contraptionEntity.getContraption()
					.setSeatMapping(mapping);
			});
		return true;
	}

}
