package com.simibubi.create.content.contraptions.sync;

import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1297;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_310;
import net.minecraft.class_638;

public class LimbSwingUpdatePacket extends SimplePacketBase {

	private int entityId;
	private class_243 position;
	private float limbSwing;

	public LimbSwingUpdatePacket(int entityId, class_243 position, float limbSwing) {
		this.entityId = entityId;
		this.position = position;
		this.limbSwing = limbSwing;
	}

	public LimbSwingUpdatePacket(class_2540 buffer) {
		entityId = buffer.readInt();
		position = new class_243(buffer.readDouble(), buffer.readDouble(), buffer.readDouble());
		limbSwing = buffer.readFloat();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(entityId);
		buffer.writeDouble(position.field_1352);
		buffer.writeDouble(position.field_1351);
		buffer.writeDouble(position.field_1350);
		buffer.writeFloat(limbSwing);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_638 world = class_310.method_1551().field_1687;
			if (world == null)
				return;
			class_1297 entity = world.method_8469(entityId);
			if (entity == null)
				return;
			class_2487 data = entity.getCustomData();
			data.method_10569("LastOverrideLimbSwingUpdate", 0);
			data.method_10548("OverrideLimbSwing", limbSwing);
			entity.method_5759(position.field_1352, position.field_1351, position.field_1350, entity.method_36454(),
				entity.method_36455(), 2, false);
		});
		return true;
	}

}
