package com.simibubi.create.content.decoration;

import java.util.function.Predicate;

import com.jamieswhiteshirt.reachentityattributes.ReachEntityAttributes;
import com.simibubi.create.content.equipment.extendoGrip.ExtendoGripItem;
import com.simibubi.create.content.equipment.wrench.IWrenchable;
import com.simibubi.create.foundation.placement.IPlacementHelper;
import com.simibubi.create.foundation.placement.PlacementHelpers;
import com.simibubi.create.foundation.placement.PlacementOffset;
import com.simibubi.create.infrastructure.config.AllConfigs;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1324;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2399;
import net.minecraft.class_2680;
import net.minecraft.class_3965;
import net.minecraft.class_6328;

public class MetalLadderBlock extends class_2399 implements IWrenchable {

	private static final int placementHelperId = PlacementHelpers.register(new PlacementHelper());

	public MetalLadderBlock(class_2251 p_54345_) {
		super(p_54345_);
	}

//	@Override // fabric: difficult to implement with little to gain
//	@Environment(EnvType.CLIENT)
//	public boolean supportsExternalFaceHiding(BlockState state) {
//		return false;
//	}

	@Override
	@Environment(EnvType.CLIENT)
	public boolean method_9522(class_2680 pState, class_2680 pAdjacentBlockState, class_2350 pDirection) {
		return pDirection == class_2350.field_11036 && pAdjacentBlockState.method_26204() instanceof class_2399;
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand,
		class_3965 ray) {
		if (player.method_5715() || !player.method_7294())
			return class_1269.field_5811;
		class_1799 heldItem = player.method_5998(hand);
		IPlacementHelper helper = PlacementHelpers.get(placementHelperId);
		if (helper.matchesItem(heldItem))
			return helper.getOffset(player, world, state, pos, ray)
				.placeInWorld(world, (class_1747) heldItem.method_7909(), player, hand, ray);
		return class_1269.field_5811;
	}

	@class_6328
	private static class PlacementHelper implements IPlacementHelper {

		@Override
		public Predicate<class_1799> getItemPredicate() {
			return i -> i.method_7909() instanceof class_1747
				&& ((class_1747) i.method_7909()).method_7711() instanceof MetalLadderBlock;
		}

		@Override
		public Predicate<class_2680> getStatePredicate() {
			return s -> s.method_26204() instanceof class_2399;
		}

		public int attachedLadders(class_1937 world, class_2338 pos, class_2350 direction) {
			class_2338 checkPos = pos.method_10093(direction);
			class_2680 state = world.method_8320(checkPos);
			int count = 0;
			while (getStatePredicate().test(state)) {
				count++;
				checkPos = checkPos.method_10093(direction);
				state = world.method_8320(checkPos);
			}
			return count;
		}

		@Override
		public PlacementOffset getOffset(class_1657 player, class_1937 world, class_2680 state, class_2338 pos,
			class_3965 ray) {
			class_2350 dir = player.method_36455() < 0 ? class_2350.field_11036 : class_2350.field_11033;

			int range = AllConfigs.server().equipment.placementAssistRange.get();
			if (player != null) {
				class_1324 reach = player.method_5996(ReachEntityAttributes.REACH);
				if (reach != null && reach.method_6196(ExtendoGripItem.singleRangeAttributeModifier))
					range += 4;
			}

			int ladders = attachedLadders(world, pos, dir);
			if (ladders >= range)
				return PlacementOffset.fail();

			class_2338 newPos = pos.method_10079(dir, ladders + 1);
			class_2680 newState = world.method_8320(newPos);

			if (!state.method_26184(world, newPos))
				return PlacementOffset.fail();

			if (newState.method_45474())
				return PlacementOffset.success(newPos, bState -> bState.method_11657(field_11253, state.method_11654(field_11253)));
			return PlacementOffset.fail();
		}

	}

}
