package com.simibubi.create.content.equipment.armor;

import java.util.function.Supplier;
import net.minecraft.class_1738.class_8051;
import net.minecraft.class_1741;
import net.minecraft.class_1802;
import net.minecraft.class_1856;
import net.minecraft.class_3414;
import com.google.common.base.Suppliers;
import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.Create;

public enum AllArmorMaterials implements class_1741 {

	COPPER(Create.asResource("copper").toString(), 7, new int[] { 2, 4, 3, 1 }, 25, () -> AllSoundEvents.COPPER_ARMOR_EQUIP.getMainEvent(), 0.0F, 0.0F,
		() -> class_1856.method_8091(class_1802.field_27022))

	;

	private static final int[] MAX_DAMAGE_ARRAY = new int[] { 11, 16, 15, 13 };
	private final String name;
	private final int maxDamageFactor;
	private final int[] damageReductionAmountArray;
	private final int enchantability;
	private final Supplier<class_3414> soundEvent;
	private final float toughness;
	private final float knockbackResistance;
	private final Supplier<class_1856> repairMaterial;

	private AllArmorMaterials(String name, int maxDamageFactor, int[] damageReductionAmountArray, int enchantability,
		Supplier<class_3414> soundEvent, float toughness, float knockbackResistance, Supplier<class_1856> repairMaterial) {
		this.name = name;
		this.maxDamageFactor = maxDamageFactor;
		this.damageReductionAmountArray = damageReductionAmountArray;
		this.enchantability = enchantability;
		this.soundEvent = soundEvent;
		this.toughness = toughness;
		this.knockbackResistance = knockbackResistance;
		this.repairMaterial = Suppliers.memoize(repairMaterial::get);
	}

	@Override
	public int method_7699() {
		return this.enchantability;
	}

	@Override
	public class_3414 method_7698() {
		return this.soundEvent.get();
	}

	@Override
	public class_1856 method_7695() {
		return this.repairMaterial.get();
	}

	@Override
	public String method_7694() {
		return this.name;
	}

	@Override
	public float method_7700() {
		return this.toughness;
	}

	@Override
	public float method_24355() {
		return this.knockbackResistance;
	}

	@Override
	public int method_48402(class_8051 pType) {
		return MAX_DAMAGE_ARRAY[pType.ordinal()] * this.maxDamageFactor;
	}

	@Override
	public int method_48403(class_8051 pType) {
		return this.damageReductionAmountArray[pType.ordinal()];
	}

}
