package com.simibubi.create.content.equipment.armor;

import com.simibubi.create.foundation.render.CachedBufferer;
import com.simibubi.create.foundation.render.SuperByteBuffer;
import com.simibubi.create.foundation.utility.AngleHelper;
import com.simibubi.create.foundation.utility.AnimationTickHolder;

import net.fabricmc.fabric.api.client.rendering.v1.LivingEntityFeatureRendererRegistrationCallback.RegistrationHelper;
import net.minecraft.class_1309;
import net.minecraft.class_1921;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_3883;
import net.minecraft.class_3887;
import net.minecraft.class_4050;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_4722;
import net.minecraft.class_572;
import net.minecraft.class_583;
import net.minecraft.class_897;
import net.minecraft.class_922;

public class BacktankArmorLayer<T extends class_1309, M extends class_583<T>> extends class_3887<T, M> {

	public BacktankArmorLayer(class_3883<T, M> renderer) {
		super(renderer);
	}

	@Override
	public void render(class_4587 ms, class_4597 buffer, int light, class_1309 entity, float yaw, float pitch,
		float pt, float p_225628_8_, float p_225628_9_, float p_225628_10_) {
		if (entity.method_18376() == class_4050.field_18078)
			return;

		BacktankItem item = BacktankItem.getWornBy(entity);
		if (item == null)
			return;

		M entityModel = method_17165();
		if (!(entityModel instanceof class_572))
			return;

		class_572<?> model = (class_572<?>) entityModel;
		class_1921 renderType = class_4722.method_24074();
		class_2680 renderedState = item.getBlock().method_9564()
				.method_11657(BacktankBlock.HORIZONTAL_FACING, class_2350.field_11035);
		SuperByteBuffer backtank = CachedBufferer.block(renderedState);
		SuperByteBuffer cogs = CachedBufferer.partial(BacktankRenderer.getCogsModel(renderedState), renderedState);

		ms.method_22903();

		model.field_3391.method_22703(ms);
		ms.method_46416(-1 / 2f, 10 / 16f, 1f);
		ms.method_22905(1, -1, -1);

		backtank.forEntityRender()
			.light(light)
			.renderInto(ms, buffer.getBuffer(renderType));

		cogs.centre()
			.rotateY(180)
			.unCentre()
			.translate(0, 6.5f / 16, 11f / 16)
			.rotate(class_2350.field_11034, AngleHelper.rad(2 * AnimationTickHolder.getRenderTime(entity.method_37908()) % 360))
			.translate(0, -6.5f / 16, -11f / 16);

		cogs.forEntityRender()
			.light(light)
			.renderInto(ms, buffer.getBuffer(renderType));

		ms.method_22909();
	}

//	public static void registerOnAll(EntityRenderDispatcher renderManager) {
//		for (EntityRenderer<? extends Player> renderer : renderManager.getSkinMap().values())
//			registerOn(renderer);
//		for (EntityRenderer<?> renderer : renderManager.renderers.values())
//			registerOn(renderer);
//	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static void registerOn(class_897<?> entityRenderer, RegistrationHelper helper) {
		if (!(entityRenderer instanceof class_922))
			return;
		class_922<?, ?> livingRenderer = (class_922<?, ?>) entityRenderer;
		if (!(livingRenderer.method_4038() instanceof class_572))
			return;
		BacktankArmorLayer<?, ?> layer = new BacktankArmorLayer<>(livingRenderer);
		helper.register(layer);
	}

}
