package com.simibubi.create.content.equipment.bell;

import javax.annotation.ParametersAreNonnullByDefault;

import com.mojang.brigadier.StringReader;
import com.mojang.serialization.Codec;
import com.simibubi.create.foundation.particle.ICustomParticleDataWithSprite;
import com.simibubi.create.foundation.utility.RegisteredObjects;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2394;
import net.minecraft.class_2396;
import net.minecraft.class_2540;
import net.minecraft.class_4002;
import net.minecraft.class_6328;
import net.minecraft.class_638;
import net.minecraft.class_702;
import net.minecraft.class_703;

@ParametersAreNonnullByDefault
@class_6328
public abstract class BasicParticleData<T extends class_703> implements class_2394, ICustomParticleDataWithSprite<BasicParticleData<T>> {

	public BasicParticleData() { }

	@Override
	public class_2395<BasicParticleData<T>> getDeserializer() {
		BasicParticleData<T> data = this;
		return new class_2394.class_2395<BasicParticleData<T>>() {
			@Override
			public BasicParticleData<T> method_10296(class_2396<BasicParticleData<T>> arg0, StringReader reader) {
				return data;
			}

			@Override
			public BasicParticleData<T> method_10297(class_2396<BasicParticleData<T>> type, class_2540 buffer) {
				return data;
			}
		};
	}

	@Override
	public Codec<BasicParticleData<T>> getCodec(class_2396<BasicParticleData<T>> type) {
		return Codec.unit(this);
	}

	public interface IBasicParticleFactory<U extends class_703> {
		U makeParticle(class_638 worldIn, double x, double y, double z, double vx, double vy, double vz, class_4002 sprite);
	}

	@Environment(EnvType.CLIENT)
	public abstract IBasicParticleFactory<T> getBasicFactory();

	@Override
	@Environment(EnvType.CLIENT)
	public class_702.class_4091<BasicParticleData<T>> getMetaFactory() {
		return animatedSprite -> (data, worldIn, x, y, z, vx, vy, vz) ->
				getBasicFactory().makeParticle(worldIn, x, y, z, vx, vy, vz, animatedSprite);
	}

	@Override
	public String method_10293() {
		return RegisteredObjects.getKeyOrThrow(method_10295()).toString();
	}

	@Override
	public void method_10294(class_2540 buffer) { }
}
