package com.simibubi.create.content.equipment.bell;

import java.util.UUID;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;

import com.google.common.cache.Cache;
import com.google.common.cache.CacheBuilder;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllPackets;
import com.simibubi.create.foundation.utility.IntAttached;
import com.simibubi.create.foundation.utility.LongAttached;

import net.fabricmc.fabric.api.networking.v1.PlayerLookup;
import net.minecraft.class_1297;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_3218;
import net.minecraft.server.MinecraftServer;

public class HauntedBellPulser {

	public static final int DISTANCE = 3;
	public static final int RECHARGE_TICKS = 8;
	public static final int WARMUP_TICKS = 10;

	public static final Cache<UUID, IntAttached<class_1297>> WARMUP = CacheBuilder.newBuilder()
		.expireAfterAccess(250, TimeUnit.MILLISECONDS)
		.build();

	public static void hauntedBellCreatesPulse(class_3218 world) {
//		if (event.phase != TickEvent.Phase.END)
//			return;
//		if (event.side != LogicalSide.SERVER)
//			return;
		PlayerLookup.world(world).forEach(player -> {
			if (player.method_7325())
				return;
			if (!player.method_24520(AllBlocks.HAUNTED_BELL::isIn))
				return;

//		Entity player = event.player;
			boolean firstPulse = false;

			try {
				IntAttached<class_1297> ticker = WARMUP.get(player.method_5667(), () -> IntAttached.with(WARMUP_TICKS, player));
				firstPulse = ticker.getFirst()
						.intValue() == 1;
				ticker.decrement();
				if (!ticker.isOrBelowZero())
					return;
			} catch (ExecutionException e) {
			}

			long gameTime = player.method_37908().method_8510();
			if (firstPulse || gameTime % RECHARGE_TICKS != 0)
				sendPulse(player.method_37908(), player.method_24515(), DISTANCE, false);
		});
	}

	public static void sendPulse(class_1937 world, class_2338 pos, int distance, boolean canOverlap) {
//		LevelChunk chunk = world.getChunkAt(pos);
		AllPackets.getChannel().sendToClientsTracking(new SoulPulseEffectPacket(pos, distance, canOverlap), (class_3218) world, pos);
	}

}
