package com.simibubi.create.content.equipment.blueprint;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.IdentityHashMap;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.AllItems;
import com.simibubi.create.content.equipment.blueprint.BlueprintEntity.BlueprintCraftingInventory;
import com.simibubi.create.content.equipment.blueprint.BlueprintEntity.BlueprintSection;
import com.simibubi.create.content.logistics.filter.AttributeFilterMenu.WhitelistMode;
import com.simibubi.create.content.logistics.filter.FilterItem;
import com.simibubi.create.content.logistics.filter.FilterItemStack;
import com.simibubi.create.content.logistics.filter.ItemAttribute;
import com.simibubi.create.content.trains.track.TrackPlacement.PlacementInfo;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import com.simibubi.create.foundation.utility.Pair;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemHandlerHelper;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;

import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.item.PlayerInventoryStorage;
import net.fabricmc.fabric.api.transfer.v1.storage.StorageUtil;
import net.fabricmc.fabric.api.transfer.v1.storage.base.ResourceAmount;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_1041;
import net.minecraft.class_124;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1934;
import net.minecraft.class_239;
import net.minecraft.class_239.class_240;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_310;
import net.minecraft.class_332;
import net.minecraft.class_3955;
import net.minecraft.class_3956;
import net.minecraft.class_3966;
import net.minecraft.class_6880;
import net.minecraft.class_7923;
import net.minecraft.class_8566;

public class BlueprintOverlayRenderer {

	static boolean active;
	static boolean empty;
	static boolean noOutput;
	static boolean lastSneakState;
	static BlueprintSection lastTargetedSection;

	static Map<class_1799, class_1799[]> cachedRenderedFilters = new IdentityHashMap<>();
	static List<Pair<class_1799, Boolean>> ingredients = new ArrayList<>();
	static class_1799 result = class_1799.field_8037;
	static boolean resultCraftable = false;

	public static void tick() {
		class_310 mc = class_310.method_1551();

		BlueprintSection last = lastTargetedSection;
		lastTargetedSection = null;
		active = false;
		noOutput = false;

		if (mc.field_1761.method_2920() == class_1934.field_9219)
			return;

		class_239 mouseOver = mc.field_1765;
		if (mouseOver == null)
			return;
		if (mouseOver.method_17783() != class_240.field_1331)
			return;

		class_3966 entityRay = (class_3966) mouseOver;
		if (!(entityRay.method_17782() instanceof BlueprintEntity))
			return;

		BlueprintEntity blueprintEntity = (BlueprintEntity) entityRay.method_17782();
		BlueprintSection sectionAt = blueprintEntity.getSectionAt(entityRay.method_17784()
			.method_1020(blueprintEntity.method_19538()));

		lastTargetedSection = last;
		active = true;

		boolean sneak = mc.field_1724.method_5715();
		if (sectionAt != lastTargetedSection || AnimationTickHolder.getTicks() % 10 == 0 || lastSneakState != sneak)
			rebuild(sectionAt, sneak);

		lastTargetedSection = sectionAt;
		lastSneakState = sneak;
	}

	public static void displayTrackRequirements(PlacementInfo info, class_1799 pavementItem) {
		if (active)
			return;

		active = true;
		empty = false;
		noOutput = true;
		ingredients.clear();

		int tracks = info.requiredTracks;
		while (tracks > 0) {
			ingredients.add(Pair.of(new class_1799(info.trackMaterial.getBlock(), Math.min(64, tracks)), info.hasRequiredTracks));
			tracks -= 64;
		}

		int pavement = info.requiredPavement;
		while (pavement > 0) {
			ingredients.add(Pair.of(ItemHandlerHelper.copyStackWithSize(pavementItem, Math.min(64, pavement)),
				info.hasRequiredPavement));
			pavement -= 64;
		}
	}

	public static void rebuild(BlueprintSection sectionAt, boolean sneak) {
		cachedRenderedFilters.clear();
		ItemStackHandler items = sectionAt.getItems();
		boolean empty = true;
		for (int i = 0; i < 9; i++) {
			if (!items.getStackInSlot(i)
				.method_7960()) {
				empty = false;
				break;
			}
		}

		BlueprintOverlayRenderer.empty = empty;
		BlueprintOverlayRenderer.result = class_1799.field_8037;

		if (empty)
			return;

		boolean firstPass = true;
		boolean success = true;
		class_310 mc = class_310.method_1551();
		PlayerInventoryStorage playerInv = PlayerInventoryStorage.of(mc.field_1724);

		int amountCrafted = 0;
		Optional<class_3955> recipe = Optional.empty();
		Map<Integer, class_1799> craftingGrid = new HashMap<>();
		ingredients.clear();
		ItemStackHandler missingItems = new ItemStackHandler(64);
		ItemStackHandler availableItems = new ItemStackHandler(64);
		List<class_1799> newlyAdded = new ArrayList<>();
		List<class_1799> newlyMissing = new ArrayList<>();
		boolean invalid = false;

		try (Transaction t = TransferUtil.getTransaction()) {
			do {
				craftingGrid.clear();
				newlyAdded.clear();
				newlyMissing.clear();

				Search:for (int i = 0; i < 9; i++) {
					FilterItemStack requestedItem = FilterItemStack.of(items.getStackInSlot(i));
					if (requestedItem.isEmpty()) {
						craftingGrid.put(i, class_1799.field_8037);
						continue;
					}

					ResourceAmount<ItemVariant> resource = StorageUtil.findExtractableContent(
							playerInv, v -> requestedItem.test(mc.field_1687, v.toStack()), t);
					if (resource != null) {
						class_1799 currentItem = resource.resource().toStack(1);
						craftingGrid.put(i, currentItem);
						newlyAdded.add(currentItem);
						continue Search;
					}

					success = false;
					newlyMissing.add(requestedItem.item());
				}

				if (success) {
					class_8566 craftingInventory = new BlueprintCraftingInventory(craftingGrid);
					if (!recipe.isPresent())
						recipe = mc.field_1687.method_8433()
								.method_8132(class_3956.field_17545, craftingInventory, mc.field_1687);
					class_1799 resultFromRecipe = recipe.filter(r -> r.method_8115(craftingInventory, mc.field_1687))
							.map(r -> r.method_8116(craftingInventory, mc.field_1687.method_30349()))
							.orElse(class_1799.field_8037);

					if (resultFromRecipe.method_7960()) {
						if (!recipe.isPresent())
							invalid = true;
						success = false;
					} else if (resultFromRecipe.method_7947() + amountCrafted > 64) {
						success = false;
					} else {
						amountCrafted += resultFromRecipe.method_7947();
						if (result.method_7960())
							result = resultFromRecipe.method_7972();
						else
							result.method_7933(resultFromRecipe.method_7947());
						resultCraftable = true;
						firstPass = false;
					}
				}

				if (success || firstPass) {
					newlyAdded.forEach(s -> availableItems.insert(ItemVariant.of(s), s.method_7947(), t));
					newlyMissing.forEach(s -> missingItems.insert(ItemVariant.of(s), s.method_7947(), t));
				}

				if (!success) {
					if (firstPass) {
						result = invalid ? class_1799.field_8037 : items.getStackInSlot(9);
						resultCraftable = false;
					}
					break;
				}

				if (!sneak)
					break;

			} while (success);
			t.commit();
		}

		for (int i = 0; i < 9; i++) {
			class_1799 available = availableItems.getStackInSlot(i);
			if (available.method_7960())
				continue;
			ingredients.add(Pair.of(available, true));
		}
		for (int i = 0; i < 9; i++) {
			class_1799 missing = missingItems.getStackInSlot(i);
			if (missing.method_7960())
				continue;
			ingredients.add(Pair.of(missing, false));
		}
	}

	public static void renderOverlay(class_332 graphics, float partialTicks, class_1041 window) {
		class_310 mc = class_310.method_1551();
		if (mc.field_1690.field_1842)
			return;
		if (!active || empty)
			return;

		int w = 21 * ingredients.size();

		if (!noOutput)
			w += 51;

		int x = (window.method_4486() - w) / 2;
		int y = (int) (window.method_4502() - 100);

		for (Pair<class_1799, Boolean> pair : ingredients) {
			RenderSystem.enableBlend();
			(pair.getSecond() ? AllGuiTextures.HOTSLOT_ACTIVE : AllGuiTextures.HOTSLOT).render(graphics, x, y);
			class_1799 itemStack = pair.getFirst();
			String count = pair.getSecond() ? null : class_124.field_1065.toString() + itemStack.method_7947();
			drawItemStack(graphics, mc, x, y, itemStack, count);
			x += 21;
		}

		if (noOutput)
			return;

		x += 5;
		RenderSystem.enableBlend();
		AllGuiTextures.HOTSLOT_ARROW.render(graphics, x, y + 4);
		x += 25;

		if (result.method_7960()) {
			AllGuiTextures.HOTSLOT.render(graphics, x, y);
			GuiGameElement.of(class_1802.field_8077)
				.at(x + 3, y + 3)
				.render(graphics);
		} else {
			(resultCraftable ? AllGuiTextures.HOTSLOT_SUPER_ACTIVE : AllGuiTextures.HOTSLOT).render(graphics,
				resultCraftable ? x - 1 : x, resultCraftable ? y - 1 : y);
			drawItemStack(graphics, mc, x, y, result, null);
		}
		RenderSystem.disableBlend();
	}

	public static void drawItemStack(class_332 graphics, class_310 mc, int x, int y, class_1799 itemStack, String count) {
		if (itemStack.method_7909() instanceof FilterItem) {
			int step = AnimationTickHolder.getTicks(mc.field_1687) / 10;
			class_1799[] itemsMatchingFilter = getItemsMatchingFilter(itemStack);
			if (itemsMatchingFilter.length > 0)
				itemStack = itemsMatchingFilter[step % itemsMatchingFilter.length];
		}

		GuiGameElement.of(itemStack)
			.at(x + 3, y + 3)
			.render(graphics);
		graphics.method_51432(mc.field_1772, itemStack, x + 3, y + 3, count);
	}

	private static class_1799[] getItemsMatchingFilter(class_1799 filter) {
		return cachedRenderedFilters.computeIfAbsent(filter, itemStack -> {
			class_2487 tag = itemStack.method_7948();

			if (AllItems.FILTER.isIn(itemStack) && !tag.method_10577("Blacklist")) {
				ItemStackHandler filterItems = FilterItem.getFilterItems(itemStack);
				List<class_1799> list = new ArrayList<>();
				for (int slot = 0; slot < filterItems.getSlotCount(); slot++) {
					class_1799 stackInSlot = filterItems.getStackInSlot(slot);
					if (!stackInSlot.method_7960())
						list.add(stackInSlot);
				}
				return list.toArray(new class_1799[list.size()]);
			}

			if (AllItems.ATTRIBUTE_FILTER.isIn(itemStack)) {
				WhitelistMode whitelistMode = WhitelistMode.values()[tag.method_10550("WhitelistMode")];
				class_2499 attributes = tag.method_10554("MatchedAttributes", net.minecraft.class_2520.field_33260);
				if (whitelistMode == WhitelistMode.WHITELIST_DISJ && attributes.size() == 1) {
					ItemAttribute fromNBT = ItemAttribute.fromNBT((class_2487) attributes.method_10534(0));
					if (fromNBT instanceof ItemAttribute.InTag inTag) {
						List<class_1799> stacks = new ArrayList<>();
						for (class_6880<class_1792> holder : class_7923.field_41178.method_40286(inTag.tag)) {
							stacks.add(new class_1799(holder.comp_349()));
						}
						return stacks.toArray(class_1799[]::new);
					}
				}
			}

			return new class_1799[0];
		});
	}

}
