package com.simibubi.create.content.equipment.clipboard;

import javax.annotation.Nullable;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.foundation.networking.SimplePacketBase;

public class ClipboardEditPacket extends SimplePacketBase {

	private int hotbarSlot;
	private class_2487 data;
	private class_2338 targetedBlock;

	public ClipboardEditPacket(int hotbarSlot, class_2487 data, @Nullable class_2338 targetedBlock) {
		this.hotbarSlot = hotbarSlot;
		this.data = data;
		this.targetedBlock = targetedBlock;
	}

	public ClipboardEditPacket(class_2540 buffer) {
		hotbarSlot = buffer.method_10816();
		data = buffer.method_10798();
		if (buffer.readBoolean())
			targetedBlock = buffer.method_10811();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10804(hotbarSlot);
		buffer.method_10794(data);
		buffer.writeBoolean(targetedBlock != null);
		if (targetedBlock != null)
			buffer.method_10807(targetedBlock);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 sender = context.getSender();

			if (targetedBlock != null) {
				class_1937 world = sender.method_37908();
				if (world == null || !world.method_8477(targetedBlock))
					return;
				if (!targetedBlock.method_19771(sender.method_24515(), 20))
					return;
				if (world.method_8321(targetedBlock) instanceof ClipboardBlockEntity cbe) {
					cbe.dataContainer.method_7980(data.method_33133() ? null : data);
					cbe.onEditedBy(sender);
				}
				return;
			}

			class_1799 itemStack = sender.method_31548()
				.method_5438(hotbarSlot);
			if (!AllBlocks.CLIPBOARD.isIn(itemStack))
				return;
			itemStack.method_7980(data.method_33133() ? null : data);
		});

		return true;
	}

}
