package com.simibubi.create.content.equipment.clipboard;

import com.simibubi.create.Create;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateItemModelProvider;
import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile.UncheckedModelFile;
import io.github.fabricators_of_create.porting_lib.models.generators.item.ItemModelBuilder;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import net.minecraft.class_5272;

public class ClipboardOverrides {

	public enum ClipboardType {
		EMPTY("empty_clipboard"), WRITTEN("clipboard"), EDITING("clipboard_and_quill");

		public String file;
		public static class_2960 ID = Create.asResource("clipboard_type");

		private ClipboardType(String file) {
			this.file = file;
		}
	}

	public static void switchTo(ClipboardType type, class_1799 clipboardItem) {
		class_2487 tag = clipboardItem.method_7948();
		tag.method_10569("Type", type.ordinal());
	}

	@Environment(EnvType.CLIENT)
	public static void registerModelOverridesClient(ClipboardBlockItem item) {
		class_5272.method_27879(item, ClipboardType.ID, (pStack, pLevel, pEntity, pSeed) -> {
			class_2487 tag = pStack.method_7969();
			return tag == null ? 0 : tag.method_10550("Type");
		});
	}

	public static ItemModelBuilder addOverrideModels(DataGenContext<class_1792, ClipboardBlockItem> c,
		RegistrateItemModelProvider p) {
		ItemModelBuilder builder = p.generated(() -> c.get());
		for (int i = 0; i < ClipboardType.values().length; i++) {
			builder.override()
				.predicate(ClipboardType.ID, i)
				.model(p.getBuilder(c.getName() + "_" + i)
					.parent(new UncheckedModelFile("item/generated"))
					.texture("layer0", Create.asResource("item/" + ClipboardType.values()[i].file)))
				.end();
		}
		return builder;
	}

}
