package com.simibubi.create.content.equipment.clipboard;

import java.util.ArrayList;
import java.util.List;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.CreateClient;
import com.simibubi.create.content.equipment.clipboard.ClipboardOverrides.ClipboardType;
import com.simibubi.create.content.trains.track.TrackBlockOutline;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_124;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1921;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_239;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_3965;
import net.minecraft.class_4184;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_4597;
import net.minecraft.class_5250;
import net.minecraft.class_761;

public class ClipboardValueSettingsHandler {

	@Environment(EnvType.CLIENT)
	public static boolean drawCustomBlockSelection(class_761 context, class_4184 camera, class_239 hitResult, float partialTicks, class_4587 ms, class_4597 buffers) {
		class_310 mc = class_310.method_1551();
		class_3965 target = (class_3965) hitResult;
		class_2338 pos = target.method_17777();
		class_2680 blockstate = mc.field_1687.method_8320(pos);

		if (mc.field_1724 == null || mc.field_1724.method_7325())
			return false;
		if (!mc.field_1687.method_8621()
			.method_11952(pos))
			return false;
		if (!AllBlocks.CLIPBOARD.isIn(mc.field_1724.method_6047()))
			return false;
		if (!(mc.field_1687.method_8321(pos) instanceof SmartBlockEntity smartBE))
			return false;
		if (!smartBE.getAllBehaviours()
			.stream()
			.anyMatch(b -> b instanceof ClipboardCloneable cc
				&& cc.writeToClipboard(new class_2487(), target.method_17780())))
			return false;

		class_265 shape = blockstate.method_26218(mc.field_1687, pos);
		if (shape.method_1110())
			return false;

		class_4588 vb = buffers
			.getBuffer(class_1921.method_23594());
		class_243 camPos = camera
			.method_19326();

		ms.method_22903();
		ms.method_22904(pos.method_10263() - camPos.field_1352, pos.method_10264() - camPos.field_1351, pos.method_10260() - camPos.field_1350);
		TrackBlockOutline.renderShape(shape, ms, vb, true);

		ms.method_22909();
		return true;
	}

	@Environment(EnvType.CLIENT)
	public static void clientTick() {
		class_310 mc = class_310.method_1551();
		if (!(mc.field_1765 instanceof class_3965 target))
			return;
		class_1657 player = mc.field_1724; // fabric: keep LocalPlayer out of lambdas
		if (!AllBlocks.CLIPBOARD.isIn(player.method_6047()))
			return;
		class_2338 pos = target.method_17777();
		if (!(mc.field_1687.method_8321(pos) instanceof SmartBlockEntity smartBE))
			return;

		class_2487 tagElement = player.method_6047()
			.method_7941("CopiedValues");

		boolean canCopy = smartBE.getAllBehaviours()
			.stream()
			.anyMatch(b -> b instanceof ClipboardCloneable cc
				&& cc.writeToClipboard(new class_2487(), target.method_17780()))
			|| smartBE instanceof ClipboardCloneable ccbe
				&& ccbe.writeToClipboard(new class_2487(), target.method_17780());

		boolean canPaste = tagElement != null && (smartBE.getAllBehaviours()
			.stream()
			.anyMatch(b -> b instanceof ClipboardCloneable cc && cc.readFromClipboard(
				tagElement.method_10562(cc.getClipboardKey()), player, target.method_17780(), true))
			|| smartBE instanceof ClipboardCloneable ccbe && ccbe.readFromClipboard(
				tagElement.method_10562(ccbe.getClipboardKey()), player, target.method_17780(), true));

		if (!canCopy && !canPaste)
			return;

		List<class_5250> tip = new ArrayList<>();
		tip.add(Lang.translateDirect("clipboard.actions"));
		if (canCopy)
			tip.add(Lang.translateDirect("clipboard.to_copy", Components.keybind("key.use")));
		if (canPaste)
			tip.add(Lang.translateDirect("clipboard.to_paste", Components.keybind("key.attack")));

		CreateClient.VALUE_SETTINGS_HANDLER.showHoverTip(tip);
	}

	public static class_1269 rightClickToCopy(class_1657 player, class_1937 world, class_1268 hand, class_2338 pos, class_2350 direction) {
		return interact(player.method_5998(hand), pos, world, player, direction, false);
	}

	public static class_1269 leftClickToPaste(class_1657 player, class_1937 world, class_1268 hand, class_3965 hitResult) {
		return interact(player.method_5998(hand), hitResult.method_17777(), world, player, hitResult.method_17780(), true);
	}

	private static class_1269 interact(class_1799 itemStack, class_2338 pos, class_1937 world, class_1657 player, class_2350 face, boolean paste) {
		if (!AllBlocks.CLIPBOARD.isIn(itemStack))
			return class_1269.field_5811;

		if (player != null && player.method_7325() || AdventureUtil.isAdventure(player))
			return class_1269.field_5811;
		if (player.method_5715())
			return class_1269.field_5811;
		if (!(world.method_8321(pos) instanceof SmartBlockEntity smartBE))
			return class_1269.field_5811;
		class_2487 tag = itemStack.method_7941("CopiedValues");
		if (paste && tag == null)
			return class_1269.field_5811;
		if (!paste)
			tag = new class_2487();

		boolean anySuccess = false;
		boolean anyValid = false;
		for (BlockEntityBehaviour behaviour : smartBE.getAllBehaviours()) {
			if (!(behaviour instanceof ClipboardCloneable cc))
				continue;
			anyValid = true;
			String clipboardKey = cc.getClipboardKey();
			if (paste) {
				anySuccess |=
					cc.readFromClipboard(tag.method_10562(clipboardKey), player, face, world.method_8608());
				continue;
			}
			class_2487 compoundTag = new class_2487();
			boolean success = cc.writeToClipboard(compoundTag, face);
			anySuccess |= success;
			if (success)
				tag.method_10566(clipboardKey, compoundTag);
		}

		if (smartBE instanceof ClipboardCloneable ccbe) {
			anyValid = true;
			String clipboardKey = ccbe.getClipboardKey();
			if (paste) {
				anySuccess |= ccbe.readFromClipboard(tag.method_10562(clipboardKey), player, face,
					world.method_8608());
			} else {
				class_2487 compoundTag = new class_2487();
				boolean success = ccbe.writeToClipboard(compoundTag, face);
				anySuccess |= success;
				if (success)
					tag.method_10566(clipboardKey, compoundTag);
			}
		}

		if (!anyValid)
			return class_1269.field_5811;

		if (world.method_8608())
			return class_1269.field_5812;
		if (!anySuccess)
			return class_1269.field_5812;

		player.method_7353(Lang
			.translate(paste ? "clipboard.pasted_to" : "clipboard.copied_from", world.method_8320(pos)
				.method_26204()
				.method_9518()
				.method_27692(class_124.field_1068))
			.style(class_124.field_1060)
			.component(), true);

		if (!paste) {
			ClipboardOverrides.switchTo(ClipboardType.WRITTEN, itemStack);
			itemStack.method_7948()
				.method_10566("CopiedValues", tag);
		}
		return class_1269.field_5812;
	}

}
