package com.simibubi.create.content.equipment.extendoGrip;

import java.util.UUID;
import java.util.function.Supplier;

import javax.annotation.Nullable;

import com.google.common.base.Suppliers;
import com.google.common.collect.ImmutableMultimap;
import com.google.common.collect.Multimap;
import com.jamieswhiteshirt.reachentityattributes.ReachEntityAttributes;
import com.simibubi.create.AllItems;
import com.simibubi.create.content.equipment.armor.BacktankUtil;
import com.simibubi.create.foundation.advancement.AllAdvancements;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import com.simibubi.create.infrastructure.config.AllConfigs;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1282;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1320;
import net.minecraft.class_1322;
import net.minecraft.class_1657;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2487;

public class ExtendoGripItem extends class_1792  {
	public static final int MAX_DAMAGE = 200;

	public static final class_1322 singleRangeAttributeModifier =
		new class_1322(UUID.fromString("7f7dbdb2-0d0d-458a-aa40-ac7633691f66"), "Range modifier", 3,
			class_1322.class_1323.field_6328);
	public static final class_1322 doubleRangeAttributeModifier =
		new class_1322(UUID.fromString("8f7dbdb2-0d0d-458a-aa40-ac7633691f66"), "Range modifier", 5,
			class_1322.class_1323.field_6328);

	private static final Supplier<Multimap<class_1320, class_1322>> rangeModifier = Suppliers.memoize(() ->
	// Holding an ExtendoGrip
	ImmutableMultimap.of(ReachEntityAttributes.REACH, singleRangeAttributeModifier, ReachEntityAttributes.ATTACK_RANGE, singleRangeAttributeModifier));
	private static final Supplier<Multimap<class_1320, class_1322>> doubleRangeModifier = Suppliers.memoize(() ->
	// Holding two ExtendoGrips o.O
	ImmutableMultimap.of(ReachEntityAttributes.REACH, doubleRangeAttributeModifier, ReachEntityAttributes.ATTACK_RANGE, doubleRangeAttributeModifier));

	private static class_1282 lastActiveDamageSource;

	public ExtendoGripItem(class_1793 properties) {
		super(properties.method_7898(MAX_DAMAGE));
	}

	public static final String EXTENDO_MARKER = "createExtendo";
	public static final String DUAL_EXTENDO_MARKER = "createDualExtendo";

	public static void holdingExtendoGripIncreasesRange(class_1309 entity) {
		if (!(entity instanceof class_1657))
			return;

		class_1657 player = (class_1657) entity;

		class_2487 persistentData = player.getCustomData();
		boolean inOff = AllItems.EXTENDO_GRIP.isIn(player.method_6079());
		boolean inMain = AllItems.EXTENDO_GRIP.isIn(player.method_6047());
		boolean holdingDualExtendo = inOff && inMain;
		boolean holdingExtendo = inOff ^ inMain;
		holdingExtendo &= !holdingDualExtendo;
		boolean wasHoldingExtendo = persistentData.method_10545(EXTENDO_MARKER);
		boolean wasHoldingDualExtendo = persistentData.method_10545(DUAL_EXTENDO_MARKER);

		if (holdingExtendo != wasHoldingExtendo) {
			if (!holdingExtendo) {
				player.method_6127()
					.method_26847(rangeModifier.get());
				persistentData.method_10551(EXTENDO_MARKER);
			} else {
				AllAdvancements.EXTENDO_GRIP.awardTo(player);
				player.method_6127()
					.method_26854(rangeModifier.get());
				persistentData.method_10556(EXTENDO_MARKER, true);
			}
		}

		if (holdingDualExtendo != wasHoldingDualExtendo) {
			if (!holdingDualExtendo) {
				player.method_6127()
					.method_26847(doubleRangeModifier.get());
				persistentData.method_10551(DUAL_EXTENDO_MARKER);
			} else {
				AllAdvancements.EXTENDO_GRIP_DUAL.awardTo(player);
				player.method_6127()
					.method_26854(doubleRangeModifier.get());
				persistentData.method_10556(DUAL_EXTENDO_MARKER, true);
			}
		}

	}

	public static void addReachToJoiningPlayersHoldingExtendo(class_1297 entity, @Nullable class_2487 persistentData) {
		if (!(entity instanceof class_1657 player) || persistentData == null) return;
//		Player player = event.getPlayer();
//		CompoundTag persistentData = player.getCustomData();

		if (persistentData.method_10545(DUAL_EXTENDO_MARKER))
			player.method_6127()
				.method_26854(doubleRangeModifier.get());
		else if (persistentData.method_10545(EXTENDO_MARKER))
			player.method_6127()
				.method_26854(rangeModifier.get());
	}

	private static void findAndDamageExtendoGrip(class_1657 player) {
		if (player == null)
			return;
		if (player.method_37908().field_9236)
			return;
		class_1268 hand = class_1268.field_5808;
		class_1799 extendo = player.method_6047();
		if (!AllItems.EXTENDO_GRIP.isIn(extendo)) {
			extendo = player.method_6079();
			hand = class_1268.field_5810;
		}
		if (!AllItems.EXTENDO_GRIP.isIn(extendo))
			return;
		final class_1268 h = hand;
		if (!BacktankUtil.canAbsorbDamage(player, maxUses()))
			extendo.method_7956(1, player, p -> p.method_20236(h));
	}

	@Override
	public boolean method_31567(class_1799 stack) {
		return BacktankUtil.isBarVisible(stack, maxUses());
	}

	@Override
	public int method_31569(class_1799 stack) {
		return BacktankUtil.getBarWidth(stack, maxUses());
	}

	@Override
	public int method_31571(class_1799 stack) {
		return BacktankUtil.getBarColor(stack, maxUses());
	}

	private static int maxUses() {
		return AllConfigs.server().equipment.maxExtendoGripActions.get();
	}

	public static float bufferLivingAttackEvent(class_1282 damageSource, class_1309 attacked, float amount) {
		// Workaround for removed patch to get the attacking entity.
		lastActiveDamageSource = damageSource;

		class_1297 trueSource = damageSource.method_5529();
		if (trueSource instanceof class_1657)
			findAndDamageExtendoGrip((class_1657) trueSource);
		return amount;
	}

	public static double attacksByExtendoGripHaveMoreKnockback(double strength, class_1657 player) {
		if (!isHoldingExtendoGrip(player))
			return strength;
		return strength + 2;
	}

	public static boolean isHoldingExtendoGrip(class_1657 player) {
		boolean inOff = AllItems.EXTENDO_GRIP.isIn(player.method_6079());
		boolean inMain = AllItems.EXTENDO_GRIP.isIn(player.method_6047());
		boolean holdingGrip = inOff || inMain;
		return holdingGrip;
	}
}
