package com.simibubi.create.content.equipment.potatoCannon;

import java.util.UUID;
import java.util.function.BiPredicate;
import java.util.function.Predicate;
import java.util.function.Supplier;

import com.mojang.authlib.GameProfile;
import com.mojang.datafixers.util.Pair;
import com.simibubi.create.AllItems;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.mixin.accessor.FallingBlockEntityAccessor;
import com.simibubi.create.foundation.utility.WorldAttached;

import com.simibubi.create.infrastructure.config.AllConfigs;

import io.github.fabricators_of_create.porting_lib.common.util.IPlantable;
import io.github.fabricators_of_create.porting_lib.entity.events.EntityEvents;
import net.fabricmc.fabric.api.entity.FakePlayer;
import net.minecraft.class_1268;
import net.minecraft.class_1291;
import net.minecraft.class_1293;
import net.minecraft.class_1294;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1540;
import net.minecraft.class_1641;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2344;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3414;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3532;
import net.minecraft.class_3965;
import net.minecraft.class_3966;
import net.minecraft.class_4019;
import net.minecraft.class_4174;
import net.minecraft.class_4176;

public class BuiltinPotatoProjectileTypes {

	private static final GameProfile ZOMBIE_CONVERTER_NAME =
		new GameProfile(UUID.fromString("be12d3dc-27d3-4992-8c97-66be53fd49c5"), "Converter");
	private static final WorldAttached<FakePlayer> ZOMBIE_CONVERTERS =
		new WorldAttached<>(w -> new ConverterFakePlayer((class_3218) w, ZOMBIE_CONVERTER_NAME){});

	public static class ConverterFakePlayer extends FakePlayer {
		public ConverterFakePlayer(class_3218 world, GameProfile profile) {
			super(world, profile);
		}
	}

	public static final PotatoCannonProjectileType

	FALLBACK = create("fallback").damage(0)
		.register(),

		POTATO = create("potato").damage(5)
			.reloadTicks(15)
			.velocity(1.25f)
			.knockback(1.5f)
			.renderTumbling()
			.onBlockHit(plantCrop(class_2246.field_10247))
			.registerAndAssign(class_1802.field_8567),

		BAKED_POTATO = create("baked_potato").damage(5)
			.reloadTicks(15)
			.velocity(1.25f)
			.knockback(0.5f)
			.renderTumbling()
			.preEntityHit(setFire(3))
			.registerAndAssign(class_1802.field_8512),

		CARROT = create("carrot").damage(4)
			.reloadTicks(12)
			.velocity(1.45f)
			.knockback(0.3f)
			.renderTowardMotion(140, 1)
			.soundPitch(1.5f)
			.onBlockHit(plantCrop(class_2246.field_10609))
			.registerAndAssign(class_1802.field_8179),

		GOLDEN_CARROT = create("golden_carrot").damage(12)
			.reloadTicks(15)
			.velocity(1.45f)
			.knockback(0.5f)
			.renderTowardMotion(140, 2)
			.soundPitch(1.5f)
			.registerAndAssign(class_1802.field_8071),

		SWEET_BERRIES = create("sweet_berry").damage(3)
			.reloadTicks(10)
			.knockback(0.1f)
			.velocity(1.05f)
			.renderTumbling()
			.splitInto(3)
			.soundPitch(1.25f)
			.registerAndAssign(class_1802.field_16998),

		GLOW_BERRIES = create("glow_berry").damage(2)
			.reloadTicks(10)
			.knockback(0.05f)
			.velocity(1.05f)
			.renderTumbling()
			.splitInto(2)
			.soundPitch(1.2f)
			.onEntityHit(potion(class_1294.field_5912, 1, 200, false))
			.registerAndAssign(class_1802.field_28659),

		CHOCOLATE_BERRIES = create("chocolate_berry").damage(4)
			.reloadTicks(10)
			.knockback(0.2f)
			.velocity(1.05f)
			.renderTumbling()
			.splitInto(3)
			.soundPitch(1.25f)
			.registerAndAssign(AllItems.CHOCOLATE_BERRIES.get()),

		POISON_POTATO = create("poison_potato").damage(5)
			.reloadTicks(15)
			.knockback(0.05f)
			.velocity(1.25f)
			.renderTumbling()
			.onEntityHit(potion(class_1294.field_5899, 1, 160, true))
			.registerAndAssign(class_1802.field_8635),

		CHORUS_FRUIT = create("chorus_fruit").damage(3)
			.reloadTicks(15)
			.velocity(1.20f)
			.knockback(0.05f)
			.renderTumbling()
			.onEntityHit(chorusTeleport(20))
			.registerAndAssign(class_1802.field_8233),

		APPLE = create("apple").damage(5)
			.reloadTicks(10)
			.velocity(1.45f)
			.knockback(0.5f)
			.renderTumbling()
			.soundPitch(1.1f)
			.registerAndAssign(class_1802.field_8279),

		HONEYED_APPLE = create("honeyed_apple").damage(6)
			.reloadTicks(15)
			.velocity(1.35f)
			.knockback(0.1f)
			.renderTumbling()
			.soundPitch(1.1f)
			.onEntityHit(potion(class_1294.field_5909, 2, 160, true))
			.registerAndAssign(AllItems.HONEYED_APPLE.get()),

		GOLDEN_APPLE = create("golden_apple").damage(1)
			.reloadTicks(100)
			.velocity(1.45f)
			.knockback(0.05f)
			.renderTumbling()
			.soundPitch(1.1f)
			.onEntityHit(ray -> {
				if (!canModifyWorld())
					return false;
				class_1297 entity = ray.method_17782();
				class_1937 world = entity.method_37908();

				if (!(entity instanceof class_1641) || !((class_1641) entity).method_6059(class_1294.field_5911))
					return foodEffects(class_4176.field_18658, false).test(ray);
				if (world.field_9236)
					return false;

				FakePlayer dummy = ZOMBIE_CONVERTERS.get(world);
				dummy.method_6122(class_1268.field_5808, new class_1799(class_1802.field_8463, 1));
				((class_1641) entity).method_5992(dummy, class_1268.field_5808);
				return true;
			})
			.registerAndAssign(class_1802.field_8463),

		ENCHANTED_GOLDEN_APPLE = create("enchanted_golden_apple").damage(1)
			.reloadTicks(100)
			.velocity(1.45f)
			.knockback(0.05f)
			.renderTumbling()
			.soundPitch(1.1f)
			.onEntityHit(foodEffects(class_4176.field_18657, false))
			.registerAndAssign(class_1802.field_8367),

		BEETROOT = create("beetroot").damage(2)
			.reloadTicks(5)
			.velocity(1.6f)
			.knockback(0.1f)
			.renderTowardMotion(140, 2)
			.soundPitch(1.6f)
			.registerAndAssign(class_1802.field_8186),

		MELON_SLICE = create("melon_slice").damage(3)
			.reloadTicks(8)
			.knockback(0.1f)
			.velocity(1.45f)
			.renderTumbling()
			.soundPitch(1.5f)
			.registerAndAssign(class_1802.field_8497),

		GLISTERING_MELON = create("glistering_melon").damage(5)
			.reloadTicks(8)
			.knockback(0.1f)
			.velocity(1.45f)
			.renderTumbling()
			.soundPitch(1.5f)
			.onEntityHit(potion(class_1294.field_5912, 1, 100, true))
			.registerAndAssign(class_1802.field_8597),

		MELON_BLOCK = create("melon_block").damage(8)
			.reloadTicks(20)
			.knockback(2.0f)
			.velocity(0.95f)
			.renderTumbling()
			.soundPitch(0.9f)
			.onBlockHit(placeBlockOnGround(class_2246.field_10545))
			.registerAndAssign(class_2246.field_10545),

		PUMPKIN_BLOCK = create("pumpkin_block").damage(6)
			.reloadTicks(15)
			.knockback(2.0f)
			.velocity(0.95f)
			.renderTumbling()
			.soundPitch(0.9f)
			.onBlockHit(placeBlockOnGround(class_2246.field_10261))
			.registerAndAssign(class_2246.field_10261),

		PUMPKIN_PIE = create("pumpkin_pie").damage(7)
			.reloadTicks(15)
			.knockback(0.05f)
			.velocity(1.1f)
			.renderTumbling()
			.sticky()
			.soundPitch(1.1f)
			.registerAndAssign(class_1802.field_8741),

		CAKE = create("cake").damage(8)
			.reloadTicks(15)
			.knockback(0.1f)
			.velocity(1.1f)
			.renderTumbling()
			.sticky()
			.soundPitch(1.0f)
			.registerAndAssign(class_1802.field_17534),

		BLAZE_CAKE = create("blaze_cake").damage(15)
			.reloadTicks(20)
			.knockback(0.3f)
			.velocity(1.1f)
			.renderTumbling()
			.sticky()
			.preEntityHit(setFire(12))
			.soundPitch(1.0f)
			.registerAndAssign(AllItems.BLAZE_CAKE.get())

	;

	private static PotatoCannonProjectileType.Builder create(String name) {
		return new PotatoCannonProjectileType.Builder(Create.asResource(name));
	}

	private static Predicate<class_3966> setFire(int seconds) {
		return ray -> {
			ray.method_17782()
				.method_5639(seconds);
			return false;
		};
	}

	private static Predicate<class_3966> potion(class_1291 effect, int level, int ticks, boolean recoverable) {
		return ray -> {
			class_1297 entity = ray.method_17782();
			if (entity.method_37908().field_9236)
				return true;
			if (entity instanceof class_1309)
				applyEffect((class_1309) entity, new class_1293(effect, ticks, level - 1));
			return !recoverable;
		};
	}

	private static Predicate<class_3966> foodEffects(class_4174 food, boolean recoverable) {
		return ray -> {
			class_1297 entity = ray.method_17782();
			if (entity.method_37908().field_9236)
				return true;

			if (entity instanceof class_1309) {
				for (Pair<class_1293, Float> effect : food.method_19235()) {
					if (Create.RANDOM.nextFloat() < effect.getSecond())
						applyEffect((class_1309) entity, new class_1293(effect.getFirst()));
				}
			}
			return !recoverable;
		};
	}

	private static void applyEffect(class_1309 entity, class_1293 effect) {
		if (effect.method_5579()
			.method_5561())
			effect.method_5579()
				.method_5564(null, null, entity, effect.method_5584(), 1.0);
		else
			entity.method_6092(effect);
	}

	private static BiPredicate<class_1936, class_3965> plantCrop(Supplier<? extends class_2248> cropBlock) {
		return (world, ray) -> {
			if (world.method_8608())
				return true;
			if (!canModifyWorld())
				return false;

			class_2338 hitPos = ray.method_17777();
			if (world instanceof class_1937 l && !l.method_8477(hitPos))
				return true;
			class_2350 face = ray.method_17780();
			if (face != class_2350.field_11036)
				return false;
			class_2338 placePos = hitPos.method_10093(face);
			if (!world.method_8320(placePos)
				.method_45474())
				return false;
			if (!(cropBlock.get() instanceof IPlantable))
				return false;
			class_2680 blockState = world.method_8320(hitPos);
			if (!(blockState.method_26204() instanceof class_2344))
				return false;
			world.method_8652(placePos, cropBlock.get().method_9564(), 3);
			return true;
		};
	}

	private static BiPredicate<class_1936, class_3965> plantCrop(class_2248 cropBlock) {
		return plantCrop(() -> cropBlock);
	}

	private static BiPredicate<class_1936, class_3965> placeBlockOnGround(
		Supplier<? extends class_2248> block) {
		return (world, ray) -> {
			if (world.method_8608())
				return true;
			if (!canModifyWorld())
				return false;

			class_2338 hitPos = ray.method_17777();
			if (world instanceof class_1937 l && !l.method_8477(hitPos))
				return true;
			class_2350 face = ray.method_17780();
			class_2338 placePos = hitPos.method_10093(face);
			if (!world.method_8320(placePos)
				.method_45474())
				return false;

			if (face == class_2350.field_11036) {
				world.method_8652(placePos, block.get().method_9564(), 3);
			} else if (world instanceof class_1937 level) {
				double y = ray.method_17784().field_1351 - 0.5;
				if (!world.method_22347(placePos.method_10084()))
					y = Math.min(y, placePos.method_10264());
				if (!world.method_22347(placePos.method_10074()))
					y = Math.max(y, placePos.method_10264());

				class_1540 falling = FallingBlockEntityAccessor.create$callInit(level, placePos.method_10263() + 0.5, y,
					placePos.method_10260() + 0.5, block.get().method_9564());
				falling.field_7192 = 1;
				world.method_8649(falling);
			}

			return true;
		};
	}

	private static BiPredicate<class_1936, class_3965> placeBlockOnGround(class_2248 block) {
		return placeBlockOnGround(() -> block);
	}

	private static Predicate<class_3966> chorusTeleport(double teleportDiameter) {
		return ray -> {
			class_1297 entity = ray.method_17782();
			class_1937 world = entity.method_5770();
			if (world.field_9236)
				return true;
			if (!canModifyWorld())
				return false;
			if (!(entity instanceof class_1309))
				return false;
			class_1309 livingEntity = (class_1309) entity;

			double entityX = livingEntity.method_23317();
			double entityY = livingEntity.method_23318();
			double entityZ = livingEntity.method_23321();

			for (int teleportTry = 0; teleportTry < 16; ++teleportTry) {
				double teleportX = entityX + (livingEntity.method_6051()
					.method_43058() - 0.5D) * teleportDiameter;
				double teleportY = class_3532.method_15350(entityY + (livingEntity.method_6051()
					.method_43048((int) teleportDiameter) - (int) (teleportDiameter / 2)), 0.0D, world.method_31605() - 1);
				double teleportZ = entityZ + (livingEntity.method_6051()
					.method_43058() - 0.5D) * teleportDiameter;

				EntityEvents.Teleport.EntityTeleportEvent event = new EntityEvents.Teleport.EntityTeleportEvent(livingEntity, teleportX, teleportY, teleportZ);
				EntityEvents.TELEPORT.invoker().onTeleport(event);
				if (event.isCanceled())
					return false;
				if (livingEntity.method_6082(teleportX, teleportY, teleportZ, true)) {
					if (livingEntity.method_5765())
						livingEntity.method_5848();

					class_3414 soundevent =
						livingEntity instanceof class_4019 ? class_3417.field_24630 : class_3417.field_14890;
					world.method_43128(null, entityX, entityY, entityZ, soundevent, class_3419.field_15248, 1.0F, 1.0F);
					livingEntity.method_5783(soundevent, 1.0F, 1.0F);
					livingEntity.method_18799(class_243.field_1353);
					return true;
				}
			}

			return false;
		};
	}

	public static void register() {}

	private static boolean canModifyWorld() {
		return AllConfigs.server().equipment.potatoCannonWorldModification.get();
	}

}
