package com.simibubi.create.content.equipment.potatoCannon;

import java.util.List;
import java.util.Optional;
import java.util.function.Predicate;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllEnchantments;
import com.simibubi.create.AllEntityTypes;
import com.simibubi.create.Create;
import com.simibubi.create.CreateClient;
import com.simibubi.create.content.equipment.armor.BacktankUtil;
import com.simibubi.create.content.equipment.zapper.ShootableGadgetItemMethods;
import com.simibubi.create.foundation.item.CustomArmPoseItem;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.VecHelper;
import com.simibubi.create.infrastructure.config.AllConfigs;

import io.github.fabricators_of_create.porting_lib.enchant.CustomEnchantingBehaviorItem;
import io.github.fabricators_of_create.porting_lib.item.EntitySwingListenerItem;
import io.github.fabricators_of_create.porting_lib.item.ReequipAnimationItem;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_124;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1271;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1811;
import net.minecraft.class_1836;
import net.minecraft.class_1838;
import net.minecraft.class_1839;
import net.minecraft.class_1887;
import net.minecraft.class_1890;
import net.minecraft.class_1893;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_243;
import net.minecraft.class_2561;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_3532;
import net.minecraft.class_5250;
import net.minecraft.class_572.class_573;
import net.minecraft.class_742;
import net.minecraft.class_746;

public class PotatoCannonItem extends class_1811 implements CustomArmPoseItem, EntitySwingListenerItem, ReequipAnimationItem, CustomEnchantingBehaviorItem {

	public static class_1799 CLIENT_CURRENT_AMMO = class_1799.field_8037;
	public static final int MAX_DAMAGE = 100;

	public PotatoCannonItem(class_1793 properties) {
		super(properties.method_7898(MAX_DAMAGE));
	}

	@Override
	public boolean method_7885(class_2680 state, class_1937 world, class_2338 pos, class_1657 player) {
		return false;
	}

	@Override
	public boolean canApplyAtEnchantingTable(class_1799 stack, class_1887 enchantment) {
		if (enchantment == class_1893.field_9103)
			return true;
		if (enchantment == class_1893.field_9116)
			return true;
		if (enchantment == class_1893.field_9126)
			return true;
		if (enchantment == class_1893.field_9110)
			return true;
		if (enchantment == AllEnchantments.POTATO_RECOVERY.get())
			return true;
		return CustomEnchantingBehaviorItem.super.canApplyAtEnchantingTable(stack, enchantment);
	}

	@Override
	public class_1269 method_7884(class_1838 context) {
		return method_7836(context.method_8045(), context.method_8036(), context.method_20287()).method_5467();
	}

	@Override
	public boolean method_31567(class_1799 stack) {
		return BacktankUtil.isBarVisible(stack, maxUses());
	}

	@Override
	public int method_31569(class_1799 stack) {
		return BacktankUtil.getBarWidth(stack, maxUses());
	}

	@Override
	public int method_31571(class_1799 stack) {
		return BacktankUtil.getBarColor(stack, maxUses());
	}

	private int maxUses() {
		return AllConfigs.server().equipment.maxPotatoCannonShots.get();
	}

	public boolean isCannon(class_1799 stack) {
		return stack.method_7909() instanceof PotatoCannonItem;
	}

	@Override
	public class_1271<class_1799> method_7836(class_1937 world, class_1657 player, class_1268 hand) {
		class_1799 stack = player.method_5998(hand);
		return findAmmoInInventory(world, player, stack).map(itemStack -> {

			if (ShootableGadgetItemMethods.shouldSwap(player, stack, hand, this::isCannon))
				return class_1271.method_22431(stack);

			if (world.field_9236) {
				CreateClient.POTATO_CANNON_RENDER_HANDLER.dontAnimateItem(hand);
				return class_1271.method_22427(stack);
			}

			class_243 barrelPos = ShootableGadgetItemMethods.getGunBarrelVec(player, hand == class_1268.field_5808,
				new class_243(.75f, -0.15f, 1.5f));
			class_243 correction =
				ShootableGadgetItemMethods.getGunBarrelVec(player, hand == class_1268.field_5808, new class_243(-.05f, 0, 0))
					.method_1020(player.method_19538()
						.method_1031(0, player.method_5751(), 0));

			PotatoCannonProjectileType projectileType = PotatoProjectileTypeManager.getTypeForStack(itemStack)
				.orElse(BuiltinPotatoProjectileTypes.FALLBACK);
			class_243 lookVec = player.method_5720();
			class_243 motion = lookVec.method_1019(correction)
				.method_1029()
				.method_1021(2)
				.method_1021(projectileType.getVelocityMultiplier());

			float soundPitch = projectileType.getSoundPitch() + (Create.RANDOM.nextFloat() - .5f) / 4f;

			boolean spray = projectileType.getSplit() > 1;
			class_243 sprayBase = VecHelper.rotate(new class_243(0, 0.1, 0), 360 * Create.RANDOM.nextFloat(), class_2351.field_11051);
			float sprayChange = 360f / projectileType.getSplit();

			for (int i = 0; i < projectileType.getSplit(); i++) {
				PotatoProjectileEntity projectile = AllEntityTypes.POTATO_PROJECTILE.create(world);
				projectile.setItem(itemStack);
				projectile.setEnchantmentEffectsFromCannon(stack);

				class_243 splitMotion = motion;
				if (spray) {
					float imperfection = 40 * (Create.RANDOM.nextFloat() - 0.5f);
					class_243 sprayOffset = VecHelper.rotate(sprayBase, i * sprayChange + imperfection, class_2351.field_11051);
					splitMotion = splitMotion.method_1019(VecHelper.lookAt(sprayOffset, motion));
				}

				if (i != 0)
					projectile.recoveryChance = 0;

				projectile.method_5814(barrelPos.field_1352, barrelPos.field_1351, barrelPos.field_1350);
				projectile.method_18799(splitMotion);
				projectile.method_7432(player);
				world.method_8649(projectile);
			}

			if (!player.method_7337()) {
				itemStack.method_7934(1);
				if (itemStack.method_7960())
					player.method_31548().method_7378(itemStack);
			}

			if (!BacktankUtil.canAbsorbDamage(player, maxUses()))
				stack.method_7956(1, player, p -> p.method_20236(hand));

			Integer cooldown =
				findAmmoInInventory(world, player, stack).flatMap(PotatoProjectileTypeManager::getTypeForStack)
					.map(PotatoCannonProjectileType::getReloadTicks)
					.orElse(10);

			ShootableGadgetItemMethods.applyCooldown(player, stack, hand, this::isCannon, cooldown);
			ShootableGadgetItemMethods.sendPackets(player,
				b -> new PotatoCannonPacket(barrelPos, lookVec.method_1029(), itemStack, hand, soundPitch, b));
			return class_1271.method_22427(stack);
		})
			.orElse(class_1271.method_22430(stack));
	}

	@Override
	public boolean shouldCauseReequipAnimation(class_1799 oldStack, class_1799 newStack, boolean slotChanged) {
		return slotChanged || newStack.method_7909() != oldStack.method_7909();
	}

	private Optional<class_1799> findAmmoInInventory(class_1937 world, class_1657 player, class_1799 held) {
		class_1799 findAmmo = player.method_18808(held);
		return PotatoProjectileTypeManager.getTypeForStack(findAmmo)
			.map($ -> findAmmo);
	}

	@Environment(EnvType.CLIENT)
	public static Optional<class_1799> getAmmoforPreview(class_1799 cannon) {
		if (AnimationTickHolder.getTicks() % 3 != 0)
			return Optional.of(CLIENT_CURRENT_AMMO)
				.filter(stack -> !stack.method_7960());

		class_746 player = class_310.method_1551().field_1724;
		CLIENT_CURRENT_AMMO = class_1799.field_8037;
		if (player == null)
			return Optional.empty();
		class_1799 findAmmo = player.method_18808(cannon);
		Optional<class_1799> found = PotatoProjectileTypeManager.getTypeForStack(findAmmo)
			.map($ -> findAmmo);
		found.ifPresent(stack -> CLIENT_CURRENT_AMMO = stack);
		return found;
	}

	@Override
	@Environment(EnvType.CLIENT)
	public void method_7851(class_1799 stack, class_1937 world, List<class_2561> tooltip, class_1836 flag) {
		int power = class_1890.method_8225(class_1893.field_9103, stack);
		int punch = class_1890.method_8225(class_1893.field_9116, stack);
		final float additionalDamageMult = 1 + power * .2f;
		final float additionalKnockback = punch * .5f;

		getAmmoforPreview(stack).ifPresent(ammo -> {
			String _attack = "potato_cannon.ammo.attack_damage";
			String _reload = "potato_cannon.ammo.reload_ticks";
			String _knockback = "potato_cannon.ammo.knockback";

			tooltip.add(Components.immutableEmpty());
			tooltip.add(Components.translatable(ammo.method_7922()).method_10852(Components.literal(":"))
				.method_27692(class_124.field_1080));
			PotatoCannonProjectileType type = PotatoProjectileTypeManager.getTypeForStack(ammo)
				.get();
			class_5250 spacing = Components.literal(" ");
			class_124 green = class_124.field_1060;
			class_124 darkGreen = class_124.field_1077;

			float damageF = type.getDamage() * additionalDamageMult;
			class_5250 damage = Components.literal(
				damageF == class_3532.method_15375(damageF) ? "" + class_3532.method_15375(damageF) : "" + damageF);
			class_5250 reloadTicks = Components.literal("" + type.getReloadTicks());
			class_5250 knockback =
				Components.literal("" + (type.getKnockback() + additionalKnockback));

			damage = damage.method_27692(additionalDamageMult > 1 ? green : darkGreen);
			knockback = knockback.method_27692(additionalKnockback > 0 ? green : darkGreen);
			reloadTicks = reloadTicks.method_27692(darkGreen);

			tooltip.add(spacing.method_27662()
				.method_10852(Lang.translateDirect(_attack, damage)
					.method_27692(darkGreen)));
			tooltip.add(spacing.method_27662()
				.method_10852(Lang.translateDirect(_reload, reloadTicks)
					.method_27692(darkGreen)));
			tooltip.add(spacing.method_27662()
				.method_10852(Lang.translateDirect(_knockback, knockback)
					.method_27692(darkGreen)));
		});
		super.method_7851(stack, world, tooltip, flag);
	}

	@Override
	public Predicate<class_1799> method_19268() {
		return stack -> PotatoProjectileTypeManager.getTypeForStack(stack)
			.isPresent();
	}

	@Override
	public boolean onEntitySwing(class_1799 stack, class_1309 entity) {
		return true;
	}

	@Override
	public class_1839 method_7853(class_1799 stack) {
		return class_1839.field_8952;
	}

	@Override
	@Nullable
	public class_573 getArmPose(class_1799 stack, class_742 player, class_1268 hand) {
		if (!player.field_6252) {
			return class_573.field_3408;
		}
		return null;
	}

	@Override
	public int method_24792() {
		return 15;
	}

//	@Override
//	@OnlyIn(Dist.CLIENT)
//	public void initializeClient(Consumer<IClientItemExtensions> consumer) {
//		consumer.accept(SimpleCustomRenderer.create(this, new PotatoCannonItemRenderer()));
//	}

}
