package com.simibubi.create.content.equipment.potatoCannon;

import static com.simibubi.create.content.equipment.potatoCannon.PotatoProjectileRenderMode.entityRandom;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.foundation.utility.AngleHelper;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1297;
import net.minecraft.class_243;
import net.minecraft.class_310;
import net.minecraft.class_3532;
import net.minecraft.class_4587;

public interface PotatoProjectileRenderMode {

	@Environment(EnvType.CLIENT)
	void transform(class_4587 ms, PotatoProjectileEntity entity, float pt);

	public static class Billboard implements PotatoProjectileRenderMode {

		public static final Billboard INSTANCE = new Billboard();

		@Override
		@Environment(EnvType.CLIENT)
		public void transform(class_4587 ms, PotatoProjectileEntity entity, float pt) {
			class_310 mc = class_310.method_1551();
			class_243 p1 = mc.method_1560()
				.method_5836(pt);
			class_243 diff = entity.method_5829()
				.method_1005()
				.method_1020(p1);

			TransformStack.cast(ms)
				.rotateY(AngleHelper.deg(class_3532.method_15349(diff.field_1352, diff.field_1350)) + 180)
				.rotateX(AngleHelper.deg(class_3532.method_15349(diff.field_1351, class_3532.method_15355((float) (diff.field_1352 * diff.field_1352 + diff.field_1350 * diff.field_1350)))));
		}

	}

	public static class Tumble extends Billboard {

		public static final Tumble INSTANCE = new Tumble();

		@Override
		@Environment(EnvType.CLIENT)
		public void transform(class_4587 ms, PotatoProjectileEntity entity, float pt) {
			super.transform(ms, entity, pt);
			TransformStack.cast(ms)
				.rotateZ((entity.field_6012 + pt) * 2 * entityRandom(entity, 16))
				.rotateX((entity.field_6012 + pt) * entityRandom(entity, 32));
		}

	}

	public static class TowardMotion implements PotatoProjectileRenderMode {

		private int spriteAngleOffset;
		private float spin;

		public TowardMotion(int spriteAngleOffset, float spin) {
			this.spriteAngleOffset = spriteAngleOffset;
			this.spin = spin;
		}

		@Override
		@Environment(EnvType.CLIENT)
		public void transform(class_4587 ms, PotatoProjectileEntity entity, float pt) {
			class_243 diff = entity.method_18798();
			TransformStack.cast(ms)
				.rotateY(AngleHelper.deg(class_3532.method_15349(diff.field_1352, diff.field_1350)))
				.rotateX(270
					+ AngleHelper.deg(class_3532.method_15349(diff.field_1351, -class_3532.method_15355((float) (diff.field_1352 * diff.field_1352 + diff.field_1350 * diff.field_1350)))));
			TransformStack.cast(ms)
				.rotateY((entity.field_6012 + pt) * 20 * spin + entityRandom(entity, 360))
				.rotateZ(-spriteAngleOffset);
		}

	}

	public static class StuckToEntity implements PotatoProjectileRenderMode {

		private class_243 offset;

		public StuckToEntity(class_243 offset) {
			this.offset = offset;
		}

		@Override
		@Environment(EnvType.CLIENT)
		public void transform(class_4587 ms, PotatoProjectileEntity entity, float pt) {
			TransformStack.cast(ms).rotateY(AngleHelper.deg(class_3532.method_15349(offset.field_1352, offset.field_1350)));
		}

	}

	public static int entityRandom(class_1297 entity, int maxValue) {
		return (System.identityHashCode(entity) * 31) % maxValue;
	}

}
