package com.simibubi.create.content.equipment.symmetryWand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Nonnull;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllPackets;
import com.simibubi.create.content.contraptions.mounted.CartAssemblerBlock;
import com.simibubi.create.content.equipment.symmetryWand.mirror.CrossPlaneMirror;
import com.simibubi.create.content.equipment.symmetryWand.mirror.EmptyMirror;
import com.simibubi.create.content.equipment.symmetryWand.mirror.PlaneMirror;
import com.simibubi.create.content.equipment.symmetryWand.mirror.SymmetryMirror;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.utility.BlockHelper;
import com.simibubi.create.foundation.utility.Iterate;
import com.simibubi.create.infrastructure.config.AllConfigs;

import io.github.fabricators_of_create.porting_lib.util.EnvExecutor;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.event.player.PlayerBlockBreakEvents;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1271;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_3610;
import net.minecraft.class_3726;

public class SymmetryWandItem extends class_1792 {

	public static final String SYMMETRY = "symmetry";
	private static final String ENABLE = "enable";

	public SymmetryWandItem(class_1793 properties) {
		super(properties);
	}

	@Nonnull
	@Override
	public class_1269 method_7884(class_1838 context) {
		class_1657 player = context.method_8036();
		class_2338 pos = context.method_8037();
		if (player == null)
			return class_1269.field_5811;
		player.method_7357()
			.method_7906(this, 5);
		class_1799 wand = player.method_5998(context.method_20287());
		checkNBT(wand);

		// Shift -> open GUI
		if (player.method_5715()) {
			if (player.method_37908().field_9236) {
				EnvExecutor.runWhenOn(EnvType.CLIENT, () -> () -> {
					openWandGUI(wand, context.method_20287());
				});
				player.method_7357()
					.method_7906(this, 5);
			}
			return class_1269.field_5812;
		}

		if (context.method_8045().field_9236 || context.method_20287() != class_1268.field_5808)
			return class_1269.field_5812;

		class_2487 compound = wand.method_7969()
			.method_10562(SYMMETRY);
		pos = pos.method_10093(context.method_8038());
		SymmetryMirror previousElement = SymmetryMirror.fromNBT(compound);

		// No Shift -> Make / Move Mirror
		wand.method_7969()
			.method_10556(ENABLE, true);
		class_243 pos3d = new class_243(pos.method_10263(), pos.method_10264(), pos.method_10260());
		SymmetryMirror newElement = new PlaneMirror(pos3d);

		if (previousElement instanceof EmptyMirror) {
			newElement.setOrientation(
				(player.method_5735() == class_2350.field_11043 || player.method_5735() == class_2350.field_11035)
					? PlaneMirror.Align.XY.ordinal()
					: PlaneMirror.Align.YZ.ordinal());
			newElement.enable = true;
			wand.method_7969()
				.method_10556(ENABLE, true);

		} else {
			previousElement.setPosition(pos3d);

			if (previousElement instanceof PlaneMirror) {
				previousElement.setOrientation(
					(player.method_5735() == class_2350.field_11043 || player.method_5735() == class_2350.field_11035)
						? PlaneMirror.Align.XY.ordinal()
						: PlaneMirror.Align.YZ.ordinal());
			}

			if (previousElement instanceof CrossPlaneMirror) {
				float rotation = player.method_5791();
				float abs = Math.abs(rotation % 90);
				boolean diagonal = abs > 22 && abs < 45 + 22;
				previousElement
					.setOrientation(diagonal ? CrossPlaneMirror.Align.D.ordinal() : CrossPlaneMirror.Align.Y.ordinal());
			}

			newElement = previousElement;
		}

		compound = newElement.writeToNbt();
		wand.method_7969()
			.method_10566(SYMMETRY, compound);

		player.method_6122(context.method_20287(), wand);
		return class_1269.field_5812;
	}

	@Override
	public class_1271<class_1799> method_7836(class_1937 worldIn, class_1657 playerIn, class_1268 handIn) {
		class_1799 wand = playerIn.method_5998(handIn);
		checkNBT(wand);

		// Shift -> Open GUI
		if (playerIn.method_5715()) {
			if (worldIn.field_9236) {
				EnvExecutor.runWhenOn(EnvType.CLIENT, () -> () -> {
					openWandGUI(playerIn.method_5998(handIn), handIn);
				});
				playerIn.method_7357()
					.method_7906(this, 5);
			}
			return new class_1271<class_1799>(class_1269.field_5812, wand);
		}

		// No Shift -> Clear Mirror
		wand.method_7969()
			.method_10556(ENABLE, false);
		return new class_1271<class_1799>(class_1269.field_5812, wand);
	}

	@Environment(EnvType.CLIENT)
	private void openWandGUI(class_1799 wand, class_1268 hand) {
		ScreenOpener.open(new SymmetryWandScreen(wand, hand));
	}

	private static void checkNBT(class_1799 wand) {
		if (!wand.method_7985() || !wand.method_7969()
			.method_10545(SYMMETRY)) {
			wand.method_7980(new class_2487());
			wand.method_7969()
				.method_10566(SYMMETRY, new EmptyMirror(new class_243(0, 0, 0)).writeToNbt());
			wand.method_7969()
				.method_10556(ENABLE, false);
		}
	}

	public static boolean isEnabled(class_1799 stack) {
		checkNBT(stack);
		class_2487 tag = stack.method_7969();
		return tag.method_10577(ENABLE) && !tag.method_10577("Simulate");
	}

	public static SymmetryMirror getMirror(class_1799 stack) {
		checkNBT(stack);
		return SymmetryMirror.fromNBT(stack.method_7969()
			.method_10562(SYMMETRY));
	}

	public static void configureSettings(class_1799 stack, SymmetryMirror mirror) {
		checkNBT(stack);
		stack.method_7969().method_10566(SYMMETRY, mirror.writeToNbt());
	}

	public static void apply(class_1937 world, class_1799 wand, class_1657 player, class_2338 pos, class_2680 block) {
		checkNBT(wand);
		if (!isEnabled(wand))
			return;
		if (!class_1747.field_8003.containsKey(block.method_26204()))
			return;

		Map<class_2338, class_2680> blockSet = new HashMap<>();
		blockSet.put(pos, block);
		SymmetryMirror symmetry = SymmetryMirror.fromNBT((class_2487) wand.method_7969()
			.method_10562(SYMMETRY));

		class_243 mirrorPos = symmetry.getPosition();
		if (mirrorPos.method_1022(class_243.method_24954(pos)) > AllConfigs.server().equipment.maxSymmetryWandRange.get())
			return;
		if (!player.method_7337() && isHoldingBlock(player, block)
			&& BlockHelper.simulateFindAndRemoveInInventory(block, player, 1) == 0) // fabric: simulate since the first block will already be removed
			return;

		symmetry.process(blockSet);
		class_2338 to = class_2338.method_49638(mirrorPos);
		List<class_2338> targets = new ArrayList<>();
		targets.add(pos);

		for (class_2338 position : blockSet.keySet()) {
			if (position.equals(pos))
				continue;

			if (world.method_8628(block, position, class_3726.method_16195(player))) {
				class_2680 blockState = blockSet.get(position);
				for (class_2350 face : Iterate.directions)
					blockState = blockState.method_26191(face, world.method_8320(position.method_10093(face)), world,
						position, position.method_10093(face));

				if (player.method_7337()) {
					world.method_8501(position, blockState);
					targets.add(position);
					continue;
				}

				class_2680 toReplace = world.method_8320(position);
				if (!toReplace.method_45474())
					continue;
				if (toReplace.method_26214(world, position) == -1)
					continue;

				if (AllBlocks.CART_ASSEMBLER.has(blockState)) {
					class_2680 railBlock = CartAssemblerBlock.getRailBlock(blockState);
					if (BlockHelper.findAndRemoveInInventory(railBlock, player, 1) == 0)
						continue;
					if (BlockHelper.findAndRemoveInInventory(blockState, player, 1) == 0)
						blockState = railBlock;
				} else {
					if (BlockHelper.findAndRemoveInInventory(blockState, player, 1) == 0)
						continue;
				}

//				BlockSnapshot blocksnapshot = BlockSnapshot.create(world.dimension(), world, position);
				class_2680 cachedState = world.method_8320(position);
				class_3610 ifluidstate = world.method_8316(position);
				world.method_8652(position, ifluidstate.method_15759(), class_2248.field_31031);
				world.method_8501(position, blockState);

				class_2487 wandNbt = wand.method_7948();
				wandNbt.method_10556("Simulate", true);
				boolean placeInterrupted = !world.method_8628(cachedState, position, class_3726.method_16194());//ForgeEventFactory.onBlockPlace(player, blocksnapshot, Direction.UP);
				wandNbt.method_10556("Simulate", false);

				if (placeInterrupted) {
//					blocksnapshot.restore(true, false);
					world.method_8501(position, cachedState);
					continue;
				}
				targets.add(position);
			}
		}

		AllPackets.getChannel().sendToClientsTrackingAndSelf(new SymmetryEffectPacket(to, targets), player);
	}

	private static boolean isHoldingBlock(class_1657 player, class_2680 block) {
		class_1799 itemBlock = BlockHelper.getRequiredItem(block);
		return player.method_24518(itemBlock.method_7909());
	}

	public static void remove(class_1937 world, class_1799 wand, class_1657 player, class_2338 pos, class_2680 ogBlock) {
		class_2680 air = class_2246.field_10124.method_9564();
		checkNBT(wand);
		if (!isEnabled(wand))
			return;

		Map<class_2338, class_2680> blockSet = new HashMap<>();
		blockSet.put(pos, air);
		SymmetryMirror symmetry = SymmetryMirror.fromNBT((class_2487) wand.method_7969()
			.method_10562(SYMMETRY));

		class_243 mirrorPos = symmetry.getPosition();
		if (mirrorPos.method_1022(class_243.method_24954(pos)) > AllConfigs.server().equipment.maxSymmetryWandRange.get())
			return;

		symmetry.process(blockSet);

		class_2338 to = class_2338.method_49638(mirrorPos);
		List<class_2338> targets = new ArrayList<>();

		targets.add(pos);
		for (class_2338 position : blockSet.keySet()) {
			if (!player.method_7337() && ogBlock.method_26204() != world.method_8320(position)
					.method_26204())
				continue;
			if (position.equals(pos))
				continue;

			class_2680 blockstate = world.method_8320(position);
			class_2586 be = blockstate.method_31709() ? world.method_8321(position) : null;
			if (!blockstate.method_26215()) {
				if (handlePreEvent(world, player, position, blockstate, be))
					continue;
				targets.add(position);
				world.method_20290(2001, position, class_2248.method_9507(blockstate));
				world.method_8652(position, air, 3);

				if (!player.method_7337()) {
					if (!player.method_6047()
						.method_7960())
						player.method_6047()
							.method_7952(world, blockstate, position, player);
					class_2586 blockEntity = blockstate.method_31709() ? world.method_8321(position) : null;
					class_2248.method_9511(blockstate, world, pos, blockEntity, player, player.method_6047()); // Add fortune, silk touch and other loot modifiers
				}
				handlePostEvent(world, player, position, blockstate, be);
			}
		}

		AllPackets.getChannel().sendToClientsTrackingAndSelf(new SymmetryEffectPacket(to, targets), player);
	}

	/**
	 * Handling firing events before the wand changes blocks.
	 * @return true if canceled
	 */
	public static boolean handlePreEvent(class_1937 world, class_1657 player, class_2338 pos, class_2680 state, class_2586 be) {
		if (PlayerBlockBreakEvents.BEFORE.invoker().beforeBlockBreak(world, player, pos, state, be)) {
			return false;
		}
		PlayerBlockBreakEvents.CANCELED.invoker().onBlockBreakCanceled(world, player, pos, state, be);
		return true;
	}

	public static void handlePostEvent(class_1937 world, class_1657 player, class_2338 pos, class_2680 state, class_2586 be) {
		PlayerBlockBreakEvents.AFTER.invoker().afterBlockBreak(world, player, pos, state, be);
	}

//	@Override
//	@Environment(EnvType.CLIENT)
//	public void initializeClient(Consumer<IItemRenderProperties> consumer) {
//		consumer.accept(SimpleCustomRenderer.create(this, new SymmetryWandItemRenderer()));
//	}

}
