package com.simibubi.create.content.equipment.toolbox;

import com.simibubi.create.foundation.networking.SimplePacketBase;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;

import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2540;
import net.minecraft.class_2586;
import net.minecraft.class_3222;

public class ToolboxEquipPacket extends SimplePacketBase {

	private class_2338 toolboxPos;
	private int slot;
	private int hotbarSlot;

	public ToolboxEquipPacket(class_2338 toolboxPos, int slot, int hotbarSlot) {
		this.toolboxPos = toolboxPos;
		this.slot = slot;
		this.hotbarSlot = hotbarSlot;
	}

	public ToolboxEquipPacket(class_2540 buffer) {
		if (buffer.readBoolean())
			toolboxPos = buffer.method_10811();
		slot = buffer.method_10816();
		hotbarSlot = buffer.method_10816();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeBoolean(toolboxPos != null);
		if (toolboxPos != null)
			buffer.method_10807(toolboxPos);
		buffer.method_10804(slot);
		buffer.method_10804(hotbarSlot);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			class_1937 world = player.method_37908();

			if (toolboxPos == null) {
				ToolboxHandler.unequip(player, hotbarSlot, false);
				ToolboxHandler.syncData(player);
				return;
			}

			class_2586 blockEntity = world.method_8321(toolboxPos);

			double maxRange = ToolboxHandler.getMaxRange(player);
			if (player.method_5649(toolboxPos.method_10263() + 0.5, toolboxPos.method_10264(), toolboxPos.method_10260() + 0.5) > maxRange
				* maxRange)
				return;
			if (!(blockEntity instanceof ToolboxBlockEntity))
				return;

			ToolboxHandler.unequip(player, hotbarSlot, false);

			if (slot < 0 || slot >= 8) {
				ToolboxHandler.syncData(player);
				return;
			}

			ToolboxBlockEntity toolboxBlockEntity = (ToolboxBlockEntity) blockEntity;

			class_1799 playerStack = player.method_31548().method_5438(hotbarSlot);
			if (!playerStack.method_7960() && !ToolboxInventory.canItemsShareCompartment(playerStack,
				toolboxBlockEntity.inventory.filters.get(slot))) {
				toolboxBlockEntity.inventory.inLimitedMode(inventory -> {
					try (Transaction t = TransferUtil.getTransaction()) {
						ItemVariant stack = ItemVariant.of(playerStack);
						long count = playerStack.method_7947();
						long inserted = inventory.insert(stack, count, t);
						if (inserted != count)
							inserted += TransferUtil.insertToMainInv(player, stack, count - inserted);
						long remainder = count - inserted;
						if (remainder != count) {
							t.commit();
							class_1799 newStack = player.method_32318(hotbarSlot).method_32327().method_7972();
							newStack.method_7939((int) remainder);
							player.method_31548().method_5447(hotbarSlot, newStack);
						}
					}
				});
			}

			class_2487 compound = player.getCustomData()
				.method_10562("CreateToolboxData");
			String key = String.valueOf(hotbarSlot);

			class_2487 data = new class_2487();
			data.method_10569("Slot", slot);
			data.method_10566("Pos", class_2512.method_10692(toolboxPos));
			compound.method_10566(key, data);

			player.getCustomData()
				.method_10566("CreateToolboxData", compound);

			toolboxBlockEntity.connectPlayer(slot, player, hotbarSlot);
			ToolboxHandler.syncData(player);
		});
		return true;
	}

}
