package com.simibubi.create.content.equipment.zapper;

import java.util.List;
import java.util.function.Predicate;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_5819;
import com.google.common.base.Predicates;
import com.simibubi.create.foundation.gui.AllIcons;
import com.simibubi.create.foundation.utility.Lang;

public enum PlacementPatterns {

	Solid(AllIcons.I_PATTERN_SOLID),
	Checkered(AllIcons.I_PATTERN_CHECKERED),
	InverseCheckered(AllIcons.I_PATTERN_CHECKERED_INVERSED),
	Chance25(AllIcons.I_PATTERN_CHANCE_25),
	Chance50(AllIcons.I_PATTERN_CHANCE_50),
	Chance75(AllIcons.I_PATTERN_CHANCE_75);

	public final String translationKey;
	public final AllIcons icon;

	private PlacementPatterns(AllIcons icon) {
		this.translationKey = Lang.asId(name());
		this.icon = icon;
	}

	public static void applyPattern(List<class_2338> blocksIn, class_1799 stack) {
		class_2487 tag = stack.method_7969();
		PlacementPatterns pattern =
			!tag.method_10545("Pattern") ? Solid : valueOf(tag.method_10558("Pattern"));
		class_5819 r = class_5819.method_43047();
		Predicate<class_2338> filter = Predicates.alwaysFalse();

		switch (pattern) {
		case Chance25:
			filter = pos -> r.method_43056() || r.method_43056();
			break;
		case Chance50:
			filter = pos -> r.method_43056();
			break;
		case Chance75:
			filter = pos -> r.method_43056() && r.method_43056();
			break;
		case Checkered:
			filter = pos -> (pos.method_10263() + pos.method_10264() + pos.method_10260()) % 2 == 0;
			break;
		case InverseCheckered:
			filter = pos -> (pos.method_10263() + pos.method_10264() + pos.method_10260()) % 2 != 0;
			break;
		case Solid:
		default:
			break;
		}

		blocksIn.removeIf(filter);
	}

}
