package com.simibubi.create.content.equipment.zapper;

import com.simibubi.create.foundation.networking.SimplePacketBase;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1297;
import net.minecraft.class_243;
import net.minecraft.class_2540;
import net.minecraft.class_310;

public abstract class ShootGadgetPacket extends SimplePacketBase {

	public class_243 location;
	public class_1268 hand;
	public boolean self;

	public ShootGadgetPacket(class_243 location, class_1268 hand, boolean self) {
		this.location = location;
		this.hand = hand;
		this.self = self;
	}

	public ShootGadgetPacket(class_2540 buffer) {
		hand = buffer.readBoolean() ? class_1268.field_5808 : class_1268.field_5810;
		self = buffer.readBoolean();
		location = new class_243(buffer.readDouble(), buffer.readDouble(), buffer.readDouble());
		readAdditional(buffer);
	}

	public final void write(class_2540 buffer) {
		buffer.writeBoolean(hand == class_1268.field_5808);
		buffer.writeBoolean(self);
		buffer.writeDouble(location.field_1352);
		buffer.writeDouble(location.field_1351);
		buffer.writeDouble(location.field_1350);
		writeAdditional(buffer);
	}

	protected abstract void readAdditional(class_2540 buffer);

	protected abstract void writeAdditional(class_2540 buffer);

	@Environment(EnvType.CLIENT)
	protected abstract void handleAdditional();

	@Environment(EnvType.CLIENT)
	protected abstract ShootableGadgetRenderHandler getHandler();

	@Override
	@Environment(EnvType.CLIENT)
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_1297 renderViewEntity = class_310.method_1551()
				.method_1560();
			if (renderViewEntity == null)
				return;
			if (renderViewEntity.method_19538()
				.method_1022(location) > 100)
				return;

			ShootableGadgetRenderHandler handler = getHandler();
			handleAdditional();
			if (self)
				handler.shoot(hand, location);
			else
				handler.playSound(hand, location);
		});
		return true;
	}

}
