package com.simibubi.create.content.equipment.zapper;

import java.util.Vector;
import net.minecraft.class_1268;
import net.minecraft.class_1799;
import net.minecraft.class_2246;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2561;
import net.minecraft.class_2680;
import net.minecraft.class_332;
import net.minecraft.class_4587;
import net.minecraft.class_7833;
import net.minecraft.class_7923;
import com.simibubi.create.AllPackets;
import com.simibubi.create.foundation.gui.AbstractSimiScreen;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.AllIcons;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import com.simibubi.create.foundation.gui.widget.IconButton;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.NBTHelper;

public abstract class ZapperScreen extends AbstractSimiScreen {

	protected final class_2561 patternSection = Lang.translateDirect("gui.terrainzapper.patternSection");

	protected AllGuiTextures background;
	protected class_1799 zapper;
	protected class_1268 hand;

	protected float animationProgress;

	protected class_2561 title;
	protected Vector<IconButton> patternButtons = new Vector<>(6);
	private IconButton confirmButton;
	protected int brightColor;
	protected int fontColor;

	protected PlacementPatterns currentPattern;

	public ZapperScreen(AllGuiTextures background, class_1799 zapper, class_1268 hand) {
		this.background = background;
		this.zapper = zapper;
		this.hand = hand;
		field_22785 = Components.immutableEmpty();
		brightColor = 0xFEFEFE;
		fontColor = AllGuiTextures.FONT_COLOR;

		class_2487 nbt = zapper.method_7948();
		currentPattern = NBTHelper.readEnum(nbt, "Pattern", PlacementPatterns.class);
	}

	@Override
	protected void method_25426() {
		setWindowSize(background.width, background.height);
		setWindowOffset(-10, 0);
		super.method_25426();

		animationProgress = 0;

		int x = guiLeft;
		int y = guiTop;

		confirmButton =
			new IconButton(x + background.width - 33, y + background.height - 24, AllIcons.I_CONFIRM);
		confirmButton.withCallback(() -> {
			method_25419();
		});
		method_37063(confirmButton);

		patternButtons.clear();
		for (int row = 0; row <= 1; row++) {
			for (int col = 0; col <= 2; col++) {
				int id = patternButtons.size();
				PlacementPatterns pattern = PlacementPatterns.values()[id];
				IconButton patternButton = new IconButton(x + background.width - 76 + col * 18, y + 21 + row * 18, pattern.icon);
				patternButton.withCallback(() -> {
					patternButtons.forEach(b -> b.field_22763 = true);
					patternButton.field_22763 = false;
					currentPattern = pattern;
				});
				patternButton.setToolTip(Lang.translateDirect("gui.terrainzapper.pattern." + pattern.translationKey));
				patternButtons.add(patternButton);
			}
		}

		patternButtons.get(currentPattern.ordinal()).field_22763 = false;

		addRenderableWidgets(patternButtons);
	}

	@Override
	protected void renderWindow(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		int x = guiLeft;
		int y = guiTop;

		background.render(graphics, x, y);
		drawOnBackground(graphics, x, y);

		renderBlock(graphics, x, y);
		renderZapper(graphics, x, y);
	}

	protected void drawOnBackground(class_332 graphics, int x, int y) {
		graphics.method_51439(field_22793, field_22785, x + 11, y + 4, 0x54214F, false);
	}

	@Override
	public void method_25393() {
		super.method_25393();
		animationProgress += 5;
	}

	@Override
	public void method_25432() {
		ConfigureZapperPacket packet = getConfigurationPacket();
		packet.configureZapper(zapper);
		AllPackets.getChannel().sendToServer(packet);
	}

	protected void renderZapper(class_332 graphics, int x, int y) {
		GuiGameElement.of(zapper)
				.scale(4)
				.at(x + background.width, y + background.height - 48, -200)
				.render(graphics);
	}

	@SuppressWarnings("deprecation")
	protected void renderBlock(class_332 graphics, int x, int y) {
		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(x + 32, y + 42, 120);
		ms.method_22907(class_7833.field_40714.rotationDegrees(-25f));
		ms.method_22907(class_7833.field_40716.rotationDegrees(-45f));
		ms.method_22905(20, 20, 20);

		class_2680 state = class_2246.field_10124.method_9564();
		if (zapper.method_7985() && zapper.method_7969()
			.method_10545("BlockUsed"))
			state = class_2512.method_10681(class_7923.field_41175.method_46771(), zapper.method_7969()
				.method_10562("BlockUsed"));

		GuiGameElement.of(state)
			.render(graphics);
		ms.method_22909();
	}

	protected abstract ConfigureZapperPacket getConfigurationPacket();

}
