package com.simibubi.create.content.equipment.zapper.terrainzapper;

import java.util.ArrayList;
import java.util.List;

import com.simibubi.create.content.equipment.zapper.PlacementPatterns;
import com.simibubi.create.content.equipment.zapper.ZapperItem;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.NBTHelper;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2561;
import net.minecraft.class_2680;
import net.minecraft.class_3965;

public class WorldshaperItem extends ZapperItem {

	public WorldshaperItem(class_1793 properties) {
		super(properties);
	}

	@Override
	@Environment(value = EnvType.CLIENT)
	protected void openHandgunGUI(class_1799 item, class_1268 hand) {
		ScreenOpener.open(new WorldshaperScreen(item, hand));
	}

	@Override
	protected int getZappingRange(class_1799 stack) {
		return 128;
	}

	@Override
	protected int getCooldownDelay(class_1799 item) {
		return 2;
	}

	@Override
	public class_2561 validateUsage(class_1799 item) {
		if (!item.method_7948()
			.method_10545("BrushParams"))
			return Lang.translateDirect("terrainzapper.shiftRightClickToSet");
		return super.validateUsage(item);
	}

	@Override
	protected boolean canActivateWithoutSelectedBlock(class_1799 stack) {
		class_2487 tag = stack.method_7948();
		TerrainTools tool = NBTHelper.readEnum(tag, "Tool", TerrainTools.class);
		return !tool.requiresSelectedBlock();
	}

	@Override
	protected boolean activate(class_1937 world, class_1657 player, class_1799 stack, class_2680 stateToUse,
		class_3965 raytrace, class_2487 data) {

		class_2338 targetPos = raytrace.method_17777();
		List<class_2338> affectedPositions = new ArrayList<>();

		class_2487 tag = stack.method_7948();
		Brush brush = NBTHelper.readEnum(tag, "Brush", TerrainBrushes.class)
			.get();
		class_2338 params = class_2512.method_10691(tag.method_10562("BrushParams"));
		PlacementOptions option = NBTHelper.readEnum(tag, "Placement", PlacementOptions.class);
		TerrainTools tool = NBTHelper.readEnum(tag, "Tool", TerrainTools.class);

		brush.set(params.method_10263(), params.method_10264(), params.method_10260());
		targetPos = targetPos.method_10081(brush.getOffset(player.method_5720(), raytrace.method_17780(), option));
		brush.addToGlobalPositions(world, targetPos, raytrace.method_17780(), affectedPositions, tool);
		PlacementPatterns.applyPattern(affectedPositions, stack);
		brush.redirectTool(tool)
			.run(world, affectedPositions, raytrace.method_17780(), stateToUse, data, player);

		return true;
	}

	public static void configureSettings(class_1799 stack, PlacementPatterns pattern, TerrainBrushes brush,
		int brushParamX, int brushParamY, int brushParamZ, TerrainTools tool, PlacementOptions placement) {
		ZapperItem.configureSettings(stack, pattern);
		class_2487 nbt = stack.method_7948();
		NBTHelper.writeEnum(nbt, "Brush", brush);
		nbt.method_10566("BrushParams", class_2512.method_10692(new class_2338(brushParamX, brushParamY, brushParamZ)));
		NBTHelper.writeEnum(nbt, "Tool", tool);
		NBTHelper.writeEnum(nbt, "Placement", placement);
	}

//	@Override
//	@OnlyIn(Dist.CLIENT)
//	public void initializeClient(Consumer<IClientItemExtensions> consumer) {
//		consumer.accept(SimpleCustomRenderer.create(this, new WorldshaperItemRenderer()));
//	}

}
