package com.simibubi.create.content.equipment.zapper.terrainzapper;

import java.util.ArrayList;
import java.util.Collection;
import java.util.function.Supplier;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_239.class_240;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_310;
import net.minecraft.class_3959;
import net.minecraft.class_3959.class_242;
import net.minecraft.class_3959.class_3960;
import net.minecraft.class_3965;
import net.minecraft.class_746;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllSpecialTextures;
import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.utility.NBTHelper;

public class WorldshaperRenderHandler {

	private static Supplier<Collection<class_2338>> renderedPositions;

	public static void tick() {
		gatherSelectedBlocks();
		if (renderedPositions == null)
			return;

		CreateClient.OUTLINER.showCluster("terrainZapper", renderedPositions.get())
				.colored(0xbfbfbf)
				.disableLineNormals()
				.lineWidth(1 / 32f)
				.withFaceTexture(AllSpecialTextures.CHECKERED);
	}

	protected static void gatherSelectedBlocks() {
		class_746 player = class_310.method_1551().field_1724;
		class_1799 heldMain = player.method_6047();
		class_1799 heldOff = player.method_6079();
		boolean zapperInMain = AllItems.WORLDSHAPER.isIn(heldMain);
		boolean zapperInOff = AllItems.WORLDSHAPER.isIn(heldOff);

		if (zapperInMain) {
			class_2487 tag = heldMain.method_7948();
			if (!tag.method_10545("_Swap") || !zapperInOff) {
				createBrushOutline(tag, player, heldMain);
				return;
			}
		}

		if (zapperInOff) {
			class_2487 tag = heldOff.method_7948();
			createBrushOutline(tag, player, heldOff);
			return;
		}

		renderedPositions = null;
	}

	public static void createBrushOutline(class_2487 tag, class_746 player, class_1799 zapper) {
		if (!tag.method_10545("BrushParams")) {
			renderedPositions = null;
			return;
		}

		Brush brush = NBTHelper.readEnum(tag, "Brush", TerrainBrushes.class)
			.get();
		PlacementOptions placement = NBTHelper.readEnum(tag, "Placement", PlacementOptions.class);
		TerrainTools tool = NBTHelper.readEnum(tag, "Tool", TerrainTools.class);
		class_2338 params = class_2512.method_10691(tag.method_10562("BrushParams"));
		brush.set(params.method_10263(), params.method_10264(), params.method_10260());

		class_243 start = player.method_19538()
			.method_1031(0, player.method_5751(), 0);
		class_243 range = player.method_5720()
			.method_1021(128);
		class_3965 raytrace = player.method_37908()
			.method_17742(new class_3959(start, start.method_1019(range), class_3960.field_17559, class_242.field_1348, player));
		if (raytrace == null || raytrace.method_17783() == class_240.field_1333) {
			renderedPositions = null;
			return;
		}

		class_2338 pos = raytrace.method_17777()
			.method_10081(brush.getOffset(player.method_5720(), raytrace.method_17780(), placement));
		renderedPositions =
			() -> brush.addToGlobalPositions(player.method_37908(), pos, raytrace.method_17780(), new ArrayList<>(), tool);
	}

}
