package com.simibubi.create.content.fluids;

import com.simibubi.create.AllFluids;
import com.simibubi.create.api.event.PipeCollisionEvent;
import com.simibubi.create.foundation.advancement.AdvancementBehaviour;
import com.simibubi.create.foundation.advancement.AllAdvancements;
import com.simibubi.create.foundation.fluid.FluidHelper;
import com.simibubi.create.foundation.utility.BlockHelper;
import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3486;
import net.minecraft.class_3610;
import net.minecraft.class_3611;
import net.minecraft.class_3612;

public class FluidReactions {

	public static void handlePipeFlowCollision(class_1937 level, class_2338 pos, FluidStack fluid, FluidStack fluid2) {
		class_3611 f1 = fluid.getFluid();
		class_3611 f2 = fluid2.getFluid();

		AdvancementBehaviour.tryAward(level, pos, AllAdvancements.CROSS_STREAMS);
		BlockHelper.destroyBlock(level, pos, 1);

		PipeCollisionEvent.Flow event = new PipeCollisionEvent.Flow(level, pos, f1, f2, null);
		PipeCollisionEvent.FLOW.invoker().handleFlow(event);
		if (event.getState() != null)
			level.method_8501(pos, event.getState());
	}

	public static void handlePipeFlowCollisionFallback(PipeCollisionEvent.Flow event) {
		class_3611 f1 = event.getFirstFluid();
		class_3611 f2 = event.getSecondFluid();

		if (f1 == class_3612.field_15910 && f2 == class_3612.field_15908 || f2 == class_3612.field_15910 && f1 == class_3612.field_15908) {
			event.setState(class_2246.field_10445.method_9564());
		} else if (f1 == class_3612.field_15908 && FluidHelper.hasBlockState(f2)) {
			class_2680 lavaInteraction = AllFluids.getLavaInteraction(FluidHelper.convertToFlowing(f2).method_15785());
			if (lavaInteraction != null) {
				event.setState(lavaInteraction);
			}
		} else if (f2 == class_3612.field_15908 && FluidHelper.hasBlockState(f1)) {
			class_2680 lavaInteraction = AllFluids.getLavaInteraction(FluidHelper.convertToFlowing(f1).method_15785());
			if (lavaInteraction != null) {
				event.setState(lavaInteraction);
			}
		}
	}

	public static void handlePipeSpillCollision(class_1937 level, class_2338 pos, class_3611 pipeFluid, class_3610 worldFluid) {
		class_3611 pf = FluidHelper.convertToStill(pipeFluid);
		class_3611 wf = worldFluid.method_15772();

		PipeCollisionEvent.Spill event = new PipeCollisionEvent.Spill(level, pos, wf, pf, null);
		PipeCollisionEvent.SPILL.invoker().handleSpill(event);
		if (event.getState() != null) {
			level.method_8501(pos, event.getState());
		}
	}

	public static void handlePipeSpillCollisionFallback(PipeCollisionEvent.Spill event) {
		class_3611 pf = event.getPipeFluid();
		class_3611 wf = event.getWorldFluid();

		if (FluidHelper.isTag(pf, class_3486.field_15517) && wf == class_3612.field_15908) {
			event.setState(class_2246.field_10540.method_9564());
		} else if (pf == class_3612.field_15910 && wf == class_3612.field_15907) {
			event.setState(class_2246.field_10445.method_9564());
		} else if (pf == class_3612.field_15908 && wf == class_3612.field_15910) {
			event.setState(class_2246.field_10340.method_9564());
		} else if (pf == class_3612.field_15908 && wf == class_3612.field_15909) {
			event.setState(class_2246.field_10445.method_9564());
		}

		if (pf == class_3612.field_15908) {
			class_2680 lavaInteraction = AllFluids.getLavaInteraction(wf.method_15785());
			if (lavaInteraction != null) {
				event.setState(lavaInteraction);
			}
		} else if (wf == class_3612.field_15907 && FluidHelper.hasBlockState(pf)) {
			class_2680 lavaInteraction = AllFluids.getLavaInteraction(FluidHelper.convertToFlowing(pf).method_15785());
			if (lavaInteraction != null) {
				event.setState(lavaInteraction);
			}
		}
	}

}
