package com.simibubi.create.content.fluids;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.content.fluids.FluidTransportBehaviour.AttachmentTypes;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.utility.Iterate;

import net.fabricmc.fabric.api.rendering.data.v1.RenderAttachmentBlockEntity;
import net.minecraft.class_2586;

/**
 * Fabric: Implement this on any BlockEntity that uses {@link PipeAttachmentModel} and call {@link #getAttachments(class_2586)}
 */
public interface PipeAttachmentBlockEntity extends RenderAttachmentBlockEntity {
	@Nullable
	static AttachmentTypes[] getAttachments(class_2586 be) {
		FluidTransportBehaviour behavior = BlockEntityBehaviour.get(be, FluidTransportBehaviour.TYPE);
		if (behavior == null)
			return null;
		AttachmentTypes[] attachments = new AttachmentTypes[6];
		for (int i = 0; i < Iterate.directions.length; i++) {
			attachments[i] = behavior.getRenderedRimAttachment(
					be.method_10997(), be.method_11016(), be.method_11010(), Iterate.directions[i]
			);
		}
		return attachments;
	}
}
