package com.simibubi.create.content.fluids.drain;

import com.simibubi.create.content.fluids.transfer.GenericItemEmptying;
import com.simibubi.create.content.kinetics.belt.transport.TransportedItemStack;

import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.base.SingleSlotStorage;
import net.fabricmc.fabric.api.transfer.v1.transaction.TransactionContext;
import net.fabricmc.fabric.api.transfer.v1.transaction.base.SnapshotParticipant;
import net.minecraft.class_1799;
import net.minecraft.class_2350;
import net.minecraft.class_3902;

public class ItemDrainItemHandler extends SnapshotParticipant<class_3902> implements SingleSlotStorage<ItemVariant> {

	private ItemDrainBlockEntity blockEntity;
	private class_2350 side;

	public ItemDrainItemHandler(ItemDrainBlockEntity be, class_2350 side) {
		this.blockEntity = be;
		this.side = side;
	}

	@Override
	public long insert(ItemVariant resource, long maxAmount, TransactionContext transaction) {
		if (!blockEntity.getHeldItemStack().method_7960())
			return 0;

		class_1799 stack = resource.toStack();
		int toInsert = GenericItemEmptying.canItemBeEmptied(blockEntity.method_10997(), stack)
				? 1
				: Math.min((int) maxAmount, resource.getItem().method_7882());
		stack.method_7939(toInsert);
		TransportedItemStack heldItem = new TransportedItemStack(stack);
		heldItem.prevBeltPosition = 0;
		blockEntity.snapshotParticipant.updateSnapshots(transaction);
		blockEntity.setHeldItem(heldItem, side.method_10153());
		return toInsert;
	}

	@Override
	public long extract(ItemVariant resource, long maxAmount, TransactionContext transaction) {
		TransportedItemStack held = blockEntity.heldItem;
		if (held == null)
			return 0;

		int toExtract = Math.min((int) maxAmount, held.stack.method_7947());
		class_1799 stack = held.stack.method_7972();
		stack.method_7934(toExtract);
		blockEntity.snapshotParticipant.updateSnapshots(transaction);
		blockEntity.heldItem.stack = stack;
		if (stack.method_7960())
			blockEntity.heldItem = null;
		return toExtract;
	}

	@Override
	public boolean isResourceBlank() {
		return getResource().isBlank();
	}

	@Override
	public ItemVariant getResource() {
		return ItemVariant.of(getStack());
	}

	@Override
	public long getAmount() {
		class_1799 stack = getStack();
		return stack.method_7960() ? 0 : stack.method_7947();
	}

	@Override
	public long getCapacity() {
		return getStack().method_7914();
	}

	public class_1799 getStack() {
		TransportedItemStack held = blockEntity.heldItem;
		if (held == null || held.stack == null || held.stack.method_7960())
			return class_1799.field_8037;
		return held.stack;
	}

	@Override
	protected class_3902 createSnapshot() {
		return class_3902.field_17274;
	}

	@Override
	protected void readSnapshot(class_3902 snapshot) {
	}

	@Override
	protected void onFinalCommit() {
		super.onFinalCommit();
		blockEntity.notifyUpdate();
	}
}
