package com.simibubi.create.content.fluids.drain;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.content.fluids.transfer.GenericItemEmptying;
import com.simibubi.create.content.kinetics.belt.BeltHelper;
import com.simibubi.create.content.kinetics.belt.transport.TransportedItemStack;
import com.simibubi.create.foundation.blockEntity.behaviour.fluid.SmartFluidTankBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.fluid.SmartFluidTankBehaviour.TankSegment;
import com.simibubi.create.foundation.blockEntity.renderer.SmartBlockEntityRenderer;
import com.simibubi.create.foundation.fluid.FluidRenderer;
import com.simibubi.create.foundation.utility.VecHelper;
import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;
import net.minecraft.class_1297;
import net.minecraft.class_1799;
import net.minecraft.class_2350;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_310;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5614;
import net.minecraft.class_5819;
import net.minecraft.class_7833;
import net.minecraft.class_811;
import net.minecraft.class_918;

public class ItemDrainRenderer extends SmartBlockEntityRenderer<ItemDrainBlockEntity> {

	public ItemDrainRenderer(class_5614.class_5615 context) {
		super(context);
	}

	@Override
	protected void renderSafe(ItemDrainBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay) {
		super.renderSafe(be, partialTicks, ms, buffer, light, overlay);
		renderFluid(be, partialTicks, ms, buffer, light);
		renderItem(be, partialTicks, ms, buffer, light, overlay);
	}

	protected void renderItem(ItemDrainBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay) {
		TransportedItemStack transported = be.heldItem;
		if (transported == null)
			return;

		TransformStack msr = TransformStack.cast(ms);
		class_243 itemPosition = VecHelper.getCenterOf(be.method_11016());

		class_2350 insertedFrom = transported.insertedFrom;
		if (!insertedFrom.method_10166()
			.method_10179())
			return;

		ms.method_22903();
		ms.method_46416(.5f, 15 / 16f, .5f);
		msr.nudge(0);
		float offset = class_3532.method_16439(partialTicks, transported.prevBeltPosition, transported.beltPosition);
		float sideOffset = class_3532.method_16439(partialTicks, transported.prevSideOffset, transported.sideOffset);

		class_243 offsetVec = class_243.method_24954(insertedFrom.method_10153()
			.method_10163())
			.method_1021(.5f - offset);
		ms.method_22904(offsetVec.field_1352, offsetVec.field_1351, offsetVec.field_1350);
		boolean alongX = insertedFrom.method_10170()
			.method_10166() == class_2350.class_2351.field_11048;
		if (!alongX)
			sideOffset *= -1;
		ms.method_46416(alongX ? sideOffset : 0, 0, alongX ? 0 : sideOffset);

		class_1799 itemStack = transported.stack;
		class_5819 r = class_5819.method_43049(0);
		class_918 itemRenderer = class_310.method_1551()
			.method_1480();
		int count = (int) (class_3532.method_15351((int) (itemStack.method_7947()))) / 2;
		boolean renderUpright = BeltHelper.isItemUpright(itemStack);
		boolean blockItem = itemRenderer.method_4019(itemStack, null, null, 0)
			.method_4712();

		if (renderUpright)
			ms.method_22904(0, 3 / 32d, 0);

		int positive = insertedFrom.method_10171()
			.method_10181();
		float verticalAngle = positive * offset * 360;
		if (insertedFrom.method_10166() != class_2350.class_2351.field_11048)
			msr.rotateX(verticalAngle);
		if (insertedFrom.method_10166() != class_2350.class_2351.field_11051)
			msr.rotateZ(-verticalAngle);

		if (renderUpright) {
			class_1297 renderViewEntity = class_310.method_1551().field_1719;
			if (renderViewEntity != null) {
				class_243 positionVec = renderViewEntity.method_19538();
				class_243 vectorForOffset = itemPosition.method_1019(offsetVec);
				class_243 diff = vectorForOffset.method_1020(positionVec);

				if (insertedFrom.method_10166() != class_2350.class_2351.field_11048)
					diff = VecHelper.rotate(diff, verticalAngle, class_2350.class_2351.field_11048);
				if (insertedFrom.method_10166() != class_2350.class_2351.field_11051)
					diff = VecHelper.rotate(diff, -verticalAngle, class_2350.class_2351.field_11051);

				float yRot = (float) class_3532.method_15349(diff.field_1350, -diff.field_1352);
				ms.method_22907(class_7833.field_40716.rotation((float) (yRot - Math.PI / 2)));
			}
			ms.method_46416(0, 0, -1 / 16f);
		}

		for (int i = 0; i <= count; i++) {
			ms.method_22903();
			if (blockItem)
				ms.method_46416(r.method_43057() * .0625f * i, 0, r.method_43057() * .0625f * i);
			ms.method_22905(.5f, .5f, .5f);
			if (!blockItem && !renderUpright)
				msr.rotateX(90);
			itemRenderer.method_23178(itemStack, class_811.field_4319, light, overlay, ms, buffer, be.method_10997(), 0);
			ms.method_22909();

			if (!renderUpright) {
				if (!blockItem)
					msr.rotateY(10);
				ms.method_22904(0, blockItem ? 1 / 64d : 1 / 16d, 0);
			} else
				ms.method_46416(0, 0, -1 / 16f);
		}

		ms.method_22909();
	}

	protected void renderFluid(ItemDrainBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light) {
		SmartFluidTankBehaviour tank = be.internalTank;
		if (tank == null)
			return;

		TankSegment primaryTank = tank.getPrimaryTank();
		FluidStack fluidStack = primaryTank.getRenderedFluid();
		float level = primaryTank.getFluidLevel()
			.getValue(partialTicks);

		if (!fluidStack.isEmpty() && level != 0) {
			float yMin = 5f / 16f;
			float min = 2f / 16f;
			float max = min + (12 / 16f);
			float yOffset = (7 / 16f) * level;
			ms.method_22903();
			ms.method_46416(0, yOffset, 0);
			FluidRenderer.renderFluidBox(fluidStack, min, yMin - yOffset, min, max, yMin, max, buffer, ms, light,
				false);
			ms.method_22909();
		}

		class_1799 heldItemStack = be.getHeldItemStack();
		if (heldItemStack.method_7960())
			return;
		FluidStack fluidStack2 = GenericItemEmptying.emptyItem(be.method_10997(), heldItemStack, true)
			.getFirst();
		if (fluidStack2.isEmpty()) {
			if (fluidStack.isEmpty())
				return;
			fluidStack2 = fluidStack;
		}

		int processingTicks = be.processingTicks;
		float processingPT = be.processingTicks - partialTicks;
		float processingProgress = 1 - (processingPT - 5) / 10;
		processingProgress = class_3532.method_15363(processingProgress, 0, 1);
		float radius = 0;

		if (processingTicks != -1) {
			radius = (float) (Math.pow(((2 * processingProgress) - 1), 2) - 1);
			class_238 bb = new class_238(0.5, 1.0, 0.5, 0.5, 0.25, 0.5).method_1014(radius / 32f);
			FluidRenderer.renderFluidBox(fluidStack2, (float) bb.field_1323, (float) bb.field_1322, (float) bb.field_1321,
				(float) bb.field_1320, (float) bb.field_1325, (float) bb.field_1324, buffer, ms, light, true);
		}

	}

}
