package com.simibubi.create.content.fluids.particle;

import com.mojang.brigadier.StringReader;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import com.simibubi.create.AllParticleTypes;
import com.simibubi.create.foundation.particle.ICustomParticleData;
import com.simibubi.create.foundation.utility.RegisteredObjects;

import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2394;
import net.minecraft.class_2396;
import net.minecraft.class_2540;
import net.minecraft.class_3612;
import net.minecraft.class_638;
import net.minecraft.class_703;
import net.minecraft.class_707;

public class FluidParticleData implements class_2394, ICustomParticleData<FluidParticleData> {

	private class_2396<FluidParticleData> type;
	private FluidStack fluid;

	public FluidParticleData() {}

	@SuppressWarnings("unchecked")
	public FluidParticleData(class_2396<?> type, FluidStack fluid) {
		this.type = (class_2396<FluidParticleData>) type;
		this.fluid = fluid;
	}

	@Override
	@Environment(EnvType.CLIENT)
	public class_707<FluidParticleData> getFactory() {
		return this::create;
	}

	// fabric: lambda funk
	@Environment(EnvType.CLIENT)
	private class_703 create(FluidParticleData type, class_638 level, double x, double y, double z, double xSpeed, double ySpeed, double zSpeed) {
		return FluidStackParticle.create(type.type, level, type.fluid, x, y, z, xSpeed, ySpeed, zSpeed);
	}

	@Override
	public class_2396<?> method_10295() {
		return type;
	}

	@Override
	public void method_10294(class_2540 buffer) {
		fluid.writeToPacket(buffer);
	}

	@Override
	public String method_10293() {
		return RegisteredObjects.getKeyOrThrow(type) + " " + RegisteredObjects.getKeyOrThrow(fluid.getFluid());
	}

	public static final Codec<FluidParticleData> CODEC = RecordCodecBuilder.create(i -> i
		.group(FluidStack.CODEC.fieldOf("fluid")
			.forGetter(p -> p.fluid))
		.apply(i, fs -> new FluidParticleData(AllParticleTypes.FLUID_PARTICLE.get(), fs)));

	public static final Codec<FluidParticleData> BASIN_CODEC = RecordCodecBuilder.create(i -> i
		.group(FluidStack.CODEC.fieldOf("fluid")
			.forGetter(p -> p.fluid))
		.apply(i, fs -> new FluidParticleData(AllParticleTypes.BASIN_FLUID.get(), fs)));

	public static final Codec<FluidParticleData> DRIP_CODEC = RecordCodecBuilder.create(i -> i
		.group(FluidStack.CODEC.fieldOf("fluid")
			.forGetter(p -> p.fluid))
		.apply(i, fs -> new FluidParticleData(AllParticleTypes.FLUID_DRIP.get(), fs)));

	public static final class_2394.class_2395<FluidParticleData> DESERIALIZER =
		new class_2394.class_2395<FluidParticleData>() {

			// TODO Fluid particles on command
			public FluidParticleData method_10296(class_2396<FluidParticleData> particleTypeIn, StringReader reader)
				throws CommandSyntaxException {
				return new FluidParticleData(particleTypeIn, new FluidStack(class_3612.field_15910, 1));
			}

			public FluidParticleData method_10297(class_2396<FluidParticleData> particleTypeIn, class_2540 buffer) {
				return new FluidParticleData(particleTypeIn, FluidStack.readFromPacket(buffer));
			}
		};

	@Override
	public class_2395<FluidParticleData> getDeserializer() {
		return DESERIALIZER;
	}

	@Override
	public Codec<FluidParticleData> getCodec(class_2396<FluidParticleData> type) {
		if (type == AllParticleTypes.BASIN_FLUID.get())
			return BASIN_CODEC;
		if (type == AllParticleTypes.FLUID_DRIP.get())
			return DRIP_CODEC;
		return CODEC;
	}

}
