package com.simibubi.create.content.fluids.particle;

import com.simibubi.create.AllParticleTypes;
import com.simibubi.create.content.fluids.potion.PotionFluid;
import com.simibubi.create.foundation.utility.Color;
import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;

import net.fabricmc.fabric.api.transfer.v1.client.fluid.FluidVariantRenderHandler;
import net.fabricmc.fabric.api.transfer.v1.client.fluid.FluidVariantRendering;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidVariantAttributes;
import net.minecraft.class_2338;
import net.minecraft.class_2396;
import net.minecraft.class_2398;
import net.minecraft.class_3999;
import net.minecraft.class_4003;
import net.minecraft.class_638;

public class FluidStackParticle extends class_4003 {
	private final float uo;
	private final float vo;
	private FluidStack fluid;
//	private IClientFluidTypeExtensions clientFluid; // fabric: replaced with FluidVariantRendering

	public static FluidStackParticle create(class_2396<FluidParticleData> type, class_638 world, FluidStack fluid,
		double x, double y, double z, double vx, double vy, double vz) {
		if (type == AllParticleTypes.BASIN_FLUID.get())
			return new BasinFluidParticle(world, fluid, x, y, z, vx, vy, vz);
		return new FluidStackParticle(world, fluid, x, y, z, vx, vy, vz);
	}

	@SuppressWarnings("UnstableApiUsage")
	public FluidStackParticle(class_638 world, FluidStack fluid, double x, double y, double z, double vx, double vy,
							  double vz) {
		super(world, x, y, z, vx, vy, vz);

		this.fluid = fluid;
		FluidVariantRenderHandler handler = FluidVariantRendering.getHandlerOrDefault(fluid.getFluid());
		this.method_18141(handler.getSprites(fluid.getType())[0]);

		this.field_3844 = 1.0F;
		this.field_3861 = 0.8F;
		this.field_3842 = 0.8F;
		this.field_3859 = 0.8F;
		int color = handler.getColor(fluid.getType(), world, class_2338.method_49637(x, y, z));
		multiplyColor(color);

		this.field_3852 = vx;
		this.field_3869 = vy;
		this.field_3850 = vz;

		this.field_17867 /= 2.0F;
		this.uo = this.field_3840.method_43057() * 3.0F;
		this.vo = this.field_3840.method_43057() * 3.0F;
	}

	@Override
	protected int method_3068(float p_189214_1_) {
		int brightnessForRender = super.method_3068(p_189214_1_);
		int skyLight = brightnessForRender >> 20;
		int blockLight = (brightnessForRender >> 4) & 0xf;
		blockLight = Math.max(blockLight, FluidVariantAttributes.getLuminance(fluid.getType()));
		return (skyLight << 20) | (blockLight << 4);
	}

	protected void multiplyColor(int color) {
		this.field_3861 *= (float) (color >> 16 & 255) / 255.0F;
		this.field_3842 *= (float) (color >> 8 & 255) / 255.0F;
		this.field_3859 *= (float) (color & 255) / 255.0F;
	}

	protected float method_18133() {
		return this.field_17886.method_4580((double) ((this.uo + 1.0F) / 4.0F * 16.0F));
	}

	protected float method_18134() {
		return this.field_17886.method_4580((double) (this.uo / 4.0F * 16.0F));
	}

	protected float method_18135() {
		return this.field_17886.method_4570((double) (this.vo / 4.0F * 16.0F));
	}

	protected float method_18136() {
		return this.field_17886.method_4570((double) ((this.vo + 1.0F) / 4.0F * 16.0F));
	}

	@Override
	public void method_3070() {
		super.method_3070();
		if (!canEvaporate())
			return;
		if (field_3845)
			method_3085();
		if (!field_3843)
			return;
		if (!field_3845 && field_3851.field_9229.method_43057() < 1 / 8f)
			return;

		Color color = new Color(field_3861, field_3842, field_3859, 1);
		field_3851.method_8406(class_2398.field_11226, field_3874, field_3854, field_3871, color.getRedAsFloat(), color.getGreenAsFloat(),
			color.getBlueAsFloat());
	}

	protected boolean canEvaporate() {
		return fluid.getFluid() instanceof PotionFluid;
	}

	@Override
	public class_3999 method_18122() {
		return class_3999.field_17827;
	}

}
