package com.simibubi.create.content.fluids.pipes;

import java.util.List;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_243;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2738;
import net.minecraft.class_4587;
import org.jetbrains.annotations.Nullable;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.content.fluids.FluidPropagator;
import com.simibubi.create.content.fluids.PipeAttachmentBlockEntity;
import com.simibubi.create.content.fluids.pipes.StraightPipeBlockEntity.StraightPipeFluidTransportBehaviour;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBoxTransform;
import com.simibubi.create.foundation.blockEntity.behaviour.filtering.FilteringBehaviour;
import com.simibubi.create.foundation.utility.AngleHelper;
import com.simibubi.create.foundation.utility.VecHelper;

import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;

public class SmartFluidPipeBlockEntity extends SmartBlockEntity implements PipeAttachmentBlockEntity {

	private FilteringBehaviour filter;

	public SmartFluidPipeBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {
		behaviours.add(new SmartPipeBehaviour(this));
		behaviours.add(filter = new FilteringBehaviour(this, new SmartPipeFilterSlot()).forFluids()
			.withCallback(this::onFilterChanged));
		registerAwardables(behaviours, FluidPropagator.getSharedTriggers());
	}

	private void onFilterChanged(class_1799 newFilter) {
		if (!field_11863.field_9236)
			FluidPropagator.propagateChangedPipe(field_11863, field_11867, method_11010());
	}

	@Override
	@Nullable
	public Object getRenderAttachmentData() {
		return PipeAttachmentBlockEntity.getAttachments(this);
	}

	class SmartPipeBehaviour extends StraightPipeFluidTransportBehaviour {

		public SmartPipeBehaviour(SmartBlockEntity be) {
			super(be);
		}

		@Override
		public boolean canPullFluidFrom(FluidStack fluid, class_2680 state, class_2350 direction) {
			if (fluid.isEmpty() || filter != null && filter.test(fluid))
				return super.canPullFluidFrom(fluid, state, direction);
			return false;
		}

		@Override
		public boolean canHaveFlowToward(class_2680 state, class_2350 direction) {
			return state.method_26204() instanceof SmartFluidPipeBlock
				&& SmartFluidPipeBlock.getPipeAxis(state) == direction.method_10166();
		}

	}

	class SmartPipeFilterSlot extends ValueBoxTransform {

		@Override
		public class_243 getLocalOffset(class_2680 state) {
			class_2738 face = state.method_11654(SmartFluidPipeBlock.field_11007);
			float y = face == class_2738.field_12473 ? 0.55f : face == class_2738.field_12471 ? 11.4f : 15.45f;
			float z = face == class_2738.field_12473 ? 4.6f : face == class_2738.field_12471 ? 0.55f : 4.625f;
			return VecHelper.rotateCentered(VecHelper.voxelSpace(8, y, z), angleY(state), class_2351.field_11052);
		}

		@Override
		public float getScale() {
			return super.getScale() * 1.02f;
		}

		@Override
		public void rotate(class_2680 state, class_4587 ms) {
			class_2738 face = state.method_11654(SmartFluidPipeBlock.field_11007);
			TransformStack.cast(ms)
				.rotateY(angleY(state))
				.rotateX(face == class_2738.field_12473 ? -45 : 45);
		}

		protected float angleY(class_2680 state) {
			class_2738 face = state.method_11654(SmartFluidPipeBlock.field_11007);
			float horizontalAngle = AngleHelper.horizontalAngle(state.method_11654(SmartFluidPipeBlock.field_11177));
			if (face == class_2738.field_12471)
				horizontalAngle += 180;
			return horizontalAngle;
		}

	}

}
