package com.simibubi.create.content.fluids.pipes;

import java.util.List;
import net.minecraft.class_1920;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import org.jetbrains.annotations.Nullable;

import com.simibubi.create.content.decoration.bracket.BracketedBlockEntityBehaviour;
import com.simibubi.create.content.fluids.FluidPropagator;
import com.simibubi.create.content.fluids.FluidTransportBehaviour;
import com.simibubi.create.content.fluids.PipeAttachmentBlockEntity;
import com.simibubi.create.content.fluids.pipes.valve.FluidValveBlock;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;

public class StraightPipeBlockEntity extends SmartBlockEntity implements PipeAttachmentBlockEntity {

	public StraightPipeBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {
		behaviours.add(new StraightPipeFluidTransportBehaviour(this));
		behaviours.add(new BracketedBlockEntityBehaviour(this));
		registerAwardables(behaviours, FluidPropagator.getSharedTriggers());
	}

	@Override
	@Nullable
	public Object getRenderAttachmentData() {
		return PipeAttachmentBlockEntity.getAttachments(this);
	}

	public static class StraightPipeFluidTransportBehaviour extends FluidTransportBehaviour {

		public StraightPipeFluidTransportBehaviour(SmartBlockEntity be) {
			super(be);
		}

		@Override
		public boolean canHaveFlowToward(class_2680 state, class_2350 direction) {
			return state.method_28498(AxisPipeBlock.field_11459) && state.method_11654(AxisPipeBlock.field_11459) == direction.method_10166();
		}

		@Override
		public AttachmentTypes getRenderedRimAttachment(class_1920 world, class_2338 pos, class_2680 state,
			class_2350 direction) {
			AttachmentTypes attachment = super.getRenderedRimAttachment(world, pos, state, direction);
			class_2680 otherState = world.method_8320(pos.method_10093(direction));

			class_2351 axis = IAxisPipe.getAxisOf(state);
			class_2351 otherAxis = IAxisPipe.getAxisOf(otherState);

			if (attachment == AttachmentTypes.RIM && state.method_26204() instanceof FluidValveBlock)
				return AttachmentTypes.NONE;
			if (attachment == AttachmentTypes.RIM && FluidPipeBlock.isPipe(otherState))
				return AttachmentTypes.PARTIAL_RIM;
			if (axis == otherAxis && axis != null)
				return AttachmentTypes.NONE;

			if (otherState.method_26204() instanceof FluidValveBlock
				&& FluidValveBlock.getPipeAxis(otherState) == direction.method_10166())
				return AttachmentTypes.NONE;

			return attachment.withoutConnector();
		}

	}

}
