package com.simibubi.create.content.fluids.pipes.valve;

import javax.annotation.Nonnull;
import net.minecraft.class_10;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_1953;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2746;
import net.minecraft.class_3218;
import net.minecraft.class_3610;
import net.minecraft.class_3726;
import net.minecraft.class_4209;
import net.minecraft.class_4538;
import net.minecraft.class_5819;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.fluids.FluidPropagator;
import com.simibubi.create.content.fluids.pipes.FluidPipeBlock;
import com.simibubi.create.content.fluids.pipes.IAxisPipe;
import com.simibubi.create.content.kinetics.base.DirectionalAxisKineticBlock;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.block.ProperWaterloggedBlock;
import com.simibubi.create.foundation.utility.Iterate;

public class FluidValveBlock extends DirectionalAxisKineticBlock
	implements IAxisPipe, IBE<FluidValveBlockEntity>, ProperWaterloggedBlock {

	public static final class_2746 ENABLED = class_2746.method_11825("enabled");

	public FluidValveBlock(class_2251 properties) {
		super(properties);
		method_9590(method_9564().method_11657(ENABLED, false)
			.method_11657(WATERLOGGED, false));
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 p_220053_2_, class_2338 p_220053_3_,
		class_3726 p_220053_4_) {
		return AllShapes.FLUID_VALVE.get(getPipeAxis(state));
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder.method_11667(ENABLED, WATERLOGGED));
	}

	@Override
	protected boolean prefersConnectionTo(class_4538 reader, class_2338 pos, class_2350 facing, boolean shaftAxis) {
		if (!shaftAxis) {
			class_2338 offset = pos.method_10093(facing);
			class_2680 blockState = reader.method_8320(offset);
			return FluidPipeBlock.canConnectTo(reader, offset, blockState, facing);
		}
		return super.prefersConnectionTo(reader, pos, facing, shaftAxis);
	}

	@Nonnull
	public static class_2351 getPipeAxis(class_2680 state) {
		if (!(state.method_26204() instanceof FluidValveBlock))
			throw new IllegalStateException("Provided BlockState is for a different block.");
		class_2350 facing = state.method_11654(FACING);
		boolean alongFirst = !state.method_11654(AXIS_ALONG_FIRST_COORDINATE);
		for (class_2351 axis : Iterate.axes) {
			if (axis == facing.method_10166())
				continue;
			if (!alongFirst) {
				alongFirst = true;
				continue;
			}
			return axis;
		}
		throw new IllegalStateException("Impossible axis.");
	}

	@Override
	public class_2351 getAxis(class_2680 state) {
		return getPipeAxis(state);
	}

	@Override
	public void method_9536(class_2680 state, class_1937 world, class_2338 pos, class_2680 newState, boolean isMoving) {
		boolean blockTypeChanged = !state.method_27852(newState.method_26204());
		if (blockTypeChanged && !world.field_9236)
			FluidPropagator.propagateChangedPipe(world, pos, state);
		super.method_9536(state, world, pos, newState, isMoving);
	}

	@Override
	public boolean method_9558(class_2680 p_196260_1_, class_4538 p_196260_2_, class_2338 p_196260_3_) {
		return true;
	}

	@Override
	public void method_9615(class_2680 state, class_1937 world, class_2338 pos, class_2680 oldState, boolean isMoving) {
		super.method_9615(state, world, pos, oldState, isMoving);
		if (world.field_9236)
			return;
		if (state != oldState)
			world.method_39280(pos, this, 1, class_1953.field_9310);
	}

	@Override
	public void method_9612(class_2680 state, class_1937 world, class_2338 pos, class_2248 otherBlock, class_2338 neighborPos,
		boolean isMoving) {
		class_4209.method_19472(world, pos);
		class_2350 d = FluidPropagator.validateNeighbourChange(state, world, pos, otherBlock, neighborPos, isMoving);
		if (d == null)
			return;
		if (!isOpenAt(state, d))
			return;
		world.method_39280(pos, this, 1, class_1953.field_9310);
	}

	public static boolean isOpenAt(class_2680 state, class_2350 d) {
		return d.method_10166() == getPipeAxis(state);
	}

	@Override
	public void method_9588(class_2680 state, class_3218 world, class_2338 pos, class_5819 r) {
		FluidPropagator.propagateChangedPipe(world, pos, state);
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	@Override
	public Class<FluidValveBlockEntity> getBlockEntityClass() {
		return FluidValveBlockEntity.class;
	}

	@Override
	public class_2591<? extends FluidValveBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.FLUID_VALVE.get();
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		return withWater(super.method_9605(context), context);
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 direction, class_2680 neighbourState, class_1936 world,
		class_2338 pos, class_2338 neighbourPos) {
		updateWater(world, state, pos);
		return state;
	}

	@Override
	public class_3610 method_9545(class_2680 state) {
		return fluidState(state);
	}

}
