package com.simibubi.create.content.fluids.potion;

import java.util.Collection;
import java.util.List;
import net.minecraft.class_1293;
import net.minecraft.class_1842;
import net.minecraft.class_1847;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2960;
import com.simibubi.create.AllFluids;
import com.simibubi.create.content.fluids.VirtualFluid;
import com.simibubi.create.foundation.utility.RegisteredObjects;

import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;

public class PotionFluid extends VirtualFluid {

	public PotionFluid(Properties properties) {
		super(properties);
	}

	public static FluidStack of(long amount, class_1842 potion) {
		FluidStack fluidStack = new FluidStack(AllFluids.POTION.get()
				.method_15751(), amount);
		return addPotionToFluidStack(fluidStack, potion);
	}

	public static FluidStack withEffects(long amount, class_1842 potion, List<class_1293> customEffects) {
		FluidStack fluidStack = of(amount, potion);
		return appendEffects(fluidStack, customEffects);
	}

	public static FluidStack addPotionToFluidStack(FluidStack fs, class_1842 potion) {
		class_2960 resourcelocation = RegisteredObjects.getKeyOrThrow(potion);
		if (potion == class_1847.field_8984) {
			fs.removeChildTag("Potion");
			return new FluidStack(fs.getFluid(), fs.getAmount(), fs.getTag());
		}
		fs.getOrCreateTag()
				.method_10582("Potion", resourcelocation.toString());
		return new FluidStack(fs.getFluid(), fs.getAmount(), fs.getTag());
	}

	public static FluidStack appendEffects(FluidStack fs, Collection<class_1293> customEffects) {
		if (customEffects.isEmpty())
			return fs;
		class_2487 compoundnbt = fs.getOrCreateTag();
		class_2499 listnbt = compoundnbt.method_10554("CustomPotionEffects", 9);
		for (class_1293 effectinstance : customEffects)
			listnbt.add(effectinstance.method_5582(new class_2487()));
		compoundnbt.method_10566("CustomPotionEffects", listnbt);
		return new FluidStack(fs.getFluid(), fs.getAmount(), fs.getTag());
	}

	public enum BottleType {
		REGULAR, SPLASH, LINGERING;
	}

// fabric: PotionFluidVariantRenderHandler and PotionFluidVariantAttributeHandler in AllFluids
// --------------------------------
//	public static class PotionFluidType extends TintedFluidType {
//
//		public PotionFluidType(Properties properties, ResourceLocation stillTexture, ResourceLocation flowingTexture) {
//			super(properties, stillTexture, flowingTexture);
//		}
//
//		@Override
//		public int getTintColor(FluidStack stack) {
//			CompoundTag tag = stack.getOrCreateTag();
//			int color = PotionUtils.getColor(PotionUtils.getAllEffects(tag)) | 0xff000000;
//			return color;
//		}
//
//		@Override
//		public String getDescriptionId(FluidStack stack) {
//			CompoundTag tag = stack.getOrCreateTag();
//			ItemLike itemFromBottleType =
//				PotionFluidHandler.itemFromBottleType(NBTHelper.readEnum(tag, "Bottle", BottleType.class));
//			return PotionUtils.getPotion(tag)
//				.getName(itemFromBottleType.asItem()
//					.getDescriptionId() + ".effect.");
//		}
//
//		@Override
//		protected int getTintColor(FluidState state, BlockAndTintGetter getter, BlockPos pos) {
//			return NO_TINT;
//		}
//
//	}
}
