package com.simibubi.create.content.fluids.pump;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.fluids.FluidPropagator;
import com.simibubi.create.content.fluids.pipes.FluidPipeBlock;
import com.simibubi.create.content.kinetics.base.DirectionalKineticBlock;
import com.simibubi.create.content.kinetics.simpleRelays.ICogWheel;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.block.ProperWaterloggedBlock;
import com.simibubi.create.foundation.utility.Iterate;
import net.minecraft.class_10;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1838;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_1953;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_243;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2741;
import net.minecraft.class_3218;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_3737;
import net.minecraft.class_4209;
import net.minecraft.class_5819;

public class PumpBlock extends DirectionalKineticBlock
	implements class_3737, ICogWheel, IBE<PumpBlockEntity> {

	public PumpBlock(class_2251 p_i48415_1_) {
		super(p_i48415_1_);
		method_9590(super.method_9564().method_11657(class_2741.field_12508, false));
	}

	@Override
	public class_2680 getRotatedBlockState(class_2680 originalState, class_2350 targetedFace) {
		return originalState.method_11657(FACING, originalState.method_11654(FACING)
			.method_10153());
	}

	@Override
	public class_2680 updateAfterWrenched(class_2680 newState, class_1838 context) {
		return super.updateAfterWrenched(newState, context);
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return state.method_11654(FACING)
			.method_10166();
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 p_220053_2_, class_2338 p_220053_3_,
		class_3726 p_220053_4_) {
		return AllShapes.PUMP.get(state.method_11654(FACING));
	}

	@Override
	public void method_9612(class_2680 state, class_1937 world, class_2338 pos, class_2248 otherBlock, class_2338 neighborPos,
		boolean isMoving) {
		class_4209.method_19472(world, pos);
		class_2350 d = FluidPropagator.validateNeighbourChange(state, world, pos, otherBlock, neighborPos, isMoving);
		if (d == null)
			return;
		if (!isOpenAt(state, d))
			return;
		world.method_39280(pos, this, 1, class_1953.field_9310);
	}

	@Override
	public class_3610 method_9545(class_2680 state) {
		return state.method_11654(class_2741.field_12508) ? class_3612.field_15910.method_15729(false)
			: class_3612.field_15906.method_15785();
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		builder.method_11667(class_2741.field_12508);
		super.method_9515(builder);
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 direction, class_2680 neighbourState, class_1936 world,
		class_2338 pos, class_2338 neighbourPos) {
		if (state.method_11654(class_2741.field_12508))
			world.method_39281(pos, class_3612.field_15910, class_3612.field_15910.method_15789(world));
		return state;
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2680 toPlace = super.method_9605(context);
		class_1937 level = context.method_8045();
		class_2338 pos = context.method_8037();
		class_1657 player = context.method_8036();
		toPlace = ProperWaterloggedBlock.withWater(level, toPlace, pos);

		class_2350 nearestLookingDirection = context.method_7715();
		class_2350 targetDirection = context.method_8036() != null && context.method_8036()
			.method_5715() ? nearestLookingDirection : nearestLookingDirection.method_10153();
		class_2350 bestConnectedDirection = null;
		double bestDistance = Double.MAX_VALUE;

		for (class_2350 d : Iterate.directions) {
			class_2338 adjPos = pos.method_10093(d);
			class_2680 adjState = level.method_8320(adjPos);
			if (!FluidPipeBlock.canConnectTo(level, adjPos, adjState, d))
				continue;
			double distance = class_243.method_24954(d.method_10163())
				.method_1022(class_243.method_24954(targetDirection.method_10163()));
			if (distance > bestDistance)
				continue;
			bestDistance = distance;
			bestConnectedDirection = d;
		}

		if (bestConnectedDirection == null)
			return toPlace;
		if (bestConnectedDirection.method_10166() == targetDirection.method_10166())
			return toPlace;
		if (player.method_5715() && bestConnectedDirection.method_10166() != targetDirection.method_10166())
			return toPlace;

		return toPlace.method_11657(FACING, bestConnectedDirection);
	}

	public static boolean isPump(class_2680 state) {
		return state.method_26204() instanceof PumpBlock;
	}

	@Override
	public void method_9615(class_2680 state, class_1937 world, class_2338 pos, class_2680 oldState, boolean isMoving) {
		super.method_9615(state, world, pos, oldState, isMoving);
		if (world.field_9236)
			return;
		if (state != oldState)
			world.method_39280(pos, this, 1, class_1953.field_9310);

		if (isPump(state) && isPump(oldState) && state.method_11654(FACING) == oldState.method_11654(FACING)
			.method_10153()) {
			class_2586 blockEntity = world.method_8321(pos);
			if (!(blockEntity instanceof PumpBlockEntity))
				return;
			PumpBlockEntity pump = (PumpBlockEntity) blockEntity;
			pump.pressureUpdate = true;
		}
	}

	public static boolean isOpenAt(class_2680 state, class_2350 d) {
		return d.method_10166() == state.method_11654(FACING)
			.method_10166();
	}

	@Override
	public void method_9588(class_2680 state, class_3218 world, class_2338 pos, class_5819 r) {
		FluidPropagator.propagateChangedPipe(world, pos, state);
	}

	@Override
	public void method_9536(class_2680 state, class_1937 world, class_2338 pos, class_2680 newState, boolean isMoving) {
		boolean blockTypeChanged = !state.method_27852(newState.method_26204());
		if (blockTypeChanged && !world.field_9236)
			FluidPropagator.propagateChangedPipe(world, pos, state);
		super.method_9536(state, world, pos, newState, isMoving);
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	@Override
	public Class<PumpBlockEntity> getBlockEntityClass() {
		return PumpBlockEntity.class;
	}

	@Override
	public class_2591<? extends PumpBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.MECHANICAL_PUMP.get();
	}

}
