package com.simibubi.create.content.fluids.spout;

import java.util.List;
import java.util.Optional;
import java.util.function.Predicate;
import net.minecraft.class_1263;
import net.minecraft.class_1799;
import net.minecraft.class_1860;
import net.minecraft.class_1937;
import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.content.fluids.transfer.FillingRecipe;
import com.simibubi.create.content.fluids.transfer.GenericItemFilling;
import com.simibubi.create.content.processing.sequenced.SequencedAssemblyRecipe;
import com.simibubi.create.foundation.fluid.FluidIngredient;

import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandlerContainer;
import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;

public class FillingBySpout {

	private static final class_1263 WRAPPER = new ItemStackHandlerContainer(1);

	public static boolean canItemBeFilled(class_1937 world, class_1799 stack) {
		WRAPPER.method_5447(0, stack);

		Optional<FillingRecipe> assemblyRecipe =
			SequencedAssemblyRecipe.getRecipe(world, WRAPPER, AllRecipeTypes.FILLING.getType(), FillingRecipe.class);
		if (assemblyRecipe.isPresent())
			return true;

		if (AllRecipeTypes.FILLING.find(WRAPPER, world)
			.isPresent())
			return true;
		return GenericItemFilling.canItemBeFilled(world, stack);
	}

	public static long getRequiredAmountForItem(class_1937 world, class_1799 stack, FluidStack availableFluid) {
		WRAPPER.method_5447(0, stack);

		Optional<FillingRecipe> assemblyRecipe = SequencedAssemblyRecipe.getRecipe(world, WRAPPER,
			AllRecipeTypes.FILLING.getType(), FillingRecipe.class, matchItemAndFluid(world, availableFluid));
		if (assemblyRecipe.isPresent()) {
			FluidIngredient requiredFluid = assemblyRecipe.get()
				.getRequiredFluid();
			if (requiredFluid.test(availableFluid))
				return requiredFluid.getRequiredAmount();
		}

		for (class_1860<class_1263> recipe : world.method_8433()
			.method_17877(AllRecipeTypes.FILLING.getType(), WRAPPER, world)) {
			FillingRecipe fillingRecipe = (FillingRecipe) recipe;
			FluidIngredient requiredFluid = fillingRecipe.getRequiredFluid();
			if (requiredFluid.test(availableFluid))
				return requiredFluid.getRequiredAmount();
		}
		return GenericItemFilling.getRequiredAmountForItem(world, stack, availableFluid);
	}

	public static class_1799 fillItem(class_1937 world, long requiredAmount, class_1799 stack, FluidStack availableFluid) {
		FluidStack toFill = availableFluid.copy();
		toFill.setAmount(requiredAmount);

		WRAPPER.method_5447(0, stack);

		FillingRecipe fillingRecipe = SequencedAssemblyRecipe
			.getRecipe(world, WRAPPER, AllRecipeTypes.FILLING.getType(), FillingRecipe.class,
				matchItemAndFluid(world, availableFluid))
			.filter(fr -> fr.getRequiredFluid()
					.test(toFill))
				.orElseGet(() -> {
					for (class_1860<class_1263> recipe : world.method_8433()
						.method_17877(AllRecipeTypes.FILLING.getType(), WRAPPER, world)) {
						FillingRecipe fr = (FillingRecipe) recipe;
						FluidIngredient requiredFluid = fr.getRequiredFluid();
						if (requiredFluid.test(toFill))
							return fr;
					}
					return null;
				});

		if (fillingRecipe != null) {
			List<class_1799> results = fillingRecipe.rollResults();
			availableFluid.shrink(requiredAmount);
			stack.method_7934(1);
			return results.isEmpty() ? class_1799.field_8037 : results.get(0);
		}

		return GenericItemFilling.fillItem(world, requiredAmount, stack, availableFluid);
	}

	private static Predicate<FillingRecipe> matchItemAndFluid(class_1937 world, FluidStack availableFluid) {
		return r -> r.method_8115(WRAPPER, world) && r.getRequiredFluid()
			.test(availableFluid);
	}

}
