package com.simibubi.create.content.fluids.transfer;

import java.util.List;
import java.util.Set;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.compat.recipeViewerCommon.SequencedAssemblySubCategoryType;
import com.simibubi.create.content.processing.recipe.ProcessingRecipe;
import com.simibubi.create.content.processing.recipe.ProcessingRecipeBuilder.ProcessingRecipeParams;
import com.simibubi.create.content.processing.sequenced.IAssemblyRecipe;
import com.simibubi.create.foundation.fluid.FluidIngredient;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;

import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;
import io.github.fabricators_of_create.porting_lib.util.FluidUtil;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1263;
import net.minecraft.class_1856;
import net.minecraft.class_1935;
import net.minecraft.class_1937;
import net.minecraft.class_2561;
import net.minecraft.class_3611;

public class FillingRecipe extends ProcessingRecipe<class_1263> implements IAssemblyRecipe {

	public FillingRecipe(ProcessingRecipeParams params) {
		super(AllRecipeTypes.FILLING, params);
	}

	@Override
	public boolean method_8115(class_1263 inv, class_1937 p_77569_2_) {
		return ingredients.get(0)
				.method_8093(inv.method_5438(0));
	}

	@Override
	protected int getMaxInputCount() {
		return 1;
	}

	@Override
	protected int getMaxOutputCount() {
		return 1;
	}

	@Override
	protected int getMaxFluidInputCount() {
		return 1;
	}

	public FluidIngredient getRequiredFluid() {
		if (fluidIngredients.isEmpty())
			throw new IllegalStateException("Filling Recipe: " + id.toString() + " has no fluid ingredient!");
		return fluidIngredients.get(0);
	}

	@Override
	public void addAssemblyIngredients(List<class_1856> list) {
	}

	@Override
	public void addAssemblyFluidIngredients(List<FluidIngredient> list) {
		list.add(getRequiredFluid());
	}

	@Override
	@Environment(EnvType.CLIENT)
	public class_2561 getDescriptionForAssembly() {
		List<FluidStack> matchingFluidStacks = fluidIngredients.get(0).getMatchingFluidStacks();

		if (matchingFluidStacks.size() == 0)
			return Components.literal("Invalid");

		class_3611 fluid = matchingFluidStacks.get(0).getFluid();
		String translationKey = FluidUtil.getTranslationKey(fluid);
		return Lang.translateDirect("recipe.assembly.spout_filling_fluid", class_2561.method_43471(translationKey).getString());
	}

	@Override
	public void addRequiredMachines(Set<class_1935> list) {
		list.add(AllBlocks.SPOUT.get());
	}

	@Override
	public SequencedAssemblySubCategoryType getJEISubCategory() {
		return SequencedAssemblySubCategoryType.SPOUTING;
	}

}
