package com.simibubi.create.content.fluids.transfer;

import java.util.List;
import java.util.Optional;

import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.content.fluids.potion.PotionFluidHandler;
import com.simibubi.create.foundation.utility.Pair;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandlerContainer;
import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;
import net.fabricmc.fabric.api.transfer.v1.context.ContainerItemContext;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidConstants;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidStorage;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.Storage;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_1263;
import net.minecraft.class_1799;
import net.minecraft.class_1812;
import net.minecraft.class_1860;
import net.minecraft.class_1937;

public class GenericItemEmptying {

	private static final class_1263 WRAPPER = new ItemStackHandlerContainer(1);

	public static boolean canItemBeEmptied(class_1937 world, class_1799 stack) {
		if (stack.method_7909() instanceof class_1812)
			return true;

		WRAPPER.method_5447(0, stack);
		if (AllRecipeTypes.EMPTYING.find(WRAPPER, world)
			.isPresent())
			return true;

		return TransferUtil.getFluidContained(stack).isPresent();
	}

	public static Pair<FluidStack, class_1799> emptyItem(class_1937 world, class_1799 stack, boolean simulate) {
		FluidStack resultingFluid = FluidStack.EMPTY;
		class_1799 resultingItem = class_1799.field_8037;

		if (stack.method_7909() instanceof class_1812)
			return PotionFluidHandler.emptyPotion(stack, simulate);

		WRAPPER.method_5447(0, stack);
		Optional<class_1860<class_1263>> recipe = AllRecipeTypes.EMPTYING.find(WRAPPER, world);
		if (recipe.isPresent()) {
			EmptyingRecipe emptyingRecipe = (EmptyingRecipe) recipe.get();
			List<class_1799> results = emptyingRecipe.rollResults();
			if (!simulate)
				stack.method_7934(1);
			resultingItem = results.isEmpty() ? class_1799.field_8037 : results.get(0);
			resultingFluid = emptyingRecipe.getResultingFluid();
			return Pair.of(resultingFluid, resultingItem);
		}

		class_1799 split = stack.method_7972();
		split.method_7939(1);
		ContainerItemContext ctx = ContainerItemContext.withConstant(split);
		Storage<FluidVariant> tank = FluidStorage.ITEM.find(split, ctx);
		if (tank == null)
			return Pair.of(resultingFluid, resultingItem);
		try (Transaction t = TransferUtil.getTransaction()) {
			resultingFluid = TransferUtil.extractAnyFluid(tank, FluidConstants.BUCKET);
			resultingItem = ctx.getItemVariant().toStack((int) ctx.getAmount());
			if (!simulate) {
				stack.method_7934(1);
				t.commit();
			}

			return Pair.of(resultingFluid, resultingItem);
		}
	}

}
