package com.simibubi.create.content.kinetics.base;

import com.simibubi.create.content.contraptions.ITransformableBlock;
import com.simibubi.create.content.contraptions.StructureTransform;
import com.simibubi.create.foundation.utility.Iterate;
import net.minecraft.class_1750;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2470;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2746;
import net.minecraft.class_4538;

public abstract class DirectionalAxisKineticBlock extends DirectionalKineticBlock implements ITransformableBlock {

	public static final class_2746 AXIS_ALONG_FIRST_COORDINATE = class_2746.method_11825("axis_along_first");

	public DirectionalAxisKineticBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		builder.method_11667(AXIS_ALONG_FIRST_COORDINATE);
		super.method_9515(builder);
	}

	protected class_2350 getFacingForPlacement(class_1750 context) {
		class_2350 facing = context.method_7715()
			.method_10153();
		if (context.method_8036() != null && context.method_8036()
			.method_5715())
			facing = facing.method_10153();
		return facing;
	}

	protected boolean getAxisAlignmentForPlacement(class_1750 context) {
		return context.method_8042()
			.method_10166() == class_2351.field_11048;
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2350 facing = getFacingForPlacement(context);
		class_2338 pos = context.method_8037();
		class_1937 world = context.method_8045();
		boolean alongFirst = false;
		class_2351 faceAxis = facing.method_10166();

		if (faceAxis.method_10179()) {
			alongFirst = faceAxis == class_2351.field_11051;
			class_2350 positivePerpendicular = faceAxis == class_2351.field_11048 ? class_2350.field_11035 : class_2350.field_11034;

			boolean shaftAbove = prefersConnectionTo(world, pos, class_2350.field_11036, true);
			boolean shaftBelow = prefersConnectionTo(world, pos, class_2350.field_11033, true);
			boolean preferLeft = prefersConnectionTo(world, pos, positivePerpendicular, false);
			boolean preferRight = prefersConnectionTo(world, pos, positivePerpendicular.method_10153(), false);

			if (shaftAbove || shaftBelow || preferLeft || preferRight)
				alongFirst = faceAxis == class_2351.field_11048;
		}

		if (faceAxis.method_10178()) {
			alongFirst = getAxisAlignmentForPlacement(context);
			class_2350 prefferedSide = null;

			for (class_2350 side : Iterate.horizontalDirections) {
				if (!prefersConnectionTo(world, pos, side, true)
					&& !prefersConnectionTo(world, pos, side.method_10170(), false))
					continue;
				if (prefferedSide != null && prefferedSide.method_10166() != side.method_10166()) {
					prefferedSide = null;
					break;
				}
				prefferedSide = side;
			}

			if (prefferedSide != null)
				alongFirst = prefferedSide.method_10166() == class_2351.field_11048;
		}

		return this.method_9564()
			.method_11657(FACING, facing)
			.method_11657(AXIS_ALONG_FIRST_COORDINATE, alongFirst);
	}

	protected boolean prefersConnectionTo(class_4538 reader, class_2338 pos, class_2350 facing, boolean shaftAxis) {
		if (!shaftAxis)
			return false;
		class_2338 neighbourPos = pos.method_10093(facing);
		class_2680 blockState = reader.method_8320(neighbourPos);
		class_2248 block = blockState.method_26204();
		return block instanceof IRotate
			&& ((IRotate) block).hasShaftTowards(reader, neighbourPos, blockState, facing.method_10153());
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		class_2351 pistonAxis = state.method_11654(FACING)
			.method_10166();
		boolean alongFirst = state.method_11654(AXIS_ALONG_FIRST_COORDINATE);

		if (pistonAxis == class_2351.field_11048)
			return alongFirst ? class_2351.field_11052 : class_2351.field_11051;
		if (pistonAxis == class_2351.field_11052)
			return alongFirst ? class_2351.field_11048 : class_2351.field_11051;
		if (pistonAxis == class_2351.field_11051)
			return alongFirst ? class_2351.field_11048 : class_2351.field_11052;

		throw new IllegalStateException("Unknown axis??");
	}

	@Override
	public class_2680 method_9598(class_2680 state, class_2470 rot) {
		if (rot.ordinal() % 2 == 1)
			state = state.method_28493(AXIS_ALONG_FIRST_COORDINATE);
		return super.method_9598(state, rot);
	}

	@Override
	public class_2680 transform(class_2680 state, StructureTransform transform) {
		if (transform.mirror != null) {
			state = method_9569(state, transform.mirror);
		}

		if (transform.rotationAxis == class_2350.class_2351.field_11052) {
			return method_9598(state, transform.rotation);
		}

		class_2350 newFacing = transform.rotateFacing(state.method_11654(FACING));
		if (transform.rotationAxis == newFacing.method_10166() && transform.rotation.ordinal() % 2 == 1) {
			state = state.method_28493(AXIS_ALONG_FIRST_COORDINATE);
		}
		return state.method_11657(FACING, newFacing);
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return face.method_10166() == getRotationAxis(state);
	}

}
