package com.simibubi.create.content.kinetics.base;

import com.jozufozu.flywheel.api.Material;
import com.jozufozu.flywheel.api.MaterialManager;
import com.jozufozu.flywheel.backend.instancing.blockentity.BlockEntityInstance;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.kinetics.base.flwdata.RotatingData;
import com.simibubi.create.content.kinetics.simpleRelays.ICogWheel;
import com.simibubi.create.content.kinetics.simpleRelays.ShaftBlock;
import com.simibubi.create.foundation.render.AllMaterialSpecs;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2680;

public abstract class KineticBlockEntityInstance<T extends KineticBlockEntity> extends BlockEntityInstance<T> {

	protected final class_2350.class_2351 axis;

	public KineticBlockEntityInstance(MaterialManager materialManager, T blockEntity) {
		super(materialManager, blockEntity);
		axis = (blockState.method_26204() instanceof IRotate irotate) ? irotate.getRotationAxis(blockState) : class_2351.field_11052;
	}

	protected final void updateRotation(RotatingData instance) {
		updateRotation(instance, getRotationAxis(), getBlockEntitySpeed());
	}

	protected final void updateRotation(RotatingData instance, class_2350.class_2351 axis) {
		updateRotation(instance, axis, getBlockEntitySpeed());
	}

	protected final void updateRotation(RotatingData instance, float speed) {
		updateRotation(instance, getRotationAxis(), speed);
	}

	protected final void updateRotation(RotatingData instance, class_2350.class_2351 axis, float speed) {
		instance.setRotationAxis(axis)
			.setRotationOffset(getRotationOffset(axis))
			.setRotationalSpeed(speed)
			.setColor(blockEntity);
	}

	protected final RotatingData setup(RotatingData key) {
		return setup(key, getRotationAxis(), getBlockEntitySpeed());
	}

	protected final RotatingData setup(RotatingData key, class_2350.class_2351 axis) {
		return setup(key, axis, getBlockEntitySpeed());
	}

	protected final RotatingData setup(RotatingData key, float speed) {
		return setup(key, getRotationAxis(), speed);
	}

	protected final RotatingData setup(RotatingData key, class_2350.class_2351 axis, float speed) {
		key.setRotationAxis(axis)
			.setRotationalSpeed(speed)
			.setRotationOffset(getRotationOffset(axis))
			.setColor(blockEntity)
			.setPosition(getInstancePosition());

		return key;
	}

	protected float getRotationOffset(final class_2350.class_2351 axis) {
		float offset = ICogWheel.isLargeCog(blockState) ? 11.25f : 0;
		double d = (((axis == class_2350.class_2351.field_11048) ? 0 : pos.method_10263()) + ((axis == class_2350.class_2351.field_11052) ? 0 : pos.method_10264())
			+ ((axis == class_2350.class_2351.field_11051) ? 0 : pos.method_10260())) % 2;
		if (d == 0) {
			offset = 22.5f;
		}
		return offset;
	}

	protected class_2350.class_2351 getRotationAxis() {
		return axis;
	}

	protected float getBlockEntitySpeed() {
		return blockEntity.getSpeed();
	}

	protected class_2680 shaft() {
		return shaft(getRotationAxis());
	}

	protected Material<RotatingData> getRotatingMaterial() {
		return materialManager.defaultSolid()
			.material(AllMaterialSpecs.ROTATING);
	}

	public static class_2680 shaft(class_2350.class_2351 axis) {
		return AllBlocks.SHAFT.getDefaultState()
			.method_11657(ShaftBlock.AXIS, axis);
	}
}
