package com.simibubi.create.content.kinetics.base.flwdata;

import org.joml.Quaternionf;

import com.simibubi.create.foundation.block.render.SpriteShiftEntry;
import net.minecraft.class_1058;

public class BeltData extends KineticData {
    float qX;
    float qY;
    float qZ;
    float qW;
    float sourceU;
    float sourceV;
    float minU;
    float minV;
    float maxU;
    float maxV;
    byte scrollMult;

    public BeltData setRotation(Quaternionf q) {
        this.qX = q.x();
        this.qY = q.y();
        this.qZ = q.z();
        this.qW = q.w();
        markDirty();
        return this;
    }

    public BeltData setScrollTexture(SpriteShiftEntry spriteShift) {
        class_1058 source = spriteShift.getOriginal();
        class_1058 target = spriteShift.getTarget();

        this.sourceU = source.method_4594();
        this.sourceV = source.method_4593();
        this.minU = target.method_4594();
        this.minV = target.method_4593();
        this.maxU = target.method_4577();
        this.maxV = target.method_4575();
        markDirty();

		return this;
	}

	public BeltData setScrollMult(float scrollMult) {
		this.scrollMult = (byte) (scrollMult * 127);
		markDirty();
		return this;
	}

}
