package com.simibubi.create.content.kinetics.belt;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import io.github.fabricators_of_create.porting_lib.tags.Tags;

import org.apache.commons.lang3.mutable.MutableBoolean;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.Create;
import com.simibubi.create.content.contraptions.ITransformableBlock;
import com.simibubi.create.content.contraptions.StructureTransform;
import com.simibubi.create.content.equipment.armor.DivingBootsItem;
import com.simibubi.create.content.fluids.transfer.GenericItemEmptying;
import com.simibubi.create.content.kinetics.base.HorizontalKineticBlock;
import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.content.kinetics.belt.BeltBlockEntity.CasingType;
import com.simibubi.create.content.kinetics.belt.BeltSlicer.Feedback;
import com.simibubi.create.content.kinetics.belt.behaviour.TransportedItemStackHandlerBehaviour.TransportedResult;
import com.simibubi.create.content.kinetics.belt.transport.BeltMovementHandler.TransportedEntityInfo;
import com.simibubi.create.content.kinetics.belt.transport.BeltTunnelInteractionHandler;
import com.simibubi.create.content.logistics.funnel.FunnelBlock;
import com.simibubi.create.content.logistics.tunnel.BeltTunnelBlock;
import com.simibubi.create.content.schematics.requirement.ISpecialBlockItemRequirement;
import com.simibubi.create.content.schematics.requirement.ItemRequirement;
import com.simibubi.create.content.schematics.requirement.ItemRequirement.ItemUseType;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.block.ProperWaterloggedBlock;
import com.simibubi.create.foundation.block.render.MultiPosDestructionHandler;
import com.simibubi.create.foundation.block.render.ReducedDestroyEffects;
import com.simibubi.create.foundation.utility.Iterate;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.util.TagUtil;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.block.BlockPickInteractionAware;
import net.fabricmc.fabric.api.registry.LandPathNodeTypesRegistry;
import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.Storage;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_10;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1297;
import net.minecraft.class_1542;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_181;
import net.minecraft.class_1838;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_238;
import net.minecraft.class_239;
import net.minecraft.class_2464;
import net.minecraft.class_2470;
import net.minecraft.class_2586;
import net.minecraft.class_259;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_2754;
import net.minecraft.class_2769;
import net.minecraft.class_2891;
import net.minecraft.class_3218;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_3727;
import net.minecraft.class_3965;
import net.minecraft.class_4538;
import net.minecraft.class_638;
import net.minecraft.class_7;
import net.minecraft.class_8567;

public class BeltBlock extends HorizontalKineticBlock
	implements IBE<BeltBlockEntity>, ISpecialBlockItemRequirement, ITransformableBlock, ProperWaterloggedBlock,
		BlockPickInteractionAware, ReducedDestroyEffects, MultiPosDestructionHandler {

	public static final class_2769<BeltSlope> SLOPE = class_2754.method_11850("slope", BeltSlope.class);
	public static final class_2769<BeltPart> PART = class_2754.method_11850("part", BeltPart.class);
	public static final class_2746 CASING = class_2746.method_11825("casing");

	public BeltBlock(class_2251 properties) {
		super(properties);
		method_9590(method_9564().method_11657(SLOPE, BeltSlope.HORIZONTAL)
			.method_11657(PART, BeltPart.START)
			.method_11657(CASING, false)
			.method_11657(WATERLOGGED, false));
		LandPathNodeTypesRegistry.register(this, class_7.field_21, null);
	}

	@Override
	protected boolean areStatesKineticallyEquivalent(class_2680 oldState, class_2680 newState) {
		return super.areStatesKineticallyEquivalent(oldState, newState)
			&& oldState.method_11654(PART) == newState.method_11654(PART);
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		if (face.method_10166() != getRotationAxis(state))
			return false;
		return getBlockEntityOptional(world, pos).map(BeltBlockEntity::hasPulley)
			.orElse(false);
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		if (state.method_11654(SLOPE) == BeltSlope.SIDEWAYS)
			return class_2351.field_11052;
		return state.method_11654(HORIZONTAL_FACING)
			.method_10170()
			.method_10166();
	}

	@Override
	public class_1799 getPickedStack(class_2680 state, class_1922 world, class_2338 pos,
		class_1657 player, class_239 target) {
		return AllItems.BELT_CONNECTOR.asStack();
	}

	@SuppressWarnings("deprecation")
	@Override
	public List<class_1799> method_9560(class_2680 state, class_8567.class_8568 builder) {
		List<class_1799> drops = super.method_9560(state, builder);
		class_2586 blockEntity = builder.method_51876(class_181.field_1228);
		if (blockEntity instanceof BeltBlockEntity && ((BeltBlockEntity) blockEntity).hasPulley())
			drops.addAll(AllBlocks.SHAFT.getDefaultState()
				.method_26189(builder));
		return drops;
	}

	@Override
	public void method_9565(class_2680 state, class_3218 worldIn, class_2338 pos, class_1799 p_220062_4_, boolean b) {
		BeltBlockEntity controllerBE = BeltHelper.getControllerBE(worldIn, pos);
		if (controllerBE != null)
			controllerBE.getInventory()
				.ejectAll();
	}

//	@Override
//	public boolean isFlammable(BlockState state, BlockGetter world, BlockPos pos, Direction face) {
//		return false;
//	}

	@Override
	public void method_9502(class_1922 worldIn, class_1297 entityIn) {
		super.method_9502(worldIn, entityIn);
		class_2338 entityPosition = entityIn.method_24515();
		class_2338 beltPos = null;

		if (AllBlocks.BELT.has(worldIn.method_8320(entityPosition)))
			beltPos = entityPosition;
		else if (AllBlocks.BELT.has(worldIn.method_8320(entityPosition.method_10074())))
			beltPos = entityPosition.method_10074();
		if (beltPos == null)
			return;
		if (!(worldIn instanceof class_1937))
			return;

		method_9548(worldIn.method_8320(beltPos), (class_1937) worldIn, beltPos, entityIn);
	}

	@Override
	public void method_9548(class_2680 state, class_1937 worldIn, class_2338 pos, class_1297 entityIn) {
		if (!canTransportObjects(state))
			return;
		if (entityIn instanceof class_1657) {
			class_1657 player = (class_1657) entityIn;
			if (player.method_5715())
				return;
			if (player.method_31549().field_7479)
				return;
		}

		if (DivingBootsItem.isWornBy(entityIn))
			return;

		BeltBlockEntity belt = BeltHelper.getSegmentBE(worldIn, pos);
		if (belt == null)
			return;
		if (entityIn instanceof class_1542 && entityIn.method_5805()) {
			if (worldIn.field_9236)
				return;
			if (entityIn.method_18798().field_1351 > 0)
				return;
			if (!entityIn.method_5805())
				return;
			if (BeltTunnelInteractionHandler.getTunnelOnPosition(worldIn, pos) != null)
				return;
			withBlockEntityDo(worldIn, pos, be -> {
				class_1542 itemEntity = (class_1542) entityIn;
				Storage<ItemVariant> handler = be.getItemStorage(null);
				if (handler == null)
					return;
				class_1799 inEntity = itemEntity.method_6983();
				try (Transaction t = TransferUtil.getTransaction()) {
					long inserted = handler.insert(ItemVariant.of(inEntity), inEntity.method_7947(), t);
					if (inserted == 0)
						return;
					if (inEntity.method_7947() == inserted) {
						itemEntity.method_31472();
					} else {
						inEntity.method_7934((int) inserted);
					}
					t.commit();
				}
			});
			return;
		}

		BeltBlockEntity controller = BeltHelper.getControllerBE(worldIn, pos);
		if (controller == null || controller.passengers == null)
			return;
		if (controller.passengers.containsKey(entityIn)) {
			TransportedEntityInfo info = controller.passengers.get(entityIn);
			if (info.getTicksSinceLastCollision() != 0 || pos.equals(entityIn.method_24515()))
				info.refresh(pos, state);
		} else {
			controller.passengers.put(entityIn, new TransportedEntityInfo(pos, state));
			entityIn.method_24830(true);
		}
	}

	public static boolean canTransportObjects(class_2680 state) {
		if (!AllBlocks.BELT.has(state))
			return false;
		BeltSlope slope = state.method_11654(SLOPE);
		return slope != BeltSlope.VERTICAL && slope != BeltSlope.SIDEWAYS;
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 handIn,
		class_3965 hit) {
		if (player.method_5715() || !player.method_7294())
			return class_1269.field_5811;
		class_1799 heldItem = player.method_5998(handIn);

		boolean isWrench = AllItems.WRENCH.isIn(heldItem);
		boolean isConnector = AllItems.BELT_CONNECTOR.isIn(heldItem);
		boolean isShaft = AllBlocks.SHAFT.isIn(heldItem);
		boolean isDye = heldItem.method_31573(Tags.Items.DYES);
		boolean hasWater = GenericItemEmptying.emptyItem(world, heldItem, true)
			.getFirst()
			.getFluid()
			.method_15780(class_3612.field_15910);
		boolean isHand = heldItem.method_7960() && handIn == class_1268.field_5808;

		if (isDye || hasWater)
			return onBlockEntityUse(world, pos,
				be -> be.applyColor(TagUtil.getColorFromStack(heldItem)) ? class_1269.field_5812 : class_1269.field_5811);

		if (isConnector)
			return BeltSlicer.useConnector(state, world, pos, player, handIn, hit, new Feedback());
		if (isWrench)
			return BeltSlicer.useWrench(state, world, pos, player, handIn, hit, new Feedback());

		BeltBlockEntity belt = BeltHelper.getSegmentBE(world, pos);
		if (belt == null)
			return class_1269.field_5811;

		if (isHand) {
			BeltBlockEntity controllerBelt = belt.getControllerBE();
			if (controllerBelt == null)
				return class_1269.field_5811;
			if (world.field_9236)
				return class_1269.field_5812;
			MutableBoolean success = new MutableBoolean(false);
			controllerBelt.getInventory()
				.applyToEachWithin(belt.index + .5f, .55f, (transportedItemStack) -> {
					player.method_31548()
						.method_7398(transportedItemStack.stack);
					success.setTrue();
					return TransportedResult.removeItem();
				});
			if (success.isTrue())
				world.method_8396(null, pos, class_3417.field_15197, class_3419.field_15248, .2f,
					1f + Create.RANDOM.nextFloat());
		}

		if (isShaft) {
			if (state.method_11654(PART) != BeltPart.MIDDLE)
				return class_1269.field_5811;
			if (world.field_9236)
				return class_1269.field_5812;
			if (!player.method_7337())
				heldItem.method_7934(1);
			KineticBlockEntity.switchToBlockState(world, pos, state.method_11657(PART, BeltPart.PULLEY));
			return class_1269.field_5812;
		}

		if (AllBlocks.BRASS_CASING.isIn(heldItem)) {
			withBlockEntityDo(world, pos, be -> be.setCasingType(CasingType.BRASS));
			updateCoverProperty(world, pos, world.method_8320(pos));
			return class_1269.field_5812;
		}

		if (AllBlocks.ANDESITE_CASING.isIn(heldItem)) {
			withBlockEntityDo(world, pos, be -> be.setCasingType(CasingType.ANDESITE));
			updateCoverProperty(world, pos, world.method_8320(pos));
			return class_1269.field_5812;
		}

		return class_1269.field_5811;
	}

	@Override
	public class_1269 onWrenched(class_2680 state, class_1838 context) {
		class_1937 world = context.method_8045();
		class_1657 player = context.method_8036();
		class_2338 pos = context.method_8037();

		if (state.method_11654(CASING)) {
			if (world.field_9236)
				return class_1269.field_5812;
			withBlockEntityDo(world, pos, be -> be.setCasingType(CasingType.NONE));
			return class_1269.field_5812;
		}

		if (state.method_11654(PART) == BeltPart.PULLEY) {
			if (world.field_9236)
				return class_1269.field_5812;
			KineticBlockEntity.switchToBlockState(world, pos, state.method_11657(PART, BeltPart.MIDDLE));
			if (player != null && !player.method_7337())
				player.method_31548()
					.method_7398(AllBlocks.SHAFT.asStack());
			return class_1269.field_5812;
		}

		return class_1269.field_5811;
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		builder.method_11667(SLOPE, PART, CASING, WATERLOGGED);
		super.method_9515(builder);
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return BeltShapes.getShape(state);
	}

	@Override
	public class_265 method_9549(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		if (state.method_26204() != this)
			return class_259.method_1073();

		class_265 shape = method_9530(state, worldIn, pos, context);
		if (!(context instanceof class_3727))
			return shape;

		return getBlockEntityOptional(worldIn, pos).map(be -> {
			class_1297 entity = ((class_3727) context).method_32480();
			if (entity == null)
				return shape;

			BeltBlockEntity controller = be.getControllerBE();
			if (controller == null)
				return shape;
			if (controller.passengers == null || !controller.passengers.containsKey(entity))
				return BeltShapes.getCollisionShape(state);
			return shape;

		})
			.orElse(shape);
	}

	@Override
	public class_2464 method_9604(class_2680 state) {
		return state.method_11654(CASING) ? class_2464.field_11458 : class_2464.field_11456;
	}

	public static void initBelt(class_1937 world, class_2338 pos) {
		if (world.field_9236)
			return;
		if (world instanceof class_3218 && ((class_3218) world).method_14178()
			.method_12129() instanceof class_2891)
			return;

		class_2680 state = world.method_8320(pos);
		if (!AllBlocks.BELT.has(state))
			return;
		// Find controller
		int limit = 1000;
		class_2338 currentPos = pos;
		while (limit-- > 0) {
			class_2680 currentState = world.method_8320(currentPos);
			if (!AllBlocks.BELT.has(currentState)) {
				world.method_22352(pos, true);
				return;
			}
			class_2338 nextSegmentPosition = nextSegmentPosition(currentState, currentPos, false);
			if (nextSegmentPosition == null)
				break;
			if (!world.method_8477(nextSegmentPosition))
				return;
			currentPos = nextSegmentPosition;
		}

		// Init belts
		int index = 0;
		List<class_2338> beltChain = getBeltChain(world, currentPos);
		if (beltChain.size() < 2) {
			world.method_22352(currentPos, true);
			return;
		}

		for (class_2338 beltPos : beltChain) {
			class_2586 blockEntity = world.method_8321(beltPos);
			class_2680 currentState = world.method_8320(beltPos);

			if (blockEntity instanceof BeltBlockEntity && AllBlocks.BELT.has(currentState)) {
				BeltBlockEntity be = (BeltBlockEntity) blockEntity;
				be.setController(currentPos);
				be.beltLength = beltChain.size();
				be.index = index;
				be.attachKinetics();
				be.method_5431();
				be.sendData();

				if (be.isController() && !canTransportObjects(currentState))
					be.getInventory()
						.ejectAll();
			} else {
				world.method_22352(currentPos, true);
				return;
			}
			index++;
		}

	}

	@Override
	public void method_9536(class_2680 state, class_1937 world, class_2338 pos, class_2680 newState, boolean isMoving) {
		super.method_9536(state, world, pos, newState, isMoving);

		if (world.field_9236)
			return;
		if (state.method_26204() == newState.method_26204())
			return;
		if (isMoving)
			return;

		// Destroy chain
		for (boolean forward : Iterate.trueAndFalse) {
			class_2338 currentPos = nextSegmentPosition(state, pos, forward);
			if (currentPos == null)
				continue;
			class_2680 currentState = world.method_8320(currentPos);
			if (!AllBlocks.BELT.has(currentState))
				continue;

			boolean hasPulley = false;
			class_2586 blockEntity = world.method_8321(currentPos);
			if (blockEntity instanceof BeltBlockEntity) {
				BeltBlockEntity belt = (BeltBlockEntity) blockEntity;
				if (belt.isController())
					belt.getInventory()
						.ejectAll();

				hasPulley = belt.hasPulley();
			}

			world.method_8544(currentPos);
			class_2680 shaftState = AllBlocks.SHAFT.getDefaultState()
				.method_11657(class_2741.field_12496, getRotationAxis(currentState));
			world.method_8652(currentPos, ProperWaterloggedBlock.withWater(world,
				hasPulley ? shaftState : class_2246.field_10124.method_9564(), currentPos), 3);
			world.method_20290(2001, currentPos, class_2248.method_9507(currentState));
		}
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 side, class_2680 p_196271_3_, class_1936 world,
		class_2338 pos, class_2338 p_196271_6_) {
		updateWater(world, state, pos);
		if (side.method_10166()
			.method_10179())
			updateTunnelConnections(world, pos.method_10084());
		if (side == class_2350.field_11036)
			updateCoverProperty(world, pos, state);
		return state;
	}

	public void updateCoverProperty(class_1936 world, class_2338 pos, class_2680 state) {
		if (world.method_8608())
			return;
		if (state.method_11654(CASING) && state.method_11654(SLOPE) == BeltSlope.HORIZONTAL)
			withBlockEntityDo(world, pos, bbe -> bbe.setCovered(isBlockCoveringBelt(world, pos.method_10084())));
	}

	public static boolean isBlockCoveringBelt(class_1936 world, class_2338 pos) {
		class_2680 blockState = world.method_8320(pos);
		class_265 collisionShape = blockState.method_26220(world, pos);
		if (collisionShape.method_1110())
			return false;
		class_238 bounds = collisionShape.method_1107();
		if (bounds.method_17939() < .5f || bounds.method_17941() < .5f)
			return false;
		if (bounds.field_1322 > 0)
			return false;
		if (AllBlocks.CRUSHING_WHEEL_CONTROLLER.has(blockState))
			return false;
		if (FunnelBlock.isFunnel(blockState) && FunnelBlock.getFunnelFacing(blockState) != class_2350.field_11036)
			return false;
		if (blockState.method_26204() instanceof BeltTunnelBlock)
			return false;
		return true;
	}

	private void updateTunnelConnections(class_1936 world, class_2338 pos) {
		class_2248 tunnelBlock = world.method_8320(pos)
			.method_26204();
		if (tunnelBlock instanceof BeltTunnelBlock)
			((BeltTunnelBlock) tunnelBlock).updateTunnel(world, pos);
	}

	public static List<class_2338> getBeltChain(class_1937 world, class_2338 controllerPos) {
		List<class_2338> positions = new LinkedList<>();

		class_2680 blockState = world.method_8320(controllerPos);
		if (!AllBlocks.BELT.has(blockState))
			return positions;

		int limit = 1000;
		class_2338 current = controllerPos;
		while (limit-- > 0 && current != null) {
			class_2680 state = world.method_8320(current);
			if (!AllBlocks.BELT.has(state))
				break;
			positions.add(current);
			current = nextSegmentPosition(state, current, true);
		}

		return positions;
	}

	public static class_2338 nextSegmentPosition(class_2680 state, class_2338 pos, boolean forward) {
		class_2350 direction = state.method_11654(HORIZONTAL_FACING);
		BeltSlope slope = state.method_11654(SLOPE);
		BeltPart part = state.method_11654(PART);

		int offset = forward ? 1 : -1;

		if (part == BeltPart.END && forward || part == BeltPart.START && !forward)
			return null;
		if (slope == BeltSlope.VERTICAL)
			return pos.method_10086(direction.method_10171() == class_2352.field_11056 ? offset : -offset);
		pos = pos.method_10079(direction, offset);
		if (slope != BeltSlope.HORIZONTAL && slope != BeltSlope.SIDEWAYS)
			return pos.method_10086(slope == BeltSlope.UPWARD ? offset : -offset);
		return pos;
	}

	@Override
	public Class<BeltBlockEntity> getBlockEntityClass() {
		return BeltBlockEntity.class;
	}

	@Override
	public class_2591<? extends BeltBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.BELT.get();
	}

	@Override
	public ItemRequirement getRequiredItems(class_2680 state, class_2586 be) {
		List<class_1799> required = new ArrayList<>();
		if (state.method_11654(PART) != BeltPart.MIDDLE)
			required.add(AllBlocks.SHAFT.asStack());
		if (state.method_11654(PART) == BeltPart.START)
			required.add(AllItems.BELT_CONNECTOR.asStack());
		if (required.isEmpty())
			return ItemRequirement.NONE;
		return new ItemRequirement(ItemUseType.CONSUME, required);
	}

	@Override
	public class_2680 method_9598(class_2680 state, class_2470 rot) {
		class_2680 rotate = super.method_9598(state, rot);

		if (state.method_11654(SLOPE) != BeltSlope.VERTICAL)
			return rotate;
		if (state.method_11654(HORIZONTAL_FACING)
			.method_10171() != rotate.method_11654(HORIZONTAL_FACING)
				.method_10171()) {
			if (state.method_11654(PART) == BeltPart.START)
				return rotate.method_11657(PART, BeltPart.END);
			if (state.method_11654(PART) == BeltPart.END)
				return rotate.method_11657(PART, BeltPart.START);
		}

		return rotate;
	}

	public class_2680 transform(class_2680 state, StructureTransform transform) {
		if (transform.mirror != null) {
			state = method_9569(state, transform.mirror);
		}

		if (transform.rotationAxis == class_2350.class_2351.field_11052) {
			return method_9598(state, transform.rotation);
		}
		return transformInner(state, transform);
	}

	protected class_2680 transformInner(class_2680 state, StructureTransform transform) {
		boolean halfTurn = transform.rotation == class_2470.field_11464;

		class_2350 initialDirection = state.method_11654(HORIZONTAL_FACING);
		boolean diagonal =
			state.method_11654(SLOPE) == BeltSlope.DOWNWARD || state.method_11654(SLOPE) == BeltSlope.UPWARD;

		if (!diagonal) {
			for (int i = 0; i < transform.rotation.ordinal(); i++) {
				class_2350 direction = state.method_11654(HORIZONTAL_FACING);
				BeltSlope slope = state.method_11654(SLOPE);
				boolean vertical = slope == BeltSlope.VERTICAL;
				boolean horizontal = slope == BeltSlope.HORIZONTAL;
				boolean sideways = slope == BeltSlope.SIDEWAYS;

				class_2350 newDirection = direction.method_10153();
				BeltSlope newSlope = BeltSlope.VERTICAL;

				if (vertical) {
					if (direction.method_10166() == transform.rotationAxis) {
						newDirection = direction.method_10160();
						newSlope = BeltSlope.SIDEWAYS;
					} else {
						newSlope = BeltSlope.HORIZONTAL;
						newDirection = direction;
						if (direction.method_10166() == class_2351.field_11051)
							newDirection = direction.method_10153();
					}
				}

				if (sideways) {
					newDirection = direction;
					if (direction.method_10166() == transform.rotationAxis)
						newSlope = BeltSlope.HORIZONTAL;
					else
						newDirection = direction.method_10160();
				}

				if (horizontal) {
					newDirection = direction;
					if (direction.method_10166() == transform.rotationAxis)
						newSlope = BeltSlope.SIDEWAYS;
					else if (direction.method_10166() != class_2351.field_11051)
						newDirection = direction.method_10153();
				}

				state = state.method_11657(HORIZONTAL_FACING, newDirection);
				state = state.method_11657(SLOPE, newSlope);
			}

		} else if (initialDirection.method_10166() != transform.rotationAxis) {
			for (int i = 0; i < transform.rotation.ordinal(); i++) {
				class_2350 direction = state.method_11654(HORIZONTAL_FACING);
				class_2350 newDirection = direction.method_10153();
				BeltSlope slope = state.method_11654(SLOPE);
				boolean upward = slope == BeltSlope.UPWARD;
				boolean downward = slope == BeltSlope.DOWNWARD;

				// Rotate diagonal
				if (direction.method_10171() == class_2352.field_11056 ^ downward ^ direction.method_10166() == class_2351.field_11051) {
					state = state.method_11657(SLOPE, upward ? BeltSlope.DOWNWARD : BeltSlope.UPWARD);
				} else {
					state = state.method_11657(HORIZONTAL_FACING, newDirection);
				}
			}

		} else if (halfTurn) {
			class_2350 direction = state.method_11654(HORIZONTAL_FACING);
			class_2350 newDirection = direction.method_10153();
			BeltSlope slope = state.method_11654(SLOPE);
			boolean vertical = slope == BeltSlope.VERTICAL;

			if (diagonal) {
				state = state.method_11657(SLOPE, slope == BeltSlope.UPWARD ? BeltSlope.DOWNWARD
					: slope == BeltSlope.DOWNWARD ? BeltSlope.UPWARD : slope);
			} else if (vertical) {
				state = state.method_11657(HORIZONTAL_FACING, newDirection);
			}
		}

		return state;
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	@Override
	public class_3610 method_9545(class_2680 pState) {
		return fluidState(pState);
	}

//	public static class RenderProperties extends ReducedDestroyEffects implements MultiPosDestructionHandler {
		@Override
		@Environment(EnvType.CLIENT)
		public Set<class_2338> getExtraPositions(class_638 level, class_2338 pos, class_2680 blockState, int progress) {
			class_2586 blockEntity = level.method_8321(pos);
			if (blockEntity instanceof BeltBlockEntity belt) {
				return new HashSet<>(BeltBlock.getBeltChain(level, belt.getController()));
			}
			return null;
		}
//	}

}
