package com.simibubi.create.content.kinetics.belt.transport;

import com.simibubi.create.content.kinetics.belt.BeltHelper;
import com.simibubi.create.content.kinetics.crusher.CrushingWheelControllerBlock;
import com.simibubi.create.content.kinetics.crusher.CrushingWheelControllerBlockEntity;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemHandlerHelper;
import io.github.fabricators_of_create.porting_lib.util.ItemStackUtil;

import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_3532;

public class BeltCrusherInteractionHandler {

    public static boolean checkForCrushers(BeltInventory beltInventory, TransportedItemStack currentItem,
                                           float nextOffset) {

        boolean beltMovementPositive = beltInventory.beltMovementPositive;
        int firstUpcomingSegment = (int) Math.floor(currentItem.beltPosition);
        int step = beltMovementPositive ? 1 : -1;
        firstUpcomingSegment = class_3532.method_15340(firstUpcomingSegment, 0, beltInventory.belt.beltLength - 1);

        for (int segment = firstUpcomingSegment; beltMovementPositive ? segment <= nextOffset
                : segment + 1 >= nextOffset; segment += step) {
            class_2338 crusherPos = BeltHelper.getPositionForOffset(beltInventory.belt, segment)
                    .method_10084();
            class_1937 world = beltInventory.belt.method_10997();
            class_2680 crusherState = world.method_8320(crusherPos);
            if (!(crusherState.method_26204() instanceof CrushingWheelControllerBlock))
                continue;
            class_2350 crusherFacing = crusherState.method_11654(CrushingWheelControllerBlock.field_10927);
            class_2350 movementFacing = beltInventory.belt.getMovementFacing();
            if (crusherFacing != movementFacing)
                continue;

            float crusherEntry = segment + .5f;
            crusherEntry += .399f * (beltMovementPositive ? -1 : 1);
            float postCrusherEntry = crusherEntry + .799f * (!beltMovementPositive ? -1 : 1);

            boolean hasCrossed = nextOffset > crusherEntry && nextOffset < postCrusherEntry && beltMovementPositive
                    || nextOffset < crusherEntry && nextOffset > postCrusherEntry && !beltMovementPositive;
            if (!hasCrossed)
                return false;
            currentItem.beltPosition = crusherEntry;

            class_2586 be = world.method_8321(crusherPos);
            if (!(be instanceof CrushingWheelControllerBlockEntity))
                return true;

            CrushingWheelControllerBlockEntity crusherBE = (CrushingWheelControllerBlockEntity) be;

            class_1799 toInsert = currentItem.stack.method_7972();
			try (Transaction t = TransferUtil.getTransaction()) {
				long inserted = crusherBE.inventory.insert(ItemVariant.of(toInsert), toInsert.method_7947(), t);
				t.commit();
				class_1799 remainder = ItemHandlerHelper.copyStackWithSize(toInsert, toInsert.method_7947() - (int) inserted);
				if (class_1799.method_7973(toInsert, remainder))
					return true;

				int notFilled = currentItem.stack.method_7947() - toInsert.method_7947();
				if (!remainder.method_7960()) {
					remainder.method_7933(notFilled);
				} else if (notFilled > 0)
					remainder = ItemHandlerHelper.copyStackWithSize(currentItem.stack, notFilled);

				currentItem.stack = remainder;
				beltInventory.belt.sendData();
				return true;
			}
        }

        return false;
    }


}
