package com.simibubi.create.content.kinetics.belt.transport;

import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.base.SingleSlotStorage;
import net.fabricmc.fabric.api.transfer.v1.transaction.TransactionContext;
import net.minecraft.class_1799;

public class ItemHandlerBeltSegment implements SingleSlotStorage<ItemVariant> {
	private final BeltInventory beltInventory;
	int offset;

	public ItemHandlerBeltSegment(BeltInventory beltInventory, int offset) {
		this.beltInventory = beltInventory;
		this.offset = offset;
	}

	@Override
	public long insert(ItemVariant resource, long maxAmount, TransactionContext transaction) {
		if (this.beltInventory.canInsertAt(offset)) {
			int toInsert = Math.min((int) maxAmount, resource.getItem().method_7882());
			TransportedItemStack newStack = new TransportedItemStack(resource.toStack(toInsert));
			newStack.insertedAt = offset;
			newStack.beltPosition = offset + .5f + (beltInventory.beltMovementPositive ? -1 : 1) / 16f;
			newStack.prevBeltPosition = newStack.beltPosition;
			this.beltInventory.toInsertSnapshotParticipant.updateSnapshots(transaction);
			this.beltInventory.addItem(newStack);
			return toInsert;
		}
		return 0;
	}

	@Override
	public long extract(ItemVariant resource, long maxAmount, TransactionContext transaction) {
		TransportedItemStack transported = this.beltInventory.getStackAtOffset(offset);
		// since actual removal occurs a tick later, it's possible to extract a removed item
		if (transported == null || beltInventory.toRemove.contains(transported))
			return 0;

		int toExtract = (int) Math.min(maxAmount, transported.stack.method_7947());
		this.beltInventory.itemsSnapshotParticipant.updateSnapshots(transaction);
		transported.stack.method_7934(toExtract);
		return toExtract;
	}

	@Override
	public boolean isResourceBlank() {
		return getResource().isBlank();
	}

	@Override
	public ItemVariant getResource() {
		return ItemVariant.of(getStack());
	}

	@Override
	public long getAmount() {
		class_1799 stack = getStack();
		return stack.method_7960() ? 0 : stack.method_7947();
	}

	@Override
	public long getCapacity() {
		return getStack().method_7914();
	}

	public class_1799 getStack() {
		TransportedItemStack transported = this.beltInventory.getStackAtOffset(offset);
		if (transported == null)
			return class_1799.field_8037;
		return transported.stack.method_7960() ? class_1799.field_8037 : transported.stack;
	}
}
