package com.simibubi.create.content.kinetics.chainDrive;

import java.util.function.BiFunction;
import net.minecraft.class_2248;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2680;
import com.simibubi.create.content.kinetics.chainDrive.ChainDriveBlock.Part;
import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;

public class ChainDriveGenerator extends SpecialBlockStateGen {

	private BiFunction<class_2680, String, ModelFile> modelFunc;

	public ChainDriveGenerator(BiFunction<class_2680, String, ModelFile> modelFunc) {
		this.modelFunc = modelFunc;
	}

	@Override
	protected int getXRotation(class_2680 state) {
		ChainDriveBlock.Part part = state.method_11654(ChainDriveBlock.PART);
		boolean connectedAlongFirst = state.method_11654(ChainDriveBlock.CONNECTED_ALONG_FIRST_COORDINATE);
		class_2351 axis = state.method_11654(ChainDriveBlock.AXIS);

		if (part == Part.NONE)
			return axis == class_2351.field_11052 ? 90 : 0;
		if (axis == class_2351.field_11048)
			return (connectedAlongFirst ? 90 : 0) + (part == Part.START ? 180 : 0);
		if (axis == class_2351.field_11051)
			return (connectedAlongFirst ? 0 : (part == Part.START ? 270 : 90));
		return 0;
	}

	@Override
	protected int getYRotation(class_2680 state) {
		ChainDriveBlock.Part part = state.method_11654(ChainDriveBlock.PART);
		boolean connectedAlongFirst = state.method_11654(ChainDriveBlock.CONNECTED_ALONG_FIRST_COORDINATE);
		class_2351 axis = state.method_11654(ChainDriveBlock.AXIS);

		if (part == Part.NONE)
			return axis == class_2351.field_11048 ? 90 : 0;
		if (axis == class_2351.field_11051)
			return (connectedAlongFirst && part == Part.END ? 270 : 90);
		boolean flip = part == Part.END && !connectedAlongFirst || part == Part.START && connectedAlongFirst;
		if (axis == class_2351.field_11052)
			return (connectedAlongFirst ? 90 : 0) + (flip ? 180 : 0);
		return 0;
	}

	@Override
	public <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> ctx, RegistrateBlockstateProvider prov,
		class_2680 state) {
		return modelFunc.apply(state, getModelSuffix(state));
	}

	protected String getModelSuffix(class_2680 state) {
		ChainDriveBlock.Part part = state.method_11654(ChainDriveBlock.PART);
		class_2351 axis = state.method_11654(ChainDriveBlock.AXIS);

		if (part == Part.NONE)
			return "single";

		String orientation = axis == class_2351.field_11052 ? "vertical" : "horizontal";
		String section = part == Part.MIDDLE ? "middle" : "end";
		return section + "_" + orientation;
	}

}
