package com.simibubi.create.content.kinetics.crafter;

import static com.simibubi.create.content.kinetics.base.HorizontalKineticBlock.HORIZONTAL_FACING;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllSpriteShifts;
import com.simibubi.create.foundation.block.connected.CTSpriteShiftEntry;
import com.simibubi.create.foundation.block.connected.ConnectedTextureBehaviour;
import net.minecraft.class_1058;
import net.minecraft.class_1920;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_2680;

public class CrafterCTBehaviour extends ConnectedTextureBehaviour.Base {

	@Override
	public boolean connectsTo(class_2680 state, class_2680 other, class_1920 reader, class_2338 pos, class_2338 otherPos,
		class_2350 face) {
		if (state.method_26204() != other.method_26204())
			return false;
		if (state.method_11654(HORIZONTAL_FACING) != other.method_11654(HORIZONTAL_FACING))
			return false;
		return CrafterHelper.areCraftersConnected(reader, pos, otherPos);
	}

	@Override
	protected boolean reverseUVs(class_2680 state, class_2350 direction) {
		if (!direction.method_10166()
			.method_10178())
			return false;
		class_2350 facing = state.method_11654(HORIZONTAL_FACING);
		if (facing.method_10166() == direction.method_10166())
			return false;

		boolean isNegative = facing.method_10171() == class_2352.field_11060;
		if (direction == class_2350.field_11033 && facing.method_10166() == class_2351.field_11051)
			return !isNegative;
		return isNegative;
	}

	@Override
	public CTSpriteShiftEntry getShift(class_2680 state, class_2350 direction, @Nullable class_1058 sprite) {
		class_2350 facing = state.method_11654(HORIZONTAL_FACING);
		boolean isFront = facing.method_10166() == direction.method_10166();
		boolean isVertical = direction.method_10166()
			.method_10178();
		boolean facingX = facing.method_10166() == class_2351.field_11048;
		return isFront ? AllSpriteShifts.BRASS_CASING
			: isVertical && !facingX ? AllSpriteShifts.CRAFTER_OTHERSIDE : AllSpriteShifts.CRAFTER_SIDE;
	}

}
