package com.simibubi.create.content.kinetics.crafter;

import com.google.gson.JsonObject;
import com.simibubi.create.AllRecipeTypes;
import net.minecraft.class_1799;
import net.minecraft.class_1856;
import net.minecraft.class_1865;
import net.minecraft.class_1869;
import net.minecraft.class_1937;
import net.minecraft.class_2371;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import net.minecraft.class_3518;
import net.minecraft.class_3956;
import net.minecraft.class_7710;
import net.minecraft.class_8566;

public class MechanicalCraftingRecipe extends class_1869 {

	private boolean acceptMirrored;

	public MechanicalCraftingRecipe(class_2960 idIn, String groupIn, int recipeWidthIn, int recipeHeightIn,
		class_2371<class_1856> recipeItemsIn, class_1799 recipeOutputIn, boolean acceptMirrored) {
		super(idIn, groupIn, class_7710.field_40251, recipeWidthIn, recipeHeightIn, recipeItemsIn, recipeOutputIn);
		this.acceptMirrored = acceptMirrored;
	}

	private static MechanicalCraftingRecipe fromShaped(class_1869 recipe, boolean acceptMirrored) {
		return new MechanicalCraftingRecipe(recipe.method_8114(), recipe.method_8112(), recipe.method_8150(), recipe.method_8158(),
			recipe.method_8117(), recipe.method_8110(null), acceptMirrored);
	}

	@Override
	public boolean method_17728(class_8566 inv, class_1937 worldIn) {
		if (!(inv instanceof MechanicalCraftingInventory))
			return false;
		if (acceptsMirrored())
			return super.method_17728(inv, worldIn);

		// From ShapedRecipe except the symmetry
		for (int i = 0; i <= inv.method_17398() - this.method_8150(); ++i)
			for (int j = 0; j <= inv.method_17397() - this.method_8158(); ++j)
				if (this.matchesSpecific(inv, i, j))
					return true;
		return false;
	}

	// From ShapedRecipe
	private boolean matchesSpecific(class_8566 inv, int p_77573_2_, int p_77573_3_) {
		class_2371<class_1856> ingredients = method_8117();
		int width = method_8150();
		int height = method_8158();
		for (int i = 0; i < inv.method_17398(); ++i) {
			for (int j = 0; j < inv.method_17397(); ++j) {
				int k = i - p_77573_2_;
				int l = j - p_77573_3_;
				class_1856 ingredient = class_1856.field_9017;
				if (k >= 0 && l >= 0 && k < width && l < height)
					ingredient = ingredients.get(k + l * width);
				if (!ingredient.method_8093(inv.method_5438(i + j * inv.method_17398())))
					return false;
			}
		}
		return true;
	}

	@Override
	public class_3956<?> method_17716() {
		return AllRecipeTypes.MECHANICAL_CRAFTING.getType();
	}

	@Override
	public boolean method_8118() {
		return true;
	}

	@Override
	public class_1865<?> method_8119() {
		return AllRecipeTypes.MECHANICAL_CRAFTING.getSerializer();
	}

	public boolean acceptsMirrored() {
		return acceptMirrored;
	}

	public static class Serializer extends class_1869.class_1870 {

		@Override
		public class_1869 method_8121(class_2960 recipeId, JsonObject json) {
			return fromShaped(super.method_8164(recipeId, json), class_3518.method_15258(json, "acceptMirrored", true));
		}

		@Override
		public class_1869 method_8122(class_2960 recipeId, class_2540 buffer) {
			return fromShaped(super.method_8163(recipeId, buffer), buffer.readBoolean() && buffer.readBoolean());
		}

		@Override
		public void method_8165(class_2540 p_199427_1_, class_1869 p_199427_2_) {
			super.method_8165(p_199427_1_, p_199427_2_);
			if (p_199427_2_ instanceof MechanicalCraftingRecipe) {
				p_199427_1_.writeBoolean(true);
				p_199427_1_.writeBoolean(((MechanicalCraftingRecipe) p_199427_2_).acceptsMirrored());
			} else
				p_199427_1_.writeBoolean(false);
		}

	}

}
