package com.simibubi.create.content.kinetics.crank;

import com.jozufozu.flywheel.api.Instancer;
import com.jozufozu.flywheel.api.MaterialManager;
import com.jozufozu.flywheel.api.instance.DynamicInstance;
import com.jozufozu.flywheel.core.materials.model.ModelData;
import com.simibubi.create.content.kinetics.base.SingleRotatingInstance;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import net.minecraft.class_2350;
import net.minecraft.class_2741;

public class HandCrankInstance extends SingleRotatingInstance<HandCrankBlockEntity> implements DynamicInstance {

	private ModelData crank;
	private class_2350 facing;

	public HandCrankInstance(MaterialManager modelManager, HandCrankBlockEntity blockEntity) {
		super(modelManager, blockEntity);
		facing = blockState.method_11654(class_2741.field_12525);
		Instancer<ModelData> model = blockEntity.getRenderedHandleInstance(getTransformMaterial());
		crank = model.createInstance();
		rotateCrank();
	}

	@Override
	public void beginFrame() {
		if (crank == null)
			return;

		rotateCrank();
	}

	private void rotateCrank() {
		class_2350.class_2351 axis = facing.method_10166();
		float angle = blockEntity.getIndependentAngle(AnimationTickHolder.getPartialTicks());

		crank.loadIdentity()
			.translate(getInstancePosition())
			.centre()
			.rotate(class_2350.method_10156(class_2350.class_2352.field_11056, axis), angle)
			.unCentre();
	}

	@Override
	public void init() {
		if (blockEntity.shouldRenderShaft())
			super.init();
	}

	@Override
	public void remove() {
		if (blockEntity.shouldRenderShaft())
			super.remove();
		if (crank != null)
			crank.delete();
	}

	@Override
	public void update() {
		if (blockEntity.shouldRenderShaft())
			super.update();
	}

	@Override
	public void updateLight() {
		if (blockEntity.shouldRenderShaft())
			super.updateLight();
		if (crank != null)
			relight(pos, crank);
	}
}
