package com.simibubi.create.content.kinetics.crank;

import javax.annotation.ParametersAreNonnullByDefault;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllShapes;
import com.simibubi.create.foundation.utility.BlockHelper;
import com.simibubi.create.foundation.utility.Couple;

import io.github.fabricators_of_create.porting_lib.util.TagUtil;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1767;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3726;
import net.minecraft.class_3965;

@ParametersAreNonnullByDefault
public class ValveHandleBlock extends HandCrankBlock {

	private final class_1767 color;
	private final boolean inCreativeTab;

	public static ValveHandleBlock copper(class_2251 properties) {
		return new ValveHandleBlock(properties, null, true);
	}

	public static ValveHandleBlock dyed(class_2251 properties, class_1767 color) {
		return new ValveHandleBlock(properties, color, false);
	}

	private ValveHandleBlock(class_2251 properties, class_1767 color, boolean inCreativeTab) {
		super(properties);
		this.color = color;
		this.inCreativeTab = inCreativeTab;
	}

	@Override
	public class_265 method_9530(class_2680 pState, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return AllShapes.VALVE_HANDLE.get(pState.method_11654(FACING));
	}

	public static class_1269 onBlockActivated(class_1657 player, class_1937 level, class_1268 hand, class_3965 hit) {
		class_2338 pos = hit.method_17777();
		class_2680 blockState = level.method_8320(pos);

		if (!(blockState.method_26204() instanceof ValveHandleBlock vhb))
			return class_1269.field_5811;
		if (!player.method_7294())
			return class_1269.field_5811;
		if (AllItems.WRENCH.isIn(player.method_5998(hand)) && player.method_5715())
			return class_1269.field_5811;

		if (vhb.clicked(level, pos, blockState, player, hand)) {
			return class_1269.field_5812;
		}
		return class_1269.field_5811;
	}

	@Override
	public void method_9536(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_2680 pNewState, boolean pIsMoving) {
		if (!(pNewState.method_26204() instanceof ValveHandleBlock))
			super.method_9536(pState, pLevel, pPos, pNewState, pIsMoving);
	}

	public boolean clicked(class_1937 level, class_2338 pos, class_2680 blockState, class_1657 player, class_1268 hand) {
		class_1799 heldItem = player.method_5998(hand);
		class_1767 color = TagUtil.getColorFromStack(heldItem);
		if (color != null && color != this.color) {
			if (!level.field_9236)
				level.method_8501(pos,
					BlockHelper.copyProperties(blockState, AllBlocks.DYED_VALVE_HANDLES.get(color)
						.getDefaultState()));
			return true;
		}

		onBlockEntityUse(level, pos,
			hcbe -> (hcbe instanceof ValveHandleBlockEntity vhbe) && vhbe.activate(player.method_5715())
				? class_1269.field_5812
				: class_1269.field_5811);
		return true;
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand,
		class_3965 hit) {
		return class_1269.field_5811;
	}

	@Override
	public class_2591<? extends HandCrankBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.VALVE_HANDLE.get();
	}

	@Override
	public int getRotationSpeed() {
		return 32;
	}

	public static Couple<Integer> getSpeedRange() {
		return Couple.create(32, 32);
	}

}
