package com.simibubi.create.content.kinetics.crusher;

import java.util.Collection;
import java.util.List;
import net.minecraft.class_1282;
import net.minecraft.class_1309;
import net.minecraft.class_1542;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import com.simibubi.create.AllDamageTypes;
import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.foundation.advancement.AllAdvancements;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.utility.Iterate;

public class CrushingWheelBlockEntity extends KineticBlockEntity {
	public CrushingWheelBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
		setLazyTickRate(20);
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {
		super.addBehaviours(behaviours);
		registerAwardables(behaviours, AllAdvancements.CRUSHING_WHEEL, AllAdvancements.CRUSHER_MAXED);
	}

	@Override
	public void onSpeedChanged(float prevSpeed) {
		super.onSpeedChanged(prevSpeed);
		fixControllers();
	}

	public void fixControllers() {
		for (class_2350 d : Iterate.directions)
			((CrushingWheelBlock) method_11010().method_26204()).updateControllers(method_11010(), method_10997(), method_11016(),
					d);
	}

	@Override
	protected class_238 createRenderBoundingBox() {
		return new class_238(field_11867).method_1014(1);
	}

	@Override
	public void lazyTick() {
		super.lazyTick();
		fixControllers();
	}

	public static int crushingIsFortunate(class_1282 source, class_1309 target, int currentLevel, boolean recentlyHit) {
		if (source == null || !source.method_49708(AllDamageTypes.CRUSH))
			return 0;
		return 2;		//This does not currently increase mob drops. It seems like this only works for damage done by an entity.
	}

	public static boolean handleCrushedMobDrops(class_1309 target, class_1282 source, Collection<class_1542> drops, int lootingLevel, boolean recentlyHit) {
		if (source == null || !source.method_49708(AllDamageTypes.CRUSH))
			return false;
		class_243 outSpeed = class_243.field_1353;
		for (class_1542 outputItem : drops) {
			outputItem.method_18799(outSpeed);
		}
		return false;
	}

}
