package com.simibubi.create.content.kinetics.crusher;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllShapes;
import com.simibubi.create.foundation.advancement.AllAdvancements;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.item.ItemHelper;
import com.simibubi.create.foundation.utility.Iterate;

import io.github.fabricators_of_create.porting_lib.block.CustomRunningEffectsBlock;
import net.minecraft.class_10;
import net.minecraft.class_1267;
import net.minecraft.class_1297;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2318;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2398;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2586;
import net.minecraft.class_259;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_3726;
import net.minecraft.class_3727;
import net.minecraft.class_5819;

public class CrushingWheelControllerBlock extends class_2318 implements IBE<CrushingWheelControllerBlockEntity>, CustomRunningEffectsBlock {

	public CrushingWheelControllerBlock(class_2251 p_i48440_1_) {
		super(p_i48440_1_);
	}

	public static final class_2746 VALID = class_2746.method_11825("valid");

	@Override
	public boolean method_9616(class_2680 state, class_1750 useContext) {
		return false;
	}

	@Override
	public boolean addRunningEffects(class_2680 state, class_1937 world, class_2338 pos, class_1297 entity) {
		return true;
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		builder.method_11667(VALID);
		builder.method_11667(field_10927);
		super.method_9515(builder);
	}

	public void method_9548(class_2680 state, class_1937 worldIn, class_2338 pos, class_1297 entityIn) {
		if (!state.method_11654(VALID))
			return;

		class_2350 facing = state.method_11654(field_10927);
		class_2351 axis = facing.method_10166();

		checkEntityForProcessing(worldIn, pos, entityIn);

		withBlockEntityDo(worldIn, pos, be -> {
			if (be.processingEntity == entityIn)

				entityIn.method_5844(state, new class_243(axis == class_2351.field_11048 ? (double) 0.05F : 0.25D,
					axis == class_2351.field_11052 ? (double) 0.05F : 0.25D, axis == class_2351.field_11051 ? (double) 0.05F : 0.25D));
		});
	}

	public void checkEntityForProcessing(class_1937 worldIn, class_2338 pos, class_1297 entityIn) {
		CrushingWheelControllerBlockEntity be = getBlockEntity(worldIn, pos);
		if (be == null)
			return;
		if (be.crushingspeed == 0)
			return;
//		if (entityIn instanceof ItemEntity)
//			((ItemEntity) entityIn).setPickUpDelay(10);
		class_2487 data = entityIn.getCustomData();
		if (data.method_10545("BypassCrushingWheel")) {
			if (pos.equals(class_2512.method_10691(data.method_10562("BypassCrushingWheel"))))
				return;
		}
		if (be.isOccupied())
			return;
		boolean isPlayer = entityIn instanceof class_1657;
		if (isPlayer && ((class_1657) entityIn).method_7337())
			return;
		if (isPlayer && entityIn.method_37908().method_8407() == class_1267.field_5801)
			return;

		be.startCrushing(entityIn);
	}

	@Override
	public void method_9502(class_1922 worldIn, class_1297 entityIn) {
		super.method_9502(worldIn, entityIn);
		// Moved to onEntityCollision to allow for omnidirectional input
	}

	@Override
	public void method_9496(class_2680 stateIn, class_1937 worldIn, class_2338 pos, class_5819 rand) {
		if (!stateIn.method_11654(VALID))
			return;
		if (rand.method_43048(1) != 0)
			return;
		double d0 = (double) ((float) pos.method_10263() + rand.method_43057());
		double d1 = (double) ((float) pos.method_10264() + rand.method_43057());
		double d2 = (double) ((float) pos.method_10260() + rand.method_43057());
		worldIn.method_8406(class_2398.field_11205, d0, d1, d2, 0.0D, 0.0D, 0.0D);
	}

	@Override
	public class_2680 method_9559(class_2680 stateIn, class_2350 facing, class_2680 facingState, class_1936 worldIn,
		class_2338 currentPos, class_2338 facingPos) {
		updateSpeed(stateIn, worldIn, currentPos);
		return stateIn;
	}

	public void updateSpeed(class_2680 state, class_1936 world, class_2338 pos) {
		withBlockEntityDo(world, pos, be -> {
			if (!state.method_11654(VALID)) {
				if (be.crushingspeed != 0) {
					be.crushingspeed = 0;
					be.sendData();
				}
				return;
			}

			for (class_2350 d : Iterate.directions) {
				class_2680 neighbour = world.method_8320(pos.method_10093(d));
				if (!AllBlocks.CRUSHING_WHEEL.has(neighbour))
					continue;
				if (neighbour.method_11654(class_2741.field_12496) == d.method_10166())
					continue;
				class_2586 adjBE = world.method_8321(pos.method_10093(d));
				if (!(adjBE instanceof CrushingWheelBlockEntity cwbe))
					continue;
				be.crushingspeed = Math.abs(cwbe.getSpeed() / 50f);
				be.sendData();

				cwbe.award(AllAdvancements.CRUSHING_WHEEL);
				if (cwbe.getSpeed() > 255)
					cwbe.award(AllAdvancements.CRUSHER_MAXED);
				break;
			}
		});
	}

	@Override
	public class_265 method_9549(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		class_265 standardShape = AllShapes.CRUSHING_WHEEL_CONTROLLER_COLLISION.get(state.method_11654(field_10927));

		if (!state.method_11654(VALID))
			return standardShape;
		if (!(context instanceof class_3727))
			return standardShape;
		class_1297 entity = ((class_3727) context).method_32480();
		if (entity == null)
			return standardShape;

		class_2487 data = entity.getCustomData();
		if (data.method_10545("BypassCrushingWheel"))
			if (pos.equals(class_2512.method_10691(data.method_10562("BypassCrushingWheel"))))
				if (state.method_11654(field_10927) != class_2350.field_11036) // Allow output items to land on top of the block rather
															// than falling back through.
					return class_259.method_1073();

		CrushingWheelControllerBlockEntity be = getBlockEntity(worldIn, pos);
		if (be != null && be.processingEntity == entity)
			return class_259.method_1073();

		return standardShape;
	}

	@Override
	public void method_9536(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 newState, boolean isMoving) {
		if (!state.method_31709() || state.method_26204() == newState.method_26204())
			return;

		withBlockEntityDo(worldIn, pos, be -> ItemHelper.dropContents(worldIn, pos, be.inventory));
		worldIn.method_8544(pos);
	}

	@Override
	public Class<CrushingWheelControllerBlockEntity> getBlockEntityClass() {
		return CrushingWheelControllerBlockEntity.class;
	}

	@Override
	public class_2591<? extends CrushingWheelControllerBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.CRUSHING_WHEEL_CONTROLLER.get();
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

}
