package com.simibubi.create.content.kinetics.crusher;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.UUID;

import com.simibubi.create.AllDamageTypes;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.content.kinetics.belt.behaviour.DirectBeltInputBehaviour;
import com.simibubi.create.content.processing.recipe.ProcessingInventory;
import com.simibubi.create.content.processing.recipe.ProcessingRecipe;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.damageTypes.CreateDamageSources;
import com.simibubi.create.foundation.item.ItemHelper;
import com.simibubi.create.foundation.sound.SoundScapes;
import com.simibubi.create.foundation.sound.SoundScapes.AmbienceGroup;
import com.simibubi.create.foundation.utility.NBTHelper;
import com.simibubi.create.foundation.utility.VecHelper;
import com.simibubi.create.infrastructure.config.AllConfigs;

import io.github.fabricators_of_create.porting_lib.util.EnvExecutor;
import io.github.fabricators_of_create.porting_lib.util.ItemStackUtil;
import io.github.fabricators_of_create.porting_lib.util.NBTSerializer;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.Storage;
import net.fabricmc.fabric.api.transfer.v1.storage.base.SidedStorageBlockEntity;
import net.minecraft.class_1263;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1542;
import net.minecraft.class_1747;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_238;
import net.minecraft.class_2388;
import net.minecraft.class_2392;
import net.minecraft.class_2394;
import net.minecraft.class_2398;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_3532;
import net.minecraft.class_5819;

public class CrushingWheelControllerBlockEntity extends SmartBlockEntity implements SidedStorageBlockEntity {

	public class_1297 processingEntity;
	private UUID entityUUID;
	protected boolean searchForEntity;

	public ProcessingInventory inventory;
	public float crushingspeed;

	public CrushingWheelControllerBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
		inventory = new ProcessingInventory(this::itemInserted) {

			@Override
			public boolean isItemValid(int slot, ItemVariant stack) {
				return super.isItemValid(slot, stack) && processingEntity == null;
			}

		};
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {
		behaviours.add(new DirectBeltInputBehaviour(this).onlyInsertWhen(this::supportsDirectBeltInput));
	}

	private boolean supportsDirectBeltInput(class_2350 side) {
		class_2680 blockState = method_11010();
		if (blockState == null)
			return false;
		class_2350 direction = blockState.method_11654(CrushingWheelControllerBlock.field_10927);
		return direction == class_2350.field_11033 || direction == side;
	}

	@Override
	public void tick() {
		super.tick();
		if (searchForEntity) {
			searchForEntity = false;
			List<class_1297> search = field_11863.method_8333((class_1297) null, new class_238(method_11016()),
				e -> entityUUID.equals(e.method_5667()));
			if (search.isEmpty())
				clear();
			else
				processingEntity = search.get(0);
		}

		if (!isOccupied())
			return;
		if (crushingspeed == 0)
			return;

		if (field_11863.field_9236)
			EnvExecutor.runWhenOn(EnvType.CLIENT, () -> () -> this.tickAudio());

		float speed = crushingspeed * 4;

		class_243 centerPos = VecHelper.getCenterOf(field_11867);
		class_2350 facing = method_11010().method_11654(CrushingWheelControllerBlock.field_10927);
		int offset = facing.method_10171()
			.method_10181();
		class_243 outSpeed = new class_243((facing.method_10166() == class_2351.field_11048 ? 0.25D : 0.0D) * offset,
			offset == 1 ? (facing.method_10166() == class_2351.field_11052 ? 0.5D : 0.0D) : 0.0D // Increased upwards speed so upwards
																			// crushing wheels shoot out the item
																			// properly.
			, (facing.method_10166() == class_2351.field_11051 ? 0.25D : 0.0D) * offset); // No downwards speed, so downwards crushing wheels
																		// drop the items as before.
		class_243 outPos = centerPos.method_1031((facing.method_10166() == class_2351.field_11048 ? .55f * offset : 0f),
			(facing.method_10166() == class_2351.field_11052 ? .55f * offset : 0f), (facing.method_10166() == class_2351.field_11051 ? .55f * offset : 0f));

		if (!hasEntity()) {

			float processingSpeed =
				class_3532.method_15363((speed) / (!inventory.appliedRecipe ? class_3532.method_15351(inventory.getStackInSlot(0)
					.method_7947()) : 1), .25f, 20);
			inventory.remainingTime -= processingSpeed;
			spawnParticles(inventory.getStackInSlot(0));

			if (field_11863.field_9236)
				return;

			if (inventory.remainingTime < 20 && !inventory.appliedRecipe) {
				applyRecipe();
				inventory.appliedRecipe = true;
				field_11863.method_8413(field_11867, method_11010(), method_11010(), 2 | 16);
				return;
			}

			if (inventory.remainingTime > 0) {
				return;
			}
			inventory.remainingTime = 0;

			// Output Items
			if (facing != class_2350.field_11036) {
				class_2338 nextPos = field_11867.method_10069(facing.method_10166() == class_2351.field_11048 ? 1 * offset : 0, -1,
					facing.method_10166() == class_2351.field_11051 ? 1 * offset : 0);
				DirectBeltInputBehaviour behaviour =
					BlockEntityBehaviour.get(field_11863, nextPos, DirectBeltInputBehaviour.TYPE);
				if (behaviour != null) {
					boolean changed = false;
					if (!behaviour.canInsertFromSide(facing))
						return;
					for (int slot = 0; slot < inventory.getSlotCount(); slot++) {
						class_1799 stack = inventory.getStackInSlot(slot);
						if (stack.method_7960())
							continue;
						class_1799 remainder = behaviour.handleInsertion(stack, facing, false);
						if (class_1799.method_7973(stack, remainder))
							continue;
						inventory.setStackInSlot(slot, remainder);
						changed = true;
					}
					if (changed) {
						method_5431();
						sendData();
					}
					return;
				}
			}

			// Eject Items
			for (int slot = 0; slot < inventory.getSlotCount(); slot++) {
				class_1799 stack = inventory.getStackInSlot(slot);
				if (stack.method_7960())
					continue;
				class_1542 entityIn = new class_1542(field_11863, outPos.field_1352, outPos.field_1351, outPos.field_1350, stack);
				entityIn.method_18799(outSpeed);
				entityIn.getCustomData()
					.method_10566("BypassCrushingWheel", class_2512.method_10692(field_11867));
				field_11863.method_8649(entityIn);
			}
			inventory.clear();
			field_11863.method_8413(field_11867, method_11010(), method_11010(), 2 | 16);

			return;
		}

		if (!processingEntity.method_5805() || !processingEntity.method_5829()
			.method_994(new class_238(field_11867).method_1014(.5f))) {
			clear();
			return;
		}

		double xMotion = ((field_11867.method_10263() + .5f) - processingEntity.method_23317()) / 2f;
		double zMotion = ((field_11867.method_10260() + .5f) - processingEntity.method_23321()) / 2f;
		if (processingEntity.method_5715())
			xMotion = zMotion = 0;
		double movement = Math.max(-speed / 4f, -.5f) * -offset;
		processingEntity.method_18799(
			new class_243(facing.method_10166() == class_2351.field_11048 ? movement : xMotion, facing.method_10166() == class_2351.field_11052 ? movement : 0f // Do
																														// not
																														// move
																														// entities
																														// upwards
																														// or
																														// downwards
																														// for
																														// horizontal
																														// crushers,
				, facing.method_10166() == class_2351.field_11051 ? movement : zMotion)); // Or they'll only get their feet crushed.

		if (field_11863.field_9236)
			return;

		if (!(processingEntity instanceof class_1542)) {
			class_243 entityOutPos = outPos.method_1031(facing.method_10166() == class_2351.field_11048 ? .5f * offset : 0f,
				facing.method_10166() == class_2351.field_11052 ? .5f * offset : 0f, facing.method_10166() == class_2351.field_11051 ? .5f * offset : 0f);
			int crusherDamage = AllConfigs.server().kinetics.crushingDamage.get();

			if (processingEntity instanceof class_1309) {
				if ((((class_1309) processingEntity).method_6032() - crusherDamage <= 0) // Takes LivingEntity instances
																							// as exception, so it can
																							// move them before it would
																							// kill them.
					&& (((class_1309) processingEntity).field_6235 <= 0)) { // This way it can actually output the items
																			// to the right spot.
					processingEntity.method_5814(entityOutPos.field_1352, entityOutPos.field_1351, entityOutPos.field_1350);
				}
			}
			processingEntity.method_5643(CreateDamageSources.crush(field_11863), crusherDamage);
			if (!processingEntity.method_5805()) {
				processingEntity.method_5814(entityOutPos.field_1352, entityOutPos.field_1351, entityOutPos.field_1350);
			}
			return;
		}

		class_1542 itemEntity = (class_1542) processingEntity;
		itemEntity.method_6982(20);
		if (facing.method_10166() == class_2351.field_11052) {
			if (processingEntity.method_23318() * -offset < (centerPos.field_1351 - .25f) * -offset) {
				intakeItem(itemEntity);
			}
		} else if (facing.method_10166() == class_2351.field_11051) {
			if (processingEntity.method_23321() * -offset < (centerPos.field_1350 - .25f) * -offset) {
				intakeItem(itemEntity);
			}
		} else {
			if (processingEntity.method_23317() * -offset < (centerPos.field_1352 - .25f) * -offset) {
				intakeItem(itemEntity);
			}
		}
	}

	@Environment(EnvType.CLIENT)
	public void tickAudio() {
		float pitch = class_3532.method_15363((crushingspeed / 256f) + .45f, .85f, 1f);
		if (entityUUID == null && inventory.getStackInSlot(0)
			.method_7960())
			return;
		SoundScapes.play(AmbienceGroup.CRUSHING, field_11867, pitch);
	}

	private void intakeItem(class_1542 itemEntity) {
		inventory.clear();
		inventory.setStackInSlot(0, itemEntity.method_6983()
			.method_7972());
		itemInserted(inventory.getStackInSlot(0));
		itemEntity.method_31472();
		field_11863.method_8413(field_11867, method_11010(), method_11010(), 2 | 16);
	}

	protected void spawnParticles(class_1799 stack) {
		if (stack == null || stack.method_7960())
			return;

		class_2394 particleData = null;
		if (stack.method_7909() instanceof class_1747)
			particleData = new class_2388(class_2398.field_11217, ((class_1747) stack.method_7909()).method_7711()
				.method_9564());
		else
			particleData = new class_2392(class_2398.field_11218, stack);

		class_5819 r = field_11863.field_9229;
		for (int i = 0; i < 4; i++)
			field_11863.method_8406(particleData, field_11867.method_10263() + r.method_43057(), field_11867.method_10264() + r.method_43057(),
				field_11867.method_10260() + r.method_43057(), 0, 0, 0);
	}

	private void applyRecipe() {
		Optional<ProcessingRecipe<class_1263>> recipe = findRecipe();

		List<class_1799> list = new ArrayList<>();
		if (recipe.isPresent()) {
			int rolls = inventory.getStackInSlot(0)
				.method_7947();
			inventory.clear();
			for (int roll = 0; roll < rolls; roll++) {
				List<class_1799> rolledResults = recipe.get()
					.rollResults();
				for (int i = 0; i < rolledResults.size(); i++) {
					class_1799 stack = rolledResults.get(i);
					ItemHelper.addToList(stack, list);
				}
			}
			for (int slot = 0; slot < list.size() && slot + 1 < inventory.getSlotCount(); slot++)
				inventory.setStackInSlot(slot + 1, list.get(slot));
		} else {
			inventory.clear();
		}

	}

	public Optional<ProcessingRecipe<class_1263>> findRecipe() {
		Optional<ProcessingRecipe<class_1263>> crushingRecipe = AllRecipeTypes.CRUSHING.find(inventory, field_11863);
		if (!crushingRecipe.isPresent())
			crushingRecipe = AllRecipeTypes.MILLING.find(inventory, field_11863);
		return crushingRecipe;
	}

	@Override
	public void write(class_2487 compound, boolean clientPacket) {
		if (hasEntity())
			compound.method_10566("Entity", class_2512.method_25929(entityUUID));
		compound.method_10566("Inventory", NBTSerializer.serializeNBT(inventory));
		compound.method_10548("Speed", crushingspeed);
		super.write(compound, clientPacket);
	}

	@Override
	protected void read(class_2487 compound, boolean clientPacket) {
		super.read(compound, clientPacket);
		if (compound.method_10545("Entity") && !isOccupied()) {
			entityUUID = class_2512.method_25930(NBTHelper.getINBT(compound, "Entity"));
			this.searchForEntity = true;
		}
		crushingspeed = compound.method_10583("Speed");
		inventory.deserializeNBT(compound.method_10562("Inventory"));
	}

	public void startCrushing(class_1297 entity) {
		processingEntity = entity;
		entityUUID = entity.method_5667();
	}

	private void itemInserted(class_1799 stack) {
		Optional<ProcessingRecipe<class_1263>> recipe = findRecipe();
		inventory.remainingTime = recipe.isPresent() ? recipe.get()
			.getProcessingDuration() : 100;
		inventory.appliedRecipe = false;
	}

	@Nullable
	@Override
	public Storage<ItemVariant> getItemStorage(@Nullable class_2350 face) {
		return inventory;
	}

	public void clear() {
		processingEntity = null;
		entityUUID = null;
	}

	public boolean isOccupied() {
		return hasEntity() || !inventory.method_5442();
	}

	public boolean hasEntity() {
		return processingEntity != null;
	}

}
