package com.simibubi.create.content.kinetics.deployer;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import javax.annotation.Nullable;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.common.accessor.BucketItemAccessor;

import org.apache.commons.lang3.tuple.Pair;

import com.google.common.collect.Multimap;
import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.AllTags.AllItemTags;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.content.contraptions.mounted.CartAssemblerBlockItem;
import com.simibubi.create.content.equipment.sandPaper.SandPaperItem;
import com.simibubi.create.content.kinetics.belt.behaviour.TransportedItemStackHandlerBehaviour;
import com.simibubi.create.content.kinetics.deployer.DeployerBlockEntity.Mode;
import com.simibubi.create.content.trains.track.ITrackBlock;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.utility.BlockHelper;
import com.simibubi.create.foundation.utility.worldWrappers.WrappedWorld;

import io.github.fabricators_of_create.porting_lib.item.UseFirstBehaviorItem;
import net.fabricmc.fabric.api.event.player.PlayerBlockBreakEvents;
import net.fabricmc.fabric.api.event.player.UseBlockCallback;
import net.fabricmc.fabric.api.event.player.UseEntityCallback;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1271;
import net.minecraft.class_1297;
import net.minecraft.class_1304;
import net.minecraft.class_1309;
import net.minecraft.class_1320;
import net.minecraft.class_1322;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1755;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1838;
import net.minecraft.class_1934;
import net.minecraft.class_1937;
import net.minecraft.class_2241;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2320;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_2756;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_3225;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3611;
import net.minecraft.class_3612;
import net.minecraft.class_3959;
import net.minecraft.class_3965;
import net.minecraft.class_3966;
import net.minecraft.class_3988;
import net.minecraft.class_4174;
import net.minecraft.class_4481;
import net.minecraft.class_4770;

public class DeployerHandler {

	private static final class ItemUseWorld extends WrappedWorld {
		private final class_2350 face;
		private final class_2338 pos;
		boolean rayMode = false;

		private ItemUseWorld(class_1937 world, class_2350 face, class_2338 pos) {
			super(world);
			this.face = face;
			this.pos = pos;
		}

		@Override
		public class_3965 method_17742(class_3959 context) {
			rayMode = true;
			class_3965 rayTraceBlocks = super.method_17742(context);
			rayMode = false;
			return rayTraceBlocks;
		}

		@Override
		public class_2680 method_8320(class_2338 position) {
			if (rayMode && (pos.method_10079(face.method_10153(), 3)
				.equals(position)
				|| pos.method_10079(face.method_10153(), 1)
					.equals(position)))
				return class_2246.field_9987.method_9564();
			return world.method_8320(position);
		}
	}

	static boolean shouldActivate(class_1799 held, class_1937 world, class_2338 targetPos, @Nullable class_2350 facing) {
		if (held.method_7909() instanceof class_1747)
			if (world.method_8320(targetPos)
				.method_26204() == ((class_1747) held.method_7909()).method_7711())
				return false;

		if (held.method_7909() instanceof class_1755) {
			class_1755 bucketItem = (class_1755) held.method_7909();
			class_3611 fluid = ((BucketItemAccessor) bucketItem).port_lib$getContent();
			if (fluid != class_3612.field_15906 && world.method_8316(targetPos)
				.method_15772() == fluid)
				return false;
		}

		if (!held.method_7960() && facing == class_2350.field_11033
			&& BlockEntityBehaviour.get(world, targetPos, TransportedItemStackHandlerBehaviour.TYPE) != null)
			return false;

		return true;
	}

	static void activate(DeployerFakePlayer player, class_243 vec, class_2338 clickedPos, class_243 extensionVector, Mode mode) {
		Multimap<class_1320, class_1322> attributeModifiers = player.method_6047()
			.method_7926(class_1304.field_6173);
		player.method_6127()
			.method_26854(attributeModifiers);
		activateInner(player, vec, clickedPos, extensionVector, mode);
		player.method_6127()
			.method_26854(attributeModifiers);
	}

	private static void activateInner(DeployerFakePlayer player, class_243 vec, class_2338 clickedPos, class_243 extensionVector,
		Mode mode) {

		class_243 rayOrigin = vec.method_1019(extensionVector.method_1021(3 / 2f + 1 / 64f));
		class_243 rayTarget = vec.method_1019(extensionVector.method_1021(5 / 2f - 1 / 64f));
		player.method_5814(rayOrigin.field_1352, rayOrigin.field_1351, rayOrigin.field_1350);
		class_2338 pos = class_2338.method_49638(vec);
		class_1799 stack = player.method_6047();
		class_1792 item = stack.method_7909();

		// Check for entities
		final class_1937 world = player.method_37908();
		List<class_1297> entities = world.method_18467(class_1297.class, new class_238(clickedPos))
			.stream()
			.filter(e -> !(e instanceof AbstractContraptionEntity))
			.collect(Collectors.toList());
		class_1268 hand = class_1268.field_5808;
		if (!entities.isEmpty()) {
			class_1297 entity = entities.get(world.field_9229.method_43048(entities.size()));
			boolean success = false;
			//entity.startCapturingDrops();

			// Use on entity
			if (mode == Mode.USE) {
				class_1269 cancelResult = UseEntityCallback.EVENT.invoker().interact(player, world, hand, entity, new class_3966(entity));
				if (cancelResult == class_1269.field_5814) {
					//entity.finishCapturingDrops();
					return;
				}
				if (cancelResult == null || cancelResult == class_1269.field_5811) {
					if (entity.method_5688(player, hand)
						.method_23665()) {
						if (entity instanceof class_3988) {
							class_3988 villager = ((class_3988) entity);
							if (villager.method_8257() instanceof DeployerFakePlayer)
								villager.method_8259(null);
						}
						success = true;
					} else if (entity instanceof class_1309
						&& stack.method_7920(player, (class_1309) entity, hand)
							.method_23665())
						success = true;
				}
				if (!success && entity instanceof class_1657 playerEntity) {
					if (stack.method_19267()) {
						class_4174 foodProperties = item.method_19264();
						if (playerEntity.method_7332(foodProperties.method_19233())) {
							playerEntity.method_18866(world, stack);
							player.spawnedItemEffects = stack.method_7972();
							success = true;
						}
					}
					if (AllItemTags.DEPLOYABLE_DRINK.matches(stack)) {
						player.spawnedItemEffects = stack.method_7972();
						player.method_6122(hand, stack.method_7910(world, playerEntity));
						success = true;
					}
				}
			}

			// Punch entity
			if (mode == Mode.PUNCH) {
				player.method_7350();
				player.method_7324(entity);
				success = true;
			}

			//List<ItemEntity> capturedDrops = entity.finishCapturingDrops();
			//capturedDrops.forEach(e -> player.getInventory()
			//	.placeItemBackInInventory(e.getItem()));
			if (success)
				return;
		}

		// Shoot ray
		class_3959 rayTraceContext =
			new class_3959(rayOrigin, rayTarget, class_3959.class_3960.field_17559, class_3959.class_242.field_1348, player);
		class_3965 result = world.method_17742(rayTraceContext);
		if (result.method_17777() != clickedPos)
			result = new class_3965(result.method_17784(), result.method_17780(), clickedPos, result.method_17781());
		class_2680 clickedState = world.method_8320(clickedPos);
		class_2350 face = result.method_17780();
		if (face == null)
			face = class_2350.method_10142(extensionVector.field_1352, extensionVector.field_1351, extensionVector.field_1350)
				.method_10153();

		// Left click
		if (mode == Mode.PUNCH) {
			if (!world.method_8505(player, clickedPos))
				return;
			if (clickedState.method_26218(world, clickedPos)
				.method_1110()) {
				player.blockBreakingProgress = null;
				return;
			}
			class_1269 actionResult = UseBlockCallback.EVENT.invoker().interact(player, player.method_37908(), player.method_6058(), result);
			if (actionResult == class_1269.field_5814)
				return;
			if (BlockHelper.extinguishFire(world, player, clickedPos, face))
				return;
//			if (actionResult != InteractionResult.FAIL) // fabric: checked above
			clickedState.method_26179(world, clickedPos, player);
			if (stack.method_7960())
				return;

			float progress = clickedState.method_26165(player, world, clickedPos) * 16;
			float before = 0;
			Pair<class_2338, Float> blockBreakingProgress = player.blockBreakingProgress;
			if (blockBreakingProgress != null)
				before = blockBreakingProgress.getValue();
			progress += before;
			world.method_8396(null, clickedPos, clickedState.method_26231()
				.method_10596(), class_3419.field_15254, .25f, 1);

			if (progress >= 1) {
				tryHarvestBlock(player, player.field_13974, clickedPos);
				world.method_8517(player.method_5628(), clickedPos, -1);
				player.blockBreakingProgress = null;
				return;
			}
			if (progress <= 0) {
				player.blockBreakingProgress = null;
				return;
			}

			if ((int) (before * 10) != (int) (progress * 10))
				world.method_8517(player.method_5628(), clickedPos, (int) (progress * 10));
			player.blockBreakingProgress = Pair.of(clickedPos, progress);
			return;
		}

		// Right click
		class_1838 itemusecontext = new class_1838(player, hand, result);
		class_1269 useBlock = class_1269.field_5811;
		class_1269 useItem = class_1269.field_5811;
		if (!clickedState.method_26218(world, clickedPos)
			.method_1110()) {
			useBlock = UseBlockCallback.EVENT.invoker().interact(player, player.method_37908(), hand, result);
			useItem = useBlock;
		}

		// Item has custom active use
		if (useItem != class_1269.field_5814 && stack.method_7909() instanceof UseFirstBehaviorItem first) {
			class_1269 actionresult = first.onItemUseFirst(stack, itemusecontext);
			if (actionresult != class_1269.field_5811)
				return;
		}

		boolean holdingSomething = !player.method_6047()
			.method_7960();
		boolean flag1 =
			!(player.method_5715() && holdingSomething)/* || (stack.doesSneakBypassUse(world, clickedPos, player))*/;

		// Use on block
		if (useBlock != null && flag1
			&& safeOnUse(clickedState, world, clickedPos, player, hand, result).method_23665())
			return;
		if (stack.method_7960())
			return;
		if (useItem == null)
			return;

		// Reposition fire placement for convenience
		if (item == class_1802.field_8884) {
			class_2350 newFace = result.method_17780();
			class_2338 newPos = result.method_17777();
			if (!class_4770.method_30032(world, clickedPos, newFace))
				newFace = class_2350.field_11036;
			if (clickedState.method_26215())
				newPos = newPos.method_10093(face.method_10153());
			result = new class_3965(result.method_17784(), newFace, newPos, result.method_17781());
			itemusecontext = new class_1838(player, hand, result);
		}

		// 'Inert' item use behaviour & block placement
		class_1269 onItemUse = stack.method_7981(itemusecontext);
		if (onItemUse.method_23665()) {
			if (stack.method_7909() instanceof class_1747 bi
				&& (bi.method_7711() instanceof class_2241 || bi.method_7711() instanceof ITrackBlock))
				player.placedTracks = true;
			return;
		}

		if (item instanceof class_1747 && !(item instanceof CartAssemblerBlockItem)
				&& !clickedState.method_26166(new class_1750(itemusecontext)))
			return;
		if (item == class_1802.field_8634)
			return;
		if (AllItemTags.DEPLOYABLE_DRINK.matches(item))
			return;

		// buckets create their own ray, We use a fake wall to contain the active area
		class_1937 itemUseWorld = world;
		if (item instanceof class_1755 || item instanceof SandPaperItem)
			itemUseWorld = new ItemUseWorld(world, face, pos);

		class_1271<class_1799> onItemRightClick = item.method_7836(itemUseWorld, player, hand);
		class_1799 resultStack = onItemRightClick.method_5466();
		if (resultStack != stack || resultStack.method_7947() != stack.method_7947() || resultStack.method_7935() > 0
			|| resultStack.method_7919() != stack.method_7919()) {
			player.method_6122(hand, onItemRightClick.method_5466());
		}

		class_2487 tag = stack.method_7969();
		if (tag != null && stack.method_7909() instanceof SandPaperItem && tag.method_10545("Polishing")) {
			player.spawnedItemEffects = class_1799.method_7915(tag.method_10562("Polishing"));
			AllSoundEvents.SANDING_SHORT.playOnServer(world, pos, .25f, 1f);
		}

		if (!player.method_6030()
			.method_7960())
			player.method_6122(hand, stack.method_7910(world, player));

		player.method_6021();
	}

	public static boolean tryHarvestBlock(class_3222 player, class_3225 interactionManager, class_2338 pos) {
		// <> PlayerInteractionManager#tryHarvestBlock

		class_3218 world = player.method_51469();
		class_2680 blockstate = world.method_8320(pos);
		class_1934 gameType = interactionManager.method_14257();

		if (!PlayerBlockBreakEvents.BEFORE.invoker().beforeBlockBreak(world, player, pos, world.method_8320(pos), world.method_8321(pos)))
			return false;

		class_2586 blockEntity = world.method_8321(pos);
//		if (player.getMainHandItem()
//			.onBlockStartBreak(pos, player))
//			return false;
		if (player.method_21701(world, pos, gameType))
			return false;

		class_1799 prevHeldItem = player.method_6047();
		class_1799 heldItem = prevHeldItem.method_7972();

		boolean canHarvest = player.method_7305(blockstate) && player.method_7294();
		prevHeldItem.method_7952(world, blockstate, pos, player);
//		if (prevHeldItem.isEmpty() && !heldItem.isEmpty())
//			net.minecraftforge.event.ForgeEventFactory.onPlayerDestroyItem(player, heldItem, InteractionHand.MAIN_HAND);

		class_2338 posUp = pos.method_10084();
		class_2680 stateUp = world.method_8320(posUp);
		if (blockstate.method_26204() instanceof class_2320
			&& blockstate.method_11654(class_2320.field_10929) == class_2756.field_12607
			&& stateUp.method_26204() == blockstate.method_26204()
			&& stateUp.method_11654(class_2320.field_10929) == class_2756.field_12609) {
			// hack to prevent DoublePlantBlock from dropping a duplicate item
			world.method_8652(pos, class_2246.field_10124.method_9564(), 35);
			world.method_8652(posUp, class_2246.field_10124.method_9564(), 35);
		} else {
			blockstate.method_26204().method_9576(world, pos, blockstate, player);
			if (!world.method_8652(pos, world.method_8316(pos).method_15772().method_15785().method_15759(), world.field_9236 ? 11 : 3))
				return true;
		}

		blockstate.method_26204()
			.method_9585(world, pos, blockstate);
		if (!canHarvest)
			return true;

		class_2248.method_9609(blockstate, world, pos, blockEntity, player, prevHeldItem)
			.forEach(item -> player.method_31548().method_7398(item));
		blockstate.method_26180(world, pos, prevHeldItem, true);
		return true;
	}

	public static class_1269 safeOnUse(class_2680 state, class_1937 world, class_2338 pos, class_1657 player,
		class_1268 hand, class_3965 ray) {
		if (state.method_26204() instanceof class_4481)
			return safeOnBeehiveUse(state, world, pos, player, hand);
		return state.method_26174(world, player, hand, ray);
	}

	protected static class_1269 safeOnBeehiveUse(class_2680 state, class_1937 world, class_2338 pos, class_1657 player,
		class_1268 hand) {
		// <> BeehiveBlock#onUse

		class_4481 block = (class_4481) state.method_26204();
		class_1799 prevHeldItem = player.method_5998(hand);
		int honeyLevel = state.method_11654(class_4481.field_20420);
		boolean success = false;
		if (honeyLevel < 5)
			return class_1269.field_5811;

		if (prevHeldItem.method_7909() == class_1802.field_8868) {
			world.method_43128(player, player.method_23317(), player.method_23318(), player.method_23321(), class_3417.field_20611,
				class_3419.field_15254, 1.0F, 1.0F);
			// <> BeehiveBlock#dropHoneycomb
			player.method_31548().method_7398(new class_1799(class_1802.field_20414, 3));
			prevHeldItem.method_7956(1, player, s -> s.method_20236(hand));
			success = true;
		}

		if (prevHeldItem.method_7909() == class_1802.field_8469) {
			prevHeldItem.method_7934(1);
			world.method_43128(player, player.method_23317(), player.method_23318(), player.method_23321(), class_3417.field_14779,
				class_3419.field_15254, 1.0F, 1.0F);
			class_1799 honeyBottle = new class_1799(class_1802.field_20417);
			if (prevHeldItem.method_7960())
				player.method_6122(hand, honeyBottle);
			else
				player.method_31548().method_7398(honeyBottle);
			success = true;
		}

		if (!success)
			return class_1269.field_5811;

		block.method_23754(world, state, pos);
		return class_1269.field_5812;
	}

}
