package com.simibubi.create.content.kinetics.deployer;

import java.util.UUID;
import net.minecraft.class_1268;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2520;
import net.minecraft.class_3218;
import net.minecraft.class_3499.class_3501;
import com.simibubi.create.foundation.utility.AdventureUtil;

import org.apache.commons.lang3.tuple.MutablePair;

import com.simibubi.create.AllItems;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import com.simibubi.create.content.contraptions.behaviour.MovingInteractionBehaviour;
import com.simibubi.create.content.contraptions.mounted.MountedContraption;
import com.simibubi.create.foundation.utility.NBTHelper;

import io.github.fabricators_of_create.porting_lib.util.NBTSerializer;

public class DeployerMovingInteraction extends MovingInteractionBehaviour {

	@Override
	public boolean handlePlayerInteraction(class_1657 player, class_1268 activeHand, class_2338 localPos,
		AbstractContraptionEntity contraptionEntity) {
		if (AdventureUtil.isAdventure(player))
			return false;
		MutablePair<class_3501, MovementContext> actor = contraptionEntity.getContraption()
			.getActorAt(localPos);
		if (actor == null || actor.right == null)
			return false;

		MovementContext ctx = actor.right;
		class_1799 heldStack = player.method_5998(activeHand);
		if (heldStack.method_7909()
				.equals(AllItems.WRENCH.get())) {
			DeployerBlockEntity.Mode mode = NBTHelper.readEnum(ctx.blockEntityData, "Mode", DeployerBlockEntity.Mode.class);
			NBTHelper.writeEnum(ctx.blockEntityData, "Mode",
				mode == DeployerBlockEntity.Mode.PUNCH ? DeployerBlockEntity.Mode.USE : DeployerBlockEntity.Mode.PUNCH);

		} else {
			if (ctx.world.field_9236)
				return true; // we'll try again on the server side
			DeployerFakePlayer fake = null;

			if (!(ctx.temporaryData instanceof DeployerFakePlayer) && ctx.world instanceof class_3218) {
				UUID owner = ctx.blockEntityData.method_10545("Owner") ? ctx.blockEntityData.method_25926("Owner") : null;
				DeployerFakePlayer deployerFakePlayer = new DeployerFakePlayer((class_3218) ctx.world, owner);
				deployerFakePlayer.onMinecartContraption = ctx.contraption instanceof MountedContraption;
				deployerFakePlayer.method_31548()
					.method_7397(ctx.blockEntityData.method_10554("Inventory", class_2520.field_33260));
				ctx.temporaryData = fake = deployerFakePlayer;
				ctx.blockEntityData.method_10551("Inventory");
			} else
				fake = (DeployerFakePlayer) ctx.temporaryData;

			if (fake == null)
				return false;

			class_1799 deployerItem = fake.method_6047();
			player.method_6122(activeHand, deployerItem.method_7972());
			fake.method_6122(class_1268.field_5808, heldStack.method_7972());
			ctx.blockEntityData.method_10566("HeldItem", NBTSerializer.serializeNBT(heldStack));
			ctx.data.method_10566("HeldItem", NBTSerializer.serializeNBT(heldStack));
		}
//		if (index >= 0)
//			setContraptionActorData(contraptionEntity, index, info, ctx);
		return true;
	}
}
