package com.simibubi.create.content.kinetics.deployer;

import java.util.List;
import java.util.Optional;
import net.minecraft.class_1263;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1799;
import net.minecraft.class_1860;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3956;
import net.minecraft.class_3965;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.content.processing.recipe.ProcessingOutput;
import com.simibubi.create.content.processing.recipe.ProcessingRecipeBuilder;
import com.simibubi.create.content.processing.recipe.ProcessingRecipeBuilder.ProcessingRecipeParams;
import com.simibubi.create.foundation.advancement.AllAdvancements;
import com.simibubi.create.foundation.advancement.CreateAdvancement;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.simibubi.create.foundation.utility.BlockHelper;

public class ManualApplicationRecipe extends ItemApplicationRecipe {

	public static class_1269 manualApplicationRecipesApplyInWorld(class_1657 player, class_1937 level, class_1268 hand, class_3965 hitResult) {
		if (AdventureUtil.isAdventure(player))
			return class_1269.field_5811;

		class_1799 heldItem = player.method_5998(hand);
		class_2338 pos = hitResult.method_17777();
		class_2680 blockState = level.method_8320(pos);

		if (heldItem.method_7960())
			return class_1269.field_5811;
		if (blockState.method_26215())
			return class_1269.field_5811;

		class_3956<class_1860<class_1263>> type = AllRecipeTypes.ITEM_APPLICATION.getType();
		Optional<class_1860<class_1263>> foundRecipe = level.method_8433()
			.method_30027(type)
			.stream()
			.filter(r -> {
				ManualApplicationRecipe mar = (ManualApplicationRecipe) r;
				return mar.testBlock(blockState) && mar.ingredients.get(1)
					.method_8093(heldItem);
			})
			.findFirst();

		if (foundRecipe.isEmpty())
			return class_1269.field_5811;

//		event.setCancellationResult(InteractionResult.SUCCESS);
//		event.setCanceled(true);

		if (level.method_8608())
			return class_1269.field_5812;

		level.method_8396(null, pos, class_3417.field_26960, class_3419.field_15248, 1, 1.45f);
		ManualApplicationRecipe recipe = (ManualApplicationRecipe) foundRecipe.get();
		level.method_22352(pos, false);

		class_2680 transformedBlock = recipe.transformBlock(blockState);
		level.method_8652(pos, transformedBlock, 3);
		recipe.rollResults()
			.forEach(stack -> class_2248.method_9577(level, pos, stack));

		boolean creative = player != null && player.method_7337();
		boolean unbreakable = heldItem.method_7985() && heldItem.method_7969()
			.method_10577("Unbreakable");
		boolean keepHeld = recipe.shouldKeepHeldItem() || creative;

		if (!unbreakable && !keepHeld) {
			if (heldItem.method_7963())
				heldItem.method_7956(1, player, s -> s.method_20236(class_1268.field_5808));
			else
				heldItem.method_7934(1);
		}

		awardAdvancements(player, transformedBlock);
		return class_1269.field_5812;
	}

	private static void awardAdvancements(class_1657 player, class_2680 placed) {
		CreateAdvancement advancement = null;

		if (AllBlocks.ANDESITE_CASING.has(placed))
			advancement = AllAdvancements.ANDESITE_CASING;
		else if (AllBlocks.BRASS_CASING.has(placed))
			advancement = AllAdvancements.BRASS_CASING;
		else if (AllBlocks.COPPER_CASING.has(placed))
			advancement = AllAdvancements.COPPER_CASING;
		else if (AllBlocks.RAILWAY_CASING.has(placed))
			advancement = AllAdvancements.TRAIN_CASING;
		else
			return;

		advancement.awardTo(player);
	}

	public ManualApplicationRecipe(ProcessingRecipeParams params) {
		super(AllRecipeTypes.ITEM_APPLICATION, params);
	}

	public static DeployerApplicationRecipe asDeploying(class_1860<?> recipe) {
		ManualApplicationRecipe mar = (ManualApplicationRecipe) recipe;
		ProcessingRecipeBuilder<DeployerApplicationRecipe> builder =
			new ProcessingRecipeBuilder<>(DeployerApplicationRecipe::new,
				new class_2960(mar.id.method_12836(), mar.id.method_12832() + "_using_deployer"))
					.require(mar.ingredients.get(0))
					.require(mar.ingredients.get(1));
		for (ProcessingOutput output : mar.results)
			builder.output(output);
		if (mar.shouldKeepHeldItem())
			builder.toolNotConsumed();
		return builder.build();
	}

	public boolean testBlock(class_2680 in) {
		return ingredients.get(0)
			.method_8093(new class_1799(in.method_26204()
				.method_8389()));
	}

	public class_2680 transformBlock(class_2680 in) {
		ProcessingOutput mainOutput = results.get(0);
		class_1799 output = mainOutput.rollOutput();
		if (output.method_7909() instanceof class_1747 bi)
			return BlockHelper.copyProperties(in, bi.method_7711()
				.method_9564());
		return class_2246.field_10124.method_9564();
	}

	@Override
	public List<class_1799> rollResults() {
		return rollResults(getRollableResultsExceptBlock());
	}

	public List<ProcessingOutput> getRollableResultsExceptBlock() {
		ProcessingOutput mainOutput = results.get(0);
		if (mainOutput.getStack()
			.method_7909() instanceof class_1747)
			return results.subList(1, results.size());
		return results;
	}

}
