package com.simibubi.create.content.kinetics.drill;

import org.joml.Quaternionf;

import com.jozufozu.flywheel.api.Material;
import com.jozufozu.flywheel.api.MaterialManager;
import com.jozufozu.flywheel.core.virtual.VirtualRenderWorld;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.contraptions.actors.flwdata.ActorData;
import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import com.simibubi.create.content.contraptions.render.ActorInstance;
import com.simibubi.create.foundation.render.AllMaterialSpecs;
import com.simibubi.create.foundation.utility.AngleHelper;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_3532;

public class DrillActorInstance extends ActorInstance {

    ActorData drillHead;
    private final class_2350 facing;

    public DrillActorInstance(MaterialManager materialManager, VirtualRenderWorld contraption, MovementContext context) {
        super(materialManager, contraption, context);

        Material<ActorData> material = materialManager.defaultSolid()
                .material(AllMaterialSpecs.ACTORS);

        class_2680 state = context.state;

        facing = state.method_11654(DrillBlock.FACING);

        class_2350.class_2351 axis = facing.method_10166();
        float eulerX = AngleHelper.verticalAngle(facing);

        float eulerY;
        if (axis == class_2350.class_2351.field_11052)
            eulerY = 0;
        else
            eulerY = facing.method_10144() + ((axis == class_2350.class_2351.field_11048) ? 180 : 0);

        drillHead = material.getModel(AllPartialModels.DRILL_HEAD, state).createInstance();

        drillHead.setPosition(context.localPos)
                 .setBlockLight(localBlockLight())
                 .setRotationOffset(0)
                 .setRotationAxis(0, 0, 1)
                 .setLocalRotation(new Quaternionf().rotationXYZ(eulerX * class_3532.field_29847, eulerY * class_3532.field_29847, 0))
                 .setSpeed(getSpeed(facing));
    }

    @Override
    public void beginFrame() {
        drillHead.setSpeed(getSpeed(facing));
    }

    protected float getSpeed(class_2350 facing) {
        if (context.contraption.stalled || !VecHelper.isVecPointingTowards(context.relativeMotion, facing.method_10153()))
            return context.getAnimationSpeed();
        return 0;
    }
}
