package com.simibubi.create.content.kinetics.drill;

import java.util.List;
import java.util.function.Predicate;

import javax.annotation.ParametersAreNonnullByDefault;
import net.minecraft.class_10;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1297;
import net.minecraft.class_1542;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_238;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689;
import net.minecraft.class_2741;
import net.minecraft.class_3532;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_3737;
import net.minecraft.class_3965;
import net.minecraft.class_4538;
import net.minecraft.class_6328;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.kinetics.base.DirectionalKineticBlock;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.damageTypes.CreateDamageSources;
import com.simibubi.create.foundation.placement.IPlacementHelper;
import com.simibubi.create.foundation.placement.PlacementHelpers;
import com.simibubi.create.foundation.placement.PlacementOffset;

@ParametersAreNonnullByDefault
@class_6328
public class DrillBlock extends DirectionalKineticBlock implements IBE<DrillBlockEntity>, class_3737 {
	private static final int placementHelperId = PlacementHelpers.register(new PlacementHelper());

	public DrillBlock(class_2251 properties) {
		super(properties);
		method_9590(super.method_9564().method_11657(class_2741.field_12508, false));
	}

	@Override
	public void method_9548(class_2680 state, class_1937 worldIn, class_2338 pos, class_1297 entityIn) {
		if (entityIn instanceof class_1542)
			return;
		if (!new class_238(pos).method_1011(.1f)
			.method_994(entityIn.method_5829()))
			return;
		withBlockEntityDo(worldIn, pos, be -> {
			if (be.getSpeed() == 0)
				return;
			entityIn.method_5643(CreateDamageSources.drill(worldIn), (float) getDamage(be.getSpeed()));
		});
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return AllShapes.CASING_12PX.get(state.method_11654(FACING));
	}

	@Override
	public void method_9612(class_2680 state, class_1937 worldIn, class_2338 pos, class_2248 blockIn, class_2338 fromPos,
		boolean isMoving) {
		withBlockEntityDo(worldIn, pos, DrillBlockEntity::destroyNextTick);
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return state.method_11654(FACING)
			.method_10166();
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return face == state.method_11654(FACING)
			.method_10153();
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	@Override
	public class_3610 method_9545(class_2680 state) {
		return state.method_11654(class_2741.field_12508) ? class_3612.field_15910.method_15729(false) : class_3612.field_15906.method_15785();
	}

	@Override
	protected void method_9515(class_2689.class_2690<class_2248, class_2680> builder) {
		builder.method_11667(class_2741.field_12508);
		super.method_9515(builder);
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 direction, class_2680 neighbourState,
								  class_1936 world, class_2338 pos, class_2338 neighbourPos) {
		if (state.method_11654(class_2741.field_12508))
			world.method_39281(pos, class_3612.field_15910, class_3612.field_15910.method_15789(world));
		return state;
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_3610 FluidState = context.method_8045().method_8316(context.method_8037());
		return super.method_9605(context).method_11657(class_2741.field_12508, Boolean.valueOf(FluidState.method_15772() == class_3612.field_15910));
	}

	public static double getDamage(float speed) {
		float speedAbs = Math.abs(speed);
		double sub1 = Math.min(speedAbs / 16, 2);
		double sub2 = Math.min(speedAbs / 32, 4);
		double sub3 = Math.min(speedAbs / 64, 4);
		return class_3532.method_15350(sub1 + sub2 + sub3, 1, 10);
	}

	@Override
	public Class<DrillBlockEntity> getBlockEntityClass() {
		return DrillBlockEntity.class;
	}

	@Override
	public class_2591<? extends DrillBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.DRILL.get();
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand,
		class_3965 ray) {
		class_1799 heldItem = player.method_5998(hand);

		IPlacementHelper placementHelper = PlacementHelpers.get(placementHelperId);
		if (!player.method_5715() && player.method_7294()) {
			if (placementHelper.matchesItem(heldItem)) {
				placementHelper.getOffset(player, world, state, pos, ray)
					.placeInWorld(world, (class_1747) heldItem.method_7909(), player, hand, ray);
				return class_1269.field_5812;
			}
		}

		return class_1269.field_5811;
	}

	@class_6328
	private static class PlacementHelper implements IPlacementHelper {

		@Override
		public Predicate<class_1799> getItemPredicate() {
			return AllBlocks.MECHANICAL_DRILL::isIn;
		}

		@Override
		public Predicate<class_2680> getStatePredicate() {
			return AllBlocks.MECHANICAL_DRILL::has;
		}

		@Override
		public PlacementOffset getOffset(class_1657 player, class_1937 world, class_2680 state, class_2338 pos,
			class_3965 ray) {
			List<class_2350> directions = IPlacementHelper.orderedByDistanceExceptAxis(pos, ray.method_17784(),
				state.method_11654(FACING)
					.method_10166(),
				dir -> world.method_8320(pos.method_10093(dir))
					.method_45474());

			if (directions.isEmpty())
				return PlacementOffset.fail();
			else {
				return PlacementOffset.success(pos.method_10093(directions.get(0)),
					s -> s.method_11657(FACING, state.method_11654(FACING)));
			}
		}
	}

}
