package com.simibubi.create.content.kinetics.fan;

import java.util.Locale;

import com.mojang.brigadier.StringReader;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import com.simibubi.create.AllParticleTypes;
import com.simibubi.create.foundation.particle.ICustomParticleDataWithSprite;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2382;
import net.minecraft.class_2394;
import net.minecraft.class_2396;
import net.minecraft.class_2540;
import net.minecraft.class_702.class_4091;

public class AirFlowParticleData implements class_2394, ICustomParticleDataWithSprite<AirFlowParticleData> {
	
	public static final Codec<AirFlowParticleData> CODEC = RecordCodecBuilder.create(i -> 
		i.group(
			Codec.INT.fieldOf("x").forGetter(p -> p.posX),
			Codec.INT.fieldOf("y").forGetter(p -> p.posY),
			Codec.INT.fieldOf("z").forGetter(p -> p.posZ))
		.apply(i, AirFlowParticleData::new));

	public static final class_2394.class_2395<AirFlowParticleData> DESERIALIZER = new class_2394.class_2395<AirFlowParticleData>() {
		public AirFlowParticleData method_10296(class_2396<AirFlowParticleData> particleTypeIn, StringReader reader)
				throws CommandSyntaxException {
			reader.expect(' ');
			int x = reader.readInt();
			reader.expect(' ');
			int y = reader.readInt();
			reader.expect(' ');
			int z = reader.readInt();
			return new AirFlowParticleData(x, y, z);
		}

		public AirFlowParticleData method_10297(class_2396<AirFlowParticleData> particleTypeIn, class_2540 buffer) {
			return new AirFlowParticleData(buffer.readInt(), buffer.readInt(), buffer.readInt());
		}
	};

	final int posX;
	final int posY;
	final int posZ;

	public AirFlowParticleData(class_2382 pos) {
		this(pos.method_10263(), pos.method_10264(), pos.method_10260());
	}

	public AirFlowParticleData(int posX, int posY, int posZ) {
		this.posX = posX;
		this.posY = posY;
		this.posZ = posZ;
	}

	public AirFlowParticleData() {
		this(0, 0, 0);
	}

	@Override
	public class_2396<?> method_10295() {
		return AllParticleTypes.AIR_FLOW.get();
	}

	@Override
	public void method_10294(class_2540 buffer) {
		buffer.writeInt(posX);
		buffer.writeInt(posY);
		buffer.writeInt(posZ);
	}

	@Override
	public String method_10293() {
		return String.format(Locale.ROOT, "%s %d %d %d", AllParticleTypes.AIR_FLOW.parameter(), posX, posY, posZ);
	}

	@Override
	public class_2395<AirFlowParticleData> getDeserializer() {
		return DESERIALIZER;
	}
	
	@Override
	public Codec<AirFlowParticleData> getCodec(class_2396<AirFlowParticleData> type) {
		return CODEC;
	}

	@Override
	@Environment(EnvType.CLIENT)
	public class_4091<AirFlowParticleData> getMetaFactory() {
		return AirFlowParticle.Factory::new;
	}

}