package com.simibubi.create.content.kinetics.fan;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.content.kinetics.base.DirectionalKineticBlock;
import com.simibubi.create.content.logistics.chute.AbstractChuteBlock;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.utility.worldWrappers.WrappedWorld;
import net.minecraft.class_1750;
import net.minecraft.class_1838;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_4538;

public class EncasedFanBlock extends DirectionalKineticBlock implements IBE<EncasedFanBlockEntity> {

	public EncasedFanBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public void method_9615(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 oldState, boolean isMoving) {
		super.method_9615(state, worldIn, pos, oldState, isMoving);
		blockUpdate(state, worldIn, pos);
	}

	@Override
	public void method_9517(class_2680 stateIn, class_1936 worldIn, class_2338 pos, int flags, int count) {
		super.method_9517(stateIn, worldIn, pos, flags, count);
		blockUpdate(stateIn, worldIn, pos);
	}

	@Override
	public void method_9612(class_2680 state, class_1937 worldIn, class_2338 pos, class_2248 blockIn, class_2338 fromPos,
		boolean isMoving) {
		blockUpdate(state, worldIn, pos);
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_1937 world = context.method_8045();
		class_2338 pos = context.method_8037();
		class_2350 face = context.method_8038();

		class_2680 placedOn = world.method_8320(pos.method_10093(face.method_10153()));
		class_2680 placedOnOpposite = world.method_8320(pos.method_10093(face));
		if (AbstractChuteBlock.isChute(placedOn))
			return method_9564().method_11657(FACING, face.method_10153());
		if (AbstractChuteBlock.isChute(placedOnOpposite))
			return method_9564().method_11657(FACING, face);

		class_2350 preferredFacing = getPreferredFacing(context);
		if (preferredFacing == null)
			preferredFacing = context.method_7715();
		return method_9564().method_11657(FACING, context.method_8036() != null && context.method_8036()
			.method_5715() ? preferredFacing : preferredFacing.method_10153());
	}

	protected void blockUpdate(class_2680 state, class_1936 worldIn, class_2338 pos) {
		if (worldIn instanceof WrappedWorld)
			return;
		notifyFanBlockEntity(worldIn, pos);
	}

	protected void notifyFanBlockEntity(class_1936 world, class_2338 pos) {
		withBlockEntityDo(world, pos, EncasedFanBlockEntity::blockInFrontChanged);
	}

	@Override
	public class_2680 updateAfterWrenched(class_2680 newState, class_1838 context) {
		blockUpdate(newState, context.method_8045(), context.method_8037());
		return newState;
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return state.method_11654(FACING)
			.method_10166();
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return face == state.method_11654(FACING)
			.method_10153();
	}

	@Override
	public Class<EncasedFanBlockEntity> getBlockEntityClass() {
		return EncasedFanBlockEntity.class;
	}
	
	@Override
	public class_2591<? extends EncasedFanBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.ENCASED_FAN.get();
	}

}
