package com.simibubi.create.content.kinetics.fan;

import java.util.List;

import javax.annotation.Nullable;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2487;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2741;
import net.minecraft.class_6328;
import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.content.logistics.chute.ChuteBlockEntity;
import com.simibubi.create.foundation.advancement.AllAdvancements;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.infrastructure.config.AllConfigs;

@class_6328
public class EncasedFanBlockEntity extends KineticBlockEntity implements IAirCurrentSource {

	public AirCurrent airCurrent;
	protected int airCurrentUpdateCooldown;
	protected int entitySearchCooldown;
	protected boolean updateAirFlow;

	public EncasedFanBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
		airCurrent = new AirCurrent(this);
		updateAirFlow = true;
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {
		super.addBehaviours(behaviours);
		registerAwardables(behaviours, AllAdvancements.ENCASED_FAN, AllAdvancements.FAN_PROCESSING);
	}
	
	@Override
	protected void read(class_2487 compound, boolean clientPacket) {
		super.read(compound, clientPacket);
		if (clientPacket)
			airCurrent.rebuild();
	}

	@Override
	public void write(class_2487 compound, boolean clientPacket) {
		super.write(compound, clientPacket);
	}

	@Override
	public AirCurrent getAirCurrent() {
		return airCurrent;
	}

	@Nullable
	@Override
	public class_1937 getAirCurrentWorld() {
		return field_11863;
	}

	@Override
	public class_2338 getAirCurrentPos() {
		return field_11867;
	}

	@Override
	public class_2350 getAirflowOriginSide() {
		return this.method_11010()
			.method_11654(EncasedFanBlock.FACING);
	}

	@Override
	public class_2350 getAirFlowDirection() {
		float speed = getSpeed();
		if (speed == 0)
			return null;
		class_2350 facing = method_11010().method_11654(class_2741.field_12525);
		speed = convertToDirection(speed, facing);
		return speed > 0 ? facing : facing.method_10153();
	}

	@Override
	public void remove() {
		super.remove();
		updateChute();
	}
	
	@Override
	public boolean isSourceRemoved() {
		return field_11865;
	}

	@Override
	public void onSpeedChanged(float prevSpeed) {
		super.onSpeedChanged(prevSpeed);
		updateAirFlow = true;
		updateChute();
	}

	public void updateChute() {
		class_2350 direction = method_11010().method_11654(EncasedFanBlock.FACING);
		if (!direction.method_10166()
			.method_10178())
			return;
		class_2586 poweredChute = field_11863.method_8321(field_11867.method_10093(direction));
		if (!(poweredChute instanceof ChuteBlockEntity))
			return;
		ChuteBlockEntity chuteBE = (ChuteBlockEntity) poweredChute;
		if (direction == class_2350.field_11033)
			chuteBE.updatePull();
		else
			chuteBE.updatePush(1);
	}

	public void blockInFrontChanged() {
		updateAirFlow = true;
	}

	@Override
	public void tick() {
		super.tick();

		boolean server = !field_11863.field_9236 || isVirtual();

		if (server && airCurrentUpdateCooldown-- <= 0) {
			airCurrentUpdateCooldown = AllConfigs.server().kinetics.fanBlockCheckRate.get();
			updateAirFlow = true;
		}

		if (updateAirFlow) {
			updateAirFlow = false;
			airCurrent.rebuild();
			if (airCurrent.maxDistance > 0)
				award(AllAdvancements.ENCASED_FAN);
			sendData();
		}

		if (getSpeed() == 0)
			return;

		if (entitySearchCooldown-- <= 0) {
			entitySearchCooldown = 5;
			airCurrent.findEntities();
		}

		airCurrent.tick();
	}

}
