package com.simibubi.create.content.kinetics.fan;

import static net.minecraft.class_2741.field_12525;

import com.jozufozu.flywheel.backend.Backend;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.base.KineticBlockEntityRenderer;
import com.simibubi.create.foundation.render.CachedBufferer;
import com.simibubi.create.foundation.render.SuperByteBuffer;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import net.minecraft.class_1921;
import net.minecraft.class_2350;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_4597;
import net.minecraft.class_5614;
import net.minecraft.class_761;

public class EncasedFanRenderer extends KineticBlockEntityRenderer<EncasedFanBlockEntity> {

	public EncasedFanRenderer(class_5614.class_5615 context) {
		super(context);
	}

	@Override
	protected void renderSafe(EncasedFanBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay) {
		if (Backend.canUseInstancing(be.method_10997())) return;

		class_2350 direction = be.method_11010()
				.method_11654(field_12525);
		class_4588 vb = buffer.getBuffer(class_1921.method_23579());

		int lightBehind = class_761.method_23794(be.method_10997(), be.method_11016().method_10093(direction.method_10153()));
		int lightInFront = class_761.method_23794(be.method_10997(), be.method_11016().method_10093(direction));

		SuperByteBuffer shaftHalf =
				CachedBufferer.partialFacing(AllPartialModels.SHAFT_HALF, be.method_11010(), direction.method_10153());
		SuperByteBuffer fanInner =
				CachedBufferer.partialFacing(AllPartialModels.ENCASED_FAN_INNER, be.method_11010(), direction.method_10153());

		float time = AnimationTickHolder.getRenderTime(be.method_10997());
		float speed = be.getSpeed() * 5;
		if (speed > 0)
			speed = class_3532.method_15363(speed, 80, 64 * 20);
		if (speed < 0)
			speed = class_3532.method_15363(speed, -64 * 20, -80);
		float angle = (time * speed * 3 / 10f) % 360;
		angle = angle / 180f * (float) Math.PI;

		standardKineticRotationTransform(shaftHalf, be, lightBehind).renderInto(ms, vb);
		kineticRotationTransform(fanInner, be, direction.method_10166(), angle, lightInFront).renderInto(ms, vb);
	}

}
