package com.simibubi.create.content.kinetics.fan;

import static net.minecraft.class_2741.field_12525;

import com.jozufozu.flywheel.api.MaterialManager;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.base.KineticBlockEntityInstance;
import com.simibubi.create.content.kinetics.base.flwdata.RotatingData;
import com.simibubi.create.foundation.render.AllMaterialSpecs;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_3532;

public class FanInstance extends KineticBlockEntityInstance<EncasedFanBlockEntity> {

    protected final RotatingData shaft;
    protected final RotatingData fan;
    final class_2350 direction;
    private final class_2350 opposite;

    public FanInstance(MaterialManager materialManager, EncasedFanBlockEntity blockEntity) {
		super(materialManager, blockEntity);

		direction = blockState.method_11654(field_12525);

		opposite = direction.method_10153();
		shaft = getRotatingMaterial().getModel(AllPartialModels.SHAFT_HALF, blockState, opposite).createInstance();
		fan = materialManager.defaultCutout()
				.material(AllMaterialSpecs.ROTATING)
				.getModel(AllPartialModels.ENCASED_FAN_INNER, blockState, opposite)
				.createInstance();

		setup(shaft);
		setup(fan, getFanSpeed());
	}

    private float getFanSpeed() {
        float speed = blockEntity.getSpeed() * 5;
        if (speed > 0)
            speed = class_3532.method_15363(speed, 80, 64 * 20);
        if (speed < 0)
            speed = class_3532.method_15363(speed, -64 * 20, -80);
        return speed;
    }

    @Override
    public void update() {
        updateRotation(shaft);
        updateRotation(fan, getFanSpeed());
    }

    @Override
    public void updateLight() {
        class_2338 behind = pos.method_10093(opposite);
        relight(behind, shaft);

        class_2338 inFront = pos.method_10093(direction);
        relight(inFront, fan);
    }

    @Override
    public void remove() {
        shaft.delete();
        fan.delete();
    }
}
