package com.simibubi.create.content.kinetics.fan.processing;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_1542;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2487;
import com.simibubi.create.content.kinetics.belt.behaviour.TransportedItemStackHandlerBehaviour.TransportedResult;
import com.simibubi.create.content.kinetics.belt.transport.TransportedItemStack;
import com.simibubi.create.infrastructure.config.AllConfigs;

public class FanProcessing {
	public static boolean canProcess(class_1542 entity, FanProcessingType type) {
		if (entity.getCustomData()
			.method_10545("CreateData")) {
			class_2487 compound = entity.getCustomData()
				.method_10562("CreateData");
			if (compound.method_10545("Processing")) {
				class_2487 processing = compound.method_10562("Processing");

				if (AllFanProcessingTypes.parseLegacy(processing.method_10558("Type")) != type)
					return type.canProcess(entity.method_6983(), entity.method_37908());
				else if (processing.method_10550("Time") >= 0)
					return true;
				else if (processing.method_10550("Time") == -1)
					return false;
			}
		}
		return type.canProcess(entity.method_6983(), entity.method_37908());
	}

	public static boolean applyProcessing(class_1542 entity, FanProcessingType type) {
		if (decrementProcessingTime(entity, type) != 0)
			return false;
		List<class_1799> stacks = type.process(entity.method_6983(), entity.method_37908());
		if (stacks == null)
			return false;
		if (stacks.isEmpty()) {
			entity.method_31472();
			return false;
		}
		entity.method_6979(stacks.remove(0));
		for (class_1799 additional : stacks) {
			class_1542 entityIn = new class_1542(entity.method_37908(), entity.method_23317(), entity.method_23318(), entity.method_23321(), additional);
			entityIn.method_18799(entity.method_18798());
			entity.method_37908().method_8649(entityIn);
		}
		return true;
	}

	public static TransportedResult applyProcessing(TransportedItemStack transported, class_1937 world, FanProcessingType type) {
		TransportedResult ignore = TransportedResult.doNothing();
		if (transported.processedBy != type) {
			transported.processedBy = type;
			int timeModifierForStackSize = ((transported.stack.method_7947() - 1) / 16) + 1;
			int processingTime =
				(int) (AllConfigs.server().kinetics.fanProcessingTime.get() * timeModifierForStackSize) + 1;
			transported.processingTime = processingTime;
			if (!type.canProcess(transported.stack, world))
				transported.processingTime = -1;
			return ignore;
		}
		if (transported.processingTime == -1)
			return ignore;
		if (transported.processingTime-- > 0)
			return ignore;

		List<class_1799> stacks = type.process(transported.stack, world);
		if (stacks == null)
			return ignore;

		List<TransportedItemStack> transportedStacks = new ArrayList<>();
		for (class_1799 additional : stacks) {
			TransportedItemStack newTransported = transported.getSimilar();
			newTransported.stack = additional.method_7972();
			transportedStacks.add(newTransported);
		}
		return TransportedResult.convertTo(transportedStacks);
	}

	private static int decrementProcessingTime(class_1542 entity, FanProcessingType type) {
		class_2487 nbt = entity.getCustomData();

		if (!nbt.method_10545("CreateData"))
			nbt.method_10566("CreateData", new class_2487());
		class_2487 createData = nbt.method_10562("CreateData");

		if (!createData.method_10545("Processing"))
			createData.method_10566("Processing", new class_2487());
		class_2487 processing = createData.method_10562("Processing");

		if (!processing.method_10545("Type") || AllFanProcessingTypes.parseLegacy(processing.method_10558("Type")) != type) {
			processing.method_10582("Type", FanProcessingTypeRegistry.getIdOrThrow(type).toString());
			int timeModifierForStackSize = ((entity.method_6983()
				.method_7947() - 1) / 16) + 1;
			int processingTime =
				(int) (AllConfigs.server().kinetics.fanProcessingTime.get() * timeModifierForStackSize) + 1;
			processing.method_10569("Time", processingTime);
		}

		int value = processing.method_10550("Time") - 1;
		processing.method_10569("Time", value);
		return value;
	}
}
