package com.simibubi.create.content.kinetics.fan.processing;

import java.util.List;
import net.minecraft.class_1297;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2394;
import net.minecraft.class_243;
import net.minecraft.class_2960;
import net.minecraft.class_5819;
import org.jetbrains.annotations.Nullable;

public interface FanProcessingType {
	boolean isValidAt(class_1937 level, class_2338 pos);

	int getPriority();

	boolean canProcess(class_1799 stack, class_1937 level);

	@Nullable
	List<class_1799> process(class_1799 stack, class_1937 level);

	void spawnProcessingParticles(class_1937 level, class_243 pos);

	void morphAirFlow(AirFlowParticleAccess particleAccess, class_5819 random);

	void affectEntity(class_1297 entity, class_1937 level);

	static FanProcessingType parse(String str) {
		class_2960 id = class_2960.method_12829(str);
		if (id == null) {
			return AllFanProcessingTypes.NONE;
		}
		FanProcessingType type = FanProcessingTypeRegistry.getType(id);
		if (type == null) {
			return AllFanProcessingTypes.NONE;
		}
		return type;
	}

	static FanProcessingType getAt(class_1937 level, class_2338 pos) {
		for (FanProcessingType type : FanProcessingTypeRegistry.getSortedTypesView()) {
			if (type.isValidAt(level, pos)) {
				return type;
			}
		}
		return AllFanProcessingTypes.NONE;
	}

	interface AirFlowParticleAccess {
		void setColor(int color);

		void setAlpha(float alpha);

		void spawnExtraParticle(class_2394 options, float speedMultiplier);
	}
}
