package com.simibubi.create.content.kinetics.gauge;

import com.jozufozu.flywheel.backend.Backend;
import com.jozufozu.flywheel.core.PartialModel;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.base.ShaftRenderer;
import com.simibubi.create.content.kinetics.gauge.GaugeBlock.Type;
import com.simibubi.create.foundation.render.CachedBufferer;
import com.simibubi.create.foundation.render.SuperByteBuffer;
import com.simibubi.create.foundation.utility.Iterate;
import net.minecraft.class_1921;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_4597;
import net.minecraft.class_5614;

public class GaugeRenderer extends ShaftRenderer<GaugeBlockEntity> {

	protected GaugeBlock.Type type;

	public static GaugeRenderer speed(class_5614.class_5615 context) {
		return new GaugeRenderer(context, Type.SPEED);
	}

	public static GaugeRenderer stress(class_5614.class_5615 context) {
		return new GaugeRenderer(context, Type.STRESS);
	}

	protected GaugeRenderer(class_5614.class_5615 context, GaugeBlock.Type type) {
		super(context);
		this.type = type;
	}

	@Override
	protected void renderSafe(GaugeBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay) {
		if (Backend.canUseInstancing(be.method_10997())) return;

		super.renderSafe(be, partialTicks, ms, buffer, light, overlay);

		class_2680 gaugeState = be.method_11010();
		GaugeBlockEntity gaugeBE = (GaugeBlockEntity) be;

		PartialModel partialModel = (type == Type.SPEED ? AllPartialModels.GAUGE_HEAD_SPEED : AllPartialModels.GAUGE_HEAD_STRESS);
		SuperByteBuffer headBuffer =
				CachedBufferer.partial(partialModel, gaugeState);
		SuperByteBuffer dialBuffer = CachedBufferer.partial(AllPartialModels.GAUGE_DIAL, gaugeState);

		float dialPivot = 5.75f / 16;
		float progress = class_3532.method_16439(partialTicks, gaugeBE.prevDialState, gaugeBE.dialState);

		for (class_2350 facing : Iterate.directions) {
			if (!((GaugeBlock) gaugeState.method_26204()).shouldRenderHeadOnFace(be.method_10997(), be.method_11016(), gaugeState,
					facing))
				continue;

			class_4588 vb = buffer.getBuffer(class_1921.method_23577());
			rotateBufferTowards(dialBuffer, facing).translate(0, dialPivot, dialPivot)
				.rotate(class_2350.field_11034, (float) (Math.PI / 2 * -progress))
				.translate(0, -dialPivot, -dialPivot)
				.light(light)
				.renderInto(ms, vb);
			rotateBufferTowards(headBuffer, facing).light(light)
				.renderInto(ms, vb);
		}
	}

	protected SuperByteBuffer rotateBufferTowards(SuperByteBuffer buffer, class_2350 target) {
		return buffer.rotateCentered(class_2350.field_11036, (float) ((-target.method_10144() - 90) / 180 * Math.PI));
	}

}
