package com.simibubi.create.content.kinetics.gearbox;

import java.util.EnumMap;
import java.util.Map;
import net.minecraft.class_1944;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2741;
import com.jozufozu.flywheel.api.InstanceData;
import com.jozufozu.flywheel.api.Instancer;
import com.jozufozu.flywheel.api.Material;
import com.jozufozu.flywheel.api.MaterialManager;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.base.KineticBlockEntityInstance;
import com.simibubi.create.content.kinetics.base.flwdata.RotatingData;
import com.simibubi.create.foundation.utility.Iterate;

public class GearboxInstance extends KineticBlockEntityInstance<GearboxBlockEntity> {

    protected final EnumMap<class_2350, RotatingData> keys;
    protected class_2350 sourceFacing;

    public GearboxInstance(MaterialManager materialManager, GearboxBlockEntity blockEntity) {
        super(materialManager, blockEntity);

        keys = new EnumMap<>(class_2350.class);

        final class_2350.class_2351 boxAxis = blockState.method_11654(class_2741.field_12496);

        int blockLight = world.method_8314(class_1944.field_9282, pos);
        int skyLight = world.method_8314(class_1944.field_9284, pos);
        updateSourceFacing();

        Material<RotatingData> rotatingMaterial = getRotatingMaterial();

        for (class_2350 direction : Iterate.directions) {
			final class_2350.class_2351 axis = direction.method_10166();
			if (boxAxis == axis)
				continue;

			Instancer<RotatingData> shaft = rotatingMaterial.getModel(AllPartialModels.SHAFT_HALF, blockState, direction);

			RotatingData key = shaft.createInstance();

			key.setRotationAxis(class_2350.method_10156(class_2350.class_2352.field_11056, axis).method_23955())
					.setRotationalSpeed(getSpeed(direction))
					.setRotationOffset(getRotationOffset(axis)).setColor(blockEntity)
					.setPosition(getInstancePosition())
					.setBlockLight(blockLight)
					.setSkyLight(skyLight);

            keys.put(direction, key);
        }
    }

    private float getSpeed(class_2350 direction) {
        float speed = blockEntity.getSpeed();

        if (speed != 0 && sourceFacing != null) {
            if (sourceFacing.method_10166() == direction.method_10166())
                speed *= sourceFacing == direction ? 1 : -1;
            else if (sourceFacing.method_10171() == direction.method_10171())
                speed *= -1;
        }
        return speed;
    }

    protected void updateSourceFacing() {
        if (blockEntity.hasSource()) {
            class_2338 source = blockEntity.source.method_10059(pos);
            sourceFacing = class_2350.method_10147(source.method_10263(), source.method_10264(), source.method_10260());
        } else {
            sourceFacing = null;
        }
    }

    @Override
    public void update() {
        updateSourceFacing();
        for (Map.Entry<class_2350, RotatingData> key : keys.entrySet()) {
            class_2350 direction = key.getKey();
            class_2350.class_2351 axis = direction.method_10166();

            updateRotation(key.getValue(), axis, getSpeed(direction));
        }
    }

    @Override
    public void updateLight() {
        relight(pos, keys.values().stream());
    }

    @Override
    public void remove() {
        keys.values().forEach(InstanceData::delete);
        keys.clear();
    }
}
