package com.simibubi.create.content.kinetics.mechanicalArm;

import org.apache.commons.lang3.mutable.MutableBoolean;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.kinetics.base.KineticBlock;
import com.simibubi.create.content.kinetics.mechanicalArm.ArmBlockEntity.Phase;
import com.simibubi.create.content.kinetics.simpleRelays.ICogWheel;
import com.simibubi.create.foundation.block.IBE;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2746;
import net.minecraft.class_3726;
import net.minecraft.class_3965;

public class ArmBlock extends KineticBlock implements IBE<ArmBlockEntity>, ICogWheel {

	public static final class_2746 CEILING = class_2746.method_11825("ceiling");

	public ArmBlock(class_2251 properties) {
		super(properties);
		method_9590(method_9564().method_11657(CEILING, false));
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> p_206840_1_) {
		super.method_9515(p_206840_1_.method_11667(CEILING));
	}

	@Override
	public class_2680 method_9605(class_1750 ctx) {
		return method_9564().method_11657(CEILING, ctx.method_8038() == class_2350.field_11033);
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 p_220053_2_, class_2338 p_220053_3_,
		class_3726 p_220053_4_) {
		return state.method_11654(CEILING) ? AllShapes.MECHANICAL_ARM_CEILING : AllShapes.MECHANICAL_ARM;
	}
	
	@Override
	public void method_9615(class_2680 state, class_1937 world, class_2338 pos, class_2680 oldState, boolean isMoving) {
		super.method_9615(state, world, pos, oldState, isMoving);
		withBlockEntityDo(world, pos, ArmBlockEntity::redstoneUpdate);
	}
	
	@Override
	public void method_9612(class_2680 state, class_1937 world, class_2338 pos, class_2248 p_220069_4_,
		class_2338 p_220069_5_, boolean p_220069_6_) {
		withBlockEntityDo(world, pos, ArmBlockEntity::redstoneUpdate);
	}
	
	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return class_2351.field_11052;
	}

	@Override
	public Class<ArmBlockEntity> getBlockEntityClass() {
		return ArmBlockEntity.class;
	}

	@Override
	public class_2591<? extends ArmBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.MECHANICAL_ARM.get();
	}
	
	@Override
	public class_1269 method_9534(class_2680 p_225533_1_, class_1937 world, class_2338 pos, class_1657 player,
		class_1268 hand, class_3965 p_225533_6_) {
		class_1799 heldItem = player.method_5998(hand);

		if (AllItems.GOGGLES.isIn(heldItem)) {
			class_1269 gogglesResult = onBlockEntityUse(world, pos, ate -> {
				if (ate.goggles)
					return class_1269.field_5811;
				ate.goggles = true;
				ate.notifyUpdate();
				return class_1269.field_5812;
			});
			if (gogglesResult.method_23665())
				return gogglesResult;
		}

		MutableBoolean success = new MutableBoolean(false);
		withBlockEntityDo(world, pos, be -> {
			if (be.heldItem.method_7960())
				return;
			success.setTrue();
			if (world.field_9236)
				return;
			player.method_31548().method_7398(be.heldItem);
			be.heldItem = class_1799.field_8037;
			be.phase = Phase.SEARCH_INPUTS;
			be.method_5431();
			be.sendData();
		});
		
		return success.booleanValue() ? class_1269.field_5812 : class_1269.field_5811;
	}

}
