package com.simibubi.create.content.kinetics.mechanicalArm;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import net.minecraft.class_124;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_239;
import net.minecraft.class_2586;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_3965;
import net.minecraft.class_746;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllPackets;
import com.simibubi.create.CreateClient;
import com.simibubi.create.content.kinetics.mechanicalArm.ArmInteractionPoint.Mode;
import com.simibubi.create.foundation.utility.Lang;

public class ArmInteractionPointHandler {

	static List<ArmInteractionPoint> currentSelection = new ArrayList<>();
	static class_1799 currentItem;

	static long lastBlockPos = -1;

	public static class_1269 rightClickingBlocksSelectsThem(class_1657 player, class_1937 world, class_1268 hand, class_3965 hitResult) {
		if (currentItem == null)
			return class_1269.field_5811;
		class_2338 pos = hitResult.method_17777();//event.getPos();
//		Level world = event.getWorld();
		if (!world.field_9236)
			return class_1269.field_5811;
//		Player player = event.getPlayer();
		if (player != null && player.method_7325())
			return class_1269.field_5811;

		ArmInteractionPoint selected = getSelected(pos);
		class_2680 state = world.method_8320(pos);

		if (selected == null) {
			ArmInteractionPoint point = ArmInteractionPoint.create(world, pos, state);
			if (point == null)
				return class_1269.field_5811;
			selected = point;
			put(point);
		}

		selected.cycleMode();
		if (player != null) {
			Mode mode = selected.getMode();
			Lang.builder()
				.translate(mode.getTranslationKey(), Lang.blockName(state)
					.style(class_124.field_1068))
				.color(mode.getColor())
				.sendStatus(player);
		}

//		event.setCanceled(true);
//		event.setCancellationResult(InteractionResult.SUCCESS);
		return class_1269.field_5812;
	}

	public static class_1269 leftClickingBlocksDeselectsThem(class_1657 player, class_1937 world, class_1268 hand, class_2338 pos, class_2350 direction) {
		if (currentItem == null)
			return class_1269.field_5811;
		if (!world.field_9236)
			return class_1269.field_5811;
		if (player.method_7325())
			return class_1269.field_5811;
//		BlockPos pos = event.getPos();
		if (remove(pos) != null) {
//			event.setCanceled(true);
//			event.setCancellationResult(InteractionResult.SUCCESS);
			return class_1269.field_5812;
		}
		return class_1269.field_5811;
	}

	public static void flushSettings(class_2338 pos) {
		if (currentSelection == null)
			return;

		int removed = 0;
		for (Iterator<ArmInteractionPoint> iterator = currentSelection.iterator(); iterator.hasNext();) {
			ArmInteractionPoint point = iterator.next();
			if (point.getPos()
				.method_19771(pos, ArmBlockEntity.getRange()))
				continue;
			iterator.remove();
			removed++;
		}

		class_746 player = class_310.method_1551().field_1724;
		if (removed > 0) {
			Lang.builder()
				.translate("mechanical_arm.points_outside_range", removed)
				.style(class_124.field_1061)
				.sendStatus(player);
		} else {
			int inputs = 0;
			int outputs = 0;
			for (ArmInteractionPoint armInteractionPoint : currentSelection) {
				if (armInteractionPoint.getMode() == Mode.DEPOSIT)
					outputs++;
				else
					inputs++;
			}
			if (inputs + outputs > 0)
				Lang.builder()
					.translate("mechanical_arm.summary", inputs, outputs)
					.style(class_124.field_1068)
					.sendStatus(player);
		}

		AllPackets.getChannel().sendToServer(new ArmPlacementPacket(currentSelection, pos));
		currentSelection.clear();
		currentItem = null;
	}

	public static void tick() {
		class_1657 player = class_310.method_1551().field_1724;

		if (player == null)
			return;

		class_1799 heldItemMainhand = player.method_6047();
		if (!AllBlocks.MECHANICAL_ARM.isIn(heldItemMainhand)) {
			currentItem = null;
		} else {
			if (heldItemMainhand != currentItem) {
				currentSelection.clear();
				currentItem = heldItemMainhand;
			}

			drawOutlines(currentSelection);
		}

		checkForWrench(heldItemMainhand);
	}

	private static void checkForWrench(class_1799 heldItem) {
		if (!AllItems.WRENCH.isIn(heldItem)) {
			return;
		}

		class_239 objectMouseOver = class_310.method_1551().field_1765;
		if (!(objectMouseOver instanceof class_3965)) {
			return;
		}

		class_3965 result = (class_3965) objectMouseOver;
		class_2338 pos = result.method_17777();

		class_2586 be = class_310.method_1551().field_1687.method_8321(pos);
		if (!(be instanceof ArmBlockEntity)) {
			lastBlockPos = -1;
			currentSelection.clear();
			return;
		}

		if (lastBlockPos == -1 || lastBlockPos != pos.method_10063()) {
			currentSelection.clear();
			ArmBlockEntity arm = (ArmBlockEntity) be;
			arm.inputs.forEach(ArmInteractionPointHandler::put);
			arm.outputs.forEach(ArmInteractionPointHandler::put);
			lastBlockPos = pos.method_10063();
		}

		if (lastBlockPos != -1) {
			drawOutlines(currentSelection);
		}
	}

	private static void drawOutlines(Collection<ArmInteractionPoint> selection) {
		for (Iterator<ArmInteractionPoint> iterator = selection.iterator(); iterator.hasNext();) {
			ArmInteractionPoint point = iterator.next();

			if (!point.isValid()) {
				iterator.remove();
				continue;
			}

			class_1937 level = point.getLevel();
			class_2338 pos = point.getPos();
			class_2680 state = level.method_8320(pos);
			class_265 shape = state.method_26218(level, pos);
			if (shape.method_1110())
				continue;

			int color = point.getMode()
				.getColor();
			CreateClient.OUTLINER.showAABB(point, shape.method_1107()
				.method_996(pos))
				.colored(color)
				.lineWidth(1 / 16f);
		}
	}

	private static void put(ArmInteractionPoint point) {
		currentSelection.add(point);
	}

	private static ArmInteractionPoint remove(class_2338 pos) {
		ArmInteractionPoint result = getSelected(pos);
		if (result != null)
			currentSelection.remove(result);
		return result;
	}

	private static ArmInteractionPoint getSelected(class_2338 pos) {
		for (ArmInteractionPoint point : currentSelection)
			if (point.getPos()
				.equals(pos))
				return point;
		return null;
	}

}
