package com.simibubi.create.content.kinetics.mechanicalArm;

import java.util.Collection;

import com.simibubi.create.foundation.networking.SimplePacketBase;

import com.tterrag.registrate.fabric.EnvExecutor;

import net.fabricmc.api.EnvType;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2520;
import net.minecraft.class_2540;
import net.minecraft.class_2586;
import net.minecraft.class_3222;

public class ArmPlacementPacket extends SimplePacketBase {

	private Collection<ArmInteractionPoint> points;
	private class_2499 receivedTag;
	private class_2338 pos;

	public ArmPlacementPacket(Collection<ArmInteractionPoint> points, class_2338 pos) {
		this.points = points;
		this.pos = pos;
	}

	public ArmPlacementPacket(class_2540 buffer) {
		class_2487 nbt = buffer.method_10798();
		receivedTag = nbt.method_10554("Points", class_2520.field_33260);
		pos = buffer.method_10811();
	}

	@Override
	public void write(class_2540 buffer) {
		class_2487 nbt = new class_2487();
		class_2499 pointsNBT = new class_2499();
		points.stream()
			.map(aip -> aip.serialize(pos))
			.forEach(pointsNBT::add);
		nbt.method_10566("Points", pointsNBT);
		buffer.method_10794(nbt);
		buffer.method_10807(pos);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (player == null)
				return;
			class_1937 world = player.method_37908();
			if (world == null || !world.method_8477(pos))
				return;
			class_2586 blockEntity = world.method_8321(pos);
			if (!(blockEntity instanceof ArmBlockEntity))
				return;

			ArmBlockEntity arm = (ArmBlockEntity) blockEntity;
			arm.interactionPointTag = receivedTag;
		});
		return true;
	}

	public static class ClientBoundRequest extends SimplePacketBase {

		class_2338 pos;

		public ClientBoundRequest(class_2338 pos) {
			this.pos = pos;
		}

		public ClientBoundRequest(class_2540 buffer) {
			this.pos = buffer.method_10811();
		}

		@Override
		public void write(class_2540 buffer) {
			buffer.method_10807(pos);
		}

		@Override
		public boolean handle(Context context) {
			context.enqueueWork(() -> EnvExecutor.runWhenOn(EnvType.CLIENT,
				() -> () -> ArmInteractionPointHandler.flushSettings(pos)));
			return true;
		}

	}

}
