package com.simibubi.create.content.kinetics.millstone;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.kinetics.base.KineticBlock;
import com.simibubi.create.content.kinetics.simpleRelays.ICogWheel;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.utility.Iterate;
import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemHandlerHelper;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;

import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.Storage;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_10;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1297;
import net.minecraft.class_1542;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3726;
import net.minecraft.class_3965;
import net.minecraft.class_4538;

public class MillstoneBlock extends KineticBlock implements IBE<MillstoneBlockEntity>, ICogWheel {

	public MillstoneBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return AllShapes.MILLSTONE;
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return face == class_2350.field_11033;
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 worldIn, class_2338 pos, class_1657 player, class_1268 handIn,
		class_3965 hit) {
		if (!player.method_5998(handIn)
			.method_7960())
			return class_1269.field_5811;
		if (worldIn.field_9236)
			return class_1269.field_5812;

		withBlockEntityDo(worldIn, pos, millstone -> {
			boolean emptyOutput = true;
			ItemStackHandler inv = millstone.outputInv;
			for (int slot = 0; slot < inv.getSlotCount(); slot++) {
				class_1799 stackInSlot = inv.getStackInSlot(slot);
				if (!stackInSlot.method_7960())
					emptyOutput = false;
				player.method_31548()
					.method_7398(stackInSlot);
				inv.setStackInSlot(slot, class_1799.field_8037);
			}

			if (emptyOutput) {
				inv = millstone.inputInv;
				for (int slot = 0; slot < inv.getSlotCount(); slot++) {
					player.method_31548()
						.method_7398(inv.getStackInSlot(slot));
					inv.setStackInSlot(slot, class_1799.field_8037);
				}
			}

			millstone.method_5431();
			millstone.sendData();
		});

		return class_1269.field_5812;
	}

	@Override
	public void method_9502(class_1922 worldIn, class_1297 entityIn) {
		super.method_9502(worldIn, entityIn);

		if (entityIn.method_37908().field_9236)
			return;
		if (!(entityIn instanceof class_1542))
			return;
		if (!entityIn.method_5805())
			return;

		MillstoneBlockEntity millstone = null;
		for (class_2338 pos : Iterate.hereAndBelow(entityIn.method_24515()))
			if (millstone == null)
				millstone = getBlockEntity(worldIn, pos);

		if (millstone == null)
			return;

		class_1542 itemEntity = (class_1542) entityIn;
		Storage<ItemVariant> handler = millstone.getItemStorage(null);
		if (handler == null)
			return;

		try (Transaction t = TransferUtil.getTransaction()) {
			class_1799 inEntity = itemEntity.method_6983();
			long inserted = handler.insert(ItemVariant.of(inEntity), inEntity.method_7947(), t);
			if (inserted == inEntity.method_7947())
				itemEntity.method_31472();
			else itemEntity.method_6979(ItemHandlerHelper.copyStackWithSize(inEntity, (int) (inEntity.method_7947() - inserted)));
			t.commit();
		}
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return class_2351.field_11052;
	}

	@Override
	public Class<MillstoneBlockEntity> getBlockEntityClass() {
		return MillstoneBlockEntity.class;
	}

	@Override
	public class_2591<? extends MillstoneBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.MILLSTONE.get();
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

}
