package com.simibubi.create.content.kinetics.motor;

import java.util.List;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_243;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_4587;
import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.kinetics.base.GeneratingKineticBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBoxTransform;
import com.simibubi.create.foundation.blockEntity.behaviour.scrollValue.ScrollValueBehaviour;
import com.simibubi.create.foundation.utility.AngleHelper;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.VecHelper;

public class CreativeMotorBlockEntity extends GeneratingKineticBlockEntity {

	public static final int DEFAULT_SPEED = 16;
	public static final int MAX_SPEED = 256;

	protected ScrollValueBehaviour generatedSpeed;

	public CreativeMotorBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {
		super.addBehaviours(behaviours);
		int max = MAX_SPEED;
		generatedSpeed = new KineticScrollValueBehaviour(Lang.translateDirect("kinetics.creative_motor.rotation_speed"),
			this, new MotorValueBox());
		generatedSpeed.between(-max, max);
		generatedSpeed.value = DEFAULT_SPEED;
		generatedSpeed.withCallback(i -> this.updateGeneratedRotation());
		behaviours.add(generatedSpeed);
	}

	@Override
	public void initialize() {
		super.initialize();
		if (!hasSource() || getGeneratedSpeed() > getTheoreticalSpeed())
			updateGeneratedRotation();
	}

	@Override
	public float getGeneratedSpeed() {
		if (!AllBlocks.CREATIVE_MOTOR.has(method_11010()))
			return 0;
		return convertToDirection(generatedSpeed.getValue(), method_11010().method_11654(CreativeMotorBlock.FACING));
	}

	class MotorValueBox extends ValueBoxTransform.Sided {

		@Override
		protected class_243 getSouthLocation() {
			return VecHelper.voxelSpace(8, 8, 12.5);
		}

		@Override
		public class_243 getLocalOffset(class_2680 state) {
			class_2350 facing = state.method_11654(CreativeMotorBlock.FACING);
			return super.getLocalOffset(state).method_1019(class_243.method_24954(facing.method_10163())
				.method_1021(-1 / 16f));
		}

		@Override
		public void rotate(class_2680 state, class_4587 ms) {
			super.rotate(state, ms);
			class_2350 facing = state.method_11654(CreativeMotorBlock.FACING);
			if (facing.method_10166() == class_2351.field_11052)
				return;
			if (getSide() != class_2350.field_11036)
				return;
			TransformStack.cast(ms)
				.rotateZ(-AngleHelper.horizontalAngle(facing) + 180);
		}

		@Override
		protected boolean isSideActive(class_2680 state, class_2350 direction) {
			class_2350 facing = state.method_11654(CreativeMotorBlock.FACING);
			if (facing.method_10166() != class_2351.field_11052 && direction == class_2350.field_11033)
				return false;
			return direction.method_10166() != facing.method_10166();
		}

	}

}
