package com.simibubi.create.content.kinetics.motor;

import com.google.common.collect.ImmutableList;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBoxTransform;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueSettingsBoard;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueSettingsFormatter;
import com.simibubi.create.foundation.blockEntity.behaviour.scrollValue.ScrollValueBehaviour;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;
import net.minecraft.class_124;
import net.minecraft.class_1657;
import net.minecraft.class_2561;
import net.minecraft.class_3965;
import net.minecraft.class_5250;

public class KineticScrollValueBehaviour extends ScrollValueBehaviour {

	public KineticScrollValueBehaviour(class_2561 label, SmartBlockEntity be, ValueBoxTransform slot) {
		super(label, be, slot);
		withFormatter(v -> String.valueOf(Math.abs(v)));
	}

	@Override
	public ValueSettingsBoard createBoard(class_1657 player, class_3965 hitResult) {
		ImmutableList<class_2561> rows = ImmutableList.of(Components.literal("\u27f3")
			.method_27692(class_124.field_1067),
			Components.literal("\u27f2")
				.method_27692(class_124.field_1067));
		ValueSettingsFormatter formatter = new ValueSettingsFormatter(this::formatSettings);
		return new ValueSettingsBoard(label, 256, 32, rows, formatter);
	}

	@Override
	public void setValueSettings(class_1657 player, ValueSettings valueSetting, boolean ctrlHeld) {
		int value = Math.max(1, valueSetting.value());
		if (!valueSetting.equals(getValueSettings()))
			playFeedbackSound(this);
		setValue(valueSetting.row() == 0 ? -value : value);
	}

	@Override
	public ValueSettings getValueSettings() {
		return new ValueSettings(value < 0 ? 0 : 1, Math.abs(value));
	}

	public class_5250 formatSettings(ValueSettings settings) {
		return Lang.number(Math.max(1, Math.abs(settings.value())))
			.add(Lang.text(settings.row() == 0 ? "\u27f3" : "\u27f2")
				.style(class_124.field_1067))
			.component();
	}
	
	@Override
	public String getClipboardKey() {
		return "Speed";
	}

}