package com.simibubi.create.content.kinetics.press;

import java.util.List;
import java.util.Set;

import javax.annotation.ParametersAreNonnullByDefault;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.compat.recipeViewerCommon.SequencedAssemblySubCategoryType;
import com.simibubi.create.content.processing.recipe.ProcessingRecipe;
import com.simibubi.create.content.processing.recipe.ProcessingRecipeBuilder.ProcessingRecipeParams;
import com.simibubi.create.content.processing.sequenced.IAssemblyRecipe;
import com.simibubi.create.foundation.utility.Lang;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1263;
import net.minecraft.class_1856;
import net.minecraft.class_1935;
import net.minecraft.class_1937;
import net.minecraft.class_2561;

@ParametersAreNonnullByDefault
public class PressingRecipe extends ProcessingRecipe<class_1263> implements IAssemblyRecipe {

	public PressingRecipe(ProcessingRecipeParams params) {
		super(AllRecipeTypes.PRESSING, params);
	}

	@Override
	public boolean method_8115(class_1263 inv, class_1937 worldIn) {
		if (inv.method_5442())
			return false;
		return ingredients.get(0)
			.method_8093(inv.method_5438(0));
	}

	@Override
	protected int getMaxInputCount() {
		return 1;
	}

	@Override
	protected int getMaxOutputCount() {
		return 2;
	}

	@Override
	public void addAssemblyIngredients(List<class_1856> list) {}

	@Override
	@Environment(EnvType.CLIENT)
	public class_2561 getDescriptionForAssembly() {
		return Lang.translateDirect("recipe.assembly.pressing");
	}

	@Override
	public void addRequiredMachines(Set<class_1935> list) {
		list.add(AllBlocks.MECHANICAL_PRESS.get());
	}

	@Override
	public SequencedAssemblySubCategoryType getJEISubCategory() {
		return SequencedAssemblySubCategoryType.PRESSING;
	}

}
