package com.simibubi.create.content.kinetics.saw;

import java.util.Optional;

import com.jozufozu.flywheel.core.virtual.VirtualRenderWorld;
import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import com.simibubi.create.content.contraptions.render.ContraptionMatrices;
import com.simibubi.create.content.kinetics.base.BlockBreakingMovementBehaviour;
import com.simibubi.create.foundation.damageTypes.CreateDamageSources;
import com.simibubi.create.foundation.utility.AbstractBlockBreakQueue;
import com.simibubi.create.foundation.utility.TreeCutter;
import com.simibubi.create.foundation.utility.VecHelper;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemHandlerHelper;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1282;
import net.minecraft.class_1542;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_3481;
import net.minecraft.class_4597;

public class SawMovementBehaviour extends BlockBreakingMovementBehaviour {

	@Override
	public boolean isActive(MovementContext context) {
		return super.isActive(context)
			&& !VecHelper.isVecPointingTowards(context.relativeMotion, context.state.method_11654(SawBlock.FACING)
				.method_10153());
	}

	@Override
	public class_243 getActiveAreaOffset(MovementContext context) {
		return class_243.method_24954(context.state.method_11654(SawBlock.FACING)
			.method_10163())
			.method_1021(.65f);
	}

	@Override
	public void visitNewPosition(MovementContext context, class_2338 pos) {
		super.visitNewPosition(context, pos);
		class_243 facingVec = class_243.method_24954(context.state.method_11654(SawBlock.FACING)
			.method_10163());
		facingVec = context.rotation.apply(facingVec);

		class_2350 closestToFacing = class_2350.method_10142(facingVec.field_1352, facingVec.field_1351, facingVec.field_1350);
		if (closestToFacing.method_10166()
			.method_10178() && context.data.method_10545("BreakingPos")) {
			context.data.method_10551("BreakingPos");
			context.stall = false;
		}
	}

	@Override
	public boolean canBreak(class_1937 world, class_2338 breakingPos, class_2680 state) {
		return super.canBreak(world, breakingPos, state) && SawBlockEntity.isSawable(state);
	}

	@Override
	protected void onBlockBroken(MovementContext context, class_2338 pos, class_2680 brokenState) {
		if (brokenState.method_26164(class_3481.field_15503))
			return;

		Optional<AbstractBlockBreakQueue> dynamicTree = TreeCutter.findDynamicTree(brokenState.method_26204(), pos);
		if (dynamicTree.isPresent()) {
			dynamicTree.get()
				.destroyBlocks(context.world, null, (stack, dropPos) -> dropItemFromCutTree(context, stack, dropPos));
			return;
		}

		TreeCutter.findTree(context.world, pos)
			.destroyBlocks(context.world, null, (stack, dropPos) -> dropItemFromCutTree(context, stack, dropPos));
	}

	public void dropItemFromCutTree(MovementContext context, class_2338 pos, class_1799 stack) {
		long inserted = TransferUtil.insertItem(context.contraption.getSharedInventory(), stack);
		if (inserted == stack.method_7947())
			return;
		long remaining = stack.method_7947() - inserted;
		class_1799 remainder = stack.method_7972();
		remainder.method_7939((int) remaining);

		class_1937 world = context.world;
		class_243 dropPos = VecHelper.getCenterOf(pos);
		float distance = context.position == null ? 1 : (float) dropPos.method_1022(context.position);
		class_1542 entity = new class_1542(world, dropPos.field_1352, dropPos.field_1351, dropPos.field_1350, remainder);
		entity.method_18799(context.relativeMotion.method_1021(distance / 20f));
		world.method_8649(entity);
	}

	@Override
	@Environment(value = EnvType.CLIENT)
	public void renderInContraption(MovementContext context, VirtualRenderWorld renderWorld,
		ContraptionMatrices matrices, class_4597 buffer) {
		SawRenderer.renderInContraption(context, renderWorld, matrices, buffer);
	}

	@Override
	protected boolean shouldDestroyStartBlock(class_2680 stateToBreak) {
		return !TreeCutter.canDynamicTreeCutFrom(stateToBreak.method_26204());
	}

	@Override
	protected class_1282 getDamageSource(class_1937 level) {
		return CreateDamageSources.saw(level);
	}
}
