package com.simibubi.create.content.kinetics.simpleRelays;

import com.jozufozu.flywheel.backend.Backend;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.kinetics.base.KineticBlockEntityRenderer;
import com.simibubi.create.foundation.render.CachedBufferer;
import com.simibubi.create.foundation.render.SuperByteBuffer;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import net.minecraft.class_1921;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5614.class_5615;

public class BracketedKineticBlockEntityRenderer extends KineticBlockEntityRenderer<BracketedKineticBlockEntity> {

	public BracketedKineticBlockEntityRenderer(class_5615 context) {
		super(context);
	}

	@Override
	protected void renderSafe(BracketedKineticBlockEntity be, float partialTicks, class_4587 ms,
		class_4597 buffer, int light, int overlay) {

		if (Backend.canUseInstancing(be.method_10997()))
			return;

		if (!AllBlocks.LARGE_COGWHEEL.has(be.method_11010())) {
			super.renderSafe(be, partialTicks, ms, buffer, light, overlay);
			return;
		}

		// Large cogs sometimes have to offset their teeth by 11.25 degrees in order to
		// mesh properly

		class_2351 axis = getRotationAxisOf(be);
		class_2350 facing = class_2350.method_10169(axis, class_2352.field_11056);
		renderRotatingBuffer(be,
			CachedBufferer.partialFacingVertical(AllPartialModels.SHAFTLESS_LARGE_COGWHEEL, be.method_11010(), facing),
			ms, buffer.getBuffer(class_1921.method_23577()), light);

		float angle = getAngleForLargeCogShaft(be, axis);
		SuperByteBuffer shaft =
			CachedBufferer.partialFacingVertical(AllPartialModels.COGWHEEL_SHAFT, be.method_11010(), facing);
		kineticRotationTransform(shaft, be, axis, angle, light);
		shaft.renderInto(ms, buffer.getBuffer(class_1921.method_23577()));

	}

	public static float getAngleForLargeCogShaft(SimpleKineticBlockEntity be, class_2351 axis) {
		class_2338 pos = be.method_11016();
		float offset = getShaftAngleOffset(axis, pos);
		float time = AnimationTickHolder.getRenderTime(be.method_10997());
		float angle = ((time * be.getSpeed() * 3f / 10 + offset) % 360) / 180 * (float) Math.PI;
		return angle;
	}

	public static float getShaftAngleOffset(class_2351 axis, class_2338 pos) {
		float offset = 0;
		double d = (((axis == class_2351.field_11048) ? 0 : pos.method_10263()) + ((axis == class_2351.field_11052) ? 0 : pos.method_10264())
			+ ((axis == class_2351.field_11051) ? 0 : pos.method_10260())) % 2;
		if (d == 0)
			offset = 22.5f;
		return offset;
	}

}
