package com.simibubi.create.content.kinetics.simpleRelays;

import java.util.Collections;
import java.util.List;
import java.util.function.Supplier;

import com.jozufozu.flywheel.core.model.ModelUtil;
import com.jozufozu.flywheel.core.virtual.VirtualEmptyBlockGetter;
import com.simibubi.create.content.decoration.bracket.BracketedBlockEntityBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;

import net.fabricmc.fabric.api.renderer.v1.model.FabricBakedModel;
import net.fabricmc.fabric.api.renderer.v1.model.ForwardingBakedModel;
import net.fabricmc.fabric.api.renderer.v1.render.RenderContext;
import net.minecraft.class_1087;
import net.minecraft.class_1920;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_5819;

public class BracketedKineticBlockModel extends ForwardingBakedModel {

	public BracketedKineticBlockModel(class_1087 template) {
		wrapped = template;
	}

	@Override
	public boolean isVanillaAdapter() {
		return false;
	}

	@Override
	public void emitBlockQuads(class_1920 blockView, class_2680 state, class_2338 pos, Supplier<class_5819> randomSupplier, RenderContext context) {
		if (!VirtualEmptyBlockGetter.is(blockView)) {
			BracketedModelData data = new BracketedModelData();
			BracketedBlockEntityBehaviour attachmentBehaviour =
				BlockEntityBehaviour.get(blockView, pos, BracketedBlockEntityBehaviour.TYPE);
			if (attachmentBehaviour != null)
				data.putBracket(attachmentBehaviour.getBracket());

			class_1087 bracket = data.getBracket();
			if (bracket != null)
				((FabricBakedModel) bracket).emitBlockQuads(blockView, state, pos, randomSupplier, context);
			return;
		}
		super.emitBlockQuads(blockView, state, pos, randomSupplier, context);
	}

	private static class BracketedModelData {
		private class_1087 bracket;

		public void putBracket(class_2680 state) {
			if (state != null) {
				this.bracket = class_310.method_1551()
					.method_1541()
					.method_3349(state);
			}
		}

		public class_1087 getBracket() {
			return bracket;
		}
	}

}
