package com.simibubi.create.content.kinetics.simpleRelays.encased;

import java.util.function.Supplier;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.decoration.encasing.EncasedBlock;
import com.simibubi.create.content.kinetics.base.AbstractEncasedShaftBlock;
import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.content.kinetics.base.RotatedPillarKineticBlock;
import com.simibubi.create.content.schematics.requirement.ISpecialBlockItemRequirement;
import com.simibubi.create.content.schematics.requirement.ItemRequirement;
import com.simibubi.create.foundation.block.IBE;

import net.fabricmc.fabric.api.block.BlockPickInteractionAware;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_239;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_3965;

public class EncasedShaftBlock extends AbstractEncasedShaftBlock
	implements IBE<KineticBlockEntity>, ISpecialBlockItemRequirement, BlockPickInteractionAware, EncasedBlock {

	private final Supplier<class_2248> casing;

	public EncasedShaftBlock(class_2251 properties, Supplier<class_2248> casing) {
		super(properties);
		this.casing = casing;
	}

	@Override
	public class_1269 onSneakWrenched(class_2680 state, class_1838 context) {
		if (context.method_8045().field_9236)
			return class_1269.field_5812;
		context.method_8045()
			.method_20290(2001, context.method_8037(), class_2248.method_9507(state));
		KineticBlockEntity.switchToBlockState(context.method_8045(), context.method_8037(),
			AllBlocks.SHAFT.getDefaultState()
				.method_11657(AXIS, state.method_11654(AXIS)));
		return class_1269.field_5812;
	}

	@Override
	public class_1799 getPickedStack(class_2680 state, class_1922 view, class_2338 pos, @Nullable class_1657 player, @Nullable class_239 target) {
		if (target instanceof class_3965)
			return ((class_3965) target).method_17780()
				.method_10166() == getRotationAxis(state) ? AllBlocks.SHAFT.asStack() : getCasing().method_8389().method_7854();
		return class_1799.field_8037;
	}

	@Override
	public ItemRequirement getRequiredItems(class_2680 state, class_2586 be) {
		return ItemRequirement.of(AllBlocks.SHAFT.getDefaultState(), be);
	}

	@Override
	public Class<KineticBlockEntity> getBlockEntityClass() {
		return KineticBlockEntity.class;
	}

	@Override
	public class_2591<? extends KineticBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.ENCASED_SHAFT.get();
	}

	@Override
	public class_2248 getCasing() {
		return casing.get();
	}

	@Override
	public void handleEncasing(class_2680 state, class_1937 level, class_2338 pos, class_1799 heldItem, class_1657 player, class_1268 hand,
	    class_3965 ray) {
		KineticBlockEntity.switchToBlockState(level, pos, method_9564()
				.method_11657(RotatedPillarKineticBlock.AXIS, state.method_11654(RotatedPillarKineticBlock.AXIS)));
	}
}
