package com.simibubi.create.content.kinetics.speedController;

import java.util.function.Predicate;

import javax.annotation.ParametersAreNonnullByDefault;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3726;
import net.minecraft.class_3965;
import net.minecraft.class_6328;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.kinetics.base.HorizontalAxisKineticBlock;
import com.simibubi.create.content.kinetics.simpleRelays.CogWheelBlock;
import com.simibubi.create.content.kinetics.simpleRelays.ICogWheel;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.placement.IPlacementHelper;
import com.simibubi.create.foundation.placement.PlacementHelpers;
import com.simibubi.create.foundation.placement.PlacementOffset;

@ParametersAreNonnullByDefault
@class_6328
public class SpeedControllerBlock extends HorizontalAxisKineticBlock implements IBE<SpeedControllerBlockEntity> {

	private static final int placementHelperId = PlacementHelpers.register(new PlacementHelper());

	public SpeedControllerBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2680 above = context.method_8045()
			.method_8320(context.method_8037()
				.method_10084());
		if (ICogWheel.isLargeCog(above) && above.method_11654(CogWheelBlock.AXIS)
			.method_10179())
			return method_9564().method_11657(HORIZONTAL_AXIS, above.method_11654(CogWheelBlock.AXIS) == class_2351.field_11048 ? class_2351.field_11051 : class_2351.field_11048);
		return super.method_9605(context);
	}

	@Override
	public void method_9612(class_2680 state, class_1937 world, class_2338 pos, class_2248 p_220069_4_, class_2338 neighbourPos,
		boolean p_220069_6_) {
		if (neighbourPos.equals(pos.method_10084()))
			withBlockEntityDo(world, pos, SpeedControllerBlockEntity::updateBracket);
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand,
		class_3965 ray) {

		class_1799 heldItem = player.method_5998(hand);
		IPlacementHelper helper = PlacementHelpers.get(placementHelperId);
		if (helper.matchesItem(heldItem))
			return helper.getOffset(player, world, state, pos, ray).placeInWorld(world, (class_1747) heldItem.method_7909(), player, hand, ray);

		return class_1269.field_5811;
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return AllShapes.SPEED_CONTROLLER;
	}

	@class_6328
	private static class PlacementHelper implements IPlacementHelper {
		@Override
		public Predicate<class_1799> getItemPredicate() {
			return ((Predicate<class_1799>) ICogWheel::isLargeCogItem).and(ICogWheel::isDedicatedCogItem);
		}

		@Override
		public Predicate<class_2680> getStatePredicate() {
			return AllBlocks.ROTATION_SPEED_CONTROLLER::has;
		}

		@Override
		public PlacementOffset getOffset(class_1657 player, class_1937 world, class_2680 state, class_2338 pos, class_3965 ray) {
			class_2338 newPos = pos.method_10084();
			if (!world.method_8320(newPos)
				.method_45474())
				return PlacementOffset.fail();

			class_2351 newAxis = state.method_11654(HORIZONTAL_AXIS) == class_2351.field_11048 ? class_2351.field_11051 : class_2351.field_11048;

			if (!CogWheelBlock.isValidCogwheelPosition(true, world, newPos, newAxis))
				return PlacementOffset.fail();

			return PlacementOffset.success(newPos, s -> s.method_11657(CogWheelBlock.AXIS, newAxis));
		}
	}

	@Override
	public Class<SpeedControllerBlockEntity> getBlockEntityClass() {
		return SpeedControllerBlockEntity.class;
	}
	
	@Override
	public class_2591<? extends SpeedControllerBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.ROTATION_SPEED_CONTROLLER.get();
	}
}
