package com.simibubi.create.content.kinetics.steamEngine;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.content.kinetics.simpleRelays.AbstractShaftBlock;
import com.simibubi.create.content.kinetics.simpleRelays.ShaftBlock;
import com.simibubi.create.foundation.placement.IPlacementHelper;
import com.simibubi.create.foundation.placement.PlacementHelpers;
import com.simibubi.create.foundation.utility.Iterate;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2464;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3726;
import net.minecraft.class_3965;
import net.minecraft.class_4538;
import net.minecraft.class_5819;

public class PoweredShaftBlock extends AbstractShaftBlock {

	public PoweredShaftBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public class_265 method_9530(class_2680 pState, class_1922 pLevel, class_2338 pPos, class_3726 pContext) {
		return AllShapes.EIGHT_VOXEL_POLE.get(pState.method_11654(AXIS));
	}

	@Override
	public class_2591<? extends KineticBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.POWERED_SHAFT.get();
	}

	@Override
	public class_1269 method_9534(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_1657 pPlayer, class_1268 pHand,
		class_3965 pHit) {
		if (pPlayer.method_5715() || !pPlayer.method_7294())
			return class_1269.field_5811;

		class_1799 heldItem = pPlayer.method_5998(pHand);
		IPlacementHelper helper = PlacementHelpers.get(ShaftBlock.placementHelperId);
		if (helper.matchesItem(heldItem))
			return helper.getOffset(pPlayer, pLevel, pState, pPos, pHit)
				.placeInWorld(pLevel, (class_1747) heldItem.method_7909(), pPlayer, pHand, pHit);

		return class_1269.field_5811;
	}

	@Override
	public class_2464 method_9604(class_2680 pState) {
		return class_2464.field_11456;
	}

	@Override
	public void method_9588(class_2680 pState, class_3218 pLevel, class_2338 pPos, class_5819 pRandom) {
		if (!stillValid(pState, pLevel, pPos))
			pLevel.method_8652(pPos, AllBlocks.SHAFT.getDefaultState()
				.method_11657(ShaftBlock.AXIS, pState.method_11654(AXIS))
				.method_11657(WATERLOGGED, pState.method_11654(WATERLOGGED)), 3);
	}

	@Override
	public class_1799 method_9574(class_1922 pLevel, class_2338 pPos, class_2680 pState) {
		return AllBlocks.SHAFT.asStack();
	}

	@Override
	public boolean method_9558(class_2680 pState, class_4538 pLevel, class_2338 pPos) {
		return stillValid(pState, pLevel, pPos);
	}

	public static boolean stillValid(class_2680 pState, class_4538 pLevel, class_2338 pPos) {
		for (class_2350 d : Iterate.directions) {
			if (d.method_10166() == pState.method_11654(AXIS))
				continue;
			class_2338 enginePos = pPos.method_10079(d, 2);
			class_2680 engineState = pLevel.method_8320(enginePos);
			if (!(engineState.method_26204()instanceof SteamEngineBlock engine))
				continue;
			if (!SteamEngineBlock.getShaftPos(engineState, enginePos)
				.equals(pPos))
				continue;
			if (SteamEngineBlock.isShaftValid(engineState, pState))
				return true;
		}
		return false;
	}

	public static class_2680 getEquivalent(class_2680 stateForPlacement) {
		return AllBlocks.POWERED_SHAFT.getDefaultState()
			.method_11657(PoweredShaftBlock.AXIS, stateForPlacement.method_11654(ShaftBlock.AXIS))
			.method_11657(WATERLOGGED, stateForPlacement.method_11654(WATERLOGGED));
	}

}
