package com.simibubi.create.content.kinetics.steamEngine;

import static net.minecraft.class_2741.field_12508;

import java.util.function.Predicate;
import net.minecraft.class_10;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2341;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2738;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_3737;
import net.minecraft.class_3965;
import net.minecraft.class_4538;
import net.minecraft.class_6328;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.equipment.wrench.IWrenchable;
import com.simibubi.create.content.fluids.tank.FluidTankBlock;
import com.simibubi.create.content.kinetics.simpleRelays.ShaftBlock;
import com.simibubi.create.foundation.advancement.AdvancementBehaviour;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.placement.IPlacementHelper;
import com.simibubi.create.foundation.placement.PlacementHelpers;
import com.simibubi.create.foundation.placement.PlacementOffset;
import com.simibubi.create.foundation.utility.BlockHelper;
import com.simibubi.create.foundation.utility.Couple;

public class SteamEngineBlock extends class_2341
	implements class_3737, IWrenchable, IBE<SteamEngineBlockEntity> {

	private static final int placementHelperId = PlacementHelpers.register(new PlacementHelper());

	public SteamEngineBlock(class_2251 properties) {
		super(properties);
		method_9590(field_10647.method_11664().method_11657(field_11007, class_2738.field_12475).method_11657(field_11177, class_2350.field_11043).method_11657(field_12508, false));
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> pBuilder) {
		super.method_9515(pBuilder.method_11667(field_11007, field_11177, field_12508));
	}

	@Override
	public void method_9567(class_1937 pLevel, class_2338 pPos, class_2680 pState, class_1309 pPlacer, class_1799 pStack) {
		super.method_9567(pLevel, pPos, pState, pPlacer, pStack);
		AdvancementBehaviour.setPlacedBy(pLevel, pPos, pPlacer);
	}
	
	@Override
	public boolean method_9558(class_2680 pState, class_4538 pLevel, class_2338 pPos) {
		return method_20046(pLevel, pPos, method_10119(pState).method_10153());
	}

	public static boolean method_20046(class_4538 pReader, class_2338 pPos, class_2350 pDirection) {
		class_2338 blockpos = pPos.method_10093(pDirection);
		return pReader.method_8320(blockpos)
			.method_26204() instanceof FluidTankBlock;
	}

	@Override
	public class_3610 method_9545(class_2680 state) {
		return state.method_11654(field_12508) ? class_3612.field_15910.method_15729(false) : class_3612.field_15906.method_15785();
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand,
		class_3965 ray) {
		class_1799 heldItem = player.method_5998(hand);

		IPlacementHelper placementHelper = PlacementHelpers.get(placementHelperId);
		if (placementHelper.matchesItem(heldItem))
			return placementHelper.getOffset(player, world, state, pos, ray)
				.placeInWorld(world, (class_1747) heldItem.method_7909(), player, hand, ray);
		return class_1269.field_5811;
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 direction, class_2680 neighbourState, class_1936 world,
		class_2338 pos, class_2338 neighbourPos) {
		if (state.method_11654(field_12508))
			world.method_39281(pos, class_3612.field_15910, class_3612.field_15910.method_15789(world));
		return state;
	}

	@Override
	public void method_9615(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_2680 pOldState, boolean pIsMoving) {
		FluidTankBlock.updateBoilerState(pState, pLevel, pPos.method_10093(getFacing(pState).method_10153()));
		class_2338 shaftPos = getShaftPos(pState, pPos);
		class_2680 shaftState = pLevel.method_8320(shaftPos);
		if (isShaftValid(pState, shaftState))
			pLevel.method_8652(shaftPos, PoweredShaftBlock.getEquivalent(shaftState), 3);
	}

	@Override
	public void method_9536(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_2680 pNewState, boolean pIsMoving) {
		if (pState.method_31709() && (!pState.method_27852(pNewState.method_26204()) || !pNewState.method_31709()))
			pLevel.method_8544(pPos);
		FluidTankBlock.updateBoilerState(pState, pLevel, pPos.method_10093(getFacing(pState).method_10153()));
		class_2338 shaftPos = getShaftPos(pState, pPos);
		class_2680 shaftState = pLevel.method_8320(shaftPos);
		if (AllBlocks.POWERED_SHAFT.has(shaftState))
			pLevel.method_39279(shaftPos, shaftState.method_26204(), 1);
	}

	@Override
	public class_265 method_9530(class_2680 pState, class_1922 pLevel, class_2338 pPos, class_3726 pContext) {
		class_2738 face = pState.method_11654(field_11007);
		class_2350 direction = pState.method_11654(field_11177);
		return face == class_2738.field_12473 ? AllShapes.STEAM_ENGINE_CEILING.get(direction.method_10166())
			: face == class_2738.field_12475 ? AllShapes.STEAM_ENGINE.get(direction.method_10166())
				: AllShapes.STEAM_ENGINE_WALL.get(direction);
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_1937 level = context.method_8045();
		class_2338 pos = context.method_8037();
		class_3610 ifluidstate = level.method_8316(pos);
		class_2680 state = super.method_9605(context);
		if (state == null)
			return null;
		return state.method_11657(field_12508, Boolean.valueOf(ifluidstate.method_15772() == class_3612.field_15910));
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	public static class_2350 getFacing(class_2680 sideState) {
		return method_10119(sideState);
	}

	public static class_2338 getShaftPos(class_2680 sideState, class_2338 pos) {
		return pos.method_10079(method_10119(sideState), 2);
	}

	public static boolean isShaftValid(class_2680 state, class_2680 shaft) {
		return (AllBlocks.SHAFT.has(shaft) || AllBlocks.POWERED_SHAFT.has(shaft))
			&& shaft.method_11654(ShaftBlock.AXIS) != getFacing(state).method_10166();
	}

	@Override
	public Class<SteamEngineBlockEntity> getBlockEntityClass() {
		return SteamEngineBlockEntity.class;
	}

	@Override
	public class_2591<? extends SteamEngineBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.STEAM_ENGINE.get();
	}

	@class_6328
	private static class PlacementHelper implements IPlacementHelper {
		@Override
		public Predicate<class_1799> getItemPredicate() {
			return AllBlocks.SHAFT::isIn;
		}

		@Override
		public Predicate<class_2680> getStatePredicate() {
			return s -> s.method_26204() instanceof SteamEngineBlock;
		}

		@Override
		public PlacementOffset getOffset(class_1657 player, class_1937 world, class_2680 state, class_2338 pos,
			class_3965 ray) {
			class_2338 shaftPos = SteamEngineBlock.getShaftPos(state, pos);
			class_2680 shaft = AllBlocks.SHAFT.getDefaultState();
			for (class_2350 direction : class_2350.method_10159(player)) {
				shaft = shaft.method_11657(ShaftBlock.AXIS, direction.method_10166());
				if (isShaftValid(state, shaft))
					break;
			}
			
			class_2680 newState = world.method_8320(shaftPos);
			if (!newState.method_45474())
				return PlacementOffset.fail();

			class_2351 axis = shaft.method_11654(ShaftBlock.AXIS);
			return PlacementOffset.success(shaftPos,
				s -> BlockHelper.copyProperties(s, AllBlocks.POWERED_SHAFT.getDefaultState())
					.method_11657(PoweredShaftBlock.AXIS, axis));
		}
	}
	
	public static Couple<Integer> getSpeedRange() {
		return Couple.create(16, 64);
	}

}
