package com.simibubi.create.content.kinetics.steamEngine;

import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_3532;
import net.minecraft.class_3999;
import net.minecraft.class_4002;
import net.minecraft.class_4184;
import net.minecraft.class_4588;
import net.minecraft.class_638;
import net.minecraft.class_703;
import net.minecraft.class_707;
import net.minecraft.class_708;
import net.minecraft.class_761;
import net.minecraft.class_7833;
import org.joml.Quaternionf;
import org.joml.Vector3f;

public class SteamJetParticle extends class_708 {

	private float yaw, pitch;

	protected SteamJetParticle(class_638 world, SteamJetParticleData data, double x, double y, double z, double dx,
		double dy, double dz, class_4002 sprite) {
		super(world, x, y, z, sprite, world.field_9229.method_43057() * .5f);
		field_3852 = 0;
		field_3869 = 0;
		field_3850 = 0;
		field_3844 = 0;
		field_17867 = .375f;
		method_3077(21);
		method_3063(x, y, z);
		field_3839 = field_3857 = world.field_9229.method_43057() * class_3532.field_29844;
		yaw = (float) class_3532.method_15349(dx, dz) - class_3532.field_29844;
		pitch = (float) class_3532.method_15349(dy, Math.sqrt(dx * dx + dz * dz)) - class_3532.field_29844 / 2;
		this.method_18142(sprite);
	}

	public class_3999 method_18122() {
		return class_3999.field_17828;
	}

	public void method_3074(class_4588 pBuffer, class_4184 pRenderInfo, float pPartialTicks) {
		class_243 vec3 = pRenderInfo.method_19326();
		float f = (float) (field_3874 - vec3.field_1352);
		float f1 = (float) (field_3854 - vec3.field_1351);
		float f2 = (float) (field_3871 - vec3.field_1350);
		float f3 = class_3532.method_16439(pPartialTicks, this.field_3857, this.field_3839);
		float f7 = this.method_18133();
		float f8 = this.method_18134();
		float f5 = this.method_18135();
		float f6 = this.method_18136();
		float f4 = this.method_18132(pPartialTicks);

		for (int i = 0; i < 4; i++) {
			Quaternionf quaternion = class_7833.field_40716.rotation(yaw);
			quaternion.mul(class_7833.field_40714.rotation(pitch));
			quaternion.mul(class_7833.field_40716.rotation(f3 + class_3532.field_29844 / 2 * i + field_3839));
			Vector3f vector3f1 = new Vector3f(-1.0F, -1.0F, 0.0F);
			vector3f1.rotate(quaternion);

			Vector3f[] avector3f = new Vector3f[] { new Vector3f(-1.0F, -1.0F, 0.0F), new Vector3f(-1.0F, 1.0F, 0.0F),
				new Vector3f(1.0F, 1.0F, 0.0F), new Vector3f(1.0F, -1.0F, 0.0F) };

			for (int j = 0; j < 4; ++j) {
				Vector3f vector3f = avector3f[j];
				vector3f.add(0, 1, 0);
				vector3f.rotate(quaternion);
				vector3f.mul(f4);
				vector3f.add(f, f1, f2);
			}

			int j = this.method_3068(pPartialTicks);
			pBuffer.method_22912((double) avector3f[0].x(), (double) avector3f[0].y(), (double) avector3f[0].z())
				.method_22913(f8, f6)
				.method_22915(this.field_3861, this.field_3842, this.field_3859, this.field_3841)
				.method_22916(j)
				.method_1344();
			pBuffer.method_22912((double) avector3f[1].x(), (double) avector3f[1].y(), (double) avector3f[1].z())
				.method_22913(f8, f5)
				.method_22915(this.field_3861, this.field_3842, this.field_3859, this.field_3841)
				.method_22916(j)
				.method_1344();
			pBuffer.method_22912((double) avector3f[2].x(), (double) avector3f[2].y(), (double) avector3f[2].z())
				.method_22913(f7, f5)
				.method_22915(this.field_3861, this.field_3842, this.field_3859, this.field_3841)
				.method_22916(j)
				.method_1344();
			pBuffer.method_22912((double) avector3f[3].x(), (double) avector3f[3].y(), (double) avector3f[3].z())
				.method_22913(f7, f6)
				.method_22915(this.field_3861, this.field_3842, this.field_3859, this.field_3841)
				.method_22916(j)
				.method_1344();

		}
	}

	@Override
	public int method_3068(float partialTick) {
		class_2338 blockpos = class_2338.method_49637(this.field_3874, this.field_3854, this.field_3871);
		return this.field_3851.method_8477(blockpos) ? class_761.method_23794(field_3851, blockpos) : 0;
	}

	public static class Factory implements class_707<SteamJetParticleData> {
		private final class_4002 spriteSet;

		public Factory(class_4002 animatedSprite) {
			this.spriteSet = animatedSprite;
		}

		public class_703 createParticle(SteamJetParticleData data, class_638 worldIn, double x, double y, double z,
			double xSpeed, double ySpeed, double zSpeed) {
			return new SteamJetParticle(worldIn, data, x, y, z, xSpeed, ySpeed, zSpeed, this.spriteSet);
		}
	}

}
