package com.simibubi.create.content.kinetics.steamEngine;

import java.util.Locale;

import com.mojang.brigadier.StringReader;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import com.simibubi.create.AllParticleTypes;
import com.simibubi.create.foundation.particle.ICustomParticleDataWithSprite;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2394;
import net.minecraft.class_2396;
import net.minecraft.class_2540;
import net.minecraft.class_702.class_4091;

public class SteamJetParticleData implements class_2394, ICustomParticleDataWithSprite<SteamJetParticleData> {

	public static final Codec<SteamJetParticleData> CODEC = RecordCodecBuilder.create(i -> i
		.group(Codec.FLOAT.fieldOf("speed")
			.forGetter(p -> p.speed))
		.apply(i, SteamJetParticleData::new));

	public static final class_2394.class_2395<SteamJetParticleData> DESERIALIZER =
		new class_2394.class_2395<SteamJetParticleData>() {
			public SteamJetParticleData method_10296(class_2396<SteamJetParticleData> particleTypeIn,
				StringReader reader) throws CommandSyntaxException {
				reader.expect(' ');
				float speed = reader.readFloat();
				return new SteamJetParticleData(speed);
			}

			public SteamJetParticleData method_10297(class_2396<SteamJetParticleData> particleTypeIn,
				class_2540 buffer) {
				return new SteamJetParticleData(buffer.readFloat());
			}
		};

	float speed;

	public SteamJetParticleData(float speed) {
		this.speed = speed;
	}

	public SteamJetParticleData() {
		this(0);
	}

	@Override
	public class_2396<?> method_10295() {
		return AllParticleTypes.STEAM_JET.get();
	}

	@Override
	public void method_10294(class_2540 buffer) {
		buffer.writeFloat(speed);
	}

	@Override
	public String method_10293() {
		return String.format(Locale.ROOT, "%s %f", AllParticleTypes.STEAM_JET.parameter(), speed);
	}

	@Override
	public class_2395<SteamJetParticleData> getDeserializer() {
		return DESERIALIZER;
	}

	@Override
	public Codec<SteamJetParticleData> getCodec(class_2396<SteamJetParticleData> type) {
		return CODEC;
	}

	@Override
	@Environment(EnvType.CLIENT)
	public class_4091<SteamJetParticleData> getMetaFactory() {
		return SteamJetParticle.Factory::new;
	}

}