package com.simibubi.create.content.kinetics.transmission.sequencer;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllItems;
import com.simibubi.create.content.contraptions.ITransformableBlock;
import com.simibubi.create.content.contraptions.StructureTransform;
import com.simibubi.create.content.kinetics.base.HorizontalAxisKineticBlock;
import com.simibubi.create.content.kinetics.base.KineticBlock;
import com.simibubi.create.content.kinetics.base.RotatedPillarKineticBlock;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.blockEntity.behaviour.filtering.FilteringBehaviour;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.tterrag.registrate.fabric.EnvExecutor;

import io.github.fabricators_of_create.porting_lib.block.WeakPowerCheckingBlock;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2746;
import net.minecraft.class_2758;
import net.minecraft.class_3218;
import net.minecraft.class_3965;
import net.minecraft.class_4538;
import net.minecraft.class_5819;
import net.minecraft.class_746;
import net.minecraft.class_8235;

public class SequencedGearshiftBlock extends HorizontalAxisKineticBlock implements IBE<SequencedGearshiftBlockEntity>, ITransformableBlock, WeakPowerCheckingBlock {

	public static final class_2746 VERTICAL = class_2746.method_11825("vertical");
	public static final class_2758 STATE = class_2758.method_11867("state", 0, 5);

	public SequencedGearshiftBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder.method_11667(STATE, VERTICAL));
	}

	@Override
    public boolean shouldCheckWeakPower(class_2680 state, class_8235 level, class_2338 pos, class_2350 side) {
        return false;
    }

	@Override
	public void method_9612(class_2680 state, class_1937 worldIn, class_2338 pos, class_2248 blockIn, class_2338 fromPos,
		boolean isMoving) {
		if (worldIn.field_9236)
			return;
		if (!worldIn.method_8397()
			.method_8677(pos, this))
			worldIn.method_39279(pos, this, 0);
	}

	@Override
	public void method_9588(class_2680 state, class_3218 worldIn, class_2338 pos, class_5819 r) {
		boolean previouslyPowered = state.method_11654(STATE) != 0;
		boolean isPowered = worldIn.method_49803(pos);
		withBlockEntityDo(worldIn, pos, sgte -> sgte.onRedstoneUpdate(isPowered, previouslyPowered));
	}

	@Override
	protected boolean areStatesKineticallyEquivalent(class_2680 oldState, class_2680 newState) {
		return false;
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		if (state.method_11654(VERTICAL))
			return face.method_10166()
				.method_10178();
		return super.hasShaftTowards(world, pos, state, face);
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 worldIn, class_2338 pos, class_1657 player, class_1268 handIn,
		class_3965 hit) {
		if (AdventureUtil.isAdventure(player))
			return class_1269.field_5811;
		class_1799 held = player.method_6047();
		if (AllItems.WRENCH.isIn(held))
			return class_1269.field_5811;
		if (held.method_7909() instanceof class_1747) {
			class_1747 blockItem = (class_1747) held.method_7909();
			if (blockItem.method_7711() instanceof KineticBlock && hasShaftTowards(worldIn, pos, state, hit.method_17780()))
				return class_1269.field_5811;
		}

		EnvExecutor.runWhenOn(EnvType.CLIENT,
			() -> () -> withBlockEntityDo(worldIn, pos, be -> this.displayScreen(be, player)));
		return class_1269.field_5812;
	}

	@Environment(value = EnvType.CLIENT)
	protected void displayScreen(SequencedGearshiftBlockEntity be, class_1657 player) {
		if (player instanceof class_746)
			ScreenOpener.open(new SequencedGearshiftScreen(be));
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2351 preferredAxis = RotatedPillarKineticBlock.getPreferredAxis(context);
		if (preferredAxis != null && (context.method_8036() == null || !context.method_8036()
			.method_5715()))
			return withAxis(preferredAxis, context);
		return withAxis(context.method_7715()
			.method_10166(), context);
	}

	@Override
	public class_1269 onWrenched(class_2680 state, class_1838 context) {
		class_2680 newState = state;

		if (context.method_8038()
			.method_10166() != class_2351.field_11052)
			if (newState.method_11654(HORIZONTAL_AXIS) != context.method_8038()
				.method_10166())
				newState = newState.method_28493(VERTICAL);

		return super.onWrenched(newState, context);
	}

	private class_2680 withAxis(class_2351 axis, class_1750 context) {
		class_2680 state = method_9564().method_11657(VERTICAL, axis.method_10178());
		if (axis.method_10178())
			return state.method_11657(HORIZONTAL_AXIS, context.method_8042()
				.method_10166());
		return state.method_11657(HORIZONTAL_AXIS, axis);
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		if (state.method_11654(VERTICAL))
			return class_2351.field_11052;
		return super.getRotationAxis(state);
	}

	@Override
	public Class<SequencedGearshiftBlockEntity> getBlockEntityClass() {
		return SequencedGearshiftBlockEntity.class;
	}

	@Override
	public class_2591<? extends SequencedGearshiftBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.SEQUENCED_GEARSHIFT.get();
	}

	@Override
	public boolean method_9498(class_2680 p_149740_1_) {
		return true;
	}

	@Override
	public int method_9572(class_2680 state, class_1937 world, class_2338 pos) {
		return state.method_11654(STATE)
			.intValue();
	}

	@Override
	public class_2680 transform(class_2680 state, StructureTransform transform) {
		if (transform.mirror != null) {
			state = method_9569(state, transform.mirror);
		}

		if (transform.rotationAxis == class_2350.class_2351.field_11052) {
			return method_9598(state, transform.rotation);
		}

		if (transform.rotation.ordinal() % 2 == 1) {
			if (transform.rotationAxis != state.method_11654(HORIZONTAL_AXIS)) {
				return state.method_28493(VERTICAL);
			} else if (state.method_11654(VERTICAL)) {
				return state.method_28493(VERTICAL).method_28493(HORIZONTAL_AXIS);
			}
		}
		return state;
	}

}
