package com.simibubi.create.content.kinetics.turntable;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.kinetics.base.KineticBlock;
import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_10;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_243;
import net.minecraft.class_2464;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3532;
import net.minecraft.class_3726;
import net.minecraft.class_4538;

public class TurntableBlock extends KineticBlock implements IBE<TurntableBlockEntity> {

	public TurntableBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public class_2464 method_9604(class_2680 state) {
		return class_2464.field_11456;
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 worldIn, class_2338 pos, class_3726 context) {
		return AllShapes.TURNTABLE_SHAPE;
	}

	@Override
	public void method_9548(class_2680 state, class_1937 worldIn, class_2338 pos, class_1297 e) {
		if (!e.method_24828())
			return;
		if (e.method_18798().field_1351 > 0)
			return;
		if (e.method_23318() < pos.method_10264() + .5f)
			return;

		withBlockEntityDo(worldIn, pos, be -> {
			float speed = ((KineticBlockEntity) be).getSpeed() * 3 / 10;
			if (speed == 0)
				return;

			class_1937 world = e.method_5770();
			if (world.field_9236 && (e instanceof class_1657)) {
				if (worldIn.method_8320(e.method_24515()) != state) {
					class_243 origin = VecHelper.getCenterOf(pos);
					class_243 offset = e.method_19538()
						.method_1020(origin);
					offset = VecHelper.rotate(offset, class_3532.method_15363(speed, -16, 16) / 1f, class_2351.field_11052);
					class_243 movement = origin.method_1019(offset)
						.method_1020(e.method_19538());
					e.method_18799(e.method_18798()
						.method_1019(movement));
					e.field_6037 = true;
				}
			}

			if ((e instanceof class_1657))
				return;
			if (world.field_9236)
				return;

			if ((e instanceof class_1309)) {
				float diff = e.method_5791() - speed;
				((class_1309) e).method_16826(20);
				e.method_5636(diff);
				e.method_5847(diff);
				e.method_24830(false);
				e.field_6037 = true;
			}

			e.method_36456(e.method_36454() - speed);
		});
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return face == class_2350.field_11033;
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return class_2351.field_11052;
	}

	@Override
	public Class<TurntableBlockEntity> getBlockEntityClass() {
		return TurntableBlockEntity.class;
	}
	
	@Override
	public class_2591<? extends TurntableBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.TURNTABLE.get();
	}
	
	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

}
