package com.simibubi.create.content.kinetics.waterwheel;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.kinetics.base.DirectionalKineticBlock;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.simibubi.create.foundation.utility.Couple;
import com.simibubi.create.foundation.utility.Iterate;
import com.simibubi.create.foundation.utility.worldWrappers.WrappedWorld;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3965;
import net.minecraft.class_4538;
import net.minecraft.class_5819;

public class WaterWheelBlock extends DirectionalKineticBlock implements IBE<WaterWheelBlockEntity> {

	public WaterWheelBlock(class_2251 properties) {
		super(properties);
	}

	@Override
	public boolean method_9558(class_2680 state, class_4538 worldIn, class_2338 pos) {
		for (class_2350 direction : Iterate.directions) {
			class_2338 neighbourPos = pos.method_10093(direction);
			class_2680 neighbourState = worldIn.method_8320(neighbourPos);
			if (!AllBlocks.WATER_WHEEL.has(neighbourState))
				continue;
			class_2351 axis = state.method_11654(FACING)
				.method_10166();
			if (neighbourState.method_11654(FACING)
				.method_10166() != axis || axis != direction.method_10166())
				return false;
		}
		return true;
	}

	@Override
	public class_1269 method_9534(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_1657 pPlayer, class_1268 pHand,
		class_3965 pHit) {
		if (AdventureUtil.isAdventure(pPlayer))
			return class_1269.field_5811;
		return onBlockEntityUse(pLevel, pPos, wwt -> wwt.applyMaterialIfValid(pPlayer.method_5998(pHand)));
	}

	@Override
	public class_2680 method_9559(class_2680 stateIn, class_2350 facing, class_2680 facingState, class_1936 worldIn,
		class_2338 currentPos, class_2338 facingPos) {
		if (worldIn instanceof WrappedWorld)
			return stateIn;
		if (worldIn.method_8608())
			return stateIn;
		if (!worldIn.method_8397()
			.method_8674(currentPos, this))
			worldIn.method_39279(currentPos, this, 1);
		return stateIn;
	}

	@Override
	public void method_9615(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 oldState, boolean isMoving) {
		super.method_9615(state, worldIn, pos, oldState, isMoving);
		if (worldIn.method_8608())
			return;
		if (!worldIn.method_8397()
			.method_8674(pos, this))
			worldIn.method_39279(pos, this, 1);
	}

	@Override
	public void method_9588(class_2680 pState, class_3218 pLevel, class_2338 pPos, class_5819 pRandom) {
		withBlockEntityDo(pLevel, pPos, WaterWheelBlockEntity::determineAndApplyFlowScore);
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2680 state = super.method_9605(context);
		state.method_11657(FACING, class_2350.method_10156(class_2352.field_11056, state.method_11654(FACING)
			.method_10166()));
		return state;
	}

	@Override
	public boolean hasShaftTowards(class_4538 world, class_2338 pos, class_2680 state, class_2350 face) {
		return state.method_11654(FACING)
			.method_10166() == face.method_10166();
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return state.method_11654(FACING)
			.method_10166();
	}

	@Override
	public float getParticleTargetRadius() {
		return 1.125f;
	}

	@Override
	public float getParticleInitialRadius() {
		return 1f;
	}

	@Override
	public boolean hideStressImpact() {
		return true;
	}

	@Override
	public Class<WaterWheelBlockEntity> getBlockEntityClass() {
		return WaterWheelBlockEntity.class;
	}

	@Override
	public class_2591<? extends WaterWheelBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.WATER_WHEEL.get();
	}

	public static Couple<Integer> getSpeedRange() {
		return Couple.create(8, 8);
	}

}
