package com.simibubi.create.content.kinetics.waterwheel;

import java.util.HashSet;
import java.util.Set;

import com.simibubi.create.foundation.utility.AdventureUtil;

import io.github.fabricators_of_create.porting_lib.block.CustomHitEffectsBlock;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.equipment.goggles.IProxyHoveringInformation;
import com.simibubi.create.content.equipment.wrench.IWrenchable;
import com.simibubi.create.foundation.block.render.MultiPosDestructionHandler;

import io.github.fabricators_of_create.porting_lib.block.CustomDestroyEffectsBlock;
import io.github.fabricators_of_create.porting_lib.block.CustomLandingEffectsBlock;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2318;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_239;
import net.minecraft.class_2464;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_3218;
import net.minecraft.class_3965;
import net.minecraft.class_5819;
import net.minecraft.class_638;
import net.minecraft.class_702;

public class WaterWheelStructuralBlock extends class_2318 implements IWrenchable, IProxyHoveringInformation, MultiPosDestructionHandler, CustomLandingEffectsBlock, CustomDestroyEffectsBlock, CustomHitEffectsBlock {

	public WaterWheelStructuralBlock(class_2251 p_52591_) {
		super(p_52591_);
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> pBuilder) {
		super.method_9515(pBuilder.method_11667(field_10927));
	}

	@Override
	public class_2464 method_9604(class_2680 pState) {
		return class_2464.field_11455;
	}

	@Override
	public class_1269 onWrenched(class_2680 state, class_1838 context) {
		return class_1269.field_5811;
	}

	@Override
	public class_1799 method_9574(class_1922 pLevel, class_2338 pPos, class_2680 pState) {
		return AllBlocks.LARGE_WATER_WHEEL.asStack();
	}

	@Override
	public class_1269 onSneakWrenched(class_2680 state, class_1838 context) {
		class_2338 clickedPos = context.method_8037();
		class_1937 level = context.method_8045();

		if (stillValid(level, clickedPos, state, false)) {
			class_2338 masterPos = getMaster(level, clickedPos, state);
			context = new class_1838(level, context.method_8036(), context.method_20287(), context.method_8041(),
				new class_3965(context.method_17698(), context.method_8038(), masterPos,
					context.method_17699()));
			state = level.method_8320(masterPos);
		}

		return IWrenchable.super.onSneakWrenched(state, context);
	}

	@Override
	public class_1269 method_9534(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_1657 pPlayer, class_1268 pHand,
		class_3965 pHit) {
		if (AdventureUtil.isAdventure(pPlayer))
			return class_1269.field_5811;
		if (!stillValid(pLevel, pPos, pState, false))
			return class_1269.field_5814;
		if (!(pLevel.method_8321(getMaster(pLevel, pPos, pState))instanceof WaterWheelBlockEntity wwt))
			return class_1269.field_5814;
		return wwt.applyMaterialIfValid(pPlayer.method_5998(pHand));
	}

	@Override
	public void method_9536(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_2680 pNewState, boolean pIsMoving) {
		if (stillValid(pLevel, pPos, pState, false))
			pLevel.method_22352(getMaster(pLevel, pPos, pState), true);
	}

	public void method_9576(class_1937 pLevel, class_2338 pPos, class_2680 pState, class_1657 pPlayer) {
		if (stillValid(pLevel, pPos, pState, false)) {
			class_2338 masterPos = getMaster(pLevel, pPos, pState);
			pLevel.method_8517(masterPos.hashCode(), masterPos, -1);
			if (!pLevel.method_8608() && pPlayer.method_7337())
				pLevel.method_22352(masterPos, false);
		}
		super.method_9576(pLevel, pPos, pState, pPlayer);
	}

	@Override
	public class_2680 method_9559(class_2680 pState, class_2350 pFacing, class_2680 pFacingState, class_1936 pLevel,
		class_2338 pCurrentPos, class_2338 pFacingPos) {
		if (stillValid(pLevel, pCurrentPos, pState, false)) {
			class_2338 masterPos = getMaster(pLevel, pCurrentPos, pState);
			if (!pLevel.method_8397()
				.method_8674(masterPos, AllBlocks.LARGE_WATER_WHEEL.get()))
				pLevel.method_39279(masterPos, AllBlocks.LARGE_WATER_WHEEL.get(), 1);
			return pState;
		}
		if (!(pLevel instanceof class_1937 level) || level.method_8608())
			return pState;
		if (!level.method_8397()
			.method_8674(pCurrentPos, this))
			level.method_39279(pCurrentPos, this, 1);
		return pState;
	}

	public static class_2338 getMaster(class_1922 level, class_2338 pos, class_2680 state) {
		class_2350 direction = state.method_11654(field_10927);
		class_2338 targetedPos = pos.method_10093(direction);
		class_2680 targetedState = level.method_8320(targetedPos);
		if (targetedState.method_27852(AllBlocks.WATER_WHEEL_STRUCTURAL.get()))
			return getMaster(level, targetedPos, targetedState);
		return targetedPos;
	}

	public boolean stillValid(class_1922 level, class_2338 pos, class_2680 state, boolean directlyAdjacent) {
		if (!state.method_27852(this))
			return false;

		class_2350 direction = state.method_11654(field_10927);
		class_2338 targetedPos = pos.method_10093(direction);
		class_2680 targetedState = level.method_8320(targetedPos);

		if (!directlyAdjacent && stillValid(level, targetedPos, targetedState, true))
			return true;
		return targetedState.method_26204() instanceof LargeWaterWheelBlock
			&& targetedState.method_11654(LargeWaterWheelBlock.AXIS) != direction.method_10166();
	}

	@Override
	public void method_9588(class_2680 pState, class_3218 pLevel, class_2338 pPos, class_5819 pRandom) {
		if (!stillValid(pLevel, pPos, pState, false))
			pLevel.method_8501(pPos, class_2246.field_10124.method_9564());
	}

	@Override
	public boolean addLandingEffects(class_2680 state1, class_3218 level, class_2338 pos, class_2680 state2,
		class_1309 entity, int numberOfParticles) {
		return true;
	}

	@Override
	public boolean addDestroyEffects(class_2680 state, class_638 Level, class_2338 pos, class_702 manager) {
		return true;
	}

	@Override
	@Environment(EnvType.CLIENT)
	public boolean addHitEffects(class_2680 state, class_1937 level, class_239 target, class_702 engine) {
		if (target instanceof class_3965 bhr) {
			class_2338 targetPos = bhr.method_17777();
			WaterWheelStructuralBlock waterWheelStructuralBlock = AllBlocks.WATER_WHEEL_STRUCTURAL.get();
			if (waterWheelStructuralBlock.stillValid(level, targetPos, state, false))
				engine.method_3054(WaterWheelStructuralBlock.getMaster(level, targetPos, state), bhr.method_17780());
			return true;
		}
		return false;
	}

	@Override
	@Nullable
	@Environment(EnvType.CLIENT)
	public Set<class_2338> getExtraPositions(class_638 level, class_2338 pos, class_2680 blockState, int progress) {
		WaterWheelStructuralBlock waterWheelStructuralBlock = AllBlocks.WATER_WHEEL_STRUCTURAL.get();
		if (!waterWheelStructuralBlock.stillValid(level, pos, blockState, false))
			return null;
		HashSet<class_2338> set = new HashSet<>();
		set.add(WaterWheelStructuralBlock.getMaster(level, pos, blockState));
		return set;
	}

	@Override
	public class_2338 getInformationSource(class_1937 level, class_2338 pos, class_2680 state) {
		return stillValid(level, pos, state, false) ? getMaster(level, pos, state) : pos;
	}

}
