package com.simibubi.create.content.legacy;

import java.util.Random;
import net.minecraft.class_1542;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2398;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2580;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_2902;
import net.minecraft.class_3532;
import net.minecraft.class_3959;
import net.minecraft.class_3959.class_242;
import net.minecraft.class_3959.class_3960;
import net.minecraft.class_5819;
import io.github.fabricators_of_create.porting_lib.mixin.accessors.common.accessor.BeaconBlockEntityAccessor;

import org.apache.commons.lang3.mutable.MutableBoolean;

import com.simibubi.create.AllItems;
import com.simibubi.create.content.kinetics.belt.behaviour.TransportedItemStackHandlerBehaviour;
import com.simibubi.create.content.kinetics.belt.behaviour.TransportedItemStackHandlerBehaviour.TransportedResult;
import com.simibubi.create.content.kinetics.belt.transport.TransportedItemStack;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.utility.Color;
import com.simibubi.create.foundation.utility.VecHelper;
import com.simibubi.create.infrastructure.config.AllConfigs;
import com.simibubi.create.infrastructure.config.CRecipes;

import io.github.fabricators_of_create.porting_lib.block.LightEmissiveBlock;
import io.github.fabricators_of_create.porting_lib.item.CustomMaxCountItem;
import io.github.fabricators_of_create.porting_lib.item.EntityTickListenerItem;

public class ChromaticCompoundItem extends class_1792 implements CustomMaxCountItem, EntityTickListenerItem {

	public ChromaticCompoundItem(class_1793 properties) {
		super(properties);
	}

	public int getLight(class_1799 stack) {
		return stack.method_7948()
			.method_10550("CollectingLight");
	}

	@Override
	public boolean method_31567(class_1799 stack) {
		return getLight(stack) > 0;
	}

	@Override
	public int method_31569(class_1799 stack) {
		return Math.round(13.0F * getLight(stack) / AllConfigs.server().recipes.lightSourceCountForRefinedRadiance.get());
	}

	@Override
	public int method_31571(class_1799 stack) {
		return Color.mixColors(0x413c69, 0xFFFFFF,
			getLight(stack) / (float) AllConfigs.server().recipes.lightSourceCountForRefinedRadiance.get());
	}

	@Override
	public int getItemStackLimit(class_1799 stack) {
		return method_31567(stack) ? 1 : 16;
	}

	@Override
	public boolean onEntityItemUpdate(class_1799 stack, class_1542 entity) {
		class_1937 world = entity.method_37908();
		class_2487 itemData = entity.method_6983()
			.method_7948();
		class_243 positionVec = entity.method_19538();
		CRecipes config = AllConfigs.server().recipes;

		if (world.field_9236) {
			int light = itemData.method_10550("CollectingLight");
			if (world.field_9229.method_43048(config.lightSourceCountForRefinedRadiance.get() + 20) < light) {
				class_243 start = VecHelper.offsetRandomly(positionVec, world.field_9229, 3);
				class_243 motion = positionVec.method_1020(start)
					.method_1029()
					.method_1021(.2f);
				world.method_8406(class_2398.field_11207, start.field_1352, start.field_1351, start.field_1350, motion.field_1352, motion.field_1351, motion.field_1350);
			}
			return false;
		}

		double y = entity.method_23318();
		double yMotion = entity.method_18798().field_1351;
		int minHeight = world.method_31607();
		class_2487 data = entity.getCustomData();

		// Convert to Shadow steel if in void
		if (y < minHeight && y - yMotion < -10 + minHeight && config.enableShadowSteelRecipe.get()) {
			class_1799 newStack = AllItems.SHADOW_STEEL.asStack();
			newStack.method_7939(stack.method_7947());
			data.method_10556("JustCreated", true);
			entity.method_6979(newStack);
		}

		if (!config.enableRefinedRadianceRecipe.get())
			return false;

		// Convert to Refined Radiance if eaten enough light sources
		if (itemData.method_10550("CollectingLight") >= config.lightSourceCountForRefinedRadiance.get()) {
			class_1799 newStack = AllItems.REFINED_RADIANCE.asStack();
			class_1542 newEntity = new class_1542(world, entity.method_23317(), entity.method_23318(), entity.method_23321(), newStack);
			newEntity.method_18799(entity.method_18798());
			newEntity.getCustomData()
				.method_10556("JustCreated", true);
			itemData.method_10551("CollectingLight");
			world.method_8649(newEntity);

			stack.method_7971(1);
			entity.method_6979(stack);
			if (stack.method_7960())
				entity.method_31472();
			return false;
		}

		// Is inside beacon beam?
		boolean isOverBeacon = false;
		int entityX = class_3532.method_15357(entity.method_23317());
		int entityZ = class_3532.method_15357(entity.method_23321());
		int localWorldHeight = world.method_8624(class_2902.class_2903.field_13202, entityX, entityZ);

		class_2338.class_2339 testPos =
			new class_2338.class_2339(entityX, Math.min(class_3532.method_15357(entity.method_23318()), localWorldHeight), entityZ);

		while (testPos.method_10264() > 0) {
			testPos.method_10098(class_2350.field_11033);
			class_2680 state = world.method_8320(testPos);
			if (state.method_26193(world, testPos) >= 15 && state.method_26204() != class_2246.field_9987)
				break;
			if (state.method_26204() == class_2246.field_10327) {
				class_2586 be = world.method_8321(testPos);

				if (!(be instanceof class_2580))
					break;

				class_2580 bte = (class_2580) be;

				if (!((BeaconBlockEntityAccessor) bte).port_lib$getBeamSections().isEmpty())
					isOverBeacon = true;

				break;
			}
		}

		if (isOverBeacon) {
			class_1799 newStack = AllItems.REFINED_RADIANCE.asStack();
			newStack.method_7939(stack.method_7947());
			data.method_10556("JustCreated", true);
			entity.method_6979(newStack);
			return false;
		}

		// Find a light source and eat it.
		class_5819 r = world.field_9229;
		int range = 3;
		float rate = 1 / 2f;
		if (r.method_43057() > rate)
			return false;

		class_2338 randomOffset = class_2338.method_49638(VecHelper.offsetRandomly(positionVec, r, range));
		class_2680 state = world.method_8320(randomOffset);

		TransportedItemStackHandlerBehaviour behaviour =
			BlockEntityBehaviour.get(world, randomOffset, TransportedItemStackHandlerBehaviour.TYPE);

		// Find a placed light source
		if (behaviour == null) {
			if (checkLight(stack, entity, world, itemData, positionVec, randomOffset, state))
				world.method_22352(randomOffset, false);
			return false;
		}

		// Find a light source from a depot/belt (chunk rebuild safe)
		MutableBoolean success = new MutableBoolean(false);
		behaviour.handleProcessingOnAllItems(ts -> {

			class_1799 heldStack = ts.stack;
			if (!(heldStack.method_7909() instanceof class_1747))
				return TransportedResult.doNothing();

			class_1747 blockItem = (class_1747) heldStack.method_7909();
			if (blockItem.method_7711() == null)
				return TransportedResult.doNothing();

			class_2680 stateToCheck = blockItem.method_7711()
				.method_9564();

			if (!success.getValue()
				&& checkLight(stack, entity, world, itemData, positionVec, randomOffset, stateToCheck)) {
				success.setTrue();
				if (ts.stack.method_7947() == 1)
					return TransportedResult.removeItem();
				TransportedItemStack left = ts.copy();
				left.stack.method_7934(1);
				return TransportedResult.convertTo(left);
			}

			return TransportedResult.doNothing();

		});
		return false;
	}

	public boolean checkLight(class_1799 stack, class_1542 entity, class_1937 world, class_2487 itemData, class_243 positionVec,
		class_2338 randomOffset, class_2680 state) {
		if(state.method_26204() instanceof LightEmissiveBlock lightEmissiveBlock && lightEmissiveBlock.getLightEmission(state, world, randomOffset) == 0)
			return false;
		else if (state.method_26213() == 0)
			return false;
		if (state.method_26214(world, randomOffset) == -1)
			return false;
		if (state.method_26204() == class_2246.field_10327)
			return false;

		class_3959 context = new class_3959(positionVec.method_1019(new class_243(0, 0.5, 0)), VecHelper.getCenterOf(randomOffset),
			class_3960.field_17558, class_242.field_1348, entity);
		if (!randomOffset.equals(world.method_17742(context)
			.method_17777()))
			return false;

		class_1799 newStack = stack.method_7971(1);
		newStack.method_7948()
			.method_10569("CollectingLight", itemData.method_10550("CollectingLight") + 1);
		class_1542 newEntity = new class_1542(world, entity.method_23317(), entity.method_23318(), entity.method_23321(), newStack);
		newEntity.method_18799(entity.method_18798());
		newEntity.method_6988();
		world.method_8649(newEntity);
//		entity.lifespan = 6000;
		if (stack.method_7960())
			entity.method_31472();
		return true;
	}

}
