package com.simibubi.create.content.logistics.chute;

import java.util.LinkedList;
import java.util.List;
import java.util.function.Predicate;

import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.Create;
import com.simibubi.create.content.equipment.goggles.IHaveGoggleInformation;
import com.simibubi.create.content.kinetics.belt.behaviour.DirectBeltInputBehaviour;
import com.simibubi.create.content.kinetics.belt.behaviour.TransportedItemStackHandlerBehaviour;
import com.simibubi.create.content.kinetics.belt.behaviour.TransportedItemStackHandlerBehaviour.TransportedResult;
import com.simibubi.create.content.kinetics.fan.AirCurrent;
import com.simibubi.create.content.kinetics.fan.EncasedFanBlock;
import com.simibubi.create.content.kinetics.fan.EncasedFanBlockEntity;
import com.simibubi.create.content.logistics.funnel.FunnelBlock;
import com.simibubi.create.foundation.advancement.AllAdvancements;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.inventory.VersionedInventoryTrackerBehaviour;
import com.simibubi.create.foundation.item.ItemHelper;
import com.simibubi.create.foundation.item.ItemHelper.ExtractionCountMode;
import com.simibubi.create.foundation.particle.AirParticleData;
import com.simibubi.create.foundation.utility.BlockHelper;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Iterate;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.VecHelper;
import com.simibubi.create.foundation.utility.animation.LerpedFloat;
import com.simibubi.create.infrastructure.config.AllConfigs;

import io.github.fabricators_of_create.porting_lib.block.CustomRenderBoundingBoxBlockEntity;
import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemHandlerHelper;
import io.github.fabricators_of_create.porting_lib.util.ItemStackUtil;
import io.github.fabricators_of_create.porting_lib.util.NBTSerializer;
import io.github.fabricators_of_create.porting_lib.util.StorageProvider;
import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.Storage;
import net.fabricmc.fabric.api.transfer.v1.storage.base.SidedStorageBlockEntity;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_124;
import net.minecraft.class_1264;
import net.minecraft.class_1542;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_238;
import net.minecraft.class_2392;
import net.minecraft.class_2398;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_3532;
import net.minecraft.class_6328;

@ParametersAreNonnullByDefault
@class_6328
/*
 * Commented Code: Chutes create air streams and act similarly to encased fans
 * (Unfinished)
 */
public class ChuteBlockEntity extends SmartBlockEntity implements IHaveGoggleInformation, CustomRenderBoundingBoxBlockEntity, SidedStorageBlockEntity { // , IAirCurrentSource {

	// public AirCurrent airCurrent;

	float pull;
	float push;

	class_1799 item;
	LerpedFloat itemPosition;
	ChuteItemHandler itemHandler;
	boolean canPickUpItems;

	float bottomPullDistance;
	float beltBelowOffset;
	TransportedItemStackHandlerBehaviour beltBelow;
	boolean updateAirFlow;
	int airCurrentUpdateCooldown;
	int entitySearchCooldown;

	VersionedInventoryTrackerBehaviour invVersionTracker;

	StorageProvider<ItemVariant> capAbove;
	StorageProvider<ItemVariant> capBelow;

	public ChuteBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
		item = class_1799.field_8037;
		itemPosition = LerpedFloat.linear();
		itemHandler = new ChuteItemHandler(this);
		canPickUpItems = false;

		bottomPullDistance = 0;
		// airCurrent = new AirCurrent(this);
		updateAirFlow = true;
	}

	@Override
	public void method_31662(class_1937 level) {
		super.method_31662(level);
		capAbove = StorageProvider.createForItems(level, field_11867.method_10084());
		capBelow = StorageProvider.createForItems(level, field_11867.method_10074());
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {
		behaviours.add(new DirectBeltInputBehaviour(this).onlyInsertWhen((d) -> canDirectlyInsertCached()));
		behaviours.add(invVersionTracker = new VersionedInventoryTrackerBehaviour(this));
		registerAwardables(behaviours, AllAdvancements.CHUTE);
	}

	// Cached per-tick, useful when a lot of items are waiting on top of it
	public boolean canDirectlyInsertCached() {
		return canPickUpItems;
	}

	private boolean canDirectlyInsert() {
		class_2680 blockState = method_11010();
		class_2680 blockStateAbove = field_11863.method_8320(field_11867.method_10084());
		if (!AbstractChuteBlock.isChute(blockState))
			return false;
		if (AbstractChuteBlock.getChuteFacing(blockStateAbove) == class_2350.field_11033)
			return false;
		if (getItemMotion() > 0 && getInputChutes().isEmpty())
			return false;
		return AbstractChuteBlock.isOpenChute(blockState);
	}

	@Override
	public void initialize() {
		super.initialize();
		onAdded();
	}

	@Override
	protected class_238 createRenderBoundingBox() {
		return new class_238(field_11867).method_1012(0, -3, 0);
	}

	@Override
	public void tick() {
		super.tick();

		if (!field_11863.field_9236)
			canPickUpItems = canDirectlyInsert();

		boolean clientSide = field_11863 != null && field_11863.field_9236 && !isVirtual();
		float itemMotion = getItemMotion();
		if (itemMotion != 0 && field_11863 != null && field_11863.field_9236)
			spawnParticles(itemMotion);
		tickAirStreams(itemMotion);

		if (item.method_7960() && !clientSide) {
			if (itemMotion < 0)
				handleInputFromAbove();
			if (itemMotion > 0)
				handleInputFromBelow();
			return;
		}

		float nextOffset = itemPosition.getValue() + itemMotion;

		if (itemMotion < 0) {
			if (nextOffset < .5f) {
				if (!handleDownwardOutput(true))
					nextOffset = .5f;
				else if (nextOffset < 0) {
					handleDownwardOutput(clientSide);
					nextOffset = itemPosition.getValue();
				}
			}
		} else if (itemMotion > 0) {
			if (nextOffset > .5f) {
				if (!handleUpwardOutput(true))
					nextOffset = .5f;
				else if (nextOffset > 1) {
					handleUpwardOutput(clientSide);
					nextOffset = itemPosition.getValue();
				}
			}
		}

		itemPosition.setValue(nextOffset);
	}

	private void updateAirFlow(float itemSpeed) {
		updateAirFlow = false;
		// airCurrent.rebuild();
		if (itemSpeed > 0 && field_11863 != null && !field_11863.field_9236) {
			float speed = pull - push;
			beltBelow = null;

			float maxPullDistance;
			if (speed >= 128)
				maxPullDistance = 3;
			else if (speed >= 64)
				maxPullDistance = 2;
			else if (speed >= 32)
				maxPullDistance = 1;
			else
				maxPullDistance = class_3532.method_16439(speed / 32, 0, 1);

			if (AbstractChuteBlock.isChute(field_11863.method_8320(field_11867.method_10074())))
				maxPullDistance = 0;
			float flowLimit = maxPullDistance;
			if (flowLimit > 0)
				flowLimit = AirCurrent.getFlowLimit(field_11863, field_11867, maxPullDistance, class_2350.field_11033);

			for (int i = 1; i <= flowLimit + 1; i++) {
				TransportedItemStackHandlerBehaviour behaviour =
					BlockEntityBehaviour.get(field_11863, field_11867.method_10087(i), TransportedItemStackHandlerBehaviour.TYPE);
				if (behaviour == null)
					continue;
				beltBelow = behaviour;
				beltBelowOffset = i - 1;
				break;
			}
			this.bottomPullDistance = Math.max(0, flowLimit);
		}
		sendData();
	}

	private void findEntities(float itemSpeed) {
		// if (getSpeed() != 0)
		// airCurrent.findEntities();
		if (bottomPullDistance <= 0 && !getItem().method_7960() || itemSpeed <= 0 || field_11863 == null || field_11863.field_9236)
			return;
		if (!canCollectItemsFromBelow())
			return;
		class_243 center = VecHelper.getCenterOf(field_11867);
		class_238 searchArea = new class_238(center.method_1031(0, -bottomPullDistance - 0.5, 0), center.method_1031(0, -0.5, 0)).method_1014(.45f);
		for (class_1542 itemEntity : field_11863.method_18467(class_1542.class, searchArea)) {
			if (!itemEntity.method_5805())
				continue;
			class_1799 entityItem = itemEntity.method_6983();
			if (!canAcceptItem(entityItem))
				continue;
			setItem(entityItem.method_7972(), (float) (itemEntity.method_5829()
				.method_1005().field_1351 - field_11867.method_10264()));
			itemEntity.method_31472();
			break;
		}
	}

	private void extractFromBelt(float itemSpeed) {
		if (itemSpeed <= 0 || field_11863 == null || field_11863.field_9236)
			return;
		if (getItem().method_7960() && beltBelow != null) {
			beltBelow.handleCenteredProcessingOnAllItems(.5f, ts -> {
				if (canAcceptItem(ts.stack)) {
					setItem(ts.stack.method_7972(), -beltBelowOffset);
					return TransportedResult.removeItem();
				}
				return TransportedResult.doNothing();
			});
		}
	}

	private void tickAirStreams(float itemSpeed) {
		if (!field_11863.field_9236 && airCurrentUpdateCooldown-- <= 0) {
			airCurrentUpdateCooldown = AllConfigs.server().kinetics.fanBlockCheckRate.get();
			updateAirFlow = true;
		}

		if (updateAirFlow) {
			updateAirFlow(itemSpeed);
		}

		if (entitySearchCooldown-- <= 0 && item.method_7960()) {
			entitySearchCooldown = 5;
			findEntities(itemSpeed);
		}

		extractFromBelt(itemSpeed);
		// if (getSpeed() != 0)
		// airCurrent.tick();
	}

	public void blockBelowChanged() {
		updateAirFlow = true;
	}

	private void spawnParticles(float itemMotion) {
		// todo: reduce the amount of particles
		if (field_11863 == null)
			return;
		class_2680 blockState = method_11010();
		boolean up = itemMotion > 0;
		float absMotion = up ? itemMotion : -itemMotion;
		if (blockState == null || !AbstractChuteBlock.isChute(blockState))
			return;
		if (push == 0 && pull == 0)
			return;

		if (up && AbstractChuteBlock.isOpenChute(blockState)
			&& BlockHelper.noCollisionInSpace(field_11863, field_11867.method_10084()))
			spawnAirFlow(1, 2, absMotion, .5f);

		if (AbstractChuteBlock.getChuteFacing(blockState) != class_2350.field_11033)
			return;

		if (AbstractChuteBlock.isTransparentChute(blockState))
			spawnAirFlow(up ? 0 : 1, up ? 1 : 0, absMotion, 1);

		if (!up && BlockHelper.noCollisionInSpace(field_11863, field_11867.method_10074()))
			spawnAirFlow(0, -1, absMotion, .5f);

		if (up && canCollectItemsFromBelow() && bottomPullDistance > 0) {
			spawnAirFlow(-bottomPullDistance, 0, absMotion, 2);
			spawnAirFlow(-bottomPullDistance, 0, absMotion, 2);
		}
	}

	private void spawnAirFlow(float verticalStart, float verticalEnd, float motion, float drag) {
		if (field_11863 == null)
			return;
		AirParticleData airParticleData = new AirParticleData(drag, motion);
		class_243 origin = class_243.method_24954(field_11867);
		float xOff = Create.RANDOM.nextFloat() * .5f + .25f;
		float zOff = Create.RANDOM.nextFloat() * .5f + .25f;
		class_243 v = origin.method_1031(xOff, verticalStart, zOff);
		class_243 d = origin.method_1031(xOff, verticalEnd, zOff)
			.method_1020(v);
		if (Create.RANDOM.nextFloat() < 2 * motion)
			field_11863.method_8494(airParticleData, v.field_1352, v.field_1351, v.field_1350, d.field_1352, d.field_1351, d.field_1350);
	}

	private void handleInputFromAbove() {
		Storage<ItemVariant> storage = grabCapability(class_2350.field_11036);
		handleInput(storage, 1);
	}

	private void handleInputFromBelow() {
		Storage<ItemVariant> storage = grabCapability(class_2350.field_11033);
		handleInput(storage, 0);
	}

	private void handleInput(Storage<ItemVariant> inv, float startLocation) {
		if (inv == null)
			return;
		if (invVersionTracker.stillWaiting(inv))
			return;
		Predicate<class_1799> canAccept = this::canAcceptItem;
		int count = getExtractionAmount();
		ExtractionCountMode mode = getExtractionMode();
		if (mode == ExtractionCountMode.UPTO || !ItemHelper.extract(inv, canAccept, mode, count, true)
			.method_7960()) {
			class_1799 extracted = ItemHelper.extract(inv, canAccept, mode, count, false);
			if (!extracted.method_7960()) {
				setItem(extracted, startLocation);
				return;
			}
		}
		invVersionTracker.awaitNewVersion(inv);
	}

	private boolean handleDownwardOutput(boolean simulate) {
		class_2680 blockState = method_11010();
		ChuteBlockEntity targetChute = getTargetChute(blockState);
		class_2350 direction = AbstractChuteBlock.getChuteFacing(blockState);

		if (field_11863 == null || direction == null || !this.canOutputItems())
			return false;
		Storage<ItemVariant> below = grabCapability(class_2350.field_11033);
		if (below != null) {
			if (field_11863.field_9236 && !isVirtual())
				return false;

			try (Transaction t = TransferUtil.getTransaction()) {
				long inserted = below.insert(ItemVariant.of(item), item.method_7947(), t);
				if (inserted != 0 && !simulate) t.commit();
				class_1799 held = getItem();
				if (!simulate) {
					class_1799 newStack = held.method_7972();
					newStack.method_7934(ItemHelper.truncateLong(inserted));
					setItem(newStack, itemPosition.getValue(0));
				}
				if (inserted != 0)
					return true;
				if (direction == class_2350.field_11033)
					return false;
			}
		}

		if (targetChute != null) {
			boolean canInsert = targetChute.canAcceptItem(item);
			if (!simulate && canInsert) {
				targetChute.setItem(item, direction == class_2350.field_11033 ? 1 : .51f);
				setItem(class_1799.field_8037);
			}
			return canInsert;
		}

		// Diagonal chutes cannot drop items
		if (direction.method_10166()
				.method_10179())
			return false;

		if (FunnelBlock.getFunnelFacing(field_11863.method_8320(field_11867.method_10074())) == class_2350.field_11033)
			return false;
		if (class_2248.method_16361(field_11863, field_11867.method_10074()))
			return false;

		if (!simulate) {
			class_243 dropVec = VecHelper.getCenterOf(field_11867)
					.method_1031(0, -12 / 16f, 0);
			class_1542 dropped = new class_1542(field_11863, dropVec.field_1352, dropVec.field_1351, dropVec.field_1350, item.method_7972());
			dropped.method_6988();
			dropped.method_18800(0, -.25f, 0);
			field_11863.method_8649(dropped);
			setItem(class_1799.field_8037);
		}

		return true;
	}

	private boolean handleUpwardOutput(boolean simulate) {
		class_2680 stateAbove = field_11863.method_8320(field_11867.method_10084());

		if (field_11863 == null || !this.canOutputItems())
			return false;

		if (AbstractChuteBlock.isOpenChute(method_11010())) {
			Storage<ItemVariant> above = grabCapability(class_2350.field_11036);
			if (above != null) {
				if (field_11863.field_9236 && !isVirtual() && !ChuteBlock.isChute(stateAbove))
					return false;

				try (Transaction t = TransferUtil.getTransaction()) {
					long inserted = above.insert(ItemVariant.of(item), item.method_7947(), t);
					if (!simulate) {
						item = item.method_7972();
						item.method_7934(ItemHelper.truncateLong(inserted));
						itemHandler.update();
						sendData();
						t.commit();
					}
					return inserted != 0;
				}
			}
		}

		ChuteBlockEntity bestOutput = null;
		List<ChuteBlockEntity> inputChutes = getInputChutes();
		for (ChuteBlockEntity targetChute : inputChutes) {
			if (!targetChute.canAcceptItem(item))
				continue;
			float itemMotion = targetChute.getItemMotion();
			if (itemMotion < 0)
				continue;
			if (bestOutput == null || bestOutput.getItemMotion() < itemMotion) {
				bestOutput = targetChute;
			}
		}

		if (bestOutput != null) {
			if (!simulate) {
				bestOutput.setItem(item, 0);
				setItem(class_1799.field_8037);
			}
			return true;
		}

		if (FunnelBlock.getFunnelFacing(field_11863.method_8320(field_11867.method_10084())) == class_2350.field_11036)
			return false;
		if (BlockHelper.hasBlockSolidSide(stateAbove, field_11863, field_11867.method_10084(), class_2350.field_11033))
			return false;
		if (!inputChutes.isEmpty())
			return false;

		if (!simulate) {
			class_243 dropVec = VecHelper.getCenterOf(field_11867)
					.method_1031(0, 8 / 16f, 0);
			class_1542 dropped = new class_1542(field_11863, dropVec.field_1352, dropVec.field_1351, dropVec.field_1350, item.method_7972());
			dropped.method_6988();
			dropped.method_18800(0, getItemMotion() * 2, 0);
			field_11863.method_8649(dropped);
			setItem(class_1799.field_8037);
		}
		return true;
	}

	protected boolean canAcceptItem(class_1799 stack) {
		return item.method_7960();
	}

	protected int getExtractionAmount() {
		return 16;
	}

	protected ExtractionCountMode getExtractionMode() {
		return ExtractionCountMode.UPTO;
	}

	protected boolean canCollectItemsFromBelow() {
		return true;
	}

	protected boolean canOutputItems() {
		return true;
	}

	private Storage<ItemVariant> grabCapability(class_2350 side) {
		if (field_11863 == null)
			return null;
		StorageProvider<ItemVariant> provider = side == class_2350.field_11036 ? capAbove : capBelow;
		class_2586 be = provider.findBlockEntity();
		if (be instanceof ChuteBlockEntity) {
			if (side != class_2350.field_11033 || !(be instanceof SmartChuteBlockEntity) || getItemMotion() > 0)
				return null;
		}
		return provider.get(side.method_10153());
	}

	public void setItem(class_1799 stack) {
		setItem(stack, getItemMotion() < 0 ? 1 : 0);
	}

	public void setItem(class_1799 stack, float insertionPos) {
		item = stack;
		itemPosition.startWithValue(insertionPos);
		itemHandler.update();
		if (!field_11863.field_9236) {
			notifyUpdate();
			award(AllAdvancements.CHUTE);
		}
	}

	@Override
	public void invalidate() {
		super.invalidate();
	}

	@Override
	public void write(class_2487 compound, boolean clientPacket) {
		compound.method_10566("Item", NBTSerializer.serializeNBT(item));
		compound.method_10548("ItemPosition", itemPosition.getValue());
		compound.method_10548("Pull", pull);
		compound.method_10548("Push", push);
		compound.method_10548("BottomAirFlowDistance", bottomPullDistance);
		super.write(compound, clientPacket);
	}

	@Override
	protected void read(class_2487 compound, boolean clientPacket) {
		class_1799 previousItem = item;
		item = class_1799.method_7915(compound.method_10562("Item"));
		itemHandler.update();
		itemPosition.startWithValue(compound.method_10583("ItemPosition"));
		pull = compound.method_10583("Pull");
		push = compound.method_10583("Push");
		bottomPullDistance = compound.method_10583("BottomAirFlowDistance");
		super.read(compound, clientPacket);
//		if (clientPacket)
//			airCurrent.rebuild();

		if (method_11002() && field_11863 != null && field_11863.field_9236 && !class_1799.method_7973(previousItem, item) && !item.method_7960()) {
			if (field_11863.field_9229.method_43048(3) != 0)
				return;
			class_243 p = VecHelper.getCenterOf(field_11867);
			p = VecHelper.offsetRandomly(p, field_11863.field_9229, .5f);
			class_243 m = class_243.field_1353;
			field_11863.method_8406(new class_2392(class_2398.field_11218, item), p.field_1352, p.field_1351, p.field_1350, m.field_1352, m.field_1351, m.field_1350);
		}
	}

	public float getItemMotion() {
		// Chutes per second
		final float fanSpeedModifier = 1 / 64f;
		final float maxItemSpeed = 20f;
		final float gravity = 4f;

		float motion = (push + pull) * fanSpeedModifier;
		return (class_3532.method_15363(motion, -maxItemSpeed, maxItemSpeed) + (motion <= 0 ? -gravity : 0)) / 20f;
	}

	@Override
	public void destroy() {
		super.destroy();
		ChuteBlockEntity targetChute = getTargetChute(method_11010());
		List<ChuteBlockEntity> inputChutes = getInputChutes();
		if (!item.method_7960() && field_11863 != null)
			class_1264.method_5449(field_11863, field_11867.method_10263(), field_11867.method_10264(), field_11867.method_10260(), item);
		method_11012();
		if (targetChute != null) {
			targetChute.updatePull();
			targetChute.propagatePush();
		}
		inputChutes.forEach(c -> c.updatePush(inputChutes.size()));
	}

	public void onAdded() {
		refreshBlockState();
		updatePull();
		ChuteBlockEntity targetChute = getTargetChute(method_11010());
		if (targetChute != null)
			targetChute.propagatePush();
		else
			updatePush(1);
	}

	public void updatePull() {
		float totalPull = calculatePull();
		if (pull == totalPull)
			return;
		pull = totalPull;
		updateAirFlow = true;
		sendData();
		ChuteBlockEntity targetChute = getTargetChute(method_11010());
		if (targetChute != null)
			targetChute.updatePull();
	}

	public void updatePush(int branchCount) {
		float totalPush = calculatePush(branchCount);
		if (push == totalPush)
			return;
		updateAirFlow = true;
		push = totalPush;
		sendData();
		propagatePush();
	}

	public void propagatePush() {
		List<ChuteBlockEntity> inputs = getInputChutes();
		inputs.forEach(c -> c.updatePush(inputs.size()));
	}

	protected float calculatePull() {
		class_2680 blockStateAbove = field_11863.method_8320(field_11867.method_10084());
		if (AllBlocks.ENCASED_FAN.has(blockStateAbove)
			&& blockStateAbove.method_11654(EncasedFanBlock.FACING) == class_2350.field_11033) {
			class_2586 be = field_11863.method_8321(field_11867.method_10084());
			if (be instanceof EncasedFanBlockEntity && !be.method_11015()) {
				EncasedFanBlockEntity fan = (EncasedFanBlockEntity) be;
				return fan.getSpeed();
			}
		}

		float totalPull = 0;
		for (class_2350 d : Iterate.directions) {
			ChuteBlockEntity inputChute = getInputChute(d);
			if (inputChute == null)
				continue;
			totalPull += inputChute.pull;
		}
		return totalPull;
	}

	protected float calculatePush(int branchCount) {
		if (field_11863 == null)
			return 0;
		class_2680 blockStateBelow = field_11863.method_8320(field_11867.method_10074());
		if (AllBlocks.ENCASED_FAN.has(blockStateBelow)
			&& blockStateBelow.method_11654(EncasedFanBlock.FACING) == class_2350.field_11036) {
			class_2586 be = field_11863.method_8321(field_11867.method_10074());
			if (be instanceof EncasedFanBlockEntity && !be.method_11015()) {
				EncasedFanBlockEntity fan = (EncasedFanBlockEntity) be;
				return fan.getSpeed();
			}
		}

		ChuteBlockEntity targetChute = getTargetChute(method_11010());
		if (targetChute == null)
			return 0;
		return targetChute.push / branchCount;
	}

	@Nullable
	private ChuteBlockEntity getTargetChute(class_2680 state) {
		if (field_11863 == null)
			return null;
		class_2350 targetDirection = AbstractChuteBlock.getChuteFacing(state);
		if (targetDirection == null)
			return null;
		class_2338 chutePos = field_11867.method_10074();
		if (targetDirection.method_10166()
			.method_10179())
			chutePos = chutePos.method_10093(targetDirection.method_10153());
		class_2680 chuteState = field_11863.method_8320(chutePos);
		if (!AbstractChuteBlock.isChute(chuteState))
			return null;
		class_2586 be = field_11863.method_8321(chutePos);
		if (be instanceof ChuteBlockEntity)
			return (ChuteBlockEntity) be;
		return null;
	}

	private List<ChuteBlockEntity> getInputChutes() {
		List<ChuteBlockEntity> inputs = new LinkedList<>();
		for (class_2350 d : Iterate.directions) {
			ChuteBlockEntity inputChute = getInputChute(d);
			if (inputChute == null)
				continue;
			inputs.add(inputChute);
		}
		return inputs;
	}

	@Nullable
	private ChuteBlockEntity getInputChute(class_2350 direction) {
		if (field_11863 == null || direction == class_2350.field_11033)
			return null;
		direction = direction.method_10153();
		class_2338 chutePos = field_11867.method_10084();
		if (direction.method_10166()
			.method_10179())
			chutePos = chutePos.method_10093(direction);
		class_2680 chuteState = field_11863.method_8320(chutePos);
		class_2350 chuteFacing = AbstractChuteBlock.getChuteFacing(chuteState);
		if (chuteFacing != direction)
			return null;
		class_2586 be = field_11863.method_8321(chutePos);
		if (be instanceof ChuteBlockEntity && !be.method_11015())
			return (ChuteBlockEntity) be;
		return null;
	}

	public boolean addToGoggleTooltip(List<class_2561> tooltip, boolean isPlayerSneaking) {
		boolean downward = getItemMotion() < 0;
		Lang.translate("tooltip.chute.header")
			.forGoggles(tooltip);

		if (pull == 0 && push == 0)
			Lang.translate("tooltip.chute.no_fans_attached")
				.style(class_124.field_1080)
				.forGoggles(tooltip);
		if (pull != 0)
			Lang.translate("tooltip.chute.fans_" + (pull > 0 ? "pull_up" : "push_down"))
				.style(class_124.field_1080)
				.forGoggles(tooltip);
		if (push != 0)
			Lang.translate("tooltip.chute.fans_" + (push > 0 ? "push_up" : "pull_down"))
				.style(class_124.field_1080)
				.forGoggles(tooltip);

		Lang.text("-> ")
			.add(Lang.translate("tooltip.chute.items_move_" + (downward ? "down" : "up")))
			.style(class_124.field_1054)
			.forGoggles(tooltip);
		if (!item.method_7960())
			Lang.translate("tooltip.chute.contains", Components.translatable(item.method_7922())
				.getString(), item.method_7947())
				.style(class_124.field_1060)
				.forGoggles(tooltip);

		return true;
	}

	@Nullable
	@Override
	public Storage<ItemVariant> getItemStorage(@Nullable class_2350 face) {
		return itemHandler;
	}

	public class_1799 getItem() {
		return item;
	}

	// @Override
	// @Nullable
	// public AirCurrent getAirCurrent() {
	// return airCurrent;
	// }
	//
	// @Nullable
	// @Override
	// public World getAirCurrentWorld() {
	// return world;
	// }
	//
	// @Override
	// public BlockPos getAirCurrentPos() {
	// return pos;
	// }
	//
	// @Override
	// public float getSpeed() {
	// if (getBlockState().get(ChuteBlock.SHAPE) == Shape.NORMAL &&
	// getBlockState().get(ChuteBlock.FACING) != Direction.DOWN)
	// return 0;
	// return pull + push;
	// }
	//
	// @Override
	// @Nullable
	// public Direction getAirFlowDirection() {
	// float speed = getSpeed();
	// if (speed == 0)
	// return null;
	// return speed > 0 ? Direction.UP : Direction.DOWN;
	// }
	//
	// @Override
	// public boolean isSourceRemoved() {
	// return removed;
	// }
	//
	// @Override
	// public Direction getAirflowOriginSide() {
	// return world != null && !(world.getBlockEntity(pos.down()) instanceof
	// IAirCurrentSource)
	// && getBlockState().get(ChuteBlock.FACING) == Direction.DOWN ? Direction.DOWN
	// : Direction.UP;
	// }
}
