package com.simibubi.create.content.logistics.chute;

import java.util.HashMap;
import java.util.Map;
import net.minecraft.class_2248;
import net.minecraft.class_2350;
import net.minecraft.class_247;
import net.minecraft.class_259;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.logistics.chute.ChuteBlock.Shape;

public class ChuteShapes {

	static Map<class_2680, class_265> cache = new HashMap<>();
	static Map<class_2680, class_265> collisionCache = new HashMap<>();

	public static final class_265 INTERSECTION_MASK = class_2248.method_9541(0, -16, 0, 16, 16, 16);
	public static final class_265 COLLISION_MASK = class_2248.method_9541(0, 0, 0, 16, 24, 16);

	public static class_265 createShape(class_2680 state) {
		if (AllBlocks.SMART_CHUTE.has(state))
			return class_259.method_1077();
		
		class_2350 direction = state.method_11654(ChuteBlock.FACING);
		Shape shape = state.method_11654(ChuteBlock.SHAPE);

		boolean intersection = shape == Shape.INTERSECTION || shape == Shape.ENCASED;
		if (direction == class_2350.field_11033)
			return intersection ? class_259.method_1077() : AllShapes.CHUTE;

		class_265 combineWith = intersection ? class_259.method_1077() : class_259.method_1073();
		class_265 result = class_259.method_1084(combineWith, AllShapes.CHUTE_SLOPE.get(direction));
		if (intersection)
			result = class_259.method_1082(INTERSECTION_MASK, result, class_247.field_16896);
		return result;
	}

	public static class_265 getShape(class_2680 state) {
		if (cache.containsKey(state))
			return cache.get(state);
		class_265 createdShape = createShape(state);
		cache.put(state, createdShape);
		return createdShape;
	}

	public static class_265 getCollisionShape(class_2680 state) {
		if (collisionCache.containsKey(state))
			return collisionCache.get(state);
		class_265 createdShape = class_259.method_1082(COLLISION_MASK, getShape(state), class_247.field_16896);
		collisionCache.put(state, createdShape);
		return createdShape;
	}

	public static final class_265 PANEL = class_2248.method_9541(1, -15, 0, 15, 4, 1);

	public static class_265 createSlope() {
		class_265 shape = class_259.method_1073();
		for (int i = 0; i < 16; i++) {
			float offset = i / 16f;
			shape = class_259.method_1072(shape, PANEL.method_1096(0, offset, offset), class_247.field_1366);
		}
		return shape;
	}

}
