package com.simibubi.create.content.logistics.chute;

import java.util.List;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.filtering.FilteringBehaviour;
import com.simibubi.create.foundation.item.ItemHelper.ExtractionCountMode;

public class SmartChuteBlockEntity extends ChuteBlockEntity {

	FilteringBehaviour filtering;

	public SmartChuteBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
	}

	@Override
	protected boolean canAcceptItem(class_1799 stack) {
		return super.canAcceptItem(stack) && canCollectItemsFromBelow() && filtering.test(stack);
	}

	@Override
	protected int getExtractionAmount() {
		return filtering.isCountVisible() && !filtering.anyAmount() ? filtering.getAmount() : 64;
	}

	@Override
	protected ExtractionCountMode getExtractionMode() {
		return filtering.isCountVisible() && !filtering.anyAmount() && !filtering.upTo ? ExtractionCountMode.EXACTLY
			: ExtractionCountMode.UPTO;
	}

	@Override
	protected boolean canCollectItemsFromBelow() {
		class_2680 blockState = method_11010();
		return blockState.method_28498(SmartChuteBlock.POWERED) && !blockState.method_11654(SmartChuteBlock.POWERED);
	}
	
	@Override
	protected boolean canOutputItems() {
		class_2680 blockState = method_11010();
		return blockState.method_28498(SmartChuteBlock.POWERED) && !blockState.method_11654(SmartChuteBlock.POWERED);
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {
		behaviours.add(filtering =
			new FilteringBehaviour(this, new SmartChuteFilterSlotPositioning()).showCountWhen(this::isExtracting)
				.withCallback($ -> invVersionTracker.reset()));
		super.addBehaviours(behaviours);
	}

	private boolean isExtracting() {
		boolean up = getItemMotion() < 0;
		class_2338 chutePos = field_11867.method_10093(up ? class_2350.field_11036 : class_2350.field_11033);
		class_2680 blockState = field_11863.method_8320(chutePos);
		return !AbstractChuteBlock.isChute(blockState) && !blockState.method_45474();
	}

}
