package com.simibubi.create.content.logistics.depot;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.content.kinetics.belt.BeltHelper;
import com.simibubi.create.content.kinetics.belt.transport.TransportedItemStack;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.renderer.SafeBlockEntityRenderer;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_1297;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_310;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5614;
import net.minecraft.class_5819;
import net.minecraft.class_7833;
import net.minecraft.class_811;
import net.minecraft.class_918;

public class DepotRenderer extends SafeBlockEntityRenderer<DepotBlockEntity> {

	public DepotRenderer(class_5614.class_5615 context) {
	}

	@Override
	protected void renderSafe(DepotBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay) {
		renderItemsOf(be, partialTicks, ms, buffer, light, overlay, be.depotBehaviour);
	}

	public static void renderItemsOf(SmartBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay, DepotBehaviour depotBehaviour) {

		TransportedItemStack transported = depotBehaviour.heldItem;
		TransformStack msr = TransformStack.cast(ms);
		class_243 itemPosition = VecHelper.getCenterOf(be.method_11016());

		ms.method_22903();
		ms.method_46416(.5f, 15 / 16f, .5f);

		if (transported != null)
			depotBehaviour.incoming.add(transported);

		// Render main items
		for (TransportedItemStack tis : depotBehaviour.incoming) {
			ms.method_22903();
			msr.nudge(0);
			float offset = class_3532.method_16439(partialTicks, tis.prevBeltPosition, tis.beltPosition);
			float sideOffset = class_3532.method_16439(partialTicks, tis.prevSideOffset, tis.sideOffset);

			if (tis.insertedFrom.method_10166()
				.method_10179()) {
				class_243 offsetVec = class_243.method_24954(tis.insertedFrom.method_10153()
					.method_10163()).method_1021(.5f - offset);
				ms.method_22904(offsetVec.field_1352, offsetVec.field_1351, offsetVec.field_1350);
				boolean alongX = tis.insertedFrom.method_10170()
					.method_10166() == class_2350.class_2351.field_11048;
				if (!alongX)
					sideOffset *= -1;
				ms.method_46416(alongX ? sideOffset : 0, 0, alongX ? 0 : sideOffset);
			}

			class_1799 itemStack = tis.stack;
			int angle = tis.angle;
			class_5819 r = class_5819.method_43049(0);
			renderItem(be.method_10997(), ms, buffer, light, overlay, itemStack, angle, r, itemPosition);
			ms.method_22909();
		}

		if (transported != null)
			depotBehaviour.incoming.remove(transported);

		// Render output items
		for (int i = 0; i < depotBehaviour.processingOutputBuffer.getSlotCount(); i++) {
			class_1799 stack = depotBehaviour.processingOutputBuffer.getStackInSlot(i);
			if (stack.method_7960())
				continue;
			ms.method_22903();
			msr.nudge(i);

			boolean renderUpright = BeltHelper.isItemUpright(stack);
			msr.rotateY(360 / 8f * i);
			ms.method_46416(.35f, 0, 0);
			if (renderUpright)
				msr.rotateY(-(360 / 8f * i));
			class_5819 r = class_5819.method_43049(i + 1);
			int angle = (int) (360 * r.method_43057());
			renderItem(be.method_10997(), ms, buffer, light, overlay, stack, renderUpright ? angle + 90 : angle, r, itemPosition);
			ms.method_22909();
		}

		ms.method_22909();
	}

	public static void renderItem(class_1937 level, class_4587 ms, class_4597 buffer, int light, int overlay, class_1799 itemStack,
		int angle, class_5819 r, class_243 itemPosition) {
		class_918 itemRenderer = class_310.method_1551()
			.method_1480();
		TransformStack msr = TransformStack.cast(ms);
		int count = (int) (class_3532.method_15351((int) (itemStack.method_7947()))) / 2;
		boolean renderUpright = BeltHelper.isItemUpright(itemStack);
		boolean blockItem = itemRenderer.method_4019(itemStack, null, null, 0)
			.method_4712();

		ms.method_22903();
		msr.rotateY(angle);

		if (renderUpright) {
			class_1297 renderViewEntity = class_310.method_1551().field_1719;
			if (renderViewEntity != null) {
				class_243 positionVec = renderViewEntity.method_19538();
				class_243 vectorForOffset = itemPosition;
				class_243 diff = vectorForOffset.method_1020(positionVec);
				float yRot = (float) (class_3532.method_15349(diff.field_1352, diff.field_1350) + Math.PI);
				ms.method_22907(class_7833.field_40716.rotation(yRot));
			}
			ms.method_22904(0, 3 / 32d, -1 / 16f);
		}

		for (int i = 0; i <= count; i++) {
			ms.method_22903();
			if (blockItem)
				ms.method_46416(r.method_43057() * .0625f * i, 0, r.method_43057() * .0625f * i);
			ms.method_22905(.5f, .5f, .5f);
			if (!blockItem && !renderUpright) {
				ms.method_46416(0, -3 / 16f, 0);
				msr.rotateX(90);
			}
			itemRenderer.method_23178(itemStack, class_811.field_4319, light, overlay, ms, buffer, level, 0);
			ms.method_22909();

			if (!renderUpright) {
				if (!blockItem)
					msr.rotateY(10);
				ms.method_22904(0, blockItem ? 1 / 64d : 1 / 16d, 0);
			} else
				ms.method_46416(0, 0, -1 / 16f);
		}

		ms.method_22909();
	}

}
