package com.simibubi.create.content.logistics.depot;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.foundation.networking.SimplePacketBase;

import com.tterrag.registrate.fabric.EnvExecutor;

import net.fabricmc.api.EnvType;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2540;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_3222;

public class EjectorPlacementPacket extends SimplePacketBase {

	private int h, v;
	private class_2338 pos;
	private class_2350 facing;

	public EjectorPlacementPacket(int h, int v, class_2338 pos, class_2350 facing) {
		this.h = h;
		this.v = v;
		this.pos = pos;
		this.facing = facing;
	}

	public EjectorPlacementPacket(class_2540 buffer) {
		h = buffer.readInt();
		v = buffer.readInt();
		pos = buffer.method_10811();
		facing = class_2350.method_10143(buffer.method_10816());
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(h);
		buffer.writeInt(v);
		buffer.method_10807(pos);
		buffer.method_10804(facing.method_10146());
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (player == null)
				return;
			class_1937 world = player.method_37908();
			if (world == null || !world.method_8477(pos))
				return;
			class_2586 blockEntity = world.method_8321(pos);
			class_2680 state = world.method_8320(pos);
			if (blockEntity instanceof EjectorBlockEntity)
				((EjectorBlockEntity) blockEntity).setTarget(h, v);
			if (AllBlocks.WEIGHTED_EJECTOR.has(state))
				world.method_8501(pos, state.method_11657(EjectorBlock.HORIZONTAL_FACING, facing));
		});
		return true;
	}

	public static class ClientBoundRequest extends SimplePacketBase {

		class_2338 pos;

		public ClientBoundRequest(class_2338 pos) {
			this.pos = pos;
		}

		public ClientBoundRequest(class_2540 buffer) {
			this.pos = buffer.method_10811();
		}

		@Override
		public void write(class_2540 buffer) {
			buffer.method_10807(pos);
		}

		@Override
		public boolean handle(Context context) {
			context.enqueueWork(
				() -> EnvExecutor.runWhenOn(EnvType.CLIENT,
						() -> () -> EjectorTargetHandler.flushSettings(pos)));
			return true;
		}

	}

}
