package com.simibubi.create.content.logistics.depot;

import org.joml.Vector3f;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllPackets;
import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import com.simibubi.create.foundation.utility.Color;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.VecHelper;
import com.simibubi.create.infrastructure.config.AllConfigs;
import net.minecraft.class_124;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_238;
import net.minecraft.class_239;
import net.minecraft.class_239.class_240;
import net.minecraft.class_2390;
import net.minecraft.class_243;
import net.minecraft.class_2586;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_3965;
import net.minecraft.class_638;
import net.minecraft.class_746;

public class EjectorTargetHandler {

	static class_2338 currentSelection;
	static class_1799 currentItem;
	static long lastHoveredBlockPos = -1;
	static EntityLauncher launcher;

	public static class_1269 rightClickingBlocksSelectsThem(class_1657 player, class_1937 world, class_1268 hand, class_3965 hitResult) {
		if (currentItem == null)
			return class_1269.field_5811;
		class_2338 pos = hitResult.method_17777();//event.getPos();
//		Level world = event.getWorld();
		if (!world.field_9236)
			return class_1269.field_5811;
//		Player player = event.getPlayer();
		if (player == null || player.method_7325() || !player.method_5715())
			return class_1269.field_5811;

		String key = "weighted_ejector.target_set";
		class_124 colour = class_124.field_1065;
		player.method_7353(Lang.translateDirect(key)
			.method_27692(colour), true);
		currentSelection = pos;
		launcher = null;
//		event.setCanceled(true);
//		event.setCancellationResult(InteractionResult.SUCCESS);
		return class_1269.field_5812;
	}

	public static class_1269 leftClickingBlocksDeselectsThem(class_1657 player, class_1937 world, class_1268 hand, class_2338 pos, class_2350 direction) {
		if (currentItem == null)
			return class_1269.field_5811;
		if (!world.field_9236)
			return class_1269.field_5811;
		if (player.method_7325())
			return class_1269.field_5811;
		if (!player
			.method_5715())
			return class_1269.field_5811;
//		BlockPos pos = event.getPos();
		if (pos.equals(currentSelection)) {
			currentSelection = null;
			launcher = null;
//			event.setCanceled(true);
//			event.setCancellationResult(InteractionResult.SUCCESS);
			return class_1269.field_5812;
		}
		return class_1269.field_5811;
	}

	public static void flushSettings(class_2338 pos) {
		int h = 0;
		int v = 0;

		class_746 player = class_310.method_1551().field_1724;
		String key = "weighted_ejector.target_not_valid";
		class_124 colour = class_124.field_1068;

		if (currentSelection == null)
			key = "weighted_ejector.no_target";

		class_2350 validTargetDirection = getValidTargetDirection(pos);
		if (validTargetDirection == null) {
			player.method_7353(Lang.translateDirect(key)
				.method_27692(colour), true);
			currentItem = null;
			currentSelection = null;
			return;
		}

		key = "weighted_ejector.targeting";
		colour = class_124.field_1060;

		player.method_7353(
			Lang.translateDirect(key, currentSelection.method_10263(), currentSelection.method_10264(), currentSelection.method_10260())
				.method_27692(colour),
			true);

		class_2338 diff = pos.method_10059(currentSelection);
		h = Math.abs(diff.method_10263() + diff.method_10260());
		v = -diff.method_10264();

		AllPackets.getChannel().sendToServer(new EjectorPlacementPacket(h, v, pos, validTargetDirection));
		currentSelection = null;
		currentItem = null;

	}

	public static class_2350 getValidTargetDirection(class_2338 pos) {
		if (currentSelection == null)
			return null;
		if (VecHelper.onSameAxis(pos, currentSelection, class_2351.field_11052))
			return null;

		int xDiff = currentSelection.method_10263() - pos.method_10263();
		int zDiff = currentSelection.method_10260() - pos.method_10260();
		int max = AllConfigs.server().kinetics.maxEjectorDistance.get();

		if (Math.abs(xDiff) > max || Math.abs(zDiff) > max)
			return null;

		if (xDiff == 0)
			return class_2350.method_10156(zDiff < 0 ? class_2352.field_11060 : class_2352.field_11056, class_2351.field_11051);
		if (zDiff == 0)
			return class_2350.method_10156(xDiff < 0 ? class_2352.field_11060 : class_2352.field_11056, class_2351.field_11048);

		return null;
	}

	public static void tick() {
		class_1657 player = class_310.method_1551().field_1724;

		if (player == null)
			return;

		class_1799 heldItemMainhand = player.method_6047();
		if (!AllBlocks.WEIGHTED_EJECTOR.isIn(heldItemMainhand)) {
			currentItem = null;
		} else {
			if (heldItemMainhand != currentItem) {
				currentSelection = null;
				currentItem = heldItemMainhand;
			}
			drawOutline(currentSelection);
		}

		checkForWrench(heldItemMainhand);
		drawArc();
	}

	protected static void drawArc() {
		class_310 mc = class_310.method_1551();
		boolean wrench = AllItems.WRENCH.isIn(mc.field_1724.method_6047());

		if (currentSelection == null)
			return;
		if (currentItem == null && !wrench)
			return;

		class_239 objectMouseOver = mc.field_1765;
		if (!(objectMouseOver instanceof class_3965))
			return;
		class_3965 blockRayTraceResult = (class_3965) objectMouseOver;
		if (blockRayTraceResult.method_17783() == class_240.field_1333)
			return;

		class_2338 pos = blockRayTraceResult.method_17777();
		if (!wrench)
			pos = pos.method_10093(blockRayTraceResult.method_17780());

		int xDiff = currentSelection.method_10263() - pos.method_10263();
		int yDiff = currentSelection.method_10264() - pos.method_10264();
		int zDiff = currentSelection.method_10260() - pos.method_10260();
		int validX = Math.abs(zDiff) > Math.abs(xDiff) ? 0 : xDiff;
		int validZ = Math.abs(zDiff) < Math.abs(xDiff) ? 0 : zDiff;

		class_2338 validPos = currentSelection.method_10069(validX, yDiff, validZ);
		class_2350 d = getValidTargetDirection(validPos);
		if (d == null)
			return;
		if (launcher == null || lastHoveredBlockPos != pos.method_10063()) {
			lastHoveredBlockPos = pos.method_10063();
			launcher = new EntityLauncher(Math.abs(validX + validZ), yDiff);
		}

		double totalFlyingTicks = launcher.getTotalFlyingTicks() + 3;
		int segments = (((int) totalFlyingTicks) / 3) + 1;
		double tickOffset = totalFlyingTicks / segments;
		boolean valid = xDiff == validX && zDiff == validZ;
		int intColor = valid ? 0x9ede73 : 0xff7171;
		Vector3f color = new Color(intColor).asVectorF();
		class_2390 data = new class_2390(color, 1);
		class_638 world = mc.field_1687;

		class_238 bb = new class_238(0, 0, 0, 1, 0, 1).method_996(currentSelection.method_10069(-validX, -yDiff, -validZ));
		CreateClient.OUTLINER.chaseAABB("valid", bb)
			.colored(intColor)
			.lineWidth(1 / 16f);

		for (int i = 0; i < segments; i++) {
			double ticks = ((AnimationTickHolder.getRenderTime() / 3) % tickOffset) + i * tickOffset;
			class_243 vec = launcher.getGlobalPos(ticks, d, pos)
				.method_1031(xDiff - validX, 0, zDiff - validZ);
			world.method_8406(data, vec.field_1352, vec.field_1351, vec.field_1350, 0, 0, 0);
		}
	}

	private static void checkForWrench(class_1799 heldItem) {
		if (!AllItems.WRENCH.isIn(heldItem))
			return;
		class_239 objectMouseOver = class_310.method_1551().field_1765;
		if (!(objectMouseOver instanceof class_3965))
			return;
		class_3965 result = (class_3965) objectMouseOver;
		class_2338 pos = result.method_17777();

		class_2586 be = class_310.method_1551().field_1687.method_8321(pos);
		if (!(be instanceof EjectorBlockEntity)) {
			lastHoveredBlockPos = -1;
			currentSelection = null;
			return;
		}

		if (lastHoveredBlockPos == -1 || lastHoveredBlockPos != pos.method_10063()) {
			EjectorBlockEntity ejector = (EjectorBlockEntity) be;
			if (!ejector.getTargetPosition()
				.equals(ejector.method_11016()))
				currentSelection = ejector.getTargetPosition();
			lastHoveredBlockPos = pos.method_10063();
			launcher = null;
		}

		if (lastHoveredBlockPos != -1)
			drawOutline(currentSelection);
	}

	public static void drawOutline(class_2338 selection) {
		class_1937 world = class_310.method_1551().field_1687;
		if (selection == null)
			return;

		class_2338 pos = selection;
		class_2680 state = world.method_8320(pos);
		class_265 shape = state.method_26218(world, pos);
		class_238 boundingBox = shape.method_1110() ? new class_238(class_2338.field_10980) : shape.method_1107();
		CreateClient.OUTLINER.showAABB("target", boundingBox.method_996(pos))
			.colored(0xffcb74)
			.lineWidth(1 / 16f);
	}

}
