package com.simibubi.create.content.logistics.depot;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.Create;
import com.simibubi.create.content.kinetics.belt.behaviour.DirectBeltInputBehaviour;
import com.simibubi.create.foundation.item.ItemHelper;
import com.simibubi.create.content.kinetics.belt.transport.TransportedItemStack;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;

import com.simibubi.create.foundation.utility.AdventureUtil;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;
import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.StorageView;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1297;
import net.minecraft.class_1542;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3532;
import net.minecraft.class_3965;

public class SharedDepotBlockMethods {

	protected static DepotBehaviour get(class_1922 worldIn, class_2338 pos) {
		return BlockEntityBehaviour.get(worldIn, pos, DepotBehaviour.TYPE);
	}

	public static class_1269 onUse(class_2680 state, class_1937 world, class_2338 pos, class_1657 player,
		class_1268 hand, class_3965 ray) {
		if (ray.method_17780() != class_2350.field_11036)
			return class_1269.field_5811;
		if (world.field_9236)
			return class_1269.field_5812;
		if (AdventureUtil.isAdventure(player))
			return class_1269.field_5811;

		DepotBehaviour behaviour = get(world, pos);
		if (behaviour == null)
			return class_1269.field_5811;
		if (!behaviour.canAcceptItems.get())
			return class_1269.field_5812;

		class_1799 heldItem = player.method_5998(hand);
		boolean wasEmptyHanded = heldItem.method_7960();
		boolean shouldntPlaceItem = AllBlocks.MECHANICAL_ARM.isIn(heldItem);

		class_1799 mainItemStack = behaviour.getHeldItemStack();
		if (!mainItemStack.method_7960()) {
			player.method_31548()
				.method_7398(mainItemStack);
			behaviour.removeHeldItem();
			world.method_8396(null, pos, class_3417.field_15197, class_3419.field_15248, .2f,
				1f + Create.RANDOM.nextFloat());
		}
		ItemStackHandler outputs = behaviour.processingOutputBuffer;
		try (Transaction t = TransferUtil.getTransaction()) {
			for (StorageView<ItemVariant> view : outputs.nonEmptyViews()) {
				ItemVariant var = view.getResource();
				long extracted = view.extract(var, 64, t);
				class_1799 stack = var.toStack(ItemHelper.truncateLong(extracted));
				player.method_31548().method_7398(stack);
			}
			t.commit();
		}

		if (!wasEmptyHanded && !shouldntPlaceItem) {
			TransportedItemStack transported = new TransportedItemStack(heldItem);
			transported.insertedFrom = player.method_5735();
			transported.prevBeltPosition = .25f;
			transported.beltPosition = .25f;
			behaviour.setHeldItem(transported);
			player.method_6122(hand, class_1799.field_8037);
			AllSoundEvents.DEPOT_SLIDE.playOnServer(world, pos);
		}

		behaviour.blockEntity.notifyUpdate();
		return class_1269.field_5812;
	}

	public static void onLanded(class_1922 worldIn, class_1297 entityIn) {
		if (!(entityIn instanceof class_1542))
			return;
		if (!entityIn.method_5805())
			return;
		if (entityIn.method_37908().field_9236)
			return;

		class_1542 itemEntity = (class_1542) entityIn;
		DirectBeltInputBehaviour inputBehaviour =
			BlockEntityBehaviour.get(worldIn, entityIn.method_24515(), DirectBeltInputBehaviour.TYPE);
		if (inputBehaviour == null)
			return;
		class_1799 remainder = inputBehaviour.handleInsertion(itemEntity.method_6983(), class_2350.field_11033, false);
		itemEntity.method_6979(remainder);
		if (remainder.method_7960())
			itemEntity.method_31472();
	}

	public static int getComparatorInputOverride(class_2680 blockState, class_1937 worldIn, class_2338 pos) {
		DepotBehaviour depotBehaviour = get(worldIn, pos);
		if (depotBehaviour == null)
			return 0;
		float f = depotBehaviour.getPresentStackSize();
		Integer max = depotBehaviour.maxStackSize.get();
		f = f / (max == 0 ? 64 : max);
		return class_3532.method_15340(class_3532.method_15375(f * 14.0F) + (f > 0 ? 1 : 0), 0, 15);
	}

}
