package com.simibubi.create.content.logistics.filter;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_124;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1713;
import net.minecraft.class_1735;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2520;
import net.minecraft.class_2540;
import net.minecraft.class_3917;
import com.simibubi.create.AllMenuTypes;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Pair;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;
import io.github.fabricators_of_create.porting_lib.transfer.item.SlotItemHandler;

public class AttributeFilterMenu extends AbstractFilterMenu {

	public enum WhitelistMode {
		WHITELIST_DISJ, WHITELIST_CONJ, BLACKLIST;
	}

	WhitelistMode whitelistMode;
	List<Pair<ItemAttribute, Boolean>> selectedAttributes;

	public AttributeFilterMenu(class_3917<?> type, int id, class_1661 inv, class_2540 extraData) {
		super(type, id, inv, extraData);
	}

	public AttributeFilterMenu(class_3917<?> type, int id, class_1661 inv, class_1799 stack) {
		super(type, id, inv, stack);
	}

	public static AttributeFilterMenu create(int id, class_1661 inv, class_1799 stack) {
		return new AttributeFilterMenu(AllMenuTypes.ATTRIBUTE_FILTER.get(), id, inv, stack);
	}

	public void appendSelectedAttribute(ItemAttribute itemAttribute, boolean inverted) {
		selectedAttributes.add(Pair.of(itemAttribute, inverted));
	}

	@Override
	protected void init(class_1661 inv, class_1799 contentHolder) {
		super.init(inv, contentHolder);
		class_1799 stack = new class_1799(class_1802.field_8448);
		stack.method_7977(
				Components.literal("Selected Tags").method_27695(class_124.field_1070, class_124.field_1078));
		ghostInventory.setStackInSlot(1, stack);
	}

	@Override
	protected int getPlayerInventoryXOffset() {
		return 51;
	}

	@Override
	protected int getPlayerInventoryYOffset() {
		return 107;
	}

	@Override
	protected void addFilterSlots() {
		this.method_7621(new SlotItemHandler(ghostInventory, 0, 16, 24));
		this.method_7621(new SlotItemHandler(ghostInventory, 1, 22, 59) {
			@Override
			public boolean method_7674(class_1657 playerIn) {
				return false;
			}
		});
	}

	@Override
	protected ItemStackHandler createGhostInventory() {
		return new ItemStackHandler(2);
	}

	@Override
	public void clearContents() {
		selectedAttributes.clear();
	}

	@Override
	public void method_7593(int slotId, int dragType, class_1713 clickTypeIn, class_1657 player) {
		if (slotId == 37)
			return;
		super.method_7593(slotId, dragType, clickTypeIn, player);
	}

	@Override
	public boolean method_7615(class_1735 slotIn) {
		if (slotIn.field_7874 == 37)
			return false;
		return super.method_7615(slotIn);
	}

	@Override
	public boolean method_7613(class_1799 stack, class_1735 slotIn) {
		if (slotIn.field_7874 == 37)
			return false;
		return super.method_7613(stack, slotIn);
	}

	@Override
	public class_1799 method_7601(class_1657 playerIn, int index) {
		if (index == 37)
			return class_1799.field_8037;
		if (index == 36) {
			ghostInventory.setStackInSlot(37, class_1799.field_8037);
			return class_1799.field_8037;
		}
		if (index < 36) {
			class_1799 stackToInsert = playerInventory.method_5438(index);
			class_1799 copy = stackToInsert.method_7972();
			copy.method_7939(1);
			ghostInventory.setStackInSlot(0, copy);
		}
		return class_1799.field_8037;
	}

	@Override
	protected void initAndReadInventory(class_1799 filterItem) {
		super.initAndReadInventory(filterItem);
		selectedAttributes = new ArrayList<>();
		whitelistMode = WhitelistMode.values()[filterItem.method_7948()
			.method_10550("WhitelistMode")];
		class_2499 attributes = filterItem.method_7948()
			.method_10554("MatchedAttributes", class_2520.field_33260);
		attributes.forEach(inbt -> {
			class_2487 compound = (class_2487) inbt;
			selectedAttributes.add(Pair.of(ItemAttribute.fromNBT(compound), compound.method_10577("Inverted")));
		});
	}

	@Override
	protected void saveData(class_1799 filterItem) {
		filterItem.method_7948()
				.method_10569("WhitelistMode", whitelistMode.ordinal());
		class_2499 attributes = new class_2499();
		selectedAttributes.forEach(at -> {
			if (at == null)
				return;
			class_2487 compoundNBT = new class_2487();
			at.getFirst()
					.serializeNBT(compoundNBT);
			compoundNBT.method_10556("Inverted", at.getSecond());
			attributes.add(compoundNBT);
		});
		filterItem.method_7948()
			.method_10566("MatchedAttributes", attributes);
		
		if (attributes.isEmpty() && whitelistMode == WhitelistMode.WHITELIST_DISJ)
			filterItem.method_7980(null);
	}

}
