package com.simibubi.create.content.logistics.filter;

import com.simibubi.create.AllMenuTypes;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;
import io.github.fabricators_of_create.porting_lib.transfer.item.SlotItemHandler;
import net.minecraft.class_1661;
import net.minecraft.class_1799;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_3917;

public class FilterMenu extends AbstractFilterMenu {

	boolean respectNBT;
	boolean blacklist;

	public FilterMenu(class_3917<?> type, int id, class_1661 inv, class_2540 extraData) {
		super(type, id, inv, extraData);
	}

	public FilterMenu(class_3917<?> type, int id, class_1661 inv, class_1799 stack) {
		super(type, id, inv, stack);
	}

	public static FilterMenu create(int id, class_1661 inv, class_1799 stack) {
		return new FilterMenu(AllMenuTypes.FILTER.get(), id, inv, stack);
	}

	@Override
	protected int getPlayerInventoryXOffset() {
		return 38;
	}

	@Override
	protected int getPlayerInventoryYOffset() {
		return 121;
	}

	@Override
	protected void addFilterSlots() {
		int x = 23;
		int y = 22;
		for (int row = 0; row < 2; ++row)
			for (int col = 0; col < 9; ++col)
				this.method_7621(new SlotItemHandler(ghostInventory, col + row * 9, x + col * 18, y + row * 18));
	}

	@Override
	protected ItemStackHandler createGhostInventory() {
		return FilterItem.getFilterItems(contentHolder);
	}

	@Override
	protected void initAndReadInventory(class_1799 filterItem) {
		super.initAndReadInventory(filterItem);
		class_2487 tag = filterItem.method_7948();
		respectNBT = tag.method_10577("RespectNBT");
		blacklist = tag.method_10577("Blacklist");
	}

	@Override
	protected void saveData(class_1799 filterItem) {
		super.saveData(filterItem);
		class_2487 tag = filterItem.method_7948();
		tag.method_10556("RespectNBT", respectNBT);
		tag.method_10556("Blacklist", blacklist);

		if (respectNBT || blacklist)
			return;
		for (int i = 0; i < ghostInventory.getSlotCount(); i++)
			if (!ghostInventory.getStackInSlot(i)
				.method_7960())
				return;
		filterItem.method_7980(null);
	}

}
