package com.simibubi.create.content.logistics.filter;

import java.util.Arrays;
import java.util.List;
import net.minecraft.class_1661;
import net.minecraft.class_2561;
import net.minecraft.class_5250;
import com.simibubi.create.content.logistics.filter.FilterScreenPacket.Option;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.AllIcons;
import com.simibubi.create.foundation.gui.widget.IconButton;
import com.simibubi.create.foundation.gui.widget.Indicator;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;

public class FilterScreen extends AbstractFilterScreen<FilterMenu> {

	private static final String PREFIX = "gui.filter.";

	private class_2561 allowN = Lang.translateDirect(PREFIX + "allow_list");
	private class_2561 allowDESC = Lang.translateDirect(PREFIX + "allow_list.description");
	private class_2561 denyN = Lang.translateDirect(PREFIX + "deny_list");
	private class_2561 denyDESC = Lang.translateDirect(PREFIX + "deny_list.description");

	private class_2561 respectDataN = Lang.translateDirect(PREFIX + "respect_data");
	private class_2561 respectDataDESC = Lang.translateDirect(PREFIX + "respect_data.description");
	private class_2561 ignoreDataN = Lang.translateDirect(PREFIX + "ignore_data");
	private class_2561 ignoreDataDESC = Lang.translateDirect(PREFIX + "ignore_data.description");

	private IconButton whitelist, blacklist;
	private IconButton respectNBT, ignoreNBT;
	private Indicator whitelistIndicator, blacklistIndicator;
	private Indicator respectNBTIndicator, ignoreNBTIndicator;

	public FilterScreen(FilterMenu menu, class_1661 inv, class_2561 title) {
		super(menu, inv, title, AllGuiTextures.FILTER);
	}

	@Override
	protected void method_25426() {
		setWindowOffset(-11, 5);
		super.method_25426();

		int x = field_2776;
		int y = field_2800;

		blacklist = new IconButton(x + 18, y + 75, AllIcons.I_BLACKLIST);
		blacklist.withCallback(() -> {
			field_2797.blacklist = true;
			sendOptionUpdate(Option.BLACKLIST);
		});
		blacklist.setToolTip(denyN);
		whitelist = new IconButton(x + 36, y + 75, AllIcons.I_WHITELIST);
		whitelist.withCallback(() -> {
			field_2797.blacklist = false;
			sendOptionUpdate(Option.WHITELIST);
		});
		whitelist.setToolTip(allowN);
		blacklistIndicator = new Indicator(x + 18, y + 69, Components.immutableEmpty());
		whitelistIndicator = new Indicator(x + 36, y + 69, Components.immutableEmpty());
		addRenderableWidgets(blacklist, whitelist, blacklistIndicator, whitelistIndicator);

		respectNBT = new IconButton(x + 60, y + 75, AllIcons.I_RESPECT_NBT);
		respectNBT.withCallback(() -> {
			field_2797.respectNBT = true;
			sendOptionUpdate(Option.RESPECT_DATA);
		});
		respectNBT.setToolTip(respectDataN);
		ignoreNBT = new IconButton(x + 78, y + 75, AllIcons.I_IGNORE_NBT);
		ignoreNBT.withCallback(() -> {
			field_2797.respectNBT = false;
			sendOptionUpdate(Option.IGNORE_DATA);
		});
		ignoreNBT.setToolTip(ignoreDataN);
		respectNBTIndicator = new Indicator(x + 60, y + 69, Components.immutableEmpty());
		ignoreNBTIndicator = new Indicator(x + 78, y + 69, Components.immutableEmpty());
		addRenderableWidgets(respectNBT, ignoreNBT, respectNBTIndicator, ignoreNBTIndicator);

		handleIndicators();
	}

	@Override
	protected List<IconButton> getTooltipButtons() {
		return Arrays.asList(blacklist, whitelist, respectNBT, ignoreNBT);
	}

	@Override
	protected List<class_5250> getTooltipDescriptions() {
		return Arrays.asList(denyDESC.method_27662(), allowDESC.method_27662(), respectDataDESC.method_27662(), ignoreDataDESC.method_27662());
	}

	@Override
	protected List<Indicator> getIndicators() {
		return Arrays.asList(blacklistIndicator, whitelistIndicator, respectNBTIndicator, ignoreNBTIndicator);
	}

	@Override
	protected boolean isButtonEnabled(IconButton button) {
		if (button == blacklist)
			return !field_2797.blacklist;
		if (button == whitelist)
			return field_2797.blacklist;
		if (button == respectNBT)
			return !field_2797.respectNBT;
		if (button == ignoreNBT)
			return field_2797.respectNBT;
		return true;
	}

	@Override
	protected boolean isIndicatorOn(Indicator indicator) {
		if (indicator == blacklistIndicator)
			return field_2797.blacklist;
		if (indicator == whitelistIndicator)
			return !field_2797.blacklist;
		if (indicator == respectNBTIndicator)
			return field_2797.respectNBT;
		if (indicator == ignoreNBTIndicator)
			return !field_2797.respectNBT;
		return false;
	}

}
