package com.simibubi.create.content.logistics.filter;

import com.simibubi.create.content.logistics.filter.AttributeFilterMenu.WhitelistMode;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_3222;

public class FilterScreenPacket extends SimplePacketBase {

	public enum Option {
		WHITELIST, WHITELIST2, BLACKLIST, RESPECT_DATA, IGNORE_DATA, UPDATE_FILTER_ITEM, ADD_TAG, ADD_INVERTED_TAG;
	}

	private final Option option;
	private final class_2487 data;

	public FilterScreenPacket(Option option) {
		this(option, new class_2487());
	}

	public FilterScreenPacket(Option option, class_2487 data) {
		this.option = option;
		this.data = data;
	}

	public FilterScreenPacket(class_2540 buffer) {
		option = Option.values()[buffer.readInt()];
		data = buffer.method_10798();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeInt(option.ordinal());
		buffer.method_10794(data);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (player == null)
				return;

			if (player.field_7512 instanceof FilterMenu) {
				FilterMenu c = (FilterMenu) player.field_7512;
				if (option == Option.WHITELIST)
					c.blacklist = false;
				if (option == Option.BLACKLIST)
					c.blacklist = true;
				if (option == Option.RESPECT_DATA)
					c.respectNBT = true;
				if (option == Option.IGNORE_DATA)
					c.respectNBT = false;
				if (option == Option.UPDATE_FILTER_ITEM)
					c.ghostInventory.setStackInSlot(
							data.method_10550("Slot"),
							net.minecraft.class_1799.method_7915(data.method_10562("Item")));
			}

			if (player.field_7512 instanceof AttributeFilterMenu) {
				AttributeFilterMenu c = (AttributeFilterMenu) player.field_7512;
				if (option == Option.WHITELIST)
					c.whitelistMode = WhitelistMode.WHITELIST_DISJ;
				if (option == Option.WHITELIST2)
					c.whitelistMode = WhitelistMode.WHITELIST_CONJ;
				if (option == Option.BLACKLIST)
					c.whitelistMode = WhitelistMode.BLACKLIST;
				if (option == Option.ADD_TAG)
					c.appendSelectedAttribute(ItemAttribute.fromNBT(data), false);
				if (option == Option.ADD_INVERTED_TAG)
					c.appendSelectedAttribute(ItemAttribute.fromNBT(data), true);
			}

		});
		return true;
	}

}
