package com.simibubi.create.content.logistics.filter.attribute;

import java.util.List;
import java.util.stream.Collectors;

import javax.annotation.Nullable;
import net.minecraft.class_1799;
import net.minecraft.class_1887;
import net.minecraft.class_1890;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import net.minecraft.class_7923;
import com.simibubi.create.content.logistics.filter.ItemAttribute;
import com.simibubi.create.foundation.utility.Components;

public class EnchantAttribute implements ItemAttribute {
    public static final EnchantAttribute EMPTY = new EnchantAttribute(null);

    private final class_1887 enchantment;

    public EnchantAttribute(@Nullable class_1887 enchantment) {
        this.enchantment = enchantment;
    }

    @Override
    public boolean appliesTo(class_1799 itemStack) {
        return class_1890.method_8222(itemStack).containsKey(enchantment);
    }

    @Override
    public List<ItemAttribute> listAttributesOf(class_1799 itemStack) {
        return class_1890.method_8222(itemStack).keySet().stream().map(EnchantAttribute::new).collect(Collectors.toList());
    }

    @Override
    public String getTranslationKey() {
        return "has_enchant";
    }

    @Override
    public Object[] getTranslationParameters() {
        String parameter = "";
        if(enchantment != null)
            parameter = Components.translatable(enchantment.method_8184()).getString();
        return new Object[] { parameter };
    }

    @Override
    public void writeNBT(class_2487 nbt) {
        if (enchantment == null)
            return;
        class_2960 id = class_7923.field_41176.method_10221(enchantment);
        if (id == null)
            return;
        nbt.method_10582("id", id.toString());
    }

    @Override
    public ItemAttribute readNBT(class_2487 nbt) {
        return nbt.method_10545("id") ? new EnchantAttribute(class_7923.field_41176.method_10223(class_2960.method_12829(nbt.method_10558("id")))) : EMPTY;
    }
}
