package com.simibubi.create.content.logistics.filter.attribute;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import javax.annotation.Nullable;

import com.simibubi.create.content.logistics.filter.ItemAttribute;

import net.fabricmc.fabric.api.transfer.v1.fluid.FluidVariant;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidVariantAttributes;
import net.minecraft.class_1799;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import net.minecraft.class_3611;
import net.minecraft.class_7923;

public class FluidContentsAttribute implements ItemAttribute {
	public static final FluidContentsAttribute EMPTY = new FluidContentsAttribute(null);

	private final class_3611 fluid;

	public FluidContentsAttribute(@Nullable class_3611 fluid) {
		this.fluid = fluid;
	}

	@Override
	public boolean appliesTo(class_1799 itemStack) {
		return extractFluids(itemStack).contains(fluid);
	}

	@Override
	public List<ItemAttribute> listAttributesOf(class_1799 itemStack) {
		return extractFluids(itemStack).stream().map(FluidContentsAttribute::new).collect(Collectors.toList());
	}

	@Override
	public String getTranslationKey() {
		return "has_fluid";
	}

	@Override
	public Object[] getTranslationParameters() {
		String parameter = "";
		 if (fluid != null)
		 	parameter = FluidVariantAttributes.getName(FluidVariant.of(fluid)).getString();
		return new Object[] { parameter };
	}

	@Override
	public void writeNBT(class_2487 nbt) {
		if (fluid == null)
			return;
		class_2960 id = class_7923.field_41173.method_10221(fluid);
		if (id == null)
			return;
		nbt.method_10582("id", id.toString());
	}

	@Override
	public ItemAttribute readNBT(class_2487 nbt) {
		return nbt.method_10545("id") ? new FluidContentsAttribute(class_7923.field_41173.method_10223(class_2960.method_12829(nbt.method_10558("id")))) : EMPTY;
	}

	private List<class_3611> extractFluids(class_1799 stack) {
		List<class_3611> fluids = new ArrayList<>();

//        LazyOptional<IFluidHandlerItem> capability =
//                stack.getCapability(ForgeCapabilities.FLUID_HANDLER_ITEM);
//
//        capability.ifPresent((cap) -> {
//            for(int i = 0; i < cap.getTanks(); i++) {
//                fluids.add(cap.getFluidInTank(i).getFluid());
//            }
//        });

		return fluids;
	}
}
