package com.simibubi.create.content.logistics.filter.attribute.astralsorcery;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_1799;
import net.minecraft.class_1887;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2520;
import net.minecraft.class_2960;
import net.minecraft.class_7923;
import com.simibubi.create.content.logistics.filter.ItemAttribute;
import com.simibubi.create.foundation.utility.Components;

public class AstralSorceryAmuletAttribute implements ItemAttribute {
    String enchName;
    int enchType;

    public AstralSorceryAmuletAttribute(String enchName, int enchType) {
        this.enchName = enchName;
        this.enchType = enchType;
    }

    @Override
    public boolean appliesTo(class_1799 itemStack) {
        for (class_2520 trait : extractTraitList(itemStack)) {
            if(((class_2487) trait).method_10558("ench").equals(this.enchName)
                    && ((class_2487)trait).method_10550("type") == this.enchType)
                return true;
        }
        return false;
    }

    @Override
    public List<ItemAttribute> listAttributesOf(class_1799 itemStack) {
        class_2499 traits = extractTraitList(itemStack);
        List<ItemAttribute> atts = new ArrayList<>();
        for (int i = 0; i < traits.size(); i++) {
            atts.add(new AstralSorceryAmuletAttribute(
                    traits.method_10602(i).method_10558("ench"),
                    traits.method_10602(i).method_10550("type")));
        }
        return atts;
    }

    @Override
    public String getTranslationKey() {
        return "astralsorcery_amulet";
    }

    @Override
    public Object[] getTranslationParameters() {
        String something = "";

        class_1887 enchant = class_7923.field_41176.method_10223(class_2960.method_12829(enchName));
        if(enchant != null) {
            something = Components.translatable(enchant.method_8184()).getString();
        }

        if(enchType == 1) something = "existing " + something;

        return new Object[] { something };
    }

    @Override
    public void writeNBT(class_2487 nbt) {
        nbt.method_10582("enchName", this.enchName);
        nbt.method_10569("enchType", this.enchType);
    }

    @Override
    public ItemAttribute readNBT(class_2487 nbt) {
        return new AstralSorceryAmuletAttribute(nbt.method_10558("enchName"), nbt.method_10550("enchType"));
    }

    private class_2499 extractTraitList(class_1799 stack) {
        return stack.method_7969() != null ? stack.method_7969().method_10562("astralsorcery").method_10554("amuletEnchantments", 10) : new class_2499();
    }
}
