package com.simibubi.create.content.logistics.filter.attribute.astralsorcery;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_1799;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import net.minecraft.class_7923;
import com.simibubi.create.content.logistics.filter.ItemAttribute;
import com.simibubi.create.foundation.utility.Components;

public class AstralSorceryAttunementAttribute implements ItemAttribute {
    String constellationName;

    public AstralSorceryAttunementAttribute(String constellationName) {
        this.constellationName = constellationName;
    }

    @Override
    public boolean appliesTo(class_1799 itemStack) {
        class_2487 nbt = extractAstralNBT(itemStack);
        String constellation = nbt.method_10545("constellation") ? nbt.method_10558("constellation") : nbt.method_10558("constellationName");

        // Special handling for shifting stars
        class_2960 itemResource = class_7923.field_41178.method_10221(itemStack.method_7909());
        if (itemResource.toString().contains("shifting_star_")) {
            constellation = itemResource.toString().replace("shifting_star_", "");
        }

        return constellation.equals(constellationName);
    }

    @Override
    public List<ItemAttribute> listAttributesOf(class_1799 itemStack) {
        class_2487 nbt = extractAstralNBT(itemStack);
        String constellation = nbt.method_10545("constellation") ? nbt.method_10558("constellation") : nbt.method_10558("constellationName");

        // Special handling for shifting stars
        class_2960 itemResource = class_7923.field_41178.method_10221(itemStack.method_7909());
        if (itemResource.toString().contains("shifting_star_")) {
            constellation = itemResource.toString().replace("shifting_star_", "");
        }

        List<ItemAttribute> atts = new ArrayList<>();
        if(constellation.length() > 0) {
            atts.add(new AstralSorceryAttunementAttribute(constellation));
        }
        return atts;
    }

    @Override
    public String getTranslationKey() {
        return "astralsorcery_constellation";
    }

    @Override
    public Object[] getTranslationParameters() {
        class_2960 constResource = new class_2960(constellationName);
        String something = Components.translatable(String.format("%s.constellation.%s", constResource.method_12836(), constResource.method_12832())).getString();
        return new Object[] { something };
    }

    @Override
    public void writeNBT(class_2487 nbt) {
        nbt.method_10582("constellation", this.constellationName);
    }

    @Override
    public ItemAttribute readNBT(class_2487 nbt) {
        return new AstralSorceryAttunementAttribute(nbt.method_10558("constellation"));
    }

    private class_2487 extractAstralNBT(class_1799 stack) {
        return stack.method_7969() != null ? stack.method_7969().method_10562("astralsorcery") : new class_2487();
    }
}
