package com.simibubi.create.content.logistics.filter.attribute.astralsorcery;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_1799;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2520;
import net.minecraft.class_2960;
import com.simibubi.create.content.logistics.filter.ItemAttribute;
import com.simibubi.create.foundation.utility.Components;

public class AstralSorceryCrystalAttribute implements ItemAttribute {
    String traitName;

    public AstralSorceryCrystalAttribute(String traitName) {
        this.traitName = traitName;
    }

    @Override
    public boolean appliesTo(class_1799 itemStack) {
        for (class_2520 trait : extractTraitList(itemStack)) {
            if(((class_2487) trait).method_10558("property").equals(this.traitName))
                return true;
        }
        return false;
    }

    @Override
    public List<ItemAttribute> listAttributesOf(class_1799 itemStack) {
        class_2499 traits = extractTraitList(itemStack);
        List<ItemAttribute> atts = new ArrayList<>();
        for (int i = 0; i < traits.size(); i++) {
            atts.add(new AstralSorceryCrystalAttribute(traits.method_10602(i).method_10558("property")));
        }
        return atts;
    }

    @Override
    public String getTranslationKey() {
        return "astralsorcery_crystal";
    }

    @Override
    public Object[] getTranslationParameters() {
        class_2960 traitResource = new class_2960(traitName);
        String something = Components.translatable(String.format("crystal.property.%s.%s.name", traitResource.method_12836(), traitResource.method_12832())).getString();
        return new Object[] { something };
    }

    @Override
    public void writeNBT(class_2487 nbt) {
        nbt.method_10582("property", this.traitName);
    }

    @Override
    public ItemAttribute readNBT(class_2487 nbt) {
        return new AstralSorceryCrystalAttribute(nbt.method_10558("property"));
    }

    private class_2499 extractTraitList(class_1799 stack) {
        return stack.method_7969() != null ? stack.method_7969().method_10562("astralsorcery").method_10562("crystalProperties").method_10554("attributes", 10) : new class_2499();
    }
}
