package com.simibubi.create.content.logistics.funnel;

import java.util.function.Consumer;

import javax.annotation.Nullable;
import net.minecraft.class_10;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_3218;
import net.minecraft.class_3610;
import net.minecraft.class_4538;
import net.minecraft.class_5819;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.content.equipment.wrench.IWrenchable;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.block.ProperWaterloggedBlock;
import com.simibubi.create.foundation.block.render.ReducedDestroyEffects;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.filtering.FilteringBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.inventory.InvManipulationBehaviour;

public abstract class AbstractFunnelBlock extends class_2248
	implements IBE<FunnelBlockEntity>, IWrenchable, ProperWaterloggedBlock, ReducedDestroyEffects {

	public static final class_2746 POWERED = class_2741.field_12484;

	protected AbstractFunnelBlock(class_2251 p_i48377_1_) {
		super(p_i48377_1_);
		method_9590(method_9564().method_11657(POWERED, false)
			.method_11657(WATERLOGGED, false));
	}

//	@Environment(EnvType.CLIENT)
//	public void initializeClient(Consumer<IClientBlockExtensions> consumer) {
//		consumer.accept(new ReducedDestroyEffects());
//	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		return withWater(method_9564().method_11657(POWERED, context.method_8045()
			.method_49803(context.method_8037())), context);
	}

	@Override
	public class_3610 method_9545(class_2680 pState) {
		return fluidState(pState);
	}

	@Override
	public class_2680 method_9559(class_2680 pState, class_2350 pDirection, class_2680 pNeighborState,
		class_1936 pLevel, class_2338 pCurrentPos, class_2338 pNeighborPos) {
		updateWater(pLevel, pState, pCurrentPos);
		return pState;
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder.method_11667(POWERED, WATERLOGGED));
	}

	@Override
	public void method_9612(class_2680 state, class_1937 worldIn, class_2338 pos, class_2248 blockIn, class_2338 fromPos,
		boolean isMoving) {
		if (worldIn.field_9236)
			return;
		InvManipulationBehaviour behaviour = BlockEntityBehaviour.get(worldIn, pos, InvManipulationBehaviour.TYPE);
		if (behaviour != null)
			behaviour.onNeighborChanged(fromPos);
		if (!worldIn.method_8397()
			.method_8677(pos, this))
			worldIn.method_39279(pos, this, 0);
	}

	@Override
	public void method_9588(class_2680 state, class_3218 worldIn, class_2338 pos, class_5819 r) {
		boolean previouslyPowered = state.method_11654(POWERED);
		if (previouslyPowered != worldIn.method_49803(pos))
			worldIn.method_8652(pos, state.method_28493(POWERED), 2);
	}

	public static class_1799 tryInsert(class_1937 worldIn, class_2338 pos, class_1799 toInsert, boolean simulate) {
		FilteringBehaviour filter = BlockEntityBehaviour.get(worldIn, pos, FilteringBehaviour.TYPE);
		InvManipulationBehaviour inserter = BlockEntityBehaviour.get(worldIn, pos, InvManipulationBehaviour.TYPE);
		if (inserter == null)
			return toInsert;
		if (filter != null && !filter.test(toInsert))
			return toInsert;
		if (simulate)
			inserter.simulate();
		class_1799 insert = inserter.insert(toInsert);

		if (!simulate && insert.method_7947() != toInsert.method_7947()) {
			class_2586 blockEntity = worldIn.method_8321(pos);
			if (blockEntity instanceof FunnelBlockEntity) {
				FunnelBlockEntity funnelBlockEntity = (FunnelBlockEntity) blockEntity;
				funnelBlockEntity.onTransfer(toInsert);
				if (funnelBlockEntity.hasFlap())
					funnelBlockEntity.flap(true);
			}
		}
		return insert;
	}

	@Override
	public boolean method_9558(class_2680 state, class_4538 world, class_2338 pos) {
		class_2248 block = world.method_8320(pos.method_10093(getFunnelFacing(state).method_10153()))
			.method_26204();
		return !(block instanceof AbstractFunnelBlock);
	}

	@Nullable
	public static boolean isFunnel(class_2680 state) {
		return state.method_26204() instanceof AbstractFunnelBlock;
	}

	@Nullable
	public static class_2350 getFunnelFacing(class_2680 state) {
		if (!(state.method_26204() instanceof AbstractFunnelBlock))
			return null;
		return ((AbstractFunnelBlock) state.method_26204()).getFacing(state);
	}

	protected abstract class_2350 getFacing(class_2680 state);

	@Override
	public void method_9536(class_2680 state, class_1937 world, class_2338 pos, class_2680 newState, boolean isMoving) {
		if (state.method_26204() != newState.method_26204() && !isFunnel(newState) || !newState.method_31709())
			IBE.onRemove(state, world, pos, newState);
	}

	@Override
	public Class<FunnelBlockEntity> getBlockEntityClass() {
		return FunnelBlockEntity.class;
	}

	public class_2591<? extends FunnelBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.FUNNEL.get();
	};

}
