package com.simibubi.create.content.logistics.funnel;

import com.simibubi.create.Create;
import com.simibubi.create.content.logistics.funnel.BeltFunnelBlock.Shape;
import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import net.minecraft.class_2248;
import net.minecraft.class_2680;
import net.minecraft.class_2741;
import net.minecraft.class_2960;

public class BeltFunnelGenerator extends SpecialBlockStateGen {

	private String type;
	private class_2960 materialBlockTexture;

	public BeltFunnelGenerator(String type) {
		this.type = type;
		this.materialBlockTexture = Create.asResource("block/" + type + "_block");
	}

	@Override
	protected int getXRotation(class_2680 state) {
		return 0;
	}

	@Override
	protected int getYRotation(class_2680 state) {
		return horizontalAngle(state.method_11654(BeltFunnelBlock.HORIZONTAL_FACING)) + 180;
	}

	@Override
	public <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> ctx, RegistrateBlockstateProvider prov,
												class_2680 state) {
		String prefix = "block/funnel/";
		Shape shape = state.method_11654(BeltFunnelBlock.SHAPE);
		String shapeName = shape.method_15434();
		boolean powered = state.method_28500(class_2741.field_12484)
			.orElse(false);
		String poweredSuffix = powered ? "_powered" : "_unpowered";
		String shapeSuffix = shape == Shape.PULLING ? "_pull" : shape == Shape.PUSHING ? "_push" : "_neutral";
		String name = ctx.getName() + "_" + shapeName + poweredSuffix;

		return prov.models()
			.withExistingParent(name, prov.modLoc("block/belt_funnel/block_" + shapeName))
			.texture("particle", materialBlockTexture)
			.texture("block", materialBlockTexture)
			.texture("direction", prov.modLoc(prefix + type + "_funnel" + shapeSuffix))
			.texture("redstone", prov.modLoc(prefix + type + "_funnel" + poweredSuffix))
			.texture("base", prov.modLoc(prefix + type + "_funnel"));
	}

}
