package com.simibubi.create.content.logistics.funnel;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllShapes;
import com.simibubi.create.foundation.advancement.AdvancementBehaviour;
import com.simibubi.create.foundation.block.ProperWaterloggedBlock;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1542;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_243;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2746;
import net.minecraft.class_3726;
import net.minecraft.class_3727;
import net.minecraft.class_3965;

public abstract class FunnelBlock extends AbstractDirectionalFunnelBlock {

	public static final class_2746 EXTRACTING = class_2746.method_11825("extracting");

	public FunnelBlock(class_2251 p_i48415_1_) {
		super(p_i48415_1_);
		method_9590(method_9564().method_11657(EXTRACTING, false));
	}

	public abstract class_2680 getEquivalentBeltFunnel(class_1922 world, class_2338 pos, class_2680 state);

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2680 state = super.method_9605(context);

		boolean sneak = context.method_8036() != null && context.method_8036()
			.method_5715();
		state = state.method_11657(EXTRACTING, !sneak);

		for (class_2350 direction : context.method_7718()) {
			class_2680 blockstate = state.method_11657(FACING, direction.method_10153());
			if (blockstate.method_26184(context.method_8045(), context.method_8037()))
				return blockstate.method_11657(POWERED, state.method_11654(POWERED));
		}

		return state;
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder.method_11667(EXTRACTING));
	}

	@Override
	public void method_9536(class_2680 state, class_1937 world, class_2338 pos, class_2680 newState, boolean isMoving) {
		if (newState.method_26204() instanceof BeltFunnelBlock bfb && bfb.isOfSameType(this))
			return;
		super.method_9536(state, world, pos, newState, isMoving);
	}

	@Override
	public void method_9567(class_1937 pLevel, class_2338 pPos, class_2680 pState, class_1309 pPlacer, class_1799 pStack) {
		super.method_9567(pLevel, pPos, pState, pPlacer, pStack);
		AdvancementBehaviour.setPlacedBy(pLevel, pPos, pPlacer);
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 worldIn, class_2338 pos, class_1657 player, class_1268 handIn,
		class_3965 hit) {
		if (AdventureUtil.isAdventure(player))
			return class_1269.field_5811;

		class_1799 heldItem = player.method_5998(handIn);
		boolean shouldntInsertItem = heldItem.method_7960() || AllBlocks.MECHANICAL_ARM.isIn(heldItem) || !canInsertIntoFunnel(state);

		if (AllItems.WRENCH.isIn(heldItem))
			return class_1269.field_5811;

		if (hit.method_17780() == getFunnelFacing(state) && !shouldntInsertItem) {
			if (!worldIn.field_9236)
				withBlockEntityDo(worldIn, pos, be -> {
					class_1799 toInsert = heldItem.method_7972();
					class_1799 remainder = tryInsert(worldIn, pos, toInsert, false);
					if (!class_1799.method_7973(remainder, toInsert))
						player.method_6122(handIn, remainder);
				});
			return class_1269.field_5812;
		}

		return class_1269.field_5811;
	}

	@Override
	public class_1269 onWrenched(class_2680 state, class_1838 context) {
		class_1937 world = context.method_8045();
		if (!world.field_9236)
			world.method_8501(context.method_8037(), state.method_28493(EXTRACTING));
		return class_1269.field_5812;
	}

	@Override
	public void method_9548(class_2680 state, class_1937 worldIn, class_2338 pos, class_1297 entityIn) {
		if (worldIn.field_9236)
			return;
		if (!(entityIn instanceof class_1542))
			return;
		if (!canInsertIntoFunnel(state))
			return;
		if (!entityIn.method_5805())
			return;
		class_1542 itemEntity = (class_1542) entityIn;

		class_2350 direction = getFunnelFacing(state);
		class_243 diff = entityIn.method_19538()
			.method_1020(VecHelper.getCenterOf(pos)
				.method_1019(class_243.method_24954(direction.method_10163())
					.method_1021(-.325f)));
		double projectedDiff = direction.method_10166()
			.method_10172(diff.field_1352, diff.field_1351, diff.field_1350);
		if (projectedDiff < 0 == (direction.method_10171() == class_2352.field_11056))
			return;

		class_1799 toInsert = itemEntity.method_6983();
		class_1799 remainder = tryInsert(worldIn, pos, toInsert, false);

		if (remainder.method_7960())
			itemEntity.method_31472();
		if (remainder.method_7947() < toInsert.method_7947())
			itemEntity.method_6979(remainder);
	}

	protected boolean canInsertIntoFunnel(class_2680 state) {
		return !state.method_11654(POWERED) && !state.method_11654(EXTRACTING);
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 world, class_2338 pos, class_3726 context) {
		class_2350 facing = state.method_11654(FACING);
		return facing == class_2350.field_11033 ? AllShapes.FUNNEL_CEILING
			: facing == class_2350.field_11036 ? AllShapes.FUNNEL_FLOOR : AllShapes.FUNNEL_WALL.get(facing);
	}

	@Override
	public class_265 method_9549(class_2680 state, class_1922 world, class_2338 pos, class_3726 context) {
		if (context instanceof class_3727
			&& ((class_3727) context).method_32480() instanceof class_1542 && getFacing(state).method_10166()
				.method_10179())
			return AllShapes.FUNNEL_COLLISION.get(getFacing(state));
		return method_9530(state, world, pos, context);
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 direction, class_2680 p_196271_3_, class_1936 world,
		class_2338 pos, class_2338 p_196271_6_) {
		updateWater(world, state, pos);
		if (getFacing(state).method_10166()
			.method_10178() || direction != class_2350.field_11033)
			return state;
		class_2680 equivalentFunnel =
			ProperWaterloggedBlock.withWater(world, getEquivalentBeltFunnel(null, null, state), pos);
		if (BeltFunnelBlock.isOnValidBelt(equivalentFunnel, world, pos))
			return equivalentFunnel.method_11657(BeltFunnelBlock.SHAPE,
				BeltFunnelBlock.getShapeForPosition(world, pos, getFacing(state), state.method_11654(EXTRACTING)));
		return state;
	}

}
