package com.simibubi.create.content.logistics.funnel;

import com.simibubi.create.Create;
import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;
import com.tterrag.registrate.providers.RegistrateItemModelProvider;
import com.tterrag.registrate.util.nullness.NonNullBiConsumer;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import io.github.fabricators_of_create.porting_lib.models.generators.block.BlockModelBuilder;
import net.minecraft.class_1792;
import net.minecraft.class_2248;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_2960;

public class FunnelGenerator extends SpecialBlockStateGen {

	private String type;
	private class_2960 blockTexture;
	private boolean hasFilter;

	public FunnelGenerator(String type, boolean hasFilter) {
		this.type = type;
		this.hasFilter = hasFilter;
		this.blockTexture = Create.asResource("block/" + type + "_block");
	}

	@Override
	protected int getXRotation(class_2680 state) {
		return state.method_11654(FunnelBlock.FACING) == class_2350.field_11033 ? 180 : 0;
	}

	@Override
	protected int getYRotation(class_2680 state) {
		return horizontalAngle(state.method_11654(FunnelBlock.FACING)) + 180;
	}

	@Override
	public <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> c, RegistrateBlockstateProvider p,
												class_2680 s) {
		String prefix = "block/funnel/";
		String powered = s.method_11654(FunnelBlock.POWERED) ? "_powered" : "_unpowered";
		String closed = s.method_11654(FunnelBlock.POWERED) ? "_closed" : "_open";
		String extracting = s.method_11654(FunnelBlock.EXTRACTING) ? "_push" : "_pull";
		class_2350 facing = s.method_11654(FunnelBlock.FACING);
		boolean horizontal = facing.method_10166()
			.method_10179();
		String parent = horizontal ? "horizontal" : hasFilter ? "vertical" : "vertical_filterless";

		BlockModelBuilder model = p.models()
			.withExistingParent("block/" + type + "_funnel_" + parent + extracting + powered,
				p.modLoc(prefix + "block_" + parent))
			.texture("particle", blockTexture)
			.texture("base", p.modLoc(prefix + type + "_funnel"))
			.texture("redstone", p.modLoc(prefix + type + "_funnel" + powered))
			.texture("direction", p.modLoc(prefix + type + "_funnel" + extracting));

		if (horizontal)
			return model.texture("block", blockTexture);

		return model.texture("frame", p.modLoc(prefix + type + "_funnel_frame"))
			.texture("open", p.modLoc(prefix + "funnel" + closed));
	}

	public static NonNullBiConsumer<DataGenContext<class_1792, FunnelItem>, RegistrateItemModelProvider> itemModel(
		String type) {
		String prefix = "block/funnel/";
		class_2960 blockTexture = Create.asResource("block/" + type + "_block");
		return (c, p) -> {
			p.withExistingParent("item/" + type + "_funnel", p.modLoc("block/funnel/item"))
				.texture("particle", blockTexture)
				.texture("block", blockTexture)
				.texture("base", p.modLoc(prefix + type + "_funnel"))
				.texture("direction", p.modLoc(prefix + type + "_funnel_neutral"))
				.texture("redstone", p.modLoc(prefix + type + "_funnel_unpowered"));
		};
	}

}
