package com.simibubi.create.content.logistics.funnel;

import java.util.List;

import com.simibubi.create.content.contraptions.behaviour.MovementBehaviour;
import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import com.simibubi.create.content.logistics.filter.FilterItemStack;
import com.simibubi.create.foundation.item.ItemHelper;

import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_1542;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_3417;
import net.minecraft.class_3419;

public class FunnelMovementBehaviour implements MovementBehaviour {

	private final boolean hasFilter;

	public static FunnelMovementBehaviour andesite() {
		return new FunnelMovementBehaviour(false);
	}

	public static FunnelMovementBehaviour brass() {
		return new FunnelMovementBehaviour(true);
	}

	private FunnelMovementBehaviour(boolean hasFilter) {
		this.hasFilter = hasFilter;
	}

	@Override
	public class_243 getActiveAreaOffset(MovementContext context) {
		class_2350 facing = FunnelBlock.getFunnelFacing(context.state);
		class_243 vec = class_243.method_24954(facing.method_10163());
		if (facing != class_2350.field_11036)
			return vec.method_1021(context.state.method_11654(FunnelBlock.EXTRACTING) ? .15 : .65);

		return vec.method_1021(.65);
	}

	@Override
	public void visitNewPosition(MovementContext context, class_2338 pos) {
		MovementBehaviour.super.visitNewPosition(context, pos);

		if (context.state.method_11654(FunnelBlock.EXTRACTING))
			extract(context, pos);
		else
			succ(context, pos);

	}

	private void extract(MovementContext context, class_2338 pos) {
		class_1937 world = context.world;

		class_243 entityPos = context.position;
		if (context.state.method_11654(FunnelBlock.FACING) != class_2350.field_11033)
			entityPos = entityPos.method_1031(0, -.5f, 0);

		if (!world.method_8320(pos)
			.method_26220(world, pos)
			.method_1110())
			return;

		if (!world.method_18467(class_1542.class, new class_238(class_2338.method_49638(entityPos)))
			.isEmpty())
			return;

		FilterItemStack filter = context.getFilterFromBE();
		int filterAmount = context.blockEntityData.method_10550("FilterAmount");
		boolean upTo = context.blockEntityData.method_10577("UpTo");
		if (filterAmount <= 0)
			filterAmount = hasFilter ? 64 : 1;

		class_1799 extract = ItemHelper.extract(context.contraption.getSharedInventory(),
			s -> filter.test(world, s),
			upTo ? ItemHelper.ExtractionCountMode.UPTO : ItemHelper.ExtractionCountMode.EXACTLY, filterAmount, false);

		if (extract.method_7960())
			return;

		if (world.field_9236)
			return;

		class_1542 entity = new class_1542(world, entityPos.field_1352, entityPos.field_1351, entityPos.field_1350, extract);
		entity.method_18799(class_243.field_1353);
		entity.method_6982(5);
		world.method_8396(null, pos, class_3417.field_15197, class_3419.field_15245, 1 / 16f, .1f);
		world.method_8649(entity);
	}

	private void succ(MovementContext context, class_2338 pos) {
		class_1937 world = context.world;
		List<class_1542> items = world.method_18467(class_1542.class, new class_238(pos));
		FilterItemStack filter = context.getFilterFromBE();

		try (Transaction t = TransferUtil.getTransaction()) {
			for (class_1542 item : items) {
				if (!item.method_5805())
					continue;
				class_1799 toInsert = item.method_6983();
				if (toInsert.method_7960() || (!filter.test(context.world, toInsert)))
					continue;
				long inserted = TransferUtil.insertItem(context.contraption.getSharedInventory(), toInsert);
				if (inserted == 0)
					continue;
				if (inserted == toInsert.method_7947()) {
					item.method_6979(class_1799.field_8037);
					item.method_31472();
					continue;
				}
				class_1799 remainder = item.method_6983().method_7972();
				remainder.method_7934(ItemHelper.truncateLong(inserted));
				item.method_6979(remainder);
			}
			t.commit();
		}
	}

	@Override
	public boolean renderAsNormalBlockEntity() {
		return true;
	}

}
