package com.simibubi.create.content.logistics.tunnel;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_2350;
import net.minecraft.class_2540;
import org.apache.commons.lang3.tuple.Pair;

import com.simibubi.create.foundation.networking.BlockEntityDataPacket;

public class TunnelFlapPacket extends BlockEntityDataPacket<BeltTunnelBlockEntity> {

    private List<Pair<class_2350, Boolean>> flaps;

    public TunnelFlapPacket(class_2540 buffer) {
        super(buffer);

        byte size = buffer.readByte();

        this.flaps = new ArrayList<>(size);

        for (int i = 0; i < size; i++) {
            class_2350 direction = class_2350.method_10143(buffer.readByte());
            boolean inwards = buffer.readBoolean();

            flaps.add(Pair.of(direction, inwards));
        }
    }

    public TunnelFlapPacket(BeltTunnelBlockEntity blockEntity, List<Pair<class_2350, Boolean>> flaps) {
        super(blockEntity.method_11016());

        this.flaps = new ArrayList<>(flaps);
    }

    @Override
    protected void writeData(class_2540 buffer) {
        buffer.writeByte(flaps.size());

        for (Pair<class_2350, Boolean> flap : flaps) {
            buffer.writeByte(flap.getLeft().method_10146());
            buffer.writeBoolean(flap.getRight());
        }
    }

    @Override
    protected void handlePacket(BeltTunnelBlockEntity blockEntity) {
        for (Pair<class_2350, Boolean> flap : flaps) {
            blockEntity.flap(flap.getLeft(), flap.getRight());
        }
    }
}
