package com.simibubi.create.content.logistics.vault;

import java.util.function.Consumer;

import javax.annotation.Nullable;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.api.connectivity.ConnectivityHandler;
import com.simibubi.create.content.equipment.wrench.IWrenchable;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.item.ItemHelper;

import io.github.fabricators_of_create.porting_lib.block.CustomSoundTypeBlock;
import net.fabricmc.fabric.api.transfer.v1.transaction.Transaction;
import net.minecraft.class_1269;
import net.minecraft.class_1297;
import net.minecraft.class_1750;
import net.minecraft.class_1838;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_2415;
import net.minecraft.class_2470;
import net.minecraft.class_2498;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_2769;
import net.minecraft.class_3417;
import net.minecraft.class_4538;

public class ItemVaultBlock extends class_2248 implements IWrenchable, IBE<ItemVaultBlockEntity>, CustomSoundTypeBlock {

	public static final class_2769<class_2351> HORIZONTAL_AXIS = class_2741.field_12529;
	public static final class_2746 LARGE = class_2746.method_11825("large");

	public ItemVaultBlock(class_2251 p_i48440_1_) {
		super(p_i48440_1_);
		method_9590(method_9564().method_11657(LARGE, false));
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> pBuilder) {
		pBuilder.method_11667(HORIZONTAL_AXIS, LARGE);
		super.method_9515(pBuilder);
	}

	@Override
	public class_2680 method_9605(class_1750 pContext) {
		if (pContext.method_8036() == null || !pContext.method_8036()
			.method_5715()) {
			class_2680 placedOn = pContext.method_8045()
				.method_8320(pContext.method_8037()
					.method_10093(pContext.method_8038()
						.method_10153()));
			class_2351 preferredAxis = getVaultBlockAxis(placedOn);
			if (preferredAxis != null)
				return this.method_9564()
					.method_11657(HORIZONTAL_AXIS, preferredAxis);
		}
		return this.method_9564()
			.method_11657(HORIZONTAL_AXIS, pContext.method_8042()
				.method_10166());
	}

	@Override
	public void method_9615(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_2680 pOldState, boolean pIsMoving) {
		if (pOldState.method_26204() == pState.method_26204())
			return;
		if (pIsMoving)
			return;
		// fabric: see comment in FluidTankItem
		Consumer<ItemVaultBlockEntity> consumer = ItemVaultItem.IS_PLACING_NBT
				? ItemVaultBlockEntity::queueConnectivityUpdate
				: ItemVaultBlockEntity::updateConnectivity;
		withBlockEntityDo(pLevel, pPos, consumer);
	}

	@Override
	public class_1269 onWrenched(class_2680 state, class_1838 context) {
		if (context.method_8038()
			.method_10166()
			.method_10178()) {
			class_2586 be = context.method_8045()
				.method_8321(context.method_8037());
			if (be instanceof ItemVaultBlockEntity) {
				ItemVaultBlockEntity vault = (ItemVaultBlockEntity) be;
				ConnectivityHandler.splitMulti(vault);
				vault.removeController(true);
			}
			state = state.method_11657(LARGE, false);
		}
		class_1269 onWrenched = IWrenchable.super.onWrenched(state, context);
		return onWrenched;
	}

	@Override
	public void method_9536(class_2680 state, class_1937 world, class_2338 pos, class_2680 newState, boolean pIsMoving) {
		if (state.method_31709() && (state.method_26204() != newState.method_26204() || !newState.method_31709())) {
			class_2586 be = world.method_8321(pos);
			if (!(be instanceof ItemVaultBlockEntity))
				return;
			ItemVaultBlockEntity vaultBE = (ItemVaultBlockEntity) be;
			ItemHelper.dropContents(world, pos, vaultBE.inventory);
			world.method_8544(pos);
			ConnectivityHandler.splitMulti(vaultBE);
		}
	}

	public static boolean isVault(class_2680 state) {
		return AllBlocks.ITEM_VAULT.has(state);
	}

	@Nullable
	public static class_2351 getVaultBlockAxis(class_2680 state) {
		if (!isVault(state))
			return null;
		return state.method_11654(HORIZONTAL_AXIS);
	}

	public static boolean isLarge(class_2680 state) {
		if (!isVault(state))
			return false;
		return state.method_11654(LARGE);
	}

	@Override
	public class_2680 method_9598(class_2680 state, class_2470 rot) {
		class_2351 axis = state.method_11654(HORIZONTAL_AXIS);
		return state.method_11657(HORIZONTAL_AXIS, rot.method_10503(class_2350.method_10169(axis, class_2352.field_11056))
			.method_10166());
	}

	@Override
	public class_2680 method_9569(class_2680 state, class_2415 mirrorIn) {
		return state;
	}

	// Vaults are less noisy when placed in batch
	public static final class_2498 SILENCED_METAL =
		new class_2498(0.1F, 1.5F, class_3417.field_21919, class_3417.field_21920,
			class_3417.field_21921, class_3417.field_21922,
			class_3417.field_21923);

	@Override
	public class_2498 getSoundType(class_2680 state, class_4538 world, class_2338 pos, class_1297 entity) {
		class_2498 soundType = method_9573(state);
		if (entity != null && entity.getCustomData()
			.method_10545("SilenceVaultSound"))
			return SILENCED_METAL;
		return soundType;
	}

	@Override
	public boolean method_9498(class_2680 p_149740_1_) {
		return true;
	}

	@Override
	public int method_9572(class_2680 pState, class_1937 pLevel, class_2338 pPos) {
		return getBlockEntityOptional(pLevel, pPos)
			.filter(vte -> !Transaction.isOpen()) // fabric: hack fix for comparators updating when they shouldn't
			.map(vte -> vte.getItemStorage(null))
			.map(ItemHelper::calcRedstoneFromInventory)
			.orElse(0);
	}

	@Override
	public class_2591<? extends ItemVaultBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.ITEM_VAULT.get();
	}

	@Override
	public Class<ItemVaultBlockEntity> getBlockEntityClass() {
		return ItemVaultBlockEntity.class;
	}
}
