package com.simibubi.create.content.logistics.vault;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllSpriteShifts;
import com.simibubi.create.api.connectivity.ConnectivityHandler;
import com.simibubi.create.foundation.block.connected.CTSpriteShiftEntry;
import com.simibubi.create.foundation.block.connected.ConnectedTextureBehaviour;
import net.minecraft.class_1058;
import net.minecraft.class_1920;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_2680;

public class ItemVaultCTBehaviour extends ConnectedTextureBehaviour.Base {

	@Override
	public CTSpriteShiftEntry getShift(class_2680 state, class_2350 direction, @Nullable class_1058 sprite) {
		class_2351 vaultBlockAxis = ItemVaultBlock.getVaultBlockAxis(state);
		boolean small = !ItemVaultBlock.isLarge(state);
		if (vaultBlockAxis == null)
			return null;

		if (direction.method_10166() == vaultBlockAxis)
			return AllSpriteShifts.VAULT_FRONT.get(small);
		if (direction == class_2350.field_11036)
			return AllSpriteShifts.VAULT_TOP.get(small);
		if (direction == class_2350.field_11033)
			return AllSpriteShifts.VAULT_BOTTOM.get(small);

		return AllSpriteShifts.VAULT_SIDE.get(small);
	}

	@Override
	protected class_2350 getUpDirection(class_1920 reader, class_2338 pos, class_2680 state, class_2350 face) {
		class_2351 vaultBlockAxis = ItemVaultBlock.getVaultBlockAxis(state);
		boolean alongX = vaultBlockAxis == class_2351.field_11048;
		if (face.method_10166()
			.method_10178() && alongX)
			return super.getUpDirection(reader, pos, state, face).method_10170();
		if (face.method_10166() == vaultBlockAxis || face.method_10166()
			.method_10178())
			return super.getUpDirection(reader, pos, state, face);
		return class_2350.method_10169(vaultBlockAxis, alongX ? class_2352.field_11056 : class_2352.field_11060);
	}

	@Override
	protected class_2350 getRightDirection(class_1920 reader, class_2338 pos, class_2680 state, class_2350 face) {
		class_2351 vaultBlockAxis = ItemVaultBlock.getVaultBlockAxis(state);
		if (face.method_10166()
			.method_10178() && vaultBlockAxis == class_2351.field_11048)
			return super.getRightDirection(reader, pos, state, face).method_10170();
		if (face.method_10166() == vaultBlockAxis || face.method_10166()
			.method_10178())
			return super.getRightDirection(reader, pos, state, face);
		return class_2350.method_10169(class_2351.field_11052, face.method_10171());
	}

	public boolean buildContextForOccludedDirections() {
		return super.buildContextForOccludedDirections();
	}

	@Override
	public boolean connectsTo(class_2680 state, class_2680 other, class_1920 reader, class_2338 pos,
		class_2338 otherPos, class_2350 face) {
		return state == other && ConnectivityHandler.isConnected(reader, pos, otherPos); //ItemVaultConnectivityHandler.isConnected(reader, pos, otherPos);
	}

}
