package com.simibubi.create.content.logistics.vault;

import org.jetbrains.annotations.ApiStatus.Internal;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.api.connectivity.ConnectivityHandler;
import com.simibubi.create.content.fluids.tank.FluidTankItem;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_2487;
import net.minecraft.class_2680;
import net.minecraft.server.MinecraftServer;

public class ItemVaultItem extends class_1747 {
	// fabric: see comment in FluidTankItem
	@Internal
	public static boolean IS_PLACING_NBT = false;

	public ItemVaultItem(class_2248 p_i48527_1_, class_1793 p_i48527_2_) {
		super(p_i48527_1_, p_i48527_2_);
	}

	@Override
	public class_1269 method_7712(class_1750 ctx) {
		IS_PLACING_NBT = FluidTankItem.checkPlacingNbt(ctx);
		class_1269 initialResult = super.method_7712(ctx);
		IS_PLACING_NBT = false;
		if (!initialResult.method_23665())
			return initialResult;
		tryMultiPlace(ctx);
		return initialResult;
	}

	@Override
	protected boolean method_7710(class_2338 p_195943_1_, class_1937 p_195943_2_, class_1657 p_195943_3_,
		class_1799 p_195943_4_, class_2680 p_195943_5_) {
		MinecraftServer minecraftserver = p_195943_2_.method_8503();
		if (minecraftserver == null)
			return false;
		class_2487 nbt = p_195943_4_.method_7941("BlockEntityTag");
		if (nbt != null) {
			nbt.method_10551("Length");
			nbt.method_10551("Size");
			nbt.method_10551("Controller");
			nbt.method_10551("LastKnownPos");
		}
		return super.method_7710(p_195943_1_, p_195943_2_, p_195943_3_, p_195943_4_, p_195943_5_);
	}

	private void tryMultiPlace(class_1750 ctx) {
		class_1657 player = ctx.method_8036();
		if (player == null)
			return;
		if (player.method_5715())
			return;
		class_2350 face = ctx.method_8038();
		class_1799 stack = ctx.method_8041();
		class_1937 world = ctx.method_8045();
		class_2338 pos = ctx.method_8037();
		class_2338 placedOnPos = pos.method_10093(face.method_10153());
		class_2680 placedOnState = world.method_8320(placedOnPos);

		if (!ItemVaultBlock.isVault(placedOnState))
			return;
		ItemVaultBlockEntity tankAt = ConnectivityHandler.partAt(AllBlockEntityTypes.ITEM_VAULT.get(), world, placedOnPos);
		if (tankAt == null)
			return;
		ItemVaultBlockEntity controllerBE = tankAt.getControllerBE();
		if (controllerBE == null)
			return;

		int width = controllerBE.radius;
		if (width == 1)
			return;

		int tanksToPlace = 0;
		class_2351 vaultBlockAxis = ItemVaultBlock.getVaultBlockAxis(placedOnState);
		if (vaultBlockAxis == null)
			return;
		if (face.method_10166() != vaultBlockAxis)
			return;

		class_2350 vaultFacing = class_2350.method_10169(vaultBlockAxis, class_2352.field_11056);
		class_2338 startPos = face == vaultFacing.method_10153() ? controllerBE.method_11016()
			.method_10093(vaultFacing.method_10153())
			: controllerBE.method_11016()
				.method_10079(vaultFacing, controllerBE.length);

		if (VecHelper.getCoordinate(startPos, vaultBlockAxis) != VecHelper.getCoordinate(pos, vaultBlockAxis))
			return;

		for (int xOffset = 0; xOffset < width; xOffset++) {
			for (int zOffset = 0; zOffset < width; zOffset++) {
				class_2338 offsetPos = vaultBlockAxis == class_2351.field_11048 ? startPos.method_10069(0, xOffset, zOffset)
					: startPos.method_10069(xOffset, zOffset, 0);
				class_2680 blockState = world.method_8320(offsetPos);
				if (ItemVaultBlock.isVault(blockState))
					continue;
				if (!blockState.method_45474())
					return;
				tanksToPlace++;
			}
		}

		if (!player.method_7337() && stack.method_7947() < tanksToPlace)
			return;

		for (int xOffset = 0; xOffset < width; xOffset++) {
			for (int zOffset = 0; zOffset < width; zOffset++) {
				class_2338 offsetPos = vaultBlockAxis == class_2351.field_11048 ? startPos.method_10069(0, xOffset, zOffset)
					: startPos.method_10069(xOffset, zOffset, 0);
				class_2680 blockState = world.method_8320(offsetPos);
				if (ItemVaultBlock.isVault(blockState))
					continue;
				class_1750 context = class_1750.method_16355(ctx, offsetPos, face);
				player.getCustomData()
					.method_10556("SilenceVaultSound", true);
				IS_PLACING_NBT = FluidTankItem.checkPlacingNbt(context);
				super.method_7712(context);
				IS_PLACING_NBT = false;
				player.getCustomData()
					.method_10551("SilenceVaultSound");
			}
		}
	}

}
