package com.simibubi.create.content.processing.burner;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Optional;

import javax.annotation.ParametersAreNonnullByDefault;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1917;
import net.minecraft.class_1937;
import net.minecraft.class_1952;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2398;
import net.minecraft.class_243;
import net.minecraft.class_2586;
import net.minecraft.class_2636;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_6008.class_6010;
import net.minecraft.class_6328;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllTags.AllEntityTags;
import com.simibubi.create.foundation.utility.RegisteredObjects;
import com.simibubi.create.foundation.utility.VecHelper;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.common.accessor.BaseSpawnerAccessor;

@class_6328
@ParametersAreNonnullByDefault
public class BlazeBurnerBlockItem extends class_1747 {

	private final boolean capturedBlaze;

	public static BlazeBurnerBlockItem empty(class_1793 properties) {
		return new BlazeBurnerBlockItem(AllBlocks.BLAZE_BURNER.get(), properties, false);
	}

	public static BlazeBurnerBlockItem withBlaze(class_2248 block, class_1793 properties) {
		return new BlazeBurnerBlockItem(block, properties, true);
	}

	@Override
	public void method_7713(Map<class_2248, class_1792> p_195946_1_, class_1792 p_195946_2_) {
		if (!hasCapturedBlaze())
			return;
		super.method_7713(p_195946_1_, p_195946_2_);
	}

	private BlazeBurnerBlockItem(class_2248 block, class_1793 properties, boolean capturedBlaze) {
		super(block, properties);
		this.capturedBlaze = capturedBlaze;
	}

	@Override
	public String method_7876() {
		return hasCapturedBlaze() ? super.method_7876() : "item.create." + RegisteredObjects.getKeyOrThrow(this).method_12832();
	}

	@Override
	public class_1269 method_7884(class_1838 context) {
		if (hasCapturedBlaze())
			return super.method_7884(context);

		class_1937 world = context.method_8045();
		class_2338 pos = context.method_8037();
		class_2586 be = world.method_8321(pos);
		class_1657 player = context.method_8036();

		if (!(be instanceof class_2636))
			return super.method_7884(context);

		class_1917 spawner = ((class_2636) be).method_11390();

		List<class_1952> possibleSpawns = ((BaseSpawnerAccessor) spawner).port_lib$getSpawnPotentials().method_34994()
			.stream()
			.map(class_6010::method_34983)
			.toList();

		if (possibleSpawns.isEmpty()) {
			possibleSpawns = new ArrayList<>();
			possibleSpawns.add(((BaseSpawnerAccessor) spawner).port_lib$getNextSpawnData());
		}

		for (class_1952 e : possibleSpawns) {
			Optional<class_1299<?>> optionalEntity = class_1299.method_17684(e.comp_64());
			if (optionalEntity.isEmpty() || !AllEntityTags.BLAZE_BURNER_CAPTURABLE.matches(optionalEntity.get()))
				continue;

			spawnCaptureEffects(world, VecHelper.getCenterOf(pos));
			if (world.field_9236 || player == null)
				return class_1269.field_5812;

			giveBurnerItemTo(player, context.method_8041(), context.method_20287());
			return class_1269.field_5812;
		}

		return super.method_7884(context);
	}

	@Override
	public class_1269 method_7847(class_1799 heldItem, class_1657 player, class_1309 entity,
		class_1268 hand) {
		if (hasCapturedBlaze())
			return class_1269.field_5811;
		if (!AllEntityTags.BLAZE_BURNER_CAPTURABLE.matches(entity))
			return class_1269.field_5811;

		class_1937 world = player.method_37908();
		spawnCaptureEffects(world, entity.method_19538());
		if (world.field_9236)
			return class_1269.field_5814;

		giveBurnerItemTo(player, heldItem, hand);
		entity.method_31472();
		return class_1269.field_5814;
	}

	protected void giveBurnerItemTo(class_1657 player, class_1799 heldItem, class_1268 hand) {
		class_1799 filled = AllBlocks.BLAZE_BURNER.asStack();
		if (!player.method_7337())
			heldItem.method_7934(1);
		if (heldItem.method_7960()) {
			player.method_6122(hand, filled);
			return;
		}
		player.method_31548()
			.method_7398(filled);
	}

	private void spawnCaptureEffects(class_1937 world, class_243 vec) {
		if (world.field_9236) {
			for (int i = 0; i < 40; i++) {
				class_243 motion = VecHelper.offsetRandomly(class_243.field_1353, world.field_9229, .125f);
				world.method_8406(class_2398.field_11240, vec.field_1352, vec.field_1351, vec.field_1350, motion.field_1352, motion.field_1351, motion.field_1350);
				class_243 circle = motion.method_18805(1, 0, 1)
					.method_1029()
					.method_1021(.5f);
				world.method_8406(class_2398.field_11251, circle.field_1352, vec.field_1351, circle.field_1350, 0, -0.125, 0);
			}
			return;
		}

		class_2338 soundPos = class_2338.method_49638(vec);
		world.method_8396(null, soundPos, class_3417.field_14842, class_3419.field_15251, .25f, .75f);
		world.method_8396(null, soundPos, class_3417.field_15102, class_3419.field_15251, .5f, .75f);
	}

	public boolean hasCapturedBlaze() {
		return capturedBlaze;
	}

}
