package com.simibubi.create.content.processing.burner;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.content.processing.burner.BlazeBurnerBlockEntity.FuelType;

import io.github.fabricators_of_create.porting_lib.entity.events.ProjectileImpactEvent;
import net.minecraft.class_1676;
import net.minecraft.class_1681;
import net.minecraft.class_1686;
import net.minecraft.class_1799;
import net.minecraft.class_1842;
import net.minecraft.class_1844;
import net.minecraft.class_1847;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_239;
import net.minecraft.class_243;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3532;
import net.minecraft.class_3965;

public class BlazeBurnerHandler {

	public static boolean onThrowableImpact(ProjectileImpactEvent event) {
		splashExtinguishesBurner(event.getProjectile(), event.getRayTraceResult());
		return thrownEggsGetEatenByBurner(event.getProjectile(), event.getRayTraceResult());
	}

	public static boolean thrownEggsGetEatenByBurner(class_1676 projectile, class_239 hitResult) {
//		Projectile projectile = event.getProjectile();
		if (!(projectile instanceof class_1681))
			return false;

		if (hitResult
			.method_17783() != class_239.class_240.field_1332)
			return false;

		class_2586 blockEntity = projectile.method_37908()
			.method_8321(class_2338.method_49638(hitResult
				.method_17784()));
		if (!(blockEntity instanceof BlazeBurnerBlockEntity)) {
			return false;
		}

//		event.setCanceled(true);
		projectile.method_18799(class_243.field_1353);
		projectile.method_31472();

		class_1937 world = projectile.method_37908();
		if (world.field_9236)
			return false;

		BlazeBurnerBlockEntity heater = (BlazeBurnerBlockEntity) blockEntity;
		if (!heater.isCreative()) {
			if (heater.activeFuel != FuelType.SPECIAL) {
				heater.activeFuel = FuelType.NORMAL;
				heater.remainingBurnTime =
					class_3532.method_15340(heater.remainingBurnTime + 80, 0, BlazeBurnerBlockEntity.MAX_HEAT_CAPACITY);
				heater.updateBlockState();
				heater.notifyUpdate();
			}
		}

		AllSoundEvents.BLAZE_MUNCH.playOnServer(world, heater.method_11016());
		return true;
	}

	public static void splashExtinguishesBurner(class_1676 projectile, class_239 hitResult) {
//		Projectile projectile = event.getProjectile();
		if (projectile.method_37908().field_9236)
			return;
		if (!(projectile instanceof class_1686))
			return;
		class_1686 entity = (class_1686) projectile;

		if (hitResult
			.method_17783() != class_239.class_240.field_1332)
			return;

		class_1799 stack = entity.method_7495();
		class_1842 potion = class_1844.method_8063(stack);
		if (potion == class_1847.field_8991 && class_1844.method_8067(stack)
			.isEmpty()) {
			class_3965 result = (class_3965) hitResult;
			class_1937 world = entity.method_37908();
			class_2350 face = result.method_17780();
			class_2338 pos = result.method_17777()
				.method_10093(face);

			extinguishLitBurners(world, pos, face);
			extinguishLitBurners(world, pos.method_10093(face.method_10153()), face);

			for (class_2350 face1 : class_2350.class_2353.field_11062) {
				extinguishLitBurners(world, pos.method_10093(face1), face1);
			}
		}
	}

	private static void extinguishLitBurners(class_1937 world, class_2338 pos, class_2350 direction) {
		class_2680 state = world.method_8320(pos);
		if (AllBlocks.LIT_BLAZE_BURNER.has(state)) {
			world.method_8396(null, pos, class_3417.field_15102, class_3419.field_15245, 0.5F,
				2.6F + (world.field_9229.method_43057() - world.field_9229.method_43057()) * 0.8F);
			world.method_8501(pos, AllBlocks.BLAZE_BURNER.getDefaultState());
		}
	}

}
