package com.simibubi.create.content.processing.burner;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.Create;
import com.simibubi.create.content.equipment.wrench.IWrenchable;
import com.simibubi.create.foundation.utility.Lang;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.block.BlockPickInteractionAware;
import net.minecraft.class_10;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1821;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_239;
import net.minecraft.class_2398;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2754;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3489;
import net.minecraft.class_3542;
import net.minecraft.class_3726;
import net.minecraft.class_3965;
import net.minecraft.class_5819;

public class LitBlazeBurnerBlock extends class_2248 implements IWrenchable, BlockPickInteractionAware {

//	public static final ToolAction EXTINGUISH_FLAME_ACTION = ToolAction.get(Create.asResource("extinguish_flame").toString());

	public static final class_2754<FlameType> FLAME_TYPE = class_2754.method_11850("flame_type", FlameType.class);

	public LitBlazeBurnerBlock(class_2251 properties) {
		super(properties);
		method_9590(method_9564().method_11657(FLAME_TYPE, FlameType.REGULAR));
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder);
		builder.method_11667(FLAME_TYPE);
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand,
		class_3965 blockRayTraceResult) {
		class_1799 heldItem = player.method_5998(hand);

		if (heldItem.method_7909() instanceof class_1821) {// || heldItem.getItem().canPerformAction(heldItem, EXTINGUISH_FLAME_ACTION)) {
			world.method_8396(player, pos, class_3417.field_15222, class_3419.field_15245, 0.5f, 2);
			if (world.field_9236)
				return class_1269.field_5812;
			heldItem.method_7956(1, player, p -> p.method_20236(hand));
			world.method_8501(pos, AllBlocks.BLAZE_BURNER.getDefaultState());
			return class_1269.field_5812;
		}

		if (state.method_11654(FLAME_TYPE) == FlameType.REGULAR) {
			if (heldItem.method_31573(class_3489.field_23801)) {
				world.method_8396(player, pos, class_3417.field_21951, class_3419.field_15245, 1.0f, world.field_9229.method_43057() * 0.4F + 0.8F);
				if (world.field_9236)
					return class_1269.field_5812;
				world.method_8501(pos, method_9564().method_11657(FLAME_TYPE, FlameType.SOUL));
				return class_1269.field_5812;
			}
		}

		return class_1269.field_5811;
	}

	@Override
	public class_265 method_9530(class_2680 state, class_1922 reader, class_2338 pos, class_3726 context) {
		return AllBlocks.BLAZE_BURNER.get()
			.method_9530(state, reader, pos, context);
	}

	@Override
	public class_1799 getPickedStack(class_2680 state, class_1922 view, class_2338 pos, @Nullable class_1657 player, @Nullable class_239 result) {
		return AllItems.EMPTY_BLAZE_BURNER.asStack();
	}

	@Environment(EnvType.CLIENT)
	public void method_9496(class_2680 state, class_1937 world, class_2338 pos, class_5819 random) {
		world.method_17452(class_2398.field_11237, true,
			(double) pos.method_10263() + 0.5D + random.method_43058() / 3.0D * (double) (random.method_43056() ? 1 : -1),
			(double) pos.method_10264() + random.method_43058() + random.method_43058(),
			(double) pos.method_10260() + 0.5D + random.method_43058() / 3.0D * (double) (random.method_43056() ? 1 : -1), 0.0D,
			0.07D, 0.0D);

		if (random.method_43048(10) == 0) {
			world.method_8486((double) ((float) pos.method_10263() + 0.5F), (double) ((float) pos.method_10264() + 0.5F),
				(double) ((float) pos.method_10260() + 0.5F), class_3417.field_17483, class_3419.field_15245,
				0.25F + random.method_43057() * .25f, random.method_43057() * 0.7F + 0.6F, false);
		}

		if (state.method_11654(FLAME_TYPE) == FlameType.SOUL) {
			if (random.method_43048(8) == 0) {
				world.method_8406(class_2398.field_23114,
					pos.method_10263() + 0.5F + random.method_43058() / 4 * (random.method_43056() ? 1 : -1),
					pos.method_10264() + 0.3F + random.method_43058() / 2,
					pos.method_10260() + 0.5F + random.method_43058() / 4 * (random.method_43056() ? 1 : -1),
					0.0, random.method_43058() * 0.04 + 0.04, 0.0);
			}
			return;
		}

		if (random.method_43048(5) == 0) {
			for (int i = 0; i < random.method_43048(1) + 1; ++i) {
				world.method_8406(class_2398.field_11239, (double) ((float) pos.method_10263() + 0.5F),
					(double) ((float) pos.method_10264() + 0.5F), (double) ((float) pos.method_10260() + 0.5F),
					(double) (random.method_43057() / 2.0F), 5.0E-5D, (double) (random.method_43057() / 2.0F));
			}
		}
	}

	@Override
	public boolean method_9498(class_2680 p_149740_1_) {
		return true;
	}

	@Override
	public int method_9572(class_2680 state, class_1937 p_180641_2_, class_2338 p_180641_3_) {
		return state.method_11654(FLAME_TYPE) == FlameType.REGULAR ? 1 : 2;
	}

	@Override
	public class_265 method_9549(class_2680 state, class_1922 reader, class_2338 pos,
		class_3726 context) {
		return AllBlocks.BLAZE_BURNER.get()
			.method_9549(state, reader, pos, context);
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	public static int getLight(class_2680 state) {
		if (state.method_11654(FLAME_TYPE) == FlameType.SOUL)
			return 9;
		else
			return 12;
	}

	public enum FlameType implements class_3542 {

		REGULAR, SOUL;

		@Override
		public String method_15434() {
			return Lang.asId(name());
		}

	}

}
