package com.simibubi.create.content.processing.recipe;

import java.util.Iterator;
import java.util.function.Consumer;

import org.jetbrains.annotations.Nullable;

import com.google.common.collect.AbstractIterator;

import io.github.fabricators_of_create.porting_lib.transfer.ViewOnlyWrappedIterator;
import io.github.fabricators_of_create.porting_lib.transfer.ViewOnlyWrappedStorageView;
import io.github.fabricators_of_create.porting_lib.transfer.callbacks.TransactionCallback;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandlerContainer;
import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.StorageView;
import net.fabricmc.fabric.api.transfer.v1.transaction.TransactionContext;
import net.minecraft.class_1799;
import net.minecraft.class_2487;

public class ProcessingInventory extends ItemStackHandlerContainer {
	public float remainingTime;
	public float recipeDuration;
	public boolean appliedRecipe;
	public Consumer<class_1799> callback;
	private boolean limit;

	public ProcessingInventory(Consumer<class_1799> callback) {
		super(16);
		this.callback = callback;
	}

	public ProcessingInventory withSlotLimit(boolean limit) {
		this.limit = limit;
		return this;
	}

	@Override
	public int getSlotLimit(int slot) {
		return !limit ? super.getSlotLimit(slot) : 1;
	}

	public void clear() {
		setSize(getSlotCount());
		remainingTime = 0;
		recipeDuration = 0;
		appliedRecipe = false;
	}

	// moved from insertItem
	@Override
	protected void onContentsChanged(int slot) {
		if (slot == 0) {
			class_1799 stack = getStackInSlot(0);
			if (!stack.method_7960()) {
				callback.accept(stack);
			}
		}
	}

	@Override
	public class_2487 serializeNBT() {
		class_2487 nbt = super.serializeNBT();
		nbt.method_10548("ProcessingTime", remainingTime);
		nbt.method_10548("RecipeTime", recipeDuration);
		nbt.method_10556("AppliedRecipe", appliedRecipe);
		return nbt;
	}

	@Override
	public void deserializeNBT(class_2487 nbt) {
		remainingTime = nbt.method_10583("ProcessingTime");
		recipeDuration = nbt.method_10583("RecipeTime");
		appliedRecipe = nbt.method_10577("AppliedRecipe");
		super.deserializeNBT(nbt);
		if(method_5442())
			appliedRecipe = false;
	}

	@Override
	public long extract(ItemVariant resource, long maxAmount, TransactionContext transaction) {
		return 0;
	}

	@Override
	public boolean isItemValid(int slot, ItemVariant resource) {
		return slot == 0 && method_5442();
	}

	@Override
	public Iterator<StorageView<ItemVariant>> iterator() {
		return new ViewOnlyWrappedIterator<>(super.iterator());
	}

	@Override
	public Iterable<StorageView<ItemVariant>> nonEmptyViews() {
		return this::nonEmptyIterator;
	}

	@Override
	public Iterator<StorageView<ItemVariant>> nonEmptyIterator() {
		return new ViewOnlyWrappedIterator<>(super.nonEmptyIterator());
	}
}
