package com.simibubi.create.content.processing.recipe;

import java.util.Random;
import net.minecraft.class_1799;
import net.minecraft.class_2522;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import net.minecraft.class_3518;
import net.minecraft.class_7923;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.google.gson.JsonSyntaxException;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.utility.Pair;
import com.simibubi.create.foundation.utility.RegisteredObjects;

public class ProcessingOutput {

	public static final ProcessingOutput EMPTY = new ProcessingOutput(class_1799.field_8037, 1);

	private static final Random r = new Random();
	private final class_1799 stack;
	private final float chance;

	private Pair<class_2960, Integer> compatDatagenOutput;

	public ProcessingOutput(class_1799 stack, float chance) {
		this.stack = stack;
		this.chance = chance;
	}

	public ProcessingOutput(Pair<class_2960, Integer> item, float chance) {
		this.stack = class_1799.field_8037;
		this.compatDatagenOutput = item;
		this.chance = chance;
	}

	public class_1799 getStack() {
		return stack;
	}

	public float getChance() {
		return chance;
	}

	public class_1799 rollOutput() {
		int outputAmount = stack.method_7947();
		for (int roll = 0; roll < stack.method_7947(); roll++)
			if (r.nextFloat() > chance)
				outputAmount--;
		if (outputAmount == 0)
			return class_1799.field_8037;
		class_1799 out = stack.method_7972();
		out.method_7939(outputAmount);
		return out;
	}

	public JsonElement serialize() {
		JsonObject json = new JsonObject();
		class_2960 resourceLocation = compatDatagenOutput == null ? RegisteredObjects.getKeyOrThrow(stack
			.method_7909()) : compatDatagenOutput.getFirst();
		json.addProperty("item", resourceLocation.toString());
		int count = compatDatagenOutput == null ? stack.method_7947() : compatDatagenOutput.getSecond();
		if (count != 1)
			json.addProperty("count", count);
		if (stack.method_7985())
			json.add("nbt", JsonParser.parseString(stack.method_7969()
				.toString()));
		if (chance != 1)
			json.addProperty("chance", chance);
		return json;
	}

	public static ProcessingOutput deserialize(JsonElement je) {
		if (!je.isJsonObject())
			throw new JsonSyntaxException("ProcessingOutput must be a json object");

		JsonObject json = je.getAsJsonObject();
		String itemId = class_3518.method_15265(json, "item");
		int count = class_3518.method_15282(json, "count", 1);
		float chance = class_3518.method_15294(json, "chance") ? class_3518.method_15259(json, "chance") : 1;
		class_1799 itemstack = new class_1799(class_7923.field_41178.method_10223(new class_2960(itemId)), count);

		if (class_3518.method_15294(json, "nbt")) {
			try {
				JsonElement element = json.get("nbt");
				itemstack.method_7980(class_2522.method_10718(
					element.isJsonObject() ? Create.GSON.toJson(element) : class_3518.method_15287(element, "nbt")));
			} catch (CommandSyntaxException e) {
				e.printStackTrace();
			}
		}

		return new ProcessingOutput(itemstack, chance);
	}

	public void write(class_2540 buf) {
		buf.method_10793(getStack());
		buf.writeFloat(getChance());
	}

	public static ProcessingOutput read(class_2540 buf) {
		return new ProcessingOutput(buf.method_10819(), buf.readFloat());
	}

}
