package com.simibubi.create.content.redstone.analogLever;

import java.util.List;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_3532;
import com.simibubi.create.content.equipment.goggles.IHaveGoggleInformation;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.animation.LerpedFloat;
import com.simibubi.create.foundation.utility.animation.LerpedFloat.Chaser;

public class AnalogLeverBlockEntity extends SmartBlockEntity implements IHaveGoggleInformation {

	int state = 0;
	int lastChange;
	LerpedFloat clientState;

	public AnalogLeverBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
		clientState = LerpedFloat.linear();
	}

	@Override
	public void write(class_2487 compound, boolean clientPacket) {
		compound.method_10569("State", state);
		compound.method_10569("ChangeTimer", lastChange);
		super.write(compound, clientPacket);
	}

	@Override
	protected void read(class_2487 compound, boolean clientPacket) {
		state = compound.method_10550("State");
		lastChange = compound.method_10550("ChangeTimer");
		clientState.chase(state, 0.2f, Chaser.EXP);
		super.read(compound, clientPacket);
	}

	@Override
	public void tick() {
		super.tick();
		if (lastChange > 0) {
			lastChange--;
			if (lastChange == 0)
				updateOutput();
		}
		if (field_11863.field_9236)
			clientState.tickChaser();
	}

	@Override
	public void initialize() {
		super.initialize();

	}

	private void updateOutput() {
		AnalogLeverBlock.updateNeighbors(method_11010(), field_11863, field_11867);
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {
	}

	public void changeState(boolean back) {
		int prevState = state;
		state += back ? -1 : 1;
		state = class_3532.method_15340(state, 0, 15);
		if (prevState != state)
			lastChange = 15;
		sendData();
	}

	@Override
	public boolean addToGoggleTooltip(List<class_2561> tooltip, boolean isPlayerSneaking) {
		tooltip.add(componentSpacing.method_27662().method_10852(Lang.translateDirect("tooltip.analogStrength", this.state)));

		return true;
	}

	public int getState() {
		return state;
	}
}
