package com.simibubi.create.content.redstone.contact;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.contraptions.behaviour.MovementBehaviour;
import com.simibubi.create.content.contraptions.behaviour.MovementContext;
import com.simibubi.create.content.contraptions.elevator.ElevatorContraption;
import net.minecraft.class_1937;
import net.minecraft.class_1953;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2512;
import net.minecraft.class_2680;

public class ContactMovementBehaviour implements MovementBehaviour {

	@Override
	public class_243 getActiveAreaOffset(MovementContext context) {
		return class_243.method_24954(context.state.method_11654(RedstoneContactBlock.field_10927)
			.method_10163())
			.method_1021(.65f);
	}

	@Override
	public void visitNewPosition(MovementContext context, class_2338 pos) {
		class_2680 block = context.state;
		class_1937 world = context.world;

		if (world.field_9236)
			return;
		if (context.firstMovement)
			return;

		deactivateLastVisitedContact(context);
		class_2680 visitedState = world.method_8320(pos);
		if (!AllBlocks.REDSTONE_CONTACT.has(visitedState) && !AllBlocks.ELEVATOR_CONTACT.has(visitedState))
			return;

		class_243 contact = class_243.method_24954(block.method_11654(RedstoneContactBlock.field_10927)
			.method_10163());
		contact = context.rotation.apply(contact);
		class_2350 direction = class_2350.method_10142(contact.field_1352, contact.field_1351, contact.field_1350);

		if (visitedState.method_11654(RedstoneContactBlock.field_10927) != direction.method_10153())
			return;

		if (AllBlocks.REDSTONE_CONTACT.has(visitedState))
			world.method_8501(pos, visitedState.method_11657(RedstoneContactBlock.POWERED, true));
		if (AllBlocks.ELEVATOR_CONTACT.has(visitedState) && context.contraption instanceof ElevatorContraption ec) 
			ec.broadcastFloorData(world, pos);

		context.data.method_10566("lastContact", class_2512.method_10692(pos));
		return;
	}

	@Override
	public void stopMoving(MovementContext context) {
		deactivateLastVisitedContact(context);
	}

	@Override
	public void cancelStall(MovementContext context) {
		MovementBehaviour.super.cancelStall(context);
		deactivateLastVisitedContact(context);
	}

	public void deactivateLastVisitedContact(MovementContext context) {
		if (!context.data.method_10545("lastContact"))
			return;

		class_2338 last = class_2512.method_10691(context.data.method_10562("lastContact"));
		context.data.method_10551("lastContact");
		class_2680 blockState = context.world.method_8320(last);

		if (AllBlocks.REDSTONE_CONTACT.has(blockState))
			context.world.method_39280(last, AllBlocks.REDSTONE_CONTACT.get(), 1, class_1953.field_9314);
	}

}
