package com.simibubi.create.content.redstone.diodes;

import java.util.Vector;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_2248;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.data.SpecialBlockStateGen;
import com.tterrag.registrate.providers.DataGenContext;
import com.tterrag.registrate.providers.RegistrateBlockstateProvider;
import com.tterrag.registrate.providers.RegistrateItemModelProvider;

import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile;
import io.github.fabricators_of_create.porting_lib.models.generators.ModelFile.ExistingModelFile;
import io.github.fabricators_of_create.porting_lib.models.generators.block.BlockModelProvider;
import io.github.fabricators_of_create.porting_lib.models.generators.item.ItemModelBuilder;

public abstract class AbstractDiodeGenerator extends SpecialBlockStateGen {

	private Vector<ModelFile> models;

	public static <I extends class_1747> void diodeItemModel(DataGenContext<class_1792, I> c, RegistrateItemModelProvider p) {
		String name = c.getName();
		String path = "block/diodes/";
		ItemModelBuilder builder = p.withExistingParent(name, p.modLoc(path + name));
		builder.texture("top", path + name + "/item");
	}

	@Override
	protected final int getXRotation(class_2680 state) {
		return 0;
	}

	@Override
	protected final int getYRotation(class_2680 state) {
		return horizontalAngle(state.method_11654(AbstractDiodeBlock.field_11177));
	}

	protected abstract <T extends class_2248> Vector<ModelFile> createModels(DataGenContext<class_2248, T> ctx,
		BlockModelProvider prov);

	protected abstract int getModelIndex(class_2680 state);

	@Override
	public final <T extends class_2248> ModelFile getModel(DataGenContext<class_2248, T> ctx, RegistrateBlockstateProvider prov,
		class_2680 state) {
		if (models == null)
			models = createModels(ctx, prov.models());
		return models.get(getModelIndex(state));
	}

	protected Vector<ModelFile> makeVector(int size) {
		return new Vector<>(size);
	}

	protected ExistingModelFile existingModel(BlockModelProvider prov, String name) {
		return prov.getExistingFile(existing(name));
	}

	protected class_2960 existing(String name) {
		return Create.asResource("block/diodes/" + name);
	}

	protected <T extends class_2248> class_2960 texture(DataGenContext<class_2248, T> ctx, String name) {
		return Create.asResource("block/diodes/" + ctx.getName() + "/" + name);
	}

	protected class_2960 poweredTorch() {
		return new class_2960("block/redstone_torch");
	}

}
