package com.simibubi.create.content.redstone.displayLink;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.CreateClient;
import com.simibubi.create.content.redstone.displayLink.target.DisplayTarget;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.infrastructure.config.AllConfigs;

import io.github.fabricators_of_create.porting_lib.item.BlockUseBypassingItem;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_124;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_310;

public class DisplayLinkBlockItem extends class_1747 implements BlockUseBypassingItem {

	public DisplayLinkBlockItem(class_2248 pBlock, class_1793 pProperties) {
		super(pBlock, pProperties);
	}

	// fabric: handled by BlockUseBypassingItem
//	public static InteractionResult gathererItemAlwaysPlacesWhenUsed(Player player, Level level, InteractionHand hand, BlockHitResult hitResult) {
//		ItemStack usedItem = player.getItemInHand(hand);
//		if (usedItem.getItem() instanceof DisplayLinkBlockItem) {
//			if (AllBlocks.DISPLAY_LINK.has(level
//				.getBlockState(hitResult.getBlockPos())))
//				return InteractionResult.PASS;
//			return InteractionResult.FAIL;
//		}
//		return InteractionResult.PASS;
//	}

	@Override
	public boolean shouldBypass(class_2680 state, class_2338 pos, class_1937 level, class_1657 player, class_1268 hand) {
		class_1799 usedItem = player.method_5998(hand);
		if (usedItem.method_7909() instanceof DisplayLinkBlockItem) {
			if (!AllBlocks.DISPLAY_LINK.has(state))
				return true;
		}
		return false;
	}

	@Override
	public class_1269 method_7884(class_1838 pContext) {
		class_1799 stack = pContext.method_8041();
		class_2338 pos = pContext.method_8037();
		class_1937 level = pContext.method_8045();
		class_2680 state = level.method_8320(pos);
		class_1657 player = pContext.method_8036();

		if (player == null)
			return class_1269.field_5814;

		if (player.method_5715() && stack.method_7985()) {
			if (level.field_9236)
				return class_1269.field_5812;
			player.method_7353(Lang.translateDirect("display_link.clear"), true);
			stack.method_7980(null);
			return class_1269.field_5812;
		}

		if (!stack.method_7985()) {
			if (level.field_9236)
				return class_1269.field_5812;
			class_2487 stackTag = stack.method_7948();
			stackTag.method_10566("SelectedPos", class_2512.method_10692(pos));
			player.method_7353(Lang.translateDirect("display_link.set"), true);
			stack.method_7980(stackTag);
			return class_1269.field_5812;
		}

		class_2487 tag = stack.method_7969();
		class_2487 teTag = new class_2487();

		class_2338 selectedPos = class_2512.method_10691(tag.method_10562("SelectedPos"));
		class_2338 placedPos = pos.method_10079(pContext.method_8038(), state.method_45474() ? 0 : 1);

		if (!selectedPos.method_19771(placedPos, AllConfigs.server().logistics.displayLinkRange.get())) {
			player.method_7353(Lang.translateDirect("display_link.too_far")
				.method_27692(class_124.field_1061), true);
			return class_1269.field_5814;
		}

		teTag.method_10566("TargetOffset", class_2512.method_10692(selectedPos.method_10059(placedPos)));
		tag.method_10566("BlockEntityTag", teTag);

		class_1269 useOn = super.method_7884(pContext);
		if (level.field_9236 || useOn == class_1269.field_5814)
			return useOn;

		class_1799 itemInHand = player.method_5998(pContext.method_20287());
		if (!itemInHand.method_7960())
			itemInHand.method_7980(null);
		player.method_7353(Lang.translateDirect("display_link.success")
			.method_27692(class_124.field_1060), true);
		return useOn;
	}

	private static class_2338 lastShownPos = null;
	private static class_238 lastShownAABB = null;

	@Environment(EnvType.CLIENT)
	public static void clientTick() {
		class_1657 player = class_310.method_1551().field_1724;
		if (player == null)
			return;
		class_1799 heldItemMainhand = player.method_6047();
		if (!(heldItemMainhand.method_7909() instanceof DisplayLinkBlockItem))
			return;
		if (!heldItemMainhand.method_7985())
			return;
		class_2487 stackTag = heldItemMainhand.method_7948();
		if (!stackTag.method_10545("SelectedPos"))
			return;

		class_2338 selectedPos = class_2512.method_10691(stackTag.method_10562("SelectedPos"));

		if (!selectedPos.equals(lastShownPos)) {
			lastShownAABB = getBounds(selectedPos);
			lastShownPos = selectedPos;
		}

		CreateClient.OUTLINER.showAABB("target", lastShownAABB)
			.colored(0xffcb74)
			.lineWidth(1 / 16f);
	}

	@Environment(EnvType.CLIENT)
	private static class_238 getBounds(class_2338 pos) {
		class_1937 world = class_310.method_1551().field_1687;
		DisplayTarget target = AllDisplayBehaviours.targetOf(world, pos);

		if (target != null)
			return target.getMultiblockBounds(world, pos);

		class_2680 state = world.method_8320(pos);
		class_265 shape = state.method_26218(world, pos);
		return shape.method_1110() ? new class_238(class_2338.field_10980)
			: shape.method_1107()
				.method_996(pos);
	}

}
