package com.simibubi.create.content.redstone.displayLink;

import com.simibubi.create.content.redstone.displayLink.source.DisplaySource;
import com.simibubi.create.foundation.networking.BlockEntityConfigurationPacket;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_2960;

public class DisplayLinkConfigurationPacket extends BlockEntityConfigurationPacket<DisplayLinkBlockEntity> {

	private class_2487 configData;
	private int targetLine;

	public DisplayLinkConfigurationPacket(class_2338 pos, class_2487 configData, int targetLine) {
		super(pos);
		this.configData = configData;
		this.targetLine = targetLine;
	}

	public DisplayLinkConfigurationPacket(class_2540 buffer) {
		super(buffer);
	}

	@Override
	protected void writeSettings(class_2540 buffer) {
		buffer.method_10794(configData);
		buffer.writeInt(targetLine);
	}

	@Override
	protected void readSettings(class_2540 buffer) {
		configData = buffer.method_10798();
		targetLine = buffer.readInt();
	}

	@Override
	protected void applySettings(DisplayLinkBlockEntity be) {
		be.targetLine = targetLine;

		if (!configData.method_10545("Id")) {
			be.notifyUpdate();
			return;
		}

		class_2960 id = new class_2960(configData.method_10558("Id"));
		DisplaySource source = AllDisplayBehaviours.getSource(id);
		if (source == null) {
			be.notifyUpdate();
			return;
		}

		if (be.activeSource == null || be.activeSource != source) {
			be.activeSource = source;
			be.setSourceConfig(configData.method_10553());
		} else {
			be.getSourceConfig()
				.method_10543(configData);
		}

		be.updateGatheredData();
		be.notifyUpdate();
	}

}
