package com.simibubi.create.content.redstone.displayLink;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.foundation.blockEntity.renderer.SafeBlockEntityRenderer;
import com.simibubi.create.foundation.render.CachedBufferer;
import com.simibubi.create.foundation.render.RenderTypes;
import com.simibubi.create.foundation.utility.AngleHelper;
import net.minecraft.class_1921;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5614;
import net.minecraft.class_765;

public class DisplayLinkRenderer extends SafeBlockEntityRenderer<DisplayLinkBlockEntity> {

	public DisplayLinkRenderer(class_5614.class_5615 context) {}

	@Override
	protected void renderSafe(DisplayLinkBlockEntity be, float partialTicks, class_4587 ms, class_4597 buffer,
		int light, int overlay) {
		float glow = be.glow.getValue(partialTicks);
		if (glow < .125f)
			return;

		glow = (float) (1 - (2 * Math.pow(glow - .75f, 2)));
		glow = class_3532.method_15363(glow, -1, 1);

		int color = (int) (200 * glow);

		class_2680 blockState = be.method_11010();
		TransformStack msr = TransformStack.cast(ms);

		class_2350 face = blockState.method_28500(DisplayLinkBlock.field_10927)
			.orElse(class_2350.field_11036);

		if (face.method_10166()
			.method_10179())
			face = face.method_10153();

		ms.method_22903();

		msr.centre()
			.rotateY(AngleHelper.horizontalAngle(face))
			.rotateX(-AngleHelper.verticalAngle(face) - 90)
			.unCentre();

		CachedBufferer.partial(AllPartialModels.DISPLAY_LINK_TUBE, blockState)
			.light(class_765.field_32767)
			.renderInto(ms, buffer.getBuffer(class_1921.method_23583()));

		CachedBufferer.partial(AllPartialModels.DISPLAY_LINK_GLOW, blockState)
			.light(class_765.field_32767)
			.color(color, color, color, 255)
			.disableDiffuse()
			.renderInto(ms, buffer.getBuffer(RenderTypes.getAdditive()));

		ms.method_22909();
	}

}
