package com.simibubi.create.content.redstone.displayLink;

import java.util.Collections;
import java.util.List;
import net.minecraft.class_124;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2248;
import net.minecraft.class_2350;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2680;
import net.minecraft.class_332;
import net.minecraft.class_364;
import net.minecraft.class_4587;
import net.minecraft.class_5250;
import net.minecraft.class_638;
import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.AllPackets;
import com.simibubi.create.content.redstone.displayLink.source.DisplaySource;
import com.simibubi.create.content.redstone.displayLink.source.SingleLineDisplaySource;
import com.simibubi.create.content.redstone.displayLink.target.DisplayTarget;
import com.simibubi.create.content.redstone.displayLink.target.DisplayTargetStats;
import com.simibubi.create.foundation.gui.AbstractSimiScreen;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.AllIcons;
import com.simibubi.create.foundation.gui.ModularGuiLine;
import com.simibubi.create.foundation.gui.ModularGuiLineBuilder;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import com.simibubi.create.foundation.gui.widget.AbstractSimiWidget;
import com.simibubi.create.foundation.gui.widget.ElementWidget;
import com.simibubi.create.foundation.gui.widget.IconButton;
import com.simibubi.create.foundation.gui.widget.Label;
import com.simibubi.create.foundation.gui.widget.ScrollInput;
import com.simibubi.create.foundation.gui.widget.SelectionScrollInput;
import com.simibubi.create.foundation.ponder.ui.PonderTagScreen;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Couple;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.infrastructure.ponder.AllPonderTags;


public class DisplayLinkScreen extends AbstractSimiScreen {

	private static final class_1799 FALLBACK = new class_1799(class_1802.field_8077);

	private AllGuiTextures background;
	private DisplayLinkBlockEntity blockEntity;
	private IconButton confirmButton;

	class_2680 sourceState;
	class_2680 targetState;
	List<DisplaySource> sources;
	DisplayTarget target;

	ScrollInput sourceTypeSelector;
	Label sourceTypeLabel;
	ScrollInput targetLineSelector;
	Label targetLineLabel;
	AbstractSimiWidget sourceWidget;
	AbstractSimiWidget targetWidget;

	Couple<ModularGuiLine> configWidgets;

	public DisplayLinkScreen(DisplayLinkBlockEntity be) {
		this.background = AllGuiTextures.DATA_GATHERER;
		this.blockEntity = be;
		sources = Collections.emptyList();
		configWidgets = Couple.create(ModularGuiLine::new);
		target = null;
	}

	@Override
	protected void method_25426() {
		setWindowSize(background.width, background.height);
		super.method_25426();
		method_37067();

		int x = guiLeft;
		int y = guiTop;


		initGathererOptions();

		confirmButton = new IconButton(x + background.width - 33, y + background.height - 24, AllIcons.I_CONFIRM);
		confirmButton.withCallback(this::method_25419);
		method_37063(confirmButton);
	}

	@Override
	public void method_25393() {
		super.method_25393();
		if (sourceState != null && sourceState.method_26204() != field_22787.field_1687.method_8320(blockEntity.getSourcePosition())
				.method_26204()
				|| targetState != null && targetState.method_26204() != field_22787.field_1687.method_8320(blockEntity.getTargetPosition())
				.method_26204())
			initGathererOptions();
	}

	@SuppressWarnings("deprecation")
	private void initGathererOptions() {
		class_638 level = field_22787.field_1687;
		sourceState = level.method_8320(blockEntity.getSourcePosition());
		targetState = level.method_8320(blockEntity.getTargetPosition());

		class_1799 asItem;
		int x = guiLeft;
		int y = guiTop;

		class_2248 sourceBlock = sourceState.method_26204();
		class_2248 targetBlock = targetState.method_26204();

		asItem = sourceBlock.method_9574(level, blockEntity.getSourcePosition(), sourceState);
		class_1799 sourceIcon = asItem == null || asItem.method_7960() ? FALLBACK : asItem;
		asItem = targetBlock.method_9574(level, blockEntity.getTargetPosition(), targetState);
		class_1799 targetIcon = asItem == null || asItem.method_7960() ? FALLBACK : asItem;

		sources = AllDisplayBehaviours.sourcesOf(level, blockEntity.getSourcePosition());
		target = AllDisplayBehaviours.targetOf(level, blockEntity.getTargetPosition());

		method_37066(targetLineSelector);
		method_37066(targetLineLabel);
		method_37066(sourceTypeSelector);
		method_37066(sourceTypeLabel);
		method_37066(sourceWidget);
		method_37066(targetWidget);

		configWidgets.forEach(s -> s.forEach(this::method_37066));

		targetLineSelector = null;
		sourceTypeSelector = null;

		if (target != null) {
			DisplayTargetStats stats = target.provideStats(new DisplayLinkContext(level, blockEntity));
			int rows = stats.maxRows();
			int startIndex = Math.min(blockEntity.targetLine, rows);

			targetLineLabel = new Label(x + 65, y + 109, Components.immutableEmpty()).withShadow();
			targetLineLabel.text = target.getLineOptionText(startIndex);

			if (rows > 1) {
				targetLineSelector = new ScrollInput(x + 61, y + 105, 135, 16).withRange(0, rows)
						.titled(Lang.translateDirect("display_link.display_on"))
						.inverted()
						.calling(i -> targetLineLabel.text = target.getLineOptionText(i))
						.setState(startIndex);
				method_37063(targetLineSelector);
			}

			method_37063(targetLineLabel);
		}

		sourceWidget = new ElementWidget(x + 37, y + 26)
				.showingElement(GuiGameElement.of(sourceIcon))
				.withCallback((mX, mY) -> {
					ScreenOpener.open(new PonderTagScreen(AllPonderTags.DISPLAY_SOURCES));
				});

		sourceWidget.getToolTip().addAll(List.of(
				Lang.translateDirect("display_link.reading_from"),
				sourceState.method_26204().method_9518()
						.method_27694(s -> s.method_36139(sources.isEmpty() ? 0xF68989 : 0xF2C16D)),
				Lang.translateDirect("display_link.attached_side"),
				Lang.translateDirect("display_link.view_compatible")
						.method_27692(class_124.field_1080)
		));

		method_37063(sourceWidget);

		targetWidget = new ElementWidget(x + 37, y + 105)
				.showingElement(GuiGameElement.of(targetIcon))
				.withCallback((mX, mY) -> {
					ScreenOpener.open(new PonderTagScreen(AllPonderTags.DISPLAY_TARGETS));
				});

		targetWidget.getToolTip().addAll(List.of(
				Lang.translateDirect("display_link.writing_to"),
				targetState.method_26204().method_9518()
						.method_27694(s -> s.method_36139(target == null ? 0xF68989 : 0xF2C16D)),
				Lang.translateDirect("display_link.targeted_location"),
				Lang.translateDirect("display_link.view_compatible")
						.method_27692(class_124.field_1080)
		));

		method_37063(targetWidget);

		if (!sources.isEmpty()) {
			int startIndex = Math.max(sources.indexOf(blockEntity.activeSource), 0);

			sourceTypeLabel = new Label(x + 65, y + 30, Components.immutableEmpty()).withShadow();
			sourceTypeLabel.text = sources.get(startIndex)
					.getName();

			if (sources.size() > 1) {
				List<class_2561> options = sources.stream()
						.map(DisplaySource::getName)
						.toList();
				sourceTypeSelector = new SelectionScrollInput(x + 61, y + 26, 135, 16).forOptions(options)
						.writingTo(sourceTypeLabel)
						.titled(Lang.translateDirect("display_link.information_type"))
						.calling(this::initGathererSourceSubOptions)
						.setState(startIndex);
				sourceTypeSelector.onChanged();
				method_37063(sourceTypeSelector);
			} else
				initGathererSourceSubOptions(0);

			method_37063(sourceTypeLabel);
		}

	}

	private void initGathererSourceSubOptions(int i) {
		DisplaySource source = sources.get(i);
		source.populateData(new DisplayLinkContext(blockEntity.method_10997(), blockEntity));

		if (targetLineSelector != null)
			targetLineSelector
					.titled(source instanceof SingleLineDisplaySource ? Lang.translateDirect("display_link.display_on")
							: Lang.translateDirect("display_link.display_on_multiline"));

		configWidgets.forEach(s -> {
			s.forEach(this::method_37066);
			s.clear();
		});

		DisplayLinkContext context = new DisplayLinkContext(field_22787.field_1687, blockEntity);
		configWidgets.forEachWithContext((s, first) -> source.initConfigurationWidgets(context,
				new ModularGuiLineBuilder(field_22793, s, guiLeft + 60, guiTop + (first ? 51 : 72)), first));
		configWidgets
				.forEach(s -> s.loadValues(blockEntity.getSourceConfig(), this::method_37063, this::method_37060));
	}

	@Override
	public void method_25419() {
		super.method_25419();
		class_2487 sourceData = new class_2487();

		if (!sources.isEmpty()) {
			sourceData.method_10582("Id",
					sources.get(sourceTypeSelector == null ? 0 : sourceTypeSelector.getState()).id.toString());
			configWidgets.forEach(s -> s.saveValues(sourceData));
		}

		AllPackets.getChannel().sendToServer(new DisplayLinkConfigurationPacket(blockEntity.method_11016(), sourceData,
				targetLineSelector == null ? 0 : targetLineSelector.getState()));
	}

	@Override
	protected void renderWindow(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		int x = guiLeft;
		int y = guiTop;

		background.render(graphics, x, y);
		class_5250 header = Lang.translateDirect("display_link.title");
		graphics.method_51439(field_22793, header, x + background.width / 2 - field_22793.method_27525(header) / 2, y + 4, 0x592424, false);

		if (sources.isEmpty())
			graphics.method_27535(field_22793, Lang.translateDirect("display_link.no_source"), x + 65, y + 30, 0xD3D3D3);
		if (target == null)
			graphics.method_27535(field_22793, Lang.translateDirect("display_link.no_target"), x + 65, y + 109, 0xD3D3D3);

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(0, guiTop + 46, 0);
		configWidgets.getFirst()
				.renderWidgetBG(guiLeft, graphics);
		ms.method_46416(0, 21, 0);
		configWidgets.getSecond()
				.renderWidgetBG(guiLeft, graphics);
		ms.method_22909();

		ms.method_22903();
		TransformStack.cast(ms)
				.pushPose()
				.translate(x + background.width + 4, y + background.height + 4, 100)
				.scale(40)
				.rotateX(-22)
				.rotateY(63);
		GuiGameElement.of(blockEntity.method_11010()
						.method_11657(DisplayLinkBlock.field_10927, class_2350.field_11036))
				.render(graphics);
		ms.method_22909();
	}

	@Override
	protected void method_37066(class_364 p_169412_) {
		if (p_169412_ != null)
			super.method_37066(p_169412_);
	}

}
