package com.simibubi.create.content.redstone.displayLink.source;

import com.simibubi.create.content.redstone.displayLink.DisplayLinkBlock;
import com.simibubi.create.content.redstone.displayLink.DisplayLinkBlockEntity;
import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.content.redstone.displayLink.target.DisplayTargetStats;
import com.simibubi.create.foundation.utility.Components;
import net.minecraft.class_5250;

public class AccumulatedItemCountDisplaySource extends NumericSingleLineDisplaySource {

	@Override
	protected class_5250 provideLine(DisplayLinkContext context, DisplayTargetStats stats) {
		return Components.literal(String.valueOf(context.sourceConfig()
			.method_10550("Collected")));
	}

	public void itemReceived(DisplayLinkBlockEntity be, int amount) {
		if (be.method_11010()
			.method_28500(DisplayLinkBlock.POWERED)
			.orElse(true))
			return;
		
		int collected = be.getSourceConfig()
			.method_10550("Collected");
		be.getSourceConfig()
			.method_10569("Collected", collected + amount);
		be.updateGatheredData();
	}

	@Override
	protected String getTranslationKey() {
		return "accumulate_items";
	}

	@Override
	public int getPassiveRefreshTicks() {
		return 200;
	}

	@Override
	public void onSignalReset(DisplayLinkContext context) {
		context.sourceConfig()
			.method_10551("Collected");
	}

	@Override
	protected boolean allowsLabeling(DisplayLinkContext context) {
		return true;
	}

}
