package com.simibubi.create.content.redstone.displayLink.source;

import java.util.stream.Stream;
import net.minecraft.class_124;
import net.minecraft.class_1937;
import net.minecraft.class_266;
import net.minecraft.class_3218;
import net.minecraft.class_5250;
import com.google.common.collect.ImmutableList;
import com.simibubi.create.content.redstone.displayLink.DisplayLinkContext;
import com.simibubi.create.foundation.gui.ModularGuiLineBuilder;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.LongAttached;
import com.simibubi.create.foundation.utility.Lang;

import com.simibubi.create.foundation.utility.LongAttached;

public class ScoreboardDisplaySource extends ValueListDisplaySource {

	@Override
	protected Stream<LongAttached<class_5250>> provideEntries(DisplayLinkContext context, int maxRows) {
		class_1937 level = context.blockEntity()
			.method_10997();
		if (!(level instanceof class_3218 sLevel))
			return Stream.empty();

		String name = context.sourceConfig()
			.method_10558("Objective");

		return showScoreboard(sLevel, name, maxRows);
	}

	protected Stream<LongAttached<class_5250>> showScoreboard(class_3218 sLevel, String objectiveName,
		int maxRows) {
		class_266 objective = sLevel.method_14170()
			.method_1170(objectiveName);
		if (objective == null)
			return notFound(objectiveName).stream();

		return sLevel.method_14170()
			.method_1184(objective)
			.stream()
			.map(score -> LongAttached.with(score.method_1126(), Components.literal(score.method_1129())
				.method_27661()))
			.sorted(LongAttached.comparator())
			.limit(maxRows);
	}

	private ImmutableList<LongAttached<class_5250>> notFound(String objective) {
		return ImmutableList
			.of(LongAttached.with(404, Lang.translateDirect("display_source.scoreboard.objective_not_found", objective)));
	}

	@Override
	protected String getTranslationKey() {
		return "scoreboard";
	}

	@Override
	public void initConfigurationWidgets(DisplayLinkContext context, ModularGuiLineBuilder builder, boolean isFirstLine) {
		if (isFirstLine)
			builder.addTextInput(0, 137, (e, t) -> {
				e.method_1852("");
				t.withTooltip(ImmutableList.of(Lang.translateDirect("display_source.scoreboard.objective")
					.method_27694(s -> s.method_36139(0x5391E1)),
					Lang.translateDirect("gui.schedule.lmb_edit")
						.method_27695(class_124.field_1063, class_124.field_1056)));
			}, "Objective");
		else
			addFullNumberConfig(builder);
	}

	@Override
	protected boolean valueFirst() {
		return false;
	}

}
