package com.simibubi.create.content.redstone.link;

import java.util.List;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2487;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import org.apache.commons.lang3.tuple.Pair;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBoxTransform;

public class RedstoneLinkBlockEntity extends SmartBlockEntity {

	private boolean receivedSignalChanged;
	private int receivedSignal;
	private int transmittedSignal;
	protected LinkBehaviour link;
	private boolean transmitter;

	public RedstoneLinkBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {}

	@Override
	public void addBehavioursDeferred(List<BlockEntityBehaviour> behaviours) {
		createLink();
		behaviours.add(link);
	}

	protected void createLink() {
		Pair<ValueBoxTransform, ValueBoxTransform> slots =
			ValueBoxTransform.Dual.makeSlots(RedstoneLinkFrequencySlot::new);
		link = transmitter ? LinkBehaviour.transmitter(this, slots, this::getSignal)
			: LinkBehaviour.receiver(this, slots, this::setSignal);
	}

	public int getSignal() {
		return transmittedSignal;
	}

	public void setSignal(int power) {
		if (receivedSignal != power)
			receivedSignalChanged = true;
		receivedSignal = power;
	}

	public void transmit(int strength) {
		transmittedSignal = strength;
		if (link != null)
			link.notifySignalChange();
	}

	@Override
	public void write(class_2487 compound, boolean clientPacket) {
		compound.method_10556("Transmitter", transmitter);
		compound.method_10569("Receive", getReceivedSignal());
		compound.method_10556("ReceivedChanged", receivedSignalChanged);
		compound.method_10569("Transmit", transmittedSignal);
		super.write(compound, clientPacket);
	}

	@Override
	protected void read(class_2487 compound, boolean clientPacket) {
		transmitter = compound.method_10577("Transmitter");
		super.read(compound, clientPacket);

		receivedSignal = compound.method_10550("Receive");
		receivedSignalChanged = compound.method_10577("ReceivedChanged");
		if (field_11863 == null || field_11863.field_9236 || !link.newPosition)
			transmittedSignal = compound.method_10550("Transmit");
	}

	@Override
	public void tick() {
		super.tick();

		if (isTransmitterBlock() != transmitter) {
			transmitter = isTransmitterBlock();
			LinkBehaviour prevlink = link;
			removeBehaviour(LinkBehaviour.TYPE);
			createLink();
			link.copyItemsFrom(prevlink);
			attachBehaviourLate(link);
		}

		if (transmitter)
			return;
		if (field_11863.field_9236)
			return;

		class_2680 blockState = method_11010();
		if (!AllBlocks.REDSTONE_LINK.has(blockState))
			return;

		if ((getReceivedSignal() > 0) != blockState.method_11654(RedstoneLinkBlock.POWERED)) {
			receivedSignalChanged = true;
			field_11863.method_8501(field_11867, blockState.method_28493(RedstoneLinkBlock.POWERED));
		}

		if (receivedSignalChanged) {
			class_2350 attachedFace = blockState.method_11654(RedstoneLinkBlock.field_10927)
				.method_10153();
			class_2338 attachedPos = field_11867.method_10093(attachedFace);
			field_11863.method_8408(field_11867, field_11863.method_8320(field_11867)
				.method_26204());
			field_11863.method_8408(attachedPos, field_11863.method_8320(attachedPos)
				.method_26204());
			receivedSignalChanged = false;
		}
	}

	protected Boolean isTransmitterBlock() {
		return !method_11010().method_11654(RedstoneLinkBlock.RECEIVER);
	}

	public int getReceivedSignal() {
		return receivedSignal;
	}

}
