package com.simibubi.create.content.redstone.link.controller;

import java.util.ArrayList;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.content.schematics.requirement.ISpecialBlockItemRequirement;
import com.simibubi.create.content.schematics.requirement.ItemRequirement;
import com.simibubi.create.foundation.block.IBE;

import net.fabricmc.fabric.api.block.BlockPickInteractionAware;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_239;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_3715;
import net.minecraft.class_3965;

public class LecternControllerBlock extends class_3715
	implements IBE<LecternControllerBlockEntity>, ISpecialBlockItemRequirement, BlockPickInteractionAware {

	public LecternControllerBlock(class_2251 properties) {
		super(properties);
		method_9590(method_9564().method_11657(field_17366, true));
	}

	@Override
	public Class<LecternControllerBlockEntity> getBlockEntityClass() {
		return LecternControllerBlockEntity.class;
	}

	@Override
	public class_2591<? extends LecternControllerBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.LECTERN_CONTROLLER.get();
	}

	@Override
	public class_2586 method_10123(class_2338 p_153573_, class_2680 p_153574_) {
		return IBE.super.method_10123(p_153573_, p_153574_);
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand,
		class_3965 hit) {
		if (!player.method_5715() && LecternControllerBlockEntity.playerInRange(player, world, pos)) {
			if (!world.field_9236)
				withBlockEntityDo(world, pos, be -> be.tryStartUsing(player));
			return class_1269.field_5812;
		}

		if (player.method_5715()) {
			if (!world.field_9236)
				replaceWithLectern(state, world, pos);
			return class_1269.field_5812;
		}

		return class_1269.field_5811;
	}

	@Override
	public void method_9536(class_2680 state, class_1937 world, class_2338 pos, class_2680 newState, boolean isMoving) {
		if (!state.method_27852(newState.method_26204())) {
			if (!world.field_9236)
				withBlockEntityDo(world, pos, be -> be.dropController(state));

			super.method_9536(state, world, pos, newState, isMoving);
		}
	}

	@Override
	public int method_9572(class_2680 state, class_1937 world, class_2338 pos) {
		return 15;
	}

	public void replaceLectern(class_2680 lecternState, class_1937 world, class_2338 pos, class_1799 controller) {
		world.method_8501(pos, method_9564().method_11657(field_16404, lecternState.method_11654(field_16404))
			.method_11657(field_17365, lecternState.method_11654(field_17365)));
		withBlockEntityDo(world, pos, be -> be.setController(controller));
	}

	public void replaceWithLectern(class_2680 state, class_1937 world, class_2338 pos) {
		AllSoundEvents.CONTROLLER_TAKE.playOnServer(world, pos);
		world.method_8501(pos, class_2246.field_16330.method_9564()
			.method_11657(field_16404, state.method_11654(field_16404))
			.method_11657(field_17365, state.method_11654(field_17365)));
	}


	@Override
	public class_1799 getPickedStack(class_2680 state, class_1922 view, class_2338 pos, @Nullable class_1657 player, @Nullable class_239 result) {
		return class_2246.field_16330.method_9574(view, pos, state);
	}

	@Override
	public ItemRequirement getRequiredItems(class_2680 state, class_2586 be) {
		ArrayList<class_1799> requiredItems = new ArrayList<>();
		requiredItems.add(new class_1799(class_2246.field_16330));
		requiredItems.add(new class_1799(AllItems.LINKED_CONTROLLER.get()));
		return new ItemRequirement(ItemRequirement.ItemUseType.CONSUME, requiredItems);
	}
}
