package com.simibubi.create.content.redstone.link.controller;

import java.util.Vector;
import net.minecraft.class_1087;
import net.minecraft.class_1306;
import net.minecraft.class_1799;
import net.minecraft.class_310;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_811;
import com.jozufozu.flywheel.core.PartialModel;
import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.AllItems;
import com.simibubi.create.Create;
import com.simibubi.create.content.redstone.link.controller.LinkedControllerClientHandler.Mode;
import com.simibubi.create.foundation.item.render.CustomRenderedItemModel;
import com.simibubi.create.foundation.item.render.CustomRenderedItemModelRenderer;
import com.simibubi.create.foundation.item.render.PartialItemModelRenderer;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import com.simibubi.create.foundation.utility.animation.LerpedFloat;
import com.simibubi.create.foundation.utility.animation.LerpedFloat.Chaser;

public class LinkedControllerItemRenderer extends CustomRenderedItemModelRenderer {

	protected static final PartialModel POWERED = new PartialModel(Create.asResource("item/linked_controller/powered"));
	protected static final PartialModel BUTTON = new PartialModel(Create.asResource("item/linked_controller/button"));

	static LerpedFloat equipProgress;
	static Vector<LerpedFloat> buttons;

	static {
		equipProgress = LerpedFloat.linear()
			.startWithValue(0);
		buttons = new Vector<>(6);
		for (int i = 0; i < 6; i++)
			buttons.add(LerpedFloat.linear()
				.startWithValue(0));
	}

	static void tick() {
		if (class_310.method_1551()
			.method_1493())
			return;

		boolean active = LinkedControllerClientHandler.MODE != Mode.IDLE;
		equipProgress.chase(active ? 1 : 0, .2f, Chaser.EXP);
		equipProgress.tickChaser();

		if (!active)
			return;

		for (int i = 0; i < buttons.size(); i++) {
			LerpedFloat lerpedFloat = buttons.get(i);
			lerpedFloat.chase(LinkedControllerClientHandler.currentlyPressed.contains(i) ? 1 : 0, .4f, Chaser.EXP);
			lerpedFloat.tickChaser();
		}
	}

	static void resetButtons() {
		for (int i = 0; i < buttons.size(); i++) {
			buttons.get(i).startWithValue(0);
		}
	}

	@Override
	protected void render(class_1799 stack, CustomRenderedItemModel model, PartialItemModelRenderer renderer,
		class_811 transformType, class_4587 ms, class_4597 buffer, int light,
		int overlay) {
		renderNormal(stack, model, renderer, transformType, ms, light);
	}

	protected static void renderNormal(class_1799 stack, CustomRenderedItemModel model,
	  	PartialItemModelRenderer renderer, class_811 transformType, class_4587 ms,
  		int light) {
		render(stack, model, renderer, transformType, ms, light, RenderType.NORMAL, false, false);
	}

	public static void renderInLectern(class_1799 stack, CustomRenderedItemModel model,
	  	PartialItemModelRenderer renderer, class_811 transformType, class_4587 ms,
  		int light, boolean active, boolean renderDepression) {
		render(stack, model, renderer, transformType, ms, light, RenderType.LECTERN, active, renderDepression);
	}

	protected static void render(class_1799 stack, CustomRenderedItemModel model,
	  	PartialItemModelRenderer renderer, class_811 transformType, class_4587 ms,
  		int light, RenderType renderType, boolean active, boolean renderDepression) {
		float pt = AnimationTickHolder.getPartialTicks();
		TransformStack msr = TransformStack.cast(ms);

		ms.method_22903();

		if (renderType == RenderType.NORMAL) {
			class_310 mc = class_310.method_1551();
			boolean rightHanded = mc.field_1690.method_42552().method_41753() == class_1306.field_6183;
			class_811 mainHand =
					rightHanded ? class_811.field_4322 : class_811.field_4321;
			class_811 offHand =
					rightHanded ? class_811.field_4321 : class_811.field_4322;

			active = false;
			boolean noControllerInMain = !AllItems.LINKED_CONTROLLER.isIn(mc.field_1724.method_6047());

			if (transformType == mainHand || (transformType == offHand && noControllerInMain)) {
				float equip = equipProgress.getValue(pt);
				int handModifier = transformType == class_811.field_4321 ? -1 : 1;
				msr.translate(0, equip / 4, equip / 4 * handModifier);
				msr.rotateY(equip * -30 * handModifier);
				msr.rotateZ(equip * -30);
				active = true;
			}

			if (transformType == class_811.field_4317) {
				if (stack == mc.field_1724.method_6047())
					active = true;
				if (stack == mc.field_1724.method_6079() && noControllerInMain)
					active = true;
			}

			active &= LinkedControllerClientHandler.MODE != Mode.IDLE;

			renderDepression = true;
		}

		renderer.render(active ? POWERED.get() : model.getOriginalModel(), light);

		if (!active) {
			ms.method_22909();
			return;
		}

		class_1087 button = BUTTON.get();
		float s = 1 / 16f;
		float b = s * -.75f;
		int index = 0;

		if (renderType == RenderType.NORMAL) {
			if (LinkedControllerClientHandler.MODE == Mode.BIND) {
				int i = (int) class_3532.method_16439((class_3532.method_15374(AnimationTickHolder.getRenderTime() / 4f) + 1) / 2, 5, 15);
				light = i << 20;
			}
		}

		ms.method_22903();
		msr.translate(2 * s, 0, 8 * s);
		renderButton(renderer, ms, light, pt, button, b, index++, renderDepression);
		msr.translate(4 * s, 0, 0);
		renderButton(renderer, ms, light, pt, button, b, index++, renderDepression);
		msr.translate(-2 * s, 0, 2 * s);
		renderButton(renderer, ms, light, pt, button, b, index++, renderDepression);
		msr.translate(0, 0, -4 * s);
		renderButton(renderer, ms, light, pt, button, b, index++, renderDepression);
		ms.method_22909();

		msr.translate(3 * s, 0, 3 * s);
		renderButton(renderer, ms, light, pt, button, b, index++, renderDepression);
		msr.translate(2 * s, 0, 0);
		renderButton(renderer, ms, light, pt, button, b, index++, renderDepression);

		ms.method_22909();
	}

	protected static void renderButton(PartialItemModelRenderer renderer, class_4587 ms, int light, float pt, class_1087 button,
		float b, int index, boolean renderDepression) {
		ms.method_22903();
		if (renderDepression) {
			float depression = b * buttons.get(index).getValue(pt);
			ms.method_46416(0, depression, 0);
		}
		renderer.renderSolid(button, light);
		ms.method_22909();
	}

	protected enum RenderType {
		NORMAL, LECTERN;
	}

}
