package com.simibubi.create.content.redstone.link.controller;

import static com.simibubi.create.foundation.gui.AllGuiTextures.PLAYER_INVENTORY;

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import net.minecraft.class_124;
import net.minecraft.class_1661;
import net.minecraft.class_1799;
import net.minecraft.class_2561;
import net.minecraft.class_332;
import net.minecraft.class_768;
import com.google.common.collect.ImmutableList;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.AllIcons;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import com.simibubi.create.foundation.gui.menu.AbstractSimiContainerScreen;
import com.simibubi.create.foundation.gui.widget.IconButton;
import com.simibubi.create.foundation.utility.ControlsUtil;
import com.simibubi.create.foundation.utility.Lang;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.common.accessor.SlotAccessor;
import io.github.fabricators_of_create.porting_lib.util.ItemStackUtil;
import io.github.fabricators_of_create.porting_lib.util.PlayerEntityHelper;

public class LinkedControllerScreen extends AbstractSimiContainerScreen<LinkedControllerMenu> {

	protected AllGuiTextures background;
	private List<class_768> extraAreas = Collections.emptyList();

	private IconButton resetButton;
	private IconButton confirmButton;

	public LinkedControllerScreen(LinkedControllerMenu menu, class_1661 inv, class_2561 title) {
		super(menu, inv, title);
		this.background = AllGuiTextures.LINKED_CONTROLLER;
	}

	@Override
	protected void method_25426() {
		setWindowSize(background.width, background.height + 4 + PLAYER_INVENTORY.height);
		setWindowOffset(1, 0);
		super.method_25426();

		int x = field_2776;
		int y = field_2800;

		resetButton = new IconButton(x + background.width - 62, y + background.height - 24, AllIcons.I_TRASH);
		resetButton.withCallback(() -> {
			field_2797.clearContents();
			field_2797.sendClearPacket();
		});
		confirmButton = new IconButton(x + background.width - 33, y + background.height - 24, AllIcons.I_CONFIRM);
		confirmButton.withCallback(() -> {
			field_22787.field_1724.method_7346();
		});

		method_37063(resetButton);
		method_37063(confirmButton);

		extraAreas = ImmutableList.of(new class_768(x + background.width + 4, y + background.height - 44, 64, 56));
	}

	@Override
	protected void method_2389(class_332 graphics, float partialTicks, int mouseX, int mouseY) {
		int invX = getLeftOfCentered(PLAYER_INVENTORY.width);
		int invY = field_2800 + background.height + 4;
		renderPlayerInventory(graphics, invX, invY);

		int x = field_2776;
		int y = field_2800;

		background.render(graphics, x, y);
		graphics.method_51439(field_22793, field_22785, x + 15, y + 4, 0x592424, false);

		GuiGameElement.of(field_2797.contentHolder).<GuiGameElement
			.GuiRenderBuilder>at(x + background.width - 4, y + background.height - 56, -200)
			.scale(5)
			.render(graphics);
	}

	@Override
	protected void method_37432() {
		if (!class_1799.method_7973(field_2797.player.method_6047(),field_2797.contentHolder))
			PlayerEntityHelper.closeScreen(field_2797.player);

		super.method_37432();
	}

	@Override
	protected void method_2380(class_332 graphics, int x, int y) {
		if (!field_2797.method_34255()
			.method_7960() || this.field_2787 == null || field_2787.field_7871 == field_2797.playerInventory) {
			super.method_2380(graphics, x, y);
			return;
		}

		List<class_2561> list = new LinkedList<>();
		if (field_2787.method_7681())
			list = method_51454(field_2787.method_7677());

		graphics.method_51434(field_22793, addToTooltip(list, ((SlotAccessor)field_2787).port_lib$getSlotIndex()), x, y);
	}

	private List<class_2561> addToTooltip(List<class_2561> list, int slot) {
		if (slot < 0 || slot >= 12)
			return list;
		list.add(Lang.translateDirect("linked_controller.frequency_slot_" + ((slot % 2) + 1), ControlsUtil.getControls()
			.get(slot / 2)
			.method_16007()
			.getString())
			.method_27692(class_124.field_1065));
		return list;
	}

	@Override
	public List<class_768> getExtraAreas() {
		return extraAreas;
	}

}
