package com.simibubi.create.content.redstone.nixieTube;

import static net.minecraft.class_2741.field_12508;

import java.util.List;
import java.util.function.BiConsumer;

import com.simibubi.create.foundation.utility.AdventureUtil;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.equipment.clipboard.ClipboardEntry;
import com.simibubi.create.content.equipment.wrench.IWrenchable;
import com.simibubi.create.content.schematics.requirement.ISpecialBlockItemRequirement;
import com.simibubi.create.content.schematics.requirement.ItemRequirement;
import com.simibubi.create.content.schematics.requirement.ItemRequirement.ItemUseType;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.utility.Iterate;

import io.github.fabricators_of_create.porting_lib.block.ConnectableRedstoneBlock;
import io.github.fabricators_of_create.porting_lib.util.TagUtil;
import net.fabricmc.fabric.api.block.BlockPickInteractionAware;
import net.minecraft.class_10;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1767;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_239;
import net.minecraft.class_2487;
import net.minecraft.class_2520;
import net.minecraft.class_2561;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_3218;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_3737;
import net.minecraft.class_3965;
import net.minecraft.class_5819;

public class NixieTubeBlock extends DoubleFaceAttachedBlock
	implements IBE<NixieTubeBlockEntity>, IWrenchable, class_3737, ISpecialBlockItemRequirement, BlockPickInteractionAware, ConnectableRedstoneBlock {

	protected final class_1767 color;

	public NixieTubeBlock(class_2251 properties, class_1767 color) {
		super(properties);
		this.color = color;
		method_9590(method_9564().method_11657(FACE, DoubleAttachFace.FLOOR)
			.method_11657(field_12508, false));
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand,
		class_3965 ray) {

		if (player.method_5715() || AdventureUtil.isAdventure(player))
			return class_1269.field_5811;

		class_1799 heldItem = player.method_5998(hand);
		NixieTubeBlockEntity nixie = getBlockEntity(world, pos);

		if (nixie == null)
			return class_1269.field_5811;
		if (heldItem.method_7960()) {
			if (nixie.reactsToRedstone())
				return class_1269.field_5811;
			nixie.clearCustomText();
			updateDisplayedRedstoneValue(state, world, pos);
			return class_1269.field_5812;
		}

		boolean display =
			heldItem.method_7909() == class_1802.field_8448 && heldItem.method_7938() || AllBlocks.CLIPBOARD.isIn(heldItem);
		class_1767 dye = TagUtil.getColorFromStack(heldItem);

		if (!display && dye == null)
			return class_1269.field_5811;

		class_2487 tag = heldItem.method_7941("display");
		String tagElement = tag != null && tag.method_10573("Name", class_2520.field_33258) ? tag.method_10558("Name") : null;

		if (AllBlocks.CLIPBOARD.isIn(heldItem)) {
			List<ClipboardEntry> entries = ClipboardEntry.getLastViewedEntries(heldItem);
			for (int i = 0; i < entries.size();) {
				tagElement = class_2561.class_2562.method_10867(entries.get(i).text);
				break;
			}
		}

		if (world.field_9236)
			return class_1269.field_5812;

		String tagUsed = tagElement;
		walkNixies(world, pos, (currentPos, rowPosition) -> {
			if (display)
				withBlockEntityDo(world, currentPos, be -> be.displayCustomText(tagUsed, rowPosition));
			if (dye != null)
				world.method_8501(currentPos, withColor(state, dye));
		});

		return class_1269.field_5812;
	}

	public static void walkNixies(class_1936 world, class_2338 start, BiConsumer<class_2338, Integer> callback) {
		class_2680 state = world.method_8320(start);
		if (!(state.method_26204() instanceof NixieTubeBlock))
			return;

		class_2338 currentPos = start;
		class_2350 left = state.method_11654(field_11177)
			.method_10153();

		if (state.method_11654(FACE) == DoubleAttachFace.WALL)
			left = class_2350.field_11036;
		if (state.method_11654(FACE) == DoubleAttachFace.WALL_REVERSED)
			left = class_2350.field_11033;

		class_2350 right = left.method_10153();

		while (true) {
			class_2338 nextPos = currentPos.method_10093(left);
			if (!areNixieBlocksEqual(world.method_8320(nextPos), state))
				break;
			currentPos = nextPos;
		}

		int index = 0;

		while (true) {
			final int rowPosition = index;
			callback.accept(currentPos, rowPosition);
			class_2338 nextPos = currentPos.method_10093(right);
			if (!areNixieBlocksEqual(world.method_8320(nextPos), state))
				break;
			currentPos = nextPos;
			index++;
		}
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder.method_11667(FACE, field_11177, field_12508));
	}

	@Override
	public void method_9536(class_2680 p_196243_1_, class_1937 p_196243_2_, class_2338 p_196243_3_, class_2680 p_196243_4_,
		boolean p_196243_5_) {
		if (!(p_196243_4_.method_26204() instanceof NixieTubeBlock))
			p_196243_2_.method_8544(p_196243_3_);
	}

	@Override
	public class_1799 method_9574(class_1922 p_185473_1_, class_2338 p_185473_2_, class_2680 p_185473_3_) {
		return AllBlocks.ORANGE_NIXIE_TUBE.asStack();
	}

	@Override
	public ItemRequirement getRequiredItems(class_2680 state, class_2586 be) {
		return new ItemRequirement(ItemUseType.CONSUME, AllBlocks.ORANGE_NIXIE_TUBE.get()
			.method_8389());
	}

	@Override
	public class_265 method_9530(class_2680 pState, class_1922 pLevel, class_2338 pPos, class_3726 pContext) {
		class_2350 facing = pState.method_11654(field_11177);
		switch (pState.method_11654(FACE)) {
		case CEILING:
			return AllShapes.NIXIE_TUBE_CEILING.get(facing.method_10170()
				.method_10166());
		case FLOOR:
			return AllShapes.NIXIE_TUBE.get(facing.method_10170()
				.method_10166());
		default:
			return AllShapes.NIXIE_TUBE_WALL.get(facing);
		}
	}

	@Override
	public class_1799 getPickedStack(class_2680 state, class_1922 view, class_2338 pos, @Nullable class_1657 player, @Nullable class_239 result) {
		if (color != class_1767.field_7946)
			return AllBlocks.ORANGE_NIXIE_TUBE.get()
					.getPickedStack(state, view, pos, player, result);
		return new class_1799(AllBlocks.NIXIE_TUBES.get(color).get());
	}

	@Override
	public class_3610 method_9545(class_2680 state) {
		return state.method_11654(field_12508) ? class_3612.field_15910.method_15729(false) : class_3612.field_15906.method_15785();
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 direction, class_2680 neighbourState, class_1936 world,
		class_2338 pos, class_2338 neighbourPos) {
		if (state.method_11654(field_12508))
			world.method_39281(pos, class_3612.field_15910, class_3612.field_15910.method_15789(world));
		return state;
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2680 state = super.method_9605(context);
		if (state == null)
			return null;
		if (state.method_11654(FACE) != DoubleAttachFace.WALL && state.method_11654(FACE) != DoubleAttachFace.WALL_REVERSED)
			state = state.method_11657(field_11177, state.method_11654(field_11177)
				.method_10170());
		return state.method_11657(field_12508, Boolean.valueOf(context.method_8045()
			.method_8316(context.method_8037())
			.method_15772() == class_3612.field_15910));
	}

	@Override
	public void method_9612(class_2680 state, class_1937 worldIn, class_2338 pos, class_2248 p_220069_4_, class_2338 p_220069_5_,
		boolean p_220069_6_) {
		if (worldIn.field_9236)
			return;
		if (!worldIn.method_8397()
			.method_8677(pos, this))
			worldIn.method_39279(pos, this, 0);
	}

	@Override
	public void method_9588(class_2680 state, class_3218 worldIn, class_2338 pos, class_5819 r) {
		updateDisplayedRedstoneValue(state, worldIn, pos);
	}

	@Override
	public void method_9615(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 oldState, boolean isMoving) {
		if (state.method_26204() == oldState.method_26204() || isMoving)
			return;
		updateDisplayedRedstoneValue(state, worldIn, pos);
	}

	private void updateDisplayedRedstoneValue(class_2680 state, class_1937 worldIn, class_2338 pos) {
		if (worldIn.field_9236)
			return;
		withBlockEntityDo(worldIn, pos, be -> {
			if (be.reactsToRedstone())
				be.updateRedstoneStrength(getPower(worldIn, pos));
		});
	}

	static boolean isValidBlock(class_1922 world, class_2338 pos, boolean above) {
		class_2680 state = world.method_8320(pos.method_10086(above ? 1 : -1));
		return !state.method_26218(world, pos)
			.method_1110();
	}

	private int getPower(class_1937 worldIn, class_2338 pos) {
		int power = 0;
		for (class_2350 direction : Iterate.directions)
			power = Math.max(worldIn.method_49808(pos.method_10093(direction), direction), power);
		for (class_2350 direction : Iterate.directions)
			power = Math.max(worldIn.method_49808(pos.method_10093(direction), class_2350.field_11036), power);
		return power;
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

	@Override
	public boolean canConnectRedstone(class_2680 state, class_1922 world, class_2338 pos, class_2350 side) {
		return side != null;
	}

	@Override
	public Class<NixieTubeBlockEntity> getBlockEntityClass() {
		return NixieTubeBlockEntity.class;
	}

	@Override
	public class_2591<? extends NixieTubeBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.NIXIE_TUBE.get();
	}

	public class_1767 getColor() {
		return color;
	}

	public static boolean areNixieBlocksEqual(class_2680 blockState, class_2680 otherState) {
		if (!(blockState.method_26204() instanceof NixieTubeBlock))
			return false;
		if (!(otherState.method_26204() instanceof NixieTubeBlock))
			return false;
		return withColor(blockState, class_1767.field_7952) == withColor(otherState, class_1767.field_7952);
	}

	public static class_2680 withColor(class_2680 state, class_1767 color) {
		return (color == class_1767.field_7946 ? AllBlocks.ORANGE_NIXIE_TUBE : AllBlocks.NIXIE_TUBES.get(color))
			.getDefaultState()
			.method_11657(field_11177, state.method_11654(field_11177))
			.method_11657(field_12508, state.method_11654(field_12508))
			.method_11657(FACE, state.method_11654(FACE));
	}

	public static class_1767 colorOf(class_2680 blockState) {
		return blockState.method_26204() instanceof NixieTubeBlock ? ((NixieTubeBlock) blockState.method_26204()).color
			: class_1767.field_7946;
	}

	public static class_2350 getFacing(class_2680 sideState) {
		return getConnectedDirection(sideState);
	}

}
