package com.simibubi.create.content.redstone.smartObserver;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.fluids.FluidTransportBehaviour;
import com.simibubi.create.content.kinetics.belt.behaviour.TransportedItemStackHandlerBehaviour;
import com.simibubi.create.content.logistics.funnel.FunnelBlockEntity;
import com.simibubi.create.content.redstone.DirectedDirectionalBlock;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.filtering.FilteringBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.inventory.InvManipulationBehaviour;
import com.simibubi.create.foundation.utility.Iterate;

import io.github.fabricators_of_create.porting_lib.block.ConnectableRedstoneBlock;
import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2738;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_3218;
import net.minecraft.class_5819;

public class SmartObserverBlock extends DirectedDirectionalBlock implements IBE<SmartObserverBlockEntity>, ConnectableRedstoneBlock {

	public static final class_2746 POWERED = class_2741.field_12484;

	public SmartObserverBlock(class_2251 properties) {
		super(properties);
		method_9590(method_9564().method_11657(POWERED, false));
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder.method_11667(POWERED));
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2680 state = method_9564();

		class_2350 preferredFacing = null;
		for (class_2350 face : context.method_7718()) {
			class_2338 offsetPos = context.method_8037()
				.method_10093(face);
			class_1937 world = context.method_8045();
			boolean canDetect = false;
			class_2586 blockEntity = world.method_8321(offsetPos);

			if (BlockEntityBehaviour.get(blockEntity, TransportedItemStackHandlerBehaviour.TYPE) != null)
				canDetect = true;
			else if (BlockEntityBehaviour.get(blockEntity, FluidTransportBehaviour.TYPE) != null)
				canDetect = true;
			else if (TransferUtil.getItemStorage(world, offsetPos, face.method_10153()) != null
					|| TransferUtil.getFluidStorage(world, offsetPos, face.method_10153()) != null)
				canDetect = true;
			else if (blockEntity instanceof FunnelBlockEntity)
				canDetect = true;

			if (canDetect) {
				preferredFacing = face;
				break;
			}
		}

		if (preferredFacing == null) {
			class_2350 facing = context.method_7715();
			preferredFacing = context.method_8036() != null && context.method_8036()
				.method_5715() ? facing : facing.method_10153();
		}

		if (preferredFacing.method_10166() == class_2351.field_11052) {
			state = state.method_11657(TARGET, preferredFacing == class_2350.field_11036 ? class_2738.field_12473 : class_2738.field_12475);
			preferredFacing = context.method_8042();
		}

		return state.method_11657(field_11177, preferredFacing);
	}

	@Override
	public boolean method_9506(class_2680 state) {
		return state.method_11654(POWERED);
	}

	@Override
	public int method_9524(class_2680 blockState, class_1922 blockAccess, class_2338 pos, class_2350 side) {
		return method_9506(blockState) && (side == null || side != getTargetDirection(blockState)
			.method_10153()) ? 15 : 0;
	}

	@Override
	public void method_9588(class_2680 state, class_3218 worldIn, class_2338 pos, class_5819 random) {
		worldIn.method_8652(pos, state.method_11657(POWERED, false), 2);
		worldIn.method_8452(pos, this);
	}

	@Override
	public boolean canConnectRedstone(class_2680 state, class_1922 world, class_2338 pos, class_2350 side) {
		return side != state.method_11654(field_11177)
			.method_10153();
	}

	@Override
	public void method_9536(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 newState, boolean isMoving) {
		IBE.onRemove(state, worldIn, pos, newState);
	}

	@Override
	public void method_9612(class_2680 state, class_1937 worldIn, class_2338 pos, class_2248 blockIn, class_2338 fromPos,
		boolean isMoving) {
		InvManipulationBehaviour behaviour = BlockEntityBehaviour.get(worldIn, pos, InvManipulationBehaviour.TYPE);
		if (behaviour != null)
			behaviour.onNeighborChanged(fromPos);
	}

	public void onFunnelTransfer(class_1937 world, class_2338 funnelPos, class_1799 transferred) {
		for (class_2350 direction : Iterate.directions) {
			class_2338 detectorPos = funnelPos.method_10093(direction);
			class_2680 detectorState = world.method_8320(detectorPos);
			if (!AllBlocks.SMART_OBSERVER.has(detectorState))
				continue;
			if (SmartObserverBlock.getTargetDirection(detectorState) != direction.method_10153())
				continue;
			withBlockEntityDo(world, detectorPos, be -> {
				FilteringBehaviour filteringBehaviour = BlockEntityBehaviour.get(be, FilteringBehaviour.TYPE);
				if (filteringBehaviour == null)
					return;
				if (!filteringBehaviour.test(transferred))
					return;
				be.activate(4);
			});
		}
	}

	@Override
	public Class<SmartObserverBlockEntity> getBlockEntityClass() {
		return SmartObserverBlockEntity.class;
	}

	@Override
	public class_2591<? extends SmartObserverBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.SMART_OBSERVER.get();
	}

}
