package com.simibubi.create.content.redstone.thresholdSwitch;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllItems;
import com.simibubi.create.content.redstone.DirectedDirectionalBlock;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.tterrag.registrate.fabric.EnvExecutor;

import io.github.fabricators_of_create.porting_lib.block.ConnectableRedstoneBlock;
import io.github.fabricators_of_create.porting_lib.transfer.TransferUtil;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2738;
import net.minecraft.class_2758;
import net.minecraft.class_3218;
import net.minecraft.class_3965;
import net.minecraft.class_4538;
import net.minecraft.class_5819;
import net.minecraft.class_746;

public class ThresholdSwitchBlock extends DirectedDirectionalBlock implements IBE<ThresholdSwitchBlockEntity>, ConnectableRedstoneBlock {

	public static final class_2758 LEVEL = class_2758.method_11867("level", 0, 5);

	public ThresholdSwitchBlock(class_2251 p_i48377_1_) {
		super(p_i48377_1_);
	}

	@Override
	public void method_9615(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 oldState, boolean isMoving) {
		updateObservedInventory(state, worldIn, pos);
	}

	private void updateObservedInventory(class_2680 state, class_4538 world, class_2338 pos) {
		withBlockEntityDo(world, pos, ThresholdSwitchBlockEntity::updateCurrentLevel);
	}

	@Override
	public boolean canConnectRedstone(class_2680 state, class_1922 world, class_2338 pos, class_2350 side) {
		return side != null && side.method_10153() != getTargetDirection(state);
	}

	@Override
	public boolean method_9506(class_2680 state) {
		return true;
	}

	@Override
	public int method_9524(class_2680 blockState, class_1922 blockAccess, class_2338 pos, class_2350 side) {
		if (side == getTargetDirection(blockState)
			.method_10153())
			return 0;
		return getBlockEntityOptional(blockAccess, pos).filter(ThresholdSwitchBlockEntity::isPowered)
			.map($ -> 15)
			.orElse(0);
	}

	@Override
	public void method_9588(class_2680 blockState, class_3218 world, class_2338 pos, class_5819 random) {
		getBlockEntityOptional(world, pos).ifPresent(ThresholdSwitchBlockEntity::updatePowerAfterDelay);
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder.method_11667(LEVEL));
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 worldIn, class_2338 pos, class_1657 player, class_1268 handIn,
		class_3965 hit) {
		if (AdventureUtil.isAdventure(player))
			return class_1269.field_5811;
		if (player != null && AllItems.WRENCH.isIn(player.method_5998(handIn)))
			return class_1269.field_5811;
		EnvExecutor.runWhenOn(EnvType.CLIENT,
			() -> () -> withBlockEntityDo(worldIn, pos, be -> this.displayScreen(be, player)));
		return class_1269.field_5812;
	}

	@Environment(value = EnvType.CLIENT)
	protected void displayScreen(ThresholdSwitchBlockEntity be, class_1657 player) {
		if (player instanceof class_746)
			ScreenOpener.open(new ThresholdSwitchScreen(be));
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2680 state = method_9564();

		class_2350 preferredFacing = null;
		for (class_2350 face : context.method_7718()) {
			class_2338 offsetPos = context.method_8037().method_10093(face);
			class_1937 world = context.method_8045();
			if (TransferUtil.getItemStorage(world, offsetPos, face.method_10153()) != null
					|| TransferUtil.getFluidStorage(world, offsetPos, face.method_10153()) != null) {
				preferredFacing = face;
				break;
			}
		}

		if (preferredFacing == null) {
			class_2350 facing = context.method_7715();
			preferredFacing = context.method_8036() != null && context.method_8036()
				.method_5715() ? facing : facing.method_10153();
		}

		if (preferredFacing.method_10166() == class_2351.field_11052) {
			state = state.method_11657(TARGET, preferredFacing == class_2350.field_11036 ? class_2738.field_12473 : class_2738.field_12475);
			preferredFacing = context.method_8042();
		}

		return state.method_11657(field_11177, preferredFacing);
	}

	@Override
	public Class<ThresholdSwitchBlockEntity> getBlockEntityClass() {
		return ThresholdSwitchBlockEntity.class;
	}

	@Override
	public class_2591<? extends ThresholdSwitchBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.THRESHOLD_SWITCH.get();
	}

}
