package com.simibubi.create.content.schematics;

import java.util.concurrent.TimeUnit;

import javax.annotation.Nullable;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2382;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2586;
import net.minecraft.class_3492;
import net.minecraft.class_3499;
import net.minecraft.class_7924;
import com.google.common.cache.Cache;
import com.google.common.cache.CacheBuilder;
import com.simibubi.create.content.contraptions.StructureTransform;
import com.simibubi.create.foundation.utility.WorldAttached;

public class SchematicInstances {

	private static final WorldAttached<Cache<Integer, SchematicWorld>> LOADED_SCHEMATICS = new WorldAttached<>($ -> CacheBuilder.newBuilder()
			.expireAfterAccess(5, TimeUnit.MINUTES)
			.build());

	public static void register() {}

	@Nullable
	public static SchematicWorld get(class_1937 world, class_1799 schematic) {
		Cache<Integer, SchematicWorld> map = LOADED_SCHEMATICS.get(world);
		int hash = getHash(schematic);
		SchematicWorld ifPresent = map.getIfPresent(hash);
		if (ifPresent != null)
			return ifPresent;
		SchematicWorld loadWorld = loadWorld(world, schematic);
		if (loadWorld == null)
			return null;
		map.put(hash, loadWorld);
		return loadWorld;
	}

	private static SchematicWorld loadWorld(class_1937 wrapped, class_1799 schematic) {
		if (schematic == null || !schematic.method_7985())
			return null;
		if (!schematic.method_7969()
			.method_10577("Deployed"))
			return null;

		class_3499 activeTemplate =
			SchematicItem.loadSchematic(wrapped.method_45448(class_7924.field_41254), schematic);

		if (activeTemplate.method_15160()
			.equals(class_2382.field_11176))
			return null;

		class_2338 anchor = class_2512.method_10691(schematic.method_7969()
			.method_10562("Anchor"));
		SchematicWorld world = new SchematicWorld(anchor, wrapped);
		class_3492 settings = SchematicItem.getSettings(schematic);
		activeTemplate.method_15172(world, anchor, anchor, settings, wrapped.method_8409(), class_2248.field_31028);

		StructureTransform transform = new StructureTransform(settings.method_15134(), class_2350.class_2351.field_11052,
			settings.method_15113(), settings.method_15114());
		for (class_2586 be : world.getBlockEntities())
			transform.apply(be);

		return world;
	}

	public static void clearHash(class_1799 schematic) {
		if (schematic == null || !schematic.method_7985())
			return;
		schematic.method_7969()
			.method_10551("SchematicHash");
	}

	public static int getHash(class_1799 schematic) {
		if (schematic == null || !schematic.method_7985())
			return -1;
		class_2487 tag = schematic.method_7969();
		if (!tag.method_10545("SchematicHash"))
			tag.method_10569("SchematicHash", tag.toString()
				.hashCode());
		return tag.method_10550("SchematicHash");
	}

}
