package com.simibubi.create.content.schematics.client;

import java.util.List;
import java.util.Vector;
import net.minecraft.class_1041;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1799;
import net.minecraft.class_1934;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_238;
import net.minecraft.class_2382;
import net.minecraft.class_2415;
import net.minecraft.class_243;
import net.minecraft.class_2470;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2520;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_332;
import net.minecraft.class_3492;
import net.minecraft.class_3499;
import net.minecraft.class_3965;
import net.minecraft.class_4587;
import net.minecraft.class_746;
import net.minecraft.class_7924;
import com.google.common.collect.ImmutableList;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllKeys;
import com.simibubi.create.AllPackets;
import com.simibubi.create.Create;
import com.simibubi.create.content.contraptions.StructureTransform;
import com.simibubi.create.content.schematics.SchematicInstances;
import com.simibubi.create.content.schematics.SchematicItem;
import com.simibubi.create.content.schematics.SchematicWorld;
import com.simibubi.create.content.schematics.client.tools.ToolType;
import com.simibubi.create.content.schematics.packet.SchematicPlacePacket;
import com.simibubi.create.content.schematics.packet.SchematicSyncPacket;
import com.simibubi.create.foundation.outliner.AABBOutline;
import com.simibubi.create.foundation.render.SuperRenderTypeBuffer;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.NBTHelper;

public class SchematicHandler {

	private String displayedSchematic;
	private SchematicTransformation transformation;
	private class_238 bounds;
	private boolean deployed;
	private boolean active;
	private ToolType currentTool;

	private static final int SYNC_DELAY = 10;
	private int syncCooldown;
	private int activeHotbarSlot;
	private class_1799 activeSchematicItem;
	private AABBOutline outline;

	private Vector<SchematicRenderer> renderers;
	private SchematicHotbarSlotOverlay overlay;
	private ToolSelectionScreen selectionScreen;

	public SchematicHandler() {
		renderers = new Vector<>(3);
		for (int i = 0; i < renderers.capacity(); i++)
			renderers.add(new SchematicRenderer());

		overlay = new SchematicHotbarSlotOverlay();
		currentTool = ToolType.DEPLOY;
		selectionScreen = new ToolSelectionScreen(ImmutableList.of(ToolType.DEPLOY), this::equip);
		transformation = new SchematicTransformation();
	}

	public void tick() {
		class_310 mc = class_310.method_1551();
		if (mc.field_1761.method_2920() == class_1934.field_9219) {
			if (active) {
				active = false;
				syncCooldown = 0;
				activeHotbarSlot = 0;
				activeSchematicItem = null;
				renderers.forEach(r -> r.setActive(false));
			}
			return;
		}

		if (activeSchematicItem != null && transformation != null)
			transformation.tick();

		class_746 player = mc.field_1724;
		class_1799 stack = findBlueprintInHand(player);
		if (stack == null) {
			active = false;
			syncCooldown = 0;
			if (activeSchematicItem != null && itemLost(player)) {
				activeHotbarSlot = 0;
				activeSchematicItem = null;
				renderers.forEach(r -> r.setActive(false));
			}
			return;
		}

		if (!active || !stack.method_7969()
			.method_10558("File")
			.equals(displayedSchematic))
			init(player, stack);
		if (!active)
			return;

		renderers.forEach(SchematicRenderer::tick);
		if (syncCooldown > 0)
			syncCooldown--;
		if (syncCooldown == 1)
			sync();

		selectionScreen.update();
		currentTool.getTool()
			.updateSelection();
	}

	private void init(class_746 player, class_1799 stack) {
		loadSettings(stack);
		displayedSchematic = stack.method_7969()
			.method_10558("File");
		active = true;
		if (deployed) {
			setupRenderer();
			ToolType toolBefore = currentTool;
			selectionScreen = new ToolSelectionScreen(ToolType.getTools(player.method_7337()), this::equip);
			if (toolBefore != null) {
				selectionScreen.setSelectedElement(toolBefore);
				equip(toolBefore);
			}
		} else
			selectionScreen = new ToolSelectionScreen(ImmutableList.of(ToolType.DEPLOY), this::equip);
	}

	private void setupRenderer() {
		class_1937 clientWorld = class_310.method_1551().field_1687;
		class_3499 schematic =
			SchematicItem.loadSchematic(clientWorld.method_45448(class_7924.field_41254), activeSchematicItem);
		class_2382 size = schematic.method_15160();
		if (size.equals(class_2382.field_11176))
			return;

		SchematicWorld w = new SchematicWorld(clientWorld);
		SchematicWorld wMirroredFB = new SchematicWorld(clientWorld);
		SchematicWorld wMirroredLR = new SchematicWorld(clientWorld);
		class_3492 placementSettings = new class_3492();
		StructureTransform transform;
		class_2338 pos;

		pos = class_2338.field_10980;

		try {
			schematic.method_15172(w, pos, pos, placementSettings, w.method_8409(), class_2248.field_31028);
		} catch (Exception e) {
			class_310.method_1551().field_1724.method_7353(Lang.translate("schematic.error")
				.component(), false);
			Create.LOGGER.error("Failed to load Schematic for Previewing", e);
			return;
		}

		placementSettings.method_15125(class_2415.field_11301);
		pos = class_2338.field_10980.method_10089(size.method_10263() - 1);
		schematic.method_15172(wMirroredFB, pos, pos, placementSettings, wMirroredFB.method_8409(), class_2248.field_31028);
		transform = new StructureTransform(placementSettings.method_15134(), class_2351.field_11052, class_2470.field_11467,
			placementSettings.method_15114());
		for (class_2586 be : wMirroredFB.getRenderedBlockEntities())
			transform.apply(be);

		placementSettings.method_15125(class_2415.field_11300);
		pos = class_2338.field_10980.method_10077(size.method_10260() - 1);
		schematic.method_15172(wMirroredLR, pos, pos, placementSettings, wMirroredFB.method_8409(), class_2248.field_31028);
		transform = new StructureTransform(placementSettings.method_15134(), class_2351.field_11052, class_2470.field_11467,
			placementSettings.method_15114());
		for (class_2586 be : wMirroredLR.getRenderedBlockEntities())
			transform.apply(be);

		renderers.get(0)
			.display(w);
		renderers.get(1)
			.display(wMirroredFB);
		renderers.get(2)
			.display(wMirroredLR);
	}

	public void render(class_4587 ms, SuperRenderTypeBuffer buffer, class_243 camera) {
		boolean present = activeSchematicItem != null;
		if (!active && !present)
			return;

		if (active) {
			ms.method_22903();
			currentTool.getTool()
				.renderTool(ms, buffer, camera);
			ms.method_22909();
		}

		ms.method_22903();
		transformation.applyTransformations(ms, camera);

		if (!renderers.isEmpty()) {
			float pt = AnimationTickHolder.getPartialTicks();
			boolean lr = transformation.getScaleLR()
				.getValue(pt) < 0;
			boolean fb = transformation.getScaleFB()
				.getValue(pt) < 0;
			if (lr && !fb)
				renderers.get(2)
					.render(ms, buffer);
			else if (fb && !lr)
				renderers.get(1)
					.render(ms, buffer);
			else
				renderers.get(0)
					.render(ms, buffer);
		}

		if (active)
			currentTool.getTool()
				.renderOnSchematic(ms, buffer);
		ms.method_22909();

	}

	public void updateRenderers() {
		for (SchematicRenderer renderer : renderers) {
			renderer.update();
		}
	}

	public void renderOverlay(class_332 graphics, float partialTicks, class_1041 window) {
		if (class_310.method_1551().field_1690.field_1842 || !active)
			return;
		if (activeSchematicItem != null)
			this.overlay.renderOn(graphics, activeHotbarSlot);
		currentTool.getTool()
			.renderOverlay(graphics, partialTicks, window.method_4486(), window.method_4502());
		selectionScreen.renderPassive(graphics, partialTicks);
	}

	public boolean onMouseInput(int button, boolean pressed) {
		if (!active)
			return false;
		if (!pressed || button != 1)
			return false;
		class_310 mc = class_310.method_1551();
		if (mc.field_1724.method_5715())
			return false;
		if (mc.field_1765 instanceof class_3965) {
			class_3965 blockRayTraceResult = (class_3965) mc.field_1765;
			class_2680 clickedBlock = mc.field_1687.method_8320(blockRayTraceResult.method_17777());
			if (AllBlocks.SCHEMATICANNON.has(clickedBlock))
				return false;
			if (AllBlocks.DEPLOYER.has(clickedBlock))
				return false;
		}
		return currentTool.getTool()
			.handleRightClick();
	}

	public void onKeyInput(int key, boolean pressed) {
		if (!active)
			return;
		if (key != AllKeys.TOOL_MENU.getBoundCode())
			return;

		if (pressed && !selectionScreen.focused)
			selectionScreen.focused = true;
		if (!pressed && selectionScreen.focused) {
			selectionScreen.focused = false;
			selectionScreen.method_25419();
		}
	}

	public boolean mouseScrolled(double delta) {
		if (!active)
			return false;

		if (selectionScreen.focused) {
			selectionScreen.cycle((int) delta);
			return true;
		}
		if (AllKeys.ctrlDown())
			return currentTool.getTool()
				.handleMouseWheel(delta);
		return false;
	}

	private class_1799 findBlueprintInHand(class_1657 player) {
		class_1799 stack = player.method_6047();
		if (!AllItems.SCHEMATIC.isIn(stack))
			return null;
		if (!stack.method_7985())
			return null;

		activeSchematicItem = stack;
		activeHotbarSlot = player.method_31548().field_7545;
		return stack;
	}

	private boolean itemLost(class_1657 player) {
		for (int i = 0; i < class_1661.method_7368(); i++) {
			if (!class_1799.method_7973(player.method_31548()
				.method_5438(i), activeSchematicItem))
				continue;
			return false;
		}
		return true;
	}

	public void markDirty() {
		syncCooldown = SYNC_DELAY;
	}

	public void sync() {
		if (activeSchematicItem == null)
			return;
		AllPackets.getChannel().sendToServer(new SchematicSyncPacket(activeHotbarSlot, transformation.toSettings(),
			transformation.getAnchor(), deployed));
	}

	public void equip(ToolType tool) {
		this.currentTool = tool;
		currentTool.getTool()
			.init();
	}

	public void loadSettings(class_1799 blueprint) {
		class_2487 tag = blueprint.method_7969();
		class_2338 anchor = class_2338.field_10980;
		class_3492 settings = SchematicItem.getSettings(blueprint);
		transformation = new SchematicTransformation();

		deployed = tag.method_10577("Deployed");
		if (deployed)
			anchor = class_2512.method_10691(tag.method_10562("Anchor"));
		class_2382 size = NBTHelper.readVec3i(tag.method_10554("Bounds", class_2520.field_33253));

		bounds = new class_238(0, 0, 0, size.method_10263(), size.method_10264(), size.method_10260());
		outline = new AABBOutline(bounds);
		outline.getParams()
			.colored(0x6886c5)
			.lineWidth(1 / 16f);
		transformation.init(anchor, settings, bounds);
	}

	public void deploy() {
		if (!deployed) {
			List<ToolType> tools = ToolType.getTools(class_310.method_1551().field_1724.method_7337());
			selectionScreen = new ToolSelectionScreen(tools, this::equip);
		}
		deployed = true;
		setupRenderer();
	}

	public String getCurrentSchematicName() {
		return displayedSchematic != null ? displayedSchematic : "-";
	}

	public void printInstantly() {
		AllPackets.getChannel().sendToServer(new SchematicPlacePacket(activeSchematicItem.method_7972()));
		class_2487 nbt = activeSchematicItem.method_7969();
		nbt.method_10556("Deployed", false);
		activeSchematicItem.method_7980(nbt);
		SchematicInstances.clearHash(activeSchematicItem);
		renderers.forEach(r -> r.setActive(false));
		active = false;
		markDirty();
	}

	public boolean isActive() {
		return active;
	}

	public class_238 getBounds() {
		return bounds;
	}

	public SchematicTransformation getTransformation() {
		return transformation;
	}

	public boolean isDeployed() {
		return deployed;
	}

	public class_1799 getActiveSchematicItem() {
		return activeSchematicItem;
	}

	public AABBOutline getOutline() {
		return outline;
	}

}
