package com.simibubi.create.content.schematics.client;

import org.lwjgl.glfw.GLFW;

import com.simibubi.create.AllItems;
import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.gui.AbstractSimiScreen;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.gui.AllIcons;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import com.simibubi.create.foundation.gui.widget.IconButton;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;
import net.minecraft.class_2561;
import net.minecraft.class_332;
import net.minecraft.class_342;

public class SchematicPromptScreen extends AbstractSimiScreen {

	private AllGuiTextures background;

	private final class_2561 convertLabel = Lang.translateDirect("schematicAndQuill.convert");
	private final class_2561 abortLabel = Lang.translateDirect("action.discard");
	private final class_2561 confirmLabel = Lang.translateDirect("action.saveToFile");

	private class_342 nameField;
	private IconButton confirm;
	private IconButton abort;
	private IconButton convert;

	public SchematicPromptScreen() {
		super(Lang.translateDirect("schematicAndQuill.title"));
		background = AllGuiTextures.SCHEMATIC_PROMPT;
	}

	@Override
	public void method_25426() {
		setWindowSize(background.width, background.height);
		super.method_25426();

		int x = guiLeft;
		int y = guiTop;

		nameField = new class_342(field_22793, x + 49, y + 26, 131, 10, Components.immutableEmpty());
		nameField.method_1868(-1);
		nameField.method_1860(-1);
		nameField.method_1858(false);
		nameField.method_1880(35);
		nameField.method_25365(true);
		method_25395(nameField);
		method_37063(nameField);

		abort = new IconButton(x + 7, y + 53, AllIcons.I_TRASH);
		abort.withCallback(() -> {
			CreateClient.SCHEMATIC_AND_QUILL_HANDLER.discard();
			method_25419();
		});
		abort.setToolTip(abortLabel);
		method_37063(abort);

		confirm = new IconButton(x + 158, y + 53, AllIcons.I_CONFIRM);
		confirm.withCallback(() -> {
			confirm(false);
		});
		confirm.setToolTip(confirmLabel);
		method_37063(confirm);

		convert = new IconButton(x + 180, y + 53, AllIcons.I_SCHEMATIC);
		convert.withCallback(() -> {
			confirm(true);
		});
		convert.setToolTip(convertLabel);
		method_37063(convert);
	}

	@Override
	protected void renderWindow(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		int x = guiLeft;
		int y = guiTop;

		background.render(graphics, x, y);
		graphics.method_27534(field_22793, field_22785, x + (background.width - 8) / 2, y + 3, 0xFFFFFF);

		GuiGameElement.of(AllItems.SCHEMATIC.asStack())
				.at(x + 22, y + 23, 0)
				.render(graphics);

		GuiGameElement.of(AllItems.SCHEMATIC_AND_QUILL.asStack())
				.scale(3)
				.at(x + background.width + 6, y + background.height - 40, -200)
				.render(graphics);
	}

	@Override
	public boolean method_25404(int keyCode, int p_keyPressed_2_, int p_keyPressed_3_) {
		if (keyCode == GLFW.GLFW_KEY_ENTER) {
			confirm(false);
			return true;
		}
		if (keyCode == 256 && this.method_25422()) {
			this.method_25419();
			return true;
		}
		return nameField.method_25404(keyCode, p_keyPressed_2_, p_keyPressed_3_);
	}

	private void confirm(boolean convertImmediately) {
		CreateClient.SCHEMATIC_AND_QUILL_HANDLER.saveSchematic(nameField.method_1882(), convertImmediately);
		method_25419();
	}
}
