package com.simibubi.create.content.schematics.client.tools;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.AllKeys;
import com.simibubi.create.content.schematics.client.SchematicTransformation;
import com.simibubi.create.foundation.outliner.AABBOutline;
import com.simibubi.create.foundation.render.SuperRenderTypeBuffer;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_2512;
import net.minecraft.class_3532;
import net.minecraft.class_4587;

public class DeployTool extends PlacementToolBase {

	@Override
	public void init() {
		super.init();
		selectionRange = -1;
	}

	@Override
	public void updateSelection() {
		if (schematicHandler.isActive() && selectionRange == -1) {
			selectionRange = (int) (schematicHandler.getBounds()
				.method_1005()
				.method_1033() / 2);
			selectionRange = class_3532.method_15340(selectionRange, 1, 100);
		}
		selectIgnoreBlocks = AllKeys.ACTIVATE_TOOL.isPressed();
		super.updateSelection();
	}

	@Override
	public void renderTool(class_4587 ms, SuperRenderTypeBuffer buffer, class_243 camera) {
		super.renderTool(ms, buffer, camera);

		if (selectedPos == null)
			return;

		ms.method_22903();
		float pt = AnimationTickHolder.getPartialTicks();
		double x = class_3532.method_16436(pt, lastChasingSelectedPos.field_1352, chasingSelectedPos.field_1352);
		double y = class_3532.method_16436(pt, lastChasingSelectedPos.field_1351, chasingSelectedPos.field_1351);
		double z = class_3532.method_16436(pt, lastChasingSelectedPos.field_1350, chasingSelectedPos.field_1350);

		SchematicTransformation transformation = schematicHandler.getTransformation();
		class_238 bounds = schematicHandler.getBounds();
		class_243 center = bounds.method_1005();
		class_243 rotationOffset = transformation.getRotationOffset(true);
		int centerX = (int) center.field_1352;
		int centerZ = (int) center.field_1350;
		double xOrigin = bounds.method_17939() / 2f;
		double zOrigin = bounds.method_17941() / 2f;
		class_243 origin = new class_243(xOrigin, 0, zOrigin);

		ms.method_22904(x - centerX - camera.field_1352, y - camera.field_1351, z - centerZ - camera.field_1350);
		TransformStack.cast(ms)
			.translate(origin)
			.translate(rotationOffset)
			.rotateY(transformation.getCurrentRotation())
			.translateBack(rotationOffset)
			.translateBack(origin);

		AABBOutline outline = schematicHandler.getOutline();
		outline.render(ms, buffer, class_243.field_1353, pt);
		outline.getParams()
			.clearTextures();
		ms.method_22909();
	}

	@Override
	public boolean handleMouseWheel(double delta) {
		if (!selectIgnoreBlocks)
			return super.handleMouseWheel(delta);
		selectionRange += delta;
		selectionRange = class_3532.method_15340(selectionRange, 1, 100);
		return true;
	}

	@Override
	public boolean handleRightClick() {
		if (selectedPos == null)
			return super.handleRightClick();
		class_243 center = schematicHandler.getBounds()
			.method_1005();
		class_2338 target = selectedPos.method_10069(-((int) center.field_1352), 0, -((int) center.field_1350));

		class_1799 item = schematicHandler.getActiveSchematicItem();
		if (item != null) {
			item.method_7969()
				.method_10556("Deployed", true);
			item.method_7969()
				.method_10566("Anchor", class_2512.method_10692(target));
			schematicHandler.getTransformation()
				.startAt(target);
		}

		schematicHandler.getTransformation()
			.moveTo(target);
		schematicHandler.markDirty();
		schematicHandler.deploy();
		return true;
	}

}
