package com.simibubi.create.content.schematics.client.tools;

import com.simibubi.create.foundation.outliner.LineOutline;
import com.simibubi.create.foundation.render.SuperRenderTypeBuffer;
import com.simibubi.create.foundation.utility.AnimationTickHolder;
import net.minecraft.class_238;
import net.minecraft.class_243;
import net.minecraft.class_4587;

public class RotateTool extends PlacementToolBase {

	private LineOutline line = new LineOutline();

	@Override
	public boolean handleMouseWheel(double delta) {
		schematicHandler.getTransformation()
			.rotate90(delta > 0);
		schematicHandler.markDirty();
		return true;
	}

	@Override
	public void renderOnSchematic(class_4587 ms, SuperRenderTypeBuffer buffer) {
		class_238 bounds = schematicHandler.getBounds();
		double height = bounds.method_17940() + Math.max(20, bounds.method_17940());
		class_243 center = bounds.method_1005()
			.method_1019(schematicHandler.getTransformation()
				.getRotationOffset(false));
		class_243 start = center.method_1023(0, height / 2, 0);
		class_243 end = center.method_1031(0, height / 2, 0);

		line.getParams()
			.disableCull()
			.disableLineNormals()
			.colored(0xdddddd)
			.lineWidth(1 / 16f);
		line.set(start, end)
			.render(ms, buffer, class_243.field_1353, AnimationTickHolder.getPartialTicks());

		super.renderOnSchematic(ms, buffer);
	}

}
