package com.simibubi.create.content.schematics.packet;

import com.simibubi.create.content.schematics.SchematicPrinter;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.simibubi.create.foundation.utility.BlockHelper;
import com.simibubi.create.infrastructure.config.AllConfigs;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_3222;

public class SchematicPlacePacket extends SimplePacketBase {

	public class_1799 stack;

	public SchematicPlacePacket(class_1799 stack) {
		this.stack = stack;
	}

	public SchematicPlacePacket(class_2540 buffer) {
		stack = buffer.method_10819();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10793(stack);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (player == null)
				return;
			if (!player.method_7337())
				return;

			class_1937 world = player.method_37908();
			SchematicPrinter printer = new SchematicPrinter();
			printer.loadSchematic(stack, world, !player.method_7338());
			if (!printer.isLoaded() || printer.isErrored())
				return;

			boolean includeAir = AllConfigs.server().schematics.creativePrintIncludesAir.get();

			while (printer.advanceCurrentPos()) {
				if (!printer.shouldPlaceCurrent(world))
					continue;

				printer.handleCurrentTarget((pos, state, blockEntity) -> {
					boolean placingAir = state.method_26215();
					if (placingAir && !includeAir)
						return;

					class_2487 data = BlockHelper.prepareBlockEntityData(state, blockEntity);
					BlockHelper.placeSchematicBlock(world, state, pos, null, data);
				}, (pos, entity) -> {
					world.method_8649(entity);
				});
			}
		});
		return true;
	}

}
