package com.simibubi.create.content.schematics.packet;

import com.simibubi.create.AllItems;
import com.simibubi.create.content.schematics.SchematicInstances;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2415;
import net.minecraft.class_2470;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import net.minecraft.class_3492;

public class SchematicSyncPacket extends SimplePacketBase {

	public int slot;
	public boolean deployed;
	public class_2338 anchor;
	public class_2470 rotation;
	public class_2415 mirror;

	public SchematicSyncPacket(int slot, class_3492 settings,
			class_2338 anchor, boolean deployed) {
		this.slot = slot;
		this.deployed = deployed;
		this.anchor = anchor;
		this.rotation = settings.method_15113();
		this.mirror = settings.method_15114();
	}

	public SchematicSyncPacket(class_2540 buffer) {
		slot = buffer.method_10816();
		deployed = buffer.readBoolean();
		anchor = buffer.method_10811();
		rotation = buffer.method_10818(class_2470.class);
		mirror = buffer.method_10818(class_2415.class);
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10804(slot);
		buffer.writeBoolean(deployed);
		buffer.method_10807(anchor);
		buffer.method_10817(rotation);
		buffer.method_10817(mirror);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 player = context.getSender();
			if (player == null)
				return;
			class_1799 stack = class_1799.field_8037;
			if (slot == -1) {
				stack = player.method_6047();
			} else {
				stack = player.method_31548().method_5438(slot);
			}
			if (!AllItems.SCHEMATIC.isIn(stack)) {
				return;
			}
			class_2487 tag = stack.method_7948();
			tag.method_10556("Deployed", deployed);
			tag.method_10566("Anchor", class_2512.method_10692(anchor));
			tag.method_10582("Rotation", rotation.name());
			tag.method_10582("Mirror", mirror.name());
			SchematicInstances.clearHash(stack);
		});
		return true;
	}

}
