package com.simibubi.create.content.schematics.table;

import java.util.List;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1703;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_2561;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_3908;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.utility.IInteractionChecker;
import com.simibubi.create.foundation.utility.Lang;
import io.github.fabricators_of_create.porting_lib.transfer.item.ItemStackHandler;


public class SchematicTableBlockEntity extends SmartBlockEntity implements class_3908, IInteractionChecker {

	public SchematicTableInventory inventory;
	public boolean isUploading;
	public String uploadingSchematic;
	public float uploadingProgress;
	public boolean sendUpdate;

	public class SchematicTableInventory extends ItemStackHandler {
		public SchematicTableInventory() {
			super(2);
		}

		@Override
		protected void onContentsChanged(int slot) {
			super.onContentsChanged(slot);
			method_5431();
		}
	}

	public SchematicTableBlockEntity(class_2591<?> type, class_2338 pos, class_2680 state) {
		super(type, pos, state);
		inventory = new SchematicTableInventory();
		uploadingSchematic = null;
		uploadingProgress = 0;
	}

	public void sendToMenu(class_2540 buffer) {
		buffer.method_10807(method_11016());
		buffer.method_10794(method_16887());
	}

	@Override
	protected void read(class_2487 compound, boolean clientPacket) {
		inventory.deserializeNBT(compound.method_10562("Inventory"));
		super.read(compound, clientPacket);
		if (!clientPacket)
			return;
		if (compound.method_10545("Uploading")) {
			isUploading = true;
			uploadingSchematic = compound.method_10558("Schematic");
			uploadingProgress = compound.method_10583("Progress");
		} else {
			isUploading = false;
			uploadingSchematic = null;
			uploadingProgress = 0;
		}
	}

	@Override
	protected void write(class_2487 compound, boolean clientPacket) {
		compound.method_10566("Inventory", inventory.serializeNBT());
		super.write(compound, clientPacket);

		if (clientPacket && isUploading) {
			compound.method_10556("Uploading", true);
			compound.method_10582("Schematic", uploadingSchematic);
			compound.method_10548("Progress", uploadingProgress);
		}
	}

	@Override
	public void tick() {
		// Update Client block entity
		if (sendUpdate) {
			sendUpdate = false;
			field_11863.method_8413(field_11867, method_11010(), method_11010(), 6);
		}
	}

	public void startUpload(String schematic) {
		isUploading = true;
		uploadingProgress = 0;
		uploadingSchematic = schematic;
		sendUpdate = true;
		inventory.setStackInSlot(0, class_1799.field_8037);
	}

	public void finishUpload() {
		isUploading = false;
		uploadingProgress = 0;
		uploadingSchematic = null;
		sendUpdate = true;
	}

	@Override
	public class_1703 createMenu(int id, class_1661 inv, class_1657 player) {
		return SchematicTableMenu.create(id, inv, this);
	}

	@Override
	public class_2561 method_5476() {
		return Lang.translateDirect("gui.schematicTable.title");
	}

	@Override
	public boolean canPlayerUse(class_1657 player) {
		if (field_11863 == null || field_11863.method_8321(field_11867) != this) {
			return false;
		}
		return player.method_5649(field_11867.method_10263() + 0.5D, field_11867.method_10264() + 0.5D,
			field_11867.method_10260() + 0.5D) <= 64.0D;
	}

	@Override
	public void addBehaviours(List<BlockEntityBehaviour> behaviours) {}

}
