package com.simibubi.create.content.schematics.table;

import com.simibubi.create.AllItems;
import com.simibubi.create.AllMenuTypes;
import com.simibubi.create.foundation.gui.menu.MenuBase;

import io.github.fabricators_of_create.porting_lib.transfer.item.SlotItemHandler;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1735;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_2586;
import net.minecraft.class_310;
import net.minecraft.class_3917;
import net.minecraft.class_638;

public class SchematicTableMenu extends MenuBase<SchematicTableBlockEntity> {

	private class_1735 inputSlot;
	private class_1735 outputSlot;

	public SchematicTableMenu(class_3917<?> type, int id, class_1661 inv, class_2540 extraData) {
		super(type, id, inv, extraData);
	}

	public SchematicTableMenu(class_3917<?> type, int id, class_1661 inv, SchematicTableBlockEntity be) {
		super(type, id, inv, be);
	}

	public static SchematicTableMenu create(int id, class_1661 inv, SchematicTableBlockEntity be) {
		return new SchematicTableMenu(AllMenuTypes.SCHEMATIC_TABLE.get(), id, inv, be);
	}

	public boolean canWrite() {
		return inputSlot.method_7681() && !outputSlot.method_7681();
	}

	@Override
	public class_1799 method_7601(class_1657 playerIn, int index) {
		class_1735 clickedSlot = method_7611(index);
		if (!clickedSlot.method_7681())
			return class_1799.field_8037;

		class_1799 stack = clickedSlot.method_7677();
		if (index < 2)
			method_7616(stack, 2, field_7761.size(), false);
		else
			method_7616(stack, 0, 1, false);

		return class_1799.field_8037;
	}

	@Override
	protected SchematicTableBlockEntity createOnClient(class_2540 extraData) {
		class_638 world = class_310.method_1551().field_1687;
		class_2586 blockEntity = world.method_8321(extraData.method_10811());
		if (blockEntity instanceof SchematicTableBlockEntity schematicTable) {
			schematicTable.readClient(extraData.method_10798());
			return schematicTable;
		}
		return null;
	}

	@Override
	protected void initAndReadInventory(SchematicTableBlockEntity contentHolder) {
	}

	@Override
	protected void addSlots() {
		inputSlot = new SlotItemHandler(contentHolder.inventory, 0, 21, 57) {
			@Override
			public boolean method_7680(class_1799 stack) {
				return AllItems.EMPTY_SCHEMATIC.isIn(stack) || AllItems.SCHEMATIC_AND_QUILL.isIn(stack)
						|| AllItems.SCHEMATIC.isIn(stack);
			}
		};

		outputSlot = new SlotItemHandler(contentHolder.inventory, 1, 166, 57) {
			@Override
			public boolean method_7680(class_1799 stack) {
				return false;
			}
		};

		method_7621(inputSlot);
		method_7621(outputSlot);

		// player Slots
		for (int row = 0; row < 3; ++row) {
			for (int col = 0; col < 9; ++col) {
				this.method_7621(new class_1735(player.method_31548(), col + row * 9 + 9, 38 + col * 18, 105 + row * 18));
			}
		}

		for (int hotbarSlot = 0; hotbarSlot < 9; ++hotbarSlot) {
			this.method_7621(new class_1735(player.method_31548(), hotbarSlot, 38 + hotbarSlot * 18, 163));
		}
	}

	@Override
	protected void saveData(SchematicTableBlockEntity contentHolder) {
	}

}
