package com.simibubi.create.content.trains;

import com.mojang.blaze3d.platform.GlStateManager;
import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.AllSpecialTextures;
import io.github.fabricators_of_create.porting_lib.util.ParticleHelper;
import net.minecraft.class_1060;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_287;
import net.minecraft.class_289;
import net.minecraft.class_290;
import net.minecraft.class_293;
import net.minecraft.class_3532;
import net.minecraft.class_3999;
import net.minecraft.class_4184;
import net.minecraft.class_4588;
import net.minecraft.class_638;
import net.minecraft.class_703;
import net.minecraft.class_707;
import net.minecraft.class_765;

public class CubeParticle extends class_703 {

	public static final class_243[] CUBE = {
		// TOP
		new class_243(1, 1, -1), new class_243(1, 1, 1), new class_243(-1, 1, 1), new class_243(-1, 1, -1),

		// BOTTOM
		new class_243(-1, -1, -1), new class_243(-1, -1, 1), new class_243(1, -1, 1), new class_243(1, -1, -1),

		// FRONT
		new class_243(-1, -1, 1), new class_243(-1, 1, 1), new class_243(1, 1, 1), new class_243(1, -1, 1),

		// BACK
		new class_243(1, -1, -1), new class_243(1, 1, -1), new class_243(-1, 1, -1), new class_243(-1, -1, -1),

		// LEFT
		new class_243(-1, -1, -1), new class_243(-1, 1, -1), new class_243(-1, 1, 1), new class_243(-1, -1, 1),

		// RIGHT
		new class_243(1, -1, 1), new class_243(1, 1, 1), new class_243(1, 1, -1), new class_243(1, -1, -1) };

	private static final class_3999 RENDER_TYPE = new class_3999() {
		@Override
		public void method_18130(class_287 builder, class_1060 textureManager) {
			AllSpecialTextures.BLANK.bind();

			// transparent, additive blending
			RenderSystem.depthMask(false);
			RenderSystem.enableBlend();
			RenderSystem.blendFunc(GlStateManager.class_4535.ONE, GlStateManager.class_4534.ONE);

			// opaque
//			RenderSystem.depthMask(true);
//			RenderSystem.disableBlend();
//			RenderSystem.enableLighting();

			builder.method_1328(class_293.class_5596.field_27382, class_290.field_1584);
		}

		@Override
		public void method_18131(class_289 tessellator) {
			tessellator.method_1350();
			RenderSystem.blendFunc(GlStateManager.class_4535.SRC_ALPHA,
				GlStateManager.class_4534.ONE_MINUS_SRC_ALPHA);
		}
	};

	protected float scale;
	protected boolean hot;

	public CubeParticle(class_638 world, double x, double y, double z, double motionX, double motionY, double motionZ) {
		super(world, x, y, z);
		this.field_3852 = motionX;
		this.field_3869 = motionY;
		this.field_3850 = motionZ;

		setScale(0.2F);
	}

	public void setScale(float scale) {
		this.scale = scale;
		this.method_3080(scale * 0.5f, scale * 0.5f);
	}

	public void averageAge(int age) {
		this.field_3847 = (int) (age + (field_3840.method_43058() * 2D - 1D) * 8);
	}

	public void setHot(boolean hot) {
		this.hot = hot;
	}

	private boolean billowing = false;

	@Override
	public void method_3070() {
		if (this.hot && this.field_3866 > 0) {
			if (this.field_3838 == this.field_3854) {
				billowing = true;
				ParticleHelper.setStoppedByCollision(this, false); // Prevent motion being ignored due to vertical collision
				if (this.field_3852 == 0 && this.field_3850 == 0) {
					class_243 diff = class_243.method_24954(class_2338.method_49637(field_3874, field_3854, field_3871))
						.method_1031(0.5, 0.5, 0.5)
						.method_1023(field_3874, field_3854, field_3871);
					this.field_3852 = -diff.field_1352 * 0.1;
					this.field_3850 = -diff.field_1350 * 0.1;
				}
				this.field_3852 *= 1.1;
				this.field_3869 *= 0.9;
				this.field_3850 *= 1.1;
			} else if (billowing) {
				this.field_3869 *= 1.2;
			}
		}
		super.method_3070();
	}

	@Override
	public void method_3074(class_4588 builder, class_4184 renderInfo, float p_225606_3_) {
		class_243 projectedView = renderInfo.method_19326();
		float lerpedX = (float) (class_3532.method_16436(p_225606_3_, this.field_3858, this.field_3874) - projectedView.method_10216());
		float lerpedY = (float) (class_3532.method_16436(p_225606_3_, this.field_3838, this.field_3854) - projectedView.method_10214());
		float lerpedZ = (float) (class_3532.method_16436(p_225606_3_, this.field_3856, this.field_3871) - projectedView.method_10215());

		// int light = getBrightnessForRender(p_225606_3_);
		int light = class_765.field_32767;
		double ageMultiplier = 1 - Math.pow(class_3532.method_15363(field_3866 + p_225606_3_, 0, field_3847), 3) / Math.pow(field_3847, 3);

		for (int i = 0; i < 6; i++) {
			// 6 faces to a cube
			for (int j = 0; j < 4; j++) {
				class_243 vec = CUBE[i * 4 + j].method_1021(-1);
				vec = vec
					/* .rotate(?) */
					.method_1021(scale * ageMultiplier)
					.method_1031(lerpedX, lerpedY, lerpedZ);

				builder.method_22912(vec.field_1352, vec.field_1351, vec.field_1350)
					.method_22913(j / 2, j % 2)
					.method_22915(field_3861, field_3842, field_3859, field_3841)
					.method_22916(light)
					.method_1344();
			}
		}
	}

	@Override
	public class_3999 method_18122() {
		return RENDER_TYPE;
	}

	public static class Factory implements class_707<CubeParticleData> {

		@Override
		public class_703 createParticle(CubeParticleData data, class_638 world, double x, double y, double z, double motionX,
			double motionY, double motionZ) {
			CubeParticle particle = new CubeParticle(world, x, y, z, motionX, motionY, motionZ);
			particle.method_3084(data.r, data.g, data.b);
			particle.setScale(data.scale);
			particle.averageAge(data.avgAge);
			particle.setHot(data.hot);
			return particle;
		}
	}
}
