package com.simibubi.create.content.trains;

import com.simibubi.create.AllPackets;
import com.simibubi.create.content.contraptions.actors.trainControls.ControlsBlock;
import com.simibubi.create.content.contraptions.actors.trainControls.ControlsHandler;
import com.simibubi.create.content.trains.entity.Carriage;
import com.simibubi.create.content.trains.entity.CarriageContraptionEntity;
import com.simibubi.create.content.trains.entity.Train;
import com.simibubi.create.foundation.gui.AllGuiTextures;
import com.simibubi.create.foundation.placement.PlacementHelpers;
import com.simibubi.create.foundation.utility.AngleHelper;
import com.simibubi.create.foundation.utility.ControlsUtil;
import com.simibubi.create.foundation.utility.animation.LerpedFloat;
import com.simibubi.create.foundation.utility.animation.LerpedFloat.Chaser;
import com.simibubi.create.infrastructure.config.AllConfigs;
import net.minecraft.class_1041;
import net.minecraft.class_1297;
import net.minecraft.class_1934;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2561;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_332;
import net.minecraft.class_3499.class_3501;
import net.minecraft.class_3532;
import net.minecraft.class_4587;

public class TrainHUD {

	static LerpedFloat displayedSpeed = LerpedFloat.linear();
	static LerpedFloat displayedThrottle = LerpedFloat.linear();
	static LerpedFloat displayedPromptSize = LerpedFloat.linear();

	static Double editedThrottle = null;
	static int hudPacketCooldown = 5;
	static int honkPacketCooldown = 5;

	public static class_2561 currentPrompt;
	public static boolean currentPromptShadow;
	public static int promptKeepAlive = 0;

	static boolean usedToHonk;

	public static void tick() {
		if (promptKeepAlive > 0)
			promptKeepAlive--;
		else
			currentPrompt = null;

		class_310 mc = class_310.method_1551();
		displayedPromptSize.chase(currentPrompt != null ? mc.field_1772.method_27525(currentPrompt) + 17 : 0, .5f, Chaser.EXP);
		displayedPromptSize.tickChaser();

		Carriage carriage = getCarriage();
		if (carriage == null)
			return;

		Train train = carriage.train;
		double value =
			Math.abs(train.speed) / (train.maxSpeed() * AllConfigs.server().trains.manualTrainSpeedModifier.getF());
		value = class_3532.method_15350(value + 0.05f, 0, 1);

		displayedSpeed.chase((int) (value * 18) / 18f, .5f, Chaser.EXP);
		displayedSpeed.tickChaser();
		displayedThrottle.chase(editedThrottle != null ? editedThrottle : train.throttle, .75f, Chaser.EXP);
		displayedThrottle.tickChaser();

		boolean isSprintKeyPressed = ControlsUtil.isActuallyPressed(mc.field_1690.field_1867);

		if (isSprintKeyPressed && honkPacketCooldown-- <= 0) {
			train.determineHonk(mc.field_1687);
			if (train.lowHonk != null) {
				AllPackets.getChannel().sendToServer(new HonkPacket.Serverbound(train, true));
				honkPacketCooldown = 5;
				usedToHonk = true;
			}
		}

		if (!isSprintKeyPressed && usedToHonk) {
			AllPackets.getChannel().sendToServer(new HonkPacket.Serverbound(train, false));
			honkPacketCooldown = 0;
			usedToHonk = false;
		}

		if (editedThrottle == null)
			return;
		if (class_3532.method_20390(editedThrottle, train.throttle)) {
			editedThrottle = null;
			hudPacketCooldown = 5;
			return;
		}

		if (hudPacketCooldown-- <= 0) {
			AllPackets.getChannel().sendToServer(new TrainHUDUpdatePacket.Serverbound(train, editedThrottle));
			hudPacketCooldown = 5;
		}
	}

	private static Carriage getCarriage() {
		if (!(ControlsHandler.getContraption() instanceof CarriageContraptionEntity cce))
			return null;
		return cce.getCarriage();
	}

	public static void renderOverlay(class_332 graphics, float partialTicks, class_1041 window) {
		class_310 mc = class_310.method_1551();
		if (mc.field_1690.field_1842 || mc.field_1761.method_2920() == class_1934.field_9219)
			return;
		if (!(ControlsHandler.getContraption() instanceof CarriageContraptionEntity cce))
			return;
		Carriage carriage = cce.getCarriage();
		if (carriage == null)
			return;
		class_1297 cameraEntity = class_310.method_1551()
			.method_1560();
		if (cameraEntity == null)
			return;
		class_2338 localPos = ControlsHandler.getControlsPos();
		if (localPos == null)
			return;

		class_4587 poseStack = graphics.method_51448();
		poseStack.method_22903();
		poseStack.method_46416(window.method_4486() / 2 - 91, window.method_4502() - 29, 0);

		// Speed, Throttle

		AllGuiTextures.TRAIN_HUD_FRAME.render(graphics, -2, 1);
		AllGuiTextures.TRAIN_HUD_SPEED_BG.render(graphics, 0, 0);

		int w = (int) (AllGuiTextures.TRAIN_HUD_SPEED.width * displayedSpeed.getValue(partialTicks));
		int h = AllGuiTextures.TRAIN_HUD_SPEED.height;

		graphics.method_25291(AllGuiTextures.TRAIN_HUD_SPEED.location, 0, 0, 0, AllGuiTextures.TRAIN_HUD_SPEED.startX,
			AllGuiTextures.TRAIN_HUD_SPEED.startY, w, h, 256, 256);

		int promptSize = (int) displayedPromptSize.getValue(partialTicks);
		if (promptSize > 1) {

			poseStack.method_22903();
			poseStack.method_46416(promptSize / -2f + 91, -27, 100);

			AllGuiTextures.TRAIN_PROMPT_L.render(graphics, -3, 0);
			AllGuiTextures.TRAIN_PROMPT_R.render(graphics, promptSize, 0);
			graphics.method_25291(AllGuiTextures.TRAIN_PROMPT.location, 0, 0, 0, AllGuiTextures.TRAIN_PROMPT.startX + (128 - promptSize / 2f),
				AllGuiTextures.TRAIN_PROMPT.startY, promptSize, AllGuiTextures.TRAIN_PROMPT.height, 256, 256);

			poseStack.method_22909();

			class_327 font = mc.field_1772;
			if (currentPrompt != null && font.method_27525(currentPrompt) < promptSize - 10) {
				poseStack.method_22903();
				poseStack.method_46416(font.method_27525(currentPrompt) / -2f + 82, -27, 100);
				if (currentPromptShadow)
					graphics.method_27535(font, currentPrompt, 9, 4, 0x544D45);
				else
					graphics.method_51439(font, currentPrompt, 9, 4, 0x544D45, false);
				poseStack.method_22909();
			}
		}

		AllGuiTextures.TRAIN_HUD_DIRECTION.render(graphics, 77, -20);

		w = (int) (AllGuiTextures.TRAIN_HUD_THROTTLE.width * (1 - displayedThrottle.getValue(partialTicks)));
		int invW = AllGuiTextures.TRAIN_HUD_THROTTLE.width - w;
		graphics.method_25291(AllGuiTextures.TRAIN_HUD_THROTTLE.location, invW, 0, 0, AllGuiTextures.TRAIN_HUD_THROTTLE.startX + invW,
			AllGuiTextures.TRAIN_HUD_THROTTLE.startY, w, h, 256, 256);
		AllGuiTextures.TRAIN_HUD_THROTTLE_POINTER.render(graphics,
			Math.max(1, AllGuiTextures.TRAIN_HUD_THROTTLE.width - w) - 3, -2);

		// Direction

		class_3501 info = cce.getContraption()
			.getBlocks()
			.get(localPos);
		class_2350 initialOrientation = cce.getInitialOrientation()
			.method_10160();
		boolean inverted = false;
		if (info != null && info.comp_1342().method_28498(ControlsBlock.field_11177))
			inverted = !info.comp_1342().method_11654(ControlsBlock.field_11177)
				.equals(initialOrientation);

		boolean reversing = ControlsHandler.currentlyPressed.contains(1);
		inverted ^= reversing;
		int angleOffset = (ControlsHandler.currentlyPressed.contains(2) ? -45 : 0)
			+ (ControlsHandler.currentlyPressed.contains(3) ? 45 : 0);
		if (reversing)
			angleOffset *= -1;

		float snapSize = 22.5f;
		float diff = AngleHelper.getShortestAngleDiff(cameraEntity.method_36454(), cce.yaw) + (inverted ? -90 : 90);
		if (Math.abs(diff) < 60)
			diff = 0;

		float angle = diff + angleOffset;
		float snappedAngle = (snapSize * Math.round(angle / snapSize)) % 360f;

		poseStack.method_46416(91, -9, 0);
		poseStack.method_22905(0.925f, 0.925f, 1);
		PlacementHelpers.textured(poseStack, 0, 0, 1, snappedAngle);

		poseStack.method_22909();
	}

	public static boolean onScroll(double delta) {
		Carriage carriage = getCarriage();
		if (carriage == null)
			return false;

		double prevThrottle = editedThrottle == null ? carriage.train.throttle : editedThrottle;
		editedThrottle = class_3532.method_15350(prevThrottle + (delta > 0 ? 1 : -1) / 18f, 1 / 18f, 1);
		return true;
	}

}
