package com.simibubi.create.content.trains.bogey;

import java.util.Optional;
import net.minecraft.class_1920;
import net.minecraft.class_1944;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_4587;
import com.jozufozu.flywheel.api.MaterialManager;
import com.jozufozu.flywheel.util.AnimationTickHolder;
import com.simibubi.create.content.trains.entity.CarriageBogey;
import com.simibubi.create.content.trains.entity.CarriageContraptionEntity;

public final class BogeyInstance {
	private final BogeySizes.BogeySize size;
	private final BogeyStyle style;

	public final CarriageBogey bogey;
	public final BogeyRenderer renderer;
	public final Optional<BogeyRenderer.CommonRenderer> commonRenderer;

	public BogeyInstance(CarriageBogey bogey, BogeyStyle style, BogeySizes.BogeySize size,
		MaterialManager materialManager) {
		this.bogey = bogey;
		this.size = size;
		this.style = style;

		this.renderer = this.style.createRendererInstance(this.size);
		this.commonRenderer = this.style.getNewCommonRenderInstance();

		commonRenderer.ifPresent(bogeyRenderer -> bogeyRenderer.initialiseContraptionModelData(materialManager, bogey));
		renderer.initialiseContraptionModelData(materialManager, bogey);
	}

	public void beginFrame(float wheelAngle, class_4587 ms) {
		if (ms == null) {
			renderer.emptyTransforms();
			return;
		}

		commonRenderer.ifPresent(bogeyRenderer -> bogeyRenderer.render(bogey.bogeyData, wheelAngle, ms));
		renderer.render(bogey.bogeyData, wheelAngle, ms);
	}

	public void updateLight(class_1920 world, CarriageContraptionEntity entity) {
		var lightPos = class_2338.method_49638(getLightPos(entity));
		commonRenderer
			.ifPresent(bogeyRenderer -> bogeyRenderer.updateLight(world.method_8314(class_1944.field_9282, lightPos),
				world.method_8314(class_1944.field_9284, lightPos)));
		renderer.updateLight(world.method_8314(class_1944.field_9282, lightPos),
			world.method_8314(class_1944.field_9284, lightPos));
	}

	private class_243 getLightPos(CarriageContraptionEntity entity) {
		return bogey.getAnchorPosition() != null ? bogey.getAnchorPosition()
			: entity.method_31166(AnimationTickHolder.getPartialTicks());
	}

	@FunctionalInterface
	interface BogeyInstanceFactory {
		BogeyInstance create(CarriageBogey bogey, BogeySizes.BogeySize size, MaterialManager materialManager);
	}
}
