package com.simibubi.create.content.trains.display;

import static net.minecraft.class_2741.field_12508;

import java.util.List;
import java.util.function.Predicate;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1767;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2338.class_2339;
import net.minecraft.class_2350;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2520;
import net.minecraft.class_2561;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_3218;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_3737;
import net.minecraft.class_3965;
import net.minecraft.class_5819;
import net.minecraft.class_6328;
import net.minecraft.class_6756;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllShapes;
import com.simibubi.create.content.equipment.clipboard.ClipboardEntry;
import com.simibubi.create.content.equipment.wrench.IWrenchable;
import com.simibubi.create.content.kinetics.base.HorizontalKineticBlock;
import com.simibubi.create.content.kinetics.base.KineticBlockEntity;
import com.simibubi.create.content.kinetics.simpleRelays.ICogWheel;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.placement.IPlacementHelper;
import com.simibubi.create.foundation.placement.PlacementHelpers;
import com.simibubi.create.foundation.placement.PlacementOffset;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Iterate;

import io.github.fabricators_of_create.porting_lib.util.TagUtil;

public class FlapDisplayBlock extends HorizontalKineticBlock
	implements IBE<FlapDisplayBlockEntity>, IWrenchable, ICogWheel, class_3737 {

	public static final class_2746 UP = class_2746.method_11825("up");
	public static final class_2746 DOWN = class_2746.method_11825("down");

	public FlapDisplayBlock(class_2251 p_49795_) {
		super(p_49795_);
		method_9590(method_9564().method_11657(UP, false)
			.method_11657(DOWN, false)
			.method_11657(field_12508, false));
	}

	@Override
	protected boolean areStatesKineticallyEquivalent(class_2680 oldState, class_2680 newState) {
		return super.areStatesKineticallyEquivalent(oldState, newState);
	}

	@Override
	public class_2351 getRotationAxis(class_2680 state) {
		return state.method_11654(HORIZONTAL_FACING)
			.method_10166();
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder.method_11667(UP, DOWN, field_12508));
	}

	@Override
	public SpeedLevel getMinimumRequiredSpeedLevel() {
		return SpeedLevel.MEDIUM;
	}

	@Override
	public class_2680 method_9605(class_1750 context) {
		class_2350 face = context.method_8038();
		class_2338 clickedPos = context.method_8037();
		class_2338 placedOnPos = clickedPos.method_10093(face.method_10153());
		class_1937 level = context.method_8045();
		class_2680 blockState = level.method_8320(placedOnPos);
		class_2680 stateForPlacement = method_9564();
		class_3610 ifluidstate = context.method_8045()
			.method_8316(context.method_8037());

		if ((blockState.method_26204() != this) || (context.method_8036() != null && context.method_8036()
			.method_5715()))
			stateForPlacement = super.method_9605(context);
		else {
			class_2350 otherFacing = blockState.method_11654(HORIZONTAL_FACING);
			stateForPlacement = stateForPlacement.method_11657(HORIZONTAL_FACING, otherFacing);
		}

		return updateColumn(level, clickedPos,
			stateForPlacement.method_11657(field_12508, Boolean.valueOf(ifluidstate.method_15772() == class_3612.field_15910)), true);
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand,
		class_3965 ray) {

		if (player.method_5715() || AdventureUtil.isAdventure(player))
			return class_1269.field_5811;

		class_1799 heldItem = player.method_5998(hand);

		IPlacementHelper placementHelper = PlacementHelpers.get(placementHelperId);
		if (placementHelper.matchesItem(heldItem))
			return placementHelper.getOffset(player, world, state, pos, ray)
				.placeInWorld(world, (class_1747) heldItem.method_7909(), player, hand, ray);

		FlapDisplayBlockEntity flapBE = getBlockEntity(world, pos);

		if (flapBE == null)
			return class_1269.field_5811;
		flapBE = flapBE.getController();
		if (flapBE == null)
			return class_1269.field_5811;

		double yCoord = ray.method_17784()
			.method_1019(class_243.method_24954(ray.method_17780()
				.method_10153()
				.method_10163())
				.method_1021(.125f)).field_1351;

		int lineIndex = flapBE.getLineIndexAt(yCoord);

		if (heldItem.method_7960()) {
			if (!flapBE.isSpeedRequirementFulfilled())
				return class_1269.field_5811;
			flapBE.applyTextManually(lineIndex, null);
			return class_1269.field_5812;
		}

		if (heldItem.method_7909() == class_1802.field_28410) {
			if (!world.field_9236) {
				world.method_8396(null, pos, class_3417.field_28397, class_3419.field_15245, 1.0F, 1.0F);
				flapBE.setGlowing(lineIndex);
			}
			return class_1269.field_5812;
		}

		boolean display =
			heldItem.method_7909() == class_1802.field_8448 && heldItem.method_7938() || AllBlocks.CLIPBOARD.isIn(heldItem);
		class_1767 dye = TagUtil.getColorFromStack(heldItem);

		if (!display && dye == null)
			return class_1269.field_5811;
		if (dye == null && !flapBE.isSpeedRequirementFulfilled())
			return class_1269.field_5811;
		if (world.field_9236)
			return class_1269.field_5812;

		class_2487 tag = heldItem.method_7941("display");
		String tagElement = tag != null && tag.method_10573("Name", class_2520.field_33258) ? tag.method_10558("Name") : null;

		if (display) {
			if (AllBlocks.CLIPBOARD.isIn(heldItem)) {
				List<ClipboardEntry> entries = ClipboardEntry.getLastViewedEntries(heldItem);
				int line = lineIndex;
				for (int i = 0; i < entries.size(); i++) {
					for (String string : entries.get(i).text.getString()
						.split("\n"))
						flapBE.applyTextManually(line++, class_2561.class_2562.method_10867(Components.literal(string)));
				}
				return class_1269.field_5812;
			}

			flapBE.applyTextManually(lineIndex, tagElement);
		}
		if (dye != null) {
			world.method_8396(null, pos, class_3417.field_28391, class_3419.field_15245, 1.0F, 1.0F);
			flapBE.setColour(lineIndex, dye);
		}

		return class_1269.field_5812;
	}

	@Override
	public class_265 method_9530(class_2680 pState, class_1922 pLevel, class_2338 pPos, class_3726 pContext) {
		return AllShapes.FLAP_DISPLAY.get(pState.method_11654(HORIZONTAL_FACING));
	}

	@Override
	public Class<FlapDisplayBlockEntity> getBlockEntityClass() {
		return FlapDisplayBlockEntity.class;
	}

	@Override
	public class_2591<? extends FlapDisplayBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.FLAP_DISPLAY.get();
	}

	@Override
	public float getParticleTargetRadius() {
		return .85f;
	}

	@Override
	public float getParticleInitialRadius() {
		return .75f;
	}

	private class_2680 updateColumn(class_1937 level, class_2338 pos, class_2680 state, boolean present) {
		class_2339 currentPos = new class_2339();
		class_2351 axis = getConnectionAxis(state);

		for (class_2350 connection : Iterate.directionsInAxis(class_2351.field_11052)) {
			boolean connect = true;

			Move: for (class_2350 movement : Iterate.directionsInAxis(axis)) {
				currentPos.method_10101(pos);
				for (int i = 0; i < 1000; i++) {
					if (!level.method_8477(currentPos))
						break;

					class_2680 other1 = currentPos.equals(pos) ? state : level.method_8320(currentPos);
					class_2680 other2 = level.method_8320(currentPos.method_10093(connection));
					boolean col1 = canConnect(state, other1);
					boolean col2 = canConnect(state, other2);
					currentPos.method_10098(movement);

					if (!col1 && !col2)
						break;
					if (col1 && col2)
						continue;

					connect = false;
					break Move;
				}
			}
			state = setConnection(state, connection, connect);
		}
		return state;
	}

	@Override
	public void method_9615(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_2680 pOldState, boolean pIsMoving) {
		super.method_9615(pState, pLevel, pPos, pOldState, pIsMoving);
		if (pOldState.method_26204() == this)
			return;
		class_6756<class_2248> blockTicks = pLevel.method_8397();
		if (!blockTicks.method_8674(pPos, this))
			pLevel.method_39279(pPos, this, 1);
	}

	@Override
	public void method_9588(class_2680 pState, class_3218 pLevel, class_2338 pPos, class_5819 pRandom) {
		if (pState.method_26204() != this)
			return;
		class_2338 belowPos =
			pPos.method_10093(class_2350.method_10169(getConnectionAxis(pState), class_2352.field_11060));
		class_2680 belowState = pLevel.method_8320(belowPos);
		if (!canConnect(pState, belowState))
			KineticBlockEntity.switchToBlockState(pLevel, pPos, updateColumn(pLevel, pPos, pState, true));
		withBlockEntityDo(pLevel, pPos, FlapDisplayBlockEntity::updateControllerStatus);
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 pDirection, class_2680 pNeighborState,
		class_1936 pLevel, class_2338 pCurrentPos, class_2338 pNeighborPos) {
		return updatedShapeInner(state, pDirection, pNeighborState, pLevel, pCurrentPos);
	}

	private class_2680 updatedShapeInner(class_2680 state, class_2350 pDirection, class_2680 pNeighborState,
		class_1936 pLevel, class_2338 pCurrentPos) {
		if (state.method_11654(class_2741.field_12508))
			pLevel.method_39281(pCurrentPos, class_3612.field_15910, class_3612.field_15910.method_15789(pLevel));
		if (!canConnect(state, pNeighborState))
			return setConnection(state, pDirection, false);
		if (pDirection.method_10166() == getConnectionAxis(state))
			return method_34725(pNeighborState).method_11657(field_12508, state.method_11654(field_12508));
		return setConnection(state, pDirection, getConnection(pNeighborState, pDirection.method_10153()));
	}

	@Override
	public class_3610 method_9545(class_2680 state) {
		return state.method_11654(class_2741.field_12508) ? class_3612.field_15910.method_15729(false)
			: class_3612.field_15906.method_15785();
	}

	protected boolean canConnect(class_2680 state, class_2680 other) {
		return other.method_26204() == this && state.method_11654(HORIZONTAL_FACING) == other.method_11654(HORIZONTAL_FACING);
	}

	protected class_2351 getConnectionAxis(class_2680 state) {
		return state.method_11654(HORIZONTAL_FACING)
			.method_10170()
			.method_10166();
	}

	public static boolean getConnection(class_2680 state, class_2350 side) {
		class_2746 property = side == class_2350.field_11033 ? DOWN : side == class_2350.field_11036 ? UP : null;
		return property != null && state.method_11654(property);
	}

	public static class_2680 setConnection(class_2680 state, class_2350 side, boolean connect) {
		class_2746 property = side == class_2350.field_11033 ? DOWN : side == class_2350.field_11036 ? UP : null;
		if (property != null)
			state = state.method_11657(property, connect);
		return state;
	}

	@Override
	public void method_9536(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_2680 pNewState, boolean pIsMoving) {
		super.method_9536(pState, pLevel, pPos, pNewState, pIsMoving);
		if (pIsMoving || pNewState.method_26204() == this)
			return;
		for (class_2350 d : Iterate.directionsInAxis(getConnectionAxis(pState))) {
			class_2338 relative = pPos.method_10093(d);
			class_2680 adjacent = pLevel.method_8320(relative);
			if (canConnect(pState, adjacent))
				KineticBlockEntity.switchToBlockState(pLevel, relative,
					updateColumn(pLevel, relative, adjacent, false));
		}
	}

	private static final int placementHelperId = PlacementHelpers.register(new PlacementHelper());

	@class_6328
	private static class PlacementHelper implements IPlacementHelper {
		@Override
		public Predicate<class_1799> getItemPredicate() {
			return AllBlocks.DISPLAY_BOARD::isIn;
		}

		@Override
		public Predicate<class_2680> getStatePredicate() {
			return AllBlocks.DISPLAY_BOARD::has;
		}

		@Override
		public PlacementOffset getOffset(class_1657 player, class_1937 world, class_2680 state, class_2338 pos,
			class_3965 ray) {
			List<class_2350> directions = IPlacementHelper.orderedByDistanceExceptAxis(pos, ray.method_17784(),
				state.method_11654(FlapDisplayBlock.HORIZONTAL_FACING)
					.method_10166(),
				dir -> world.method_8320(pos.method_10093(dir))
					.method_45474());

			return directions.isEmpty() ? PlacementOffset.fail()
				: PlacementOffset.success(pos.method_10093(directions.get(0)), s -> AllBlocks.DISPLAY_BOARD.get()
					.updateColumn(world, pos.method_10093(directions.get(0)),
						s.method_11657(HORIZONTAL_FACING, state.method_11654(FlapDisplayBlock.HORIZONTAL_FACING)), true));
		}
	}

}
