package com.simibubi.create.content.trains.display;

import java.util.Arrays;
import java.util.List;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2520;
import org.apache.commons.lang3.mutable.MutableInt;

import com.simibubi.create.foundation.utility.NBTHelper;

public class FlapDisplayLayout {

	List<FlapDisplaySection> sections;
	String layoutKey;

	public FlapDisplayLayout(int maxCharCount) {
		loadDefault(maxCharCount);
	}

	public void loadDefault(int maxCharCount) {
		configure("Default", Arrays
			.asList(new FlapDisplaySection(maxCharCount * FlapDisplaySection.MONOSPACE, "alphabet", false, false)));
	}

	public boolean isLayout(String key) {
		return layoutKey.equals(key);
	}

	public void configure(String layoutKey, List<FlapDisplaySection> sections) {
		this.layoutKey = layoutKey;
		this.sections = sections;
	}

	public class_2487 write() {
		class_2487 tag = new class_2487();
		tag.method_10582("Key", layoutKey);
		tag.method_10566("Sections", NBTHelper.writeCompoundList(sections, FlapDisplaySection::write));
		return tag;
	};

	public void read(class_2487 tag) {
		String prevKey = layoutKey;
		layoutKey = tag.method_10558("Key");
		class_2499 sectionsTag = tag.method_10554("Sections", class_2520.field_33260);

		if (!prevKey.equals(layoutKey)) {
			sections = NBTHelper.readCompoundList(sectionsTag, FlapDisplaySection::load);
			return;
		}

		MutableInt index = new MutableInt(0);
		NBTHelper.iterateCompoundList(sectionsTag, nbt -> sections.get(index.getAndIncrement())
			.update(nbt));
	}

	public List<FlapDisplaySection> getSections() {
		return sections;
	}

}
