package com.simibubi.create.content.trains.entity;

import com.simibubi.create.Create;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import net.minecraft.class_1297;
import net.minecraft.class_2540;
import net.minecraft.class_310;

public class CarriageDataUpdatePacket extends SimplePacketBase {

	private int entity;
	private CarriageSyncData data;

	public CarriageDataUpdatePacket(CarriageContraptionEntity entity) {
		this.entity = entity.method_5628();
		this.data = entity.carriageData;
	}

	public CarriageDataUpdatePacket(class_2540 buf) {
		this.entity = buf.method_10816();
		this.data = new CarriageSyncData();
		this.data.read(buf);
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10804(entity);
		this.data.write(buffer);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_310 mc = class_310.method_1551();
			class_1297 entity = mc.field_1687.method_8469(this.entity);
			if (entity instanceof CarriageContraptionEntity carriage) {
				carriage.onCarriageDataUpdate(this.data);
			} else {
				Create.LOGGER.error("Invalid CarriageDataUpdatePacket for non-carriage entity: " + entity);
			}
		});
		return true;
	}
}
