package com.simibubi.create.content.trains.entity;

import java.util.HashMap;
import java.util.Map;

import com.simibubi.create.Create;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2960;
import net.minecraft.class_332;

public class TrainIconType {

	public static Map<class_2960, TrainIconType> REGISTRY = new HashMap<>();

	public static void register(class_2960 id, class_2960 sheet, int x, int y) {
		REGISTRY.put(id, new TrainIconType(id, sheet, x, y));
	}

	static {
		class_2960 sheet = Create.asResource("textures/gui/assemble.png");
		register(Create.asResource("traditional"), sheet, 2, 205);
		register(Create.asResource("electric"), sheet, 2, 216);
		register(Create.asResource("modern"), sheet, 2, 227);
	}

	class_2960 sheet;
	class_2960 id;
	int x, y;

	public TrainIconType(class_2960 id, class_2960 sheet, int x, int y) {
		this.id = id;
		this.sheet = sheet;
		this.x = x;
		this.y = y;
	}

	public static TrainIconType byId(class_2960 id) {
		return REGISTRY.getOrDefault(id, getDefault());
	}

	public static TrainIconType getDefault() {
		return REGISTRY.get(Create.asResource("traditional"));
	}

	public class_2960 getId() {
		return id;
	}

	public static final int ENGINE = -1;
	public static final int FLIPPED_ENGINE = -2;

	@Environment(EnvType.CLIENT)
	public int render(int lengthOrEngine, class_332 graphics, int x, int y) {
		int offset = getIconOffset(lengthOrEngine);
		int width = getIconWidth(lengthOrEngine);
		graphics.method_25291(sheet, x, y, 0, this.x + offset, this.y, width, 10, 256, 256);
		return width;
	}

	public int getIconWidth(int lengthOrEngine) {
		if (lengthOrEngine == FLIPPED_ENGINE)
			return 19;
		if (lengthOrEngine == ENGINE)
			return 19;
		if (lengthOrEngine < 3)
			return 7;
		if (lengthOrEngine < 9)
			return 13;
		return 19;
	}

	public int getIconOffset(int lengthOrEngine) {
		if (lengthOrEngine == FLIPPED_ENGINE)
			return 0;
		if (lengthOrEngine == ENGINE)
			return 62;
		if (lengthOrEngine < 3)
			return 34;
		if (lengthOrEngine < 9)
			return 20;
		return 42;
	}

}
