package com.simibubi.create.content.trains.entity;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import net.minecraft.class_2248;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_2561;
import net.minecraft.class_7923;
import com.simibubi.create.CreateClient;
import com.simibubi.create.content.trains.bogey.AbstractBogeyBlock;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.simibubi.create.foundation.utility.Couple;
import com.simibubi.create.foundation.utility.Iterate;
import com.simibubi.create.foundation.utility.RegisteredObjects;

public class TrainPacket extends SimplePacketBase {

	UUID trainId;
	Train train;
	boolean add;

	public TrainPacket(Train train, boolean add) {
		this.train = train;
		this.add = add;
	}

	public TrainPacket(class_2540 buffer) {
		add = buffer.readBoolean();
		trainId = buffer.method_10790();

		if (!add)
			return;

		UUID owner = null;
		if (buffer.readBoolean())
			owner = buffer.method_10790();

		List<Carriage> carriages = new ArrayList<>();
		List<Integer> carriageSpacing = new ArrayList<>();

		int size = buffer.method_10816();
		for (int i = 0; i < size; i++) {
			Couple<CarriageBogey> bogies = Couple.create(null, null);
			for (boolean isFirst : Iterate.trueAndFalse) {
				if (!isFirst && !buffer.readBoolean())
					continue;
				AbstractBogeyBlock<?> type = (AbstractBogeyBlock<?>) class_7923.field_41175.method_10223(buffer.method_10810());
				boolean upsideDown = buffer.readBoolean();
				class_2487 data = buffer.method_10798();
				bogies.set(isFirst, new CarriageBogey(type, upsideDown, data, new TravellingPoint(), new TravellingPoint()));
			}
			int spacing = buffer.method_10816();
			carriages.add(new Carriage(bogies.getFirst(), bogies.getSecond(), spacing));
		}

		size = buffer.method_10816();
		for (int i = 0; i < size; i++)
			carriageSpacing.add(buffer.method_10816());

		boolean doubleEnded = buffer.readBoolean();
		train = new Train(trainId, owner, null, carriages, carriageSpacing, doubleEnded);

		train.name = class_2561.class_2562.method_10877(buffer.method_19772());
		train.icon = TrainIconType.byId(buffer.method_10810());
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeBoolean(add);
		buffer.method_10797(train.id);

		if (!add)
			return;

		buffer.writeBoolean(train.owner != null);
		if (train.owner != null)
			buffer.method_10797(train.owner);

		buffer.method_10804(train.carriages.size());
		for (Carriage carriage : train.carriages) {
			for (boolean first : Iterate.trueAndFalse) {
				if (!first) {
					boolean onTwoBogeys = carriage.isOnTwoBogeys();
					buffer.writeBoolean(onTwoBogeys);
					if (!onTwoBogeys)
						continue;
				}
				CarriageBogey bogey = carriage.bogeys.get(first);
				buffer.method_10812(RegisteredObjects.getKeyOrThrow((class_2248) bogey.type));
				buffer.writeBoolean(bogey.upsideDown);
				buffer.method_10794(bogey.bogeyData);
			}
			buffer.method_10804(carriage.bogeySpacing);
		}

		buffer.method_10804(train.carriageSpacing.size());
		train.carriageSpacing.forEach(buffer::method_10804);

		buffer.writeBoolean(train.doubleEnded);
		buffer.method_10814(class_2561.class_2562.method_10867(train.name));
		buffer.method_10812(train.icon.id);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			Map<UUID, Train> trains = CreateClient.RAILWAYS.trains;
			if (add)
				trains.put(train.id, train);
			else
				trains.remove(trainId);
		});
		return true;
	}

}
