package com.simibubi.create.content.trains.entity;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.UUID;
import java.util.function.Consumer;

import javax.annotation.Nullable;

import org.apache.commons.lang3.mutable.MutableBoolean;
import org.apache.commons.lang3.mutable.MutableInt;

import com.simibubi.create.AllItems;
import com.simibubi.create.AllPackets;
import com.simibubi.create.Create;
import com.simibubi.create.CreateClient;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.content.contraptions.ContraptionHandlerClient;
import com.simibubi.create.content.trains.entity.TravellingPoint.IEdgePointListener;
import com.simibubi.create.content.trains.entity.TravellingPoint.ITrackSelector;
import com.simibubi.create.content.trains.entity.TravellingPoint.ITurnListener;
import com.simibubi.create.content.trains.entity.TravellingPoint.SteerDirection;
import com.simibubi.create.content.trains.graph.TrackEdge;
import com.simibubi.create.content.trains.graph.TrackGraph;
import com.simibubi.create.content.trains.graph.TrackGraphHelper;
import com.simibubi.create.content.trains.graph.TrackGraphLocation;
import com.simibubi.create.content.trains.graph.TrackNode;
import com.simibubi.create.content.trains.track.BezierTrackPointLocation;
import com.simibubi.create.content.trains.track.ITrackBlock;
import com.simibubi.create.content.trains.track.TrackBlockOutline;
import com.simibubi.create.content.trains.track.TrackBlockOutline.BezierPointSelection;
import com.simibubi.create.foundation.item.TooltipHelper;
import com.simibubi.create.foundation.utility.Couple;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.Pair;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_124;
import net.minecraft.class_1297;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_238;
import net.minecraft.class_239;
import net.minecraft.class_243;
import net.minecraft.class_2561;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_3965;
import net.minecraft.class_746;

public class TrainRelocator {

	static WeakReference<CarriageContraptionEntity> hoveredEntity = new WeakReference<>(null);
	static UUID relocatingTrain;
	static class_243 relocatingOrigin;
	static int relocatingEntityId;

	static class_2338 lastHoveredPos;
	static BezierTrackPointLocation lastHoveredBezierSegment;
	static Boolean lastHoveredResult;
	static List<class_243> toVisualise;

	public static boolean isRelocating() {
		return relocatingTrain != null;
	}

	@Environment(EnvType.CLIENT)
	public static boolean onClicked() {
		if (relocatingTrain == null)
			return false;

		class_310 mc = class_310.method_1551();
		class_746 player = mc.field_1724;
		if (player == null)
			return false;
		if (player.method_7325())
			return false;

		if (!player.method_19538()
			.method_24802(relocatingOrigin, 24) || player.method_5715()) {
			relocatingTrain = null;
			player.method_7353(Lang.translateDirect("train.relocate.abort")
				.method_27692(class_124.field_1061), true);
			return false;
		}

		if (player.method_5765())
			return false;
		if (mc.field_1687 == null)
			return false;
		Train relocating = getRelocating(mc.field_1687);
		if (relocating != null) {
			Boolean relocate = relocateClient(relocating, false);
			if (relocate != null && relocate.booleanValue())
				relocatingTrain = null;
			if (relocate != null)
				return true; // cancel
		}
		return false;
	}

	@Nullable
	@Environment(EnvType.CLIENT)
	public static Boolean relocateClient(Train relocating, boolean simulate) {
		class_310 mc = class_310.method_1551();
		class_239 hitResult = mc.field_1765;
		if (!(hitResult instanceof class_3965 blockhit))
			return null;

		class_2338 blockPos = blockhit.method_17777();
		BezierTrackPointLocation hoveredBezier = null;

		boolean upsideDown = relocating.carriages.get(0).leadingBogey().isUpsideDown();
		class_243 offset = upsideDown ? new class_243(0, -0.5, 0) : class_243.field_1353;

		if (simulate && toVisualise != null && lastHoveredResult != null) {
			for (int i = 0; i < toVisualise.size() - 1; i++) {
				class_243 vec1 = toVisualise.get(i).method_1019(offset);
				class_243 vec2 = toVisualise.get(i + 1).method_1019(offset);
				CreateClient.OUTLINER.showLine(Pair.of(relocating, i), vec1.method_1031(0, -.925f, 0), vec2.method_1031(0, -.925f, 0))
					.colored(lastHoveredResult || i != toVisualise.size() - 2 ? 0x95CD41 : 0xEA5C2B)
					.disableLineNormals()
					.lineWidth(i % 2 == 1 ? 1 / 6f : 1 / 4f);
			}
		}

		BezierPointSelection bezierSelection = TrackBlockOutline.result;
		if (bezierSelection != null) {
			blockPos = bezierSelection.blockEntity()
				.method_11016();
			hoveredBezier = bezierSelection.loc();
		}

		if (simulate) {
			if (lastHoveredPos != null && lastHoveredPos.equals(blockPos)
				&& Objects.equals(lastHoveredBezierSegment, hoveredBezier))
				return lastHoveredResult;
			lastHoveredPos = blockPos;
			lastHoveredBezierSegment = hoveredBezier;
			toVisualise = null;
		}

		class_2680 blockState = mc.field_1687.method_8320(blockPos);
		if (!(blockState.method_26204()instanceof ITrackBlock track))
			return lastHoveredResult = null;

		class_243 lookAngle = mc.field_1724.method_5720();
		boolean direction = bezierSelection != null && lookAngle.method_1026(bezierSelection.direction()) < 0;
		boolean result = relocate(relocating, mc.field_1687, blockPos, hoveredBezier, direction, lookAngle, true);
		if (!simulate && result) {
			relocating.carriages.forEach(c -> c.forEachPresentEntity(e -> e.nonDamageTicks = 10));
			AllPackets.getChannel().sendToServer(new TrainRelocationPacket(relocatingTrain, blockPos, hoveredBezier,
				direction, lookAngle, relocatingEntityId));
		}

		return lastHoveredResult = result;
	}

	public static boolean relocate(Train train, class_1937 level, class_2338 pos, BezierTrackPointLocation bezier,
		boolean bezierDirection, class_243 lookAngle, boolean simulate) {
		class_2680 blockState = level.method_8320(pos);
		if (!(blockState.method_26204()instanceof ITrackBlock track))
			return false;

		Pair<class_243, class_2352> nearestTrackAxis = track.getNearestTrackAxis(level, pos, blockState, lookAngle);
		TrackGraphLocation graphLocation = bezier != null
			? TrackGraphHelper.getBezierGraphLocationAt(level, pos,
				bezierDirection ? class_2352.field_11056 : class_2352.field_11060, bezier)
			: TrackGraphHelper.getGraphLocationAt(level, pos, nearestTrackAxis.getSecond(),
				nearestTrackAxis.getFirst());

		if (graphLocation == null)
			return false;

		TrackGraph graph = graphLocation.graph;
		TrackNode node1 = graph.locateNode(graphLocation.edge.getFirst());
		TrackNode node2 = graph.locateNode(graphLocation.edge.getSecond());
		TrackEdge edge = graph.getConnectionsFrom(node1)
			.get(node2);
		if (edge == null)
			return false;

		TravellingPoint probe = new TravellingPoint(node1, node2, edge, graphLocation.position, false);
		IEdgePointListener ignoreSignals = probe.ignoreEdgePoints();
		ITurnListener ignoreTurns = probe.ignoreTurns();
		List<Pair<Couple<TrackNode>, Double>> recordedLocations = new ArrayList<>();
		List<class_243> recordedVecs = new ArrayList<>();
		Consumer<TravellingPoint> recorder = tp -> {
			recordedLocations.add(Pair.of(Couple.create(tp.node1, tp.node2), tp.position));
			recordedVecs.add(tp.getPosition(graph));
		};
		ITrackSelector steer = probe.steer(SteerDirection.NONE, track.getUpNormal(level, pos, blockState));
		MutableBoolean blocked = new MutableBoolean(false);
		MutableBoolean portal = new MutableBoolean(false);

		MutableInt blockingIndex = new MutableInt(0);
		train.forEachTravellingPointBackwards((tp, d) -> {
			if (blocked.booleanValue())
				return;
			probe.travel(graph, d, steer, ignoreSignals, ignoreTurns, $ -> {
				portal.setTrue();
				return true;
			});
			recorder.accept(probe);
			if (probe.blocked || portal.booleanValue()) {
				blocked.setTrue();
				return;
			}
			blockingIndex.increment();
		});

		if (level.field_9236 && simulate && !recordedVecs.isEmpty()) {
			toVisualise = new ArrayList<>();
			toVisualise.add(recordedVecs.get(0));
		}

		for (int i = 0; i < recordedVecs.size() - 1; i++) {
			class_243 vec1 = recordedVecs.get(i);
			class_243 vec2 = recordedVecs.get(i + 1);
			boolean blocking = i >= blockingIndex.intValue() - 1;
			boolean collided =
				!blocked.booleanValue() && train.findCollidingTrain(level, vec1, vec2, level.method_27983()) != null;
			if (level.field_9236 && simulate)
				toVisualise.add(vec2);
			if (collided || blocking)
				return false;
		}

		if (blocked.booleanValue())
			return false;

		if (simulate)
			return true;

		train.leaveStation();
		train.derailed = false;
		train.navigation.waitingForSignal = null;
		train.occupiedSignalBlocks.clear();
		train.graph = graph;
		train.speed = 0;
		train.migratingPoints.clear();
		train.cancelStall();

		if (train.navigation.destination != null)
			train.navigation.cancelNavigation();

		train.forEachTravellingPoint(tp -> {
			Pair<Couple<TrackNode>, Double> last = recordedLocations.remove(recordedLocations.size() - 1);
			tp.node1 = last.getFirst()
				.getFirst();
			tp.node2 = last.getFirst()
				.getSecond();
			tp.position = last.getSecond();
			tp.edge = graph.getConnectionsFrom(tp.node1)
				.get(tp.node2);
		});

		for (Carriage carriage : train.carriages)
			carriage.updateContraptionAnchors();

		train.status.successfulMigration();
		train.collectInitiallyOccupiedSignalBlocks();
		return true;
	}

	@Environment(EnvType.CLIENT)
	public static void visualise(Train train, int i, class_243 v1, class_243 v2, boolean valid) {
		CreateClient.OUTLINER.showLine(Pair.of(train, i), v1.method_1031(0, -.825f, 0), v2.method_1031(0, -.825f, 0))
			.colored(valid ? 0x95CD41 : 0xEA5C2B)
			.disableLineNormals()
			.lineWidth(i % 2 == 1 ? 1 / 6f : 1 / 4f);
	}

	@Environment(EnvType.CLIENT)
	public static void clientTick() {
		class_310 mc = class_310.method_1551();
		class_746 player = mc.field_1724;

		if (player == null)
			return;
		if (player.method_5765())
			return;
		if (mc.field_1687 == null)
			return;

		if (relocatingTrain != null) {
			Train relocating = getRelocating(mc.field_1687);
			if (relocating == null) {
				relocatingTrain = null;
				return;
			}

			class_1297 entity = mc.field_1687.method_8469(relocatingEntityId);
			if (entity instanceof AbstractContraptionEntity ce && Math.abs(ce.method_30950(0)
				.method_1020(ce.method_30950(1))
				.method_1027()) > 1 / 1024d) {
				player.method_7353(Lang.translateDirect("train.cannot_relocate_moving")
					.method_27692(class_124.field_1061), true);
				relocatingTrain = null;
				return;
			}

			if (!AllItems.WRENCH.isIn(player.method_6047())) {
				player.method_7353(Lang.translateDirect("train.relocate.abort")
					.method_27692(class_124.field_1061), true);
				relocatingTrain = null;
				return;
			}

			if (!player.method_19538()
				.method_24802(relocatingOrigin, 24)) {
				player.method_7353(Lang.translateDirect("train.relocate.too_far")
					.method_27692(class_124.field_1061), true);
				return;
			}

			Boolean success = relocateClient(relocating, true);
			if (success == null)
				player.method_7353(Lang.translateDirect("train.relocate", relocating.name), true);
			else if (success.booleanValue())
				player.method_7353(Lang.translateDirect("train.relocate.valid")
					.method_27692(class_124.field_1060), true);
			else
				player.method_7353(Lang.translateDirect("train.relocate.invalid")
					.method_27692(class_124.field_1061), true);
			return;
		}

		Couple<class_243> rayInputs = ContraptionHandlerClient.getRayInputs(player);
		class_243 origin = rayInputs.getFirst();
		class_243 target = rayInputs.getSecond();

		CarriageContraptionEntity currentEntity = hoveredEntity.get();
		if (currentEntity != null) {
			if (ContraptionHandlerClient.rayTraceContraption(origin, target, currentEntity) != null)
				return;
			hoveredEntity = new WeakReference<>(null);
		}

		class_238 aabb = new class_238(origin, target);
		List<CarriageContraptionEntity> intersectingContraptions =
			mc.field_1687.method_18467(CarriageContraptionEntity.class, aabb);

		for (CarriageContraptionEntity contraptionEntity : intersectingContraptions) {
			if (ContraptionHandlerClient.rayTraceContraption(origin, target, contraptionEntity) == null)
				continue;
			hoveredEntity = new WeakReference<>(contraptionEntity);
		}
	}

	@Environment(EnvType.CLIENT)
	public static boolean carriageWrenched(class_243 vec3, CarriageContraptionEntity entity) {
		Train train = getTrainFromEntity(entity);
		if (train == null)
			return false;
		relocatingOrigin = vec3;
		relocatingTrain = train.id;
		relocatingEntityId = entity.method_5628();
		return true;
	}

	@Environment(EnvType.CLIENT)
	public static boolean addToTooltip(List<class_2561> tooltip, boolean shiftKeyDown) {
		Train train = getTrainFromEntity(hoveredEntity.get());
		if (train != null && train.derailed) {
			TooltipHelper.addHint(tooltip, "hint.derailed_train");
			return true;
		}
		return false;
	}

	@Environment(EnvType.CLIENT)
	private static Train getRelocating(class_1936 level) {
		return relocatingTrain == null ? null : Create.RAILWAYS.sided(level).trains.get(relocatingTrain);
	}

	private static Train getTrainFromEntity(CarriageContraptionEntity carriageContraptionEntity) {
		if (carriageContraptionEntity == null)
			return null;
		Carriage carriage = carriageContraptionEntity.getCarriage();
		if (carriage == null)
			return null;
		return carriage.train;
	}

}
