package com.simibubi.create.content.trains.graph;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_1937;
import net.minecraft.class_2487;
import net.minecraft.class_2520;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import net.minecraft.class_7924;
import com.simibubi.create.foundation.utility.NBTHelper;

public class DimensionPalette {

	List<class_5321<class_1937>> gatheredDims;

	public DimensionPalette() {
		gatheredDims = new ArrayList<>();
	}

	public int encode(class_5321<class_1937> dimension) {
		int indexOf = gatheredDims.indexOf(dimension);
		if (indexOf == -1) {
			indexOf = gatheredDims.size();
			gatheredDims.add(dimension);
		}
		return indexOf;
	}

	public class_5321<class_1937> decode(int index) {
		if (gatheredDims.size() <= index || index < 0)
			return class_1937.field_25179;
		return gatheredDims.get(index);
	}

	public void send(class_2540 buffer) {
		buffer.writeInt(gatheredDims.size());
		gatheredDims.forEach(rk -> buffer.method_10812(rk.method_29177()));
	}

	public static DimensionPalette receive(class_2540 buffer) {
		DimensionPalette palette = new DimensionPalette();
		int length = buffer.readInt();
		for (int i = 0; i < length; i++)
			palette.gatheredDims.add(class_5321.method_29179(class_7924.field_41223, buffer.method_10810()));
		return palette;
	}

	public void write(class_2487 tag) {
		tag.method_10566("DimensionPalette", NBTHelper.writeCompoundList(gatheredDims, rk -> {
			class_2487 c = new class_2487();
			c.method_10582("Id", rk.method_29177()
				.toString());
			return c;
		}));
	}

	public static DimensionPalette read(class_2487 tag) {
		DimensionPalette palette = new DimensionPalette();
		NBTHelper.iterateCompoundList(tag.method_10554("DimensionPalette", class_2520.field_33260), c -> palette.gatheredDims
			.add(class_5321.method_29179(class_7924.field_41223, new class_2960(c.method_10558("Id")))));
		return palette;
	}

}
