package com.simibubi.create.content.trains.graph;

import java.util.UUID;
import net.minecraft.class_2487;
import net.minecraft.class_2520;
import com.simibubi.create.foundation.utility.Couple;

public class TrackEdgeIntersection {

	public double location;
	public Couple<TrackNodeLocation> target;
	public double targetLocation;
	public UUID groupId;
	public UUID id;

	public TrackEdgeIntersection() {
		id = UUID.randomUUID();
	}

	public boolean isNear(double location) {
		return Math.abs(location - this.location) < 1 / 32f;
	}

	public boolean targets(TrackNodeLocation target1, TrackNodeLocation target2) {
		return target1.equals(target.getFirst()) && target2.equals(target.getSecond())
			|| target1.equals(target.getSecond()) && target2.equals(target.getFirst());
	}

	public class_2487 write(DimensionPalette dimensions) {
		class_2487 nbt = new class_2487();
		nbt.method_25927("Id", id);
		if (groupId != null)
			nbt.method_25927("GroupId", groupId);
		nbt.method_10549("Location", location);
		nbt.method_10549("TargetLocation", targetLocation);
		nbt.method_10566("TargetEdge", target.serializeEach(loc -> loc.write(dimensions)));
		return nbt;
	}

	public static TrackEdgeIntersection read(class_2487 nbt, DimensionPalette dimensions) {
		TrackEdgeIntersection intersection = new TrackEdgeIntersection();
		intersection.id = nbt.method_25926("Id");
		if (nbt.method_10545("GroupId"))
			intersection.groupId = nbt.method_25926("GroupId");
		intersection.location = nbt.method_10574("Location");
		intersection.targetLocation = nbt.method_10574("TargetLocation");
		intersection.target = Couple.deserializeEach(nbt.method_10554("TargetEdge", class_2520.field_33260),
			tag -> TrackNodeLocation.read(tag, dimensions));
		return intersection;
	}

}
