package com.simibubi.create.content.trains.schedule;

import java.util.List;

import com.simibubi.create.AllMenuTypes;
import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.content.contraptions.Contraption;
import com.simibubi.create.content.trains.entity.CarriageContraption;
import com.simibubi.create.content.trains.entity.CarriageContraptionEntity;
import com.simibubi.create.content.trains.entity.Train;
import com.simibubi.create.content.trains.schedule.destination.DestinationInstruction;
import com.simibubi.create.foundation.advancement.AllAdvancements;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Couple;
import com.simibubi.create.foundation.utility.Lang;

import io.github.fabricators_of_create.porting_lib.util.NetworkHooks;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_124;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1271;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1703;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1836;
import net.minecraft.class_1838;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2561;
import net.minecraft.class_3222;
import net.minecraft.class_3908;
import net.minecraft.class_5250;

public class ScheduleItem extends class_1792 implements class_3908 {

	public ScheduleItem(class_1793 pProperties) {
		super(pProperties);
	}

	@Override
	public class_1269 method_7884(class_1838 context) {
		if (context.method_8036() == null)
			return class_1269.field_5811;
		return method_7836(context.method_8045(), context.method_8036(), context.method_20287()).method_5467();
	}

	@Override
	public class_1271<class_1799> method_7836(class_1937 world, class_1657 player, class_1268 hand) {
		class_1799 heldItem = player.method_5998(hand);

		if (!player.method_5715() && hand == class_1268.field_5808) {
			if (!world.field_9236 && player instanceof class_3222)
				NetworkHooks.openScreen((class_3222) player, this, buf -> {
					buf.method_10793(heldItem);
				});
			return class_1271.method_22427(heldItem);
		}
		return class_1271.method_22430(heldItem);
	}

	public class_1269 handScheduleTo(class_1799 pStack, class_1657 pPlayer, class_1309 pInteractionTarget,
		class_1268 pUsedHand) {
		class_1269 pass = class_1269.field_5811;

		Schedule schedule = getSchedule(pStack);
		if (schedule == null)
			return pass;
		if (pInteractionTarget == null)
			return pass;
		class_1297 rootVehicle = pInteractionTarget.method_5668();
		if (!(rootVehicle instanceof CarriageContraptionEntity))
			return pass;
		if (pPlayer.method_37908().field_9236)
			return class_1269.field_5812;

		CarriageContraptionEntity entity = (CarriageContraptionEntity) rootVehicle;
		Contraption contraption = entity.getContraption();
		if (contraption instanceof CarriageContraption cc) {

			Train train = entity.getCarriage().train;
			if (train == null)
				return class_1269.field_5812;

			Integer seatIndex = contraption.getSeatMapping()
				.get(pInteractionTarget.method_5667());
			if (seatIndex == null)
				return class_1269.field_5812;
			class_2338 seatPos = contraption.getSeats()
				.get(seatIndex);
			Couple<Boolean> directions = cc.conductorSeats.get(seatPos);
			if (directions == null) {
				pPlayer.method_7353(Lang.translateDirect("schedule.non_controlling_seat"), true);
				AllSoundEvents.DENY.playOnServer(pPlayer.method_37908(), pPlayer.method_24515(), 1, 1);
				return class_1269.field_5812;
			}

			if (train.runtime.getSchedule() != null) {
				AllSoundEvents.DENY.playOnServer(pPlayer.method_37908(), pPlayer.method_24515(), 1, 1);
				pPlayer.method_7353(Lang.translateDirect("schedule.remove_with_empty_hand"), true);
				return class_1269.field_5812;
			}

			if (schedule.entries.isEmpty()) {
				AllSoundEvents.DENY.playOnServer(pPlayer.method_37908(), pPlayer.method_24515(), 1, 1);
				pPlayer.method_7353(Lang.translateDirect("schedule.no_stops"), true);
				return class_1269.field_5812;
			}

			train.runtime.setSchedule(schedule, false);
			AllAdvancements.CONDUCTOR.awardTo(pPlayer);
			AllSoundEvents.CONFIRM.playOnServer(pPlayer.method_37908(), pPlayer.method_24515(), 1, 1);
			pPlayer.method_7353(Lang.translateDirect("schedule.applied_to_train")
				.method_27692(class_124.field_1060), true);
			pStack.method_7934(1);
			pPlayer.method_6122(pUsedHand, pStack.method_7960() ? class_1799.field_8037 : pStack);
		}

		return class_1269.field_5812;
	}

	@Override
	@Environment(EnvType.CLIENT)
	public void method_7851(class_1799 stack, class_1937 worldIn, List<class_2561> tooltip, class_1836 flagIn) {
		Schedule schedule = getSchedule(stack);
		if (schedule == null || schedule.entries.isEmpty())
			return;

		class_5250 caret = Components.literal("> ").method_27692(class_124.field_1080);
		class_5250 arrow = Components.literal("-> ").method_27692(class_124.field_1080);

		List<ScheduleEntry> entries = schedule.entries;
		for (int i = 0; i < entries.size(); i++) {
			boolean current = i == schedule.savedProgress && schedule.entries.size() > 1;
			ScheduleEntry entry = entries.get(i);
			if (!(entry.instruction instanceof DestinationInstruction destination))
				continue;
			class_124 format = current ? class_124.field_1054 : class_124.field_1065;
			class_5250 prefix = current ? arrow : caret;
			tooltip.add(prefix.method_27661()
				.method_10852(Components.literal(destination.getFilter()).method_27692(format)));
		}
	}

	public static Schedule getSchedule(class_1799 pStack) {
		if (!pStack.method_7985())
			return null;
		if (!pStack.method_7969()
			.method_10545("Schedule"))
			return null;
		return Schedule.fromTag(pStack.method_7941("Schedule"));
	}

	@Override
	public class_1703 createMenu(int id, class_1661 inv, class_1657 player) {
		class_1799 heldItem = player.method_6047();
		return new ScheduleMenu(AllMenuTypes.SCHEDULE.get(), id, inv, heldItem);
	}

	@Override
	public class_2561 method_5476() {
		return method_7848();
	}

}
