package com.simibubi.create.content.trains.schedule;

import com.simibubi.create.foundation.utility.AdventureUtil;

import org.jetbrains.annotations.Nullable;

import com.simibubi.create.AllItems;
import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.content.contraptions.Contraption;
import com.simibubi.create.content.trains.entity.CarriageContraption;
import com.simibubi.create.content.trains.entity.CarriageContraptionEntity;
import com.simibubi.create.content.trains.entity.Train;
import com.simibubi.create.foundation.utility.Couple;
import com.simibubi.create.foundation.utility.Lang;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_3966;

public class ScheduleItemEntityInteraction {

	public static class_1269 interactWithConductor(class_1657 player, class_1937 world, class_1268 hand, class_1297 entity, @Nullable class_3966 hitResult) {
		if (player == null || entity == null)
			return class_1269.field_5811;
		if (player.method_7325() || AdventureUtil.isAdventure(player))
			return class_1269.field_5811;

		class_1297 rootVehicle = entity.method_5668();
		if (!(rootVehicle instanceof CarriageContraptionEntity))
			return class_1269.field_5811;
		if (!(entity instanceof class_1309 living))
			return class_1269.field_5811;
		if (player.method_7357()
			.method_7904(AllItems.SCHEDULE.get()))
			return class_1269.field_5811;

		class_1799 itemStack = player.method_5998(hand);
		if (itemStack.method_7909()instanceof ScheduleItem si) {
			class_1269 result = si.handScheduleTo(itemStack, player, living, hand);
			if (result.method_23665()) {
				player.method_7357()
					.method_7906(AllItems.SCHEDULE.get(), 5);
				return result;
			}
		}

		if (hand == class_1268.field_5810)
			return class_1269.field_5811;

		CarriageContraptionEntity cce = (CarriageContraptionEntity) rootVehicle;
		Contraption contraption = cce.getContraption();
		if (!(contraption instanceof CarriageContraption cc))
			return class_1269.field_5811;

		Train train = cce.getCarriage().train;
		if (train == null)
			return class_1269.field_5811;
		if (train.runtime.getSchedule() == null)
			return class_1269.field_5811;

		Integer seatIndex = contraption.getSeatMapping()
			.get(entity.method_5667());
		if (seatIndex == null)
			return class_1269.field_5811;
		class_2338 seatPos = contraption.getSeats()
			.get(seatIndex);
		Couple<Boolean> directions = cc.conductorSeats.get(seatPos);
		if (directions == null)
			return class_1269.field_5811;

		boolean onServer = !world.field_9236;

		if (train.runtime.paused && !train.runtime.completed) {
			if (onServer) {
				train.runtime.paused = false;
				AllSoundEvents.CONFIRM.playOnServer(player.method_37908(), player.method_24515(), 1, 1);
				player.method_7353(Lang.translateDirect("schedule.continued"), true);
			}

			player.method_7357()
				.method_7906(AllItems.SCHEDULE.get(), 5);
			return class_1269.field_5812;
		}

		class_1799 itemInHand = player.method_5998(hand);
		if (!itemInHand.method_7960()) {
			if (onServer) {
				AllSoundEvents.DENY.playOnServer(player.method_37908(), player.method_24515(), 1, 1);
				player.method_7353(Lang.translateDirect("schedule.remove_with_empty_hand"), true);
			}
			return class_1269.field_5812;
		}

		if (onServer) {
			AllSoundEvents.playItemPickup(player);
			player.method_7353(
				Lang.translateDirect(
					train.runtime.isAutoSchedule ? "schedule.auto_removed_from_train" : "schedule.removed_from_train"),
				true);

			player.method_31548()
				.method_7398(train.runtime.returnSchedule());
		}

		player.method_7357()
			.method_7906(AllItems.SCHEDULE.get(), 5);
		return class_1269.field_5812;
	}

}
