package com.simibubi.create.content.trains.schedule;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.AllPartialModels;
import com.simibubi.create.content.contraptions.Contraption;
import com.simibubi.create.content.trains.entity.CarriageContraption;
import com.simibubi.create.content.trains.entity.CarriageContraptionEntity;
import com.simibubi.create.foundation.mixin.accessor.AgeableListModelAccessor;
import com.simibubi.create.foundation.render.CachedBufferer;
import com.simibubi.create.foundation.utility.Couple;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.ModelPartAccessor;
import net.fabricmc.fabric.api.client.rendering.v1.LivingEntityFeatureRendererRegistrationCallback.RegistrationHelper;
import net.minecraft.class_1297;
import net.minecraft.class_1304;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1921;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_3883;
import net.minecraft.class_3887;
import net.minecraft.class_4587;
import net.minecraft.class_4592;
import net.minecraft.class_4597;
import net.minecraft.class_4722;
import net.minecraft.class_5597;
import net.minecraft.class_576;
import net.minecraft.class_5772;
import net.minecraft.class_583;
import net.minecraft.class_609;
import net.minecraft.class_624;
import net.minecraft.class_630;
import net.minecraft.class_630.class_628;
import net.minecraft.class_7198;
import net.minecraft.class_7280;
import net.minecraft.class_897;
import net.minecraft.class_922;

public class TrainHatArmorLayer<T extends class_1309, M extends class_583<T>> extends class_3887<T, M> {

	private class_243 offset;

	public TrainHatArmorLayer(class_3883<T, M> renderer, class_243 offset) {
		super(renderer);
		this.offset = offset;
	}

	@Override
	public void render(class_4587 ms, class_4597 buffer, int light, class_1309 entity, float yaw, float pitch,
		float pt, float p_225628_8_, float p_225628_9_, float p_225628_10_) {
		if (!shouldRenderOn(entity))
			return;

		M entityModel = method_17165();
		class_1921 renderType = class_4722.method_24074();
		ms.method_22903();

		boolean valid = false;
		TransformStack msr = TransformStack.cast(ms);
		float scale = 1;

		if (entityModel instanceof class_4592<?> model && entityModel instanceof io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.AgeableListModelAccessor access) {
			if (model.field_3448) {
				if (access.porting_lib$scaleHead()) {
					float f = 1.5F / access.porting_lib$babyHeadScale();
					ms.method_22905(f, f, f);
				}
				ms.method_22904(0.0D, access.porting_lib$babyYHeadOffset() / 16.0F, access.porting_lib$babyZHeadOffset() / 16.0F);
			}

			class_630 head = getHeadPart(model);
			if (head != null) {
				head.method_22703(ms);

				if (model instanceof class_624)
					head = head.method_32086("real_head");
				if (model instanceof class_5772)
					head = head.method_32086("head");

				ms.method_22904(offset.field_1352 / 16f, offset.field_1351 / 16f, offset.field_1350 / 16f);

				if (!head.method_32087()) {
					class_628 cube = ((ModelPartAccessor) (Object) head).porting_lib$cubes().get(0);
					ms.method_22904(offset.field_1352 / 16f, (cube.field_3644 - cube.field_3647 + offset.field_1351) / 16f, offset.field_1350 / 16f);
					float max = Math.max(cube.field_3648 - cube.field_3645, cube.field_3646 - cube.field_3643) / 8f;
					ms.method_22905(max, max, max);
				}

				valid = true;
			}
		}

		else if (entityModel instanceof class_5597<?> model) {
			boolean slime = model instanceof class_609 || model instanceof class_576;
			class_630 root = model.method_32008();
			String headName = slime ? "cube" : "head";
			class_630 head = root.method_41919(headName) ? root.method_32086(headName) : null;

			if (model instanceof class_7280)
				head = root.method_32086("bone").method_32086("body").method_32086("head");

			if (model instanceof class_7198) {
				head = root.method_32086("body").method_32086("head");
				scale = .5f;
			}

			if (head != null) {
				head.method_22703(ms);

				if (!head.method_32087()) {
					ModelPartAccessor headAccess = (ModelPartAccessor) (Object) head;
					class_628 cube = headAccess.porting_lib$cubes().get(0);
					ms.method_22904(offset.field_1352, (cube.field_3644 - cube.field_3647 + offset.field_1351) / 16f, offset.field_1350 / 16f);
					float max = Math.max(cube.field_3648 - cube.field_3645, cube.field_3646 - cube.field_3643) / (slime ? 6.5f : 8f) * scale;
					ms.method_22905(max, max, max);
				}

				valid = true;
			}
		}

		if (valid) {
			ms.method_22905(1, -1, -1);
			ms.method_46416(0, -2.25f / 16f, 0);
			msr.rotateX(-8.5f);
			class_2680 air = class_2246.field_10124.method_9564();
			CachedBufferer.partial(AllPartialModels.TRAIN_HAT, air)
				.forEntityRender()
				.light(light)
				.renderInto(ms, buffer.getBuffer(renderType));
		}

		ms.method_22909();
	}

	private boolean shouldRenderOn(class_1309 entity) {
		if (entity == null)
			return false;
		if (entity.getCustomData()
			.method_10545("TrainHat"))
			return true;
		if (!entity.method_5765())
			return false;
		if (entity instanceof class_1657 p) {
			class_1799 headItem = p.method_6118(class_1304.field_6169);
			if (!headItem.method_7960())
				return false;
		}
		class_1297 vehicle = entity.method_5854();
		if (!(vehicle instanceof CarriageContraptionEntity cce))
			return false;
		if (!cce.hasSchedule() && !(entity instanceof class_1657))
			return false;
		Contraption contraption = cce.getContraption();
		if (!(contraption instanceof CarriageContraption cc))
			return false;
		class_2338 seatOf = cc.getSeatOf(entity.method_5667());
		if (seatOf == null)
			return false;
		Couple<Boolean> validSides = cc.conductorSeats.get(seatOf);
		return validSides != null;
	}

	public static void registerOn(class_897<?> entityRenderer, RegistrationHelper helper) {
		if (!(entityRenderer instanceof class_922<?, ?> livingRenderer))
			return;

		class_583<?> model = livingRenderer.method_4038();

		if (!(model instanceof class_5597) && !(model instanceof class_4592))
			return;

		class_243 offset = TrainHatOffsets.getOffset(model);
		TrainHatArmorLayer<?, ?> layer = new TrainHatArmorLayer<>(livingRenderer, offset);
		helper.register(layer);
	}

	private static class_630 getHeadPart(class_4592<?> model) {
		for (class_630 part : ((AgeableListModelAccessor) model).create$callHeadParts())
			return part;
		for (class_630 part : ((AgeableListModelAccessor) model).create$callBodyParts())
			return part;
		return null;
	}

}
