package com.simibubi.create.content.trains.schedule.condition;

import com.simibubi.create.Create;
import com.simibubi.create.content.trains.entity.Carriage;
import com.simibubi.create.content.trains.entity.Train;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.Pair;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2960;

public class IdleCargoCondition extends TimedWaitCondition {
	
	@Override
	public Pair<class_1799, class_2561> getSummary() {
		return Pair.of(class_1799.field_8037, Lang.translateDirect("schedule.condition.idle_short", formatTime(true)));
	}

	@Override
	public class_2960 getId() {
		return Create.asResource("idle");
	}
	
	@Override
	public boolean tickCompletion(class_1937 level, Train train, class_2487 context) {
		int idleTime = Integer.MAX_VALUE;
		for (Carriage carriage : train.carriages) 
			idleTime = Math.min(idleTime, carriage.storage.getTicksSinceLastExchange());
		context.method_10569("Time", idleTime);
		requestDisplayIfNecessary(context, idleTime);
		return idleTime > totalWaitTicks();
	}
	
}