package com.simibubi.create.content.trains.schedule.condition;

import com.simibubi.create.content.trains.entity.Train;
import net.minecraft.class_1937;
import net.minecraft.class_2487;

public abstract class LazyTickedScheduleCondition extends ScheduleWaitCondition {

	private int tickRate;

	public LazyTickedScheduleCondition(int tickRate) {
		this.tickRate = tickRate;
	}
	
	@Override
	public boolean tickCompletion(class_1937 level, Train train, class_2487 context) {
		int time = context.method_10550("Time");
		if (time % tickRate == 0) {
			if (lazyTickCompletion(level, train, context))
				return true;
			time = 0;
		}
		context.method_10569("Time", time + 1);
		return false;
	}

	protected abstract boolean lazyTickCompletion(class_1937 level, Train train, class_2487 context);
	
}
