package com.simibubi.create.content.trains.schedule.condition;

import java.util.function.Supplier;
import net.minecraft.class_1937;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import net.minecraft.class_5250;
import com.simibubi.create.Create;
import com.simibubi.create.content.trains.entity.Train;
import com.simibubi.create.content.trains.schedule.Schedule;
import com.simibubi.create.content.trains.schedule.ScheduleDataEntry;
import com.simibubi.create.foundation.utility.Pair;

public abstract class ScheduleWaitCondition extends ScheduleDataEntry {

	public abstract boolean tickCompletion(class_1937 level, Train train, class_2487 context);

	protected void requestStatusToUpdate(class_2487 context) {
		context.method_10569("StatusVersion", context.method_10550("StatusVersion") + 1);
	}

	public final class_2487 write() {
		class_2487 tag = new class_2487();
		class_2487 dataCopy = data.method_10553();
		writeAdditional(dataCopy);
		tag.method_10582("Id", getId().toString());
		tag.method_10566("Data", dataCopy);
		return tag;
	}

	public static ScheduleWaitCondition fromTag(class_2487 tag) {
		class_2960 location = new class_2960(tag.method_10558("Id"));
		Supplier<? extends ScheduleWaitCondition> supplier = null;
		for (Pair<class_2960, Supplier<? extends ScheduleWaitCondition>> pair : Schedule.CONDITION_TYPES)
			if (pair.getFirst()
				.equals(location))
				supplier = pair.getSecond();

		if (supplier == null) {
			Create.LOGGER.warn("Could not parse waiting condition type: " + location);
			return null;
		}

		ScheduleWaitCondition condition = supplier.get();
		// Left around for migration purposes. Data added in writeAdditional has moved into the "Data" tag
		condition.readAdditional(tag);
		class_2487 data = tag.method_10562("Data");
		condition.readAdditional(data);
		condition.data = data;
		return condition;
	}

	public abstract class_5250 getWaitingStatus(class_1937 level, Train train, class_2487 tag);

}
