package com.simibubi.create.content.trains.schedule.condition;

import com.simibubi.create.Create;
import com.simibubi.create.content.trains.entity.Train;
import com.simibubi.create.content.trains.station.GlobalStation;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.Pair;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_3218;
import net.minecraft.class_5250;
import net.minecraft.class_5321;
import net.minecraft.server.MinecraftServer;

public class StationUnloadedCondition extends ScheduleWaitCondition {
	@Override
	public Pair<class_1799, class_2561> getSummary() {
		return Pair.of(class_1799.field_8037, Lang.translateDirect("schedule.condition.unloaded"));
	}

	@Override
	public boolean tickCompletion(class_1937 level, Train train, class_2487 context) {
		GlobalStation currentStation = train.getCurrentStation();
		if (currentStation == null)
			return false;
		class_5321<class_1937> stationDim = currentStation.getBlockEntityDimension();
		MinecraftServer server = level.method_8503();
		if (server == null)
			return false;
		class_3218 stationLevel = server.method_3847(stationDim);
		if (stationLevel == null) {
			return false;
		}
		return !stationLevel.method_37118(currentStation.getBlockEntityPos());
	}

	@Override
	protected void writeAdditional(class_2487 tag) {}

	@Override
	protected void readAdditional(class_2487 tag) {}

	@Override
	public class_2960 getId() {
		return Create.asResource("unloaded");
	}

	@Override
	public class_5250 getWaitingStatus(class_1937 level, Train train, class_2487 tag) {
		return Lang.translateDirect("schedule.condition.unloaded.status");
	}
}
