package com.simibubi.create.content.trains.schedule.destination;

import java.util.List;

import com.google.common.collect.ImmutableList;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.gui.ModularGuiLineBuilder;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.Pair;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_124;
import net.minecraft.class_1799;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_5250;

public class ChangeThrottleInstruction extends ScheduleInstruction {

	public ChangeThrottleInstruction() {
		super();
		data.method_10569("Value", 100);
	}

	@Override
	public Pair<class_1799, class_2561> getSummary() {
		return Pair.of(icon(), formatted());
	}

	private class_5250 formatted() {
		return Components.literal(intData("Value") + "%");
	}

	@Override
	public class_2960 getId() {
		return Create.asResource("throttle");
	}

	@Override
	public class_1799 getSecondLineIcon() {
		return icon();
	}

	@Override
	public boolean supportsConditions() {
		return false;
	}

	@Override
	public List<class_2561> getTitleAs(String type) {
		return ImmutableList.of(Lang
			.translateDirect("schedule." + type + "." + getId().method_12832() + ".summary",
				formatted().method_27692(class_124.field_1068))
			.method_27692(class_124.field_1065));
	}

	@Override
	@Environment(EnvType.CLIENT)
	public void initConfigurationWidgets(ModularGuiLineBuilder builder) {
		builder.addScrollInput(0, 50, (si, l) -> {
			si.withRange(5, 101)
				.withStepFunction(c -> c.shift ? 25 : 5)
				.titled(Lang.translateDirect("schedule.instruction.throttle_edit_box"));
			l.withSuffix("%");
		}, "Value");
	}

	public float getThrottle() {
		return intData("Value") / 100f;
	}

	private class_1799 icon() {
		return AllBlocks.TRAIN_CONTROLS.asStack();
	}

	@Override
	public List<class_2561> getSecondLineTooltip(int slot) {
		return ImmutableList.of(Lang.translateDirect("schedule.instruction.throttle_edit_box"),
			Lang.translateDirect("schedule.instruction.throttle_edit_box_1")
				.method_27692(class_124.field_1080));
	}

}
