package com.simibubi.create.content.trains.schedule.destination;

import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.google.common.collect.ImmutableList;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.Pair;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_124;
import net.minecraft.class_1799;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_342;

public class DestinationInstruction extends TextScheduleInstruction {

	@Override
	public Pair<class_1799, class_2561> getSummary() {
		return Pair.of(AllBlocks.TRACK_STATION.asStack(), Components.literal(getLabelText()));
	}

	@Override
	public boolean supportsConditions() {
		return true;
	}

	@Override
	public class_2960 getId() {
		return Create.asResource("destination");
	}

	@Override
	public class_1799 getSecondLineIcon() {
		return AllBlocks.TRACK_STATION.asStack();
	}

	public String getFilter() {
		return getLabelText();
	}
	
	public String getFilterForRegex() {
		String filter = getFilter();
		if (filter.isBlank())
			return filter;
		return "\\Q" + filter.replace("*", "\\E.*\\Q") + "\\E";
	}

	@Override
	public List<class_2561> getSecondLineTooltip(int slot) {
		return ImmutableList.of(Lang.translateDirect("schedule.instruction.filter_edit_box"),
			Lang.translateDirect("schedule.instruction.filter_edit_box_1")
				.method_27692(class_124.field_1080),
			Lang.translateDirect("schedule.instruction.filter_edit_box_2")
				.method_27692(class_124.field_1063),
			Lang.translateDirect("schedule.instruction.filter_edit_box_3")
				.method_27692(class_124.field_1063));
	}

	@Override
	@Environment(EnvType.CLIENT)
	protected void modifyEditBox(class_342 box) {
		box.method_1890(s -> StringUtils.countMatches(s, '*') <= 3);
	}

}