package com.simibubi.create.content.trains.schedule.destination;

import java.util.function.Supplier;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import com.simibubi.create.Create;
import com.simibubi.create.content.trains.schedule.Schedule;
import com.simibubi.create.content.trains.schedule.ScheduleDataEntry;
import com.simibubi.create.foundation.utility.Pair;

public abstract class ScheduleInstruction extends ScheduleDataEntry {

	public abstract boolean supportsConditions();

	public final class_2487 write() {
		class_2487 tag = new class_2487();
		class_2487 dataCopy =  data.method_10553();
		writeAdditional(dataCopy);
		tag.method_10582("Id", getId().toString());
		tag.method_10566("Data", dataCopy);
		return tag;
	}

	public static ScheduleInstruction fromTag(class_2487 tag) {
		class_2960 location = new class_2960(tag.method_10558("Id"));
		Supplier<? extends ScheduleInstruction> supplier = null;
		for (Pair<class_2960, Supplier<? extends ScheduleInstruction>> pair : Schedule.INSTRUCTION_TYPES)
			if (pair.getFirst()
				.equals(location))
				supplier = pair.getSecond();

		if (supplier == null) {
			Create.LOGGER.warn("Could not parse schedule instruction type: " + location);
			return new DestinationInstruction();
		}

		ScheduleInstruction scheduleDestination = supplier.get();
		// Left around for migration purposes. Data added in writeAdditional has moved into the "Data" tag
		scheduleDestination.readAdditional(tag);
		class_2487 data = tag.method_10562("Data");
		scheduleDestination.readAdditional(data);
		scheduleDestination.data = data;
		return scheduleDestination;
	}

}
