package com.simibubi.create.content.trains.signal;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import net.minecraft.class_2540;
import com.google.common.collect.ImmutableList;
import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.networking.SimplePacketBase;

public class SignalEdgeGroupPacket extends SimplePacketBase {

	List<UUID> ids;
	List<EdgeGroupColor> colors;
	boolean add;

	public SignalEdgeGroupPacket(UUID id, EdgeGroupColor color) {
		this(ImmutableList.of(id), ImmutableList.of(color), true);
	}

	public SignalEdgeGroupPacket(List<UUID> ids, List<EdgeGroupColor> colors, boolean add) {
		this.ids = ids;
		this.colors = colors;
		this.add = add;
	}

	public SignalEdgeGroupPacket(class_2540 buffer) {
		ids = new ArrayList<>();
		colors = new ArrayList<>();
		add = buffer.readBoolean();
		int size = buffer.method_10816();
		for (int i = 0; i < size; i++)
			ids.add(buffer.method_10790());
		size = buffer.method_10816();
		for (int i = 0; i < size; i++)
			colors.add(EdgeGroupColor.values()[buffer.method_10816()]);
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.writeBoolean(add);
		buffer.method_10804(ids.size());
		ids.forEach(buffer::method_10797);
		buffer.method_10804(colors.size());
		colors.forEach(c -> buffer.method_10804(c.ordinal()));
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			Map<UUID, SignalEdgeGroup> signalEdgeGroups = CreateClient.RAILWAYS.signalEdgeGroups;
			int i = 0;
			for (UUID id : ids) {
				if (!add) {
					signalEdgeGroups.remove(id);
					continue;
				}

				SignalEdgeGroup group = new SignalEdgeGroup(id);
				signalEdgeGroups.put(id, group);
				if (colors.size() > i)
					group.color = colors.get(i);
				i++;
			}
		});
		return true;
	}

}
