package com.simibubi.create.content.trains.station;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllShapes;
import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.content.equipment.wrench.IWrenchable;
import com.simibubi.create.content.logistics.depot.SharedDepotBlockMethods;
import com.simibubi.create.foundation.advancement.AdvancementBehaviour;
import com.simibubi.create.foundation.block.IBE;
import com.simibubi.create.foundation.block.ProperWaterloggedBlock;
import com.simibubi.create.foundation.gui.ScreenOpener;

import com.simibubi.create.foundation.utility.AdventureUtil;
import com.tterrag.registrate.fabric.EnvExecutor;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_10;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1806;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_22;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689.class_2690;
import net.minecraft.class_2746;
import net.minecraft.class_3610;
import net.minecraft.class_3726;
import net.minecraft.class_3965;
import net.minecraft.class_746;

public class StationBlock extends class_2248 implements IBE<StationBlockEntity>, IWrenchable, ProperWaterloggedBlock {

	public static final class_2746 ASSEMBLING = class_2746.method_11825("assembling");

	public StationBlock(class_2251 p_54120_) {
		super(p_54120_);
		method_9590(method_9564().method_11657(ASSEMBLING, false)
			.method_11657(WATERLOGGED, false));
	}

	@Override
	protected void method_9515(class_2690<class_2248, class_2680> pBuilder) {
		super.method_9515(pBuilder.method_11667(ASSEMBLING, WATERLOGGED));
	}

	@Override
	public class_2680 method_9605(class_1750 pContext) {
		return withWater(super.method_9605(pContext), pContext);
	}

	@Override
	public class_2680 method_9559(class_2680 pState, class_2350 pDirection, class_2680 pNeighborState,
		class_1936 pLevel, class_2338 pCurrentPos, class_2338 pNeighborPos) {
		updateWater(pLevel, pState, pCurrentPos);
		return pState;
	}

	@Override
	public void method_9567(class_1937 pLevel, class_2338 pPos, class_2680 pState, class_1309 pPlacer, class_1799 pStack) {
		super.method_9567(pLevel, pPos, pState, pPlacer, pStack);
		AdvancementBehaviour.setPlacedBy(pLevel, pPos, pPlacer);
	}

	@Override
	public class_3610 method_9545(class_2680 pState) {
		return fluidState(pState);
	}

	@Override
	public boolean method_9498(class_2680 pState) {
		return true;
	}

	@Override
	public int method_9572(class_2680 pState, class_1937 pLevel, class_2338 pPos) {
		return getBlockEntityOptional(pLevel, pPos).map(ste -> ste.trainPresent ? 15 : 0)
			.orElse(0);
	}

	@Override
	public void method_9536(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 newState, boolean isMoving) {
		IBE.onRemove(state, worldIn, pos, newState);
	}

	@Override
	public void method_9502(class_1922 worldIn, class_1297 entityIn) {
		super.method_9502(worldIn, entityIn);
		SharedDepotBlockMethods.onLanded(worldIn, entityIn);
	}

	@Override
	public class_1269 method_9534(class_2680 pState, class_1937 pLevel, class_2338 pPos, class_1657 pPlayer, class_1268 pHand,
		class_3965 pHit) {

		if (pPlayer == null || pPlayer.method_5715() || AdventureUtil.isAdventure(pPlayer))
			return class_1269.field_5811;
		class_1799 itemInHand = pPlayer.method_5998(pHand);
		if (AllItems.WRENCH.isIn(itemInHand))
			return class_1269.field_5811;

		if (itemInHand.method_7909() == class_1802.field_8204) {
			return onBlockEntityUse(pLevel, pPos, station -> {
				if (pLevel.field_9236)
					return class_1269.field_5812;

				if (station.getStation() == null || station.getStation().getId() == null)
					return class_1269.field_5814;

				class_22 savedData = class_1806.method_8001(itemInHand, pLevel);
				if (!(savedData instanceof StationMapData stationMapData))
					return class_1269.field_5814;

				if (!stationMapData.toggleStation(pLevel, pPos, station))
					return class_1269.field_5814;

				return class_1269.field_5812;
			});
		}

		class_1269 result = onBlockEntityUse(pLevel, pPos, station -> {
			class_1799 autoSchedule = station.getAutoSchedule();
			if (autoSchedule.method_7960())
				return class_1269.field_5811;
			if (pLevel.field_9236)
				return class_1269.field_5812;
			pPlayer.method_31548()
				.method_7398(autoSchedule.method_7972());
			station.depotBehaviour.removeHeldItem();
			station.notifyUpdate();
			AllSoundEvents.playItemPickup(pPlayer);
			return class_1269.field_5812;
		});

		if (result == class_1269.field_5811)
			EnvExecutor.runWhenOn(EnvType.CLIENT,
				() -> () -> withBlockEntityDo(pLevel, pPos, be -> this.displayScreen(be, pPlayer)));
		return class_1269.field_5812;
	}

	@Environment(value = EnvType.CLIENT)
	protected void displayScreen(StationBlockEntity be, class_1657 player) {
		if (!(player instanceof class_746))
			return;
		GlobalStation station = be.getStation();
		class_2680 blockState = be.method_11010();
		if (station == null || blockState == null)
			return;
		boolean assembling = blockState.method_26204() == this && blockState.method_11654(ASSEMBLING);
		ScreenOpener.open(assembling ? new AssemblyScreen(be, station) : new StationScreen(be, station));
	}

	@Override
	public class_265 method_9530(class_2680 pState, class_1922 pLevel, class_2338 pPos, class_3726 pContext) {
		return AllShapes.STATION;
	}

	@Override
	public Class<StationBlockEntity> getBlockEntityClass() {
		return StationBlockEntity.class;
	}

	@Override
	public class_2591<? extends StationBlockEntity> getBlockEntityType() {
		return AllBlockEntityTypes.TRACK_STATION.get();
	}

	@Override
	public boolean method_9516(class_2680 state, class_1922 reader, class_2338 pos, class_10 type) {
		return false;
	}

}
