package com.simibubi.create.content.trains.station;

import java.util.Objects;
import java.util.Optional;
import net.minecraft.class_1921;
import net.minecraft.class_1922;
import net.minecraft.class_20;
import net.minecraft.class_22;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_4597;
import org.joml.Matrix4f;
import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.Create;
import com.simibubi.create.content.trains.track.TrackTargetingBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.map.CustomRenderedMapDecoration;
import com.simibubi.create.foundation.utility.Components;

public class StationMarker {
	// Not MANSION or MONUMENT to allow map extending
	public static final class_20.class_21 TYPE = class_20.class_21.field_89;

	private final class_2338 source;
	private final class_2338 target;
	private final class_2561 name;
	private final String id;

	public StationMarker(class_2338 source, class_2338 target, class_2561 name) {
		this.source = source;
		this.target = target;
		this.name = name;
		id = "create:station-" + target.method_10263() + "," + target.method_10264() + "," + target.method_10260();
	}

	public static StationMarker load(class_2487 tag) {
		class_2338 source = class_2512.method_10691(tag.method_10562("source"));
		class_2338 target = class_2512.method_10691(tag.method_10562("target"));
		class_2561 name = class_2561.class_2562.method_10877(tag.method_10558("name"));
		if (name == null) name = Components.immutableEmpty();

		return new StationMarker(source, target, name);
	}

	public static StationMarker fromWorld(class_1922 level, class_2338 pos) {
		Optional<StationBlockEntity> stationOption = AllBlockEntityTypes.TRACK_STATION.get(level, pos);

		if (stationOption.isEmpty() || stationOption.get().getStation() == null)
			return null;

		String name = stationOption.get()
			.getStation().name;
		return new StationMarker(pos, BlockEntityBehaviour.get(stationOption.get(), TrackTargetingBehaviour.TYPE)
			.getPositionForMapMarker(), Components.literal(name));
	}

	public class_2487 save() {
		class_2487 tag = new class_2487();
		tag.method_10566("source", class_2512.method_10692(source));
		tag.method_10566("target", class_2512.method_10692(target));
		tag.method_10582("name", class_2561.class_2562.method_10867(name));

		return tag;
	}

	public class_2338 getSource() {
		return source;
	}

	public class_2338 getTarget() {
		return target;
	}

	public class_2561 getName() {
		return name;
	}

	public String getId() {
		return id;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) return true;
		if (o == null || getClass() != o.getClass()) return false;

		StationMarker that = (StationMarker) o;

		if (!target.equals(that.target)) return false;
		return name.equals(that.name);
	}

	@Override
	public int hashCode() {
		return Objects.hash(target, name);
	}

	public static class Decoration extends class_20 implements CustomRenderedMapDecoration {
		private static final class_2960 TEXTURE = Create.asResource("textures/gui/station_map_icon.png");

		public Decoration(byte x, byte y, class_2561 name) {
			super(TYPE, x, y, (byte) 0, name);
		}

		public static Decoration from(class_20 decoration) {
			return new StationMarker.Decoration(decoration.method_90(), decoration.method_91(), decoration.method_88());
		}

		@Override
		public boolean method_94() {
			return true;
		}

		@Override
		public void render(class_4587 poseStack, class_4597 bufferSource, boolean active, int packedLight, class_22 mapData, int index) {
			poseStack.method_22903();

			poseStack.method_22904(method_90() / 2D + 64.0, method_91() / 2D + 64.0, -0.02D);

			poseStack.method_22903();

			poseStack.method_46416(0.5f, 0f, 0);
			poseStack.method_22905(4.5F, 4.5F, 3.0F);

			class_4588 buffer = bufferSource.getBuffer(class_1921.method_23028(TEXTURE));
			Matrix4f mat = poseStack.method_23760().method_23761();
			float zOffset = -0.001f;
			buffer.method_22918(mat, -1, -1, zOffset * index).method_1336(255, 255, 255, 255).method_22913(0.0f		, 0.0f		 ).method_22916(packedLight).method_1344();
			buffer.method_22918(mat, -1,  1, zOffset * index).method_1336(255, 255, 255, 255).method_22913(0.0f		, 0.0f + 1.0f).method_22916(packedLight).method_1344();
			buffer.method_22918(mat,  1,  1, zOffset * index).method_1336(255, 255, 255, 255).method_22913(0.0f + 1.0f, 0.0f + 1.0f).method_22916(packedLight).method_1344();
			buffer.method_22918(mat,  1, -1, zOffset * index).method_1336(255, 255, 255, 255).method_22913(0.0f + 1.0f, 0.0f		 ).method_22916(packedLight).method_1344();

			poseStack.method_22909();

			if (method_88() != null) {
				class_327 font = class_310.method_1551().field_1772;
				class_2561 component = method_88();
				float f6 = (float)font.method_27525(component);
//				float f7 = Mth.clamp(25.0F / f6, 0.0F, 6.0F / 9.0F);
				poseStack.method_22903();
//				poseStack.translate((double)(0.0F + (float)getX() / 2.0F + 64.0F / 2.0F), (double)(0.0F + (float)getY() / 2.0F + 64.0F + 4.0F), (double)-0.025F);
				poseStack.method_22904(0, 6.0D, -0.005F);

				poseStack.method_22905(0.8f, 0.8f, 1.0F);
				poseStack.method_46416(-f6 / 2f + .5f, 0, 0);
//				poseStack.scale(f7, f7, 1.0F);
				font.method_30882(component, 0.0F, 0.0F, -1, false, poseStack.method_23760()
					.method_23761(), bufferSource, class_327.class_6415.field_33993, Integer.MIN_VALUE, packedLight);
				poseStack.method_22909();
			}

			poseStack.method_22909();
		}

		@Override
		public boolean render(int index) {
			return true;
		}
	}
}
