package com.simibubi.create.content.trains.station;

import java.util.UUID;
import net.minecraft.class_1937;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import net.minecraft.class_3222;
import com.simibubi.create.AllPackets;
import com.simibubi.create.Create;
import com.simibubi.create.content.trains.entity.Train;
import com.simibubi.create.content.trains.entity.TrainIconType;
import com.simibubi.create.foundation.networking.SimplePacketBase;
import com.simibubi.create.foundation.utility.Components;

public class TrainEditPacket extends SimplePacketBase {

	private String name;
	private UUID id;
	private class_2960 iconType;

	public TrainEditPacket(UUID id, String name, class_2960 iconType) {
		this.name = name;
		this.id = id;
		this.iconType = iconType;
	}

	public TrainEditPacket(class_2540 buffer) {
		id = buffer.method_10790();
		name = buffer.method_10800(256);
		iconType = buffer.method_10810();
	}

	@Override
	public void write(class_2540 buffer) {
		buffer.method_10797(id);
		buffer.method_10814(name);
		buffer.method_10812(iconType);
	}

	@Override
	public boolean handle(Context context) {
		context.enqueueWork(() -> {
			class_3222 sender = context.getSender();
			class_1937 level = sender == null ? null : sender.method_37908();
			Train train = Create.RAILWAYS.sided(level).trains.get(id);
			if (train == null)
				return;
			if (!name.isBlank())
				train.name = Components.literal(name);
			train.icon = TrainIconType.byId(iconType);
			if (sender != null)
				AllPackets.getChannel().sendToClientsInServer(new TrainEditReturnPacket(id, name, iconType),
						level.method_8503());
		});
		return true;
	}

	public static class TrainEditReturnPacket extends TrainEditPacket {

		public TrainEditReturnPacket(class_2540 buffer) {
			super(buffer);
		}

		public TrainEditReturnPacket(UUID id, String name, class_2960 iconType) {
			super(id, name, iconType);
		}

	}

}
