package com.simibubi.create.content.trains.track;

import com.simibubi.create.AllSoundEvents;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.networking.BlockEntityConfigurationPacket;
import com.simibubi.create.infrastructure.config.AllConfigs;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2498;
import net.minecraft.class_2540;
import net.minecraft.class_2680;
import net.minecraft.class_3222;
import net.minecraft.class_3419;

public class CurvedTrackDestroyPacket extends BlockEntityConfigurationPacket<TrackBlockEntity> {

	private class_2338 targetPos;
	private class_2338 soundSource;
	private boolean wrench;

	public CurvedTrackDestroyPacket(class_2338 pos, class_2338 targetPos, class_2338 soundSource, boolean wrench) {
		super(pos);
		this.targetPos = targetPos;
		this.soundSource = soundSource;
		this.wrench = wrench;
	}

	public CurvedTrackDestroyPacket(class_2540 buffer) {
		super(buffer);
	}

	@Override
	protected void writeSettings(class_2540 buffer) {
		buffer.method_10807(targetPos);
		buffer.method_10807(soundSource);
		buffer.writeBoolean(wrench);
	}

	@Override
	protected void readSettings(class_2540 buffer) {
		targetPos = buffer.method_10811();
		soundSource = buffer.method_10811();
		wrench = buffer.readBoolean();
	}

	@Override
	protected void applySettings(class_3222 player, TrackBlockEntity be) {
		int verifyDistance = AllConfigs.server().trains.maxTrackPlacementLength.get() * 4;
		if (!be.method_11016()
			.method_19771(player.method_24515(), verifyDistance)) {
			Create.LOGGER.warn(player.method_5820() + " too far away from destroyed Curve track");
			return;
		}

		class_1937 level = be.method_10997();
		BezierConnection bezierConnection = be.getConnections()
			.get(targetPos);

		be.removeConnection(targetPos);
		if (level.method_8321(targetPos)instanceof TrackBlockEntity other)
			other.removeConnection(pos);

		class_2680 blockState = be.method_11010();
		TrackPropagator.onRailRemoved(level, pos, blockState);

		if (wrench) {
			AllSoundEvents.WRENCH_REMOVE.playOnServer(player.method_37908(), soundSource, 1,
				Create.RANDOM.nextFloat() * .5f + .5f);
			if (!player.method_7337() && bezierConnection != null)
				bezierConnection.addItemsToPlayer(player);
		} else if (!player.method_7337() && bezierConnection != null)
			bezierConnection.spawnItems(level);

		bezierConnection.spawnDestroyParticles(level);
		class_2498 soundtype = blockState.method_26231();
		if (soundtype == null)
			return;

		level.method_8396(null, soundSource, soundtype.method_10595(), class_3419.field_15245,
			(soundtype.method_10597() + 1.0F) / 2.0F, soundtype.method_10599() * 0.8F);
	}

	@Override
	protected int maxRange() {
		return 64;
	}

	@Override
	protected void applySettings(TrackBlockEntity be) {}

}
