package com.simibubi.create.content.trains.track;

import com.simibubi.create.AllItems;
import com.simibubi.create.AllPackets;
import com.simibubi.create.AllTags;
import com.simibubi.create.content.trains.track.TrackBlockOutline.BezierPointSelection;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.VecHelper;
import net.minecraft.class_1109;
import net.minecraft.class_124;
import net.minecraft.class_1268;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2388;
import net.minecraft.class_2398;
import net.minecraft.class_243;
import net.minecraft.class_2498;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_3419;
import net.minecraft.class_638;
import net.minecraft.class_746;

public class CurvedTrackInteraction {

	static final int breakerId = new Object().hashCode();

	static int breakTicks;
	static int breakTimeout;
	static float breakProgress;
	static class_2338 breakPos;

	public static void clientTick() {
		BezierPointSelection result = TrackBlockOutline.result;
		class_310 mc = class_310.method_1551();
		class_746 player = mc.field_1724;
		class_638 level = mc.field_1687;

		if (!player.method_31549().field_7476)
			return;

		if (mc.field_1690.field_1886.method_1434() && result != null) {
			breakPos = result.blockEntity()
				.method_11016();
			class_2680 blockState = level.method_8320(breakPos);
			if (blockState.method_26215()) {
				resetBreakProgress();
				return;
			}

			if (breakTicks % 4.0F == 0.0F) {
				class_2498 soundtype = blockState.method_26231();
				mc.method_1483()
					.method_4873(new class_1109(soundtype.method_10596(), class_3419.field_15245,
						(soundtype.method_10597() + 1.0F) / 8.0F, soundtype.method_10599() * 0.5F,
						level.field_9229, class_2338.method_49638(result.vec())));
			}

			boolean creative = player.method_31549().field_7477;

			breakTicks++;
			breakTimeout = 2;
			breakProgress += creative ? 0.125f : blockState.method_26165(player, level, breakPos) / 8f;

			class_243 vec = VecHelper.offsetRandomly(result.vec(), level.field_9229, 0.25f);
			level.method_8406(new class_2388(class_2398.field_11217, blockState), vec.field_1352, vec.field_1351, vec.field_1350, 0, 0, 0);

			int progress = (int) (breakProgress * 10.0F) - 1;
			level.method_8517(player.method_5628(), breakPos, progress);
			player.method_6104(class_1268.field_5808);

			if (breakProgress >= 1) {
				AllPackets.getChannel().sendToServer(new CurvedTrackDestroyPacket(breakPos, result.loc()
					.curveTarget(), class_2338.method_49638(result.vec()), false));
				resetBreakProgress();
			}

			return;
		}

		if (breakTimeout == 0)
			return;
		if (--breakTimeout > 0)
			return;

		resetBreakProgress();
	}

	private static void resetBreakProgress() {
		class_310 mc = class_310.method_1551();
		class_638 level = mc.field_1687;

		if (breakPos != null && level != null)
			level.method_8517(mc.field_1724.method_5628(), breakPos, -1);

		breakProgress = 0;
		breakTicks = 0;
		breakPos = null;
	}

	public static boolean onClickInput(boolean isUse, boolean isAttack) {
		BezierPointSelection result = TrackBlockOutline.result;
		if (result == null)
			return false;

		class_310 mc = class_310.method_1551();
		class_746 player = mc.field_1724;
		class_638 level = mc.field_1687;

		if (player == null || level == null)
			return false;

		if (isUse) {
			class_1799 heldItem = player.method_6047();
			class_1792 item = heldItem.method_7909();
			if (AllTags.AllBlockTags.TRACKS.matches(heldItem)) {
				player.method_7353(Lang.translateDirect("track.turn_start")
					.method_27692(class_124.field_1061), true);
				player.method_6104(class_1268.field_5808);
				return true;
			}
			if (item instanceof TrackTargetingBlockItem ttbi && ttbi.useOnCurve(result, heldItem)) {
				player.method_6104(class_1268.field_5808);
				return true;
			}
			if (AllItems.WRENCH.isIn(heldItem) && player.method_5715()) {
				AllPackets.getChannel()
					.sendToServer(new CurvedTrackDestroyPacket(result.blockEntity()
						.method_11016(),
						result.loc()
							.curveTarget(),
						class_2338.method_49638(result.vec()), true));
				resetBreakProgress();
				player.method_6104(class_1268.field_5808);
				return true;
			}
		}

		if (isAttack)
			return true;

		return false;
	}

}
