package com.simibubi.create.content.trains.track;

import java.util.function.Supplier;
import java.util.function.UnaryOperator;

import com.simibubi.create.foundation.model.BakedQuadHelper;
import com.simibubi.create.foundation.utility.VecHelper;

import net.fabricmc.fabric.api.renderer.v1.model.ForwardingBakedModel;
import net.fabricmc.fabric.api.renderer.v1.render.RenderContext;
import net.fabricmc.fabric.api.rendering.data.v1.RenderAttachedBlockView;
import net.minecraft.class_1087;
import net.minecraft.class_1920;
import net.minecraft.class_2338;
import net.minecraft.class_2350.class_2351;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_3532;
import net.minecraft.class_5819;

public class TrackModel extends ForwardingBakedModel {

	public TrackModel(class_1087 originalModel) {
		wrapped = originalModel;
	}

	@Override
	public boolean isVanillaAdapter() {
		return false;
	}

	@Override
	public void emitBlockQuads(class_1920 blockView, class_2680 state, class_2338 pos, Supplier<class_5819> randomSupplier, RenderContext context) {
		if (!(blockView instanceof RenderAttachedBlockView attachmentView
				&& attachmentView.getBlockEntityRenderAttachment(pos) instanceof Double data)) {
			super.emitBlockQuads(blockView, state, pos, randomSupplier, context);
			return;
		}

		double angleIn = data;
		double angle = Math.abs(angleIn);
		boolean flip = angleIn < 0;

		TrackShape trackShape = state.method_11654(TrackBlock.SHAPE);
		double hAngle = switch (trackShape) {
		case XO -> 0;
		case PD -> 45;
		case ZO -> 90;
		case ND -> 135;
		default -> 0;
		};

		class_243 verticalOffset = new class_243(0, -0.25, 0);
		class_243 diagonalRotationPoint =
			(trackShape == TrackShape.ND || trackShape == TrackShape.PD) ? new class_243((class_3532.field_15724 - 1) / 2, 0, 0)
				: class_243.field_1353;

		UnaryOperator<class_243> transform = v -> {
			v = v.method_1019(verticalOffset);
			v = VecHelper.rotateCentered(v, hAngle, class_2351.field_11052);
			v = v.method_1019(diagonalRotationPoint);
			v = VecHelper.rotate(v, angle, class_2351.field_11051);
			v = v.method_1020(diagonalRotationPoint);
			v = VecHelper.rotateCentered(v, -hAngle + (flip ? 180 : 0), class_2351.field_11052);
			v = v.method_1020(verticalOffset);
			return v;
		};

		context.pushTransform(quad -> {
			for (int vertex = 0; vertex < 4; vertex++) {
				BakedQuadHelper.setXYZ(quad, vertex, transform.apply(BakedQuadHelper.getXYZ(quad, vertex)));
			}
			return true;
		});
		super.emitBlockQuads(blockView, state, pos, randomSupplier, context);
		context.popTransform();
	}

}
