package com.simibubi.create.content.trains.track;

import com.google.common.base.Objects;
import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.Create;
import com.simibubi.create.content.trains.graph.EdgePointType;
import com.simibubi.create.content.trains.graph.TrackGraphLocation;
import com.simibubi.create.content.trains.track.TrackBlockOutline.BezierPointSelection;
import com.simibubi.create.content.trains.track.TrackTargetingBehaviour.RenderedTrackOverlayType;
import com.simibubi.create.content.trains.track.TrackTargetingBlockItem.OverlapResult;
import com.simibubi.create.foundation.render.SuperRenderTypeBuffer;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2350.class_2352;
import net.minecraft.class_239;
import net.minecraft.class_239.class_240;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2512;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_3965;
import net.minecraft.class_4587;
import net.minecraft.class_4608;
import net.minecraft.class_746;
import net.minecraft.class_761;

public class TrackTargetingClient {

	static class_2338 lastHovered;
	static boolean lastDirection;
	static EdgePointType<?> lastType;
	static BezierTrackPointLocation lastHoveredBezierSegment;

	static OverlapResult lastResult;
	static TrackGraphLocation lastLocation;

	public static void clientTick() {
		class_310 mc = class_310.method_1551();
		class_746 player = mc.field_1724;
		class_243 lookAngle = player.method_5720();

		class_2338 hovered = null;
		boolean direction = false;
		EdgePointType<?> type = null;
		BezierTrackPointLocation hoveredBezier = null;

		class_1799 stack = player.method_6047();
		if (stack.method_7909() instanceof TrackTargetingBlockItem ttbi)
			type = ttbi.getType(stack);

		if (type == EdgePointType.SIGNAL)
			Create.RAILWAYS.sided(null)
				.tickSignalOverlay();

		boolean alreadySelected = stack.method_7985() && stack.method_7969()
			.method_10545("SelectedPos");

		if (type != null) {
			BezierPointSelection bezierSelection = TrackBlockOutline.result;

			if (alreadySelected) {
				class_2487 tag = stack.method_7969();
				hovered = class_2512.method_10691(tag.method_10562("SelectedPos"));
				direction = tag.method_10577("SelectedDirection");
				if (tag.method_10545("Bezier")) {
					class_2487 bezierNbt = tag.method_10562("Bezier");
					class_2338 key = class_2512.method_10691(bezierNbt.method_10562("Key"));
					hoveredBezier = new BezierTrackPointLocation(key, bezierNbt.method_10550("Segment"));
				}

			} else if (bezierSelection != null) {
				hovered = bezierSelection.blockEntity()
					.method_11016();
				hoveredBezier = bezierSelection.loc();
				direction = lookAngle.method_1026(bezierSelection.direction()) < 0;

			} else {
				class_239 hitResult = mc.field_1765;
				if (hitResult != null && hitResult.method_17783() == class_240.field_1332) {
					class_3965 blockHitResult = (class_3965) hitResult;
					class_2338 pos = blockHitResult.method_17777();
					class_2680 blockState = mc.field_1687.method_8320(pos);
					if (blockState.method_26204() instanceof ITrackBlock track) {
						direction = track.getNearestTrackAxis(mc.field_1687, pos, blockState, lookAngle)
							.getSecond() == class_2352.field_11056;
						hovered = pos;
					}
				}
			}
		}

		if (hovered == null) {
			lastHovered = null;
			lastResult = null;
			lastLocation = null;
			lastHoveredBezierSegment = null;
			return;
		}

		if (Objects.equal(hovered, lastHovered) && Objects.equal(hoveredBezier, lastHoveredBezierSegment)
			&& direction == lastDirection && type == lastType)
			return;

		lastType = type;
		lastHovered = hovered;
		lastDirection = direction;
		lastHoveredBezierSegment = hoveredBezier;

		TrackTargetingBlockItem.withGraphLocation(mc.field_1687, hovered, direction, hoveredBezier, type,
			(result, location) -> {
				lastResult = result;
				lastLocation = location;
			});
	}

	public static void render(class_4587 ms, SuperRenderTypeBuffer buffer, class_243 camera) {
		if (lastLocation == null || lastResult.feedback != null)
			return;

		class_310 mc = class_310.method_1551();
		class_2338 pos = lastHovered;
		int light = class_761.method_23794(mc.field_1687, pos);
		class_2352 direction = lastDirection ? class_2352.field_11056 : class_2352.field_11060;

		RenderedTrackOverlayType type = lastType == EdgePointType.SIGNAL ? RenderedTrackOverlayType.SIGNAL
			: lastType == EdgePointType.OBSERVER ? RenderedTrackOverlayType.OBSERVER : RenderedTrackOverlayType.STATION;

		ms.method_22903();
		TransformStack.cast(ms)
			.translate(class_243.method_24954(pos)
				.method_1020(camera));
		TrackTargetingBehaviour.render(mc.field_1687, pos, direction, lastHoveredBezierSegment, ms, buffer, light,
			class_4608.field_21444, type, 1 + 1 / 16f);
		ms.method_22909();
	}

}
