package com.simibubi.create.foundation.block.render;

import com.jozufozu.flywheel.core.StitchedSprite;
import net.minecraft.class_1058;
import net.minecraft.class_2960;

public class SpriteShiftEntry {
	protected StitchedSprite original;
	protected StitchedSprite target;

	public void set(class_2960 originalTextureLocation, class_2960 targetTextureLocation) {
		original = new StitchedSprite(originalTextureLocation);
		target = new StitchedSprite(targetTextureLocation);
	}

	public class_2960 getOriginalResourceLocation() {
		return original.getLocation();
	}

	public class_2960 getTargetResourceLocation() {
		return target.getLocation();
	}

	public class_1058 getOriginal() {
		return original.get();
	}

	public class_1058 getTarget() {
		return target.get();
	}

	public float getTargetU(float localU) {
		return getTarget().method_4580(getUnInterpolatedU(getOriginal(), localU));
	}

	public float getTargetV(float localV) {
		return getTarget().method_4570(getUnInterpolatedV(getOriginal(), localV));
	}

	public static float getUnInterpolatedU(class_1058 sprite, float u) {
		float f = sprite.method_4577() - sprite.method_4594();
		return (u - sprite.method_4594()) / f * 16.0F;
	}

	public static float getUnInterpolatedV(class_1058 sprite, float v) {
		float f = sprite.method_4575() - sprite.method_4593();
		return (v - sprite.method_4593()) / f * 16.0F;
	}
}
