package com.simibubi.create.foundation.blockEntity.behaviour.scrollValue;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_1268;
import net.minecraft.class_1799;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_238;
import net.minecraft.class_239;
import net.minecraft.class_243;
import net.minecraft.class_2561;
import net.minecraft.class_310;
import net.minecraft.class_3965;
import net.minecraft.class_5250;
import net.minecraft.class_638;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllKeys;
import com.simibubi.create.AllTags;
import com.simibubi.create.CreateClient;
import com.simibubi.create.foundation.blockEntity.SmartBlockEntity;
import com.simibubi.create.foundation.blockEntity.behaviour.BlockEntityBehaviour;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBox;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBox.IconValueBox;
import com.simibubi.create.foundation.blockEntity.behaviour.ValueBox.TextValueBox;
import com.simibubi.create.foundation.utility.AdventureUtil;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;

public class ScrollValueRenderer {

	public static void tick() {
		class_310 mc = class_310.method_1551();
		class_239 target = mc.field_1765;
		if (target == null || !(target instanceof class_3965))
			return;

		class_3965 result = (class_3965) target;
		class_638 world = mc.field_1687;
		class_2338 pos = result.method_17777();
		class_2350 face = result.method_17780();

		ScrollValueBehaviour behaviour = BlockEntityBehaviour.get(world, pos, ScrollValueBehaviour.TYPE);
		if (behaviour == null)
			return;
		if (!behaviour.isActive()) {
			CreateClient.OUTLINER.remove(pos);
			return;
		}
		class_1799 mainhandItem = mc.field_1724.method_5998(class_1268.field_5808);
		boolean clipboard = AllBlocks.CLIPBOARD.isIn(mainhandItem);
		if (behaviour.needsWrench && !AllItems.WRENCH.isIn(mainhandItem) && !clipboard)
			return;
		boolean highlight = behaviour.testHit(target.method_17784()) && !clipboard;

		if (behaviour instanceof BulkScrollValueBehaviour && AllKeys.ctrlDown()) {
			BulkScrollValueBehaviour bulkScrolling = (BulkScrollValueBehaviour) behaviour;
			for (SmartBlockEntity smartBlockEntity : bulkScrolling.getBulk()) {
				ScrollValueBehaviour other = smartBlockEntity.getBehaviour(ScrollValueBehaviour.TYPE);
				if (other != null)
					addBox(world, smartBlockEntity.method_11016(), face, other, highlight);
			}
		} else
			addBox(world, pos, face, behaviour, highlight);

		if (!highlight)
			return;

		List<class_5250> tip = new ArrayList<>();
		tip.add(behaviour.label.method_27661());
		tip.add(Lang.translateDirect("gui.value_settings.hold_to_edit"));
		CreateClient.VALUE_SETTINGS_HANDLER.showHoverTip(tip);
	}

	protected static void addBox(class_638 world, class_2338 pos, class_2350 face, ScrollValueBehaviour behaviour,
		boolean highlight) {
		class_238 bb = new class_238(class_243.field_1353, class_243.field_1353).method_1014(.5f)
			.method_1002(0, 0, -.5f)
			.method_989(0, 0, -.125f);
		class_2561 label = behaviour.label;
		ValueBox box;

		if (behaviour instanceof ScrollOptionBehaviour) {
			box = new IconValueBox(label, ((ScrollOptionBehaviour<?>) behaviour).getIconForSelected(), bb, pos);
		} else {
			box = new TextValueBox(label, bb, pos, Components.literal(behaviour.formatValue()));
		}

		if (!AdventureUtil.isAdventure(class_310.method_1551().field_1724))
			box.passive(!highlight)
			.wideOutline();

		CreateClient.OUTLINER.showValueBox(pos, box.transform(behaviour.slotPositioning))
			.highlightFace(face);
	}

}
