package com.simibubi.create.foundation.config.ui;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import com.simibubi.create.foundation.utility.Components;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.AbstractSelectionListAccessor;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.AbstractWidgetAccessor;

import org.lwjgl.glfw.GLFW;
import com.simibubi.create.foundation.config.ui.compat.flywheel.FlwConfigScreen;
import com.simibubi.create.foundation.gui.AllIcons;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.gui.Theme;
import com.simibubi.create.foundation.gui.element.DelegatedStencilElement;
import com.simibubi.create.foundation.gui.widget.BoxWidget;
import com.simibubi.create.foundation.item.TooltipHelper;
import com.simibubi.create.foundation.item.TooltipHelper.Palette;

import net.fabricmc.loader.api.FabricLoader;
import net.minecraft.class_332;
import net.minecraft.class_437;

public class ConfigModListScreen extends ConfigScreen {

	ConfigScreenList list;
	HintableTextFieldWidget search;
	BoxWidget goBack;
	List<ModEntry> allEntries;

	public ConfigModListScreen(class_437 parent) {
		super(parent);
	}

	@Override
	protected void method_25426() {
		super.method_25426();

		int listWidth = Math.min(field_22789 - 80, 300);

		list = new ConfigScreenList(field_22787, listWidth, field_22790 - 60, 15, field_22790 - 45, 40);
		list.method_25333(this.field_22789 / 2 - ((AbstractSelectionListAccessor) list).port_lib$getWidth() / 2);
		method_37063(list);

		allEntries = new ArrayList<>();
		FabricLoader.getInstance().getAllMods().forEach(container -> allEntries.add(new ModEntry(container.getMetadata().getId(), this)));
//		ModList.get().getMods().stream().map(IModInfo::getModId).forEach(id -> allEntries.add(new ModEntry(id, this)));
		allEntries.sort((e1, e2) -> {
			int empty = (e2.button.field_22763 ? 1 : 0) - (e1.button.field_22763 ? 1 : 0);
			if (empty != 0)
				return empty;

			return e1.id.compareToIgnoreCase(e2.id);
		});
		list.method_25396().clear();
		list.method_25396().addAll(allEntries);

		goBack = new BoxWidget(field_22789 / 2 - listWidth / 2 - 30, field_22790 / 2 + 65, 20, 20).withPadding(2, 2)
				.withCallback(() -> ScreenOpener.open(parent));
		goBack.showingElement(AllIcons.I_CONFIG_BACK.asStencil()
				.withElementRenderer(BoxWidget.gradientFactory.apply(goBack)));
		goBack.getToolTip()
				.add(Components.literal("Go Back"));
		method_37063(goBack);

		search = new HintableTextFieldWidget(field_22793, field_22789 / 2 - listWidth / 2, field_22790 - 35, listWidth, 20);
		search.method_1863(this::updateFilter);
		search.setHint("Search...");
		search.method_1870();
		method_37063(search);
	}

	@Override
	public boolean method_25404(int keyCode, int scanCode, int modifiers) {
		if (super.method_25404(keyCode, scanCode, modifiers))
			return true;
		if (keyCode == GLFW.GLFW_KEY_BACKSPACE) {
			ScreenOpener.open(parent);
		}
		return false;
	}

	private void updateFilter(String search) {
		list.method_25396().clear();
		allEntries
				.stream()
				.filter(modEntry -> modEntry.id.contains(search.toLowerCase(Locale.ROOT)))
				.forEach(list.method_25396()::add);

		list.method_25307(list.method_25341());
		if (list.method_25396().size() > 0) {
			this.search.method_1868(Theme.i(Theme.Key.TEXT));
		} else {
			this.search.method_1868(Theme.i(Theme.Key.BUTTON_FAIL));
		}
	}

	public static class ModEntry extends ConfigScreenList.LabeledEntry {

		protected BoxWidget button;
		protected String id;

		public ModEntry(String id, class_437 parent) {
			super(toHumanReadable(id));
			this.id = id;

			button = new BoxWidget(0, 0, 35, 16)
					.showingElement(AllIcons.I_CONFIG_OPEN.asStencil().at(10, 0));
			button.modifyElement(e -> ((DelegatedStencilElement) e).withElementRenderer(BoxWidget.gradientFactory.apply(button)));

			if (ConfigHelper.hasAnyForgeConfig(id)) {
				button.withCallback(() -> ScreenOpener.open(new BaseConfigScreen(parent, id)));
			} else if (id.equals("flywheel")) {
				button.withCallback(() -> ScreenOpener.open(new FlwConfigScreen(parent, id)));
			} else {
				button.field_22763 = false;
				button.updateColorsFromState();
				button.modifyElement(e -> ((DelegatedStencilElement) e).withElementRenderer(BaseConfigScreen.DISABLED_RENDERER));
				labelTooltip.add(Components.literal(toHumanReadable(id)));
				labelTooltip.addAll(TooltipHelper.cutStringTextComponent("This Mod does not have any configs registered or is not using a compatible config system", Palette.ALL_GRAY));
			}

			listeners.add(button);
		}

		public String getId() {
			return id;
		}

		@Override
		public void tick() {
			super.tick();
			button.tick();
		}

		@Override
		public void method_25343(class_332 graphics, int index, int y, int x, int width, int height, int mouseX, int mouseY, boolean p_230432_9_, float partialTicks) {
			super.method_25343(graphics, index, y, x, width, height, mouseX, mouseY, p_230432_9_, partialTicks);

			button.method_46421(x + width - 108);
			button.method_46419(y + 10);
			((AbstractWidgetAccessor) button).port_lib$setHeight(height - 20);
			button.method_25394(graphics, mouseX, mouseY, partialTicks);
		}

		@Override
		protected int getLabelWidth(int totalWidth) {
			return (int) (totalWidth * labelWidthMult) + 30;
		}
	}
}
