package com.simibubi.create.foundation.config.ui;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_332;
import net.minecraft.class_437;
import net.minecraft.class_4587;
import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.util.TriConsumer;
import org.jetbrains.annotations.NotNull;
import org.lwjgl.opengl.GL30;

import com.mojang.blaze3d.platform.GlStateManager;
import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.content.kinetics.simpleRelays.CogWheelBlock;
import com.simibubi.create.foundation.gui.AbstractSimiScreen;
import com.simibubi.create.foundation.gui.UIRenderHelper;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import com.simibubi.create.foundation.gui.element.StencilElement;
import com.simibubi.create.foundation.utility.animation.Force;
import com.simibubi.create.foundation.utility.animation.PhysicalFloat;
import com.simibubi.create.infrastructure.gui.CreateMainMenuScreen;

public abstract class ConfigScreen extends AbstractSimiScreen {

	/*
	 *
	 * TODO
	 *
	 * reduce number of packets sent to the server when saving a bunch of values
	 *
	 * FIXME
	 *
	 * tooltips are hidden underneath the scrollbar, if the bar is near the middle
	 *
	 */

	public static final Map<String, TriConsumer<class_437, class_332, Float>> backgrounds = new HashMap<>();
	public static final PhysicalFloat cogSpin = PhysicalFloat.create().withLimit(10f).withDrag(0.3).addForce(new Force.Static(.2f));
	public static final class_2680 cogwheelState = AllBlocks.LARGE_COGWHEEL.getDefaultState().method_11657(CogWheelBlock.AXIS, class_2350.class_2351.field_11052);
	public static String modID = null;
	protected final class_437 parent;

	public ConfigScreen(class_437 parent) {
		this.parent = parent;
	}

	@Override
	public void method_25393() {
		super.method_25393();
		cogSpin.tick();
	}

//	@Override
//	public void renderBackground(GuiGraphics graphics) {
//		net.minecraftforge.common.MinecraftForge.EVENT_BUS.post(new ScreenEvent.BackgroundRendered(this, graphics));
//	}

	@Override
	protected void renderWindowBackground(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		if (this.field_22787 != null && this.field_22787.field_1687 != null) {
			//in game
			graphics.method_25294(0, 0, this.field_22789, this.field_22790, 0xb0_282c34);
		} else {
			//in menus
			renderMenuBackground(graphics, partialTicks);
		}

		new StencilElement() {
			@Override
			protected void renderStencil(class_332 graphics) {
				renderCog(graphics, partialTicks);
			}

			@Override
			protected void renderElement(class_332 graphics) {
				graphics.method_25294(-200, -200, 200, 200, 0x60_000000);
			}
		}.at(field_22789 * 0.5f, field_22790 * 0.5f, 0).render(graphics);

		super.renderWindowBackground(graphics, mouseX, mouseY, partialTicks);

	}

	@Override
	protected void prepareFrame() {
		UIRenderHelper.swapAndBlitColor(field_22787.method_1522(), UIRenderHelper.framebuffer);
		RenderSystem.clear(GL30.GL_STENCIL_BUFFER_BIT | GL30.GL_DEPTH_BUFFER_BIT, class_310.field_1703);
	}

	@Override
	protected void endFrame() {
		UIRenderHelper.swapAndBlitColor(UIRenderHelper.framebuffer, field_22787.method_1522());
	}

	@Override
	protected void renderWindow(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
	}

	@Override
	public boolean method_25401(double mouseX, double mouseY, double delta) {
		cogSpin.bump(3, -delta * 5);

		return super.method_25401(mouseX, mouseY, delta);
	}

	@Override
	public boolean method_25421() {
		return true;
	}

	public static String toHumanReadable(String key) {
		String s = key.replaceAll("_", " ");
		s = Arrays.stream(StringUtils.splitByCharacterTypeCamelCase(s)).map(StringUtils::capitalize).collect(Collectors.joining(" "));
		s = StringUtils.normalizeSpace(s);
		return s;
	}

	/**
	 * By default ConfigScreens will render the Create Panorama as
	 * their background when opened from the Main- or ModList-Menu.
	 * If your addon wants to render something else, please add to the
	 * backgrounds Map in this Class with your modID as the key.
	 */
	protected void renderMenuBackground(class_332 graphics, float partialTicks) {
		TriConsumer<class_437, class_332, Float> customBackground = backgrounds.get(modID);
		if (customBackground != null) {
			customBackground.accept(this, graphics, partialTicks);
			return;
		}

		float elapsedPartials = field_22787.method_1534();
		CreateMainMenuScreen.PANORAMA.method_3317(elapsedPartials, 1);

		RenderSystem.enableBlend();
		RenderSystem.blendFunc(GlStateManager.class_4535.SRC_ALPHA, GlStateManager.class_4534.ONE_MINUS_SRC_ALPHA);
		graphics.method_25293(CreateMainMenuScreen.PANORAMA_OVERLAY_TEXTURES, 0, 0, this.field_22789, this.field_22790, 0.0F, 0.0F, 16, 128, 16, 128);

		graphics.method_25294(0, 0, this.field_22789, this.field_22790, 0x90_282c34);
	}

	protected void renderCog(class_332 graphics, float partialTicks) {
		class_4587 ms = graphics.method_51448();
		ms.method_22903();

		ms.method_46416(-100, 100, -100);
		ms.method_22905(200, 200, 1);
		GuiGameElement.of(cogwheelState)
				.rotateBlock(22.5, cogSpin.getValue(partialTicks), 22.5)
				.render(graphics);

		ms.method_22909();
	}

	@Override
	public void method_25434(@NotNull class_332 graphics) {
	}
}
