package com.simibubi.create.foundation.config.ui.compat.flywheel;

import java.util.Locale;

import org.jetbrains.annotations.NotNull;

import com.jozufozu.flywheel.config.FlwConfig;
import com.simibubi.create.foundation.config.ui.BaseConfigScreen;
import com.simibubi.create.foundation.config.ui.ConfigModListScreen;
import com.simibubi.create.foundation.config.ui.ConfigScreen;
import com.simibubi.create.foundation.gui.AllIcons;
import com.simibubi.create.foundation.gui.Theme;
import com.simibubi.create.foundation.gui.UIRenderHelper;
import com.simibubi.create.foundation.gui.element.TextStencilElement;
import com.simibubi.create.foundation.gui.widget.BoxWidget;
import net.minecraft.class_2561;
import net.minecraft.class_437;
import net.minecraftforge.fml.config.ModConfig;

public class FlwConfigScreen extends BaseConfigScreen {

	private final FlwConfig flwConfig;

	public FlwConfigScreen(class_437 parent, @NotNull String modID) {
		super(parent, modID);
		flwConfig = FlwConfig.get();
	}

	@Override
	protected void method_25426() {
		guiLeft = (field_22789 - windowWidth) / 2;
		guiTop = (field_22790 - windowHeight) / 2;
		guiLeft += windowXOffset;
		guiTop += windowYOffset;
		returnOnClose = true;

		TextStencilElement clientText = new TextStencilElement(field_22787.field_1772, class_2561.method_43470(clientTitle)).centered(true, true);
		method_37063(clientConfigWidget = new BoxWidget(field_22789 / 2 - 100, field_22790 / 2 - 15 - 30, 200, 16).showingElement(clientText));

		if (flwConfig != null) {
			clientConfigWidget.withCallback(() -> linkTo(new FlwSubMenuConfigScreen(this, ModConfig.Type.CLIENT, flwConfig)));
			clientText.withElementRenderer(BoxWidget.gradientFactory.apply(clientConfigWidget));
		} else {
			clientConfigWidget.field_22763 = false;
			clientConfigWidget.updateColorsFromState();
			clientText.withElementRenderer(DISABLED_RENDERER);
		}

		TextStencilElement commonText = new TextStencilElement(field_22787.field_1772, class_2561.method_43470(commonTitle)).centered(true, true);
		method_37063(commonConfigWidget = new BoxWidget(field_22789 / 2 - 100, field_22790 / 2 - 15, 200, 16).showingElement(commonText));

		commonConfigWidget.field_22763 = false;
		commonConfigWidget.updateColorsFromState();
		commonText.withElementRenderer(DISABLED_RENDERER);


		TextStencilElement serverText = new TextStencilElement(field_22787.field_1772, class_2561.method_43470(serverTitle)).centered(true, true);
		method_37063(serverConfigWidget = new BoxWidget(field_22789 / 2 - 100, field_22790 / 2 - 15 + 30, 200, 16).showingElement(serverText));

		serverConfigWidget.field_22763 = false;
		serverConfigWidget.updateColorsFromState();
		serverText.withElementRenderer(DISABLED_RENDERER);

		TextStencilElement titleText = new TextStencilElement(field_22787.field_1772, modID.toUpperCase(Locale.ROOT))
				.centered(true, true)
				.withElementRenderer((ms, w, h, alpha) -> {
					UIRenderHelper.angledGradient(ms, 0, 0, h / 2, h, w / 2, Theme.p(Theme.Key.CONFIG_TITLE_A));
					UIRenderHelper.angledGradient(ms, 0, w / 2, h / 2, h, w / 2, Theme.p(Theme.Key.CONFIG_TITLE_B));
				});
		int boxWidth = field_22789 + 10;
		int boxHeight = 39;
		int boxPadding = 4;
		title = new BoxWidget(-5, field_22790 / 2 - 110, boxWidth, boxHeight)
				//.withCustomBackground(new Color(0x20_000000, true))
				.withBorderColors(Theme.p(Theme.Key.BUTTON_IDLE))
				.withPadding(0, boxPadding)
				.rescaleElement(boxWidth / 2f, (boxHeight - 2 * boxPadding) / 2f)//double the text size by telling it the element is only half as big as the available space
				.showingElement(titleText.at(0, 7));
		title.field_22763 = false;

		method_37063(title);


		ConfigScreen.modID = this.modID;

		goBack = new BoxWidget(field_22789 / 2 - 134, field_22790 / 2, 20, 20).withPadding(2, 2)
				.withCallback(this::method_25419);
		goBack.showingElement(AllIcons.I_CONFIG_BACK.asStencil()
				.withElementRenderer(BoxWidget.gradientFactory.apply(goBack)));
		goBack.getToolTip()
				.add(class_2561.method_43470("Go Back"));
		method_37063(goBack);

		TextStencilElement othersText = new TextStencilElement(field_22787.field_1772, class_2561.method_43470("Access Configs of other Mods")).centered(true, true);
		others = new BoxWidget(field_22789 / 2 - 100, field_22790 / 2 - 15 + 90, 200, 16).showingElement(othersText);
		othersText.withElementRenderer(BoxWidget.gradientFactory.apply(others));
		others.withCallback(() -> linkTo(new ConfigModListScreen(this)));
		method_37063(others);
	}
}
