package com.simibubi.create.foundation.data;

import java.util.function.Function;
import java.util.stream.Stream;

import com.simibubi.create.AllTags;
import com.simibubi.create.AllTags.AllBlockTags;
import com.simibubi.create.AllTags.AllEntityTags;
import com.simibubi.create.AllTags.AllFluidTags;
import com.simibubi.create.AllTags.AllItemTags;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.data.recipe.Mods;
import com.simibubi.create.foundation.mixin.fabric.TagAppenderAccessor;
import com.tterrag.registrate.builders.BlockBuilder;
import com.tterrag.registrate.builders.ItemBuilder;
import com.tterrag.registrate.providers.ProviderType;
import com.tterrag.registrate.providers.RegistrateTagsProvider;
import com.tterrag.registrate.util.nullness.NonNullFunction;

import io.github.fabricators_of_create.porting_lib.tags.Tags;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricTagProvider;
import net.minecraft.class_1299;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_1802;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2474;
import net.minecraft.class_2474.class_5124;
import net.minecraft.class_3481;
import net.minecraft.class_3486;
import net.minecraft.class_3489;
import net.minecraft.class_3495;
import net.minecraft.class_3611;
import net.minecraft.class_3612;
import net.minecraft.class_5321;
import net.minecraft.class_6862;
import net.minecraft.class_6880;
import org.jetbrains.annotations.NotNull;

public class TagGen {
	public static <T extends class_2248, P> NonNullFunction<BlockBuilder<T, P>, BlockBuilder<T, P>> axeOrPickaxe() {
		return b -> b.tag(class_3481.field_33713)
			.tag(class_3481.field_33715);
	}

	public static <T extends class_2248, P> NonNullFunction<BlockBuilder<T, P>, BlockBuilder<T, P>> axeOnly() {
		return b -> b.tag(class_3481.field_33713);
	}

	public static <T extends class_2248, P> NonNullFunction<BlockBuilder<T, P>, BlockBuilder<T, P>> pickaxeOnly() {
		return b -> b.tag(class_3481.field_33715);
	}

	public static <T extends class_2248, P> NonNullFunction<BlockBuilder<T, P>, ItemBuilder<class_1747, BlockBuilder<T, P>>> tagBlockAndItem(
		String... path) {
		return b -> {
			for (String p : path)
				b.tag(AllTags.forgeBlockTag(p));
			ItemBuilder<class_1747, BlockBuilder<T, P>> item = b.item();
			for (String p : path)
				item.tag(AllTags.forgeItemTag(p));
			return item;
		};
	}

	public static <T extends class_5124<?>> T addOptional(T appender, Mods mod, String id) {
		appender.method_35922(mod.asResource(id));
		return appender;
	}

	public static <T extends class_5124<?>> T addOptional(T appender, Mods mod, String... ids) {
		for (String id : ids) {
			appender.method_35922(mod.asResource(id));
		}
		return appender;
	}

	public static void datagen() {
		Create.REGISTRATE.addDataGenerator(ProviderType.BLOCK_TAGS, TagGen::genBlockTags);
		Create.REGISTRATE.addDataGenerator(ProviderType.ITEM_TAGS, TagGen::genItemTags);
		Create.REGISTRATE.addDataGenerator(ProviderType.FLUID_TAGS, TagGen::genFluidTags);
		Create.REGISTRATE.addDataGenerator(ProviderType.ENTITY_TAGS, TagGen::genEntityTags);
	}

	private static void genBlockTags(RegistrateTagsProvider<class_2248> provIn) {
		CreateTagsProvider<class_2248> prov = new CreateTagsProvider<>(provIn, class_2248::method_40142);
		prov.tag(AllBlockTags.BRITTLE.tag)
			.add(class_2246.field_16332, class_2246.field_10302, class_2246.field_10495)
			.method_26792(class_3481.field_16443)
			.method_26792(class_3481.field_15495);
		prov.tag(AllBlockTags.MOVABLE_EMPTY_COLLIDER.tag)
			.add(class_2246.field_10343, class_2246.field_27879, class_2246.field_10589, class_2246.field_10348)
			.method_26792(class_3481.field_25147);

		prov.tag(AllBlockTags.FAN_TRANSPARENT.tag)
			.add(class_2246.field_10576)
			.add(class_2246.field_37546)
			.method_26792(class_3481.field_23799)
			.method_26792(class_3481.field_16584)
			.method_26792(class_3481.field_15503);

		prov.tag(AllBlockTags.ORE_OVERRIDE_STONE.tag)
			.method_26792(class_3481.field_28992);

		prov.tag(AllBlockTags.PASSIVE_BOILER_HEATERS.tag)
			.add(class_2246.field_10092, class_2246.field_10164)
			.method_26792(class_3481.field_23799)
			.method_26792(class_3481.field_21952);

		prov.tag(AllBlockTags.SAFE_NBT.tag)
			.method_26792(class_3481.field_15501)
			.method_26792(class_3481.field_15500);

		prov.tag(AllBlockTags.TREE_ATTACHMENTS.tag)
			.add(class_2246.field_20421, class_2246.field_10302, class_2246.field_37544, class_2246.field_28680, class_2246.field_22122, class_2246.field_10597);

		prov.tag(AllBlockTags.WINDMILL_SAILS.tag)
			.method_26792(class_3481.field_15481);

		prov.tag(AllBlockTags.WRENCH_PICKUP.tag)
			.add(class_2246.field_10091, class_2246.field_10523, class_2246.field_10450, class_2246.field_10363,
					class_2246.field_10377, class_2246.field_10282, class_2246.field_10301, class_2246.field_10560, class_2246.field_10615,
					class_2246.field_10589, class_2246.field_10348, class_2246.field_10429, class_2246.field_22422, class_2246.field_10312)
			.method_26792(class_3481.field_15493)
			.method_26792(class_3481.field_24076)
			.method_26792(class_3481.field_15463);

		prov.tag(AllBlockTags.COPYCAT_ALLOW.tag)
			.add(class_2246.field_16328);
		prov.tag(AllBlockTags.COPYCAT_DENY.tag)
			.method_26792(class_3481.field_26985)
			.method_26792(class_3481.field_15462)
			.method_26792(class_3481.field_22414);

		// COMPAT

		addOptional(prov.tag(AllBlockTags.NON_MOVABLE.tag), Mods.IE,
				"connector_lv", "connector_lv_relay", "connector_mv", "connector_mv_relay",
				"connector_hv", "connector_hv_relay", "connector_bundled", "connector_structural",
				"connector_redstone", "connector_probe", "breaker_switch");

		// VALIDATE

		for (AllBlockTags tag : AllBlockTags.values()) {
			if (tag.alwaysDatagen) {
				prov.tag(tag.tag);
			}
		}
	}

	private static void genItemTags(RegistrateTagsProvider<class_1792> provIn) {
		CreateTagsProvider<class_1792> prov = new CreateTagsProvider<>(provIn, class_1792::method_40131);

		prov.tag(AllItemTags.SLEEPERS.tag)
			.add(class_1802.field_8595, class_1802.field_8291, class_1802.field_8742);

		prov.tag(AllItemTags.STRIPPED_LOGS.tag)
			.method_26792(AllItemTags.VANILLA_STRIPPED_LOGS.tag)
			.method_26792(AllItemTags.MODDED_STRIPPED_LOGS.tag);

		prov.tag(AllItemTags.STRIPPED_WOOD.tag)
			.method_26792(AllItemTags.VANILLA_STRIPPED_WOOD.tag)
			.method_26792(AllItemTags.MODDED_STRIPPED_WOOD.tag);

		prov.tag(AllItemTags.DEPLOYABLE_DRINK.tag)
			.add(class_1802.field_8103, class_1802.field_8574);

		prov.tag(AllItemTags.UPRIGHT_ON_BELT.tag)
			.add(class_1802.field_8469, class_1802.field_8574, class_1802.field_8436, class_1802.field_8150,
					class_1802.field_20417, class_1802.field_17534);

		prov.tag(AllItemTags.CONTRAPTION_CONTROLLED.tag)
			.add(class_1802.field_16315, class_1802.field_17346, class_1802.field_23842, class_1802.field_8357, class_1802.field_8878);

		prov.tag(AllItemTags.VANILLA_STRIPPED_LOGS.tag)
			.add(class_1802.field_8072, class_1802.field_8767, class_1802.field_21983,
					class_1802.field_8808, class_1802.field_8334, class_1802.field_37515,
					class_1802.field_8415, class_1802.field_8624, class_1802.field_21984);

		prov.tag(AllItemTags.VANILLA_STRIPPED_WOOD.tag)
			.add(class_1802.field_8284, class_1802.field_8472, class_1802.field_22487,
					class_1802.field_8219, class_1802.field_8785, class_1802.field_37509,
					class_1802.field_8248, class_1802.field_8362, class_1802.field_22488);

		prov.tag(class_3489.field_22277)
			.method_26792(AllItemTags.CREATE_INGOTS.tag);

		prov.tag(Tags.Items.INGOTS)
			.method_26792(AllItemTags.CREATE_INGOTS.tag);

		// COMPAT

		genStrippedWood(prov);

		// VALIDATE

		for (AllItemTags tag : AllItemTags.values()) {
			if (tag.alwaysDatagen) {
				prov.tag(tag.tag);
			}
		}
	}

	private static void genStrippedWood(CreateTagsProvider<class_1792> prov) {
		class_5124<class_1792> logAppender = prov.tag(AllItemTags.MODDED_STRIPPED_LOGS.tag);
		class_5124<class_1792> woodAppender = prov.tag(AllItemTags.MODDED_STRIPPED_WOOD.tag);
		StrippedWoodHelper helper = new StrippedWoodHelper(logAppender, woodAppender);

		helper.add(Mods.ARS_N, "blue_archwood", "purple_archwood", "green_archwood", "red_archwood");
		helper.add(Mods.BTN, "livingwood", "dreamwood");
		helper.add(Mods.FA, "cherrywood", "mysterywood");
		helper.add(Mods.HEX, "akashic");
		helper.add(Mods.ID, "menril");
		helper.add(Mods.BYG, "aspen", "baobab", "enchanted", "cherry", "cika", "cypress", "ebony", "ether",
			"fir", "green_enchanted", "holly", "jacaranda", "lament", "mahogany", "mangrove", "maple", "nightshade",
			"palm", "palo_verde", "pine", "rainbow_eucalyptus", "redwood", "skyris", "willow", "witch_hazel",
			"zelkova");
		helper.add(Mods.SG, "netherwood");
		helper.add(Mods.TF, "twilight_oak", "canopy", "mangrove", "dark", "time", "transformation", "mining",
			"sorting");
		helper.add(Mods.TIC, "greenheart", "skyroot", "bloodshroom");
		helper.add(Mods.AP, "twisted");
		helper.add(Mods.Q, "azalea", "blossom");
		helper.add(Mods.ECO, "coconut", "walnut", "azalea");
		helper.add(Mods.BOP, "fir", "redwood", "cherry", "mahogany", "jacaranda", "palm", "willow", "dead",
			"magic", "umbran", "hellbark");
		helper.add(Mods.BSK, "bluebright", "starlit", "frostbright", "lunar", "dusk", "maple", "cherry");

		addOptional(logAppender, Mods.BYG, "stripped_bulbis_stem");
		addOptional(woodAppender, Mods.BYG, "stripped_bulbis_wood");
	}

	private static void genFluidTags(RegistrateTagsProvider<class_3611> provIn) {
		CreateTagsProvider<class_3611> prov = new CreateTagsProvider<>(provIn, class_3611::method_40178);

		prov.tag(AllFluidTags.BOTTOMLESS_ALLOW.tag)
			.add(class_3612.field_15910, class_3612.field_15908);

		prov.tag(AllFluidTags.DIVING_FLUIDS.tag)
				.method_26792(class_3486.field_15517);

		// VALIDATE

		for (AllFluidTags tag : AllFluidTags.values()) {
			if (tag.alwaysDatagen) {
				prov.tag(tag.tag);
			}
		}
	}

	private static void genEntityTags(RegistrateTagsProvider<class_1299<?>> provIn) {
		CreateTagsProvider<class_1299<?>> prov = new CreateTagsProvider<>(provIn, class_1299::method_40124);
		// VALIDATE

		for (AllEntityTags tag : AllEntityTags.values()) {
			if (tag.alwaysDatagen) {
				prov.tag(tag.tag);
			}
		}
	}

	private static class StrippedWoodHelper {
		protected final class_5124<class_1792> logAppender;
		protected final class_5124<class_1792> woodAppender;

		public StrippedWoodHelper(class_5124<class_1792> logAppender, class_5124<class_1792> woodAppender) {
			this.logAppender = logAppender;
			this.woodAppender = woodAppender;
		}

		public void add(Mods mod, String... woodTypes) {
			for (String type : woodTypes) {
				String strippedPre = mod.strippedIsSuffix ? "" : "stripped_";
				String strippedPost = mod.strippedIsSuffix ? "_stripped" : "";
				addOptional(logAppender, mod, strippedPre + type + "_log" + strippedPost);
				addOptional(woodAppender, mod, strippedPre + type + (mod.omitWoodSuffix ? "" : "_wood") + strippedPost);
			}
		}
	}

	public static class CreateTagsProvider<T> {

		private RegistrateTagsProvider<T> provider;
		private Function<T, class_5321<T>> keyExtractor;

		public CreateTagsProvider(RegistrateTagsProvider<T> provider, Function<T, class_6880.class_6883<T>> refExtractor) {
			this.provider = provider;
			this.keyExtractor = refExtractor.andThen(class_6880.class_6883::method_40237);
		}

		public CreateTagAppender<T> tag(class_6862<T> tag) {
			FabricTagProvider<T>.FabricTagBuilder fabricBuilder = provider.addTag(tag);
			return new CreateTagAppender<>(fabricBuilder, keyExtractor);
		}

		public class_3495 getOrCreateRawBuilder(class_6862<T> tag) {
			return provider.addTag(tag).field_23960;
		}
	}

	public static class CreateTagAppender<T> extends class_2474.class_5124<T> {

		private Function<T, class_5321<T>> keyExtractor;
		private FabricTagProvider<T>.FabricTagBuilder fabricBuilder;

		public CreateTagAppender(FabricTagProvider<T>.FabricTagBuilder fabricBuilder, Function<T, class_5321<T>> pKeyExtractor) {
			//noinspection DataFlowIssue
			super(((TagAppenderAccessor) (Object) fabricBuilder).getBuilder());
			this.fabricBuilder = fabricBuilder;
			this.keyExtractor = pKeyExtractor;
		}

		public CreateTagAppender<T> add(T entry) {
			this.method_46835(this.keyExtractor.apply(entry));
			return this;
		}

		@SafeVarargs
		public final CreateTagAppender<T> add(T... entries) {
			Stream.<T>of(entries)
				.map(this.keyExtractor)
				.forEach(this::method_46835);
			return this;
		}

		@Override
		@NotNull
		public class_5124<T> method_26792(@NotNull class_6862<T> tag) {
			// fabric: need to force add, since the vanilla tag validation doesn't work
			fabricBuilder.forceAddTag(tag);
			return this;
		}
	}
}
