package com.simibubi.create.foundation.data.recipe;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Consumer;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllTags;
import com.simibubi.create.Create;

import io.github.fabricators_of_create.porting_lib.tags.Tags;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricRecipeProvider;
import net.minecraft.class_1792;
import net.minecraft.class_1802;
import net.minecraft.class_1856;
import net.minecraft.class_1935;
import net.minecraft.class_2444;
import net.minecraft.class_3489;
import net.minecraft.class_6862;

public abstract class CreateRecipeProvider extends FabricRecipeProvider {

	protected final List<GeneratedRecipe> all = new ArrayList<>();

	public CreateRecipeProvider(FabricDataOutput output) {
		super(output);
	}

	@Override
	public void method_10419(Consumer<class_2444> p_200404_1_) {
		all.forEach(c -> c.register(p_200404_1_));
		Create.LOGGER.info(method_10321() + " registered " + all.size() + " recipe" + (all.size() == 1 ? "" : "s"));
	}

	protected GeneratedRecipe register(GeneratedRecipe recipe) {
		all.add(recipe);
		return recipe;
	}

	@FunctionalInterface
	public interface GeneratedRecipe {
		void register(Consumer<class_2444> consumer);
	}

	protected static class Marker {
	}

	protected static class I {

		static class_6862<class_1792> redstone() {
			return Tags.Items.DUSTS_REDSTONE;
		}

		static class_6862<class_1792> planks() {
			return class_3489.field_15537;
		}

		static class_6862<class_1792> woodSlab() {
			return class_3489.field_15534;
		}

		static class_6862<class_1792> gold() {
			return AllTags.forgeItemTag("gold_ingots");
		}

		static class_6862<class_1792> goldSheet() {
			return AllTags.forgeItemTag("gold_plates");
		}

		static class_6862<class_1792> stone() {
			return Tags.Items.STONE;
		}

		static class_1935 andesite() {
			return AllItems.ANDESITE_ALLOY.get();
		}

		static class_1935 shaft() {
			return AllBlocks.SHAFT.get();
		}

		static class_1935 cog() {
			return AllBlocks.COGWHEEL.get();
		}

		static class_1935 largeCog() {
			return AllBlocks.LARGE_COGWHEEL.get();
		}

		static class_1935 andesiteCasing() {
			return AllBlocks.ANDESITE_CASING.get();
		}

		static class_6862<class_1792> brass() {
			return AllTags.forgeItemTag("brass_ingots");
		}

		static class_6862<class_1792> brassSheet() {
			return AllTags.forgeItemTag("brass_plates");
		}

		static class_6862<class_1792> iron() {
			return Tags.Items.INGOTS_IRON;
		}

		static class_6862<class_1792> ironNugget() {
			return AllTags.forgeItemTag("iron_nuggets");
		}

		static class_6862<class_1792> zinc() {
			return AllTags.forgeItemTag("zinc_ingots");
		}

		static class_6862<class_1792> ironSheet() {
			return AllTags.forgeItemTag("iron_plates");
		}

		static class_6862<class_1792> sturdySheet() {
			return AllTags.forgeItemTag("obsidian_plates");
		}

		static class_1935 brassCasing() {
			return AllBlocks.BRASS_CASING.get();
		}

		static class_1935 railwayCasing() {
			return AllBlocks.RAILWAY_CASING.get();
		}

		static class_1935 electronTube() {
			return AllItems.ELECTRON_TUBE.get();
		}

		static class_1935 precisionMechanism() {
			return AllItems.PRECISION_MECHANISM.get();
		}

		static class_1935 copperBlock() {
			return class_1802.field_27071;
		}

		static class_6862<class_1792> brassBlock() {
			return AllTags.forgeItemTag("brass_blocks");
		}

		static class_6862<class_1792> zincBlock() {
			return AllTags.forgeItemTag("zinc_blocks");
		}

		static class_6862<class_1792> wheatFlour() {
			return AllTags.forgeItemTag("wheat_flour");
		}

		static class_1935 copper() {
			return class_1802.field_27022;
		}

		static class_6862<class_1792> copperSheet() {
			return AllTags.forgeItemTag("copper_plates");
		}

		static class_6862<class_1792> copperNugget() {
			return AllTags.forgeItemTag("copper_nuggets");
		}

		static class_6862<class_1792> brassNugget() {
			return AllTags.forgeItemTag("brass_nuggets");
		}

		static class_6862<class_1792> zincNugget() {
			return AllTags.forgeItemTag("zinc_nuggets");
		}

		static class_1935 copperCasing() {
			return AllBlocks.COPPER_CASING.get();
		}

		static class_1935 refinedRadiance() {
			return AllItems.REFINED_RADIANCE.get();
		}

		static class_1935 shadowSteel() {
			return AllItems.SHADOW_STEEL.get();
		}

		static class_1856 netherite() {
			return class_1856.method_8106(AllTags.forgeItemTag("netherite_ingots"));
		}

	}
}
