package com.simibubi.create.foundation.data.recipe;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllRecipeTypes;

import net.fabricmc.fabric.api.datagen.v1.FabricDataGenerator;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.minecraft.class_2246;
import net.minecraft.class_2248;

public class CuttingRecipeGen extends ProcessingRecipeGen {

	GeneratedRecipe

	ANDESITE_ALLOY = create(I::andesite, b -> b.duration(200)
		.output(AllBlocks.SHAFT.get(), 6)),

		BAMBOO_PLANKS = create(() -> class_2246.field_40294, b -> b.duration(20)
			.output(class_2246.field_40295, 1)),

		OAK_WOOD = stripAndMakePlanks(class_2246.field_10126, class_2246.field_10250, class_2246.field_10161),
		SPRUCE_WOOD = stripAndMakePlanks(class_2246.field_10155, class_2246.field_10558, class_2246.field_9975),
		BIRCH_WOOD = stripAndMakePlanks(class_2246.field_10307, class_2246.field_10204, class_2246.field_10148),
		JUNGLE_WOOD = stripAndMakePlanks(class_2246.field_10303, class_2246.field_10084, class_2246.field_10334),
		ACACIA_WOOD = stripAndMakePlanks(class_2246.field_9999, class_2246.field_10103, class_2246.field_10218),
		CHERRY_WOOD = stripAndMakePlanks(class_2246.field_42733, class_2246.field_42730, class_2246.field_42751),
		DARK_OAK_WOOD = stripAndMakePlanks(class_2246.field_10178, class_2246.field_10374, class_2246.field_10075),
		MANGROVE_WOOD = stripAndMakePlanks(class_2246.field_37549, class_2246.field_37550, class_2246.field_37577),
		CRIMSON_WOOD = stripAndMakePlanks(class_2246.field_22505, class_2246.field_22506, class_2246.field_22126),
		WARPED_WOOD = stripAndMakePlanks(class_2246.field_22503, class_2246.field_22504, class_2246.field_22127),

		OAK_LOG = stripAndMakePlanks(class_2246.field_10431, class_2246.field_10519, class_2246.field_10161),
		SPRUCE_LOG = stripAndMakePlanks(class_2246.field_10037, class_2246.field_10436, class_2246.field_9975),
		BIRCH_LOG = stripAndMakePlanks(class_2246.field_10511, class_2246.field_10366, class_2246.field_10148),
		JUNGLE_LOG = stripAndMakePlanks(class_2246.field_10306, class_2246.field_10254, class_2246.field_10334),
		ACACIA_LOG = stripAndMakePlanks(class_2246.field_10533, class_2246.field_10622, class_2246.field_10218),
		CHERRY_LOG = stripAndMakePlanks(class_2246.field_42729, class_2246.field_42732, class_2246.field_42751),
		DARK_OAK_LOG = stripAndMakePlanks(class_2246.field_10010, class_2246.field_10244, class_2246.field_10075),
		MANGROVE_LOG = stripAndMakePlanks(class_2246.field_37545, class_2246.field_37548, class_2246.field_37577),
		BAMBOO_BLOCK = stripAndMakePlanks(class_2246.field_41072, class_2246.field_41073, class_2246.field_40294, 3),
		CRIMSON_LOG = stripAndMakePlanks(class_2246.field_22118, class_2246.field_22119, class_2246.field_22126),
		WARPED_LOG = stripAndMakePlanks(class_2246.field_22111, class_2246.field_22112, class_2246.field_22127),

		/*
		 * Mod compat
		 */

		// Ars Nouveau (all logs yield the same plank)
		ARS_N = cuttingCompat(Mods.ARS_N, "blue_archwood", "purple_archwood", "green_archwood", "red_archwood"),

		// Botania (stripped prefix is offset)
		BTN = cuttingCompat(Mods.BTN, "livingwood", "dreamwood"),
		BTN_2 = stripAndMakePlanks(Mods.BTN, "glimmering_livingwood_log", "glimmering_stripped_livingwood_log",
			"livingwood_planks"),
		BTN_3 = stripAndMakePlanks(Mods.BTN, "glimmering_livingwood", "glimmering_stripped_livingwood",
			"livingwood_planks"),
		BTN_4 = stripAndMakePlanks(Mods.BTN, "glimmering_dreamwood_log", "glimmering_stripped_dreamwood_log",
			"dreamwood_planks"),
		BTN_5 =
			stripAndMakePlanks(Mods.BTN, "glimmering_dreamwood", "glimmering_stripped_dreamwood", "dreamwood_planks"),

		// Forbidden Arcanus (no _wood suffix)
		FA = cuttingCompat(Mods.FA, "cherrywood", "mysterywood"),

		// Hexcasting (stripped is a suffix here)
		HEX = cuttingCompat(Mods.HEX, "edified"),

		// Integrated Dynamics (stripped is a suffix here also)
		ID = cuttingCompat(Mods.ID, "menril"),

		// Oh The Biomes You'll Go
		BYG =
			cuttingCompat(Mods.BYG, "aspen", "baobab", "blue_enchanted", "cherry", "cika", "cypress", "ebony", "ether",
				"fir", "green_enchanted", "holly", "jacaranda", "lament", "mahogany", "maple", "nightshade",
				"palm", "pine", "rainbow_eucalyptus", "redwood", "skyris", "willow", "witch_hazel", "zelkova"),
		BYG_2 = stripAndMakePlanks(Mods.BYG, "bulbis_stem", "stripped_bulbis_stem", "bulbis_planks"),
		BYG_3 = stripAndMakePlanks(Mods.BYG, "bulbis_wood", "stripped_bulbis_wood", "bulbis_planks"),
		BYG_4 = stripAndMakePlanks(Mods.BYG, null, "imparius_stem", "imparius_planks"),
		BYG_5 = stripAndMakePlanks(Mods.BYG, null, "imparius_hyphae", "imparius_planks"),
		BYG_6 = stripAndMakePlanks(Mods.BYG, null, "fungal_imparius_stem", "imparius_planks"),
		BYG_7 = stripAndMakePlanks(Mods.BYG, null, "fungal_imparius_hyphae", "imparius_planks"),
		BYG_8 = stripAndMakePlanks(Mods.BYG, "palo_verde_log", "stripped_palo_verde_log", null),
		BYG_9 = stripAndMakePlanks(Mods.BYG, "palo_verde_wood", "stripped_palo_verde_wood", null),

		// Silent Gear
		SG = cuttingCompat(Mods.SG, "netherwood"),

		// Twilight Forest
		TF = cuttingCompat(Mods.TF, "twilight_oak", "canopy", "mangrove", "dark", "time", "transformation", "mining",
			"sorting"),

		// Tinkers Construct
		TIC = cuttingCompat(Mods.TIC, "greenheart", "skyroot", "bloodshroom"),

		// Architects palette
		AP = cuttingCompat(Mods.AP, "twisted"),

		// Quark
		Q = cuttingCompat(Mods.Q, "azalea", "blossom"),

		// Ecologics
		ECO = cuttingCompat(Mods.ECO, "coconut", "walnut", "azalea"),
		ECO_2 = stripAndMakePlanks(Mods.ECO, "flowering_azalea_log", "stripped_azalea_log", null),
		ECO_3 = stripAndMakePlanks(Mods.ECO, "flowering_azalea_wood", "stripped_azalea_wood", null),

		// Biomes O' Plenty
		BOP = cuttingCompat(Mods.BOP, "fir", "redwood", "cherry", "mahogany", "jacaranda", "palm", "willow", "dead",
			"magic", "umbran", "hellbark"),

		// Blue Skies (crystallized does not have stripped variants)
		BSK = cuttingCompat(Mods.BSK, "bluebright", "starlit", "frostbright", "lunar", "dusk", "maple", "cherry"),
		BSK_2 = stripAndMakePlanks(Mods.BSK, null, "crystallized_log", "crystallized_planks"),
		BSK_3 = stripAndMakePlanks(Mods.BSK, null, "crystallized_wood", "crystallized_planks")

	;

	GeneratedRecipe stripAndMakePlanks(class_2248 wood, class_2248 stripped, class_2248 planks) {
		return stripAndMakePlanks(wood, stripped, planks, 6);
	}

	GeneratedRecipe stripAndMakePlanks(class_2248 wood, class_2248 stripped, class_2248 planks, int planksAmount) {
		create(() -> wood, b -> b.duration(50)
			.output(stripped));
		return create(() -> stripped, b -> b.duration(50)
			.output(planks, planksAmount));
	}

	GeneratedRecipe cuttingCompat(Mods mod, String... woodtypes) {
		for (String type : woodtypes) {
			String planks = type + "_planks";

			if (mod == Mods.ARS_N && type.contains("archwood"))
				planks = "archwood_planks";

			String strippedPre = mod.strippedIsSuffix ? "" : "stripped_";
			String strippedPost = mod.strippedIsSuffix ? "_stripped" : "";
			stripAndMakePlanks(mod, type + "_log", strippedPre + type + "_log" + strippedPost, planks);

			String wood = type + (mod.omitWoodSuffix ? "" : "_wood");
			stripAndMakePlanks(mod, wood, strippedPre + wood + strippedPost, planks);
		}
		return null;
	}

	GeneratedRecipe stripAndMakePlanks(Mods mod, String wood, String stripped, String planks) {
		if (wood != null)
			create("compat/" + mod.getId() + "/" + wood, b -> b.duration(50)
				.require(mod, wood)
				.output(1, mod, stripped, 1)
				.whenModLoaded(mod.getId()));
		if (planks != null)
			create("compat/" + mod.getId() + "/" + stripped, b -> b.duration(50)
				.require(mod, stripped)
				.output(1, mod, planks, 6)
				.whenModLoaded(mod.getId()));
		return null;
	}

	public CuttingRecipeGen(FabricDataOutput output) {
		super(output);
	}

	@Override
	protected AllRecipeTypes getRecipeType() {
		return AllRecipeTypes.CUTTING;
	}

}
