package com.simibubi.create.foundation.data.recipe;

import java.util.function.Supplier;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.foundation.block.CopperBlockSet;
import com.simibubi.create.foundation.block.CopperBlockSet.Variant;

import net.fabricmc.fabric.api.datagen.v1.FabricDataGenerator;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.minecraft.class_1802;
import net.minecraft.class_1935;
import net.minecraft.class_2246;
import net.minecraft.class_5955.class_5811;

public class DeployingRecipeGen extends ProcessingRecipeGen {

	GeneratedRecipe COPPER_TILES = copperChain(AllBlocks.COPPER_TILES);
	GeneratedRecipe COPPER_SHINGLES = copperChain(AllBlocks.COPPER_SHINGLES);

	GeneratedRecipe

	COGWHEEL = create("cogwheel", b -> b.require(I.shaft())
		.require(I.planks())
		.output(I.cog())),

		LARGE_COGWHEEL = create("large_cogwheel", b -> b.require(I.cog())
			.require(I.planks())
			.output(I.largeCog()));

	GeneratedRecipe

	CB1 = addWax(() -> class_2246.field_27133, () -> class_2246.field_27119),
		CB2 = addWax(() -> class_2246.field_27135, () -> class_2246.field_27118),
		CB3 = addWax(() -> class_2246.field_27134, () -> class_2246.field_27117),
		CB4 = addWax(() -> class_2246.field_33407, () -> class_2246.field_27116),

		CCB1 = addWax(() -> class_2246.field_27138, () -> class_2246.field_27124),
		CCB2 = addWax(() -> class_2246.field_27137, () -> class_2246.field_27123),
		CCB3 = addWax(() -> class_2246.field_27136, () -> class_2246.field_27122),
		CCB4 = addWax(() -> class_2246.field_33408, () -> class_2246.field_27121),

		CCST1 = addWax(() -> class_2246.field_27167, () -> class_2246.field_27128),
		CCST2 = addWax(() -> class_2246.field_27166, () -> class_2246.field_27127),
		CCST3 = addWax(() -> class_2246.field_27139, () -> class_2246.field_27126),
		CCST4 = addWax(() -> class_2246.field_33409, () -> class_2246.field_27125),

		CCS1 = addWax(() -> class_2246.field_27170, () -> class_2246.field_27132),
		CCS2 = addWax(() -> class_2246.field_27169, () -> class_2246.field_27131),
		CCS3 = addWax(() -> class_2246.field_27168, () -> class_2246.field_27130),
		CCS4 = addWax(() -> class_2246.field_33410, () -> class_2246.field_27129);

	public GeneratedRecipe copperChain(CopperBlockSet set) {
		for (Variant<?> variant : set.getVariants())
			for (class_5811 state : class_5811.values())
				addWax(set.get(variant, state, true)::get, set.get(variant, state, false)::get);
		return null;
	}

	public GeneratedRecipe addWax(Supplier<class_1935> waxed, Supplier<class_1935> nonWaxed) {
		return createWithDeferredId(idWithSuffix(waxed, "_from_adding_wax"), b -> b.require(nonWaxed.get())
			.require(class_1802.field_21087)
			.toolNotConsumed()
			.output(waxed.get()));
	}

	public DeployingRecipeGen(FabricDataOutput output) {
		super(output);
	}

	@Override
	protected AllRecipeTypes getRecipeType() {
		return AllRecipeTypes.DEPLOYING;
	}

}
