package com.simibubi.create.foundation.data.recipe;

import com.simibubi.create.AllFluids;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.AllTags.AllFluidTags;
import com.simibubi.create.content.fluids.potion.PotionFluidHandler;

import io.github.fabricators_of_create.porting_lib.tags.Tags;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidConstants;
import net.minecraft.class_1802;
import net.minecraft.class_1847;
import net.minecraft.class_3612;

public class FillingRecipeGen extends ProcessingRecipeGen {

	GeneratedRecipe

	HONEY_BOTTLE = create("honey_bottle", b -> b.require(AllFluidTags.HONEY.tag, AllFluids.HONEY_BOTTLE_AMOUNT)
		.require(class_1802.field_8469)
		.output(class_1802.field_20417)),

		BUILDERS_TEA = create("builders_tea", b -> b.require(AllFluids.TEA.get(), FluidConstants.BOTTLE)
			.require(class_1802.field_8469)
			.output(AllItems.BUILDERS_TEA.get())),

		FD_MILK = create(Mods.FD.recipeId("milk_bottle"), b -> b.require(Tags.Fluids.MILK, FluidConstants.BOTTLE)
			.require(class_1802.field_8469)
			.output(1, Mods.FD, "milk_bottle", 1)
			.whenModLoaded(Mods.FD.getId())),

		BLAZE_CAKE = create("blaze_cake", b -> b.require(class_3612.field_15908, FluidConstants.BOTTLE)
			.require(AllItems.BLAZE_CAKE_BASE.get())
			.output(AllItems.BLAZE_CAKE.get())),

		HONEYED_APPLE = create("honeyed_apple", b -> b.require(AllFluidTags.HONEY.tag, AllFluids.HONEY_BOTTLE_AMOUNT)
			.require(class_1802.field_8279)
			.output(AllItems.HONEYED_APPLE.get())),

		SWEET_ROLL = create("sweet_roll", b -> b.require(Tags.Fluids.MILK, FluidConstants.BOTTLE)
			.require(class_1802.field_8229)
			.output(AllItems.SWEET_ROLL.get())),

		CHOCOLATE_BERRIES = create("chocolate_glazed_berries", b -> b.require(AllFluids.CHOCOLATE.get(), FluidConstants.BOTTLE)
			.require(class_1802.field_16998)
			.output(AllItems.CHOCOLATE_BERRIES.get())),

		GRASS_BLOCK = create("grass_block", b -> b.require(class_3612.field_15910, FluidConstants.BUCKET / 2)
			.require(class_1802.field_8831)
			.output(class_1802.field_8270)),

		GUNPOWDER = create("gunpowder", b -> b.require(PotionFluidHandler.potionIngredient(class_1847.field_9004, FluidConstants.BUCKET / 40))
			.require(AllItems.CINDER_FLOUR.get())
			.output(class_1802.field_8054)),

		REDSTONE = create("redstone", b -> b.require(PotionFluidHandler.potionIngredient(class_1847.field_8978, FluidConstants.BUCKET / 40))
			.require(AllItems.CINDER_FLOUR.get())
			.output(class_1802.field_8725)),

		GLOWSTONE = create("glowstone", b -> b.require(PotionFluidHandler.potionIngredient(class_1847.field_8968, FluidConstants.BUCKET / 40))
			.require(AllItems.CINDER_FLOUR.get())
			.output(class_1802.field_8601))

	;

	public FillingRecipeGen(FabricDataOutput output) {
		super(output);
	}

	@Override
	protected AllRecipeTypes getRecipeType() {
		return AllRecipeTypes.FILLING;
	}

}
