package com.simibubi.create.foundation.data.recipe;

import com.simibubi.create.AllItems;
import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.AllTags;
import com.tterrag.registrate.util.entry.ItemEntry;

import net.fabricmc.fabric.api.datagen.v1.FabricDataGenerator;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.resource.conditions.v1.DefaultResourceConditions;
import net.minecraft.class_1792;
import net.minecraft.class_1802;
import net.minecraft.class_2246;
import net.minecraft.class_2960;
import net.minecraft.class_3489;
import net.minecraft.class_6862;
import net.minecraft.class_7924;

public class MillingRecipeGen extends ProcessingRecipeGen {

	GeneratedRecipe

	GRANITE = create(() -> class_2246.field_10474, b -> b.duration(200)
		.output(class_2246.field_10534)),

		WOOL = create("wool", b -> b.duration(100)
			.require(class_3489.field_15544)
			.output(class_1802.field_8276)),

		CLAY = create(() -> class_2246.field_10460, b -> b.duration(50)
			.output(class_1802.field_8696, 3)
			.output(.5f, class_1802.field_8696)),

		CALCITE = create(() -> class_1802.field_27020, b -> b.duration(250)
			.output(.75f, class_1802.field_8324, 1)),
		DRIPSTONE = create(() -> class_1802.field_28043, b -> b.duration(250)
			.output(class_1802.field_8696, 1)),

		TERRACOTTA = create(() -> class_2246.field_10415, b -> b.duration(200)
			.output(class_2246.field_10534)),
		ANDESITE = create(() -> class_2246.field_10115, b -> b.duration(200)
			.output(class_2246.field_10445)),
		COBBLESTONE = create(() -> class_2246.field_10445, b -> b.duration(250)
			.output(class_2246.field_10255)),
		GRAVEL = create(() -> class_2246.field_10255, b -> b.duration(250)
			.output(class_1802.field_8145)),
		SANDSTONE = create(() -> class_2246.field_9979, b -> b.duration(150)
			.output(class_2246.field_10102)),

		WHEAT = create(() -> class_1802.field_8861, b -> b.duration(150)
			.output(AllItems.WHEAT_FLOUR.get())
			.output(.25f, AllItems.WHEAT_FLOUR.get(), 2)
			.output(.25f, class_1802.field_8317)),

		BONE = create(() -> class_1802.field_8606, b -> b.duration(100)
			.output(class_1802.field_8324, 3)
			.output(.25f, class_1802.field_8446, 1)
			.output(.25f, class_1802.field_8324, 3)),

		CACTUS = create(() -> class_2246.field_10029, b -> b.duration(50)
			.output(class_1802.field_8408, 2)
			.output(.1f, class_1802.field_8408, 1)
			.whenModMissing("quark")),

		SEA_PICKLE = create(() -> class_2246.field_10476, b -> b.duration(50)
			.output(class_1802.field_8131, 2)
			.output(.1f, class_1802.field_8408)),

		BONE_MEAL = create(() -> class_1802.field_8324, b -> b.duration(70)
			.output(class_1802.field_8446, 2)
			.output(.1f, class_1802.field_8851, 1)),

		COCOA_BEANS = create(() -> class_1802.field_8116, b -> b.duration(70)
			.output(class_1802.field_8099, 2)
			.output(.1f, class_1802.field_8099, 1)),

		SADDLE = create(() -> class_1802.field_8175, b -> b.duration(200)
			.output(class_1802.field_8745, 2)
			.output(.5f, class_1802.field_8745, 2)),

		SUGAR_CANE = create(() -> class_1802.field_17531, b -> b.duration(50)
			.output(class_1802.field_8479, 2)
			.output(.1f, class_1802.field_8479)),

		BEETROOT = create(() -> class_1802.field_8186, b -> b.duration(70)
			.output(class_1802.field_8264, 2)
			.output(.1f, class_1802.field_8309)),

		INK_SAC = create(() -> class_1802.field_8794, b -> b.duration(100)
			.output(class_1802.field_8226, 2)
			.output(.1f, class_1802.field_8298)),

		CHARCOAL = create(() -> class_1802.field_8665, b -> b.duration(100)
			.output(class_1802.field_8226, 1)
			.output(.1f, class_1802.field_8298, 2)),

		COAL = create(() -> class_1802.field_8713, b -> b.duration(100)
			.output(class_1802.field_8226, 2)
			.output(.1f, class_1802.field_8298, 1)),

		LAPIS_LAZULI = create(() -> class_1802.field_8759, b -> b.duration(100)
			.output(class_1802.field_8345, 2)
			.output(.1f, class_1802.field_8345)),

		AZURE_BLUET = create(() -> class_2246.field_10573, b -> b.duration(50)
			.output(class_1802.field_8851, 2)
			.output(.1f, class_1802.field_8446, 2)),

		BLUE_ORCHID = create(() -> class_2246.field_10086, b -> b.duration(50)
			.output(class_1802.field_8273, 2)
			.output(.05f, class_1802.field_8851, 1)),

		FERN = create(() -> class_2246.field_10112, b -> b.duration(50)
			.output(class_1802.field_8408)
			.output(.1f, class_1802.field_8317)),

		LARGE_FERN = create(() -> class_2246.field_10313, b -> b.duration(50)
			.output(class_1802.field_8408, 2)
			.output(.5f, class_1802.field_8408)
			.output(.1f, class_1802.field_8317)),

		LILAC = create(() -> class_2246.field_10378, b -> b.duration(100)
			.output(class_1802.field_8669, 3)
			.output(.25f, class_1802.field_8669)
			.output(.25f, class_1802.field_8296)),

		PEONY = create(() -> class_2246.field_10003, b -> b.duration(100)
			.output(class_1802.field_8330, 3)
			.output(.25f, class_1802.field_8669)
			.output(.25f, class_1802.field_8330)),

		ALLIUM = create(() -> class_2246.field_10226, b -> b.duration(50)
			.output(class_1802.field_8669, 2)
			.output(.1f, class_1802.field_8296, 2)
			.output(.1f, class_1802.field_8330)),

		LILY_OF_THE_VALLEY = create(() -> class_2246.field_10548, b -> b.duration(50)
			.output(class_1802.field_8446, 2)
			.output(.1f, class_1802.field_8131)
			.output(.1f, class_1802.field_8446)),

		ROSE_BUSH = create(() -> class_2246.field_10430, b -> b.duration(50)
			.output(class_1802.field_8264, 3)
			.output(.05f, class_1802.field_8408, 2)
			.output(.25f, class_1802.field_8264, 2)),

		SUNFLOWER = create(() -> class_2246.field_10583, b -> b.duration(100)
			.output(class_1802.field_8192, 3)
			.output(.25f, class_1802.field_8492)
			.output(.25f, class_1802.field_8192)),

		OXEYE_DAISY = create(() -> class_2246.field_10554, b -> b.duration(50)
			.output(class_1802.field_8851, 2)
			.output(.2f, class_1802.field_8446)
			.output(.05f, class_1802.field_8192)),

		POPPY = create(() -> class_2246.field_10449, b -> b.duration(50)
			.output(class_1802.field_8264, 2)
			.output(.05f, class_1802.field_8408)),

		DANDELION = create(() -> class_2246.field_10182, b -> b.duration(50)
			.output(class_1802.field_8192, 2)
			.output(.05f, class_1802.field_8192)),

		CORNFLOWER = create(() -> class_2246.field_9995, b -> b.duration(50)
			.output(class_1802.field_8345, 2)),

		WITHER_ROSE = create(() -> class_2246.field_10606, b -> b.duration(50)
			.output(class_1802.field_8226, 2)
			.output(.1f, class_1802.field_8226)),

		ORANGE_TULIP = create(() -> class_2246.field_10048, b -> b.duration(50)
			.output(class_1802.field_8492, 2)
			.output(.1f, class_1802.field_8131)),

		RED_TULIP = create(() -> class_2246.field_10270, b -> b.duration(50)
			.output(class_1802.field_8264, 2)
			.output(.1f, class_1802.field_8131)),

		WHITE_TULIP = create(() -> class_2246.field_10156, b -> b.duration(50)
			.output(class_1802.field_8446, 2)
			.output(.1f, class_1802.field_8131)),

		PINK_TULIP = create(() -> class_2246.field_10315, b -> b.duration(50)
			.output(class_1802.field_8330, 2)
			.output(.1f, class_1802.field_8131)),

		TALL_GRASS = create(() -> class_2246.field_10214, b -> b.duration(100)
			.output(.5f, class_1802.field_8317)),
		GRASS = create(() -> class_2246.field_10479, b -> b.duration(50)
			.output(.25f, class_1802.field_8317))

	;

	protected GeneratedRecipe metalOre(String name, ItemEntry<? extends class_1792> crushed, int duration) {
		return create(name + "_ore", b -> b.duration(duration)
			.withCondition(DefaultResourceConditions.not(DefaultResourceConditions.tagsPopulated(class_6862.method_40092(class_7924.field_41197, new class_2960("c", name + "_ores")))))
			.require(AllTags.forgeItemTag(name + "_ores"))
			.output(crushed.get()));
	}

	public MillingRecipeGen(FabricDataOutput output) {
		super(output);
	}

	@Override
	protected AllRecipeTypes getRecipeType() {
		return AllRecipeTypes.MILLING;
	}

}
