package com.simibubi.create.foundation.data.recipe;

import com.simibubi.create.AllFluids;
import com.simibubi.create.AllItems;
import com.simibubi.create.AllRecipeTypes;
import com.simibubi.create.content.processing.recipe.HeatCondition;
import com.simibubi.create.foundation.recipe.BlockTagIngredient;

import io.github.fabricators_of_create.porting_lib.tags.Tags;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.transfer.v1.fluid.FluidConstants;
import net.minecraft.class_1802;
import net.minecraft.class_2246;
import net.minecraft.class_3481;
import net.minecraft.class_3489;
import net.minecraft.class_3612;

public class MixingRecipeGen extends ProcessingRecipeGen {

	GeneratedRecipe

	TEMP_LAVA = create("lava_from_cobble", b -> b.require(Tags.Items.COBBLESTONE)
		.output(class_3612.field_15908, FluidConstants.BUCKET / 20)
		.requiresHeat(HeatCondition.SUPERHEATED)),

		TEA = create("tea", b -> b.require(class_3612.field_15910, FluidConstants.BOTTLE)
			.require(Tags.Fluids.MILK, FluidConstants.BOTTLE)
			.require(class_3489.field_15558)
			.output(AllFluids.TEA.get(), FluidConstants.BOTTLE * 2)
			.requiresHeat(HeatCondition.HEATED)),

		CHOCOLATE = create("chocolate", b -> b.require(Tags.Fluids.MILK, FluidConstants.BOTTLE)
			.require(class_1802.field_8479)
			.require(class_1802.field_8116)
			.output(AllFluids.CHOCOLATE.get(), FluidConstants.BOTTLE)
			.requiresHeat(HeatCondition.HEATED)),

		CHOCOLATE_MELTING = create("chocolate_melting", b -> b.require(AllItems.BAR_OF_CHOCOLATE.get())
			.output(AllFluids.CHOCOLATE.get(), FluidConstants.BOTTLE)
			.requiresHeat(HeatCondition.HEATED)),

		HONEY = create("honey", b -> b.require(class_1802.field_21086)
			.output(AllFluids.HONEY.get(), FluidConstants.BUCKET)
			.requiresHeat(HeatCondition.HEATED)),

		DOUGH = create("dough_by_mixing", b -> b.require(I.wheatFlour())
			.require(class_3612.field_15910, FluidConstants.BUCKET)
			.output(AllItems.DOUGH.get(), 1)),

		BRASS_INGOT = create("brass_ingot", b -> b.require(I.copper())
			.require(I.zinc())
			.output(AllItems.BRASS_INGOT.get(), 2)
			.requiresHeat(HeatCondition.HEATED)),

		ANDESITE_ALLOY = create("andesite_alloy", b -> b.require(class_2246.field_10115)
			.require(I.ironNugget())
			.output(I.andesite(), 1)),

		ANDESITE_ALLOY_FROM_ZINC = create("andesite_alloy_from_zinc", b -> b.require(class_2246.field_10115)
			.require(I.zincNugget())
			.output(I.andesite(), 1)),

		MUD = create("mud_by_mixing", b -> b.require(BlockTagIngredient.create(class_3481.field_37397))
			.require(class_3612.field_15910, FluidConstants.BOTTLE)
			.output(class_2246.field_37576, 1))

	;

	public MixingRecipeGen(FabricDataOutput output) {
		super(output);
	}

	@Override
	protected AllRecipeTypes getRecipeType() {
		return AllRecipeTypes.MIXING;
	}

}
