package com.simibubi.create.foundation.data.recipe;

import static com.simibubi.create.foundation.data.recipe.CompatMetals.ALUMINUM;
import static com.simibubi.create.foundation.data.recipe.CompatMetals.LEAD;
import static com.simibubi.create.foundation.data.recipe.CompatMetals.NICKEL;
import static com.simibubi.create.foundation.data.recipe.CompatMetals.OSMIUM;
import static com.simibubi.create.foundation.data.recipe.CompatMetals.PLATINUM;
import static com.simibubi.create.foundation.data.recipe.CompatMetals.QUICKSILVER;
import static com.simibubi.create.foundation.data.recipe.CompatMetals.SILVER;
import static com.simibubi.create.foundation.data.recipe.CompatMetals.TIN;
import static com.simibubi.create.foundation.data.recipe.CompatMetals.URANIUM;

import java.util.function.Supplier;

import com.simibubi.create.AllItems;
import com.simibubi.create.AllRecipeTypes;
import com.tterrag.registrate.util.entry.ItemEntry;

import io.github.fabricators_of_create.porting_lib.tags.Tags;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.minecraft.class_1792;
import net.minecraft.class_1802;
import net.minecraft.class_1856;
import net.minecraft.class_1935;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2960;
import net.minecraft.class_3489;

public class WashingRecipeGen extends ProcessingRecipeGen {

	GeneratedRecipe

	WOOL = create("wool", b -> b.require(class_3489.field_15544)
		.output(class_1802.field_19044)),

		STAINED_GLASS = create("stained_glass", b -> b.require(Tags.Items.STAINED_GLASS)
			.output(class_1802.field_8280)),
		STAINED_GLASS_PANE = create("stained_glass_pane", b -> b.require(Tags.Items.STAINED_GLASS_PANES)
			.output(class_1802.field_8141)),

		GRAVEL = create(() -> class_2246.field_10255, b -> b.output(.25f, class_1802.field_8145)
			.output(.125f, class_1802.field_8675)),
		SOUL_SAND = create(() -> class_2246.field_10114, b -> b.output(.125f, class_1802.field_8155, 4)
			.output(.02f, class_1802.field_8397)),
		RED_SAND = create(() -> class_2246.field_10534, b -> b.output(.125f, class_1802.field_8397, 3)
			.output(.05f, class_1802.field_8689)),
		SAND = create(() -> class_2246.field_10102, b -> b.output(.25f, class_1802.field_8696)),

		CRUSHED_COPPER = crushedOre(AllItems.CRUSHED_COPPER, AllItems.COPPER_NUGGET::get, () -> class_1802.field_8696, .5f),
		CRUSHED_ZINC = crushedOre(AllItems.CRUSHED_ZINC, AllItems.ZINC_NUGGET::get, () -> class_1802.field_8054, .25f),
		CRUSHED_GOLD = crushedOre(AllItems.CRUSHED_GOLD, () -> class_1802.field_8397, () -> class_1802.field_8155, .5f),
		CRUSHED_IRON = crushedOre(AllItems.CRUSHED_IRON, () -> class_1802.field_8675, () -> class_1802.field_8725, .75f),

		CRUSHED_OSMIUM = moddedCrushedOre(AllItems.CRUSHED_OSMIUM, OSMIUM),
		CRUSHED_PLATINUM = moddedCrushedOre(AllItems.CRUSHED_PLATINUM, PLATINUM),
		CRUSHED_SILVER = moddedCrushedOre(AllItems.CRUSHED_SILVER, SILVER),
		CRUSHED_TIN = moddedCrushedOre(AllItems.CRUSHED_TIN, TIN),
		CRUSHED_LEAD = moddedCrushedOre(AllItems.CRUSHED_LEAD, LEAD),
		CRUSHED_QUICKSILVER = moddedCrushedOre(AllItems.CRUSHED_QUICKSILVER, QUICKSILVER),
		CRUSHED_BAUXITE = moddedCrushedOre(AllItems.CRUSHED_BAUXITE, ALUMINUM),
		CRUSHED_URANIUM = moddedCrushedOre(AllItems.CRUSHED_URANIUM, URANIUM),
		CRUSHED_NICKEL = moddedCrushedOre(AllItems.CRUSHED_NICKEL, NICKEL),

		ICE = convert(class_2246.field_10295, class_2246.field_10225), MAGMA_BLOCK = convert(class_2246.field_10092, class_2246.field_10540),

		WHITE_CONCRETE = convert(class_2246.field_10197, class_2246.field_10107),
		ORANGE_CONCRETE = convert(class_2246.field_10022, class_2246.field_10210),
		MAGENTA_CONCRETE = convert(class_2246.field_10300, class_2246.field_10585),
		LIGHT_BLUE_CONCRETE = convert(class_2246.field_10321, class_2246.field_10242),
		LIME_CONCRETE = convert(class_2246.field_10133, class_2246.field_10421),
		YELLOW_CONCRETE = convert(class_2246.field_10145, class_2246.field_10542),
		PINK_CONCRETE = convert(class_2246.field_10522, class_2246.field_10434),
		LIGHT_GRAY_CONCRETE = convert(class_2246.field_10628, class_2246.field_10172),
		GRAY_CONCRETE = convert(class_2246.field_10353, class_2246.field_10038),
		PURPLE_CONCRETE = convert(class_2246.field_10404, class_2246.field_10206),
		GREEN_CONCRETE = convert(class_2246.field_10529, class_2246.field_10367),
		BROWN_CONCRETE = convert(class_2246.field_10023, class_2246.field_10439),
		RED_CONCRETE = convert(class_2246.field_10287, class_2246.field_10058),
		BLUE_CONCRETE = convert(class_2246.field_10456, class_2246.field_10011),
		CYAN_CONCRETE = convert(class_2246.field_10233, class_2246.field_10308),
		BLACK_CONCRETE = convert(class_2246.field_10506, class_2246.field_10458),

		FLOUR = create("wheat_flour", b -> b.require(I.wheatFlour())
			.output(AllItems.DOUGH.get()))

	;

	public GeneratedRecipe convert(class_2248 block, class_2248 result) {
		return create(() -> block, b -> b.output(result));
	}

	public GeneratedRecipe crushedOre(ItemEntry<class_1792> crushed, Supplier<class_1935> nugget, Supplier<class_1935> secondary,
		float secondaryChance) {
		return create(crushed::get, b -> b.output(nugget.get(), 9)
			.output(secondaryChance, secondary.get(), 1));
	}

	public GeneratedRecipe moddedCrushedOre(ItemEntry<? extends class_1792> crushed, CompatMetals metal) {
		String metalName = metal.getName();
		for (Mods mod : metal.getMods()) {
			class_2960 nugget = mod.nuggetOf(metalName);
			create(mod.getId() + "/" + crushed.getId()
				.method_12832(),
				b -> b.withItemIngredients(class_1856.method_8091(crushed::get))
					.output(1, nugget, 9)
					.whenModLoaded(mod.getId()));
		}
		return null;
	}

	public WashingRecipeGen(FabricDataOutput output) {
		super(output);
	}

	@Override
	protected AllRecipeTypes getRecipeType() {
		return AllRecipeTypes.SPLASHING;
	}

}
