package com.simibubi.create.foundation.gui;

import java.util.Collection;
import java.util.List;
import com.simibubi.create.foundation.gui.widget.AbstractSimiWidget;
import com.simibubi.create.foundation.utility.Components;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.ScreenAccessor;
import io.github.fabricators_of_create.porting_lib.util.KeyBindingHelper;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2561;
import net.minecraft.class_332;
import net.minecraft.class_339;
import net.minecraft.class_342;
import net.minecraft.class_364;
import net.minecraft.class_3675;
import net.minecraft.class_4068;
import net.minecraft.class_437;
import net.minecraft.class_4587;
import net.minecraft.class_6379;

@Environment(EnvType.CLIENT)
public abstract class AbstractSimiScreen extends class_437 {

	protected int windowWidth, windowHeight;
	protected int windowXOffset, windowYOffset;
	protected int guiLeft, guiTop;

	protected AbstractSimiScreen(class_2561 title) {
		super(title);
	}

	protected AbstractSimiScreen() {
		this(Components.immutableEmpty());
	}

	/**
	 * This method must be called before {@code super.init()}!
	 */
	protected void setWindowSize(int width, int height) {
		windowWidth = width;
		windowHeight = height;
	}

	/**
	 * This method must be called before {@code super.init()}!
	 */
	protected void setWindowOffset(int xOffset, int yOffset) {
		windowXOffset = xOffset;
		windowYOffset = yOffset;
	}

	@Override
	protected void method_25426() {
		guiLeft = (field_22789 - windowWidth) / 2;
		guiTop = (field_22790 - windowHeight) / 2;
		guiLeft += windowXOffset;
		guiTop += windowYOffset;
	}

	@Override
	public void method_25393() {
		for (class_364 listener : method_25396()) {
			if (listener instanceof TickableGuiEventListener tickable) {
				tickable.tick();
			}
		}
	}

	@Override
	public boolean method_25402(double pMouseX, double pMouseY, int pButton) {
		if (method_25399() != null && !method_25399().method_25405(pMouseX, pMouseY))
			method_25395(null);
		return super.method_25402(pMouseX, pMouseY, pButton);
	}

	@Override
	public boolean method_25421() {
		return false;
	}

	@SuppressWarnings("unchecked")
	protected <W extends class_364 & class_4068 & class_6379> void addRenderableWidgets(W... widgets) {
		for (W widget : widgets) {
			method_37063(widget);
		}
	}

	protected <W extends class_364 & class_4068 & class_6379> void addRenderableWidgets(Collection<W> widgets) {
		for (W widget : widgets) {
			method_37063(widget);
		}
	}

	protected void removeWidgets(class_364... widgets) {
		for (class_364 widget : widgets) {
			method_37066(widget);
		}
	}

	protected void removeWidgets(Collection<? extends class_364> widgets) {
		for (class_364 widget : widgets) {
			method_37066(widget);
		}
	}

	@Override
	public void method_25394(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		partialTicks = field_22787.method_1488();
		class_4587 ms = graphics.method_51448();

		ms.method_22903();

		prepareFrame();

		renderWindowBackground(graphics, mouseX, mouseY, partialTicks);
		renderWindow(graphics, mouseX, mouseY, partialTicks);
		super.method_25394(graphics, mouseX, mouseY, partialTicks);
		renderWindowForeground(graphics, mouseX, mouseY, partialTicks);

		endFrame();

		ms.method_22909();
	}

	@Override
	public boolean method_25404(int keyCode, int scanCode, int modifiers) {
		boolean keyPressed = super.method_25404(keyCode, scanCode, modifiers);
		if (keyPressed || method_25399() instanceof class_342)
			return keyPressed;

		class_3675.class_306 mouseKey = class_3675.method_15985(keyCode, scanCode);
		if (KeyBindingHelper.isActiveAndMatches(this.field_22787.field_1690.field_1822, mouseKey)) {
			this.method_25419();
			return true;
		}

		return false;
	}

	protected void prepareFrame() {
	}

	protected void renderWindowBackground(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		method_25420(graphics);
	}

	protected abstract void renderWindow(class_332 graphics, int mouseX, int mouseY, float partialTicks);

	protected void renderWindowForeground(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		for (class_4068 widget : ((ScreenAccessor) this).port_lib$getRenderables()) {
			if (widget instanceof AbstractSimiWidget simiWidget && simiWidget.method_25405(mouseX, mouseY)
					&& simiWidget.field_22764) {
				List<class_2561> tooltip = simiWidget.getToolTip();
				if (tooltip.isEmpty())
					continue;
				int ttx = simiWidget.lockedTooltipX == -1 ? mouseX : simiWidget.lockedTooltipX + simiWidget.method_46426();
				int tty = simiWidget.lockedTooltipY == -1 ? mouseY : simiWidget.lockedTooltipY + simiWidget.method_46427();
				graphics.method_51434(field_22793, tooltip, ttx, tty);
			}
		}
	}

	protected void endFrame() {
	}

	@Deprecated
	protected void debugWindowArea(class_332 graphics) {
		graphics.method_25294(guiLeft + windowWidth, guiTop + windowHeight, guiLeft, guiTop, 0xD3D3D3D3);
	}

	@Override
	public class_364 method_25399() {
		class_364 focused = super.method_25399();
		if (focused instanceof class_339 && !((class_339) focused).method_25370())
			focused = null;
		method_25395(focused);
		return focused;
	}

}
