package com.simibubi.create.foundation.gui;

import io.github.fabricators_of_create.porting_lib.extensions.extensions.RenderTargetExtensions;
import net.minecraft.class_1041;
import net.minecraft.class_276;
import net.minecraft.class_287;
import net.minecraft.class_289;
import net.minecraft.class_290;
import net.minecraft.class_293;
import net.minecraft.class_310;
import net.minecraft.class_332;
import net.minecraft.class_4587;
import net.minecraft.class_757;
import net.minecraft.class_7833;
import org.joml.Matrix4f;
import org.lwjgl.opengl.GL20;
import org.lwjgl.opengl.GL30;
import com.mojang.blaze3d.platform.GlConst;
import com.mojang.blaze3d.platform.GlStateManager;
import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.foundation.utility.Color;
import com.simibubi.create.foundation.utility.Couple;

public class UIRenderHelper {

	/**
	 * An FBO that has a stencil buffer for use wherever stencil are necessary. Forcing the main FBO to have a stencil
	 * buffer will cause GL error spam when using fabulous graphics.
	 */
	public static CustomRenderTarget framebuffer;

	public static void init() {
		RenderSystem.recordRenderCall(() -> {
			class_1041 mainWindow = class_310.method_1551().method_22683();
			framebuffer = CustomRenderTarget.create(mainWindow);
		});
	}

	public static void updateWindowSize(class_1041 mainWindow) {
		if (framebuffer != null)
			framebuffer.method_1234(mainWindow.method_4489(), mainWindow.method_4506(), class_310.field_1703);
	}

	public static void drawFramebuffer(float alpha) {
		framebuffer.renderWithAlpha(alpha);
	}

	/**
	 * Switch from src to dst, after copying the contents of src to dst.
	 */
	public static void swapAndBlitColor(class_276 src, class_276 dst) {
		GlStateManager._glBindFramebuffer(GL30.GL_READ_FRAMEBUFFER, src.field_1476);
		GlStateManager._glBindFramebuffer(GL30.GL_DRAW_FRAMEBUFFER, dst.field_1476);
		GlStateManager._glBlitFrameBuffer(0, 0, src.field_1480, src.field_1477, 0, 0, dst.field_1480, dst.field_1477, GL30.GL_COLOR_BUFFER_BIT, GL20.GL_LINEAR);

		GlStateManager._glBindFramebuffer(GlConst.GL_FRAMEBUFFER, dst.field_1476);
	}

	public static void streak(class_332 graphics, float angle, int x, int y, int breadth, int length) {
		streak(graphics, angle, x, y, breadth, length, Theme.i(Theme.Key.STREAK));
	}
	// angle in degrees; 0° -> fading to the right
	// x and y specify the middle point of the starting edge
	// breadth is the total width of the streak

	public static void streak(class_332 graphics, float angle, int x, int y, int breadth, int length, int color) {
		int a1 = 0xa0 << 24;
		int a2 = 0x80 << 24;
		int a3 = 0x10 << 24;
		int a4 = 0x00 << 24;

		color &= 0x00FFFFFF;
		int c1 = a1 | color;
		int c2 = a2 | color;
		int c3 = a3 | color;
		int c4 = a4 | color;

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(x, y, 0);
		ms.method_22907(class_7833.field_40718.rotationDegrees(angle - 90));

		streak(graphics, breadth / 2, length, c1, c2, c3, c4);

		ms.method_22909();
	}

	public static void streak(class_332 graphics, float angle, int x, int y, int breadth, int length, Color c) {
		Color color = c.copy().setImmutable();
		int c1 = color.scaleAlpha(0.625f).getRGB();
		int c2 = color.scaleAlpha(0.5f).getRGB();
		int c3 = color.scaleAlpha(0.0625f).getRGB();
		int c4 = color.scaleAlpha(0f).getRGB();

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(x, y, 0);
		ms.method_22907(class_7833.field_40718.rotationDegrees(angle - 90));

		streak(graphics, breadth / 2, length, c1, c2, c3, c4);

		ms.method_22909();
	}

	private static void streak(class_332 graphics, int width, int height, int c1, int c2, int c3, int c4) {
		double split1 = .5;
		double split2 = .75;
		graphics.method_33284(-width, 0, width, (int) (split1 * height), 0, c1, c2);
		graphics.method_33284(-width, (int) (split1 * height), width, (int) (split2 * height), 0, c2, c3);
		graphics.method_33284(-width, (int) (split2 * height), width, height, 0, c3, c4);
	}

	public static void angledGradient(class_332 graphics, float angle, int x, int y, int breadth, int length, Couple<Color> c) {
		angledGradient(graphics, angle, x, y, 0, breadth, length, c);
	}

	public static void angledGradient(class_332 graphics, float angle, int x, int y, int z, int breadth, int length, Couple<Color> c) {
		angledGradient(graphics, angle, x, y, z, breadth, length, c.getFirst(), c.getSecond());
	}

	public static void angledGradient(class_332 graphics, float angle, int x, int y, int breadth, int length, Color color1, Color color2) {
		angledGradient(graphics, angle, x, y, 0, breadth, length, color1, color2);
	}

	/**
	 * x and y specify the middle point of the starting edge
	 *
	 * @param angle   the angle of the gradient in degrees; 0° means from left to right
	 * @param color1  the color at the starting edge
	 * @param color2  the color at the ending edge
	 * @param breadth the total width of the gradient
	 */
	public static void angledGradient(class_332 graphics, float angle, int x, int y, int z, int breadth, int length, Color color1, Color color2) {
		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(x, y, z);
		ms.method_22907(class_7833.field_40718.rotationDegrees(angle - 90));

		int w = breadth / 2;
		graphics.method_33284(-w, 0, w, length, 0, color1.getRGB(), color2.getRGB());

		ms.method_22909();
	}

	public static void breadcrumbArrow(class_332 graphics, int x, int y, int z, int width, int height, int indent, Couple<Color> colors) {breadcrumbArrow(graphics, x, y, z, width, height, indent, colors.getFirst(), colors.getSecond());}

	// draws a wide chevron-style breadcrumb arrow pointing left
	public static void breadcrumbArrow(class_332 graphics, int x, int y, int z, int width, int height, int indent, Color startColor, Color endColor) {
		class_4587 matrixStack = graphics.method_51448();
		matrixStack.method_22903();
		matrixStack.method_46416(x - indent, y, z);

		breadcrumbArrow(graphics, width, height, indent, startColor, endColor);

		matrixStack.method_22909();
	}

	private static void breadcrumbArrow(class_332 graphics, int width, int height, int indent, Color c1, Color c2) {

		/*
		 * 0,0       x1,y1 ********************* x4,y4 ***** x7,y7
		 *       ****                                     ****
		 *   ****                                     ****
		 * x0,y0     x2,y2                       x5,y5
		 *   ****                                     ****
		 *       ****                                     ****
		 *           x3,y3 ********************* x6,y6 ***** x8,y8
		 *
		 */

		float x0 = 0, y0 = height / 2f;
		float x1 = indent, y1 = 0;
		float x2 = indent, y2 = height / 2f;
		float x3 = indent, y3 = height;
		float x4 = width, y4 = 0;
		float x5 = width, y5 = height / 2f;
		float x6 = width, y6 = height;
		float x7 = indent + width, y7 = 0;
		float x8 = indent + width, y8 = height;

		indent = Math.abs(indent);
		width = Math.abs(width);
		Color fc1 = Color.mixColors(c1, c2, 0);
		Color fc2 = Color.mixColors(c1, c2, (indent) / (width + 2f * indent));
		Color fc3 = Color.mixColors(c1, c2, (indent + width) / (width + 2f * indent));
		Color fc4 = Color.mixColors(c1, c2, 1);

//		RenderSystem.disableTexture();
		RenderSystem.enableBlend();
		RenderSystem.disableCull();
		RenderSystem.defaultBlendFunc();
		RenderSystem.setShader(class_757::method_34540);

		class_289 tessellator = class_289.method_1348();
		class_287 bufferbuilder = tessellator.method_1349();
		Matrix4f model = graphics.method_51448().method_23760().method_23761();
		bufferbuilder.method_1328(class_293.class_5596.field_27379, class_290.field_1576);

		bufferbuilder.method_22918(model, x0, y0, 0).method_1336(fc1.getRed(), fc1.getGreen(), fc1.getBlue(), fc1.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x1, y1, 0).method_1336(fc2.getRed(), fc2.getGreen(), fc2.getBlue(), fc2.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x2, y2, 0).method_1336(fc2.getRed(), fc2.getGreen(), fc2.getBlue(), fc2.getAlpha()).method_1344();

		bufferbuilder.method_22918(model, x0, y0, 0).method_1336(fc1.getRed(), fc1.getGreen(), fc1.getBlue(), fc1.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x2, y2, 0).method_1336(fc2.getRed(), fc2.getGreen(), fc2.getBlue(), fc2.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x3, y3, 0).method_1336(fc2.getRed(), fc2.getGreen(), fc2.getBlue(), fc2.getAlpha()).method_1344();

		bufferbuilder.method_22918(model, x3, y3, 0).method_1336(fc2.getRed(), fc2.getGreen(), fc2.getBlue(), fc2.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x1, y1, 0).method_1336(fc2.getRed(), fc2.getGreen(), fc2.getBlue(), fc2.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x4, y4, 0).method_1336(fc3.getRed(), fc3.getGreen(), fc3.getBlue(), fc3.getAlpha()).method_1344();

		bufferbuilder.method_22918(model, x3, y3, 0).method_1336(fc2.getRed(), fc2.getGreen(), fc2.getBlue(), fc2.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x4, y4, 0).method_1336(fc3.getRed(), fc3.getGreen(), fc3.getBlue(), fc3.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x6, y6, 0).method_1336(fc3.getRed(), fc3.getGreen(), fc3.getBlue(), fc3.getAlpha()).method_1344();

		bufferbuilder.method_22918(model, x5, y5, 0).method_1336(fc3.getRed(), fc3.getGreen(), fc3.getBlue(), fc3.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x4, y4, 0).method_1336(fc3.getRed(), fc3.getGreen(), fc3.getBlue(), fc3.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x7, y7, 0).method_1336(fc4.getRed(), fc4.getGreen(), fc4.getBlue(), fc4.getAlpha()).method_1344();

		bufferbuilder.method_22918(model, x6, y6, 0).method_1336(fc3.getRed(), fc3.getGreen(), fc3.getBlue(), fc3.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x5, y5, 0).method_1336(fc3.getRed(), fc3.getGreen(), fc3.getBlue(), fc3.getAlpha()).method_1344();
		bufferbuilder.method_22918(model, x8, y8, 0).method_1336(fc4.getRed(), fc4.getGreen(), fc4.getBlue(), fc4.getAlpha()).method_1344();

		tessellator.method_1350();
		RenderSystem.enableCull();
		RenderSystem.disableBlend();
//		RenderSystem.enableTexture();
	}

	//just like AbstractGui#drawTexture, but with a color at every vertex
	public static void drawColoredTexture(class_332 graphics, Color c, int x, int y, int tex_left, int tex_top, int width, int height) {
		drawColoredTexture(graphics, c, x, y, 0, (float) tex_left, (float) tex_top, width, height, 256, 256);
	}

	public static void drawColoredTexture(class_332 graphics, Color c, int x, int y, int z, float tex_left, float tex_top, int width, int height, int sheet_width, int sheet_height) {
		drawColoredTexture(graphics, c, x, x + width, y, y + height, z, width, height, tex_left, tex_top, sheet_width, sheet_height);
	}

	public static void drawStretched(class_332 graphics, int left, int top, int w, int h, int z, AllGuiTextures tex) {
		tex.bind();
		drawTexturedQuad(graphics.method_51448().method_23760()
			.method_23761(), Color.WHITE, left, left + w, top, top + h, z, tex.startX / 256f, (tex.startX + tex.width) / 256f,
			tex.startY / 256f, (tex.startY + tex.height) / 256f);
	}

	public static void drawCropped(class_332 graphics, int left, int top, int w, int h, int z, AllGuiTextures tex) {
		tex.bind();
		drawTexturedQuad(graphics.method_51448().method_23760()
			.method_23761(), Color.WHITE, left, left + w, top, top + h, z, tex.startX / 256f, (tex.startX + w) / 256f,
			tex.startY / 256f, (tex.startY + h) / 256f);
	}

	private static void drawColoredTexture(class_332 graphics, Color c, int left, int right, int top, int bot, int z, int tex_width, int tex_height, float tex_left, float tex_top, int sheet_width, int sheet_height) {
		drawTexturedQuad(graphics.method_51448().method_23760().method_23761(), c, left, right, top, bot, z, (tex_left + 0.0F) / (float) sheet_width, (tex_left + (float) tex_width) / (float) sheet_width, (tex_top + 0.0F) / (float) sheet_height, (tex_top + (float) tex_height) / (float) sheet_height);
	}

	private static void drawTexturedQuad(Matrix4f m, Color c, int left, int right, int top, int bot, int z, float u1, float u2, float v1, float v2) {
		class_289 tesselator = class_289.method_1348();
		class_287 bufferbuilder = tesselator.method_1349();
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		RenderSystem.setShader(class_757::method_34541);
		bufferbuilder.method_1328(class_293.class_5596.field_27382, class_290.field_20887);
		bufferbuilder.method_22918(m, (float) left , (float) bot, (float) z).method_1336(c.getRed(), c.getGreen(), c.getBlue(), c.getAlpha()).method_22913(u1, v2).method_1344();
		bufferbuilder.method_22918(m, (float) right, (float) bot, (float) z).method_1336(c.getRed(), c.getGreen(), c.getBlue(), c.getAlpha()).method_22913(u2, v2).method_1344();
		bufferbuilder.method_22918(m, (float) right, (float) top, (float) z).method_1336(c.getRed(), c.getGreen(), c.getBlue(), c.getAlpha()).method_22913(u2, v1).method_1344();
		bufferbuilder.method_22918(m, (float) left , (float) top, (float) z).method_1336(c.getRed(), c.getGreen(), c.getBlue(), c.getAlpha()).method_22913(u1, v1).method_1344();
		tesselator.method_1350();
		RenderSystem.disableBlend();
	}

	public static void flipForGuiRender(class_4587 poseStack) {
		poseStack.method_34425(new Matrix4f().scaling(1, -1, 1));
	}

	public static class CustomRenderTarget extends class_276 implements RenderTargetExtensions {

		public CustomRenderTarget(boolean useDepth) {
			super(useDepth);
		}

		public static CustomRenderTarget create(class_1041 mainWindow) {
			CustomRenderTarget framebuffer = new CustomRenderTarget(true);
			framebuffer.method_1234(mainWindow.method_4489(), mainWindow.method_4506(), class_310.field_1703);
			framebuffer.method_1236(0, 0, 0, 0);
			framebuffer.enableStencil();
			return framebuffer;
		}

		public void renderWithAlpha(float alpha) {
			class_1041 window = class_310.method_1551().method_22683();

			float vx = (float) window.method_4486();
			float vy = (float) window.method_4502();
			float tx = (float) field_1480 / (float) field_1482;
			float ty = (float) field_1477 / (float) field_1481;

//			RenderSystem.enableTexture();
			RenderSystem.enableDepthTest();
			RenderSystem.setShader(() -> class_310.method_1551().field_1773.field_29403);
			RenderSystem.getShader().method_34583("DiffuseSampler", field_1475);

			method_35610();

			class_289 tessellator = class_289.method_1348();
			class_287 bufferbuilder = tessellator.method_1349();
			bufferbuilder.method_1328(class_293.class_5596.field_27382, class_290.field_20887);

			bufferbuilder.method_22912(0, vy, 0).method_22915(1, 1, 1, alpha).method_22913(0, 0).method_1344();
			bufferbuilder.method_22912(vx, vy, 0).method_22915(1, 1, 1, alpha).method_22913(tx, 0).method_1344();
			bufferbuilder.method_22912(vx, 0, 0).method_22915(1, 1, 1, alpha).method_22913(tx, ty).method_1344();
			bufferbuilder.method_22912(0, 0, 0).method_22915(1, 1, 1, alpha).method_22913(0, ty).method_1344();

			tessellator.method_1350();
			method_1242();
		}

	}

}
