package com.simibubi.create.foundation.gui.element;

import com.simibubi.create.foundation.utility.Components;
import net.minecraft.class_327;
import net.minecraft.class_332;
import net.minecraft.class_4587;
import net.minecraft.class_5250;

public class TextStencilElement extends DelegatedStencilElement {

	protected class_327 font;
	protected class_5250 component;
	protected boolean centerVertically = false;
	protected boolean centerHorizontally = false;

	public TextStencilElement(class_327 font) {
		super();
		this.font = font;
		height = 10;
	}

	public TextStencilElement(class_327 font, String text) {
		this(font);
		component = Components.literal(text);
	}

	public TextStencilElement(class_327 font, class_5250 component) {
		this(font);
		this.component = component;
	}

	public TextStencilElement withText(String text) {
		component = Components.literal(text);
		return this;
	}

	public TextStencilElement withText(class_5250 component) {
		this.component = component;
		return this;
	}

	public TextStencilElement centered(boolean vertical, boolean horizontal) {
		this.centerVertically = vertical;
		this.centerHorizontally = horizontal;
		return this;
	}

	@Override
	protected void renderStencil(class_332 graphics) {
		float x = 0, y = 0;
		if (centerHorizontally)
			x = width / 2f - font.method_27525(component) / 2f;

		if (centerVertically)
			y = height / 2f - (font.field_2000 - 1) / 2f;

		graphics.method_51439(font, component, Math.round(x), Math.round(y), 0xff_000000, false);
	}

	@Override
	protected void renderElement(class_332 graphics) {
		float x = 0, y = 0;
		if (centerHorizontally)
			x = width / 2f - font.method_27525(component) / 2f;

		if (centerVertically)
			y = height / 2f - (font.field_2000 - 1) / 2f;

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(x, y, 0);
		element.render(graphics, font.method_27525(component), font.field_2000 + 2, alpha);
		ms.method_22909();
	}

	public class_5250 getComponent() {
		return component;
	}
}
