package com.simibubi.create.foundation.gui.widget;

import java.util.LinkedList;
import java.util.List;
import java.util.function.BiConsumer;

import javax.annotation.Nonnull;
import net.minecraft.class_2561;
import net.minecraft.class_332;
import net.minecraft.class_339;
import net.minecraft.class_6382;
import net.minecraft.class_8000;
import net.minecraft.class_8001;
import com.simibubi.create.foundation.gui.TickableGuiEventListener;
import com.simibubi.create.foundation.utility.Components;

public abstract class AbstractSimiWidget extends class_339 implements TickableGuiEventListener {

	public static final int HEADER_RGB = 0x5391E1;
	public static final int HINT_RGB = 0x96B7E0;

	protected float z;
	protected boolean wasHovered = false;
	protected List<class_2561> toolTip = new LinkedList<>();
	protected BiConsumer<Integer, Integer> onClick = (_$, _$$) -> {};

	public int lockedTooltipX = -1;
	public int lockedTooltipY = -1;

	protected AbstractSimiWidget(int x, int y) {
		this(x, y, 16, 16);
	}

	protected AbstractSimiWidget(int x, int y, int width, int height) {
		this(x, y, width, height, Components.immutableEmpty());
	}

	protected AbstractSimiWidget(int x, int y, int width, int height, class_2561 message) {
		super(x, y, width, height, message);
	}

	@Override
	protected class_8000 method_47937() {
		return class_8001.field_41687;
	}

	public <T extends AbstractSimiWidget> T withCallback(BiConsumer<Integer, Integer> cb) {
		this.onClick = cb;
		//noinspection unchecked
		return (T) this;
	}

	public <T extends AbstractSimiWidget> T withCallback(Runnable cb) {
		return withCallback((_$, _$$) -> cb.run());
	}

	public <T extends AbstractSimiWidget> T atZLevel(float z) {
		this.z = z;
		//noinspection unchecked
		return (T) this;
	}

	public List<class_2561> getToolTip() {
		return toolTip;
	}

	@Override
	public void tick() {}

	@Override
	public void method_48579(@Nonnull class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		beforeRender(graphics, mouseX, mouseY, partialTicks);
		doRender(graphics, mouseX, mouseY, partialTicks);
		afterRender(graphics, mouseX, mouseY, partialTicks);
		wasHovered = method_25367();
	}

	protected void beforeRender(@Nonnull class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		graphics.method_51448().method_22903();
	}

	protected void doRender(@Nonnull class_332 graphics, int mouseX, int mouseY, float partialTicks) {
	}

	protected void afterRender(@Nonnull class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		graphics.method_51448().method_22909();
	}

	public void runCallback(double mouseX, double mouseY) {
		onClick.accept((int) mouseX, (int) mouseY);
	}

	@Override
	public void method_25348(double mouseX, double mouseY) {
		runCallback(mouseX, mouseY);
	}

	@Override
	public void method_47399(class_6382 pNarrationElementOutput) {
		method_37021(pNarrationElementOutput);
	}
}
