package com.simibubi.create.foundation.item;

import java.util.List;
import net.minecraft.class_1657;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1836;
import net.minecraft.class_2561;
import net.minecraft.class_7923;
import org.jetbrains.annotations.Nullable;

import com.simibubi.create.foundation.utility.AttachedRegistry;

public interface TooltipModifier {
	AttachedRegistry<class_1792, TooltipModifier> REGISTRY = new AttachedRegistry<>(class_7923.field_41178);

	TooltipModifier EMPTY = new TooltipModifier() {
		@Override
		public void modify(class_1799 stack, class_1657 player, class_1836 flags, List<class_2561> tooltip) {
		}

		@Override
		public TooltipModifier andThen(TooltipModifier after) {
			return after;
		}
	};

	void modify(class_1799 stack, class_1657 player, class_1836 flags, List<class_2561> tooltip);

	default TooltipModifier andThen(TooltipModifier after) {
		if (after == EMPTY) {
			return this;
		}
		return (stack, player, flags, tooltip) -> {
			modify(stack, player, flags, tooltip);
			after.modify(stack, player, flags, tooltip);
		};
	}

	static TooltipModifier mapNull(@Nullable TooltipModifier modifier) {
		if (modifier == null) {
			return EMPTY;
		}
		return modifier;
	}
}
