package com.simibubi.create.foundation.networking;

import java.util.concurrent.Executor;

import org.jetbrains.annotations.Nullable;

import me.pepperbell.simplenetworking.C2SPacket;
import me.pepperbell.simplenetworking.S2CPacket;
import me.pepperbell.simplenetworking.SimpleChannel;
import net.fabricmc.fabric.api.networking.v1.PacketSender;
import net.minecraft.class_2540;
import net.minecraft.class_2547;
import net.minecraft.class_310;
import net.minecraft.class_3222;
import net.minecraft.class_3244;
import net.minecraft.class_634;
import net.minecraft.server.MinecraftServer;

public abstract class SimplePacketBase implements C2SPacket, S2CPacket {

	public abstract void write(class_2540 buffer);

	public abstract boolean handle(Context context);

	@Override
	public final void encode(class_2540 buffer) {
		write(buffer);
	}

	@Override
	public void handle(class_310 client, class_634 listener, PacketSender responseSender, SimpleChannel channel) {
		handle(new Context(client, listener, null));
	}

	@Override
	public void handle(MinecraftServer server, class_3222 player, class_3244 listener, PacketSender responseSender, SimpleChannel channel) {
		handle(new Context(server, listener, player));
	}

	public enum NetworkDirection {
		PLAY_TO_CLIENT,
		PLAY_TO_SERVER
	}

	public record Context(Executor exec, class_2547 listener, @Nullable class_3222 sender) {
		public void enqueueWork(Runnable runnable) {
			exec().execute(runnable);
		}

		@Nullable
		public class_3222 getSender() {
			return sender();
		}

		public NetworkDirection getDirection() {
			return sender() == null ? NetworkDirection.PLAY_TO_SERVER : NetworkDirection.PLAY_TO_CLIENT;
		}
	}
}
