package com.simibubi.create.foundation.ponder;

import javax.annotation.Nonnull;
import net.minecraft.class_2960;
import net.minecraft.class_332;
import net.minecraft.class_4587;
import com.simibubi.create.foundation.gui.element.ScreenElement;

public class PonderChapter implements ScreenElement {

	private final class_2960 id;
	private final class_2960 icon;

	private PonderChapter(class_2960 id) {
		this.id = id;
		icon = new class_2960(id.method_12836(), "textures/ponder/chapter/" + id.method_12832() + ".png");
	}

	public class_2960 getId() {
		return id;
	}

	public String getTitle() {
		return PonderLocalization.getChapter(id);
	}

	public PonderChapter addTagsToChapter(PonderTag... tags) {
		for (PonderTag t : tags)
			PonderRegistry.TAGS.add(t, this);
		return this;
	}

	@Override
	public void render(class_332 graphics, int x, int y) {
		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_22905(0.25f, 0.25f, 1);
		//x and y offset, blit z offset, tex x and y, tex width and height, entire tex sheet width and height
		graphics.method_25291(icon, x, y, 0, 0, 0, 64, 64, 64, 64);
		ms.method_22909();
	}

	@Nonnull
	public static PonderChapter of(class_2960 id) {
		PonderChapter chapter = PonderRegistry.CHAPTERS.getChapter(id);
		if (chapter == null) {
			 chapter = PonderRegistry.CHAPTERS.addChapter(new PonderChapter(id));
		}

		return chapter;
	}
}
