package com.simibubi.create.foundation.ponder;

import com.simibubi.create.Create;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import com.simibubi.create.foundation.gui.element.ScreenElement;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1799;
import net.minecraft.class_1935;
import net.minecraft.class_2960;
import net.minecraft.class_332;
import net.minecraft.class_4587;

public class PonderTag implements ScreenElement {

	public static final PonderTag HIGHLIGHT_ALL = new PonderTag(Create.asResource("_all"));

	private final class_2960 id;
	private class_2960 icon;
	private class_1799 itemIcon = class_1799.field_8037;
	private class_1799 mainItem = class_1799.field_8037;

	public PonderTag(class_2960 id) {
		this.id = id;
	}

	public class_2960 getId() {
		return id;
	}

	public class_1799 getMainItem() {
		return mainItem;
	}

	public String getTitle() {
		return PonderLocalization.getTag(id);
	}

	public String getDescription() {
		return PonderLocalization.getTagDescription(id);
	}

	// Builder

	public PonderTag defaultLang(String title, String description) {
		PonderLocalization.registerTag(id, title, description);
		return this;
	}

	public PonderTag addToIndex() {
		PonderRegistry.TAGS.listTag(this);
		return this;
	}

	public PonderTag icon(class_2960 location) {
		this.icon = new class_2960(location.method_12836(), "textures/ponder/tag/" + location.method_12832() + ".png");
		return this;
	}

	public PonderTag icon(String location) {
		this.icon = new class_2960(id.method_12836(), "textures/ponder/tag/" + location + ".png");
		return this;
	}

	public PonderTag idAsIcon() {
		return icon(id);
	}

	public PonderTag item(class_1935 item, boolean useAsIcon, boolean useAsMainItem) {
		if (useAsIcon)
			this.itemIcon = new class_1799(item);
		if (useAsMainItem)
			this.mainItem = new class_1799(item);
		return this;
	}

	public PonderTag item(class_1935 item) {
		return this.item(item, true, false);
	}

	@Override
	@Environment(EnvType.CLIENT)
	public void render(class_332 graphics, int x, int y) {
		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(x, y, 0);
		if (icon != null) {
			ms.method_22905(0.25f, 0.25f, 1);
			graphics.method_25291(icon, 0, 0, 0, 0, 0, 64, 64, 64, 64);
		} else if (!itemIcon.method_7960()) {
			ms.method_46416(-2, -2, 0);
			ms.method_22905(1.25f, 1.25f, 1.25f);
			GuiGameElement.of(itemIcon)
				.render(graphics);
		}
		ms.method_22909();
	}

}
