package com.simibubi.create.foundation.ponder;

import java.util.List;

import com.google.common.base.Strings;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.item.ItemHelper;
import com.simibubi.create.foundation.ponder.ui.NavigatableSimiScreen;
import com.simibubi.create.foundation.ponder.ui.PonderUI;
import com.simibubi.create.foundation.utility.Color;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.RegisteredObjects;
import com.simibubi.create.foundation.utility.animation.LerpedFloat;

import io.github.fabricators_of_create.porting_lib.event.client.RenderTooltipBorderColorCallback;
import net.fabricmc.fabric.api.client.keybinding.v1.KeyBindingHelper;
import net.minecraft.class_124;
import net.minecraft.class_1799;
import net.minecraft.class_2561;
import net.minecraft.class_304;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_3675;
import net.minecraft.class_437;
import net.minecraft.class_5250;

public class PonderTooltipHandler {

	public static boolean enable = true;

	static LerpedFloat holdWProgress = LerpedFloat.linear()
		.startWithValue(0);
	static class_1799 hoveredStack = class_1799.field_8037;
	static class_1799 trackingStack = class_1799.field_8037;
	static boolean subject = false;
	static boolean deferTick = false;

	public static final String HOLD_TO_PONDER = PonderLocalization.LANG_PREFIX + "hold_to_ponder";
	public static final String SUBJECT = PonderLocalization.LANG_PREFIX + "subject";

	public static void tick() {
		deferTick = true;
	}

	public static void deferredTick() {
		deferTick = false;
		class_310 instance = class_310.method_1551();
		class_437 currentScreen = instance.field_1755;

		if (hoveredStack.method_7960() || trackingStack.method_7960()) {
			trackingStack = class_1799.field_8037;
			holdWProgress.startWithValue(0);
			return;
		}

		float value = holdWProgress.getValue();
		int keyCode = KeyBindingHelper.getBoundKeyOf(ponderKeybind()).method_1444();
		long window = instance.method_22683()
			.method_4490();

		if (!subject && class_3675.method_15987(window, keyCode)) {
			if (value >= 1) {
				if (currentScreen instanceof NavigatableSimiScreen)
					((NavigatableSimiScreen) currentScreen).centerScalingOnMouse();
				ScreenOpener.transitionTo(PonderUI.of(trackingStack));
				holdWProgress.startWithValue(0);
				return;
			}
			holdWProgress.setValue(Math.min(1, value + Math.max(.25f, value) * .25f));
		} else
			holdWProgress.setValue(Math.max(0, value - .05f));

		hoveredStack = class_1799.field_8037;
	}

	public static void addToTooltip(class_1799 stack, List<class_2561> tooltip) {
		if (!enable)
			return;

		updateHovered(stack);

		if (deferTick)
			deferredTick();

		if (trackingStack != stack)
			return;

		float renderPartialTicks = class_310.method_1551()
			.method_1488();
		class_2561 component = subject ? Lang.translateDirect(SUBJECT)
			.method_27692(class_124.field_1060)
			: makeProgressBar(Math.min(1, holdWProgress.getValue(renderPartialTicks) * 8 / 7f));
		if (tooltip.size() < 2)
			tooltip.add(component);
		else
			tooltip.add(1, component);
	}

	protected static void updateHovered(class_1799 stack) {
		class_310 instance = class_310.method_1551();
		class_437 currentScreen = instance.field_1755;
		boolean inPonderUI = currentScreen instanceof PonderUI;

		class_1799 prevStack = trackingStack;
		hoveredStack = class_1799.field_8037;
		subject = false;

		if (inPonderUI) {
			PonderUI ponderUI = (PonderUI) currentScreen;
			if (ItemHelper.sameItem(stack, ponderUI.getSubject()))
				subject = true;
		}

		if (stack.method_7960())
			return;
		if (!PonderRegistry.ALL.containsKey(RegisteredObjects.getKeyOrThrow(stack.method_7909())))
			return;

		if (prevStack.method_7960() || !ItemHelper.sameItem(prevStack, stack))
			holdWProgress.startWithValue(0);

		hoveredStack = stack;
		trackingStack = stack;
	}

	public static RenderTooltipBorderColorCallback.BorderColorEntry handleTooltipColor(class_1799 stack, int originalBorderColorStart, int originalBorderColorEn) {
		if (trackingStack != stack)
			return null;
		if (holdWProgress.getValue() == 0)
			return null;
		float renderPartialTicks = class_310.method_1551()
			.method_1488();
		int start = originalBorderColorStart;
		int end = originalBorderColorEn;
		float progress = Math.min(1, holdWProgress.getValue(renderPartialTicks) * 8 / 7f);

		start = getSmoothColorForProgress(progress);
		end = getSmoothColorForProgress((progress));

		return new RenderTooltipBorderColorCallback.BorderColorEntry(start | 0xa0000000, end | 0xa0000000);
	}

	private static int getSmoothColorForProgress(float progress) {
		if (progress < .5f)
			return Color.mixColors(0x5000FF, 5592575, progress * 2);
		return Color.mixColors(5592575, 0xffffff, (progress - .5f) * 2);
	}

	private static class_2561 makeProgressBar(float progress) {
		class_5250 holdW = Lang
			.translateDirect(HOLD_TO_PONDER,
				((class_5250) ponderKeybind().method_16007()).method_27692(class_124.field_1080))
			.method_27692(class_124.field_1063);

		class_327 fontRenderer = class_310.method_1551().field_1772;
		float charWidth = fontRenderer.method_1727("|");
		float tipWidth = fontRenderer.method_27525(holdW);

		int total = (int) (tipWidth / charWidth);
		int current = (int) (progress * total);

		if (progress > 0) {
			String bars = "";
			bars += class_124.field_1080 + Strings.repeat("|", current);
			if (progress < 1)
				bars += class_124.field_1063 + Strings.repeat("|", total - current);
			return Components.literal(bars);
		}

		return holdW;
	}

	protected static class_304 ponderKeybind() {
		return class_310.method_1551().field_1690.field_1894;
	}

}
