package com.simibubi.create.foundation.ponder.element;

import com.jozufozu.flywheel.util.transform.TransformStack;
import com.simibubi.create.foundation.ponder.PonderWorld;
import com.simibubi.create.foundation.utility.animation.LerpedFloat;
import net.minecraft.class_1921;
import net.minecraft.class_243;
import net.minecraft.class_3532;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_765;

public abstract class AnimatedSceneElement extends PonderSceneElement {

	protected class_243 fadeVec;
	protected LerpedFloat fade;

	public AnimatedSceneElement() {
		fade = LerpedFloat.linear()
			.startWithValue(0);
	}

	public void forceApplyFade(float fade) {
		this.fade.startWithValue(fade);
	}

	public void setFade(float fade) {
		this.fade.setValue(fade);
	}

	public void setFadeVec(class_243 fadeVec) {
		this.fadeVec = fadeVec;
	}

	@Override
	public final void renderFirst(PonderWorld world, class_4597 buffer, class_4587 ms, float pt) {
		ms.method_22903();
		float currentFade = applyFade(ms, pt);
		renderFirst(world, buffer, ms, currentFade, pt);
		ms.method_22909();
	}

	@Override
	public final void renderLayer(PonderWorld world, class_4597 buffer, class_1921 type, class_4587 ms,
		float pt) {
		ms.method_22903();
		float currentFade = applyFade(ms, pt);
		renderLayer(world, buffer, type, ms, currentFade, pt);
		ms.method_22909();
	}

	@Override
	public final void renderLast(PonderWorld world, class_4597 buffer, class_4587 ms, float pt) {
		ms.method_22903();
		float currentFade = applyFade(ms, pt);
		renderLast(world, buffer, ms, currentFade, pt);
		ms.method_22909();
	}

	protected float applyFade(class_4587 ms, float pt) {
		float currentFade = fade.getValue(pt);
		if (fadeVec != null)
			TransformStack.cast(ms)
					.translate(fadeVec.method_1021(-1 + currentFade));
		return currentFade;
	}

	protected void renderLayer(PonderWorld world, class_4597 buffer, class_1921 type, class_4587 ms, float fade,
		float pt) {}

	protected void renderFirst(PonderWorld world, class_4597 buffer, class_4587 ms, float fade, float pt) {}

	protected void renderLast(PonderWorld world, class_4597 buffer, class_4587 ms, float fade, float pt) {}

	protected int lightCoordsFromFade(float fade) {
		int light = class_765.field_32767;
		if (fade != 1) {
			light = (int) (class_3532.method_16439(fade, 5, 0xF));
			light = class_765.method_23687(light, light);
		}
		return light;
	}

}
