package com.simibubi.create.foundation.ponder.element;

import java.lang.ref.WeakReference;
import java.util.function.Consumer;
import net.minecraft.class_1921;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import com.simibubi.create.foundation.ponder.PonderWorld;

public abstract class TrackedElement<T> extends PonderSceneElement {

	private WeakReference<T> reference;

	public TrackedElement(T wrapped) {
		this.reference = new WeakReference<>(wrapped);
	}

	public void ifPresent(Consumer<T> func) {
		if (reference == null)
			return;
		T resolved = reference.get();
		if (resolved == null)
			return;
		func.accept(resolved);
	}
	
	protected boolean isStillValid(T element) { 
		return true;
	}
	
	@Override
	public void renderFirst(PonderWorld world, class_4597 buffer, class_4587 ms, float pt) {}

	@Override
	public void renderLayer(PonderWorld world, class_4597 buffer, class_1921 type, class_4587 ms, float pt) {}

	@Override
	public void renderLast(PonderWorld world, class_4597 buffer, class_4587 ms, float pt) {}

}
