package com.simibubi.create.foundation.ponder.instruction;

import java.util.function.UnaryOperator;
import net.minecraft.class_2487;
import net.minecraft.class_2586;
import com.simibubi.create.foundation.blockEntity.SyncedBlockEntity;
import com.simibubi.create.foundation.ponder.PonderScene;
import com.simibubi.create.foundation.ponder.PonderWorld;
import com.simibubi.create.foundation.ponder.Selection;

public class BlockEntityDataInstruction extends WorldModifyInstruction {

	private boolean redraw;
	private UnaryOperator<class_2487> data;
	private Class<? extends class_2586> type;

	public BlockEntityDataInstruction(Selection selection, Class<? extends class_2586> type,
		UnaryOperator<class_2487> data, boolean redraw) {
		super(selection);
		this.type = type;
		this.data = data;
		this.redraw = redraw;
	}

	@Override
	protected void runModification(Selection selection, PonderScene scene) {
		PonderWorld world = scene.getWorld();
		selection.forEach(pos -> {
			if (!world.getBounds()
				.method_14662(pos))
				return;
			class_2586 blockEntity = world.method_8321(pos);
			if (!type.isInstance(blockEntity))
				return;
			class_2487 apply = data.apply(blockEntity.method_38242());
			if (blockEntity instanceof SyncedBlockEntity)
				((SyncedBlockEntity) blockEntity).readClient(apply);
			blockEntity.method_11014(apply);
		});
	}

	@Override
	protected boolean needsRedraw() {
		return redraw;
	}

}
