package com.simibubi.create.foundation.ponder.instruction;

import com.simibubi.create.Create;
import com.simibubi.create.foundation.ponder.PonderScene;
import com.simibubi.create.foundation.ponder.PonderWorld;
import net.minecraft.class_2394;
import net.minecraft.class_243;
import net.minecraft.class_310;
import net.minecraft.class_702;

public class EmitParticlesInstruction extends TickingInstruction {

	private class_243 anchor;
	private Emitter emitter;
	private float runsPerTick;

	@FunctionalInterface
	public static interface Emitter {

		public static <T extends class_2394> Emitter simple(T data, class_243 motion) {
			return (w, x, y, z) -> w.method_8406(data, x, y, z, motion.field_1352, motion.field_1351, motion.field_1350);
		}

		public static <T extends class_2394> Emitter withinBlockSpace(T data, class_243 motion) {
			return (w, x, y, z) -> w.method_8406(data, Math.floor(x) + Create.RANDOM.nextFloat(),
					Math.floor(y) + Create.RANDOM.nextFloat(), Math.floor(z) + Create.RANDOM.nextFloat(), motion.field_1352,
					motion.field_1351, motion.field_1350);
		}

		static class_702 paticleManager() {
			return class_310.method_1551().field_1713;
		}

		public void create(PonderWorld world, double x, double y, double z);

	}

	public EmitParticlesInstruction(class_243 anchor, Emitter emitter, float runsPerTick, int ticks) {
		super(false, ticks);
		this.anchor = anchor;
		this.emitter = emitter;
		this.runsPerTick = runsPerTick;
	}

	@Override
	public void tick(PonderScene scene) {
		super.tick(scene);
		int runs = (int) runsPerTick;
		if (Create.RANDOM.nextFloat() < (runsPerTick - runs))
			runs++;
		for (int i = 0; i < runs; i++)
			emitter.create(scene.getWorld(), anchor.field_1352, anchor.field_1351, anchor.field_1350);
	}

}
