package com.simibubi.create.foundation.ponder.instruction;

import java.util.function.UnaryOperator;
import net.minecraft.class_2246;
import net.minecraft.class_2680;
import com.simibubi.create.foundation.ponder.PonderScene;
import com.simibubi.create.foundation.ponder.PonderWorld;
import com.simibubi.create.foundation.ponder.Selection;

public class ReplaceBlocksInstruction extends WorldModifyInstruction {

	private UnaryOperator<class_2680> stateToUse;
	private boolean replaceAir;
	private boolean spawnParticles;

	public ReplaceBlocksInstruction(Selection selection, UnaryOperator<class_2680> stateToUse, boolean replaceAir,
		boolean spawnParticles) {
		super(selection);
		this.stateToUse = stateToUse;
		this.replaceAir = replaceAir;
		this.spawnParticles = spawnParticles;
	}

	@Override
	protected void runModification(Selection selection, PonderScene scene) {
		PonderWorld world = scene.getWorld();
		selection.forEach(pos -> {
			if (!world.getBounds()
				.method_14662(pos))
				return;
			class_2680 prevState = world.method_8320(pos);
			if (!replaceAir && prevState == class_2246.field_10124.method_9564())
				return;
			if (spawnParticles)
				world.addBlockDestroyEffects(pos, prevState);
			world.method_8501(pos, stateToUse.apply(prevState));
		});
	}

	@Override
	protected boolean needsRedraw() {
		return true;
	}

}
