package com.simibubi.create.foundation.ponder.ui;

import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import net.minecraft.class_1041;
import net.minecraft.class_310;
import net.minecraft.class_332;
import net.minecraft.class_3532;
import net.minecraft.class_437;
import net.minecraft.class_4587;
import net.minecraft.class_5250;
import org.apache.commons.lang3.mutable.MutableBoolean;
import org.apache.commons.lang3.mutable.MutableInt;
import org.lwjgl.glfw.GLFW;
import com.simibubi.create.foundation.gui.AbstractSimiScreen;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.gui.Theme;
import com.simibubi.create.foundation.gui.UIRenderHelper;
import com.simibubi.create.foundation.ponder.PonderLocalization;
import com.simibubi.create.foundation.utility.Color;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.animation.LerpedFloat;

public abstract class NavigatableSimiScreen extends AbstractSimiScreen {

	public static final String THINK_BACK = PonderLocalization.LANG_PREFIX + "think_back";

	protected int depthPointX, depthPointY;
	public final LerpedFloat transition = LerpedFloat.linear()
		.startWithValue(0)
		.chase(0, .1f, LerpedFloat.Chaser.LINEAR);
	protected final LerpedFloat arrowAnimation = LerpedFloat.linear()
		.startWithValue(0)
		.chase(0, 0.075f, LerpedFloat.Chaser.LINEAR);
	protected PonderButton backTrack;

	public NavigatableSimiScreen() {
		class_1041 window = class_310.method_1551().method_22683();
		depthPointX = window.method_4486() / 2;
		depthPointY = window.method_4502() / 2;
	}

	@Override
	public void method_25419() {
		ScreenOpener.clearStack();
		super.method_25419();
	}

	@Override
	public void method_25393() {
		super.method_25393();
		transition.tickChaser();
		arrowAnimation.tickChaser();
	}

	@Override
	protected void method_25426() {
		super.method_25426();

		backTrack = null;
		List<class_437> screenHistory = ScreenOpener.getScreenHistory();
		if (screenHistory.isEmpty())
			return;
		if (!(screenHistory.get(0) instanceof NavigatableSimiScreen))
			return;

		NavigatableSimiScreen screen = (NavigatableSimiScreen) screenHistory.get(0);

		method_37063(backTrack = new PonderButton(31, field_22790 - 31 - 20).enableFade(0, 5)
			.withCallback(() -> ScreenOpener.openPreviousScreen(this, Optional.empty())));
		backTrack.fade(1);

		screen.initBackTrackIcon(backTrack);
	}

	/**
	 * Called when {@code this} represents the previous screen to
	 * initialize the {@code backTrack} icon of the current screen.
	 *
	 * @param backTrack The backTrack button of the current screen.
	 */
	protected abstract void initBackTrackIcon(PonderButton backTrack);

	@Override
	public void method_25394(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		super.method_25394(graphics, mouseX, mouseY, partialTicks);
//		renderZeloBreadcrumbs(ms, mouseX, mouseY, partialTicks);
		if (backTrack == null)
			return;

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(0, 0, 500);
		if (backTrack.method_25367()) {
			class_5250 translate = Lang.translateDirect(backTrackingLangKey());
			graphics.method_51439(field_22793, translate, 41 - field_22793.method_27525(translate) / 2, field_22790 - 16,
				Theme.i(Theme.Key.TEXT_DARKER), false);
			if (class_3532.method_15347(arrowAnimation.getValue(), arrowAnimation.getChaseTarget())) {
				arrowAnimation.setValue(1);
				arrowAnimation.setValue(1);// called twice to also set the previous value to 1
			}
		}
		ms.method_22909();
	}

	protected String backTrackingLangKey() {
		return THINK_BACK;
	}

	@Override
	protected void renderWindowBackground(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		if (backTrack != null) {
			int x = (int) class_3532.method_16439(arrowAnimation.getValue(partialTicks), -9, 21);
			int maxX = backTrack.method_46426() + backTrack.method_25368();

			if (x + 30 < backTrack.method_46426())
				UIRenderHelper.breadcrumbArrow(graphics, x + 30, field_22790 - 51, 0, maxX - (x + 30), 20, 5,
					Theme.p(Theme.Key.PONDER_BACK_ARROW));

			UIRenderHelper.breadcrumbArrow(graphics, x, field_22790 - 51, 0, 30, 20, 5, Theme.p(Theme.Key.PONDER_BACK_ARROW));
			UIRenderHelper.breadcrumbArrow(graphics, x - 30, field_22790 - 51, 0, 30, 20, 5, Theme.p(Theme.Key.PONDER_BACK_ARROW));
		}

		if (transition.getChaseTarget() == 0 || transition.settled()) {
			method_25420(graphics);
			return;
		}

		method_25420(graphics);

		class_4587 ms = graphics.method_51448();
		
//		Screen lastScreen = ScreenOpener.getPreviouslyRenderedScreen();
		float transitionValue = transition.getValue(partialTicks);
		float scale = 1 + 0.5f * transitionValue;

		
		/*
		 * Looks like this stopped working sometime before 1.18
		 * Now commented as it does mess with the background alpha since 1.20
		 */
		
		// draw last screen into buffer
//		if (lastScreen != null && lastScreen != this && !transition.settled()) {
//			ms.pushPose();
//			UIRenderHelper.framebuffer.clear(Minecraft.ON_OSX);
//			ms.translate(0, 0, -1000);
//			UIRenderHelper.framebuffer.bindWrite(true);
//			PonderTooltipHandler.enable = false;
//			// Using 0,0 for mouse coords to hide tooltips
//			lastScreen.render(graphics, 0, 0, partialTicks);
//			PonderTooltipHandler.enable = true;
//
//			ms.popPose();
//			ms.pushPose();
//
//			// use the buffer texture
//			minecraft.getMainRenderTarget()
//				.bindWrite(true);
//
//			Window window = minecraft.getWindow();
//			int dpx = window.getGuiScaledWidth() / 2;
//			int dpy = window.getGuiScaledHeight() / 2;
//			if (lastScreen instanceof NavigatableSimiScreen navigableScreen) {
//				dpx = navigableScreen.depthPointX;
//				dpy = navigableScreen.depthPointY;
//			}
//
//			ms.translate(dpx, dpy, 0);
//			ms.scale(scale, scale, 1);
//			ms.translate(-dpx, -dpy, 0);
//			RenderSystem.enableBlend();
//			RenderSystem.defaultBlendFunc();
//			UIRenderHelper.drawFramebuffer(1f - Math.abs(transitionValue));
//			RenderSystem.disableBlend();
//			ms.popPose();
//		}

		// modify current screen as well
		scale = transitionValue > 0 ? 1 - 0.5f * (1 - transitionValue) : 1 + .5f * (1 + transitionValue);
		ms.method_46416(depthPointX, depthPointY, 0);
		ms.method_22905(scale, scale, 1);
		ms.method_46416(-depthPointX, -depthPointY, 0);
	}

	@Override
	public boolean method_25404(int code, int p_keyPressed_2_, int p_keyPressed_3_) {
		if (code == GLFW.GLFW_KEY_BACKSPACE) {
			ScreenOpener.openPreviousScreen(this, Optional.empty());
			return true;
		}
		return super.method_25404(code, p_keyPressed_2_, p_keyPressed_3_);
	}

	public void centerScalingOn(int x, int y) {
		depthPointX = x;
		depthPointY = y;
	}

	public void centerScalingOnMouse() {
		class_1041 w = field_22787.method_22683();
		double mouseX = field_22787.field_1729.method_1603() * w.method_4486() / w.method_4480();
		double mouseY = field_22787.field_1729.method_1604() * w.method_4502() / w.method_4507();
		centerScalingOn((int) mouseX, (int) mouseY);
	}

	public boolean isEquivalentTo(NavigatableSimiScreen other) {
		return false;
	}

	public void shareContextWith(NavigatableSimiScreen other) {}

	protected void renderZeloBreadcrumbs(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		List<class_437> history = ScreenOpener.getScreenHistory();
		if (history.isEmpty())
			return;

		history.add(0, field_22787.field_1755);
		int spacing = 20;

		List<String> names = history.stream()
			.map(NavigatableSimiScreen::screenTitle)
			.collect(Collectors.toList());

		int bWidth = names.stream()
			.mapToInt(s -> field_22793.method_1727(s) + spacing)
			.sum();

		MutableInt x = new MutableInt(field_22789 - bWidth);
		MutableInt y = new MutableInt(field_22790 - 18);
		MutableBoolean first = new MutableBoolean(true);

		if (x.getValue() < 25)
			x.setValue(25);

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(0, 0, 600);
		names.forEach(s -> {
			int sWidth = field_22793.method_1727(s);
			UIRenderHelper.breadcrumbArrow(graphics, x.getValue(), y.getValue(), 0, sWidth + spacing, 14, spacing / 2,
					new Color(0xdd101010), new Color(0x44101010));
			graphics.method_51433(field_22793, s, x.getValue() + 5, y.getValue() + 3, first.getValue() ? 0xffeeffee : 0xffddeeff, false);
			first.setFalse();

			x.add(sWidth + spacing);
		});
		ms.method_22909();
	}

	private static String screenTitle(class_437 screen) {
		if (screen instanceof NavigatableSimiScreen)
			return ((NavigatableSimiScreen) screen).getBreadcrumbTitle();
		return "<";
	}

	protected String getBreadcrumbTitle() {
		return this.getClass()
			.getSimpleName();
	}
}
