package com.simibubi.create.foundation.ponder.ui;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import net.minecraft.class_1041;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2248;
import net.minecraft.class_332;
import net.minecraft.class_3532;
import net.minecraft.class_364;
import net.minecraft.class_4587;
import net.minecraft.class_768;
import net.minecraft.class_7923;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.content.kinetics.crank.ValveHandleBlock;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.gui.Theme;
import com.simibubi.create.foundation.gui.UIRenderHelper;
import com.simibubi.create.foundation.ponder.PonderChapter;
import com.simibubi.create.foundation.ponder.PonderRegistry;
import com.simibubi.create.foundation.utility.RegisteredObjects;

public class PonderIndexScreen extends NavigatableSimiScreen {

	protected final List<PonderChapter> chapters;
	private final double chapterXmult = 0.5;
	private final double chapterYmult = 0.3;
	protected class_768 chapterArea;

	protected final List<class_1792> items;
	private final double itemXmult = 0.5;
	private double itemYmult = 0.75;
	protected class_768 itemArea;

	private class_1799 hoveredItem = class_1799.field_8037;

	public PonderIndexScreen() {
		chapters = new ArrayList<>();
		items = new ArrayList<>();
	}

	@Override
	protected void method_25426() {
		super.method_25426();

		chapters.clear();
		// chapters.addAll(PonderRegistry.CHAPTERS.getAllChapters());

		items.clear();
		PonderRegistry.ALL.keySet()
			.stream()
			.map(key -> {
				return class_7923.field_41178.method_17966(key)
						.or(() -> class_7923.field_41175.method_17966(key).map(class_2248::method_8389))
						.orElse(null);
			})
			.filter(Objects::nonNull)
			.filter(PonderIndexScreen::exclusions)
			.forEach(items::add);

		boolean hasChapters = !chapters.isEmpty();

		// setup chapters
		LayoutHelper layout = LayoutHelper.centeredHorizontal(chapters.size(),
			class_3532.method_15340((int) Math.ceil(chapters.size() / 4f), 1, 4), 200, 38, 16);
		chapterArea = layout.getArea();
		int chapterCenterX = (int) (field_22789 * chapterXmult);
		int chapterCenterY = (int) (field_22790 * chapterYmult);

		// todo at some point pagination or horizontal scrolling may be needed for
		// chapters/items
		for (PonderChapter chapter : chapters) {
			ChapterLabel label = new ChapterLabel(chapter, chapterCenterX + layout.getX(),
				chapterCenterY + layout.getY(), (mouseX, mouseY) -> {
					centerScalingOn(mouseX, mouseY);
					ScreenOpener.transitionTo(PonderUI.of(chapter));
				});

			method_37063(label);
			layout.next();
		}

		// setup items
		if (!hasChapters) {
			itemYmult = 0.5;
		}

		int maxItemRows = hasChapters ? 4 : 7;
		layout = LayoutHelper.centeredHorizontal(items.size(),
			class_3532.method_15340((int) Math.ceil(items.size() / 11f), 1, maxItemRows), 28, 28, 8);
		itemArea = layout.getArea();
		int itemCenterX = (int) (field_22789 * itemXmult);
		int itemCenterY = (int) (field_22790 * itemYmult);

		for (class_1792 item : items) {
			PonderButton b = new PonderButton(itemCenterX + layout.getX() + 4, itemCenterY + layout.getY() + 4)
					.showing(new class_1799(item))
					.withCallback((x, y) -> {
						if (!PonderRegistry.ALL.containsKey(RegisteredObjects.getKeyOrThrow(item)))
							return;

						centerScalingOn(x, y);
						ScreenOpener.transitionTo(PonderUI.of(new class_1799(item)));
					});

			method_37063(b);
			layout.next();
		}

	}

	@Override
	protected void initBackTrackIcon(PonderButton backTrack) {
		backTrack.showing(AllItems.WRENCH.asStack());
	}

	private static boolean exclusions(class_1792 item) {
		if (item instanceof class_1747) {
			class_2248 block = ((class_1747) item).method_7711();
			if (block instanceof ValveHandleBlock && !AllBlocks.COPPER_VALVE_HANDLE.is(item))
				return false;
		}

		return true;
	}

	@Override
	public void method_25393() {
		super.method_25393();
		PonderUI.ponderTicks++;

		hoveredItem = class_1799.field_8037;
		class_1041 w = field_22787.method_22683();
		double mouseX = field_22787.field_1729.method_1603() * w.method_4486() / w.method_4480();
		double mouseY = field_22787.field_1729.method_1604() * w.method_4502() / w.method_4507();
		for (class_364 child : method_25396()) {
			if (child instanceof PonderButton button) {
				if (button.method_25405(mouseX, mouseY)) {
					hoveredItem = button.getItem();
				}
			}
		}
	}

	@Override
	protected void renderWindow(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		int x = (int) (field_22789 * chapterXmult);
		int y = (int) (field_22790 * chapterYmult);

		class_4587 ms = graphics.method_51448();

		if (!chapters.isEmpty()) {
			ms.method_22903();
			ms.method_46416(x, y, 0);

			UIRenderHelper.streak(graphics, 0, chapterArea.method_3321() - 10, chapterArea.method_3322() - 20, 20, 220);
			graphics.method_51433(field_22793, "Topics to Ponder about", chapterArea.method_3321() - 5, chapterArea.method_3322() - 25, Theme.i(Theme.Key.TEXT), false);

			ms.method_22909();
		}

		x = (int) (field_22789 * itemXmult);
		y = (int) (field_22790 * itemYmult);

		ms.method_22903();
		ms.method_46416(x, y, 0);

		UIRenderHelper.streak(graphics, 0, itemArea.method_3321() - 10, itemArea.method_3322() - 20, 20, 220);
		graphics.method_51433(field_22793, "Items to inspect", itemArea.method_3321() - 5, itemArea.method_3322() - 25, Theme.i(Theme.Key.TEXT), false);

		ms.method_22909();
	}

	@Override
	protected void renderWindowForeground(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		if (hoveredItem.method_7960())
			return;

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(0, 0, 200);

		graphics.method_51446(field_22793, hoveredItem, mouseX, mouseY);

		ms.method_22909();
	}

	/*@Override
	public boolean mouseClicked(double x, double y, int button) {
		MutableBoolean handled = new MutableBoolean(false);
		widgets.forEach(w -> {
			if (handled.booleanValue())
				return;
			if (!w.isMouseOver(x, y))
				return;
			if (w instanceof PonderButton) {
				PonderButton btn = (PonderButton) w;
				btn.runCallback(x, y);
				handled.setTrue();
			}
		});

		if (handled.booleanValue())
			return true;
		return super.mouseClicked(x, y, button);
	}*/

	@Override
	public boolean isEquivalentTo(NavigatableSimiScreen other) {
		return other instanceof PonderIndexScreen;
	}

	public class_1799 getHoveredTooltipItem() {
		return hoveredItem;
	}

	@Override
	public boolean method_25421() {
		return true;
	}
}
