package com.simibubi.create.foundation.ponder.ui;

import java.util.List;
import java.util.Optional;
import net.minecraft.class_1041;
import net.minecraft.class_2561;
import net.minecraft.class_332;
import net.minecraft.class_3532;
import net.minecraft.class_364;
import net.minecraft.class_4587;
import net.minecraft.class_768;
import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.AllItems;
import com.simibubi.create.foundation.gui.AllIcons;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.gui.Theme;
import com.simibubi.create.foundation.gui.UIRenderHelper;
import com.simibubi.create.foundation.gui.element.BoxElement;
import com.simibubi.create.foundation.gui.element.GuiGameElement;
import com.simibubi.create.foundation.item.TooltipHelper;
import com.simibubi.create.foundation.item.TooltipHelper.Palette;
import com.simibubi.create.foundation.ponder.PonderLocalization;
import com.simibubi.create.foundation.ponder.PonderRegistry;
import com.simibubi.create.foundation.ponder.PonderTag;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.FontHelper;
import com.simibubi.create.foundation.utility.Lang;

public class PonderTagIndexScreen extends NavigatableSimiScreen {

	public static final String EXIT = PonderLocalization.LANG_PREFIX + "exit";
	public static final String TITLE = PonderLocalization.LANG_PREFIX + "index_title";
	public static final String WELCOME = PonderLocalization.LANG_PREFIX + "welcome";
	public static final String CATEGORIES = PonderLocalization.LANG_PREFIX + "categories";
	public static final String DESCRIPTION = PonderLocalization.LANG_PREFIX + "index_description";

	private final double itemXmult = 0.5;
	protected class_768 itemArea;
	protected class_768 chapterArea;
	private final double mainYmult = 0.15;

	private PonderTag hoveredItem = null;

	// The ponder entry point from the menu. May be changed to include general
	// chapters in the future
	public PonderTagIndexScreen() {}

	@Override
	protected void method_25426() {
		super.method_25426();

		List<PonderTag> tags = PonderRegistry.TAGS.getListedTags();
		int rowCount = class_3532.method_15340((int) Math.ceil(tags.size() / 11d), 1, 3);
		LayoutHelper layout = LayoutHelper.centeredHorizontal(tags.size(), rowCount, 28, 28, 8);
		itemArea = layout.getArea();
		int itemCenterX = (int) (field_22789 * itemXmult);
		int itemCenterY = getItemsY();

		for (PonderTag i : tags) {
			PonderButton b =
				new PonderButton(itemCenterX + layout.getX() + 4, itemCenterY + layout.getY() + 4).showingTag(i)
					.withCallback((mouseX, mouseY) -> {
						centerScalingOn(mouseX, mouseY);
						ScreenOpener.transitionTo(new PonderTagScreen(i));
					});
			method_37063(b);
			layout.next();
		}

		method_37063(backTrack = new PonderButton(31, field_22790 - 31 - 20).enableFade(0, 5)
			.showing(AllIcons.I_MTD_CLOSE)
			.withCallback(() -> ScreenOpener.openPreviousScreen(this, Optional.empty())));
		backTrack.fade(1);
	}

	@Override
	protected void initBackTrackIcon(PonderButton backTrack) {
		backTrack.showing(AllItems.WRENCH.asStack());
	}

	@Override
	public void method_25393() {
		super.method_25393();
		PonderUI.ponderTicks++;

		hoveredItem = null;
		class_1041 w = field_22787.method_22683();
		double mouseX = field_22787.field_1729.method_1603() * w.method_4486() / w.method_4480();
		double mouseY = field_22787.field_1729.method_1604() * w.method_4502() / w.method_4507();
		for (class_364 child : method_25396()) {
			if (child == backTrack)
				continue;
			if (child instanceof PonderButton button)
				if (button.method_25405(mouseX, mouseY))
					hoveredItem = button.getTag();
		}
	}
	
	@Override
	protected String backTrackingLangKey() {
		return EXIT;
	}

	@Override
	protected void renderWindow(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		renderItems(graphics, mouseX, mouseY, partialTicks);

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_22904(field_22789 / 2 - 120, field_22790 * mainYmult - 40, 0);

		ms.method_22903();
		// ms.translate(0, 0, 800);
		int x = 31 + 20 + 8;
		int y = 31;

		String title = Lang.translateDirect(WELCOME)
			.getString();

		int streakHeight = 35;
		UIRenderHelper.streak(graphics, 0, x - 4, y - 12 + streakHeight / 2, streakHeight, 240);
		// PonderUI.renderBox(ms, 21, 21, 30, 30, false);
		new BoxElement().withBackground(Theme.c(Theme.Key.PONDER_BACKGROUND_FLAT))
			.gradientBorder(Theme.p(Theme.Key.PONDER_IDLE))
			.at(21, 21, 100)
			.withBounds(30, 30)
			.render(graphics);

		graphics.method_51433(field_22793, title, x + 8, y + 1, Theme.i(Theme.Key.TEXT), false);
//		y += 8;
//		x += 0;
//		ms.translate(x, y, 0);
//		ms.translate(0, 0, 5);
//		textRenderer.draw(ms, title, 0, 0, Theme.i(Theme.Key.TEXT));
		ms.method_22909();

		ms.method_22903();
		ms.method_46416(23, 23, 10);
		ms.method_22905(1.66f, 1.66f, 1.66f);
		ms.method_46416(-4, -4, 0);
		ms.method_22905(1.5f, 1.5f, 1.5f);
		GuiGameElement.of(AllItems.WRENCH.asStack())
			.render(graphics);
		ms.method_22909();
		ms.method_22909();

		ms.method_22903();
		int w = (int) (field_22789 * .45);
		x = (field_22789 - w) / 2;
		y = getItemsY() - 10 + Math.max(itemArea.method_3320(), 48);

		String desc = Lang.translateDirect(DESCRIPTION)
			.getString();
		int h = field_22793.method_1713(desc, w);

		// PonderUI.renderBox(ms, x - 3, y - 3, w + 6, h + 6, false);
		new BoxElement().withBackground(Theme.c(Theme.Key.PONDER_BACKGROUND_FLAT))
			.gradientBorder(Theme.p(Theme.Key.PONDER_IDLE))
			.at(x - 3, y - 3, 90)
			.withBounds(w + 6, h + 6)
			.render(graphics);

		ms.method_46416(0, 0, 100);
		FontHelper.drawSplitString(ms, field_22793, desc, x, y, w, Theme.i(Theme.Key.TEXT));
		ms.method_22909();
	}

	protected void renderItems(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		List<PonderTag> tags = PonderRegistry.TAGS.getListedTags();
		if (tags.isEmpty())
			return;

		int x = (int) (field_22789 * itemXmult);
		int y = getItemsY();

		String relatedTitle = Lang.translateDirect(CATEGORIES)
			.getString();
		int stringWidth = field_22793.method_1727(relatedTitle);

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(x, y, 0);
		// PonderUI.renderBox(ms, (sWidth - stringWidth) / 2 - 5, itemArea.getY() - 21,
		// stringWidth + 10, 10, false);
		new BoxElement().withBackground(Theme.c(Theme.Key.PONDER_BACKGROUND_FLAT))
			.gradientBorder(Theme.p(Theme.Key.PONDER_IDLE))
			.at((windowWidth - stringWidth) / 2f - 5, itemArea.method_3322() - 21, 100)
			.withBounds(stringWidth + 10, 10)
			.render(graphics);

		ms.method_46416(0, 0, 200);

//		UIRenderHelper.streak(0, itemArea.getX() - 10, itemArea.getY() - 20, 20, 180, 0x101010);
		graphics.method_25300(field_22793, relatedTitle, windowWidth / 2, itemArea.method_3322() - 20, Theme.i(Theme.Key.TEXT));

		ms.method_46416(0, 0, -200);

		UIRenderHelper.streak(graphics, 0, 0, 0, itemArea.method_3320() + 10, itemArea.method_3319() / 2 + 75);
		UIRenderHelper.streak(graphics, 180, 0, 0, itemArea.method_3320() + 10, itemArea.method_3319() / 2 + 75);

		ms.method_22909();

	}

	public int getItemsY() {
		return (int) (mainYmult * field_22790 + 85);
	}

	@Override
	protected void renderWindowForeground(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		RenderSystem.disableDepthTest();
		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(0, 0, 200);

		if (hoveredItem != null) {
			List<class_2561> list = TooltipHelper.cutStringTextComponent(hoveredItem.getDescription(),
				Palette.ALL_GRAY);
			list.add(0, Components.literal(hoveredItem.getTitle()));
			graphics.method_51434(field_22793, list, mouseX, mouseY);
		}

		ms.method_22909();
		RenderSystem.enableDepthTest();
	}

	@Override
	protected String getBreadcrumbTitle() {
		return Lang.translateDirect(TITLE)
			.getString();
	}

	@Override
	public boolean method_25421() {
		return true;
	}

	@Override
	public void method_25432() {
		super.method_25432();
		hoveredItem = null;
	}

}
