package com.simibubi.create.foundation.ponder.ui;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import net.minecraft.class_1041;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_2248;
import net.minecraft.class_2960;
import net.minecraft.class_332;
import net.minecraft.class_3532;
import net.minecraft.class_364;
import net.minecraft.class_4587;
import net.minecraft.class_768;
import net.minecraft.class_7923;
import com.mojang.blaze3d.systems.RenderSystem;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.gui.Theme;
import com.simibubi.create.foundation.gui.UIRenderHelper;
import com.simibubi.create.foundation.gui.element.BoxElement;
import com.simibubi.create.foundation.ponder.PonderChapter;
import com.simibubi.create.foundation.ponder.PonderLocalization;
import com.simibubi.create.foundation.ponder.PonderRegistry;
import com.simibubi.create.foundation.ponder.PonderTag;
import com.simibubi.create.foundation.utility.FontHelper;
import com.simibubi.create.foundation.utility.Lang;
import com.simibubi.create.foundation.utility.RegisteredObjects;

public class PonderTagScreen extends NavigatableSimiScreen {

	public static final String ASSOCIATED = PonderLocalization.LANG_PREFIX + "associated";

	private final PonderTag tag;
	protected final List<class_1792> items;
	private final double itemXmult = 0.5;
	protected class_768 itemArea;
	protected final List<PonderChapter> chapters;
	private final double chapterXmult = 0.5;
	private final double chapterYmult = 0.75;
	protected class_768 chapterArea;
	private final double mainYmult = 0.15;

	private class_1799 hoveredItem = class_1799.field_8037;

	public PonderTagScreen(PonderTag tag) {
		this.tag = tag;
		items = new ArrayList<>();
		chapters = new ArrayList<>();
	}

	@Override
	protected void method_25426() {
		super.method_25426();

		// items
		items.clear();
		PonderRegistry.TAGS.getItems(tag)
			.stream()
			.map(key -> {
				return class_7923.field_41178.method_17966(key)
						.or(() -> class_7923.field_41175.method_17966(key).map(class_2248::method_8389))
						.orElse(null);
			})
			.filter(Objects::nonNull)
			.forEach(items::add);

		if (!tag.getMainItem().method_7960())
			items.remove(tag.getMainItem().method_7909());

		int rowCount = class_3532.method_15340((int) Math.ceil(items.size() / 11d), 1, 3);
		LayoutHelper layout = LayoutHelper.centeredHorizontal(items.size(), rowCount, 28, 28, 8);
		itemArea = layout.getArea();
		int itemCenterX = (int) (field_22789 * itemXmult);
		int itemCenterY = getItemsY();

		for (class_1792 i : items) {
			PonderButton b = new PonderButton(itemCenterX + layout.getX() + 4, itemCenterY + layout.getY() + 4)
					.showing(new class_1799(i));

			if (PonderRegistry.ALL.containsKey(RegisteredObjects.getKeyOrThrow(i))) {
				b.withCallback((mouseX, mouseY) -> {
					centerScalingOn(mouseX, mouseY);
					ScreenOpener.transitionTo(PonderUI.of(new class_1799(i), tag));
				});
			} else {
				if (RegisteredObjects.getKeyOrThrow(i)
						.method_12836()
						.equals(Create.ID))
					b.withBorderColors(Theme.p(Theme.Key.PONDER_MISSING_CREATE))
							.animateColors(false);
				else
					b.withBorderColors(Theme.p(Theme.Key.PONDER_MISSING_VANILLA))
							.animateColors(false);
			}

			method_37063(b);
			layout.next();
		}

		if (!tag.getMainItem().method_7960()) {
			class_2960 registryName = RegisteredObjects.getKeyOrThrow(tag.getMainItem()
					.method_7909());

			PonderButton b = new PonderButton(itemCenterX - layout.getTotalWidth() / 2 - 48, itemCenterY - 10)
					.showing(tag.getMainItem());
			b.withCustomBackground(Theme.c(Theme.Key.PONDER_BACKGROUND_IMPORTANT));

			if (PonderRegistry.ALL.containsKey(registryName)) {
				b.withCallback((mouseX, mouseY) -> {
					centerScalingOn(mouseX, mouseY);
					ScreenOpener.transitionTo(PonderUI.of(tag.getMainItem(), tag));
				});
			} else {
				if (registryName.method_12836()
						.equals(Create.ID))
					b.withBorderColors(Theme.p(Theme.Key.PONDER_MISSING_CREATE))
							.animateColors(false);
				else
					b.withBorderColors(Theme.p(Theme.Key.PONDER_MISSING_VANILLA))
							.animateColors(false);
			}

			method_37063(b);
		}

		// chapters
		chapters.clear();
		chapters.addAll(PonderRegistry.TAGS.getChapters(tag));

		rowCount = class_3532.method_15340((int) Math.ceil(chapters.size() / 3f), 1, 3);
		layout = LayoutHelper.centeredHorizontal(chapters.size(), rowCount, 200, 38, 16);
		chapterArea = layout.getArea();
		int chapterCenterX = (int) (field_22789 * chapterXmult);
		int chapterCenterY = (int) (field_22790 * chapterYmult);

		for (PonderChapter chapter : chapters) {
			ChapterLabel label = new ChapterLabel(chapter, chapterCenterX + layout.getX(),
				chapterCenterY + layout.getY(), (mouseX, mouseY) -> {
					centerScalingOn(mouseX, mouseY);
					ScreenOpener.transitionTo(PonderUI.of(chapter));
				});

			method_37063(label);
			layout.next();
		}

	}

	@Override
	protected void initBackTrackIcon(PonderButton backTrack) {
		backTrack.showing(tag);
	}

	@Override
	public void method_25393() {
		super.method_25393();
		PonderUI.ponderTicks++;

		hoveredItem = class_1799.field_8037;
		class_1041 w = field_22787.method_22683();
		double mouseX = field_22787.field_1729.method_1603() * w.method_4486() / w.method_4480();
		double mouseY = field_22787.field_1729.method_1604() * w.method_4502() / w.method_4507();
		for (class_364 child : method_25396()) {
			if (child == backTrack)
				continue;
			if (child instanceof PonderButton button)
				if (button.method_25405(mouseX, mouseY)) {
					hoveredItem = button.getItem();
				}
		}
	}

	@Override
	protected void renderWindow(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		renderItems(graphics, mouseX, mouseY, partialTicks);

		renderChapters(graphics, mouseX, mouseY, partialTicks);

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_22904(field_22789 / 2 - 120, field_22790 * mainYmult - 40, 0);

		ms.method_22903();
		//ms.translate(0, 0, 800);
		int x = 31 + 20 + 8;
		int y = 31;

		String title = tag.getTitle();

		int streakHeight = 35;
		UIRenderHelper.streak(graphics, 0, x - 4, y - 12 + streakHeight / 2, streakHeight, 240);
		//PonderUI.renderBox(ms, 21, 21, 30, 30, false);
		new BoxElement()
				.withBackground(Theme.c(Theme.Key.PONDER_BACKGROUND_FLAT))
				.gradientBorder(Theme.p(Theme.Key.PONDER_IDLE))
				.at(21, 21, 100)
				.withBounds(30, 30)
				.render(graphics);

		graphics.method_51439(field_22793, Lang.translateDirect(PonderUI.PONDERING), x, y - 6, Theme.i(Theme.Key.TEXT_DARKER), false);
		y += 8;
		x += 0;
		ms.method_46416(x, y, 0);
		ms.method_46416(0, 0, 5);
		graphics.method_51433(field_22793, title, 0, 0, Theme.i(Theme.Key.TEXT), false);
		ms.method_22909();

		ms.method_22903();
		ms.method_46416(23, 23, 10);
		ms.method_22905(1.66f, 1.66f, 1.66f);
		tag.render(graphics, 0, 0);
		ms.method_22909();
		ms.method_22909();

		ms.method_22903();
		int w = (int) (field_22789 * .45);
		x = (field_22789 - w) / 2;
		y = getItemsY() - 10 + Math.max(itemArea.method_3320(), 48);

		String desc = tag.getDescription();
		int h = field_22793.method_1713(desc, w);


		//PonderUI.renderBox(ms, x - 3, y - 3, w + 6, h + 6, false);
		new BoxElement()
				.withBackground(Theme.c(Theme.Key.PONDER_BACKGROUND_FLAT))
				.gradientBorder(Theme.p(Theme.Key.PONDER_IDLE))
				.at(x - 3, y - 3, 90)
				.withBounds(w + 6, h + 6)
				.render(graphics);

		ms.method_46416(0, 0, 100);
		FontHelper.drawSplitString(ms, field_22793, desc, x, y, w, Theme.i(Theme.Key.TEXT));
		ms.method_22909();
	}

	protected void renderItems(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		if (items.isEmpty())
			return;

		int x = (int) (field_22789 * itemXmult);
		int y = getItemsY();

		String relatedTitle = Lang.translateDirect(ASSOCIATED).getString();
		int stringWidth = field_22793.method_1727(relatedTitle);

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(x, y, 0);
		//PonderUI.renderBox(ms, (sWidth - stringWidth) / 2 - 5, itemArea.getY() - 21, stringWidth + 10, 10, false);
		new BoxElement()
				.withBackground(Theme.c(Theme.Key.PONDER_BACKGROUND_FLAT))
				.gradientBorder(Theme.p(Theme.Key.PONDER_IDLE))
				.at((windowWidth - stringWidth) / 2f - 5, itemArea.method_3322() - 21, 100)
				.withBounds(stringWidth + 10, 10)
				.render(graphics);

		ms.method_46416(0, 0, 200);

//		UIRenderHelper.streak(0, itemArea.getX() - 10, itemArea.getY() - 20, 20, 180, 0x101010);
		graphics.method_25300(field_22793, relatedTitle, windowWidth / 2, itemArea.method_3322() - 20, Theme.i(Theme.Key.TEXT));

		ms.method_46416(0, 0, -200);

		UIRenderHelper.streak(graphics, 0, 0, 0, itemArea.method_3320() + 10, itemArea.method_3319() / 2 + 75);
		UIRenderHelper.streak(graphics, 180, 0, 0, itemArea.method_3320() + 10, itemArea.method_3319() / 2 + 75);

		ms.method_22909();

	}

	public int getItemsY() {
		return (int) (mainYmult * field_22790 + 85);
	}

	protected void renderChapters(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		if (chapters.isEmpty())
			return;

		int chapterX = (int) (field_22789 * chapterXmult);
		int chapterY = (int) (field_22790 * chapterYmult);

		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(chapterX, chapterY, 0);

		UIRenderHelper.streak(graphics, 0, chapterArea.method_3321() - 10, chapterArea.method_3322() - 20, 20, 220);
		graphics.method_51433(field_22793, "More Topics to Ponder about", chapterArea.method_3321() - 5, chapterArea.method_3322() - 25, Theme.i(Theme.Key.TEXT_ACCENT_SLIGHT), false);

		ms.method_22909();
	}

	@Override
	protected void renderWindowForeground(class_332 graphics, int mouseX, int mouseY, float partialTicks) {
		RenderSystem.disableDepthTest();
		class_4587 ms = graphics.method_51448();
		ms.method_22903();
		ms.method_46416(0, 0, 200);

		if (!hoveredItem.method_7960()) {
			graphics.method_51446(field_22793, hoveredItem, mouseX, mouseY);
		}

		ms.method_22909();
		RenderSystem.enableDepthTest();
	}

	@Override
	protected String getBreadcrumbTitle() {
		return tag.getTitle();
	}

	public class_1799 getHoveredTooltipItem() {
		return hoveredItem;
	}

	/*@Override
	public boolean mouseClicked(double x, double y, int button) {
		MutableBoolean handled = new MutableBoolean(false);
		widgets.forEach(w -> {
			if (handled.booleanValue())
				return;
			if (!w.isMouseOver(x, y))
				return;
			if (w instanceof PonderButton) {
				PonderButton mtdButton = (PonderButton) w;
				mtdButton.runCallback(x, y);
				handled.setTrue();
				return;
			}
		});

		if (handled.booleanValue())
			return true;
		return super.mouseClicked(x, y, button);
	}*/

	@Override
	public boolean isEquivalentTo(NavigatableSimiScreen other) {
		if (other instanceof PonderTagScreen)
			return tag == ((PonderTagScreen) other).tag;
		return super.isEquivalentTo(other);
	}

	@Override
	public boolean method_25421() {
		return true;
	}

	public PonderTag getTag() {
		return tag;
	}

	@Override
	public void method_25432() {
		super.method_25432();
		hoveredItem = class_1799.field_8037;
	}

}
