package com.simibubi.create.foundation.render;

import java.io.IOException;

import com.jozufozu.flywheel.backend.ShadersModHandler;
import com.simibubi.create.AllSpecialTextures;
import com.simibubi.create.Create;

import io.github.fabricators_of_create.porting_lib.mixin.accessors.client.accessor.RenderTypeAccessor;
import net.fabricmc.fabric.api.client.rendering.v1.CoreShaderRegistrationCallback;
import net.fabricmc.fabric.api.client.rendering.v1.CoreShaderRegistrationCallback.RegistrationContext;
import net.minecraft.class_1723;
import net.minecraft.class_1921;
import net.minecraft.class_290;
import net.minecraft.class_293;
import net.minecraft.class_2960;
import net.minecraft.class_4668;
import net.minecraft.class_5944;

// TODO 1.17: use custom shaders instead of vanilla ones
public class RenderTypes extends class_4668 {

	public static final class_4668.class_5942 GLOWING_SHADER = new class_4668.class_5942(() -> Shaders.glowingShader);

	private static final class_1921 OUTLINE_SOLID =
		RenderTypeAccessor.port_lib$create(createLayerName("outline_solid"), class_290.field_1580, class_293.class_5596.field_27382, 256, false,
			false, class_1921.class_4688.method_23598()
				.method_34578(field_29450)
				.method_34577(new class_4668.class_4683(AllSpecialTextures.BLANK.getLocation(), false, false))
				.method_23603(field_21344)
				.method_23608(field_21383)
				.method_23611(field_21385)
				.method_23617(false));

	public static class_1921 getOutlineSolid() {
		return OUTLINE_SOLID;
	}

	public static class_1921 getOutlineTranslucent(class_2960 texture, boolean cull) {
		return RenderTypeAccessor.port_lib$create(createLayerName("outline_translucent" + (cull ? "_cull" : "")),
			class_290.field_1580, class_293.class_5596.field_27382, 256, false, true, class_1921.class_4688.method_23598()
				.method_34578(cull ? field_29406 : field_29407)
				.method_34577(new class_4668.class_4683(texture, false, false))
				.method_23615(field_21370)
				.method_23603(cull ? field_21344 : field_21345)
				.method_23608(field_21383)
				.method_23611(field_21385)
				.method_23616(field_21350)
				.method_23617(false));
	}

	public static class_1921 getGlowingSolid(class_2960 texture) {
		return RenderTypeAccessor.port_lib$create(createLayerName("glowing_solid"), class_290.field_1580, class_293.class_5596.field_27382, 256,
			true, false, class_1921.class_4688.method_23598()
				.method_34578(GLOWING_SHADER)
				.method_34577(new class_4668.class_4683(texture, false, false))
				.method_23603(field_21344)
				.method_23608(field_21383)
				.method_23611(field_21385)
				.method_23617(true));
	}

	private static final class_1921 GLOWING_SOLID_DEFAULT = getGlowingSolid(class_1723.field_21668);

	public static class_1921 getGlowingSolid() {
		return GLOWING_SOLID_DEFAULT;
	}

	public static class_1921 getGlowingTranslucent(class_2960 texture) {
		return RenderTypeAccessor.port_lib$create(createLayerName("glowing_translucent"), class_290.field_1580, class_293.class_5596.field_27382,
			256, true, true, class_1921.class_4688.method_23598()
				.method_34578(GLOWING_SHADER)
				.method_34577(new class_4668.class_4683(texture, false, false))
				.method_23615(field_21370)
				.method_23608(field_21383)
				.method_23611(field_21385)
				.method_23617(true));
	}

	private static final class_1921 ADDITIVE = class_1921.method_24049(createLayerName("additive"), class_290.field_1590,
		class_293.class_5596.field_27382, 256, true, true, class_1921.class_4688.method_23598()
			.method_34578(field_29443)
			.method_34577(new class_4668.class_4683(class_1723.field_21668, false, false))
			.method_23615(field_21366)
			.method_23603(field_21345)
			.method_23608(field_21383)
			.method_23611(field_21385)
			.method_23617(true));

	public static class_1921 getAdditive() {
		return ADDITIVE;
	}

	private static final class_1921 GLOWING_TRANSLUCENT_DEFAULT = getGlowingTranslucent(class_1723.field_21668);

	public static class_1921 getGlowingTranslucent() {
		return GLOWING_TRANSLUCENT_DEFAULT;
	}

	private static final class_1921 ITEM_PARTIAL_SOLID =
		RenderTypeAccessor.port_lib$create(createLayerName("item_partial_solid"), class_290.field_1580, class_293.class_5596.field_27382, 256, true,
			false, class_1921.class_4688.method_23598()
				.method_34578(field_29450)
				.method_34577(field_21377)
				.method_23603(field_21344)
				.method_23608(field_21383)
				.method_23611(field_21385)
				.method_23617(true));

	public static class_1921 getItemPartialSolid() {
		return ITEM_PARTIAL_SOLID;
	}

	private static final class_1921 ITEM_PARTIAL_TRANSLUCENT = RenderTypeAccessor.port_lib$create(createLayerName("item_partial_translucent"),
		class_290.field_1580, class_293.class_5596.field_27382, 256, true, true, class_1921.class_4688.method_23598()
			.method_34578(field_29406)
			.method_34577(field_21377)
			.method_23615(field_21370)
			.method_23608(field_21383)
			.method_23611(field_21385)
			.method_23617(true));

	public static class_1921 getItemPartialTranslucent() {
		return ITEM_PARTIAL_TRANSLUCENT;
	}

	private static final class_1921 FLUID = RenderTypeAccessor.port_lib$create(createLayerName("fluid"),
		class_290.field_1580, class_293.class_5596.field_27382, 256, false, true, class_1921.class_4688.method_23598()
			.method_34578(field_29406)
			.method_34577(field_21376)
			.method_23615(field_21370)
			.method_23608(field_21383)
			.method_23611(field_21385)
			.method_23617(true));

	public static class_1921 getFluid() {
		return FLUID;
	}

	private static String createLayerName(String name) {
		return Create.ID + ":" + name;
	}

	// Mmm gimme those protected fields
	private RenderTypes() {
		super(null, null, null);
	}

	public static void init() {
		CoreShaderRegistrationCallback.EVENT.register(Shaders::onRegisterShaders);
	}

	private static class Shaders {
		private static class_5944 glowingShader;

		public static void onRegisterShaders(RegistrationContext ctx) throws IOException {
			ctx.register(Create.asResource("glowing_shader"), class_290.field_1580, shader -> glowingShader = shader);
		}
	}

}
