package com.simibubi.create.foundation.render;

import java.util.SortedMap;
import net.minecraft.class_1088;
import net.minecraft.class_156;
import net.minecraft.class_1921;
import net.minecraft.class_287;
import net.minecraft.class_4588;
import net.minecraft.class_4597;
import net.minecraft.class_4722;
import net.minecraft.class_750;
import it.unimi.dsi.fastutil.objects.Object2ObjectLinkedOpenHashMap;

public class SuperRenderTypeBuffer implements class_4597 {

	private static final SuperRenderTypeBuffer INSTANCE = new SuperRenderTypeBuffer();

	public static SuperRenderTypeBuffer getInstance() {
		return INSTANCE;
	}

	private SuperRenderTypeBufferPhase earlyBuffer;
	private SuperRenderTypeBufferPhase defaultBuffer;
	private SuperRenderTypeBufferPhase lateBuffer;

	public SuperRenderTypeBuffer() {
		earlyBuffer = new SuperRenderTypeBufferPhase();
		defaultBuffer = new SuperRenderTypeBufferPhase();
		lateBuffer = new SuperRenderTypeBufferPhase();
	}

	public class_4588 getEarlyBuffer(class_1921 type) {
		return earlyBuffer.bufferSource.getBuffer(type);
	}

	@Override
	public class_4588 getBuffer(class_1921 type) {
		return defaultBuffer.bufferSource.getBuffer(type);
	}

	public class_4588 getLateBuffer(class_1921 type) {
		return lateBuffer.bufferSource.getBuffer(type);
	}

	public void draw() {
		earlyBuffer.bufferSource.method_22993();
		defaultBuffer.bufferSource.method_22993();
		lateBuffer.bufferSource.method_22993();
	}

	public void draw(class_1921 type) {
		earlyBuffer.bufferSource.method_22994(type);
		defaultBuffer.bufferSource.method_22994(type);
		lateBuffer.bufferSource.method_22994(type);
	}

	private static class SuperRenderTypeBufferPhase {

		// Visible clones from RenderBuffers
		private final class_750 fixedBufferPack = new class_750();
		private final SortedMap<class_1921, class_287> fixedBuffers = class_156.method_654(new Object2ObjectLinkedOpenHashMap<>(), map -> {
				map.put(class_4722.method_24073(), fixedBufferPack.method_3154(class_1921.method_23577()));
				map.put(class_4722.method_24074(), fixedBufferPack.method_3154(class_1921.method_23581()));
				map.put(class_4722.method_24059(), fixedBufferPack.method_3154(class_1921.method_23579()));
				map.put(class_4722.method_24076(), fixedBufferPack.method_3154(class_1921.method_23583()));
				put(map, class_4722.method_24067());
				put(map, class_4722.method_24069());
				put(map, class_4722.method_24070());
				put(map, class_4722.method_24071());
				put(map, class_4722.method_24072());
				put(map, class_1921.method_23585());
				put(map, class_1921.method_27948());
				put(map, class_1921.method_27949());
				put(map, class_1921.method_23590());
				put(map, class_1921.method_29706());
				put(map, class_1921.method_30676());
				put(map, class_1921.method_23591());
				put(map, class_1921.method_29707());
				put(map, class_1921.method_23589());
				put(map, RenderTypes.getOutlineSolid());
				class_1088.field_21772.forEach((p_173062_) -> {
					put(map, p_173062_);
				});
			});
		private final class_4597.class_4598 bufferSource = class_4597.method_22992(fixedBuffers, new class_287(256));

		private static void put(Object2ObjectLinkedOpenHashMap<class_1921, class_287> map, class_1921 type) {
			map.put(type, new class_287(type.method_22722()));
		}

	}

}
