package com.simibubi.create.foundation.utility;

import com.simibubi.create.foundation.ponder.PonderWorld;
import com.simibubi.create.foundation.ponder.ui.PonderUI;
import com.simibubi.create.foundation.utility.worldWrappers.WrappedClientWorld;

import io.github.fabricators_of_create.porting_lib.common.util.MinecraftClientUtil;
import net.minecraft.class_1936;
import net.minecraft.class_310;

public class AnimationTickHolder {

	private static int ticks;
	private static int pausedTicks;

	public static void reset() {
		ticks = 0;
		pausedTicks = 0;
	}

	public static void tick() {
		if (!class_310.method_1551()
			.method_1493()) {
			ticks = (ticks + 1) % 1_728_000; // wrap around every 24 hours so we maintain enough floating point precision
		} else {
			pausedTicks = (pausedTicks + 1) % 1_728_000;
		}
	}

	public static int getTicks() {
		return getTicks(false);
	}

	public static int getTicks(boolean includePaused) {
		return includePaused ? ticks + pausedTicks : ticks;
	}

	public static float getRenderTime() {
		return getTicks() + getPartialTicks();
	}

	public static float getPartialTicks() {
		class_310 mc = class_310.method_1551();
		return (mc.method_1493() ? MinecraftClientUtil.getRenderPartialTicksPaused(mc) : mc.method_1488());
	}

	public static int getTicks(class_1936 world) {
		if (world instanceof WrappedClientWorld)
			return getTicks(((WrappedClientWorld) world).getWrappedWorld());
		return world instanceof PonderWorld ? PonderUI.ponderTicks : getTicks();
	}

	public static float getRenderTime(class_1936 world) {
		return getTicks(world) + getPartialTicks(world);
	}

	public static float getPartialTicks(class_1936 world) {
		return world instanceof PonderWorld ? PonderUI.getPartialTicks() : getPartialTicks();
	}
}
