package com.simibubi.create.foundation.utility;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import net.minecraft.class_1799;
import net.minecraft.class_2561;
import net.minecraft.class_2680;
import net.minecraft.class_5250;
import com.simibubi.create.Create;

import io.github.fabricators_of_create.porting_lib.fluids.FluidStack;

public class Lang {

	/**
	 * legacy-ish. Use Lang.translate and other builder methods where possible
	 *
	 * @param key
	 * @param args
	 * @return
	 */
	public static class_5250 translateDirect(String key, Object... args) {
		return Components.translatable(Create.ID + "." + key, resolveBuilders(args));
	}

	public static String asId(String name) {
		return name.toLowerCase(Locale.ROOT);
	}

	public static String nonPluralId(String name) {
		String asId = asId(name);
		return asId.endsWith("s") ? asId.substring(0, asId.length() - 1) : asId;
	}

	public static List<class_2561> translatedOptions(String prefix, String... keys) {
		List<class_2561> result = new ArrayList<>(keys.length);
		for (String key : keys)
			result.add(translate((prefix != null ? prefix + "." : "") + key).component());
		return result;
	}

	//

	public static LangBuilder builder() {
		return new LangBuilder(Create.ID);
	}

	public static LangBuilder builder(String namespace) {
		return new LangBuilder(namespace);
	}

	//

	public static LangBuilder blockName(class_2680 state) {
		return builder().add(state.method_26204()
			.method_9518());
	}

	public static LangBuilder itemName(class_1799 stack) {
		return builder().add(stack.method_7964()
			.method_27661());
	}

	public static LangBuilder fluidName(FluidStack stack) {
		return builder().add(stack.getDisplayName()
			.method_27661());
	}

	public static LangBuilder number(double d) {
		return builder().text(LangNumberFormat.format(d));
	}

	public static LangBuilder translate(String langKey, Object... args) {
		return builder().translate(langKey, args);
	}

	public static LangBuilder text(String text) {
		return builder().text(text);
	}

	//

	public static Object[] resolveBuilders(Object[] args) {
		for (int i = 0; i < args.length; i++)
			if (args[i]instanceof LangBuilder cb)
				args[i] = cb.component();
		return args;
	}

}
