package com.simibubi.create.foundation.utility.ghost;

import com.jozufozu.flywheel.core.virtual.VirtualEmptyBlockGetter;
import com.jozufozu.flywheel.fabric.model.DefaultLayerFilteringBakedModel;
import com.simibubi.create.foundation.placement.PlacementHelpers;
import com.simibubi.create.foundation.render.SuperRenderTypeBuffer;

import io.github.fabricators_of_create.porting_lib.models.virtual.FixedLightBakedModel;
import io.github.fabricators_of_create.porting_lib.models.virtual.TranslucentBakedModel;
import net.minecraft.class_1087;
import net.minecraft.class_1921;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import net.minecraft.class_310;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_4608;
import net.minecraft.class_4696;
import net.minecraft.class_5819;
import net.minecraft.class_761;
import net.minecraft.class_776;

public abstract class GhostBlockRenderer {

	private static final GhostBlockRenderer STANDARD = new DefaultGhostBlockRenderer();

	public static GhostBlockRenderer standard() {
		return STANDARD;
	}

	private static final GhostBlockRenderer TRANSPARENT = new TransparentGhostBlockRenderer();

	public static GhostBlockRenderer transparent() {
		return TRANSPARENT;
	}

	public abstract void render(class_4587 ms, SuperRenderTypeBuffer buffer, class_243 camera, GhostBlockParams params);

	private static class DefaultGhostBlockRenderer extends GhostBlockRenderer {

		@Override
		public void render(class_4587 ms, SuperRenderTypeBuffer buffer, class_243 camera, GhostBlockParams params) {
			ms.method_22903();

			class_776 dispatcher = class_310.method_1551()
				.method_1541();

			class_1087 model = dispatcher.method_3349(params.state);

			class_1921 layer = class_4696.method_23683(params.state, false);
			class_4588 vb = buffer.getEarlyBuffer(layer);

			class_2338 pos = params.pos;
			ms.method_22904(pos.method_10263() - camera.field_1352, pos.method_10264() - camera.field_1351, pos.method_10260() - camera.field_1350);

			model = DefaultLayerFilteringBakedModel.wrap(model);
			dispatcher.method_3350()
					.method_3374(VirtualEmptyBlockGetter.FULL_BRIGHT, model, params.state, pos, ms, vb, false, class_5819.method_43047(), 42L, class_4608.field_21444);

			ms.method_22909();
		}

	}

	private static class TransparentGhostBlockRenderer extends GhostBlockRenderer {

		@Override
		public void render(class_4587 ms, SuperRenderTypeBuffer buffer, class_243 camera, GhostBlockParams params) {
			class_310 mc = class_310.method_1551();
			class_776 dispatcher = mc.method_1541();

			class_2680 state = params.state;
			class_2338 pos = params.pos;
			float alpha = params.alphaSupplier.get() * .75f * PlacementHelpers.getCurrentAlpha();

			class_1087 model = dispatcher.method_3349(state);
			class_1921 layer = class_1921.method_23583();
			class_4588 vb = buffer.getEarlyBuffer(layer);

			ms.method_22903();
			ms.method_22904(pos.method_10263() - camera.field_1352, pos.method_10264() - camera.field_1351, pos.method_10260() - camera.field_1350);

			ms.method_22904(.5, .5, .5);
			ms.method_22905(.85f, .85f, .85f);
			ms.method_22904(-.5, -.5, -.5);

			model = DefaultLayerFilteringBakedModel.wrap(model);
			model = FixedLightBakedModel.wrap(model, class_761.method_23794(mc.field_1687, pos));
			model = TranslucentBakedModel.wrap(model, () -> params.alphaSupplier.get() * .75f * PlacementHelpers.getCurrentAlpha());
			dispatcher.method_3350()
					.method_3374(VirtualEmptyBlockGetter.INSTANCE, model, params.state, pos, ms, vb, false, class_5819.method_43047(), 42L, class_4608.field_21444);

			ms.method_22909();
		}

	}

}
