package com.simibubi.create.infrastructure.command;

import java.util.Collection;
import java.util.concurrent.atomic.AtomicInteger;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_2186;
import net.minecraft.class_3222;
import com.mojang.brigadier.arguments.FloatArgumentType;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.simibubi.create.AllPackets;
import com.simibubi.create.foundation.utility.CameraAngleAnimationService;

public class CameraAngleCommand {

	public static ArgumentBuilder<class_2168, ?> register() {
		return class_2170.method_9247("angle")
				.requires(cs -> cs.method_9259(2))
				.then(class_2170.method_9244("players", class_2186.method_9308())
						.then(class_2170.method_9247("yaw")
								.then(class_2170.method_9244("degrees", FloatArgumentType.floatArg())
										.executes(context -> updateCameraAngle(context, true))
								)
						).then(class_2170.method_9247("pitch")
								.then(class_2170.method_9244("degrees", FloatArgumentType.floatArg())
										.executes(context -> updateCameraAngle(context, false))
								)
						).then(class_2170.method_9247("mode")
								.then(class_2170.method_9247("linear")
										.executes(context -> updateCameraAnimationMode(context, CameraAngleAnimationService.Mode.LINEAR.name()))
										.then(class_2170.method_9244("speed", FloatArgumentType.floatArg(0))
												.executes(context -> updateCameraAnimationMode(context, CameraAngleAnimationService.Mode.LINEAR.name(), FloatArgumentType.getFloat(context, "speed")))
										)
								).then(class_2170.method_9247("exponential")
										.executes(context -> updateCameraAnimationMode(context, CameraAngleAnimationService.Mode.EXPONENTIAL.name()))
										.then(class_2170.method_9244("speed", FloatArgumentType.floatArg(0))
												.executes(context -> updateCameraAnimationMode(context, CameraAngleAnimationService.Mode.EXPONENTIAL.name(), FloatArgumentType.getFloat(context, "speed")))
										)
								)
						)
				);
	}

	private static int updateCameraAngle(CommandContext<class_2168> ctx, boolean yaw) throws CommandSyntaxException {
		AtomicInteger targets = new AtomicInteger(0);

		float angleTarget = FloatArgumentType.getFloat(ctx, "degrees");
		String optionName = (yaw ? SConfigureConfigPacket.Actions.camAngleYawTarget : SConfigureConfigPacket.Actions.camAnglePitchTarget).name();

		getPlayersFromContext(ctx).forEach(player -> {
			AllPackets.getChannel().sendToClient(
					new SConfigureConfigPacket(optionName, String.valueOf(angleTarget)), player
			);
			targets.incrementAndGet();
		});

		return targets.get();
	}

	private static int updateCameraAnimationMode(CommandContext<class_2168> ctx, String value) throws CommandSyntaxException {
		AtomicInteger targets = new AtomicInteger(0);

		getPlayersFromContext(ctx).forEach(player -> {
			AllPackets.getChannel().sendToClient(
					new SConfigureConfigPacket(SConfigureConfigPacket.Actions.camAngleFunction.name(), value), player
			);
			targets.incrementAndGet();
		});

		return targets.get();
	}

	private static int updateCameraAnimationMode(CommandContext<class_2168> ctx, String value, float speed) throws CommandSyntaxException {
		AtomicInteger targets = new AtomicInteger(0);

		getPlayersFromContext(ctx).forEach(player -> {
			AllPackets.getChannel().sendToClient(
					new SConfigureConfigPacket(SConfigureConfigPacket.Actions.camAngleFunction.name(), value + ":" + speed), player
			);
			targets.incrementAndGet();
		});

		return targets.get();
	}

	private static Collection<class_3222> getPlayersFromContext(CommandContext<class_2168> ctx) throws CommandSyntaxException {
		return class_2186.method_9312(ctx, "players");
	}
}
