package com.simibubi.create.infrastructure.command;

import java.util.Collection;
import net.minecraft.class_1937;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_2186;
import net.minecraft.class_2262;
import net.minecraft.class_2338;
import net.minecraft.class_239;
import net.minecraft.class_243;
import net.minecraft.class_2586;
import net.minecraft.class_3222;
import net.minecraft.class_3959;
import net.minecraft.class_3965;
import com.jamieswhiteshirt.reachentityattributes.ReachEntityAttributes;
import com.mojang.brigadier.Command;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.simibubi.create.AllPackets;
import com.simibubi.create.content.contraptions.AssemblyException;
import com.simibubi.create.content.contraptions.IDisplayAssemblyExceptions;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.foundation.utility.fabric.ReachUtil;

public class HighlightCommand {

	public static ArgumentBuilder<class_2168, ?> register() {
		return class_2170.method_9247("highlight")
			.then(class_2170.method_9244("pos", class_2262.method_9698())
				.then(class_2170.method_9244("players", class_2186.method_9308())
					.executes(ctx -> {
						Collection<class_3222> players = class_2186.method_9312(ctx, "players");
						class_2338 pos = class_2262.method_9696(ctx, "pos");

						for (class_3222 p : players) {
							AllPackets.getChannel().sendToClient(new HighlightPacket(pos), p);
						}

						return players.size();
					}))
				// .requires(AllCommands.sourceIsPlayer)
				.executes(ctx -> {
					class_2338 pos = class_2262.method_9696(ctx, "pos");

					AllPackets.getChannel().sendToClient(new HighlightPacket(pos), (class_3222) ctx.getSource().method_9228());

					return Command.SINGLE_SUCCESS;
				}))
			// .requires(AllCommands.sourceIsPlayer)
			.executes(ctx -> {
				class_3222 player = ctx.getSource()
					.method_9207();
				return highlightAssemblyExceptionFor(player, ctx.getSource());
			});

	}

	private static void sendMissMessage(class_2168 source) {
		source.method_9226(() ->
			Components.literal("Try looking at a Block that has failed to assemble a Contraption and try again."),
			true);
	}

	private static int highlightAssemblyExceptionFor(class_3222 player, class_2168 source) {
		double distance = ReachUtil.reach(player);
		class_243 start = player.method_5836(1);
		class_243 look = player.method_5828(1);
		class_243 end = start.method_1031(look.field_1352 * distance, look.field_1351 * distance, look.field_1350 * distance);
		class_1937 world = player.method_37908();

		class_3965 ray = world.method_17742(
			new class_3959(start, end, class_3959.class_3960.field_17559, class_3959.class_242.field_1348, player));
		if (ray.method_17783() == class_239.class_240.field_1333) {
			sendMissMessage(source);
			return 0;
		}

		class_2338 pos = ray.method_17777();
		class_2586 be = world.method_8321(pos);
		if (!(be instanceof IDisplayAssemblyExceptions)) {
			sendMissMessage(source);
			return 0;
		}

		IDisplayAssemblyExceptions display = (IDisplayAssemblyExceptions) be;
		AssemblyException exception = display.getLastAssemblyException();
		if (exception == null) {
			sendMissMessage(source);
			return 0;
		}

		if (!exception.hasPosition()) {
			source.method_9226(() -> Components.literal("Can't highlight a specific position for this issue"), true);
			return Command.SINGLE_SUCCESS;
		}

		class_2338 p = exception.getPosition();
		String command = "/create highlight " + p.method_10263() + " " + p.method_10264() + " " + p.method_10260();
		return player.field_13995.method_3734()
			.method_44252(source, command);
	}
}
