package com.simibubi.create.infrastructure.command;

import com.mojang.brigadier.arguments.IntegerArgumentType;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.simibubi.create.content.contraptions.AbstractContraptionEntity;
import com.simibubi.create.content.contraptions.ControlledContraptionEntity;
import com.simibubi.create.content.trains.entity.CarriageContraptionEntity;
import net.minecraft.class_1297;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_2186;

public class PassengerCommand {

	static ArgumentBuilder<class_2168, ?> register() {
		return class_2170.method_9247("passenger")
			.requires(cs -> cs.method_9259(2))
			.then(class_2170.method_9244("rider", class_2186.method_9309())
				.then(class_2170.method_9244("vehicle", class_2186.method_9309())
					.executes(ctx -> {
						run(ctx.getSource(), class_2186.method_9313(ctx, "vehicle"),
							class_2186.method_9313(ctx, "rider"), 0);
						return 1;
					})
					.then(class_2170.method_9244("seatIndex", IntegerArgumentType.integer(0))
						.executes(ctx -> {
							run(ctx.getSource(), class_2186.method_9313(ctx, "vehicle"),
								class_2186.method_9313(ctx, "rider"),
								IntegerArgumentType.getInteger(ctx, "seatIndex"));
							return 1;
						}))));
	}

	private static void run(class_2168 source, class_1297 vehicle, class_1297 rider, int index) {
		if (vehicle == rider)
			return;
		if (rider instanceof CarriageContraptionEntity)
			return;
		if (rider instanceof ControlledContraptionEntity)
			return;
		
		if (vehicle instanceof AbstractContraptionEntity ace) {
			if (ace.getContraption()
				.getSeats()
				.size() > index)
				ace.addSittingPassenger(rider, index);
			return;
		}
		
		rider.method_5873(vehicle, true);
	}
}
