package com.simibubi.create.infrastructure.command;

import java.util.Collection;

import com.google.common.collect.ImmutableList;
import com.mojang.brigadier.Command;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.mojang.brigadier.suggestion.SuggestionProvider;
import com.simibubi.create.AllPackets;
import com.simibubi.create.foundation.ponder.PonderRegistry;

import net.fabricmc.fabric.api.entity.FakePlayer;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_2172;
import net.minecraft.class_2186;
import net.minecraft.class_2232;
import net.minecraft.class_2321;
import net.minecraft.class_2960;
import net.minecraft.class_3222;

public class PonderCommand {
	public static final SuggestionProvider<class_2168> ITEM_PONDERS = class_2321.method_10022(new class_2960("all_ponders"), (iSuggestionProviderCommandContext, builder) -> class_2172.method_9257(PonderRegistry.ALL.keySet().stream(), builder));

	static ArgumentBuilder<class_2168, ?> register() {
		return class_2170.method_9247("ponder")
				.requires(cs -> cs.method_9259(0))
				.executes(ctx -> openScene("index", ctx.getSource().method_9207()))
				.then(class_2170.method_9244("scene", class_2232.method_9441())
						.suggests(ITEM_PONDERS)
						.executes(ctx -> openScene(class_2232.method_9443(ctx, "scene").toString(), ctx.getSource().method_9207()))
						.then(class_2170.method_9244("targets", class_2186.method_9308())
								.requires(cs -> cs.method_9259(2))
								.executes(ctx -> openScene(class_2232.method_9443(ctx, "scene").toString(), class_2186.method_9312(ctx, "targets")))
						)
				);

	}

	private static int openScene(String sceneId, class_3222 player) {
		return openScene(sceneId, ImmutableList.of(player));
	}

	private static int openScene(String sceneId, Collection<? extends class_3222> players) {
		for (class_3222 player : players) {
			if (player instanceof FakePlayer)
				continue;

			AllPackets.getChannel().sendToClient(new SConfigureConfigPacket(SConfigureConfigPacket.Actions.openPonder.name(), sceneId), player);
		}
		return Command.SINGLE_SUCCESS;
	}
}
