package com.simibubi.create.infrastructure.command;

import org.apache.commons.lang3.mutable.MutableInt;

import com.mojang.brigadier.arguments.StringArgumentType;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.simibubi.create.foundation.utility.Components;
import net.minecraft.class_1918;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_2262;
import net.minecraft.class_2288;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2593;
import net.minecraft.class_2680;
import net.minecraft.class_3218;

public class ReplaceInCommandBlocksCommand {

	public static ArgumentBuilder<class_2168, ?> register() {
		return class_2170.method_9247("replaceInCommandBlocks")
			.requires(cs -> cs.method_9259(2))
			.then(class_2170.method_9244("begin", class_2262.method_9698())
				.then(class_2170.method_9244("end", class_2262.method_9698())
					.then(class_2170.method_9244("toReplace", StringArgumentType.string())
						.then(class_2170.method_9244("replaceWith", StringArgumentType.string())
							.executes(ctx -> {
								doReplace(ctx.getSource(), class_2262.method_9696(ctx, "begin"),
									class_2262.method_9696(ctx, "end"),
									StringArgumentType.getString(ctx, "toReplace"),
									StringArgumentType.getString(ctx, "replaceWith"));
								return 1;
							})))));

	}

	private static void doReplace(class_2168 source, class_2338 from, class_2338 to, String toReplace,
		String replaceWith) {
		class_3218 world = source.method_9225();
		MutableInt blocks = new MutableInt(0);
		class_2338.method_20437(from, to)
			.forEach(pos -> {
				class_2680 blockState = world.method_8320(pos);
				if (!(blockState.method_26204() instanceof class_2288))
					return;
				class_2586 blockEntity = world.method_8321(pos);
				if (!(blockEntity instanceof class_2593))
					return;
				class_2593 cb = (class_2593) blockEntity;
				class_1918 commandBlockLogic = cb.method_11040();
				String command = commandBlockLogic.method_8289();
				if (command.indexOf(toReplace) != -1)
					blocks.increment();
				commandBlockLogic.method_8286(command.replaceAll(toReplace, replaceWith));
				cb.method_5431();
				world.method_8413(pos, blockState, blockState, 2);
			});
		int intValue = blocks.intValue();
		if (intValue == 0) {
			source.method_9226(() -> Components.literal("Couldn't find \"" + toReplace + "\" anywhere."), true);
			return;
		}
		source.method_9226(() -> Components.literal("Replaced occurrences in " + intValue + " blocks."), true);
	}

}
