package com.simibubi.create.infrastructure.data;

import com.simibubi.create.AllTags.AllBlockTags;
import com.simibubi.create.AllTags.AllEntityTags;
import com.simibubi.create.AllTags.AllFluidTags;
import com.simibubi.create.AllTags.AllItemTags;
import com.simibubi.create.Create;
import com.simibubi.create.foundation.data.TagGen;
import com.simibubi.create.foundation.data.TagGen.CreateTagsProvider;
import com.simibubi.create.foundation.data.recipe.Mods;
import com.tterrag.registrate.providers.ProviderType;
import com.tterrag.registrate.providers.RegistrateTagsProvider;

import io.github.fabricators_of_create.porting_lib.tags.Tags;
import net.minecraft.class_1299;
import net.minecraft.class_1792;
import net.minecraft.class_1802;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2474.class_5124;
import net.minecraft.class_3481;
import net.minecraft.class_3489;
import net.minecraft.class_3611;
import net.minecraft.class_3612;

public class CreateRegistrateTags {
	public static void addGenerators() {
		Create.REGISTRATE.addDataGenerator(ProviderType.BLOCK_TAGS, CreateRegistrateTags::genBlockTags);
		Create.REGISTRATE.addDataGenerator(ProviderType.ITEM_TAGS, CreateRegistrateTags::genItemTags);
		Create.REGISTRATE.addDataGenerator(ProviderType.FLUID_TAGS, CreateRegistrateTags::genFluidTags);
		Create.REGISTRATE.addDataGenerator(ProviderType.ENTITY_TAGS, CreateRegistrateTags::genEntityTags);
	}

	private static void genBlockTags(RegistrateTagsProvider<class_2248> provIn) {
		CreateTagsProvider<class_2248> prov = new CreateTagsProvider<>(provIn, class_2248::method_40142);

		prov.tag(AllBlockTags.BRITTLE.tag)
			.add(class_2246.field_16332, class_2246.field_10302, class_2246.field_10495)
			.method_26792(class_3481.field_16443)
			.method_26792(class_3481.field_15495);

		prov.tag(AllBlockTags.COPYCAT_ALLOW.tag)
			.add(class_2246.field_16328);

		prov.tag(AllBlockTags.COPYCAT_DENY.tag)
			.method_26792(class_3481.field_26985)
			.method_26792(class_3481.field_15462)
			.method_26792(class_3481.field_22414);

		prov.tag(AllBlockTags.FAN_PROCESSING_CATALYSTS_HAUNTING.tag)
			.add(class_2246.field_22089)
			.add(class_2246.field_23860);

		prov.tag(AllBlockTags.FAN_PROCESSING_CATALYSTS_SMOKING.tag)
			.add(class_2246.field_10036)
			.add(class_2246.field_17350);

		prov.tag(AllBlockTags.FAN_TRANSPARENT.tag)
			.add(class_2246.field_10576)
			.add(class_2246.field_37546)
			.method_26792(class_3481.field_23799)
			.method_26792(class_3481.field_16584)
			.method_26792(class_3481.field_15503);

		prov.tag(AllBlockTags.MOVABLE_EMPTY_COLLIDER.tag)
			.add(class_2246.field_10343, class_2246.field_27879, class_2246.field_10589, class_2246.field_10348)
			.method_26792(class_3481.field_25147);

		prov.tag(AllBlockTags.ORE_OVERRIDE_STONE.tag)
			.method_26792(class_3481.field_28992);

		prov.tag(AllBlockTags.PASSIVE_BOILER_HEATERS.tag)
			.add(class_2246.field_10092, class_2246.field_10164)
			.method_26792(class_3481.field_23799)
			.method_26792(class_3481.field_21952);

		prov.tag(AllBlockTags.SAFE_NBT.tag)
			.method_26792(class_3481.field_15501)
			.method_26792(class_3481.field_15500);

		prov.tag(AllBlockTags.TREE_ATTACHMENTS.tag)
			.add(class_2246.field_20421, class_2246.field_10302, class_2246.field_37544, class_2246.field_28680, class_2246.field_22122, class_2246.field_10597);

		prov.tag(AllBlockTags.WINDMILL_SAILS.tag)
			.method_26792(class_3481.field_15481);

		prov.tag(AllBlockTags.WRENCH_PICKUP.tag)
			.add(class_2246.field_10091, class_2246.field_10523, class_2246.field_10450, class_2246.field_10363,
					class_2246.field_10377, class_2246.field_10282, class_2246.field_10301, class_2246.field_10560, class_2246.field_10615,
					class_2246.field_10589, class_2246.field_10348, class_2246.field_10429, class_2246.field_22422, class_2246.field_10312)
			.method_26792(class_3481.field_15493)
			.method_26792(class_3481.field_24076)
			.method_26792(class_3481.field_15463);

		// COMPAT

		TagGen.addOptional(prov.tag(AllBlockTags.NON_MOVABLE.tag), Mods.IE,
				"connector_lv", "connector_lv_relay", "connector_mv", "connector_mv_relay",
				"connector_hv", "connector_hv_relay", "connector_bundled", "connector_structural",
				"connector_redstone", "connector_probe", "breaker_switch");

		// VALIDATE

		for (AllBlockTags tag : AllBlockTags.values()) {
			if (tag.alwaysDatagen) {
				prov.getOrCreateRawBuilder(tag.tag);
			}
		}
	}

	private static void genItemTags(RegistrateTagsProvider<class_1792> provIn) {
		CreateTagsProvider<class_1792> prov = new CreateTagsProvider<>(provIn, class_1792::method_40131);

		prov.tag(AllItemTags.SLEEPERS.tag)
			.add(class_1802.field_8595, class_1802.field_8291, class_1802.field_8742);

		prov.tag(AllItemTags.STRIPPED_LOGS.tag)
			.method_26792(AllItemTags.VANILLA_STRIPPED_LOGS.tag)
			.method_26792(AllItemTags.MODDED_STRIPPED_LOGS.tag);

		prov.tag(AllItemTags.STRIPPED_WOOD.tag)
			.method_26792(AllItemTags.VANILLA_STRIPPED_WOOD.tag)
			.method_26792(AllItemTags.MODDED_STRIPPED_WOOD.tag);

		prov.tag(AllItemTags.DEPLOYABLE_DRINK.tag)
			.add(class_1802.field_8103, class_1802.field_8574);

		prov.tag(AllItemTags.UPRIGHT_ON_BELT.tag)
			.add(class_1802.field_8469, class_1802.field_8574, class_1802.field_8436, class_1802.field_8150,
					class_1802.field_20417, class_1802.field_17534);

		prov.tag(AllItemTags.CONTRAPTION_CONTROLLED.tag)
			.add(class_1802.field_16315, class_1802.field_17346, class_1802.field_23842, class_1802.field_8357, class_1802.field_8878);

		prov.tag(AllItemTags.VANILLA_STRIPPED_LOGS.tag)
			.add(class_1802.field_8072, class_1802.field_8767, class_1802.field_21983,
				class_1802.field_8808, class_1802.field_8334, class_1802.field_37515,
				class_1802.field_8415, class_1802.field_8624, class_1802.field_21984, class_1802.field_42693, class_1802.field_41065);

		prov.tag(AllItemTags.VANILLA_STRIPPED_WOOD.tag)
			.add(class_1802.field_8284, class_1802.field_8472, class_1802.field_22487,
				class_1802.field_8219, class_1802.field_8785, class_1802.field_37509,
				class_1802.field_8248, class_1802.field_8362, class_1802.field_22488, class_1802.field_42690);

		prov.tag(class_3489.field_22277)
			.method_26792(AllItemTags.CREATE_INGOTS.tag);

		prov.tag(Tags.Items.INGOTS)
			.method_26792(AllItemTags.CREATE_INGOTS.tag);

		// COMPAT

		genStrippedWoodItemTags(prov);

		// VALIDATE

		for (AllItemTags tag : AllItemTags.values()) {
			if (tag.alwaysDatagen) {
				prov.getOrCreateRawBuilder(tag.tag);
			}
		}
	}

	private static void genStrippedWoodItemTags(CreateTagsProvider<class_1792> prov) {
		class_5124<class_1792> logAppender = prov.tag(AllItemTags.MODDED_STRIPPED_LOGS.tag);
		class_5124<class_1792> woodAppender = prov.tag(AllItemTags.MODDED_STRIPPED_WOOD.tag);
		StrippedWoodHelper helper = new StrippedWoodHelper(logAppender, woodAppender);

		helper.add(Mods.ARS_N, "blue_archwood", "purple_archwood", "green_archwood", "red_archwood");
		helper.add(Mods.BTN, "livingwood", "dreamwood");
		helper.add(Mods.FA, "cherrywood", "mysterywood");
		helper.add(Mods.HEX, "akashic");
		helper.add(Mods.ID, "menril");
		helper.add(Mods.BYG, "aspen", "baobab", "enchanted", "cherry", "cika", "cypress", "ebony", "ether",
			"fir", "green_enchanted", "holly", "jacaranda", "lament", "mahogany", "mangrove", "maple", "nightshade",
			"palm", "palo_verde", "pine", "rainbow_eucalyptus", "redwood", "skyris", "willow", "witch_hazel",
			"zelkova");
		helper.add(Mods.SG, "netherwood");
		helper.add(Mods.TF, "twilight_oak", "canopy", "mangrove", "dark", "time", "transformation", "mining",
			"sorting");
		helper.add(Mods.TIC, "greenheart", "skyroot", "bloodshroom");
		helper.add(Mods.AP, "twisted");
		helper.add(Mods.Q, "azalea", "blossom");
		helper.add(Mods.ECO, "coconut", "walnut", "azalea");
		helper.add(Mods.BOP, "fir", "redwood", "cherry", "mahogany", "jacaranda", "palm", "willow", "dead",
			"magic", "umbran", "hellbark");
		helper.add(Mods.BSK, "bluebright", "starlit", "frostbright", "lunar", "dusk", "maple", "cherry");
		helper.add(Mods.ENV, "cherry", "willow", "wisteria");
		helper.add(Mods.ATM, "aspen", "kousa", "yucca", "morado");
		helper.add(Mods.ATM_2, "rosewood", "grimwood");
		helper.add(Mods.GOOD, "muddy_oak", "cypress");
		helper.add(Mods.BMK, "blighted_balsa", "willow", "swamp_cypress", "ancient_oak");

		TagGen.addOptional(logAppender, Mods.IX, "stripped_luminous_stem");
		TagGen.addOptional(woodAppender, Mods.IX, "stripped_luminous_hyphae");
		TagGen.addOptional(logAppender, Mods.BYG, "stripped_bulbis_stem");
		TagGen.addOptional(woodAppender, Mods.BYG, "stripped_bulbis_wood");
	}

	private static void genFluidTags(RegistrateTagsProvider<class_3611> provIn) {
		CreateTagsProvider<class_3611> prov = new CreateTagsProvider<>(provIn, class_3611::method_40178);

		prov.tag(AllFluidTags.BOTTOMLESS_ALLOW.tag)
			.add(class_3612.field_15910, class_3612.field_15908);

		prov.tag(AllFluidTags.FAN_PROCESSING_CATALYSTS_BLASTING.tag)
			.add(class_3612.field_15908, class_3612.field_15907);

		prov.tag(AllFluidTags.FAN_PROCESSING_CATALYSTS_SPLASHING.tag)
			.add(class_3612.field_15910, class_3612.field_15909);

		// VALIDATE

		for (AllFluidTags tag : AllFluidTags.values()) {
			if (tag.alwaysDatagen) {
				prov.getOrCreateRawBuilder(tag.tag);
			}
		}
	}

	private static void genEntityTags(RegistrateTagsProvider<class_1299<?>> provIn) {
		CreateTagsProvider<class_1299<?>> prov = new CreateTagsProvider<>(provIn, class_1299::method_40124);

		prov.tag(AllEntityTags.BLAZE_BURNER_CAPTURABLE.tag)
			.add(class_1299.field_6099);

		// VALIDATE

		for (AllEntityTags tag : AllEntityTags.values()) {
			if (tag.alwaysDatagen) {
				prov.getOrCreateRawBuilder(tag.tag);
			}
		}
	}

	private static class StrippedWoodHelper {
		protected final class_5124<class_1792> logAppender;
		protected final class_5124<class_1792> woodAppender;

		public StrippedWoodHelper(class_5124<class_1792> logAppender, class_5124<class_1792> woodAppender) {
			this.logAppender = logAppender;
			this.woodAppender = woodAppender;
		}

		public void add(Mods mod, String... woodTypes) {
			for (String type : woodTypes) {
				String strippedPre = mod.strippedIsSuffix ? "" : "stripped_";
				String strippedPost = mod.strippedIsSuffix ? "_stripped" : "";
				TagGen.addOptional(logAppender, mod, strippedPre + type + "_log" + strippedPost);
				TagGen.addOptional(woodAppender, mod, strippedPre + type + (mod.omitWoodSuffix ? "" : "_wood") + strippedPost);
			}
		}
	}
}
