package com.simibubi.create.infrastructure.debugInfo;

import java.util.Objects;

import javax.annotation.Nullable;
import net.minecraft.class_1657;

/**
 * A supplier of debug information. May be queried on the client or server.
 */
@FunctionalInterface
public interface InfoProvider {
	/**
	 * @param player the player requesting the data. May be null
	 */
	@Nullable
	String getInfo(@Nullable class_1657 player);

	default String getInfoSafe(class_1657 player) {
		try {
			return Objects.toString(getInfo(player));
		} catch (Throwable t) {
			StringBuilder builder = new StringBuilder("Error getting information!");
			builder.append(' ').append(t.getMessage());
			for (StackTraceElement element : t.getStackTrace()) {
				builder.append('\n').append("\t").append(element.toString());
			}
			return builder.toString();
		}
	}
}
