package com.simibubi.create.infrastructure.debugInfo.element;

import java.util.function.Consumer;
import net.minecraft.class_1657;
import net.minecraft.class_2540;
import org.jetbrains.annotations.Nullable;

public sealed interface InfoElement permits DebugInfoSection, InfoEntry {
	void write(class_1657 player, class_2540 buffer);

	void print(int depth, @Nullable class_1657 player, Consumer<String> lineConsumer);

	default void print(@Nullable class_1657 player, Consumer<String> lineConsumer) {
		print(0, player, lineConsumer);
	}

	static InfoElement read(class_2540 buffer) {
		boolean section = buffer.readBoolean();
		if (section) {
			return DebugInfoSection.read(buffer);
		} else {
			return InfoEntry.read(buffer);
		}
	}
}
