package com.simibubi.create.infrastructure.gametest.tests;

import static com.simibubi.create.infrastructure.gametest.CreateGameTestHelper.FIFTEEN_SECONDS;

import com.simibubi.create.AllBlockEntityTypes;
import com.simibubi.create.content.redstone.thresholdSwitch.ThresholdSwitchBlockEntity;
import com.simibubi.create.content.schematics.SchematicExport;
import com.simibubi.create.content.schematics.SchematicItem;
import com.simibubi.create.content.schematics.cannon.SchematicannonBlockEntity;
import com.simibubi.create.content.schematics.cannon.SchematicannonBlockEntity.State;
import com.simibubi.create.infrastructure.gametest.CreateGameTestHelper;
import com.simibubi.create.infrastructure.gametest.GameTestGroup;
import net.minecraft.class_1299;
import net.minecraft.class_1304;
import net.minecraft.class_1472;
import net.minecraft.class_1531;
import net.minecraft.class_1642;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2453;
import net.minecraft.class_2512;
import net.minecraft.class_3218;
import net.minecraft.class_3419;
import net.minecraft.class_6302;
import net.minecraft.class_7924;

@GameTestGroup(path = "misc")
public class TestMisc {
	@class_6302(method_35936 = "schematicannon", method_35932 = FIFTEEN_SECONDS)
	public static void schematicannon(CreateGameTestHelper helper) {
		// load the structure
		class_2338 whiteEndBottom = helper.method_36052(new class_2338(5, 2, 1));
		class_2338 redEndTop = helper.method_36052(new class_2338(5, 4, 7));
		class_3218 level = helper.method_35943();
		SchematicExport.saveSchematic(
				SchematicExport.SCHEMATICS.resolve("uploaded/Deployer"), "schematicannon_gametest", true,
				level, whiteEndBottom, redEndTop
		);
		class_1799 schematic =
			SchematicItem.create(level.method_45448(class_7924.field_41254), "schematicannon_gametest.nbt", "Deployer");
		// deploy to pos
		class_2338 anchor = helper.method_36052(new class_2338(1, 2, 1));
		schematic.method_7948().method_10556("Deployed", true);
		schematic.method_7948().method_10566("Anchor", class_2512.method_10692(anchor));
		// setup cannon
		class_2338 cannonPos = new class_2338(3, 2, 6);
		SchematicannonBlockEntity cannon = helper.getBlockEntity(AllBlockEntityTypes.SCHEMATICANNON.get(), cannonPos);
		cannon.inventory.setStackInSlot(0, schematic);
		// run
		cannon.state = State.RUNNING;
		cannon.statusMsg = "running";
		helper.method_36018(() -> {
			if (cannon.state != State.STOPPED) {
				helper.method_35995("Schematicannon not done");
			}
			class_2338 lastBlock = new class_2338(1, 4, 7);
			helper.method_35972(class_2246.field_10314, lastBlock);
		});
	}

	@class_6302(method_35936 = "shearing")
	public static void shearing(CreateGameTestHelper helper) {
		class_2338 sheepPos = new class_2338(2, 1, 2);
		class_1472 sheep = helper.getFirstEntity(class_1299.field_6115, sheepPos);
		sheep.method_6636(class_3419.field_15254);
		helper.method_36018(() -> {
			helper.method_35969(class_1802.field_19044, sheepPos, 2);
		});
	}

	@class_6302(method_35936 = "smart_observer_blocks")
	public static void smartObserverBlocks(CreateGameTestHelper helper) {
		class_2338 lever = new class_2338(2, 2, 1);
		class_2338 leftLamp = new class_2338(3, 4, 3);
		class_2338 rightLamp = new class_2338(1, 4, 3);
		helper.method_36039(lever);
		helper.method_36018(() -> {
			helper.method_35987(leftLamp, class_2453.field_11413, true);
			helper.method_35987(rightLamp, class_2453.field_11413, false);
		});
	}

	@class_6302(method_35936 = "threshold_switch_pulley")
	public static void thresholdSwitchPulley(CreateGameTestHelper helper) {
		class_2338 lever = new class_2338(3, 7, 1);
		class_2338 switchPos = new class_2338(1, 6, 1);
		helper.method_36039(lever);
		helper.method_36018(() -> {
			ThresholdSwitchBlockEntity switchBe = helper.getBlockEntity(AllBlockEntityTypes.THRESHOLD_SWITCH.get(), switchPos);
			float level = switchBe.getStockLevel();
			if (level < 0 || level > 1)
				helper.method_35995("Invalid level: " + level);
		});
	}

	@class_6302(method_35936 = "netherite_backtank", method_35932 = CreateGameTestHelper.TEN_SECONDS)
	public static void netheriteBacktank(CreateGameTestHelper helper) {
		class_2338 lava = new class_2338(2, 2, 3);
		class_2338 zombieSpawn = lava.method_10086(2);
		class_2338 armorStandPos = new class_2338(2, 2, 1);
		helper.method_35951(5, () -> {
			class_1642 zombie = helper.method_35964(class_1299.field_6051, zombieSpawn);
			class_1531 armorStand = helper.getFirstEntity(class_1299.field_6131, armorStandPos);
			for (class_1304 slot : class_1304.values()) {
				zombie.method_5673(slot, armorStand.method_6118(slot).method_7972());
			}
		});
		helper.method_36018(() -> {
			helper.assertSecondsPassed(9);
			helper.method_36023(class_1299.field_6051, lava);
		});
	}
}
