package com.simibubi.create.infrastructure.gametest.tests;

import java.util.List;

import com.simibubi.create.AllBlocks;
import com.simibubi.create.AllItems;
import com.simibubi.create.Create;
import com.simibubi.create.content.processing.recipe.ProcessingOutput;
import com.simibubi.create.content.processing.sequenced.SequencedAssemblyRecipe;
import com.simibubi.create.foundation.item.ItemHelper;
import com.simibubi.create.infrastructure.gametest.CreateGameTestHelper;
import com.simibubi.create.infrastructure.gametest.GameTestGroup;

import net.fabricmc.fabric.api.transfer.v1.item.ItemVariant;
import net.fabricmc.fabric.api.transfer.v1.storage.Storage;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_1844;
import net.minecraft.class_1847;
import net.minecraft.class_2338;
import net.minecraft.class_4512;
import net.minecraft.class_6302;

@GameTestGroup(path = "processing")
public class TestProcessing {
	@class_6302(method_35936 = "brass_mixing", method_35932 = CreateGameTestHelper.TEN_SECONDS)
	public static void brassMixing(CreateGameTestHelper helper) {
		class_2338 lever = new class_2338(2, 3, 2);
		class_2338 chest = new class_2338(7, 3, 1);
		helper.method_36039(lever);
		helper.method_36018(() -> helper.method_35983(chest, AllItems.BRASS_INGOT.get()));
	}

	@class_6302(method_35936 = "brass_mixing_2", method_35932 = CreateGameTestHelper.TWENTY_SECONDS)
	public static void brassMixing2(CreateGameTestHelper helper) {
		class_2338 basinLever = new class_2338(3, 3, 1);
		class_2338 armLever = new class_2338(3, 3, 5);
		class_2338 output = new class_2338(1, 2, 3);
		helper.method_36039(armLever);
		helper.whenSecondsPassed(7, () -> helper.method_36039(armLever));
		helper.whenSecondsPassed(10, () -> helper.method_36039(basinLever));
		helper.method_36018(() -> helper.method_35983(output, AllItems.BRASS_INGOT.get()));
	}

	@class_6302(method_35936 = "crushing_wheel_crafting", method_35932 = CreateGameTestHelper.TEN_SECONDS)
	public static void crushingWheelCrafting(CreateGameTestHelper helper) {
		class_2338 chest = new class_2338(1, 4, 3);
		List<class_2338> levers = List.of(
				new class_2338(2, 3, 2),
				new class_2338(6, 3, 2),
				new class_2338(3, 7, 3)
		);
		levers.forEach(helper::method_36039);
		class_1799 expected = new class_1799(AllBlocks.CRUSHING_WHEEL.get(), 2);
		helper.method_36018(() -> helper.assertContainerContains(chest, expected));
	}

	@class_6302(method_35936 = "precision_mechanism_crafting", method_35932 = CreateGameTestHelper.TWENTY_SECONDS)
	public static void precisionMechanismCrafting(CreateGameTestHelper helper) {
		class_2338 lever = new class_2338(6, 3, 6);
		class_2338 output = new class_2338(11, 3, 1);
		helper.method_36039(lever);

		SequencedAssemblyRecipe recipe = (SequencedAssemblyRecipe) helper.method_35943().method_8433()
				.method_8130(Create.asResource("sequenced_assembly/precision_mechanism"))
				.orElseThrow(() -> new class_4512("Precision Mechanism recipe not found"));
		class_1792 result = recipe.method_8110(helper.method_35943().method_30349()).method_7909();
		class_1792[] possibleResults = recipe.resultPool.stream()
				.map(ProcessingOutput::getStack)
				.map(class_1799::method_7909)
				.filter(item -> item != result)
				.toArray(class_1792[]::new);

		helper.method_36018(() -> {
			helper.method_35983(output, result);
			helper.assertAnyContained(output, possibleResults);
		});
	}

	@class_6302(method_35936 = "sand_washing", method_35932 = CreateGameTestHelper.TEN_SECONDS)
	public static void sandWashing(CreateGameTestHelper helper) {
		class_2338 leverPos = new class_2338(5, 3, 1);
		helper.method_36039(leverPos);
		class_2338 chestPos = new class_2338(8, 3, 2);
		helper.method_36018(() -> helper.method_35983(chestPos, class_1802.field_8696));
	}

	@class_6302(method_35936 = "stone_cobble_sand_crushing", method_35932 = CreateGameTestHelper.TEN_SECONDS)
	public static void stoneCobbleSandCrushing(CreateGameTestHelper helper) {
		class_2338 chest = new class_2338(1, 6, 2);
		class_2338 lever = new class_2338(2, 3, 1);
		helper.method_36039(lever);
		class_1799 expected = new class_1799(class_1802.field_8858, 5);
		helper.method_36018(() -> helper.assertContainerContains(chest, expected));
	}

	@class_6302(method_35936 = "track_crafting", method_35932 = CreateGameTestHelper.TEN_SECONDS)
	public static void trackCrafting(CreateGameTestHelper helper) {
		class_2338 output = new class_2338(7, 3, 2);
		class_2338 lever = new class_2338(2, 3, 1);
		helper.method_36039(lever);
		class_1799 expected = new class_1799(AllBlocks.TRACK.get(), 6);
		helper.method_36018(() -> {
			helper.assertContainerContains(output, expected);
			Storage<ItemVariant> storage = helper.itemStorageAt(output);
			ItemHelper.extract(storage, ItemHelper.sameItemPredicate(expected), 6, false);
			helper.method_36047(output);
		});
	}

	@class_6302(method_35936 = "water_filling_bottle")
	public static void waterFillingBottle(CreateGameTestHelper helper) {
		class_2338 lever = new class_2338(3, 3, 3);
		class_2338 output = new class_2338(2, 2, 4);
		class_1799 expected = class_1844.method_8061(new class_1799(class_1802.field_8574), class_1847.field_8991);
		helper.method_36039(lever);
		helper.method_36018(() -> helper.assertContainerContains(output, expected));
	}

	@class_6302(method_35936 = "wheat_milling")
	public static void wheatMilling(CreateGameTestHelper helper) {
		class_2338 output = new class_2338(1, 2, 1);
		class_2338 lever = new class_2338(1, 7, 1);
		helper.method_36039(lever);
		class_1799 expected = new class_1799(AllItems.WHEAT_FLOUR.get(), 3);
		helper.method_36018(() -> helper.assertContainerContains(output, expected));
	}
}
