package com.simibubi.create.infrastructure.gui;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import com.simibubi.create.AllItems;
import com.simibubi.create.foundation.gui.ScreenOpener;
import com.simibubi.create.foundation.utility.Components;
import com.simibubi.create.infrastructure.config.AllConfigs;

import net.fabricmc.fabric.api.client.screen.v1.Screens;
import net.minecraft.class_1799;
import net.minecraft.class_2588;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_332;
import net.minecraft.class_4185;
import net.minecraft.class_433;
import net.minecraft.class_437;
import net.minecraft.class_442;

public class OpenCreateMenuButton extends class_4185 {

	public static final class_1799 ICON = AllItems.GOGGLES.asStack();

	public OpenCreateMenuButton(int x, int y) {
		super(x, y, 20, 20, Components.immutableEmpty(), OpenCreateMenuButton::click, field_40754);
	}

	@Override
	public void method_48589(class_332 graphics, class_327 pFont, int pColor) {
		graphics.method_51427(ICON, method_46426() + 2, method_46427() + 2);
	}

	public static void click(class_4185 b) {
		ScreenOpener.open(new CreateMainMenuScreen(class_310.method_1551().field_1755));
	}

	public static class SingleMenuRow {
		public final String left, right;

		public SingleMenuRow(String left, String right) {
			this.left = left;
			this.right = right;
		}

		public SingleMenuRow(String center) {
			this(center, center);
		}
	}

	public static class MenuRows {
		public static final MenuRows MAIN_MENU = new MenuRows(Arrays.asList(
				new SingleMenuRow("menu.singleplayer"),
				new SingleMenuRow("menu.multiplayer"),
				new SingleMenuRow("menu.online"),
				new SingleMenuRow("narrator.button.language", "narrator.button.accessibility")
		));

		public static final MenuRows INGAME_MENU = new MenuRows(Arrays.asList(
				new SingleMenuRow("menu.returnToGame"),
				new SingleMenuRow("gui.advancements", "gui.stats"),
				new SingleMenuRow("menu.sendFeedback", "menu.reportBugs"),
				new SingleMenuRow("menu.options", "menu.shareToLan"),
				new SingleMenuRow("menu.returnToMenu")
		));

		protected final List<String> leftButtons, rightButtons;

		public MenuRows(List<SingleMenuRow> variants) {
			leftButtons = variants.stream().map(r -> r.left).collect(Collectors.toList());
			rightButtons = variants.stream().map(r -> r.right).collect(Collectors.toList());
		}
	}

	public static class OpenConfigButtonHandler {

		public static void onGuiInit(class_310 client, class_437 gui, int scaledWidth, int scaledHeight) {
			MenuRows menu = null;
			int rowIdx = 0, offsetX = 0;
			if (gui instanceof class_442) {
				menu = MenuRows.MAIN_MENU;
				rowIdx = AllConfigs.client().mainMenuConfigButtonRow.get();
				offsetX = AllConfigs.client().mainMenuConfigButtonOffsetX.get();
			} else if (gui instanceof class_433) {
				menu = MenuRows.INGAME_MENU;
				rowIdx = AllConfigs.client().ingameMenuConfigButtonRow.get();
				offsetX = AllConfigs.client().ingameMenuConfigButtonOffsetX.get();
			}

			if (rowIdx != 0 && menu != null) {
				boolean onLeft = offsetX < 0;
				String target = (onLeft ? menu.leftButtons : menu.rightButtons).get(rowIdx - 1);

				int offsetX_ = offsetX;
				Screens.getButtons(gui).stream()
						.filter(w -> w.method_25369().method_10851() instanceof class_2588 translatable
								&& translatable.method_11022().equals(target))
						.findFirst()
						.ifPresent(w -> {
							gui.method_37063(
									new OpenCreateMenuButton(w.method_46426() + offsetX_ + (onLeft ? -20 : w.method_25368()), w.method_46427())
							);
						});
			}
		}

	}

}
