package com.simibubi.create.infrastructure.ponder.scenes;

import com.simibubi.create.content.redstone.RoseQuartzLampBlock;
import com.simibubi.create.content.redstone.nixieTube.NixieTubeBlockEntity;
import com.simibubi.create.foundation.ponder.ElementLink;
import com.simibubi.create.foundation.ponder.SceneBuilder;
import com.simibubi.create.foundation.ponder.SceneBuildingUtil;
import com.simibubi.create.foundation.ponder.Selection;
import com.simibubi.create.foundation.ponder.element.InputWindowElement;
import com.simibubi.create.foundation.ponder.element.WorldSectionElement;
import com.simibubi.create.foundation.utility.Pointing;
import net.minecraft.class_2338;
import net.minecraft.class_2350;

public class RedstoneScenes2 {

	public static void roseQuartzLamp(SceneBuilder scene, SceneBuildingUtil util) {
		scene.title("rose_quartz_lamp", "Rose Quartz Lamps");
		scene.configureBasePlate(0, 0, 7);

		class_2338 centerLamp = util.grid.at(3, 1, 3);
		Selection input = util.select.fromTo(3, 1, 1, 3, 1, 2);
		Selection button = util.select.position(3, 1, 1);
		Selection wire = util.select.position(3, 1, 2);
		Selection output = util.select.fromTo(5, 1, 2, 5, 1, 1);
		Selection comparator = util.select.fromTo(1, 1, 3, 0, 1, 3);

		scene.showBasePlate();
		scene.idle(15);

		ElementLink<WorldSectionElement> rowElement =
			scene.world.showIndependentSection(util.select.position(centerLamp), class_2350.field_11033);
		scene.idle(5);
		scene.world.showSection(input, class_2350.field_11035);
		scene.idle(15);

		scene.world.toggleRedstonePower(input);
		scene.effects.indicateRedstone(util.grid.at(3, 1, 1));
		scene.world.cycleBlockProperty(centerLamp, RoseQuartzLampBlock.POWERING);
		scene.idle(15);

		scene.overlay.showText(70)
			.pointAt(util.vector.blockSurface(centerLamp, class_2350.field_11039))
			.placeNearTarget()
			.attachKeyFrame()
			.text("Rose Quartz Lamps activate on a Redstone signal");
		scene.idle(5);
		scene.world.toggleRedstonePower(button);
		scene.idle(55);

		scene.world.hideSection(input, class_2350.field_11034);
		scene.idle(10);
		ElementLink<WorldSectionElement> outputElement = scene.world.showIndependentSection(output, class_2350.field_11034);
		scene.world.moveSection(outputElement, util.vector.of(-2, 0, 0), 0);
		scene.idle(10);
		scene.world.toggleRedstonePower(wire);
		scene.world.toggleRedstonePower(output);
		scene.idle(5);

		scene.overlay.showText(70)
			.pointAt(util.vector.blockSurface(centerLamp, class_2350.field_11039))
			.placeNearTarget()
			.text("They will continue to emit redstone power afterwards");
		scene.idle(60);

		scene.world.hideIndependentSection(outputElement, class_2350.field_11043);
		scene.world.showSectionAndMerge(util.select.position(centerLamp.method_10067()), class_2350.field_11034, rowElement);
		scene.idle(3);
		scene.world.showSectionAndMerge(util.select.position(centerLamp.method_10078()), class_2350.field_11039, rowElement);
		scene.idle(25);

		scene.overlay.showText(50)
			.pointAt(util.vector.blockSurface(util.grid.at(2, 1, 3), class_2350.field_11039))
			.placeNearTarget()
			.attachKeyFrame()
			.text("When multiple lamps are arranged in a group...");
		scene.idle(40);

		ElementLink<WorldSectionElement> inputElement = scene.world.showIndependentSection(input, class_2350.field_11035);
		scene.world.moveSection(inputElement, util.vector.of(1, 0, 0), 0);
		scene.idle(15);

		scene.world.toggleRedstonePower(input);
		scene.effects.indicateRedstone(util.grid.at(4, 1, 1));
		scene.world.cycleBlockProperty(centerLamp, RoseQuartzLampBlock.POWERING);
		scene.world.cycleBlockProperty(centerLamp.method_10078(), RoseQuartzLampBlock.POWERING);
		scene.idle(15);

		scene.overlay.showText(80)
			.pointAt(util.vector.blockSurface(util.grid.at(4, 1, 3), class_2350.field_11036))
			.placeNearTarget()
			.text("...activating a Lamp will focus the signal to it, deactivating all others");

		scene.idle(5);
		scene.world.toggleRedstonePower(button);
		scene.idle(60);

		scene.world.hideIndependentSection(inputElement, class_2350.field_11043);
		scene.world.moveSection(rowElement, util.vector.of(1, 0, 0), 10);
		scene.idle(15);
		scene.world.showSectionAndMerge(comparator, class_2350.field_11034, rowElement);
		scene.idle(15);
		scene.world.toggleRedstonePower(comparator);
		scene.world.modifyBlockEntityNBT(comparator, NixieTubeBlockEntity.class, nbt -> nbt.method_10569("RedstoneStrength", 13));
		scene.idle(25);

		scene.overlay.showText(80)
			.pointAt(util.vector.blockSurface(util.grid.at(1, 1, 3), class_2350.field_11039))
			.placeNearTarget()
			.attachKeyFrame()
			.text("Comparators output based on the distance to a powered lamp");
		scene.idle(90);

		scene.overlay
			.showControls(new InputWindowElement(util.vector.topOf(centerLamp.method_10089(2)), Pointing.DOWN).rightClick()
				.withWrench(), 20);
		scene.idle(6);
		scene.world.cycleBlockProperty(centerLamp.method_10078(), RoseQuartzLampBlock.POWERING);
		scene.world.toggleRedstonePower(comparator);
		scene.world.modifyBlockEntityNBT(comparator, NixieTubeBlockEntity.class, nbt -> nbt.method_10569("RedstoneStrength", 0));
		scene.idle(20);

		scene.overlay.showControls(new InputWindowElement(util.vector.topOf(centerLamp), Pointing.DOWN).rightClick()
			.withWrench(), 20);
		scene.idle(6);
		scene.world.cycleBlockProperty(centerLamp.method_10067(), RoseQuartzLampBlock.POWERING);
		scene.world.toggleRedstonePower(comparator);
		scene.world.modifyBlockEntityNBT(comparator, NixieTubeBlockEntity.class, nbt -> nbt.method_10569("RedstoneStrength", 15));
		scene.idle(20);

		scene.overlay.showText(80)
			.pointAt(util.vector.blockSurface(util.grid.at(3, 1, 3), class_2350.field_11036))
			.placeNearTarget()
			.attachKeyFrame()
			.text("The Lamps can also be toggled manually using a Wrench");
		scene.idle(50);

	}

}
