package com.simibubi.create.infrastructure.worldgen;

import static net.minecraft.class_6803.method_39708;

import java.util.List;
import net.minecraft.class_2975;
import net.minecraft.class_3031;
import net.minecraft.class_3124;
import net.minecraft.class_3124.class_5876;
import net.minecraft.class_3481;
import net.minecraft.class_3798;
import net.minecraft.class_3825;
import net.minecraft.class_5321;
import net.minecraft.class_7891;
import net.minecraft.class_7924;
import com.simibubi.create.AllBlocks;
import com.simibubi.create.Create;

public class AllConfiguredFeatures {
	public static final class_5321<class_2975<?, ?>>
				ZINC_ORE = key("zinc_ore"),
				STRIATED_ORES_OVERWORLD = key("striated_ores_overworld"),
				STRIATED_ORES_NETHER = key("striated_ores_nether");

	private static class_5321<class_2975<?, ?>> key(String name) {
		return class_5321.method_29179(class_7924.field_41239, Create.asResource(name));
	}

	public static void bootstrap(class_7891<class_2975<?, ?>> ctx) {
		class_3825 stoneOreReplaceables = new class_3798(class_3481.field_28992);
		class_3825 deepslateOreReplaceables = new class_3798(class_3481.field_28993);

		List<class_5876> zincTargetStates = List.of(
			class_3124.method_33994(stoneOreReplaceables, AllBlocks.ZINC_ORE.get()
				.method_9564()),
			class_3124.method_33994(deepslateOreReplaceables, AllBlocks.DEEPSLATE_ZINC_ORE.get()
				.method_9564())
		);

		method_39708(ctx, ZINC_ORE, class_3031.field_13517, new class_3124(zincTargetStates, 12));

		List<LayerPattern> overworldLayerPatterns = List.of(
			AllLayerPatterns.SCORIA.get(),
			AllLayerPatterns.CINNABAR.get(),
			AllLayerPatterns.MAGNETITE.get(),
			AllLayerPatterns.MALACHITE.get(),
			AllLayerPatterns.LIMESTONE.get(),
			AllLayerPatterns.OCHRESTONE.get()
		);

		method_39708(ctx, STRIATED_ORES_OVERWORLD, AllFeatures.LAYERED_ORE.get(), new LayeredOreConfiguration(overworldLayerPatterns, 32, 0));

		List<LayerPattern> netherLayerPatterns = List.of(
			AllLayerPatterns.SCORIA_NETHER.get(),
			AllLayerPatterns.SCORCHIA_NETHER.get()
		);

		method_39708(ctx, STRIATED_ORES_NETHER, AllFeatures.LAYERED_ORE.get(), new LayeredOreConfiguration(netherLayerPatterns, 32, 0));
	}
}
