package com.simibubi.create.infrastructure.worldgen;

import com.simibubi.create.content.decoration.palettes.AllPaletteStoneTypes;
import com.tterrag.registrate.util.nullness.NonNullSupplier;
import net.minecraft.class_2246;

public class AllLayerPatterns {

	public static final NonNullSupplier<LayerPattern>

	CINNABAR = () -> LayerPattern.builder()
		.layer(l -> l.weight(2)
			.block(AllPaletteStoneTypes.CRIMSITE.getBaseBlock())
			.size(2, 5))
		.layer(l -> l.weight(1)
			.block(class_2246.field_27165)
			.block(class_2246.field_28888)
			.size(2, 3))
		.layer(l -> l.weight(1)
			.blocks(class_2246.field_28888, class_2246.field_27165)
			.size(2, 2))
		.layer(l -> l.weight(1)
			.block(AllPaletteStoneTypes.LIMESTONE.getBaseBlock())
			.size(1, 2))
		.build();

	public static final NonNullSupplier<LayerPattern> MAGNETITE = () -> LayerPattern.builder()
		.layer(l -> l.weight(2)
			.block(AllPaletteStoneTypes.ASURINE.getBaseBlock())
			.size(2, 5))
		.layer(l -> l.weight(1)
			.block(class_2246.field_27165)
			.block(class_2246.field_28888)
			.size(2, 3))
		.layer(l -> l.weight(1)
			.blocks(class_2246.field_28888, class_2246.field_27165)
			.size(2, 2))
		.layer(l -> l.weight(1)
			.block(class_2246.field_27114)
			.size(1, 2))
		.build();

	public static final NonNullSupplier<LayerPattern> OCHRESTONE = () -> LayerPattern.builder()
		.layer(l -> l.weight(2)
			.block(AllPaletteStoneTypes.OCHRUM.getBaseBlock())
			.size(2, 5))
		.layer(l -> l.weight(2)
			.block(class_2246.field_27165)
			.block(class_2246.field_28888)
			.size(2, 3))
		.layer(l -> l.weight(2)
			.block(class_2246.field_28049)
			.size(1, 2))
		.build();

	public static final NonNullSupplier<LayerPattern> MALACHITE = () -> LayerPattern.builder()
		.layer(l -> l.weight(4)
			.block(AllPaletteStoneTypes.VERIDIUM.getBaseBlock())
			.size(2, 5))
		.layer(l -> l.weight(2)
			.block(class_2246.field_27165)
			.block(class_2246.field_10115)
			.size(2, 3))
		.layer(l -> l.weight(2)
			.blocks(class_2246.field_27165, class_2246.field_10115)
			.size(2, 2))
		.layer(l -> l.weight(3)
			.block(class_2246.field_29032)
			.size(1, 2))
		.build();

	public static final NonNullSupplier<LayerPattern> SCORIA = () -> LayerPattern.builder()
		.layer(l -> l.weight(2)
			.block(AllPaletteStoneTypes.SCORIA.getBaseBlock())
			.size(2, 5))
		.layer(l -> l.weight(2)
			.block(class_2246.field_27165)
			.block(class_2246.field_10115)
			.size(2, 3))
		.layer(l -> l.weight(1)
			.blocks(class_2246.field_27165, class_2246.field_10115)
			.size(2, 2))
		.layer(l -> l.weight(1)
			.block(class_2246.field_10508)
			.size(1, 2))
		.build();

	public static final NonNullSupplier<LayerPattern> LIMESTONE = () -> LayerPattern.builder()
		.layer(l -> l.weight(1)
			.passiveBlock())
		.layer(l -> l.weight(2)
			.block(class_2246.field_27114))
		.layer(l -> l.weight(1)
			.block(class_2246.field_10508))
		.layer(l -> l.weight(2)
			.block(AllPaletteStoneTypes.LIMESTONE.getBaseBlock())
			.size(2, 4))
		.build();

	public static final NonNullSupplier<LayerPattern> SCORIA_NETHER = () -> LayerPattern.builder()
		.inNether()
		.layer(l -> l.weight(1)
			.passiveBlock())
		.layer(l -> l.weight(2)
			.block(AllPaletteStoneTypes.SCORIA.getBaseBlock())
			.size(2, 5))
		.layer(l -> l.weight(1)
			.block(class_2246.field_23869)
			.size(1, 2))
		.layer(l -> l.weight(1)
			.block(class_2246.field_22091)
			.block(class_2246.field_29032)
			.size(2, 3))
		.build();

	public static final NonNullSupplier<LayerPattern> SCORCHIA_NETHER = () -> LayerPattern.builder()
		.inNether()
		.layer(l -> l.weight(4)
			.passiveBlock())
		.layer(l -> l.weight(8)
			.block(AllPaletteStoneTypes.SCORCHIA.getBaseBlock())
			.size(2, 5))
		.layer(l -> l.weight(4)
			.block(class_2246.field_22090)
			.block(class_2246.field_10114)
			.size(1, 3))
		.layer(l -> l.weight(1)
			.block(class_2246.field_10092))
		.layer(l -> l.weight(4)
			.block(class_2246.field_22091)
			.block(class_2246.field_29032)
			.size(2, 3))
		.build();

}
