package com.simibubi.create.infrastructure.worldgen;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Function;
import net.minecraft.class_2338;
import net.minecraft.class_2338.class_2339;
import net.minecraft.class_2680;
import net.minecraft.class_2826;
import net.minecraft.class_2902;
import net.minecraft.class_3031;
import net.minecraft.class_3124;
import net.minecraft.class_3124.class_5876;
import net.minecraft.class_3532;
import net.minecraft.class_4076;
import net.minecraft.class_5281;
import net.minecraft.class_5819;
import net.minecraft.class_5821;
import net.minecraft.class_5867;
import com.simibubi.create.Create;
import com.simibubi.create.infrastructure.worldgen.LayerPattern.Layer;

public class LayeredOreFeature extends class_3031<LayeredOreConfiguration> {
	public LayeredOreFeature() {
		super(LayeredOreConfiguration.CODEC);
	}

	@Override
	public boolean method_13151(class_5821<LayeredOreConfiguration> pContext) {
		class_5819 random = pContext.method_33654();
		class_2338 blockpos = pContext.method_33655();
		class_5281 worldgenlevel = pContext.method_33652();
		LayeredOreConfiguration config = pContext.method_33656();
		List<LayerPattern> patternPool = config.layerPatterns;

		if (patternPool.isEmpty())
			return false;

		LayerPattern layerPattern = patternPool.get(random.method_43048(patternPool.size()));

		int placedAmount = 0;
		int size = config.size;
		int radius = class_3532.method_15386(config.size / 2f);
		int x0 = blockpos.method_10263() - radius;
		int y0 = blockpos.method_10264() - radius;
		int z0 = blockpos.method_10260() - radius;
		int width = size + 1;
		int length = size + 1;
		int height = size + 1;

		if (blockpos.method_10264() >= worldgenlevel.method_8624(class_2902.class_2903.field_13195, blockpos.method_10263(),
			blockpos.method_10260()))
			return false;

		List<LayerPattern.Layer> resolvedLayers = new ArrayList<>();
		List<Float> layerDiameterOffsets = new ArrayList<>();

		class_2339 mutablePos = new class_2339();
		class_5867 bulksectionaccess = new class_5867(worldgenlevel);
		int layerCoordinate = random.method_43048(4);
		int slantyCoordinate = random.method_43048(3);
		float slope = random.method_43057() * .75f;

		try {

			for (int x = 0; x < width; x++) {
				float dx = x * 2f / width - 1;
				if (dx * dx > 1)
					continue;

				for (int y = 0; y < height; y++) {
					float dy = y * 2f / height - 1;
					if (dx * dx + dy * dy > 1)
						continue;
					if (worldgenlevel.method_31601(y0 + y))
						continue;

					for (int z = 0; z < length; z++) {
						float dz = z * 2f / height - 1;

						int layerIndex = layerCoordinate == 0 ? z : layerCoordinate == 1 ? x : y;
						if (slantyCoordinate != layerCoordinate)
							layerIndex += class_3532.method_15375(slantyCoordinate == 0 ? z : slantyCoordinate == 1 ? x : y) * slope;

						while (layerIndex >= resolvedLayers.size()) {
							Layer next = layerPattern.rollNext(
								resolvedLayers.isEmpty() ? null : resolvedLayers.get(resolvedLayers.size() - 1),
								random);
							float offset = random.method_43057() * .5f + .5f;
							for (int i = 0; i < next.minSize + random.method_43048(1 + next.maxSize - next.minSize); i++) {
								resolvedLayers.add(next);
								layerDiameterOffsets.add(offset);
							}
						}

						if (dx * dx + dy * dy + dz * dz > 1 * layerDiameterOffsets.get(layerIndex))
							continue;

						LayerPattern.Layer layer = resolvedLayers.get(layerIndex);
						List<class_5876> state = layer.rollBlock(random);

						int currentX = x0 + x;
						int currentY = y0 + y;
						int currentZ = z0 + z;

						mutablePos.method_10103(currentX, currentY, currentZ);
						if (!worldgenlevel.method_37368(mutablePos))
							continue;
						class_2826 levelchunksection = bulksectionaccess.method_33944(mutablePos);
						if (levelchunksection == null)
							continue;

						int i3 = class_4076.method_18684(currentX);
						int j3 = class_4076.method_18684(currentY);
						int k3 = class_4076.method_18684(currentZ);
						class_2680 blockstate = levelchunksection.method_12254(i3, j3, k3);

						for (class_3124.class_5876 oreconfiguration$targetblockstate : state) {
							if (!canPlaceOre(blockstate, bulksectionaccess::method_33946, random, config,
								oreconfiguration$targetblockstate, mutablePos))
								continue;
							if (oreconfiguration$targetblockstate.field_29069.method_26215())
								continue;
							levelchunksection.method_12256(i3, j3, k3, oreconfiguration$targetblockstate.field_29069, false);
							++placedAmount;
							break;
						}

					}
				}
			}

		} catch (Throwable throwable1) {
			try {
				bulksectionaccess.close();
			} catch (Throwable throwable) {
				throwable1.addSuppressed(throwable);
			}

			throw throwable1;
		}

		bulksectionaccess.close();
		return placedAmount > 0;
	}

	public boolean canPlaceOre(class_2680 pState, Function<class_2338, class_2680> pAdjacentStateAccessor,
		class_5819 pRandom, LayeredOreConfiguration pConfig, class_3124.class_5876 pTargetState,
		class_2338.class_2339 pMatablePos) {
		if (!pTargetState.field_29068.method_16768(pState, pRandom))
			return false;
		if (shouldSkipAirCheck(pRandom, pConfig.discardChanceOnAirExposure))
			return true;

		return !method_33981(pAdjacentStateAccessor, pMatablePos);
	}

	protected boolean shouldSkipAirCheck(class_5819 pRandom, float pChance) {
		return pChance <= 0 ? true : pChance >= 1 ? false : pRandom.method_43057() >= pChance;
	}
}
